!   LUXURY LEVELS.
!  level 0  (p=24): equivalent to the original RCARRY of Marsaglia
!           and Zaman, very long period, but fails many tests.
!  level 1  (p=48): considerable improvement in quality over level 0,
!           now passes the gap test, but still fails spectral test.
!  level 2  (p=97): passes all known tests, but theoretically still
!           defective.
!  level 3  (p=223): DEFAULT VALUE.  Any theoretically possible
!           correlations have very small chance of being observed.
!  level 4  (p=389): highest possible luxury, all 24 bits chaotic.
c---------------------------------------------
      SUBROUTINE ranlux(rvec, lenv)
c                    returns a vector RVEC of LEN   
c                   32-bit random floating point numbers between 
c                   zero (not included) and one (also not incl.).
c           Next call to ranlux gives next LEN of random numbers
c---------------------------------------------
      INTEGER  lenv
      REAL        rvec(lenv)
      INTEGER  iseeds(24)
      INCLUDE 'luxury.h'
      DATA ndskip/ 0, 24, 73, 199, 365 /
      DATA i24,j24,luxlev/24,10,lxdflt/
      DATA notyet/.true./
      DATA in24,kount,mkount,carry/0,0,0,0./


!  NOTYET is .TRUE. if no initialization has been performed yet.
!              Default Initialization by Multiplicative Congruential

      IF (notyet) THEN
        notyet = .false.
        jseed = jsdflt
        inseed = jseed
c        WRITE (6,'(A,I12)') ' RANLUX DEFAULT INITIALIZATION: ', jseed
        luxlev = lxdflt
        nskip = ndskip(luxlev)
        lp = nskip + 24
        in24 = 0
        kount = 0
        mkount = 0
c      WRITE (6,'(A,I2,A,I4)') ' RANLUX DEFAULT LUXURY LEVEL= ', luxlev,   
c     &                            '    p =', lp
      twom24 = 1.
        DO i = 1, 24
          twom24 = twom24 * 0.5
          k = jseed / 53668
          jseed = 40014 * (jseed-k*53668) - k * 12211
          IF (jseed.LT.0) jseed = jseed + icons
          iseeds(i) = MOD(jseed,itwo24)
        END DO
        twom12 = twom24 * 4096.
        DO i = 1, 24
          seeds(i) = REAL(iseeds(i)) * twom24
          next(i) = i - 1
        END DO
        next(1) = 24
        i24 = 24
        j24 = 10
        carry = 0.
        IF (seeds(24).EQ.0.) carry = twom24
      END IF

!          The Generator proper: "Subtract-with-borrow",
!          as proposed by Marsaglia and Zaman,
!          Florida State University, March, 1989

      DO ivec = 1, lenv
        uni = seeds(j24) - seeds(i24) - carry
        IF (uni.LT.0.) THEN
          uni = uni + 1.0
          carry = twom24
        ELSE
          carry = 0.
        END IF
        seeds(i24) = uni
        i24 = next(i24)
        j24 = next(j24)
        rvec(ivec) = uni
      !  small numbers (with less than 12 "significant" bits) are "padded".
        IF (uni.LT.twom12) THEN
          rvec(ivec) = rvec(ivec) + twom24 * seeds(j24)
      !        and zero is forbidden in case someone takes a logarithm
          IF (rvec(ivec).EQ.0.) rvec(ivec) = twom24 * twom24
        END IF
      !        Skipping to luxury.  As proposed by Martin Luscher.
        in24 = in24 + 1
        IF (in24.EQ.24) THEN
          in24 = 0
          kount = kount + nskip
          DO isk = 1, nskip
            uni = seeds(j24) - seeds(i24) - carry
            IF (uni.LT.0.) THEN
              uni = uni + 1.0
              carry = twom24
            ELSE
              carry = 0.
            END IF
            seeds(i24) = uni
            i24 = next(i24)
            j24 = next(j24)
          END DO
        END IF
      END DO
      kount = kount + lenv
      IF (kount.GE.igiga) THEN
        mkount = mkount + 1
        kount = kount - igiga
      END IF
      RETURN

      END ! SUBROUTINE ranlux

c---------------------------------------------
c           Subroutine to input and float integer seeds from previous run
      SUBROUTINE rluxin(isdext)
c                   restarts the generator from vector  
c                   ISDEXT of 25 32-bit integers 
c---------------------------------------------
      INCLUDE 'luxury.h'
      INTEGER isdext(25)
      IF (notyet) THEN
        WRITE (6,'(A)')' Proper results ONLY with ',
     &        'initialisation from 25 integers obtained with RLUXUT'
        notyet = .false.
      END IF
      
      twom24 = 1.
      DO i = 1, 24
        next(i) = i - 1
        twom24 = twom24 * 0.5
      END DO
      next(1) = 24
      twom12 = twom24 * 4096.
c      WRITE (6,'(A)') ' FULL INITIALIZATION OF RANLUX WITH 25 INTEGERS:'
c      WRITE (6,'(5X,5I12)') isdext
      DO i = 1, 24
        seeds(i) = REAL(isdext(i)) * twom24
      END DO
      carry = 0.
      IF (isdext(25).LT.0) carry = twom24
      isd = ABS(isdext(25))
      i24 = MOD(isd,100)
      isd = isd / 100
      j24 = MOD(isd,100)
      isd = isd / 100
      in24 = MOD(isd,100)
      isd = isd / 100
      luxlev = isd
      IF (luxlev.LE.maxlev) THEN
        nskip = ndskip(luxlev)
c        WRITE (6,'(A,I2)') ' RANLUX LUXURY LEVEL SET BY RLUXIN TO: ',
c     &                       luxlev
      ELSE IF (luxlev.GE.24) THEN
        nskip = luxlev - 24
c        WRITE (6,'(A,I5)') ' RANLUX P-VALUE SET BY RLUXIN TO:', luxlev
      ELSE
        nskip = ndskip(maxlev)
c        WRITE (6,'(A,I5)') ' RANLUX ILLEGAL LUXURY RLUXIN: ', luxlev
        luxlev = maxlev
      END IF
      inseed = -1
      RETURN
      
      END ! SUBROUTINE rluxin

c---------------------------------------------
c                    Subroutine to ouput seeds as integers
      SUBROUTINE rluxut(isdext)
c      outputs the current values of the 25
c                 32-bit integer seeds, to be used for restarting
c      ISDEXT must be dimensioned 25 in the calling program 
c---------------------------------------------
      INCLUDE 'luxury.h' 
      INTEGER isdext(25)
      DO i = 1, 24
        isdext(i) = INT(seeds(i)*twop12*twop12)
      END DO
      isdext(25) = i24 + 100 * j24 + 10000 * in24 + 1000000 * luxlev
      IF (carry.GT.0.) isdext(25) = -isdext(25)
      RETURN
      
      END ! SUBROUTINE rluxut

c---------------------------------------------
!                    Subroutine to output the "convenient" restart point
      SUBROUTINE rluxat(lout, inout, k1, k2)
c---------------------------------------------
      INCLUDE 'luxury.h'
      
      lout = luxlev
      inout = inseed
      k1 = kount
      k2 = mkount
      RETURN
      
      END ! SUBROUTINE rluxat

c---------------------------------------------
c                    Subroutine to initialize from one or three integers
      SUBROUTINE rluxgo(lux, ins, k1, k2)
c                initializes the generator from  
c               one 32-bit integer INT and sets Luxury Level LUX
c               which is integer between zero and MAXLEV, or if
c               LUX .GT. 24, it sets p=LUX directly.  K1 and K2
c               should be set to zero unless restarting at a break
c               point given by output of RLUXAT
c---------------------------------------------
      INCLUDE 'luxury.h'
      INTEGER  iseeds(24)
      
      IF (lux.LT.0) THEN
        luxlev = lxdflt
      ELSE IF (lux.LE.maxlev) THEN
        luxlev = lux
      ELSE IF (lux.LT.24.OR.lux.GT.2000) THEN
        luxlev = maxlev
        WRITE (6,'(A,I7)') ' RANLUX ILLEGAL LUXURY RLUXGO: ', lux
      ELSE
        luxlev = lux
        DO ilx = 0, maxlev
          IF (lux.EQ.ndskip(ilx)+24) luxlev = ilx
        END DO
      END IF
      IF (luxlev.LE.maxlev) THEN
        nskip = ndskip(luxlev)
        WRITE (6,'(A,I2,A,I4)') ' RANLUX LUXURY LEVEL SET BY RLUXGO :',
     &              luxlev,'     P=', nskip + 24
      ELSE
        nskip = luxlev - 24
        WRITE (6,'(A,I5)') ' RANLUX P-VALUE SET BY RLUXGO TO:', luxlev
      END IF
      in24 = 0
      IF (ins.LT.0) WRITE (6,'(A)')
     &        ' Illegal initialization by RLUXGO, negative input seed'
      IF (ins.GT.0) THEN
        jseed = ins
        WRITE (6,'(A,3I12)')' RANLUX INITIALIZED BY RLUXGO FROM SEEDS',
     &                                    jseed, k1, k2
      ELSE
        jseed = jsdflt
       WRITE (6,'(A)')' RANLUX INITIALIZED BY RLUXGO FROM DEFAULT SEED'
      END IF
      inseed = jseed
      notyet = .false.
      twom24 = 1.
      DO i = 1, 24
        twom24 = twom24 * 0.5
        k = jseed / 53668
        jseed = 40014 * (jseed-k*53668) - k * 12211
        IF (jseed.LT.0) jseed = jseed + icons
        iseeds(i) = MOD(jseed,itwo24)
      END DO
      twom12 = twom24 * 4096.
      DO i = 1, 24
        seeds(i) = REAL(iseeds(i)) * twom24
        next(i) = i - 1
      END DO
      next(1) = 24
      i24 = 24
      j24 = 10
      carry = 0.
      IF (seeds(24).EQ.0.) carry = twom24
      !        If restarting at a break point, skip K1 + IGIGA*K2
      !        Note that this is the number of numbers delivered to
      !        the user PLUS the number skipped (if luxury .GT. 0).
      kount = k1
      mkount = k2
      IF (k1+k2.NE.0) THEN
        DO iouter = 1, k2 + 1
          inner = igiga
          IF (iouter.EQ.k2+1) inner = k1
          DO isk = 1, inner
            uni = seeds(j24) - seeds(i24) - carry
            IF (uni.LT.0.) THEN
              uni = uni + 1.0
              carry = twom24
            ELSE
              carry = 0.
            END IF
            seeds(i24) = uni
            i24 = next(i24)
            j24 = next(j24)
          END DO
        END DO
      !         Get the right value of IN24 by direct calculation
        in24 = MOD(kount,nskip+24)
        IF (mkount.GT.0) THEN
          izip = MOD(igiga, nskip+24)
          izip2 = mkount * izip + in24
          in24 = MOD(izip2, nskip+24)
        END IF
      !       Now IN24 had better be between zero and 23 inclusive
        IF (in24.GT.23) THEN
          WRITE (6,'(A/A,3I11,A,I5)') 
     &       '  Error in RESTARTING with RLUXGO:', '  The values', ins, 
     &                k1, k2, ' cannot occur at luxury level', luxlev
          in24 = 0
        END IF
      END IF
      RETURN
      
      END ! SUBROUTINE rluxgo


!************************************************************************
      PROGRAM luxtst
!         Exercise for the RANLUX Pseudorandom number generator.
!    USE luxury
      PARAMETER (Nnumbers = 10000)
      INCLUDE 'luxury.h'
      REAL    rvec(Nnumbers)
      INTEGER restart(25)

      CALL rluxgo(3,0,0,0)
      WRITE (6,'(/A)') '  CALL RANLUX(RVEC,Nnumbers)'
      CALL ranlux(rvec,Nnumbers)
      WRITE (6,'(A/9X,5F12.8)') ' RANLUX default numbers   1-  5:', 
     &     (rvec(i),i=1,5)            
      CALL ranlux(rvec,Nnumbers)
      WRITE (6,'(A/9X,5F12.8)') ' RANLUX default numbers:', 
     &     (rvec(i),i=1,5)      

      
      WRITE (6,'(/A)') '  test restarting from the full vector'
      CALL rluxut(restart)
      WRITE (6,'(/A/(1X,5I14))') '  current RANLUX status saved:', 
     &     (restart(i),i=1,25)
      CALL ranlux(rvec,Nnumbers)
      WRITE (6,'(A/9X,5F12.8)') ' RANLUX numbers 1- 5:',
     &     (rvec(i),i=1,5)
      CALL ranlux(rvec,Nnumbers)
      WRITE (6,'(A/9X,5F12.8)') ' RANLUX numbers:',
     &     (rvec(i),i=1,5)
      
      WRITE (6,'(/A)') '   previous RANLUX status will be restored'
      CALL rluxin(restart)
      CALL ranlux(rvec,Nnumbers)
      WRITE (6,'(A/9X,5F12.8)') ' RANLUX numbers 1- 5:',
     &     (rvec(i),i=1,5)
      CALL ranlux(rvec,Nnumbers)
      WRITE (6,'(A/9X,5F12.8)') ' RANLUX numbers:', 
     &     (rvec(i),i=1,5)
      
      STOP

      END  !PROGRAM luxtst

C ______________________________	   POWER SPECTRUM
C		                      25 april 1990
C		                     R. Kates (Potsdam), A. Klypin (NMSU)
C	     NROW = number of particles per row
C	     NGRID= number of cells on a side (normal grid)
C
C           Warning: comment out lines with declarations of
C                         common blocks /FOURAR/ and /F67COM/
C                         in files PMparameters.h        
C
       INCLUDE 'PMparameters.h'
       INCLUDE 'PMmesh.h'
       REAL     INPUT
C...................................................................
C			Read data and open files
      OPEN(17,FILE='Spectrum.DAT',STATUS='UNKNOWN')
      CALL RDTAPE

      write (*,*) ' RDTAPE is done'
      WRITE (17,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,wspecies(1),
     +                  EKIN,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv,lspecies(1),Nspecies
100   FORMAT(1X,'Header=>',A45,/
     +            1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I9,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3,/
     +            1x,' Number of part.1specie=',i10,' Nspecies=',i3)
      Box = extras(100)
      If(Box.le.1.e-3)Then
          Box =INPUT(' Enter box size in Mpc/h   =')
      EndIf 
C
         CALL DENSIT    !   Find density
            write (*,*) ' Density is ok'
c      Call DensCR
         CALL DENTES(DELR) ! Statistics
         CALL POWER(Box)   ! Power spectrum

      STOP
      END

C-----------------------------------------------------
C		                                                  Compute mean density and rms
      SUBROUTINE DENTES(DELR)
C-----------------------------------------------------
       INCLUDE 'PMparameters.h'
       INCLUDE 'PMmesh.h'
      Dimension x(44),amass(44),imass(44)
      real*8 SUM,SUM2

      Data x/  0.,  0.2, 0.4, 0.6, 0.7,  0.8,  0.9,  1.,  1.1,   1.2,
     .         1.3, 1.5, 1.75, 2., 2.25, 2.5,  3.0,  3.5,  4.,    5.,
     .         7.,  10., 12., 15., 20.,  25.,  30.,  40.,  50.,  70.,
     .       100., 120.,150.,200.,300., 500., 700.,1000.,1200.,1500.,
     .       2.e3, 3.e3,5.e3,1.e4/
      Do i=1,44
         amass(i) =0.
         imass(i) =0
      EndDo
      
      SUM = 0.
      SUM2= 0.
      Nn  = 0
      Am  = 0.
C.... Open_MP
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP+PRIVATE ( k,j,i)
C$OMP+REDUCTION(+:SUM,SUM2)
      DO K=1,NGRID
      DO J=1,NGRID
      DO I=1,NGRID
       SUM = SUM + FI(I,J,K)
       SUM2= SUM2+ FI(I,J,K)**2
c       Do l=44,1,-1
c          Dens =FI(I,J,K) +1.
c          If(Dens .GT. x(l))Then
c             Nn       =Nn +1
c             Am       =Am +Dens
c             imass(l) =imass(l) +1
c             amass(l) =amass(l) +Dens
c             GoTo 10
c          EndIf
c       EndDo
c 10    Continue
      ENDDO
      ENDDO
      ENDDO
      Total =(FLOAT(NGRID))**3
      DENM = SUM/Total
      DELR = DSQRT(SUM2/Total-DENM**2)
      DensAv=PARTW*float(NROW)**3/(float(NGRID))**3
      DensOne= float(NGRID)**3/float(NROW)**3
         WRITE (*,150)  DELR,DENM,DensAv,DensOne
         WRITE (17,150) DELR,DENM,DensAv,DensOne
 150     format(20('-'),' Density Distribution',20('-'),/
     &   '              Density is in units of average density',
     &                       ' in the Box',/20x,
     &                     ' RMS Delta Rho/Rho   =',G11.4,/20x,
     &                     ' Mean Delta Rho/Rho  =',G11.4,/20x,
     &                     ' Average density     =',G11.4,/20x,
     &                     ' One particle density=',G11.4)
c     &,/' bin    Rho     Rho   Sum(rho_i)/dRho/TotMass        Sum',/
c     &'      <center>< left > Normalized density     Number of cells ',/
c     &'      < bin  ><border>   Distribution         With this density')  
c      Do k=1,44-1
c         drho =x(k+1)-x(k)
c         rhom =x(k)+drho/2.
c         Sn   =drho*Total
c            If(Sn .lt.1.e-7)Sn=1.
c         write (*,20)  k,rhom,x(k),amass(k)/Sn,imass(k)
c         write (17,20) k,rhom,x(k),amass(k)/Sn,imass(k)
c 20      Format(i3,2f8.1,2x,G12.3,12X,i12)
c      EndDo
c         k =44
c         write (*,20)  k,x(k),x(k),amass(k),imass(k)
c         write (17,20) k,x(k),x(k),amass(k),imass(k)
      RETURN
      END

C----------------------------------------------------
C                                                     power spectrum   P(k)
C                                                     for given density field FI
      SUBROUTINE POWER(Box)
C----------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMmesh.h'
      PARAMETER ( Pi=3.141592653, NPOWER =NGRID)
      PARAMETER (NPROCS =64)
      DIMENSION DPOWER(NPOWER),iVolume(NPOWER),dk(NPOWER)
      DIMENSION DPW(NPOWER,NPROCS),iVol(NPOWER,NPROCS),
     &          dkk(NPOWER,NPROCS)

      dimension Zf(narr) , Yf(narr)
      dimension si(nf67) , indx(nf67)
      REAL*8    SIGMA,DPOWER,DPW

      NSPEC = NGRID/2
      If(Box.le.0..or.Box.gt.1.e+4)Then
         write (*,*) ' Wrong Box size=',Box,' STOP'
         Return
      EndIf
      SIGMA =0.
      Scale = 2.*Pi/Box
      DO M =1,NPOWER
         iVolume(M) =0
         DPOWER(M)  =0.
         dk(M)      =0.
         Do i=1,NPROCS
           iVol(M,i) =0
           DPW(M,i)     =0.
           dkk(M,i)     =0.
         EndDo 
      ENDDO
      ib1 = 3  
      iq  = int(alog(float(NGRID))/alog(2.)+0.5)
      FT  = (2.*NGRID)**3*float(NGRID)**3   
C                                               FFT of density field
      write (*,*) '     Do fft of rho along x-axis'
      call setf67(ib1,iq,ibc,ip,isl,l1,n2,n3,n4,n7,si,indx,Zf,Yf)

C.... Open_MP
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP+PRIVATE ( k,j,i,zf,yf,ip,isl,l1,n2,n4 )
      DO K=1,NGRID
         DO J=1,NGRID
            DO I=1,NGRID
               Zf(I) =FI(I,J,K)
            ENDDO
	    call four67(ib1,iq,ip,isl,l1,n2,n7,
     &                 si,indx,Zf,Yf)
            DO I=1,NGRID
               FI(I,J,K) = Yf(I)
            ENDDO
c      If(J.lt.12.and.K.eq.1)write (*,'(2i4,16g12.3)')J,K,(Zf(I),I=1,16)
         ENDDO
      ENDDO

C.... Open_MP
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP+PRIVATE ( k,j,i,zf,yf,ip,isl,l1,n2,n4 )
      DO K=1,NGRID
         DO I=1,NGRID
            DO J=1,NGRID
               Zf(J) =FI(I,J,K)
            ENDDO
            call four67(ib1,iq,ip,isl,l1,n2,n7,si,indx,
     &                        Zf,Yf)
            DO J=1,NGRID
               FI(I,J,K) = Yf(J)
            ENDDO
         ENDDO
      ENDDO

      write (*,*) '  Swap k<->i'
C.... Open_MP
C$OMP PARALLEL DO DEFAULT(SHARED)
C$OMP+PRIVATE ( k,j,i,aa)
      DO J=1,NGRID
      DO K=1,NGRID-1
            DO I=K+1,NGRID
               aa = FI(I,J,K)
               FI(I,J,K) =FI(K,J,I)
               FI(K,J,I) =aa
            ENDDO
         ENDDO
      ENDDO


      write (*,*) '     ....z'
C.... Open_MP
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP+PRIVATE ( k,j,i,zf,yf,ip,isl,l1,n2,n4 )
      DO K=1,NGRID
         DO J=1,NGRID
            DO I=1,NGRID
               Zf(I) =FI(I,J,K)
            ENDDO
            call four67(ib1,iq,ip,isl,l1,n2,n7,si,indx,
     &                        Zf,Yf)
            DO I=1,NGRID
                  FI(I,J,K) =  Yf(I)**2/FT
            ENDDO
         ENDDO
      ENDDO

      FI(1,1,1) =0.
      kStep     =NGRID/NPROCS
      If(kstep*NPROCS.ne.NGRID)STOP '-- Wrong number of NPROCS'
      write (*,*) '    Power .... kStep=',kStep

C.... Open_MP
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP+PRIVATE (iP,kStart,kEnd, k,j,i,MJ,MK,AMP,RK,MP)
C$OMP+REDUCTION(+:SIGMA)
      Do iP=1,NPROCS
         kStart =(iP-1)*kStep+1
         kEnd   =iP*kStep
      Do K=kStart,kEnd
         IF(K.LE.(NSPEC+1)) THEN
               MK =(K-1)**2 
         ELSE  
               MK =(K-1-NSPEC)**2
         ENDIF                                                                                              
      DO J=1,NGRID
         IF(J.LE.(NSPEC+1)) THEN
            MJ =(J-1)**2
         ELSE
            MJ =(J-1-NSPEC)**2
         ENDIF
         DO I=1,NGRID
               AMP = FI(I,J,K)
                  SIGMA = SIGMA +AMP
C                                          Find Abs(K)
                  IF(I.LE.(NSPEC+1)) THEN
                     RK =SQRT( FLOAT((I-1)**2     +MK+MJ) )
                  ELSE
                     RK =SQRT( FLOAT((I-1-NSPEC)**2+MK+MJ) )
                  ENDIF
C                                          Power Spectrum
                  MP =INT(RK +0.5)
                  IF(MP.LE.NPOWER.and.MP.gt.0)THEN
                     DPW(MP,iP)  =DPW(MP,iP) +AMP
                     iVol(MP,iP) =iVol(MP,iP)+1
                     dkk(MP,iP)  =dkk(MP,iP) +RK
                  ENDIF
            ENDDO
         ENDDO
      ENDDO
      ENDDO
      Do MP=1,NPOWER
      Do iP=1,NPROCS
          DPOWER(MP)  =DPOWER(MP) +DPW(MP,iP)
          iVolume(MP) =iVolume(MP)+iVol(MP,iP)
          dk(MP)      =dk(MP)     +dkk(MP,iP)
      EndDo 
      EndDo 

      WRITE (*,100) SQRT(SIGMA),Scale*NROW/2.
      WRITE (17,100) SQRT(SIGMA),Scale*NROW/2.
100   FORMAT(5x,'RMS DRho/Rho=',F7.3,' k_Nyquist for Particles=',f6.2,
     &        /4X,'n',2X,'k(h/Mpc)',1X,
     &       'Harmonics ','Power Spectrum(h^3)')
110   FORMAT(1x,I4,F8.3,I10,3X,5G12.4)
      DO I=1,NPOWER
         IF(iVolume(I).GT.0)THEN
            wk  = dk(I)/iVolume(I)*Scale
            Pk  = Box**3*DPOWER(I)/iVolume(I)
             
            WRITE (*,110)  I,wk,iVolume(I),Pk
            WRITE (17,110) I,wk,iVolume(I),Pk
         ENDIF
      ENDDO
      RETURN
      END
C*********************************************************************
C                                      Corr.function for given R
      FUNCTION FCORR(R)
       INCLUDE 'PMparameters.h'
       INCLUDE 'PMmesh.h'
      PARAMETER (  MMAX=NMAX-2)
      PARAMETER (PI=3.141592653)
 
      IF(R.LE.1.E-5)THEN
            WRITE (*,*) ' Fcorr(R): R can not be zero'
            STOP
      ENDIF
      QF    =2.*PI*R/FLOAT(NGRID)
      QSHF  =(FLOAT(NGRID)/2.)**2
      M     =NMAX +1
 
      SIGMA =0.
      FK    =SQRT(3.)*NMAX
      SIGMA =SIGMA + SIN(QF*FK) * FI(M,M,M)
      FK    =SQRT(2.)*NMAX
      SIGMA =SIGMA + SIN(QF*FK) *(FI(M,M,1)+FI(M,1,M)+FI(1,M,M))
      FK    =         NMAX
      SIGMA =SIGMA + SIN(QF*FK) *(FI(M,1,1)+FI(1,M,1)+FI(1,1,M))
      DO K1 =1,MMAX
         M1    =K1 +1
         L1    =K1 +1+NMAX
         K12   =K1**2
         SIGMA =SIGMA + SIN(QF*K1)*( FI(M1,1,1)+FI(L1,1,1)+
     .                               FI(1,M1,1)+FI(1,L1,1)+
     .                               FI(1,1,M1)+FI(1,1,L1))
         FK    =SQRT(K12+2.*QSHF)
         SIGMA =SIGMA + SIN(QF*FK)*( FI(M1,M,M)+FI(L1,M,M)+
     .                               FI(M,M1,M)+FI(M,L1,M)+
     .                               FI(M,M,M1)+FI(M,M,L1))
         FK    =SQRT(K12+   QSHF)
         SIGMA =SIGMA + SIN(QF*FK)*( FI(M1,M,1)+FI(L1,M,1)+
     .                               FI(M,M1,1)+FI(M,L1,1)+
     .                               FI(M1,1,M)+FI(L1,1,M)+
     .                               FI(M,1,M1)+FI(M,1,L1)+
     .                               FI(1,M1,M)+FI(1,L1,M)+
     .                               FI(1,M,M1)+FI(1,M,L1))
         DO K2 =1,MMAX
            M2    =K2 +1
            L2    =K2 +1+NMAX
            K22   =K2**2
            FK    =SQRT(Float(K12+ K22))
            SIGMA =SIGMA + SIN(QF*FK)*( FI(M1,M2,1)+FI(M1,L2,1)+
     .                                  FI(L1,M2,1)+FI(L1,L2,1)+
     .                                  FI(1,M1,M2)+FI(1,M1,L2)+
     .                                  FI(1,L1,M2)+FI(1,L1,L2)+
     .                                  FI(M1,1,M2)+FI(M1,1,L2)+
     .                                  FI(L1,1,M2)+FI(L1,1,L2))
            FK    =SQRT(K12+ K22 +QSHF)
            SIGMA =SIGMA + SIN(QF*FK)*( FI(M1,M2,M)+FI(M1,L2,M)+
     .                                  FI(L1,M2,M)+FI(L1,L2,M)+
     .                                  FI(M,M1,M2)+FI(M,M1,L2)+
     .                                  FI(M,L1,M2)+FI(M,L1,L2)+
     .                                  FI(M1,M,M2)+FI(M1,M,L2)+
     .                                  FI(L1,M,M2)+FI(L1,M,L2))
            DO K3 =1,MMAX
               M3    =K3 +1
               L3    =K3 +1+NMAX
               K32   =K3**2
               FK    =SQRT(Float(K12+ K22 +K32))
               SIGMA =SIGMA + SIN(QF*FK)*( FI(M1,M2,M3)+FI(M1,L2,M3)+
     .                                     FI(L1,M2,M3)+FI(L1,L2,M3)+
     .                                     FI(M1,M2,L3)+FI(M1,L2,L3)+
     .                                     FI(L1,M2,L3)+FI(L1,L2,L3))
            ENDDO
         ENDDO
      ENDDO
 
      FCORR  = SIGMA/QF
 
      RETURN
      END
C---------------------------------------
C                                                       Density Field    
      SUBROUTINE DENSIT
C---------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMmesh.h'
      	XN   =FLOAT(NGRID)+1.-1.E-7
	      YN   =FLOAT(NGRID)
C				       Subtract mean density
      DO M3=1,NGRID
       DO M2=1,NGRID
	      DO M1=1,NGRID
	        FI(M1,M2,M3) = -1.
	      END DO
       END DO
      END DO

      W     = (FLOAT(NGRID)/FLOAT(NROW))**3
      PARTW = W  
      WPAR = wspecies(1)
      N =0
      xmin =1.e+5
      xmax =-1.e+5
      ymin =1.e+5
      ymax =-1.e+5
      zmin =1.e+5
      zmax =-1.e+5

C				       Loop over particles
       If(Nspecies.eq.0)Then ! old case: 1 complete set
         Npages =NROW          ! Number of pages
         N_in_last=NPAGE       ! Number of particles in last page
      Else                             ! multiple masses
         N_particles =lspecies(Nspecies)   ! Total number of particles
         Npages = (N_particles -1)/NPAGE +1
         N_in_last=N_particles -NPAGE*(Npages-1)
      EndIf     
      write (*,*) Nspecies,
     + lspecies(Nspecies),wspecies(Nspecies)
      Nsp_current =1
      ff       = float(NGRIDC)
      ind = INT(log(float(NGRID)/ff)/log(2.)+10.)-10
      WPAR     = wspecies(1) *8.**ind
      Lspec_next=lspecies(1)+1

      DO IROW=1,Npages
            In_page =NPAGE
            If(IROW.eq.Npages)In_page =N_in_last
            If(IROW/50*50.eq.IROW)
     +        write (*,*) ' Read page=',IROW,' N=',N,
     +             ' Npages=',Npages,In_page
            iL = NPAGE*(IROW-1)
C				       Loop over particles
         READ  (21,REC=IROW) RECDAT
	   DO   IN=1,In_page
            N   = N +1
            If(N.ge.Lspec_next)Then   ! next specie
               write (*,*) ' Another specie. Current=',Nsp_current
               write (*,*) '     Particle=',N,WPAR,
     &                         ' lspecies=',lspecies(Nsp_current),
     &                         ' next=',lspecies(Nsp_current+1)
               Nsp_current=Nsp_current+1
               Lspec_next =lspecies(Nsp_current)+1
               WPAR     = wspecies(Nsp_current)
            EndIf
            X=(XPAR(IN)-1.)*NGRID/ff +1.
            Y=(YPAR(IN)-1.)*NGRID/ff +1.
            Z=(ZPAR(IN)-1.)*NGRID/ff +1.
           IF(X.ge.NGRID+1.)X=X-NGRID
           IF(Y.ge.NGRID+1.)Y=Y-NGRID
           IF(Z.ge.NGRID+1.)Z=Z-NGRID
           xmin =MIN(xmin,X)
           ymin =MIN(ymin,Y)
           zmin =MIN(zmin,Z)
           xmax =MAX(xmax,X)
           ymax =MAX(ymax,Y)
           zmax =MAX(zmax,Z)
	        I=INT(X)
	        J=INT(Y)
	        K=INT(Z)
            If(I.le.0)write (*,*) ' X:',X,Y,Z,I,' Irow=',IROW,IN,ifile
            If(J.le.0)write (*,*) ' Y:',X,Y,Z,I,' Irow=',IROW,IN,ifile
            If(K.le.0)write (*,*) ' Z:',X,Y,Z,I,' Irow=',IROW,IN,ifile
	        D1=X-FLOAT(I)
	        D2=Y-FLOAT(J)
	        D3=Z-FLOAT(K)
	        T1=1.-D1
	        T2=1.-D2
	        T3=1.-D3
	        T2W =T2*WPAR
	        D2W =D2*WPAR
	        I1=I+1
	           IF(I1.GT.NGRID)I1=1
	        J1=J+1
	           IF(J1.GT.NGRID)J1=1
	        K1=K+1
	           IF(K1.GT.NGRID)K1=1
		      FI(I ,J ,K ) =FI(I ,J ,K ) +T3*T1*T2W
		      FI(I1,J ,K ) =FI(I1,J ,K ) +T3*D1*T2W
		      FI(I ,J1,K ) =FI(I ,J1,K ) +T3*T1*D2W
		      FI(I1,J1,K ) =FI(I1,J1,K ) +T3*D1*D2W
    
		      FI(I ,J ,K1) =FI(I ,J ,K1) +D3*T1*T2W
		      FI(I1,J ,K1) =FI(I1,J ,K1) +D3*D1*T2W
		      FI(I ,J1,K1) =FI(I ,J1,K1) +D3*T1*D2W
		      FI(I1,J1,K1) =FI(I1,J1,K1) +D3*D1*D2W
	      ENDDO
        ENDDO 

      write (*,*) ' Number of particles read=', N
      write (*,*) ' X:',xmin,xmax
      write (*,*) ' Y:',ymin,ymax
      write (*,*) ' Z:',zmin,zmax
        RETURN
      END

C------------------------------------
c      Subroutine densCR
c      INCLUDE 'PMparameters.h'
c      INCLUDE 'PMmesh.h'
c      	XN   =FLOAT(NGRID)+1.-1.E-7
c	      YN   =FLOAT(NGRID)

c      SUMM = 0.
c      WD       =0.
c      open(40,file='dens_cr.dat',status='unknown')
c      read(40,*) FI
c      Do k=1,NROW
c      Do j=1,NROW
c      Do i=1,NROW
c         SUMM =SUMM +FI(i,j,k)
c         WD      =WD +FI(i,j,k)**2
c      EndDo
c      EndDo
c      EndDo
c      sigma = sqrt(MAX(1.d-10,WD/NROW**3))
c      write (*,*) ' Average density=',SUMM/NROW**3
c      write (*,*) ' RMS density=',sigma
c       IFOUR = INT(ALOG(FLOAT(NROW))/ALOG(2.)+0.5)
c       Write (*,*) ' Ifour =',IFOUR,' Nrow=',NROW

c       Return
c       End
C---------------------------------------------------
C                                  Read  current data from disk/tape,
C                                  Open files
C                                  Nrecl is the number of values in a record
C                                  Npage is the number of particles in a page
      SUBROUTINE RDTAPE
C---------------------------------------------------
      INCLUDE 'PMparameters.h'
C                                     Open file on a tape
      OPEN(UNIT=9,FILE='PMcrd.DAT',
     +                FORM='UNFORMATTED', STATUS='UNKNOWN')
C                                 Read control information
C                                 and see whether it has proper
C                                 structure
      READ  (9,err=20,end=20) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  TINTG,EKIN,EKIN1,EKIN2,AU0,AEU0,
     +                  NROWC,NGRIDC,Nspecies,Nseed,Om0,Oml0,hubble,Wp5
     +                   ,Ocurv,extras
      WRITE (*,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,EKIN1,EKIN2,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
      WRITE (16,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,EKIN1,EKIN2,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
100   FORMAT(1X,'Header=>',A45,/
     +          1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',3E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I9,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3)
      IF(NROW.NE.NROWC) THEN
         WRITE (*,*)
     +            ' NROW in PARAMETER and in TAPE-FILE are different'
      ENDIF
      IF(NGRID.NE.NGRIDC) THEN
         WRITE (*,*)
     +           ' NGRID in PARAMETER and in TAPE-FILE are different:'
         write (*,*) ' Ngrid=',NGRID,' NgridC=',NGRIDC
      ENDIF
C                                         Open work file on disk
      write (*,*)  ' start openning PMcrs0'
 10   NBYTE = NRECL*4
      NACCES= NBYTE / nbyteword

      OPEN(UNIT=21,FILE='PMcrs0.DAT',ACCESS='DIRECT',
     +	               STATUS='UNKNOWN',RECL=NACCES)


      REWIND 9
       write (*,*)  ' done openning PMcrs0'
      RETURN
 20   write (*,*) ' Error reading the header file: Abort'
      stop
      END
C---------------------------------- Read in variables      
      REAL FUNCTION INPUT(text)
C------------------------------------------------
      Character text*(*)
          write (*,'(A,$)')text
          read (*,*) x
          INPUT =x
      Return
      End

C--------------------------------------   Fourier Transform
      SUBROUTINE SETF67(IBC1,IQ1,ibc,ip,isl,l1,n2,n3,n4,n7,
     &                  si,indx,Zf,Yf)
c     -----------------------------------------------------
       INCLUDE 'PMparameters.h'
       include 'PMmesh.h'
      dimension Zf(narr) , Yf(narr)
      dimension si(nf67) , indx(nf67)

      integer  ibc , ip, isl , l1 , n2 , n3 , n4 , n7
c      INCLUDE 'Control.param'
      PI=DATAN(1.D0)*4.
       IBC=IBC1
       IQ=IQ1
       IF(IBC.LT.3) GO TO 101
       IQ=IQ-1
  101      N3=2**IQ
       N7=N3/2
       N5=N3/4
       I=1
       INDX(I)=N5
       SI(I)=0.5*SQRT(2.)
       K=I
       I=I+1
  102     IL=I
       IF(I.EQ.N7) GO TO 104
  103     K1=INDX(K)/2
       INDX(I)=K1
       SI(I)=SIN(PI*FLOAT(K1)/FLOAT(N3))
       K1=N7-K1
       I=I+1
       INDX(I)=K1
       SI(I)=SIN(PI*FLOAT(K1)/FLOAT(N3))
       K=K+1
       I=I+1
       IF(K.EQ.IL) GO TO 102
       GO TO 103
  104     RETURN
       END
C-----------------------------------------
       SUBROUTINE TFOLD(IS,L,ZZZ,n2)
       INCLUDE 'PMparameters.h'
       include 'PMmesh.h'

       integer  n2

       DIMENSION ZZZ(NARR)
       IH2=N2/2-1
       DO 100 I=IS,IH2
       I1=I+L
       I2=N2-I+L
       A=ZZZ(I1)
       ZZZ(I1)=A-ZZZ(I2)
       ZZZ(I2)=A+ZZZ(I2)
  100     CONTINUE
       RETURN
       END
C------------------------------------
       SUBROUTINE NEG(I1,I3,I2,ibc,ip,isl,l1,n2,n3,n4,n7,si,indx,Zf,Yf)
       INCLUDE 'PMparameters.h'
       include 'PMmesh.h'
       dimension Zf(narr) , Yf(narr)
       dimension si(nf67) , indx(nf67)
 
       integer  ibc , ip, isl , l1 , n2 , n3 , n4 , n7

       DO 100 K=I1,I3,I2
       Yf(K)=-Yf(K)
  100     CONTINUE
       RETURN
       END
C-------------------------------------
       SUBROUTINE REVNEG(ibc,ip,isl,l1,n2,n3,n4,n7,si,indx,Zf,Yf)
       INCLUDE 'PMparameters.h'
       include 'PMmesh.h'
       dimension Zf(narr) , Yf(narr)
       dimension si(nf67) , indx(nf67)

       integer  ibc , ip, isl , l1 , n2 , n3 , n4 , n7

       DO 100 I=1,N7
       J=N3+1+I
       K=N4+1-I
       A=Yf(J)
       Yf(J)=-Yf(K)
       Yf(K)=-A
  100     CONTINUE
       RETURN
       END
C-------------------------------------
       SUBROUTINE ZEERO(L,ibc,ip,isl,l1,n2,n3,n4,n7,si,indx,Zf,Yf)
       INCLUDE 'PMparameters.h'
       include 'PMmesh.h'
       dimension Zf(narr) , Yf(narr)
       dimension si(nf67) , indx(nf67)

       integer  ibc , ip, isl , l1 , n2 , n3 , n4 , n7

       DO 100 I=1,N2
       LI=L+I
       Zf(LI-1)=0.0
  100     CONTINUE
       RETURN
       END
C------------------------------------------
       SUBROUTINE TFOLD1(ibc,ip,isl,l1,n2,n3,n4,n7,si,indx,Zf,Yf)
       INCLUDE 'PMparameters.h'
       include 'PMmesh.h'
       dimension Zf(narr) , Yf(narr)
       dimension si(nf67) , indx(nf67)

       integer  ibc , ip, isl , l1 , n2 , n3 , n4 , n7

       II=N2-1
       DO 100 I=1,II
       I1=ISL+I
       I2=L1-I
       A=Zf(I1)
       Zf(I1)=A+Zf(I2)
       Zf(I2)=A-Zf(I2)
  100     CONTINUE
       RETURN
       END
C-------------------------------------
       SUBROUTINE KFOLD(ibc,ip,isl,l1,n2,n3,n4,n7,si,indx,Zf,Yf)
       INCLUDE 'PMparameters.h'
       include 'PMmesh.h'
       dimension Zf(narr) , Yf(narr)
       dimension si(nf67) , indx(nf67)

       integer  ibc , ip, isl , l1 , n2 , n3 , n4 , n7

       JS1=N2
       I=1
       J5=ISL+N2
       IS1=ISL
       IC1=L1
       JS1=JS1/2
       IF(JS1.NE.1) GO TO 200
       K1=INDX(I)
       SN=SI(I)
       IS0=IS1
       IS1=IS1+JS1
       IC0=IC1
       IC1=IC1+JS1
       ODD1=SN*(Zf(IC1)-Zf(IS1))
       Yf(K1+1)=Zf(IC0)+ODD1
       N3MK1=N3-K1
       Yf(N3MK1+1)=Zf(IC0)-ODD1
       IF(IBC.LT.3) GO TO 110
       ODD2=SN*(Zf(IC1)+Zf(IS1))
       N3PK1=N3+K1
       Yf(N3PK1+1)=Zf(IS0)+ODD2
       N4MK1=N4-K1
       Yf(N4MK1+1)=-Zf(IS0)+ODD2
  110     RETURN
  200     SN=SI(I)
       IS1=IS1+JS1
       IC1=IC1+JS1
       J3=IS1+JS1
  210     IS0=IS1-JS1
       IC0=IC1-JS1
       ODD1=SN*(Zf(IC1)-Zf(IS1))
       ODD2=SN*(Zf(IC1)+Zf(IS1))
       Zf(IC1)=Zf(IC0)-ODD1
       Zf(IS1)=-Zf(IS0)+ODD2
       Zf(IC0)=Zf(IC0)+ODD1
       Zf(IS0)=Zf(IS0)+ODD2
       IS1=IS1+1
       IC1=IC1+1
       IF(IS1.NE.J3) GO TO 210
       I=I+1
  300     IS1=ISL
       IC1=L1
       JS1=JS1/2
       IF(JS1.EQ.1) GO TO 400
  310     SN=SI(I)
       I=I+1
       CS=SI(I)
       IS1=IS1+JS1
       IC1=IC1+JS1
       J3=IS1+JS1
  320     IS0=IS1-JS1
       IC0=IC1-JS1
       ODD1=CS*Zf(IC1)-SN*Zf(IS1)
       ODD2=SN*Zf(IC1)+CS*Zf(IS1)
       Zf(IC1)=Zf(IC0)-ODD1
       Zf(IC0)=Zf(IC0)+ODD1
       Zf(IS1)=-Zf(IS0)+ODD2
       Zf(IS0)=Zf(IS0)+ODD2
       IS1=IS1+1
       IC1=IC1+1
       IF(IS1.NE.J3) GO TO 320
       IS1=IS1+JS1
       IC1=IC1+JS1
       J3=IS1+JS1
  330     IS0=IS1-JS1
       IC0=IC1-JS1
       ODD1=SN*Zf(IC1)-CS*Zf(IS1)
       ODD2=CS*Zf(IC1)+SN*Zf(IS1)
       Zf(IC1)=Zf(IC0)-ODD1
       Zf(IC0)=Zf(IC0)+ODD1
       Zf(IS1)=-Zf(IS0)+ODD2
       Zf(IS0)=Zf(IS0)+ODD2
       IS1=IS1+1
       IC1=IC1+1
       IF(IS1.NE.J3) GO TO 330
       I=I+1
       IF(IS1.EQ.J5) GO TO 300
       GO TO 310
  400     K1=INDX(I)
       SN=SI(I)
       I=I+1
       CS=SI(I)
       IS0=IS1
       IS1=IS1+JS1
       IC0=IC1
       IC1=IC1+JS1
       ODD1=CS*Zf(IC1)-SN*Zf(IS1)
       Yf(K1+1)=Zf(IC0)+ODD1
       N3MK1=N3-K1
       Yf(N3MK1+1)=Zf(IC0)-ODD1
       IF(IBC.LT.3) GO TO 410
       ODD2=SN*Zf(IC1)+CS*Zf(IS1)
       N3PK1=N3+K1
       Yf(N3PK1+1)=Zf(IS0)+ODD2
       N4MK1=N4-K1
       Yf(N4MK1+1)=-Zf(IS0)+ODD2
  410     IS1=IS1+1
       IC1=IC1+1
       K1=INDX(I)
       IS0=IS1
       IS1=IS1+JS1
       IC0=IC1
       IC1=IC1+JS1
       ODD1=SN*Zf(IC1)-CS*Zf(IS1)
       Yf(K1+1)=Zf(IC0)+ODD1
       N3MK1=N3-K1
       Yf(N3MK1+1)=Zf(IC0)-ODD1
       IF(IBC.LT.3) GO TO 420
       ODD2=CS*Zf(IC1)+SN*Zf(IS1)
       N3PK1=N3+K1
       Yf(N3PK1+1)=Zf(IS0)+ODD2
       N4MK1=N4-K1
       Yf(N4MK1+1)=-Zf(IS0)+ODD2
  420     IS1=IS1+1
       IC1=IC1+1
       I=I+1
       IF(IS1.NE.J5) GO TO 400
       RETURN
       END

c      ------------------------------------------------------
       SUBROUTINE FOUR67(IBC1,IQ1,ip1,isl1,l11,n21,n71,
     &                   si,indx,Zf,Yf)
c      ------------------------------------------------------
       INCLUDE 'PMparameters.h'
       include 'PMmesh.h'
       dimension Zf(narr) , Yf(narr)
       dimension si(nf67) , indx(nf67)

       integer  ibc , ip, isl , l1 , n2 , n3 , n4 , n7

c       INCLUDE 'Control.param'
       IBC=IBC1
       IQ=IQ1
       ip = ip1
       isl = isl1
       l1 = l11
       n2 = n21
       n7 = n71
       A5=0.5*SQRT(2.0)
       N4=2**IQ
       N3=N4
       GO TO (103,103,101,102),IBC
  101     Zf(1)=Zf(1)/2.0
       Zf(N3+1)=Zf(1)
       N2=N3

       CALL TFOLD(0,1,Zf,n2)

       N3=N3/2
       IQ=IQ-1
       GO TO 103
  102     N3=N3/2
       IQ=IQ-1
  103     N5=N3/4
       N7=N3/2
       N11=3*N7
       N31=N3+1
       GO TO(300,400,500,600),IBC
  300     Zf(N31)=0.0
       Zf(1)=0.0
       N2=N3
       DO 301 I=2,IQ

       CALL TFOLD(1,1,Zf,n2)

  301     N2=N2/2
       Yf(N7+1)=Zf(2)
       JF=N5
       ISL=1
       DO 302 IP=2,IQ
       L1=N2+1

       CALL ZEERO(1,ibc,ip,isl,l1,n2,n3,n4,n7,si,indx,Zf,Yf)
       CALL KFOLD(ibc,ip,isl,l1,n2,n3,n4,n7,si,indx,Zf,Yf)

       I1=3*JF+1
       I2=4*JF
       I3=I1+(N2/2-1)*I2

       CALL NEG(I1,I3,I2,ibc,ip,isl,l1,n2,n3,n4,n7,si,indx,Zf,Yf)

       N2=N2+N2
  302     JF=JF/2
       RETURN
  400     Zf(1)=Zf(1)/2.0
       Zf(N31)=Zf(N31)/2.0
       N2=N3
       DO 401 I=2,IQ

       CALL TFOLD(0,N31-N2,Zf,n2)

  401     N2=N2/2
       L1=N31-N2
       A=Zf(L1)+Zf(L1+2)
       Yf(1)=-A-Zf(L1+1)
       Yf(N31)=-A+Zf(L1+1)
       Yf(N7+1)=Zf(L1)-Zf(L1+2)
       DO 402 IP=2,IQ
       ISL=N31-N2
       L1=ISL-N2
       idum = isl

       CALL ZEERO(idum,ibc,ip,isl,l1,n2,n3,n4,n7,si,indx,Zf,Yf)
       CALL KFOLD(ibc,ip,isl,l1,n2,n3,n4,n7,si,indx,Zf,Yf)

  402     N2=N2+N2

       CALL NEG(1,N31,2,ibc,ip,isl,l1,n2,n3,n4,n7,si,indx,Zf,Yf)

       RETURN
  500     N2=N3
       L2=N4
       DO 501 IP=2,IQ

       CALL TFOLD(1,1,Zf,n2)
       CALL TFOLD(0,L2-N2+1,Zf,n2)

  501     N2=N2/2
       L1=L2-N2+1
       A=Zf(L1)+Zf(L1+2)
       Yf(N7+1)=2.0*(-Zf(L1)+Zf(L1+2))
       Yf(1)=2.0*(A+Zf(L1+1))
       Yf(N31)=2.0*(A-Zf(L1+1))
       Yf(N11+1)=2.0*Zf(2)
       DO 502 IP=2,IQ
       Zf(N2+1)=2.0*Zf(N2+1)
       ISL=N2+1

       CALL TFOLD1(ibc,ip,isl,l1,n2,n3,n4,n7,si,indx,Zf,Yf)

       L1=L1-N2
       Zf(L1)=-2.0*Zf(L1)

       CALL KFOLD(ibc,ip,isl,l1,n2,n3,n4,n7,si,indx,Zf,Yf)

  502     N2=N2+N2
       Yf(1)=Yf(1)*A5
       Yf(N31)=Yf(N31)*A5
       RETURN
  600     Zf(1)=Zf(1)*A5
       Zf(N31)=Zf(N31)*A5
       N2=N3
       DO 601 IP=2,IQ

       CALL TFOLD(0,N31-N2,Zf,n2)
       CALL TFOLD(1,N31,Zf,n2)

  601     N2=N2/2
       L1=N31-N2
       A=Zf(L1)+Zf(L1+2)
       Yf(1)=2.0*(A+Zf(L1+1))
       Yf(N31)=2.0*(A-Zf(L1+1))
       Yf(N7+1)=2.0*(-Zf(L1)+Zf(L1+2))
       Yf(N11+1)=2.0*Zf(N3+2)
       DO 602 IP=2,IQ
       ISL=N31+N2
       Zf(ISL)=2.0*Zf(ISL)

       CALL TFOLD1(ibc,ip,isl,l1,n2,n3,n4,n7,si,indx,Zf,Yf)

       L1=L1-N2
       Zf(L1)=-2.0*Zf(L1)

       CALL KFOLD(ibc,ip,isl,l1,n2,n3,n4,n7,si,indx,Zf,Yf)

  602     N2=N2+N2

       CALL REVNEG(ibc,ip,isl,l1,n2,n3,n4,n7,si,indx,Zf,Yf)

       idum = n3

       CALL NEG(2,idum,2,ibc,ip,isl,l1,n2,n3,n4,n7,si,indx,Zf,Yf)

       N2=N4

       CALL TFOLD(1,1,Yf,n2)

       Yf(N4+1)=0.0

       RETURN
       END

C-------------------------------------------------
C        A.Klypin 25 Nov.1997 (NMSU)
C                            Bound-Density-Maxima code:
C                            Find  maxima of mass in spheres of radius Rsearch1 
C                            for particles in a periodic cube     of size     Box
C                           Coordinates: 0-NGRID,  Box =NGRID
C       All variables and constants are scaled to the Hubble constant of your
C       model. Only FINAL values are rescled to H=100km/s/Mpc
C       More detailed description of the algorithm and the code can be
C       found in file BDM_describe
C--------------------------------------------------   
C       Arrays Label and Lst provide quick access to neibhor particles
C       Label(i,j,k) = number of the first particle in
c                      the cell (i,j,k), if Label .ne. 0
C                    = 0 - empty cell
C       Cell         = size of a cell for Label
C       Lst(i)       = number of the next particle in the cell,
C                      where i-th was found.
C                      If Lst=0 - last point in the cell was found.
C     
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      Real             INPUT,Mhalo
      Real             Overdens(Nrad),Mass(Nrad),MnMass(Nrad)
      COMMON /OVER/ Ovlim,Ovcnt
      DIMENSION      Radsc(Nrad)

C     ------------------------------------------ Read data
      If(iHelp.eq.1)Call Help
      CALL RDTAPE
      If(iDebug.eq.1)write (*,*) ' RDTAPE is done'
      write (*,*)  '  RDTAPE is done'
      CALL SetWeights
      If(extras(100).gt.0.)Then
         Box =extras(100)
      Else
         Box  =INPUT(' Enter box size in comoving Mpc/h =')
      EndIf

      WRITE (*,120) 
     +                 AEXPN,ISTEP,NROW,NGRID
      write (*,*) '     Number of mass Species   =',Nspecies
      write (*,*) '     Total number of particles=',lspecies(Nspecies)
      write (*,*) '     Number of small particles=',lspecies(1)
      write (*,*) '     Box size (Mpc/h)         =  ',Box
120      FORMAT(1X,
     +     5x,'Expansion Parameter= ',F8.3,' Step= ',i5,/
     +     5x,'Nrow= ',I4,' Ngrid= ',I4)
           hsmall= hubble            ! Hubble/100.
           Box   = Box /hsmall       ! Scale to real Mpc          
           Xscale= Box/Ngrid        ! Scale for comoving coordinates
           Vscale= 100.*hsmall*Xscale/AEXPN ! Scale for velocities
           Dscale= 2.746e+11*hsmall**2*(Box/NROW)**3 *iWeight(1) ! mass scale
           aMassOne= Om0*Dscale*hsmall
      write (*,'(6x,"Mass of smallest particle",/9x,
     +    "in units M_sun/h is   =",3x,g10.3)') 
     +      aMassOne
      write(*,'(6x,"first species=",2g11.3)')wspecies(1),iWeight(1)
      If(Nspecies.gt.1)Then
      write (*,'(6x,"Mass of largest particle",/9x,
     +    "in units M_sun/h is   =",3x,g10.3)') 
     +   Om0*Dscale*wspecies(Nspecies)*hsmall/(NGRID**3/FLOAT(NROW**3))
      EndIf

      If(iHelp.eq.1)write(*,140)
 140  format(10x,'Give average overdensity inside halo radius',/
     +10x,'= 178 for CDM, Omg_0=1; =340 for LCDM Omg_0=0.3')

      Ovlim   = OverdenVir()        ! set virial overdensity
      Ovcnt   = Ovlim   ! Min. Center Overdensity for Halos 
                                   ! scale factor to get number of virial particles
      aNvir  = 4.1888*Ovlim*(NROW/float(NGRID))**3/iWeight(1)
      Amassl  = AmassOne*5.  ! Minimum halo mass in Msun/h 
      If(iHelp.eq.1)write(*,150)
 150  format(10x,'Code searches for maxima of mass inside spheres',/
     +10x,'with radii ranging from small radius (second question) to',/
     +10x,'large radius (first question). The radii may be equal.',/
     +10x,'The search radii should be larger than the resolution ',/
     +10x,'of the run. Code will fail if there is too few particles ',/
     +10x,'inside the spheres.',/
     +10x,'The smaller radius also is used for the search of ',/
     +10x,'more accurate position of density peak',/
     +10x,' Never give the value of the small radius which is ',/
     +10x,'smaller than 1.5-2 highest spatial resolution')

      Rsearch1=INPUT('Enter comoving search radius(Mpc/h)       => ')
      Rsearch2=INPUT('Enter smaller radius(Mpc/h) of final halos=> ')
      Rminhalo=0.0001   ! min.radius for halos(Mpc/h) 
      Fract   = 1.            ! fraction of DM particles (1/4,1/2,1)
      Fract   =Min(Max(Fract,0.),1.0)
                             
      If(iHelp.eq.1)write(*,160)
 160  format(10x,'Unbounding particles.',/
     +   10x,' =1 for removing unbound particles; =0 or >10',
     +    ' for no unbounding')
      Toohot  =INPUT('Enter rejection velocity limit (V/Vescape)=> ')
      If(iHelp.eq.1)write(*,170)
 170  format(10x,'Halos with close masses, close velocities and with',/
     +11x,'distances less than some value (Mpc/h) are considered ',/
     +10x,'as the same halo. Only the largest is kept.')

      dRdubl  =INPUT('Distance to check for Velocity duplicates => ')
      fVdubl  =0.15    ! Define duplicates if  (v1-v2)/Vrms   <   
      if(iHelp.eq.1)Then
         write (25,*) Ovlim,'  Overdensity Threshold for Halos'
         write (25,*) Rsearch1,' comoving search radius(Mpc/h)'
         write (25,*) Rsearch2,' smaller radius(Mpc/h) of final halos'
         write (25,*) Toohot,' rejection velocity limit (V/Vescape)'
         write (25,*) dRdubl,
     +             '  Distance to check for Velocity duplicates'     
      EndIf
C     ------------------------------------------ Open files
      Open( 2,file='Catshort.DAT',Status='UNKNOWN')! short list of halos
      Open(20,file='Catalog.DAT',Status='UNKNOWN') ! catalog of halos
C     ------------------------------------------ Read data
      CALL ReadPnt(N,Fract,xshift,yshift,zshift)                     ! particles
      If(iDebug.eq.1)write (*,*)' done Reading Particles'
C       CALL ReadMax(N,Fract)                     ! particles
c      Rsearch1=Rsearch1/AEXPN              ! scale to proper distances
c      Rsearch2=Rsearch2/AEXPN
c      dRdubl  =dRdubl /AEXPN
      Boxx =Box    !  store box size in Mpc

         WRITE (2,100) HEADER,
     +               AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +               EKIN,NROW,NGRID,Om0,Oml0,hubble
         WRITE (20,100) HEADER,
     +               AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +               EKIN,NROW,NGRID,Om0,Oml0,hubble
100      FORMAT(1X,'Header=>',A45,/
     +         ' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +         ' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,
     +         ' Nrow=',I4,' Ngrid=',I4,/' Omega_0=',f6.3,
     +         ' Omega_L=',f6.3,' h=',f6.3)
C     ------------------------------------------ Constants ---------
           Omcold= Om0 
           Omhot = 0.
           Amassl= Amassl/hsmall     ! Scale to real masses
           Radius= Rsearch1/hsmall  ! Comoving Search radius in real Mpc
           Rminhalo=Rminhalo/hsmall
           dRdubl= dRdubl/hsmall
C                         Dscale is a factor used to convert particles to mass 
C                                    =  mass of a particle for Omega=1 model
C                         Xscale is a factor to convert PM coordinates into Mpc
C                                    = Box / Ngrid = length of a PM cell in Mpc
C                        Vscale is a factor to convert PM pomenta to V (km/sec)
C                                    = the Hubble velocity at the distance 
C                                         of 1 PM cell
C                the factor AEXPN is needed to go from momenta to pec.velocity
      If(iDebug.eq.1)write (*,*) ' Vscale=',Vscale, ' X=',Xscale,
     +        ' Box(Mpc)=',Box
           Radius=Radius/Xscale   ! comoving radius in cell units
           RadSr1 =Rsearch1/hsmall/Xscale ! max Min search radii
           RadSr2 =Rsearch2/hsmall/Xscale           
           Box   =NGRID           ! all internal variables are in Grid units
           Riter =0.0001          ! Error for iteration of radius in cell units
           Rmax  =Radius          ! Treat maxima Identical  if dR<Rmax
           Cell   = Box/Nlinker
               If(iDebug.eq.1) write (*,*) ' Cell size=',Cell,
     +               ' Search Radius in cell units=',Radius
         DtoNscale = Om0*Dscale/Fract ! scale dark matter particles
cc         ANlimit =!!!Amassl/(DtoNscale)         ! and this
         ANlimit =8.*aNvir*iWeight(1) ! factor to calculate
                                      ! central overdensity
                                      ! It will be 8 times larger than
                                      ! virial overdensity
           R0    =0.004
           Rnrad =R0*((Nrad-1)/4.+1.)**2 
           write (*,'(/" The first and the last bins have radii:",
     &                   2f8.4," Mpc/h, comoving")')  R0,Rnrad
           write (*,*) '   If you want to change shells, enter a factor'
           write (*,'(A,$)') '    or 1 to keep current radii : '
           read  (*,*) factor
         if(iHelp.eq.1)write(25,*)factor,'  scale factor for bins'
           If(abs(factor-1.).ge.1.e-3.and.factor.gt.0.)Then
              R0    =0.004 * factor
              Rnrad =R0*((Nrad-1)/4.+1.)**2           
              write (*,*) '   The first and the last radii for halos'
              write (*,*) '   will be',R0,Rnrad,' Mpc/h, comoving'
           EndIf
           Do ir=1,Nrad                            ! Radii for halo shells
              Rad(ir) =R0/hsmall*((ir-1)/4.+1.)**2/Xscale ! comoving
              Rad2(ir)=Rad(ir)**2
           EndDo
           write (*,*) ' Final Radii(Mpc/h): 1st=',Rad(1)*Xscale*hsmall,
     +                  ' last=',Rad(Nrad)*Xscale*hsmall,' Cell=',Cell

c------------------------------------------ Prepare Data
           RadOld =Radius
           Radius  =Rad(Nrad)            ! Make radius temporarily bigger
      CALL Points(Box,N,Ncp,Radius)      ! Make more points periodically
                     If(iDebug.eq.1)
     +               write (*,*) ' Nparticles in periodic set=',Ncp,
     +                           '( Maximum =',Np,')'
           Radius =RadOld                ! Restore radius
      Call List(Box,Ncp)                 ! make linker List, Label
         write (*,*)  'List made'
      CALL ReadCent(N,Ncentr,Boxx)       ! read initial centers
          write (*,*) ' Nparticles=',N,' Ncenters=',Ncentr
C----------------------------- Find maxima
      CALL Pairs(Box,N,Ncentr,Riter)       ! find maxima 
      write (*,16)  Amassl*hsmall,ANlimit,Rminhalo*hsmall,
     &               Rsearch1,Rsearch2,Toohot,Cell
      write (2,16)  Amassl*hsmall,ANlimit,Rminhalo*hsmall,
     &               Rsearch1,Rsearch2,Toohot,Cell
      write (20,16) Amassl*hsmall,ANlimit,Rminhalo*hsmall,
     &               Rsearch1,Rsearch2,Toohot,Cell
             If(iDebug.eq.1)write (*,*) ' Om0=',Om0,' Dscale=',Dscale
 16   format(5x,'Small halos with Mass(M_sun/h) less than',
     .       g10.3,'(N_eff<',g11.3,') were removed',/
     .       5x,'Minimum Radius of Halo(Mpc/h)=',f7.4,/
     .       5x,'Comov.Search radius(Mpc/h)=',f7.4,
     .         ' Second radius(Mpc/h)=',f7.4,/
     .       5x,'Particles with V>',f5.1,'V_escape were removed',
     .       ' Cell (in grids) for linker list=',f8.3)
           write (*,*)  'Pairs made'

      CALL SmallRem(ANlimit,Ncentr)  ! Remove small halos
           write (*,*)  'Small Rem made'
      CALL CATALOG(Box,Ncentr)      ! Remove duplicates
           write (*,*)  'CATALOG made'
C                           Final touch: if Rsearch1 and Rsearch2 are different
C                           then  improve position of halos by shrinking
C                           the search Radius to Rsearch2 in Nit steps
      Rsearch2 = Rsearch2/2.  ! reduce the small radius 
                              ! for more accurate search of center
      IF(ABS(Rsearch1-Rsearch2).gt.0.001*Rsearch1)Then
         Nit =3
         hNit =(Rsearch1/Rsearch2)**(1./Nit)
         If(iDebug.eq.1)write (*,*) ' Nit =',Nit,' Factor:',hNit
        Do ii =1,Nit
            n1 = 0
            r1  =0.
            Do i=1,Ncentr
      	     If(Rmc(i).gt.RadSr2)Then
                    n1       =n1 +1
                    Rmc(i)=Rmc(i)/hNit
                    r1        =r1 +Rmc(i)
                 Endif
             Enddo 
          write (*,*)'Iterate:',
     &               ' Mean Comoving Radius for halos(Mpc/h)=',
     &                   r1/(max(n1,1))*Xscale*hsmall,' n=',n1
          CALL Pairs(Box,N,Ncentr,Riter) 
        EndDo
          t3 =seconds()
          write (*,*) ' time after Pairs=',t3

        Radius=Rsearch1
      EndIf
         If(Ncentr.gt.Ncc)Then
         write (*,*) ' Too many centers:',Ncentr,' max (Ncc)=',Ncc
         STOP ' Too many centers. Increase Ncc parameter'
      Endif 
      Celloptimal = (Rad(Nrad)/FracSearch)
      If(Celloptimal.gt.Cell)Then
          Cell = Celloptimal
          Call List(Box,Ncp)             ! make linker List, Label
      EndIf     
       write (*,20) N,Ncentr,Box*Xscale*hsmall,Ovlim,Cell
       write (2,20) N,Ncentr,Box*Xscale*hsmall,Ovlim,Cell
       write (20,20)N,Ncentr,Box*Xscale*hsmall,Ovlim,Cell
20         Format(5x,'Statistics for ',i9,' points. Maxima=',i8,/
     .         5x,'Box(Mpc)=',f6.1,
     .            5x,'Overdensity Limit=',f6.1,
     .             ' Cell for linker list(grids)=',f8.3)
      CALL SPairs(Box,N,Ncentr)  ! Accumulate  statistics 
          t3 =seconds()
          write (*,*) ' timeafter Spairs=',t3
      Amassl  = AmassOne*5.  ! Minimum halo mass in Msun/h 
C-----------------------------      Auxiliary Settings
      nfalse =0
      Do ir=1,Nrad                  ! all scaled to hubble, not h^(-1)
         Radsc(ir) =Rad(ir) *Xscale ! scale radii to comoving Mpc
         MnMass(ir)=Om0*4.188*2.746e+11*hubble**2*Radsc(ir)**3 
c                                   mass at the mean density
      EndDo
      write (*,12) (Radsc(i)*hsmall*1000.,i=1,Nrad)
      write (2,12) (Radsc(i)*hsmall*1000.,i=1,Nrad)
      write (20,12) (Radsc(i)*hsmall*1000.,i=1,Nrad)
 12   Format(5x,'Radii of shells in comoving kpc/h:',/20(4x,10f8.2/))
C---------------------------- Process Halos : Unbind, Dublicates 
      CALL CLEAN(Ncentr,Xscale,Vscale,Dscale, 
     +            Fract,Radsc,MnMass,Toohot,Rminhalo)
      IF(fVdubl .gt.0. .and. dRdubl.gt.0.)Then    !  Remove VelDublicates
          dRdubl =dRdubl/Xscale                       ! scale to cell units
         CALL RemVelDubl(Box,Ncentr,dRdubl,fVdubl,Xscale,Vscale) 
         write (*,25) Ncentr,dRdubl*Xscale*hsmall ,fVdubl
         write (2,25) Ncentr,dRdubl*Xscale*hsmall ,fVdubl
         write (20,25)Ncentr,dRdubl*Xscale*hsmall ,fVdubl
 25       Format(5x,'Number of centers=',i6,
     &                   2x,'Velocity Duplicates: dR(Mpc/h)<',f6.3,
     &                   2x,'dV/Vrms<',f6.3)
       ENDIF
C---------------------------------- Find largest halo
c       NpMax =0
c       inpMax =0
c      Do i=1,Ncentr        
c         write (*,*) ' halo=',i,NbcS(i,1),NbcS(i,2),NbcS(i,3)
c         If(NbcS(i,2).gt. NpMax)Then
c            inpMax =i
c            NpMax =NbcS(i,2)
c         EndIf
c      EndDo
c      If(inpMax.eq.0.or.NpMax.eq.0)Write (*,*) ' Errrror'
c      Do i=1,Ncentr         
cc         If(i.ne.inpMax) iRadius(i) =0
c         If(Vrm(i).lt. 100.) iRadius(i) =0
c      EndDo
c      iRadius(inpMax) =Nrad
C------------------------------- Print Results
      iCount = 0
      write ( 2,13)
      write (20,13)
 13   Format(6x,'Coordinates Mpc',9x,'Velocity km/s',7x,
     & 'Mass     Radius Vrms(3D) Vcirc Npart(<Rad) Rmax(kpc/h)Concent')
       write (20,14)
 14   Format('R(kpc/h)',5x,' N(<R)    M/Msun   Overdens   Vrms  Vcirc',
     &                  ' Dens(R)Msun/Mpc^3')
      Do i=1,Ncentr          ! Scale all to physical units
         Xc    =(Xm(i)-xshift)  *Xscale
         Yc    =(Ym(i)-yshift)  *Xscale
         Zc    =(Zm(i)-zshift)  *Xscale
         irad  =iRadius(i)
         Mhalo =Amc(i)
         Rhalo =Rmc(i)
         RmaxH =RmaxV(i)
         Vcirc =Vrm(i)
         iS      =NbcS(i,irad)   ! small-size particles
         iM      =NbcM(i,irad)   ! Medium-size particles
         iG      =NbcG(i,irad)   ! Giant  particles
         Nnp   =INT(Mhalo/(Dscale*Om0))
c         iPart =Nnp -8*iWeight(1)*iM -64*iWeight(1)*iG +iM +iG ! total part
c         iPart   =Max(iPart,0)
         Do ir =1,Nrad
            Summass     = Om0*Nbc(i,ir)/Fract
            Mass(ir)    = Dscale*Summass
            Overdens(ir)= Mass(ir)/MnMass(ir)
         EndDo
         im =Nbc(i,Nrad)
             Do ir =Nrad-1,1,-1
                if(Nbc(i,ir).ne.im)Then
                   iLast =ir
                   goto 220
                EndIf 
             EndDo
 220         iLast = min(Nrad,iLast+1)
       If(irad.eq.0.or.Rhalo.le.Rminhalo
     .      .or.Mhalo.le.Amassl)Then
              nfalse=nfalse+1
            irr =Max(irad,2)         ! don't take V from the first bin
            VXc =Wxc(i,irr)   *Vscale
            VYc =Wyc(i,irr)   *Vscale
            VZc =Wzc(i,irr)   *Vscale
            Nnp =INT(Mhalo/(Dscale*Om0))

             write (25,45) Xc*hsmall,Yc*hsmall,Zc*hsmall,
     &                      VXc,VYc,VZc,Mhalo*hsmall,
     &                      Rhalo*hsmall*1000.,Vrmc(i,irr),
     &                      Vcirc,Nnp,
     &                      RmaxH*hsmall*1000.

         EndIf
         If((irad.ne.0.and.Rhalo.gt.Rminhalo)
     .                .and.Mhalo.gt.Amassl
     .                )Then
            irr =Max(irad,2)         ! don't take V from the first bin
            VXc =Wxc(i,irr)   *Vscale
            VYc =Wyc(i,irr)   *Vscale
            VZc =Wzc(i,irr)   *Vscale
            Nnp =INT(Mhalo/(Dscale*Om0))

             write (20,45) Xc*hsmall,Yc*hsmall,Zc*hsmall,
     &                      VXc,VYc,VZc,Mhalo*hsmall,
     &                      Rhalo*hsmall*1000.,Vrmc(i,irr),
     &                      Vcirc,Nnp,
     &                      RmaxH*hsmall*1000.,Rhalo/RmaxH*2.15,iLast

             write ( 2,46) Xc*hsmall,Yc*hsmall,Zc*hsmall,
     &                      VXc,VYc,VZc,Mhalo*hsmall,
     &                      Rhalo*hsmall*1000.,Vrmc(i,irr),
     &                      Vcirc,Nnp,
     &                      RmaxH*hsmall*1000.,Rhalo/RmaxH*2.15

            Do ir=1,iLast
               If(ir.eq.1)Then
                  Vvc =Vrmc(i,ir)
                  Volume =4.188*Radsc(ir)**3
                  DenDm=Mass(ir)/Volume
                  If(Nbc(i,ir).le.2)Then ! too few particles
                      Radmean =Radsc(ir)/2.**0.3333
                  Else         ! take real mean radius
                      Radmean  =Rrc(i,ir)*Xscale/Nbc(i,ir)
                  EndIf
                  Vcr    =sqrt(Mass(1)/Radsc(1)/AEXPN)*6.58e-5
               Else              ! remove contribution from inner rad
                 Vvc =sqrt(MAX((Vrmc(i,ir)**2*Nbc(i,ir) -
     .              Vrmc(i,ir-1)**2*Nbc(i,ir-1))/
     .              max(Nbc(i,ir) -Nbc(i,ir-1),1),1.e-10))
c                  Vvc =(Vrmc(i,ir)*Nbc(i,ir) -  !radial velocity
c     .              Vrmc(i,ir-1)*Nbc(i,ir-1))/
c     .              max(Nbc(i,ir) -Nbc(i,ir-1),1)
                  Volume =4.188*(Radsc(ir)**3- Radsc(ir-1)**3) 
                  DenDm  =(Mass(ir)-Mass(ir-1)) /Volume
                  If(Nbc(i,ir) -Nbc(i,ir-1).le.2)Then ! too few particles
                     Radmean=((Radsc(ir)**3+Radsc(ir-1)**3)/2.)**0.333
                  Else         ! take real mean radius
                     Radmean=(Rrc(i,ir)-Rrc(i,ir-1))*Xscale/
     .                        (Nbc(i,ir)-Nbc(i,ir-1))
                  EndIf
                  Vcr    =sqrt(Mass(ir)/Radsc(ir)/AEXPN)*6.58e-5
                EndIf
               write (20,40) Radmean*hsmall*1000.,
     +                       Nbc(i,ir),Mass(ir)*hsmall,Overdens(ir),
     +                       Vvc,Vcr,DenDm/hsmall**2,NbcS(i,ir),
     +                       NbcM(i,ir),NbcG(i,ir)
            EndDo  ! end loop ir
45          Format(F8.3,2F8.3,3F8.1,g11.3,f8.2,2f7.1,I9,f8.1,f8.2,i3)
46          Format(F8.3,2F8.3,3F8.1,g11.3,f8.2,2F7.1,i9,f8.1,f8.2,i3)
47         Format(F8.3,2F8.3,g11.3,f8.2,i9,i8,i7,i5)
40          Format(g11.4,I9,g11.3,g10.3,2f7.1,g10.3,i8,i7,i5)
41          Format(f7.4,I7,I6,g11.3,g10.3,2f7.1,f6.3,g10.3,4G10.3)
         Endif
      EndDo    !  end loop Ncentr
      write (*,50) Ncentr-nfalse,nfalse
c      write (2,50) Ncentr,nfalse
 50   Format('---------- Final Catalog has ',i7,' halos ------------',
     .      /'                    ',i7,' were too puffy or too small') 
      Stop
      End
C--------------------------------------------------------------
C                        virial overdensity for cosmological model
C                        at different expansion parameter AEXPN
      Function OverdenVir()
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      

      xx =-(1.-Om0)*AEXPN**3/(Om0+(1.-Om0)*AEXPN**3)
      Ovlim =(178.+82.*xx-39.*xx**2)/(1.+xx)
      write (*,*)  'Overdensity Delta =',Ovlim
                              ! FOR DARK ENERGY
      ISUGRA = 0   ! 1- for RP
      If(ISUGRA.eq.1)Then
         Qlambda  = 3    ! log(lambda/Gev) for RP
         a = -2.119e-2*Qlambda-0.259
         b = -1.833e-2*Qlambda+0.975
         c = -6.975e-3*Qlambda+9.771e-2
         z = 1./AEXPN-1.
         Omz = 1.-(1.-Om0)*AEXPN**(a+b*abs(z)**c)
         write (*,*) ' a,b,c=',a,b,c
         write (*,*) ' power =',a+b*abs(z)**c
         a = -1.45e-2*Qlambda+0.186
         b =  -1.1e-2*Qlambda +0.22
         Ovlim =178.*Omz**(a+b*Omz-1)
         write (*,*) ' OverdensLimit=',Ovlim
         write (*,*) ' Omega_matter(z) =',Omz
         write (*,*) ' Omega_matter(0) =',Om0
      EndIf

      OverdenVir = Ovlim
c      Ovlim   =INPUT('Enter Overdensity Threshold for Halos     => ')

 
      RETURN
      END
C--------------------------------------------------------------
C                                           Make linker lists of particles in each cell
      SUBROUTINE List(Box,Ncp)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
             Do i=1,Ncp
                Lst(i)=-1
             EndDo
             Do k=Nm,Nb
             Do j=Nm,Nb
             Do i=Nm,Nb
                Label(i,j,k)=0
             EndDo
             EndDo
             EndDo  
      Do jp=1,Ncp
         i=INT(Xp(jp)/Cell)
         j=INT(Yp(jp)/Cell)
         k=INT(Zp(jp)/Cell)
         i=MIN(MAX(Nm,i),Nb)
         j=MIN(MAX(Nm,j),Nb)
         k=MIN(MAX(Nm,k),Nb)
         Lst(jp)      =Label(i,j,k)
         Label(i,j,k) =jp
      EndDo

      Return
      End
C--------------------------------------------------------------
C                                Find all neibhours for a center
C                                Xc,Yc,Zc - center; a0 -its weight
C
      SUBROUTINE Neib(Xnew,Ynew,Znew,Amnew,Xc,Yc,Zc,Radius)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
C                                       Initiate counters
        Xnew =0.
        Ynew =0.
        Znew =0.
  	     Amnew=0.
        Radius2=Radius**2
c                      limits for Label
         i1=INT((Xc-Radius)/Cell)
         j1=INT((Yc-Radius)/Cell)
         k1=INT((Zc-Radius)/Cell)
            i1=MIN(MAX(Nm,i1),Nb)
            j1=MIN(MAX(Nm,j1),Nb)
            k1=MIN(MAX(Nm,k1),Nb)
         i2=INT((Xc+Radius)/Cell)
         j2=INT((Yc+Radius)/Cell)
         k2=INT((Zc+Radius)/Cell)
            i2=MIN(MAX(Nm,i2),Nb)
            j2=MIN(MAX(Nm,j2),Nb)
            k2=MIN(MAX(Nm,k2),Nb)
C                                        Look for neibhours
            nn =0
         Do k=k1,k2
         Do j=j1,j2
         Do i=i1,i2
            jp =Label(i,j,k)
 10         If(jp.ne.0)Then
               dd =(Xc-Xp(jp))**2+(Yc-Yp(jp))**2+(Zc-Zp(jp))**2
               If(dd.lt.Radius2)Then
                  nn =nn +1
                  ww =iWeight(jp)
	             Xnew =Xnew +Xp(jp)*ww
	             Ynew =Ynew +Yp(jp)*ww
	             Znew =Znew +Zp(jp)*ww
	             Amnew=Amnew+ww
               EndIf  
                  jp =Lst(jp)
               GoTo10
            EndIf
         EndDo
         EndDo
         EndDo
         	If(Amnew.GT.0.)Then
	            Xnew =Xnew /Amnew
	            Ynew =Ynew /Amnew
	            Znew =Znew /Amnew
            EndIf
      Return
      End
C--------------------------------------------------------------
C                                Find all neibhours for a center
C                                Xc,Yc,Zc - center; 
C                               
      SUBROUTINE SNeib(Xc,Yc,Zc,Vx1,Vy1,Vz1,Nob1,NobS,NobM,
     &                     NobG,Rob1,Vxx )
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      DIMENSION  Vx1(Nrad),Vy1(Nrad),Vz1(Nrad),Vxx(Nrad),Nob1(Nrad),
     .             Rob1(Nrad),NobM(Nrad),NobG(Nrad),NobS(Nrad)

      iFlag = 0
         Radmax =Rad(Nrad)/FracSearch 
         d0      = Rad(1)
 50      dmax = Radmax**2
         Ninside = aNvir*Radmax**3
         iw1 = 1
         iw8 = 8
         iw64 = 64

         Do i=1,Nrad
              Nob1(i) =0
              NobS(i) =0
              NobM(i) =0
              NobG(i) =0
              Rob1(i) =0.
              Vx1(i)  =0.
              Vy1(i)  =0.
              Vz1(i)  =0.
              Vxx(i)  =0.
         EndDo
c                      limits for Label
         i1=INT((Xc-Radmax)/Cell)
         j1=INT((Yc-Radmax)/Cell)
         k1=INT((Zc-Radmax)/Cell)
            i1=MIN(MAX(Nm,i1),Nb)
            j1=MIN(MAX(Nm,j1),Nb)
            k1=MIN(MAX(Nm,k1),Nb)
         i2=INT((Xc+Radmax)/Cell)
         j2=INT((Yc+Radmax)/Cell)
         k2=INT((Zc+Radmax)/Cell)
            i2=MIN(MAX(Nm,i2),Nb)
            j2=MIN(MAX(Nm,j2),Nb)
            k2=MIN(MAX(Nm,k2),Nb)
            nps =0
C                                        Look for neibhours
         Do k=k1,k2
         Do j=j1,j2
         Do i=i1,i2
            jp =Label(i,j,k)   !  Dark matter
 10         If(jp.ne.0)Then
               dd =(Xc-Xp(jp))**2+(Yc-Yp(jp))**2+(Zc-Zp(jp))**2
              
               If(dd.lt.dmax)Then
                  d1 =sqrt(dd)
                    ir =INT(max(0.,4.*(sqrt(d1/d0)-1.) +1)) +1
                  ir =1
                    ir = min(max(1,ir),Nrad)
                    ww =iWeight(jp)
                    iww = INT(ww/iWeight(1)+0.05)
                    Nob1(ir)= Nob1(ir)+ iww
c                   If(iww.eq.iw1)NobS(ir)= NobS(ir)+ 1
c                    If(iww.eq.iw8)NobM(ir)= NobM(ir)+ 1
c                    If(iww.eq.iw64)NobG(ir)= NobG(ir)+ 1
c                    Rob1(ir)= Rob1(ir)+ d1*iww
c                    Vxx(ir) = Vxx(ir) +
c     +                            iww*(VXp(jp)**2+VYp(jp)**2+VZp(jp)**2)
                    Vx1(ir) = Vx1(ir) +iww*VXp(jp)  
                    Vy1(ir) = Vy1(ir) +iww*VYp(jp)
                    Vz1(ir) = Vz1(ir) +iww*VZp(jp)
               EndIf
               jp =Lst(jp)
               GoTo10
            EndIf
         EndDo
         EndDo
         EndDo
         Do ir =2,Nrad
            Nob1(ir)= Nob1(ir)   + Nob1(ir-1)
c            NobS(ir)= NobS(ir)  +  NobS(ir-1)
c            NobM(ir)= NobM(ir) +  NobM(ir-1)
c            NobG(ir)= NobG(ir)  + NobG(ir-1)
c            Rob1(ir)= Rob1(ir)    + Rob1(ir-1)
c            Vxx(ir) = Vxx(ir)      + Vxx(ir-1)
            Vx1(ir) = Vx1(ir)      + Vx1(ir-1)
            Vy1(ir) = Vy1(ir)      + Vy1(ir-1) 
            Vz1(ir) = Vz1(ir)      + Vz1(ir-1) 
         EndDo
               Nobj = Nob1(6)
               Vx14 = Vx1(6)/Nobj
               Vy14 = Vy1(6)/Nobj
               Vz14 = Vz1(6)/Nobj
               Vmn  = Vx14**2+Vy14**2+Vz14**2
 
         Do ir=1,Nrad
c             Vmn =0.
	         If(Nob1(ir).GT.0)Then
               Nobj    = Nob1(ir)
               Vx1(ir) = Vx1(ir)/Nobj
               Vy1(ir) = Vy1(ir)/Nobj
               Vz1(ir) = Vz1(ir)/Nobj
c              Vmn     = Vx1(ir)**2+Vy1(ir)**2+Vz1(ir)**2
c               Vxx(ir) = SQRT(ABS(Vxx(ir)/Nobj -Vmn))
	         EndIf
         EndDo
         If(Nob1(Nrad).gt.Ninside.and.iFlag.eq.0)Then
             Radmax =Rad(Nrad)
             Iflag = 1
             goto50
          EndIf 
      Return
      End
C--------------------------------------------------------------
C                                Find all neibhours for a center
C                                Xc,Yc,Zc - center; 
C                               
      SUBROUTINE SNeibOld(Xc,Yc,Zc,Vx1,Vy1,Vz1,Nob1,NobS,NobM,
     &                     NobG,Rob1,Vxx )
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      DIMENSION  Vx1(Nrad),Vy1(Nrad),Vz1(Nrad),Vxx(Nrad),Nob1(Nrad),
     .             Rob1(Nrad),NobM(Nrad),NobG(Nrad),NobS(Nrad)

         Radmax =Rad2(Nrad)
         iw1 = 1
         iw8 = 8
         iw64 = 64

         Do i=1,Nrad
              Nob1(i) =0
              NobS(i) =0
              NobM(i) =0
              NobG(i) =0
              Rob1(i) =0.
              Vx1(i)  =0.
              Vy1(i)  =0.
              Vz1(i)  =0.
              Vxx(i)  =0.
         EndDo
c                      limits for Label
         i1=INT((Xc-Radmax)/Cell)
         j1=INT((Yc-Radmax)/Cell)
         k1=INT((Zc-Radmax)/Cell)
            i1=MIN(MAX(Nm,i1),Nb)
            j1=MIN(MAX(Nm,j1),Nb)
            k1=MIN(MAX(Nm,k1),Nb)
         i2=INT((Xc+Radmax)/Cell)
         j2=INT((Yc+Radmax)/Cell)
         k2=INT((Zc+Radmax)/Cell)
            i2=MIN(MAX(Nm,i2),Nb)
            j2=MIN(MAX(Nm,j2),Nb)
            k2=MIN(MAX(Nm,k2),Nb)
            nps =0
C                                        Look for neibhours
         Do k=k1,k2
         Do j=j1,j2
         Do i=i1,i2
            jp =Label(i,j,k)   !  Dark matter
 10         If(jp.ne.0)Then
               dd =(Xc-Xp(jp))**2+(Yc-Yp(jp))**2+(Zc-Zp(jp))**2
c             write (*,'(" jp=",i9," d=",7g11.3)')
c     &            jp,dd,Rad2(Nrad),Xc,Yc,Zc
                Do ir =1,Nrad
                  If(dd.lt.Rad2(ir))Then
                     ww =iWeight(jp)
                     iww = INT(ww/iWeight(1)+0.05)
                    Nob1(ir)= Nob1(ir)+ iww
                    If(iww.eq.iw1)NobS(ir)= NobS(ir)+ 1
                    If(iww.eq.iw8)NobM(ir)= NobM(ir)+ 1
                    If(iww.eq.iw64)NobG(ir)= NobG(ir)+ 1
                    Rob1(ir)= Rob1(ir)+ sqrt(dd)*iww
                   Vxx(ir) = Vxx(ir) +
     +                            iww*(VXp(jp)**2+VYp(jp)**2+VZp(jp)**2)
                    Vx1(ir) = Vx1(ir) +iww*VXp(jp)  
                    Vy1(ir) = Vy1(ir) +iww*VYp(jp)
                    Vz1(ir) = Vz1(ir) +iww*VZp(jp)
c            write (*,'("  old ",i9,2i7," ww=",5g11.3)')
c     &            jp,ir,Nob1(ir),sqrt(dd),Rad(ir)
                 EndIf
               EndDo
               jp =Lst(jp)
               GoTo10
            EndIf
         EndDo
         EndDo
         EndDo
c         write(*,*) '------------ Old Nob1',Xc,Yc,Zc
c         write (*,'(10i11)')Nob1
c         write(*,*) ' Old Rob1'
c         write (*,'(1P,10G11.3)')Rob1
c         write(*,*) ' Old Vxx'
c         write (*,'(1P,10G11.3)')Vxx
 
                Nobj =Nob1(6)
               Vx14 = Vx1(6)/Nobj
               Vy14 = Vy1(6)/Nobj
               Vz14 = Vz1(6)/Nobj
              Vmn     = Vx14**2+Vy14**2+Vz14**2
 
         Do ir=1,Nrad
c             Vmn =0.
	         If(Nob1(ir).GT.0)Then
               Nobj    = Nob1(ir)
               Vx1(ir) = Vx1(ir)/Nobj
               Vy1(ir) = Vy1(ir)/Nobj
               Vz1(ir) = Vz1(ir)/Nobj
c              Vmn     = Vx1(ir)**2+Vy1(ir)**2+Vz1(ir)**2
               Vxx(ir) = SQRT(ABS(Vxx(ir)/Nobj -Vmn))
	         EndIf
         EndDo


      Return
      End
C--------------------------------------------------------------
C                       Add points around the Box to take into account periodical conditions
C  It replicates points periodically and keeps those which are at  distance
C  less than Radius from the Box. 
C                        N     = number of points inside the Box
C                        Ncp = total number of points
      SUBROUTINE Points(Box,N,Ncp,Radius)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      Logical    Inside
         B1  =-Radius
         B2  =Box+Radius
         B3  =Box-Radius
         Ncp =N
      Do i=1,N               ! Add dark matter particles
         x0 =xp(i)
         y0 =yp(i)
         z0 =zp(i)
         Inside =            (x0.gt.Radius).and.(x0.lt.B3)
         Inside =Inside.and.((y0.gt.Radius).and.(y0.lt.B3))
         Inside =Inside.and.((z0.gt.Radius).and.(z0.lt.B3))
         If(.not.Inside)THEN         
         ux =VXp(i)
         uy =VYp(i)
         uz =VZp(i)
         ww=iWeight(i)
            Do k1 = -1,1
               zr =z0+k1*Box
               If(zr.GT.B1.AND.zr.LT.B2)Then
               kk =k1**2
               Do j1 = -1,1
                  yr =y0+j1*Box
                  If(yr.GT.B1.AND.yr.LT.B2)Then
                     jj = kk +j1**2
                     Do i1 = -1,1
                        xr =x0+i1*Box
                        ii =jj +i1**2
                        If((xr.GT.B1.AND.xr.LT.B2).AND.ii.ne.0)
     .                     Then
                             Ncp =Ncp +1
                             If(Ncp.le.Np)Then
                               xp(Ncp)  =xr
                               yp(Ncp)  =yr
                               zp(Ncp)  =zr
                               VXp(Ncp)  =ux
                               VYp(Ncp)  =uy
                               VZp(Ncp)  =uz
                               iWeight(Ncp) =ww
                             EndIf
                        EndIf
                     EndDo
                  EndIf
               EndDo
               EndIf
            EndDo
         EndIf
      EndDo
      If(Ncp.Gt.Np)Then
         write(*,*)' Too many points:',Ncp,' Maximum is =', Np
         STOP
      EndIf
      Return
      End
C-------------------------------------------------------------
C                     Find positions of 'Ncentr' spheres, which maximize number of particles
C                    inside 'radius Radius'. 
C                    Iterations are repeated until 1) mass stops increasing   OR
C                                                       2) the sphere stops moving: dR is less than Riter 
C                    Looks for all particles inside Radius for periodical set 
      SUBROUTINE Pairs(Box,N,Ncentr,Riter)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      INTEGER Lab(Nc)
      write (*,*)  ' Pairs: start',N,Ncentr
      Do i=1,Ncentr
      	Lab(i) =1
         Amc(i) =0
         If(Rmc(i).lt.1.e-8)write (*,*) ' Error in Rmc: zero',Rmc(i),i
         If(Rmc(i).le.0.5*RadSr2)
     &               write (*,*) ' Error in Rmc: too small ',Rmc(i),i
         If(Rmc(i).gt.RadSr1)write (*,*) ' Error in Rmc: big ',Rmc(i),i
c         Rmc(i) =Radius
      EndDo
      Niter =0
10    Iter  =0
      Niter =Niter +1
      Iter1 =0
      Do i=1,Ncentr
         If(Lab(i).gt.0.and.Rmc(i).ge.0.999*RadSR2)Iter1 =Iter1 +1
      EndDo
C.... Open_MP
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP+PRIVATE (i,Xc,Yc,Zc,a0,in,Radius)
C$OMP+PRIVATE (Xnew,Ynew,Znew,Amnew,Dr)
C$OMP+SCHEDULE(DYNAMIC,10000)
      Do i=1,Ncentr
         Xc =Xm(i)
         Yc =Ym(i)
         Zc =Zm(i)
         a0 =Amc(i)
         in =Lab(i)
         Radius =Rmc(i)
         If(Radius.lt.0.999*RadSR2)in =-Niter
         If(in.gt.0)Then         ! If not converged, keep iterating
            Call Neib(Xnew,Ynew,Znew,Amnew,Xc,Yc,Zc,Radius) ! new center of mass
            Dr =MAX(ABS(Xnew-Xc),ABS(Ynew-Yc),ABS(Znew-Zc))
            IF(Dr.LT.Riter.or.Amnew.lt.Amc(i))
     .                  Lab(i)=-Niter     ! iterations converged
c            Iter =Iter +1
	         IF(Xnew.lt.0.)Xnew =Xnew+Box
	         IF(Ynew.lt.0.)Ynew =Ynew+Box
	         IF(Znew.lt.0.)Znew =Znew+Box
	         IF(Xnew.gt.Box)Xnew =Xnew-Box
	         IF(Ynew.gt.Box)Ynew =Ynew-Box
	         IF(Znew.gt.Box)Znew =Znew-Box
            Xm(i)  = Xnew
            Ym(i)  = Ynew
            Zm(i)  = Znew
            Amc(i) = Amnew
c            write (*,'(i6,6g12.5)') i, Xm(i),Ym(i),Zm(i),Amc(i) 
         EndIf
      EndDo

      Write (*,*) ' Iteration=',Niter,' Centers left=',Iter,Iter1
      If(Iter1.GE.1 .and. Niter.LT.100)Goto10

      Return
      End
C-------------------------------- Remove dublicates in Velocity
C                   If distance is less than 'dRdubl' and 
C                   if difference in velocitiy is less than a fraction
C                   'fVdubl' of the velocity dispersion -->
C                   dublicates: keep only one (largest) halo
C
C  Condition of proximity in velocity depends on how close are halos
C  in space. Halos with velocity difference dv =sqrt(vx_1-vx_2)^2 +(y)+ (z)),
C  at distance d one from the other, with mass ratio 1/1.5 < M1/M2 < 1.5
C   and with internal velocity dispersions Vrms_1 and Vrms_2
C   are considered too close ('dublicates')
C  if     dv < fVdubl*max(Vrms_1,Vrms_2)*sqrt(6-5(d/dRdubl)^2)

      SUBROUTINE RemVelDubl(Box,Ncentr,dRdubl,fVdubl,Xscale,Vscale)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      Logical    Lab(Nc)
      Real      Mhalo,Mhalo2

      dR2 = dRdubl**2
      fV2 = fVdubl**2
      Vol_2 =Rad(2)**3-Rad(1)**3
      nrem= 0
      Do i=1,Ncentr
         Lab(i) =.true.
      EndDo
      If(iDebug.eq.1)write (*,50)
 50   format(5X,'<========  Remove fake halos ========>',
     &     /17x,'difference in velocities dV is small as compared with',
     &     /17x,'internal rms velocity Vrms',
     &          ' and halos are close in space',/
     &     4x,'dR(Mpc)',' dV(km/s)',' Vrms(km/s)',
     &        ' N_part_halo_1',' N_part_halo_2',
     &        ' dVx(km/s) dVy(km/s) dVz(km/s)') 
      Do i=1,Ncentr-1
        Mhalo  =Amc(i)
        irad   =Max(iRadius(i),2)
        Rh_1 =Rad(irad)
        Vrh2   =(Vrmc(i,irad)/Vscale)**2
        If(Mhalo.eq.0. .or. irad.eq.0)Lab(i) =.false.
       If(Lab(i))Then
       Do j=i+1,Ncentr
          dd =(Xm(j)-Xm(i))**2 +
     .        (Ym(j)-Ym(i))**2 +      
     .        (Zm(j)-Zm(i))**2     
          Mhalo2 =Amc(j)
          If(dd.lt.dR2.and.Mhalo2.gt.Mhalo/1.5)Then    ! close distance pair
          If(Mhalo2.lt.Mhalo*1.5)Then                         ! close mass range
             jrad=Max(iRadius(j),2)
             Rh_2 =Rad(jrad)
             Rhh =MAX(Rh_1,Rh_2,1.e-8)
             dv =(Wxc(j,jrad)-Wxc(i,irad))**2 +
     .           (Wyc(j,jrad)-Wyc(i,irad))**2 +      
     .           (Wzc(j,jrad)-Wzc(i,irad))**2
             VV =MAX(Vrh2,(Vrmc(j,jrad)/Vscale)**2) ! max Vrms of the two
c             If(dv.lt.(6.-5.*dd/dR2)*fV2*VV)Then   ! close in velocity
             If(dv.lt.(2.-dd/(dRdubl*Rhh))*fV2*VV)Then ! close in velocity
                
                If(Nbc(i,2).gt.Nbc(j,2))Then ! find if density at the distance
                   idens =i                       ! between halos does not change more than 
                   idens_0 =j
                 Else                              ! five times -- then this is dublicates
                   idens_0 =i
                    idens =j
                 Endif 
                 dist =sqrt(dd)
                 Do irr =1,Nrad
                    If(dist.lt.rad(irr))Then
                       idist =irr
                       goto 300
                    Endif 
                 Enddo
 300          irr=max(irr,2)
                 rho_cent =(Nbc(idens_0,2)-Nbc(idens_0,1))/Vol_2
                 rho_dist  =(Nbc(idens,irr)-Nbc(idens,irr-1))/
     +                           (Rad(irr)**3-Rad(irr-1)**3)
                 If(iDebug.eq.1)write (*,31) sqrt(dd)*Xscale,
     +                          sqrt(dv)*Vscale,sqrt(VV)*Vscale,
     .                 Nbc(i,irad),Nbc(j,jrad),
     .               (Wxc(j,jrad)-Wxc(i,irad))*Vscale,
     +              (Wyc(j,jrad)-Wyc(i,irad))*Vscale,
     +              (Wzc(j,jrad)-Wzc(i,irad))*Vscale,
     +              rho_cent,rho_dist,irr,Nbc(idens_0,2),
     +              Nbc(idens,2),idens_0,idens
                IF(rho_dist.gt.rho_cent/1000.)Then ! dublicates   
                nrem = nrem +1
 31           format(f10.4,f9.3,f11.2,2i14,3f10.3,2g11.3,i4,2i5,2i3)               
 30             format(f10.4,f9.3,f11.2,2i14,3f10.3,2g11.3,i4)                
c                If(Mhalo.gt.Mhalo2)Then ! choose the biggest
                If(Nbc(i,2).gt.Nbc(j,2))Then ! choose the densiest
                   Lab(j)=.false.               
c                   write (*,30) sqrt(dd)*Xscale,sqrt(dv)*Vscale,
c     +                            sqrt(VV)*Vscale,
c     .                 Nbc(i,irad),Nbc(j,jrad),
c     .               (Wxc(j,jrad)-Wxc(i,irad))*Vscale,
c     +              (Wyc(j,jrad)-Wyc(i,irad))*Vscale,
c     +              (Wzc(j,jrad)-Wzc(i,irad))*Vscale,
c     +              rho_cent,rho_dist,irr
c        +              Xm(j)*Xscale,Ym(j)*Xscale,Zm(j)*Xscale
                Else
                   Lab(i)=.false.
c                   write (*,30) sqrt(dd)*Xscale,sqrt(dv)*Vscale,
c     +                            sqrt(VV)*Vscale,
c     .                 Nbc(i,irad),Nbc(j,jrad),
c     .               (Wxc(j,jrad)-Wxc(i,irad))*Vscale,
c     +              (Wyc(j,jrad)-Wyc(i,irad))*Vscale,
c     +              (Wzc(j,jrad)-Wzc(i,irad))*Vscale, 
c     +              rho_cent,rho_dist,irr
c        +              Xm(i)*Xscale,Ym(i)*Xscale,Zm(i)*Xscale
                EndIf
             EndIf
             EndIf
          EndIf
          EndIf
        EndDo
      EndIf
      EndDo
      m  =0
      meanmass =0
      Do i=1,Ncentr
         If(Lab(i))Then
            m = m +1
            Xm(m)      =Xm(i)
            Ym(m)      =Ym(i)
            Zm(m)      =Zm(i)
            Amc(m)     =Amc(i)   
            Rmc(m)     =Rmc(i)  
            RmaxV(m)   =RmaxV(i)
            Vrm(m)     =Vrm(i) 
            iRadius(m) =iRadius(i)
            Do ir=1,Nrad  !  Store Results 
               Wxc(m,ir)  =Wxc(i,ir) 
               Wyc(m,ir)  =Wyc(i,ir) 
               Wzc(m,ir)  =Wzc(i,ir) 
               Nbc(m,ir)  =Nbc(i,ir) 
               NbcS(m,ir)  =NbcS(i,ir) 
               NbcM(m,ir)  =NbcM(i,ir) 
               NbcG(m,ir)  =NbcG(i,ir) 
               Rrc(m,ir)  =Rrc(i,ir)
               Vrmc(m,ir) =Vrmc(i,ir)
            EndDo
            meanmass =meanmass +Nbc(m,Nrad)
         EndIf
      EndDo
      xmeanmass = FLOAT(meanmass)/FLOAT(m)      
      write(*,10) m,Ncentr,xmeanmass
      write(20,10) m,Ncentr,xmeanmass
      write(*,20) dRdubl*Xscale*hubble,fVdubl
 10   format(5x,'Vel.Dublicates: New number of objects=',i6,' Old=',i6,
     .       ' mean N_particles=',g11.3)
 20   format('     Distance Difference=',f8.4,/
     .       '     Vrelative/Vrms <    ',f8.4)
      Ncentr =m
      Return
      End

C-------------------------------- Update Statistics of pairs 
C                   
      SUBROUTINE SPairs(Box,N,Ncentr)
C---------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      DIMENSION  Vx1(Nrad),Vy1(Nrad),Vz1(Nrad),Vxx(Nrad),Nob1(Nrad),
     .             Rob1(Nrad),NobM(Nrad),NobG(Nrad),NobS(Nrad)

         Do i=1,Ncentr
               Do ir=1,Nrad
                  Wxc(i,ir) = 0.
                  Wyc(i,ir) = 0.
                  Wzc(i,ir) = 0.
                  Nbc(i,ir) = 0
                  NbcS(i,ir) = 0
                  NbcM(i,ir) = 0
                  NbcG(i,ir) = 0
                  Rrc(i,ir) = 0.
                  Vrmc(i,ir)= 0.
               EndDo
         EndDo

C.... Open_MP
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP+PRIVATE (i,ir,Xc,Yc,Zc,Vx1,Vy1,Vz1,Nob1,NobS,NobM)
C$OMP+PRIVATE (NobG,Rob1,Vxx )
C$OMP+SCHEDULE (DYNAMIC,2000)
       Do i=1,Ncentr
          if(mod(i,10000).eq.0)write (*,*)  ' Sneib halo=',i
         Xc =Xm(i)
         Yc =Ym(i)
         Zc =Zm(i)
         Call SNeib(Xc,Yc,Zc,Vx1,Vy1,Vz1,Nob1,NobS,NobM,
     &                     NobG,Rob1,Vxx )
           Do ir=1,Nrad  !  Store Results 
               Wxc(i,ir) =Vx1(ir)
               Wyc(i,ir) =Vy1(ir)
               Wzc(i,ir) =Vz1(ir)
               Nbc(i,ir) =Nob1(ir)
               NbcS(i,ir) =NobS(ir)
               NbcM(i,ir) =NobM(ir)
               NbcG(i,ir) =NobG(ir)
               Rrc(i,ir) =Rob1(ir)
               Vrmc(i,ir)=Vxx(ir)
            EndDo
      EndDo
      Return
      End

C-------------------------------- Remove small halos
C           
C           
      SUBROUTINE SmallRem(ANlimit,Ncentr)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'

      New =0
      Do i=1,Ncentr
         If(Amc(i).GT.ANlimit*Rmc(i)**3)Then
          New =New +1
          Xm(New) =Xm(i)
          Ym(New) =Ym(i)
          Zm(New) =Zm(i)
          Amc(New)=Amc(i)
          Rmc(New)=Rmc(i)
         EndIf
      EndDo
      Ncentr =New
      write (*,*) ' small centers removed. New Ncentr=',Ncentr
      Return
      End
C-------------------------------- Get Catalog of Halos
C                        Remove close centers, keep only the largest
C                        Emass - small difference in mass
      SUBROUTINE CATALOG(Box,Ncentr)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      Dimension    Lab(Ncc)

      New =0
      If(Ncentr.gt.Ncc)Then
         write (*,*)  ' Error: too small Ncc in CATALOG:',Ncc,Ncentr
         stop
      EndIf
      Do i=1,Ncentr
        Lab(i) =1
      EndDo
C.... Open_MP
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP+PRIVATE (i,j,Xc,Yc,Zc,a0,Rh,dd)
C$OMP+SCHEDULE (DYNAMIC,5000)
      Do i=1,Ncentr
         If(Rmc(i).lt.1.e-8)Lab(i)=0
            Xc =Xm(i)
            Yc =Ym(i)
            Zc =Zm(i)
            a0 =Amc(i)
            Rh =Rmc(i)
            Do j=1,Ncentr
               If(i.ne.j)Then
                dd =((Xc-Xm(j))**2+(Yc-Ym(j))**2+(Zc-Zm(j))**2)
                IF(dd.lt.( (Rh+Rmc(j))/2. )**2 )Then
                      If(a0.GT.Amc(j))Then! take largest of maxima
                         Lab(j)=0
                      Else
                         If(a0.lt.Amc(j))Then
                            Lab(i)=0
                         Else   ! equal masses -> take max(i,j)
                            Lab(min(i,j)) =0
                         EndIf
                      EndIf
                 EndIf
              EndIf
            EndDo            
      EndDo
      write (*,*)  '    CATALOG: done Lab clean',Ncentr 
c      icount =0
c      Do i=1,Ncentr
c         icount =icount +Lab(i)
c      Enddo
c      write (*,*) ' Count=',icount
c      write (*,'(40i2)') (Lab(i),i=1,Ncentr)
c      STOP
C                                 Remove maxima with Label =0
      Do i=1,Ncentr
        If(Lab(i).eq.1)Then
          New =New +1
          Xm(New) =Xm(i)
          Ym(New) =Ym(i)
          Zm(New) =Zm(i)
          Amc(New)=Amc(i)
          Rmc(New)=Rmc(i)
          Vrm(New)=Vrm(i)
          Wxc(New,1)=Wxc(i,1)
          Wyc(New,1)=Wyc(i,1)
          Wzc(New,1)=Wzc(i,1)
        EndIf
      EndDo
      Ncentr =New
      write (*,*) ' dublicates removed. New Ncentr=',Ncentr
      Return
      End
C---------------------------------------------------------
C                                         Select particles
c                                         as initial seeds of centers
      SUBROUTINE ReadCent(N,Ncentr,Boxx)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      Real INPUT,Iweigh_first,Iweigh_last,Iweigh_min
      Logical      Ldiff
c      Xccc =INPUT(' Center x=')
c         write (*,*) Xccc
c      Yccc =INPUT(' Center y=')
c         write (*,*) Yccc
c      Zccc =INPUT(' Center z=')
c         write (*,*) Zccc
c      Rccc =INPUT(' Center r=')
c         write (*,*) Rccc
c      Xccc =Xccc/Boxx*NGRID
c      Yccc =Yccc/Boxx*NGRID
c      Zccc =Zccc/Boxx*NGRID
c      Rccc =Rccc/Boxx*NGRID
      Ncentr =0
      Iweigh_first =iWeight(1)
      Iweigh_last  =iWeight(N)
      Iweigh_min  = Iweigh_first
      If(iDebug.eq.1)
     & write (*,*) ' Weights: first species=',Iweigh_first,
     &  ' last=',Iweigh_last,' Weight minimum center=',Iweigh_min
        n1        = 0  
        nhalf    = 0
        n2        = 0
      If(RadSr1.lt.1.1*RadSr2.or.ABS(RadSr2).lt.1.e-8)Then
                                   ! there is only one radius
         Ldiff =.false.
         Radius = RadSr1
         R1        = RadSr1
         R2        = RadSr1
         Rhalf    = RadSr1
      Else
        Ldiff =.true.
        R1       = 1.1*RadSr2
        R2       = 0.9*RadSr1
        Rhalf   =(RadSr1+RadSr2)/2.
        ialpha =3
        RRs  = (RadSr1-RadSr2)
        If(iDebug.eq.1)Then
	  write(*,*) ' Min Radius=',RadSr2,' Max=',RadSr1
	  write(*,*) ' Power index =',ialpha
        EndIf
      Endif 
      If(iHelp.eq.1)Write(*,130)
 130     format(/
     +10x,'These parameters define how and how many spheres are ',/
     +10x,'used to search for density maxima. Tests can be done ',/
     +10x,'with few spheres (answers: 100 0). For final search ',/
     +10x,'a large fraction of particles should be used. ',/
     +10x,'Combinations (np/10 10) or (np/3 5) are recommended',/
     +10x,'Only particles of the smallest mass are used for ',/
     +10x,'initial centers of shperes')

      Nline=INPUT(' Enter Number of particles for initial seeds=> ')
      jneib=INPUT(' Enter Number of neibhours for a seed       => ')

      If(Nline.eq.0)Return
         fr    = N/FLOAT(Nline)
         xrand =1.00001
         Nstep =MAX(INT(fr+1.),1)
         fr    =1./fr
         Nseed = 121071
         write (*,*) ' Every ',Nstep,' particle is used',
     &                ' as initial center',' Fraction=',fr
         Nplast =0
         Do i=1,N        ! take centers if weight is less than Iweigh_min
           If( iWeight(i).le.Iweigh_min)Then
              Nplast =Nplast +1
           Endif 
         Enddo 
         write (*,*) ' Total pool for particles centers=',Nplast
C         Do i=1,N,Nstep
          Do i=1,Nplast
             If(fr.lt.0.999)xrand =RANDd(Nseed) 
               IF(xrand.lt.fr)Then 
c                 IF(ABS(Xp(i)-Xccc).lt.Rccc.and. 
c     .                ABS(Yp(i)-Yccc).lt.Rccc.and.
c     .                ABS(Zp(i)-Zccc).lt.Rccc)THEN
                  Ncentr           =Ncentr+1
                  IF(Ldiff)Then           ! different radii
                        Rrrr   =RadSr2+
     &                            RRs*(MAX(RANDd(Nseed),1.e-8))**ialpha
                        Rmc(Ncentr) = Rrrr

                        If(Rrrr.lt.R1)n1 = n1+1
                        If(Rrrr.lt.R2.and.Rrrr.ge.R1)nhalf = nhalf+1
                        If(Rrrr.gt.R2)n2 = n2+1
                  Else
                        Rmc(Ncentr) =Radius
                  Endif 
                  Amc(Ncentr) =1.
                  Xm(Ncentr)   =Xp(i)
                  Ym(Ncentr)   =Yp(i)
                  Zm(Ncentr)   =Zp(i)
                  j=Ncentr
c                 EndIf      ! endif for small box test
               EndIf
         EndDo
         write (*,*) ' Ncenters (random fraction)=',Ncentr
      If(jneib.eq.0)goto 150               ! No more points

      Imax =MIN(INT(NGRID/Cell),Nb)
      write (*,*) ' Size of Grid centers=',Imax,Cell,NGRID
      Do k=0,Imax
      Do j=0,Imax
      Do i=0,Imax
         jp =Label(i,j,k)
         Ncount  =0
         jcount    =0
 10       jcount= jcount+1
              If(jp.ne.0.and.jcount.lt.jneib)Then
                     jp=Lst(jp) ! find if there are enough neib
                     goto 10
                 endif 
               jcount    =0
          If(jp.ne.0.and.iWeight(jp).le.Iweigh_min)Then 
              Ncount =Ncount +1
c                  IF(ABS(Xp(jp)-Xccc).lt.Rccc.and. 
c     .                 ABS(Yp(jp)-Yccc).lt.Rccc.and.
c     .                 ABS(Zp(jp)-Zccc).lt.Rccc)THEN
                Ncentr=Ncentr+1
                If(Ncentr.le.Nc)Then
                  IF(Ldiff)Then           ! different radii
                        Rrrr   =RadSr2+
     &                            RRs*(MAX(RANDd(Nseed),1.e-8))**ialpha
                        Rmc(Ncentr) = Rrrr

                        If(Rrrr.lt.R1)n1 = n1+1
                        If(Rrrr.lt.R2.and.Rrrr.ge.R1)nhalf = nhalf+1
                        If(Rrrr.gt.R2)n2 = n2+1
                  Else
                        Rmc(Ncentr) =Radius
                  Endif 
                        Amc(Ncentr) =1.
                        Xm(Ncentr)  =Xp(jp)
                        Ym(Ncentr)  =Yp(jp)
                        Zm(Ncentr)  =Zp(jp)
                EndIf
c                  EndIf           ! endif for small-box test
c                  write (*,*) ' Count=',Ncount,i,j,k,Ncentr
                 If(Ncount.lt.3) Goto 10
          EndIf
      EndDo
      EndDo
      EndDo
150   write(*,*) ' Ncentr (total)=',Ncentr,' Max=',Nc
      If(Ncentr.gt.Nc)Then
         write (*,*) ' Too many centers'
         STOP ' Too many centers'
      Endif 
         If(Ncentr.gt.0)Then
            write (*,200) RadSR2,R1,n1,R1,R2,nhalf,R2,RadSR1,n2
            write (2,200) RadSR2,R1,n1,R1,R2,nhalf,R2,RadSR1,n2
            write (20,200) RadSR2,R1,n1,R1,R2,nhalf,R2,RadSR1,n2

 200   format(' Number of centers with radii between ',3x,2f7.4,
     &                ' was ',i8,
     &              /18x,' with radii between ',3x,2f7.4,' was ',i8,
     &              /18x,' with radii between ',3x,2f7.4,' was ',i8)
          Endif 
      Return
      End
C---------------------------------------------------------
C                                        Read list of maxima
c                                     Xnew =X-1: coord. now are 0-NGRID       
      SUBROUTINE ReadMax(N,Xscale)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'

         read(3) 
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,
     +                  NROWC,NGRIDC,NREC0,Om0,Oml0,hubble,
     +                  Ocurv
         write(*,200)
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,
     +                  NROWC,NGRIDC,NREC0,Om0,Oml0,hubble,
     +                  Ocurv
200   FORMAT(
     +           1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I9,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3)
       N =0
      xxm =1000.
      xxn =-1000.
 10   read (3,err=5,end=5) X0, Y0, Z0, VvX,VvY,VvZ
            N=N+1
            If(N.le.Np)Then
            Xp(N)  =X0-1.
            Yp(N)  =Y0-1.
            Zp(N)  =Z0-1.
            VXp(N)=VvX
            VYp(N)=VvY
            VZp(N)=VvZ
            xxm    =min(xxm,Xp(N))
            xxn     =max(xxn,Xp(N))
            EndIf
            GoTo 10
 5    write(*,*) ' Read Particles: X{Min,Max}=',xxm,xxn,' N=',N
      If(N.GT.Np)Then
         write (*,*) ' Too many particles: Max=',Np
         Stop
      EndIf
      Return
      End
C---------------------------------------------------------
C                                        Read particles
      SUBROUTINE ReadPnt(N,Fract,xshift,yshift,zshift)    
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'

      N =0
      Iz=1
      Iy=1
      Ff=1.
c      xshift = 100.
c      yshift = 100.
c      zshift = 0.
      xshift = 0.
      yshift = 0.
      zshift = 0.

      xmin =1.e10
      xmax =-1.e10
      ymin =1.e10
      ymax =-1.e10
      zmin =1.e10
      zmax =-1.e10
      Nsmall =0
      Lsmall =lspecies(1)
      If(Fract.le.0.666)Then
         Iz=2
         Ff=0.5
         If(Fract.le.0.333)Then
            Iy=2
            Ff=0.25
         Endif
      EndIf
      Fract =Ff
      If(Nspecies.eq.0)Then ! old case: 1 complete set
         Npages =NROW          ! Number of pages
         N_in_last=NPAGE       ! Number of particles in last page
      Else                             ! multiple masses
         N_particles =lspecies(Nspecies)   ! Total number of particles
         Npages = (N_particles -1)/NPAGE +1
         N_in_last=N_particles -NPAGE*(Npages-1)
      EndIf
c      write (*,*) ' Pages=',Npages,' Species=',Nspecies
c      write (*,*) ' N_in_last=',N_in_last

      DO  IROW=1, Npages,Iz         ! Loop over particle pages
c      DO  IROW=32,66      
            In_page =NPAGE
            If(IROW.eq.Npages)In_page =N_in_last
            iL = NPAGE*(IROW-1)
C				       Loop over particles
         READ  (21,REC=IROW) RECDAT
	   DO   IN=1,In_page,Iy
            N   = N +1
            Xp(N)  =XPAR(IN)-1.+xshift
            Yp(N)  =YPAR(IN)-1.+yshift
            Zp(N)  =ZPAR(IN)-1.+zshift
            If(Xp(N).gt.NGRID)Xp(N)  =Xp(N)-NGRID
            If(Yp(N).gt.NGRID)Yp(N)  =Yp(N)-NGRID
            If(Zp(N).gt.NGRID)Zp(N)  =Zp(N)-NGRID
            If(N.le.Lsmall)Then
               Nsmall =Nsmall + 1
               xmin =min(Xp(N),xmin)
               xmax =max(Xp(N),xmax)
               ymin =min(Yp(N),ymin)
               ymax =max(Yp(N),ymax)
               zmin =min(Zp(N),zmin)
               zmax =max(Zp(N),zmax)
            EndIf
            VXp(N)=VX(IN)
            VYp(N)=VY(IN)
            VZp(N)=VZ(IN)
                Ipart =min(IN+iL,Nmaxpart)                     ! current particle number
             iWeight(N) =iWeight(Ipart)   ! particles weight            
         ENDDO
      ENDDO 

      write(*,*) ' Small Particles:',Nsmall
      write(*,*) '               x:',xmin,xmax
      write(*,*) '               y:',ymin,ymax
      write(*,*) '               z:',zmin,zmax

      Return
      End

C---------------------------------------------------
C                                Remove Unbound particles, find radius and mass
C                                No removal of unbound particles If:
C                                       Toohot =< 0 or Toohot =>5
C                             Vscale =100.*hsmall*Xscale/AEXPN 
C                              Xscale=Box/Ngrid 
C                              Dscale=2.75e+11*hsmall**2*(Box/NROW)**3 
      SUBROUTINE CLEAN(Ncentr,Xscale,Vscale,Dscale,
     +     Fract,Radsc,MnMass,Toohot,Rminhalo)  
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      dimension Mass(Nrad),MnMass(Nrad),Overdens(Nrad),Radsc(Nrad)
      Real          Mass,MnMass,Mhalo

C.... Open_MP
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP+PRIVATE (i,ir,iter,Xc,Yc,Zc,Summass,Mass,Overdens)
C$OMP+PRIVATE (irad,Mhalo,Rhalo,Vmaxrot,Rmaxrot,Vcirc,Vcc)
C$OMP+PRIVATE (NobG,Rob1,Vxx )
C$OMP+SCHEDULE (DYNAMIC,2000)
      Do i=1,Ncentr          
         if(mod(i,10000).eq.0)write(*,*)' Clean halo=',i,Ncentr
         Xc =Xm(i)  *Xscale !          Scale all to physical units: comoving
         Yc =Ym(i)  *Xscale
         Zc =Zm(i)  *Xscale
         iflag =0
         ifirst=0
         Do ir =1,Nrad
            Vrmc(i,ir)=Vrmc(i,ir) *Vscale   !  Scale to km/s
            Summass     = Om0*Nbc(i,ir)/Fract
            If(Nbc(i,ir).gt.5.and.iflag.eq.0)Then
               ifirst = ir            ! find first significant bin
               iflag  = 1
            EndIf 
            Mass(ir)    = Dscale*Summass
            Overdens(ir)= Mass(ir)/MnMass(ir)
         EndDo  
C                                     find size, mass, rad ... for a halo
         Call Decide(Mass,Radsc,Overdens,Nrad,irad,Mhalo,Rhalo,
     +                                       Vmaxrot,Rmaxrot,ifirst )
         Vcirc=sqrt(Vmaxrot/AEXPN)*6.58e-5 ! =10^-5*sqrt(G 2e33/3.08e24) 

         If(Toohot.gt.0. .and. Toohot.lt.5.)Then
            Do iter =0,4      !  Remove High Energy particles from halos
         If(irad .ge.1 .and. Rhalo.gt.Rminhalo)Then
           Vcc =Vcirc/Vscale          ! back to dimensionless units
           Vmaxrot=Vcc*Toohot*1.1**(4-iter) ! Increase the Rotatioanl Vel.
           Call RemEng(i,Vmaxrot,Rmaxrot/Xscale)  ! Remove Unbound Particles
           iflag =0
           ifirst=0
           Do ir =1,Nrad
            If(Nbc(i,ir).gt.5.and.iflag.eq.0)Then
               ifirst = ir            ! find first significant bin
               iflag  = 1
            EndIf 
              Vrmc(i,ir)=Vrmc(i,ir) *Vscale
             Summass     =Om0*Nbc(i,ir)/Fract
             Mass(ir)    = Dscale*Summass
             Overdens(ir)=Mass(ir)/MnMass(ir)
           EndDo  
          Call Decide(Mass,Radsc,Overdens,Nrad,irad,Mhalo,Rhalo,
     +                                       Vmaxrot,Rmaxrot,ifirst)
          Vcirc=sqrt(Vmaxrot/AEXPN)*6.58e-5 !=10^-5*sqrt(2e33/3.08e24)
c         If(Vcirc.gt.100.)write (*,'(5x,f7.2,i3,2g11.3)')
c     &                      Vcirc,irad,Mhalo,Rhalo

         EndIf
         EndDo       ! end iter energy
         EndIf
         Amc(i)     =Mhalo ! store results
         Rmc(i)     = Rhalo 
         RmaxV(i)   = Rmaxrot
         Vrm(i)     =Vcirc
         iRadius(i) =irad
c         write(*,'(i6,1P,5g11.3)')i,Rmaxrot,Vcirc,Rhalo,Mhalo
       Enddo   ! end i (Ncentr)
       Return
       End
C------------------------------------------------------------- 
C                                       Find  halo radius and mass
      SUBROUTINE Decide(Mass,Rad,Overdens,Nrad,irad,Mhalo,Rhalo,
     +                                   Vmaxrot,Rmaxrot,ifirst )
C--------------------------------------------------------------
      COMMON /OVER/ Ovlim,Ovcnt
      Real   Rad(Nrad),Overdens(Nrad),Mass(Nrad),Mhalo
      DATA  slope/0.999/
         Vmaxrot =0
         Rmaxrot =0. 
         Mhalo=0.
         Rhalo=0.   
      If(ifirst.eq.0)Then
         irad =0         ! too few particles
         RETURN
      EndIf

      If(MAX(Overdens(ifirst),Overdens(2)).LT.Ovcnt)Then
         irad =0         ! max overdensity is less then Ovcnt
         RETURN
      EndIf
      iov  =0
      Do ir=Nrad,ifirst,-1
         If(Overdens(ir).gt.Ovlim .and. iov.eq.0)Then
            iov  =ir
         EndIf
      EndDo
      If(iov.eq.0)Then
         irad =0         ! max overdensity is less then Ovlim
         RETURN
      EndIf
      iovv =0
      Do ir=ifirst,iov
         irleft =max(ir-1,1)
         irr1   =min(ir+1,Nrad)
         irr2   =min(ir+2,Nrad)
         Overright =(2.*Overdens(irr1)+Overdens(irr2))/3.
         Overleft  =(2.*Overdens(ir)+Overdens(irleft))/3.
         If(Overright.gt.0.97*Overleft)Then !stop:rising profile
            If(ir.eq.1)Then ! softer conditions for the first bin
               If(Overright.gt.1.2*Overleft)Then
                   iovv =ir
                   goto 20
               EndIf
            else 
                iovv =ir
               goto 20
            EndIf
         EndIf
      EndDo
 20   If(iovv.ne.0)iov =iovv
         irad =iov
            If(irad.lt.ifirst)write (*,*)' err: irad=',irad,ifirst


 30      irleft  =max(irad-2,1)  ! check if overdens is steep
         irright =min(irad+1,Nrad)
         gradlf  =Overdens(irleft) * (Rad(irleft))**slope
         gradrt  =Overdens(irright)* (Rad(irright))**slope
         If(gradlf.lt.gradrt)Then  ! not a steep gradient
            irad =irad -1        ! reduce radius
            iovv =irad
            If(irad.lt.ifirst)Then   ! zero radius -> quit
               irad =0
               RETURN
            Else
               goto 30             ! iterate
            EndIf
         EndIf
            If(irad.lt.ifirst)write (*,*)' err2: irad=',irad,ifirst
         If(irad.lt.Nrad)Then    ! interpolate to Overlim
            If(Ovlim.gt.Overdens(irad+1) .and.
     .         Overdens(irad).gt.Ovlim)Then       
              Mhalo=(Mass(irad)*(Ovlim-Overdens(irad+1))+
     .             Mass(irad+1)*(Overdens(irad)-Ovlim)) /
     .             (Overdens(irad)-Overdens(irad+1))
              Rhalo=(Rad(irad)*(Ovlim-Overdens(irad+1))+
     .             Rad(irad+1)*(Overdens(irad)-Ovlim)) /
     .             (Overdens(irad)-Overdens(irad+1))
            Else                 ! Overdens is > Overlim 
              Mhalo =Mass(irad)
              Rhalo =Rad(irad)
            EndIf
         Else                 ! Overdens is > Overlim 
            Mhalo =Mass(irad)
            Rhalo =Rad(irad)
         EndIf

         imax  = 0
         Do ir =1,irad  ! find max rotational velocity
            V2    = Mass(ir)/Rad(ir)
            If (V2.gt.Vmaxrot)Then
               Vmaxrot =V2               
               Rmaxrot =Rad(ir)
               imax = ir
            EndIf
         EndDo
                              ! improve Rmaxrot value by finding
                              ! radius containing F(1)/F(2.15)=0.415 fraction
                              ! of mass at Vmax. Then Rmax=2.15*R
         imax = max(imax,1)
         aMrs = 0.415*Mass(imax)
c         write (*,*)  ' == imax=',imax,' mass=',aMrs
c         write (*,'(1P,10G11.3)') Mass
         Do ir=1,irad
            If(Mass(ir).gt.aMrs)Then
               if(ir.eq.1)Then
                  aM0 =0.
                  r0     =0.
               Else
                  aM0 =Mass(ir-1)
                  r0     =Rad(ir-1)
               EndIf
               Rmaxrot2 =2.15*(r0+(Rad(ir)-r0)*(aMrs-aM0)/
     &                          max(Mass(ir)-aM0,1.e-3))
               Rmaxrot =min(Rmaxrot,Rmaxrot2,Rhalo/2.)
               return
            EndIf 
          EndDo 
 50       write (*,'(4i4,1P,10G11.3)') ir,irad,ifirst,iovv,
     &             Mass(ir),Ovlim,   Rmaxrot,
     &                Rmaxrot2,Rad(ir),r0
          write (*,'(1P,10g11.3)')Overdens  

      Return
      End
C------------------------------------------------
C                                  Remove unbound particles for i-th halo
C                                  irad   = radius of the halo
C                                 Vmaxrot = max rotational Velocity
C                                 Rmaxrot = radius at max rot.velocity
      SUBROUTINE RemEng(i,Vmaxrot,Rmaxrot)
C-----------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      DIMENSION VXxc(Nrad), VYyc(Nrad), VZzc(Nrad),
     &             Vescape2(Nrad)            
      DIMENSION  Vx1(Nrad),Vy1(Nrad),Vz1(Nrad),Vxx(Nrad),Nob1(Nrad),
     .             Rob1(Nrad),NobM(Nrad),NobG(Nrad),NobS(Nrad)
         Xc  =Xm(i)  ! store center of mass and velocity      
         Yc  =Ym(i)     
         Zc  =Zm(i)     
         Do ir =1,Nrad ! store mean velocity
            VXxc(ir) =Wxc(i,ir) 
            VYyc(ir) =Wyc(i,ir) 
            VZzc(ir) =Wzc(i,ir) 
                                         ! escape velocity for NFW profile
            Vescape2(ir) = (2.15*Vmaxrot)**2 * 
     &           log(1.0+2.*Rad(ir)/Rmaxrot)/(Rad(ir)/Rmaxrot) 
               Wxc(i,ir) = 0.
               Wyc(i,ir) = 0.
               Wzc(i,ir) = 0.
               Nbc(i,ir) = 0
               NbcS(i,ir) = 0
               NbcM(i,ir) = 0
               NbcG(i,ir) = 0
               Rrc(i,ir) = 0.
               Vrmc(i,ir)= 0.
            EndDo
            Call SrejNeib(VXxc,VYyc,VZzc,Xc,Yc,Zc,Vescape2,
     &                  Vx1,Vy1,Vz1,Nob1,NobS,NobM,NobG,Rob1,Vxx)
            Do ir=1,Nrad  !  Store Results 
               Wxc(i,ir) =Vx1(ir)
               Wyc(i,ir) =Vy1(ir)
               Wzc(i,ir) =Vz1(ir)
               Nbc(i,ir) =Nob1(ir)
               NbcS(i,ir) =NobS(ir)
               NbcM(i,ir) =NobM(ir)
               NbcG(i,ir) =NobG(ir)
               Rrc(i,ir) =Rob1(ir)
               Vrmc(i,ir)=Vxx(ir)
            EndDo
      Return
      End
C--------------------------------------------------------------
C                                Accumilate statistics only
C                                if relative velocity is not large
C                                Xc,Yc,Zc - center; 
C                               
      SUBROUTINE SrejNeib(VXxc,VYyc,VZzc,Xc,Yc,Zc,Vescape2,
     &                  Vx1,Vy1,Vz1,Nob1,NobS,NobM,NobG,Rob1,Vxx)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      DIMENSION VXxc(Nrad), VYyc(Nrad), VZzc(Nrad),Vescape2(Nrad)
      DIMENSION  Vx1(Nrad),Vy1(Nrad),Vz1(Nrad),Vxx(Nrad),Nob1(Nrad),
     .             Rob1(Nrad),NobM(Nrad),NobG(Nrad),NobS(Nrad)

      iFlag = 0
         Radmax =Rad(Nrad)/FracSearch
         d0      = Rad(1)

 50      dmax = Radmax**2
         Ninside = aNvir*Radmax**3
         iw1 = 1
         iw8 = 8
         iw64 = 64

         Do i=1,Nrad
              Nob1(i) =0
              NobS(i) =0
              NobM(i) =0
              NobG(i) =0
              Rob1(i) =0.
              Vx1(i)  =0.
              Vy1(i)  =0.
              Vz1(i)  =0.
              Vxx(i)  =0.
         EndDo
c                                           limits for Label
         i1=INT((Xc-Radmax)/Cell)
         j1=INT((Yc-Radmax)/Cell)
         k1=INT((Zc-Radmax)/Cell)
            i1=MIN(MAX(Nm,i1),Nb)
            j1=MIN(MAX(Nm,j1),Nb)
            k1=MIN(MAX(Nm,k1),Nb)
         i2=INT((Xc+Radmax)/Cell)
         j2=INT((Yc+Radmax)/Cell)
         k2=INT((Zc+Radmax)/Cell)
            i2=MIN(MAX(Nm,i2),Nb)
            j2=MIN(MAX(Nm,j2),Nb)
            k2=MIN(MAX(Nm,k2),Nb)
C                                        Look for neibhours
         Do k=k1,k2
         Do j=j1,j2
         Do i=i1,i2
           jp =Label(i,j,k)       !  Dark matter
 10        If(jp.ne.0)Then
                dd =(Xc-Xp(jp))**2+(Yc-Yp(jp))**2+(Zc-Zp(jp))**2
             If(dd.lt.dmax)Then
                  d1 =sqrt(dd)
                    iov =INT(   max(0.,4.*(sqrt(d1/d0)-1.) +1)) +1
                    iov = min(max(1,iov),Nrad)
                    dv =  (VXxc(iov)-VXp(jp))**2+
     +                     (VYyc(iov)-VYp(jp))**2+
     +                     (VZzc(iov)-VZp(jp))**2
                If(dv .lt. Vescape2(iov))Then
                    ww =iWeight(jp)
                    iww =INT(ww/iWeight(1)+0.005)
                    Nob1(iov)= Nob1(iov)+ iww
                    If(iww.eq.iw1)NobS(iov)= NobS(iov)+ 1
                    If(iww.eq.iw8)NobM(iov)= NobM(iov)+ 1
                    If(iww.eq.iw64)NobG(iov)= NobG(iov)+ 1
                    Rob1(iov)= Rob1(iov)+ d1*iww
                    Vxx(iov) = Vxx(iov) +
     +                          iww*(VXp(jp)**2+VYp(jp)**2+VZp(jp)**2)
                    Vx1(iov) = Vx1(iov) +iww*VXp(jp)  
                    Vy1(iov) = Vy1(iov) +iww*VYp(jp)
                    Vz1(iov) = Vz1(iov) +iww*VZp(jp)
                EndIf
             EndIf
           jp =Lst(jp)
           GoTo10
           EndIf
         EndDo
         EndDo
         EndDo

         Do ir =2,Nrad
            Nob1(ir)= Nob1(ir)   + Nob1(ir-1)
            NobS(ir)= NobS(ir)  +  NobS(ir-1)
            NobM(ir)= NobM(ir) +  NobM(ir-1)
            NobG(ir)= NobG(ir)  + NobG(ir-1)
            Rob1(ir)= Rob1(ir)    + Rob1(ir-1)
            Vxx(ir) = Vxx(ir)      + Vxx(ir-1)
            Vx1(ir) = Vx1(ir)      + Vx1(ir-1)
            Vy1(ir) = Vy1(ir)      + Vy1(ir-1) 
            Vz1(ir) = Vz1(ir)      + Vz1(ir-1) 
         EndDo


        Do ir=1,Nrad
           Vmn =0.
     	      If(Nob1(ir).GT.0)Then
               Nobj =Nob1(ir)
               Vx1(ir) = Vx1(ir)/Nobj
               Vy1(ir) = Vy1(ir)/Nobj
               Vz1(ir) = Vz1(ir)/Nobj
              Vmn     = Vx1(ir)**2+Vy1(ir)**2+Vz1(ir)**2
               Vxx(ir) = SQRT(ABS(Vxx(ir)/Nobj -Vmn))
	         EndIf
         EndDo
         If(Nob1(Nrad).gt.Ninside.and.iFlag.eq.0)Then
             Radmax =Rad(Nrad)
             Iflag = 1
             goto50
          EndIf 

      Return
      End
C--------------------------------------------------------------
C                                Accumilate statistics only
C                                if relative velocity is not large
C                                Xc,Yc,Zc - center; 
C                               
      SUBROUTINE SrejNeibOld(VXxc,VYyc,VZzc,Xc,Yc,Zc,Vescape2,
     &                  Vx1,Vy1,Vz1,Nob1,NobS,NobM,NobG,Rob1,Vxx)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      DIMENSION VXxc(Nrad), VYyc(Nrad), VZzc(Nrad),Vescape2(Nrad)
      DIMENSION  Vx1(Nrad),Vy1(Nrad),Vz1(Nrad),Vxx(Nrad),Nob1(Nrad),
     .             Rob1(Nrad),NobM(Nrad),NobG(Nrad),NobS(Nrad)
         Radmax =Rad(Nrad)
         alph =Rad(1)**2
         iw1 = 1
         iw8 = 8
         iw64 = 64

         Do i=1,Nrad
              Nob1(i) =0
              NobS(i) =0
              NobM(i) =0
              NobG(i) =0
              Rob1(i) =0.
              Vx1(i)  =0.
              Vy1(i)  =0.
              Vz1(i)  =0.
              Vxx(i)  =0.
         EndDo
c                                           limits for Label
         i1=INT((Xc-Radmax)/Cell)
         j1=INT((Yc-Radmax)/Cell)
         k1=INT((Zc-Radmax)/Cell)
            i1=MIN(MAX(Nm,i1),Nb)
            j1=MIN(MAX(Nm,j1),Nb)
            k1=MIN(MAX(Nm,k1),Nb)
         i2=INT((Xc+Radmax)/Cell)
         j2=INT((Yc+Radmax)/Cell)
         k2=INT((Zc+Radmax)/Cell)
            i2=MIN(MAX(Nm,i2),Nb)
            j2=MIN(MAX(Nm,j2),Nb)
            k2=MIN(MAX(Nm,k2),Nb)
C                                        Look for neibhours
         Do k=k1,k2
         Do j=j1,j2
         Do i=i1,i2
           jp =Label(i,j,k)       !  Dark matter
 10        If(jp.ne.0)Then
             dd =(Xc-Xp(jp))**2+(Yc-Yp(jp))**2+(Zc-Zp(jp))**2
             If(dd.lt.Rad2(Nrad))Then
c                iov =max(1,INT(4.*sqrt(sqrt(dd/alph)) ) -2)
             iov =0
             Do ir =1,Nrad          ! find bin
                If(dd.le.Rad2(ir))Then
                   iov =ir
                   goto 30
                EndIf
             EndDo
 30          If(iov.eq. 0)Then   ! error
                write (*,*) ' Error SrejNeib: iov =',iov,' d=',sqrt(dd)
                Stop
             EndIf
             dv =  (VXxc(iov)-VXp(jp))**2+
     +             (VYyc(iov)-VYp(jp))**2+
     +             (VZzc(iov)-VZp(jp))**2
             If(dv .lt. Vescape2(iov))Then
                    ww =iWeight(jp)
                    iww =INT(ww/iWeight(1)+0.005)
              Do ir =iov,Nrad   ! Nrad
                   Nob1(ir)= Nob1(ir)+ iww
                    If(iww.eq.iw1)NobS(ir)= NobS(ir)+ 1
                    If(iww.eq.iw8)NobM(ir)= NobM(ir)+ 1
                    If(iww.eq.iw64)NobG(ir)= NobG(ir)+ 1
                   Rob1(ir)= Rob1(ir)+ sqrt(dd)*iww
c                   Vrr = - (VXp(jp)*(Xc-Xp(jp))+ !  radial velocity
c     &                      VYp(jp)*(Yc-Yp(jp))+
c     &                      VZp(jp)*(Zc-Zp(jp)) )/sqrt(dd)
c                    Vxx(ir) = Vxx(ir) +  iww*Vrr
                   Vxx(ir) = Vxx(ir) +
     +                          iww*(VXp(jp)**2+VYp(jp)**2+VZp(jp)**2)
                   Vx1(ir) = Vx1(ir) +iww*VXp(jp)  
                   Vy1(ir) = Vy1(ir) +iww*VYp(jp)
                   Vz1(ir) = Vz1(ir) +iww*VZp(jp)
              EndDo
             EndIf
             EndIf
           jp =Lst(jp)
           GoTo10
           EndIf
         EndDo
         EndDo
         EndDo

        Do ir=1,Nrad
           Vmn =0.
     	      If(Nob1(ir).GT.0)Then
               Nobj =Nob1(ir)
               Vx1(ir) = Vx1(ir)/Nobj
               Vy1(ir) = Vy1(ir)/Nobj
               Vz1(ir) = Vz1(ir)/Nobj
              Vmn     = Vx1(ir)**2+Vy1(ir)**2+Vz1(ir)**2
               Vxx(ir) = SQRT(ABS(Vxx(ir)/Nobj -Vmn))
	         EndIf
         EndDo
      Return
      End

C--------------------------------------------------
C                             Set Weights of particles for
C                             fast access
      SUBROUTINE SetWeights
C--------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMlists.h'
      Wpr =NGRID**3/FLOAT(NROW**3)
      If(Nspecies.eq.0)Then  ! old  constant weights
         N_particles =lspecies(1)
         lspecies(1) = NROW**3
         N_particles =lspecies(1)
         Nspecies = 1
         wspecies(1) = 1.
         Ww  = 1.
         Do i=1,N_particles
            iWeight(i) =Ww
         EndDo
      Else
         N_particles =min(lspecies(Nspecies),Nmaxpart)
         jstart =1
         If(iDebug.eq.1)
     +    write (*,*) ' N_Particles=',N_particles
         If(N_particles.le.0)Then
            write (*,*) ' Wrong number of particles:',N_particles
            write (*,*) ' Nspecies=',Nspecies,' N=',lspecies
            STop
         endif 
         Do j=1,Nspecies
            jend =min(lspecies(j),Nmaxpart)
            Do k=jstart ,jend
               iWeight(k) =wspecies(j)/Wpr
            EndDo
            jstart =jend
         EndDo
      EndIf
      If(iDebug.eq.1)Then
      write (*,*) ' Set Weights for ',N_particles,' particles:',
     &       ' w_first=' ,iWeight(1),' w_last=',  iWeight(N_particles)
      write (*,*) ' Nspecies=',Nspecies,' Weights=',wspecies(1),
     &            wspecies(2), wspecies(3)
      EndIf
      RETURN
      END
C-----------------------------------------------------------
C                        Open file with answers for rerunning
C                        Print help and description
      SUBROUTINE Help
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'

      Open(25,file='InHalos.dat',Status='UNKNOWN')
      Write (*,100)
 100  format(//,55('-'),/
     +1x,'You run BDM - Bound Density Maxima - code'/
     +5x,'Code reads data from two files: PMcrd.DAT',
     +                 ' and PMcrs0.DAT',/
     +5x,'It writes output to two files  :', 
     +   ' Catshort.DAT and Catalog.DAT',/
     +5x,'Code will ask you few questions to set parameters',
     +   ' of the search',/
     +5x,'Your answers will be written into file InHalos.dat')
 




      RETURN
      END


c     ------------------------
      real function seconds ()
c     ------------------------
c
c     purpose: returns elapsed time in seconds
c     uses   : xlf90 utility function timef()
c              (in this case - to be compiled with xlf90 or with -lxlf90)
c              or dtime (Exemplar) or etime (Power Challenge)
c      real*8 timef
      real*8 dummy
      real tarray(2)

      dummy = 0.0

c.... for IBM SP
      dummy   = timef ()
      seconds = dummy / 1000

c.... for exemplar
c      dummy = dtime(tarray) 
c      seconds = dtime(tarray)

c.... for hitachi
c      dummy = dtime(tarray)
c       seconds = second()

c.... for power challenge
c      dummy = etime(tarray)
c      seconds = etime(tarray)

      return
      end

c----------------------------------------
c
c
      Include 'LCDMevol.h'
      DIMENSION sMass(4)
      DATA sMass/1.d11,1.d12,1.d13,1.d15/

      CALL InitValues
      R8 = 8./hubble
      aM = 3.41d11*R8**3
      aexpn =1.
      Anorm =1.
      Anorm = sig8**2/Sigma(aM)
      GrFactor= Growth()
      write (*,5) Om0,OmL,hubble,sig8 
      write (*,10) aexpn,1./aexpn-1.,Anorm,GrFactor,Age()/1.d9
 5    format(' Omega_0=',f8.3,' Omega_Lambda=',f8.3,' hubble=',f8.3,
     &    ' sig8=',f8.3)
 10   format(10x,'Expansion Parameter  =',g11.3,' z       =',g11.3,
     &    /10x,'Normalization        =',g11.3,' GrowthFactor=',f8.3,
     &    ' Age(Gyrs)=',f8.4)

      Do j=1,4
      aM =sMass(j)/hubble
      write (*,*)  
      write(*,'("-------------- mass=",P1G11.3)')sMass(j)
      Do i=0,5
         z=i
         aexpn =1./(1.+z)
         Ss =Sigma(aM)
         GrFactor= Growth()
         Fm    = Fmass(Ss)
         write (*,20) aexpn,z,sqrt(Ss),Fm,GrFactor,Age()/1.d9
 20      format('a  =',g11.3,' z=',g11.3,
     &    ' Sigma=',g11.3,' FracMass=',g11.3,' Growth=',f8.3,
     &    ' Age(Gyrs)=',f8.4)
       EndDo 
       EndDo 

      Stop
      end
c-------------------------------------------------------------------- 
c                            
      SUBROUTINE InitValues
      Include 'LCDMevol.h'
         eps1    = 1.d-7           ! errors of intigration
         eps2    = 1.d-5
         Om0     = 0.3
         OmL     = 1.-Om0
         hubble  = 0.7
         sig8    = 0.9
      return
      end
c-------------------------------------------------------------------- 
      REAL*8 Function Sigma(aM)
c-------------------------------------------------------------------- 
      Include 'LCDMevol.h'
       EXTERNAL PW     

         Rtophat = (aM/3.41d11)**0.33333
         rmin = 1.d-5
         rmax = 1.d3
         CALL DGAUS8 (PW, rmin,rmax, eps2, Ss, IERR)
                  if(IERR.ne.1)write (*,*)  ' ERROR Sigma=',IERR
         Sigma = Anorm*Growth(aexpn)**2*Ss
      
      return
      end
c-------------------------------------------------------------------- 
c                             auxiliary function for sigma
      double precision function PW(x)
      Include 'LCDMevol.h'
         PW = x**2*Pk(x)*Wtophat(x*Rtophat)
      Return
      End

c-------------------------------------------------------------------- 
      REAL*8 Function Fmass(sS)
c-------------------------------------------------------------------- 
      Include 'LCDMevol.h'
       EXTERNAL ddex     

       xs = 1.68/sq2/sS
       xmax = max(10.*xs,10.d0)
         CALL DGAUS8 (ddex, xs,xmax, eps2, fF, IERR)
                  if(IERR.ne.1)write (*,*)  ' ERROR fF=',IERR
         Fmass = fF/sqrt(pi)
      return
      end
c-------------------------------------------------------------------- 
c                             auxiliary function for sigma
      double precision function ddex(x)
      Include 'LCDMevol.h'
         ddex = exp(-x**2)
      Return
      End

c-------------------------------------------------------------------- 
c                             Window function W**2(kRtophat)
      double precision function Wtophat(x)
      Include 'LCDMevol.h'
         Wtophat = (3.d0*(sin(x)-x*cos(x))/x**3)**2
      Return
      End

c-------------------------------------------------------------------- 
c                             Growth rate for LCDM model
      double precision function Growth()
      Include 'LCDMevol.h'
      SAVE init,start,x0
      EXTERNAL aGr
      DATA init/0/

      If(init.eq.0)Then
         init =1
         x0 = (OmL/Om0)**0.33333333
         CALL DGAUS8 (aGr, 0.d0,x0, eps2, Ss, IERR)
         start = sqrt(1.d0+x0**3)/x0**2.5d0*Ss
      EndIf
         x = x0*aexpn
         CALL DGAUS8 (aGr, 0.d0,x, eps2, Ss, IERR)
         Growth = sqrt(1.d0+1.d0/x**3)/x0*Ss/start
      Return
      End
        
c-------------------------------------------------------------------- 
c                             auxiliary function for Growth
      double precision function AGr(x)
      Include 'LCDMevol.h'
         AGr = sqrt((x/(1.d+0+x**3))**3)
      Return
      End

c-------------------------------------------------------------------- 
c                                  age for LCDM model 
      double precision function Age()
      Include 'LCDMevol.h'
      PARAMETER (tconst =9.31e+9)
          x = ((1.-Om0)/Om0)**0.333333*aexpn
          Age = tconst /sqrt(1.-Om0)*(log(x**1.5+sqrt(1.+x**3)))
       Return
       End

C---------------------------------------
      REAL*8 FUNCTION Pk(x)
c                     
c                       x is in real 1/Mpc
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      DATA p2,p3,p4,p5,p6/-1.5598d0,47.986d0,117.77d0,
     &                      321.92d0,1.8606d0/

         Pk = x/(1.d0+sqrt(x)*(p2+p4*x)+x*(p3+p5*x))**p6

       Return
       End
c-------------------------------------------------------------------- 
*DECK DGAUS8
      SUBROUTINE DGAUS8 (FUN, A, B, ERR, ANS, IERR)
C***BEGIN PROLOGUE  DGAUS8
C***PURPOSE  Integrate a real function of one variable over a finite
C            interval using an adaptive 8-point Legendre-Gauss
C            algorithm.  Intended primarily for high accuracy
C            integration or integration of smooth functions.
C***LIBRARY   SLATEC
C***CATEGORY  H2A1A1
C***TYPE      DOUBLE PRECISION (GAUS8-S, DGAUS8-D)
C***KEYWORDS  ADAPTIVE QUADRATURE, AUTOMATIC INTEGRATOR,
C             GAUSS QUADRATURE, NUMERICAL INTEGRATION
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C     Abstract  *** a DOUBLE PRECISION routine ***
C        DGAUS8 integrates real functions of one variable over finite
C        intervals using an adaptive 8-point Legendre-Gauss algorithm.
C        DGAUS8 is intended primarily for high accuracy integration
C        or integration of smooth functions.
C
C        The maximum number of significant digits obtainable in ANS
C        is the smaller of 18 and the number of digits carried in
C        double precision arithmetic.
C
C     Description of Arguments
C
C        Input--* FUN, A, B, ERR are DOUBLE PRECISION *
C        FUN - name of external function to be integrated.  This name
C              must be in an EXTERNAL statement in the calling program.
C              FUN must be a DOUBLE PRECISION function of one DOUBLE
C              PRECISION argument.  The value of the argument to FUN
C              is the variable of integration which ranges from A to B.
C        A   - lower limit of integration
C        B   - upper limit of integration (may be less than A)
C        ERR - is a requested pseudorelative error tolerance.  Normally
C              pick a value of ABS(ERR) so that DTOL .LT. ABS(ERR) .LE.
C              1.0D-3 where DTOL is the larger of 1.0D-18 and the
C              double precision unit roundoff D1MACH(4).  ANS will
C              normally have no more error than ABS(ERR) times the
C              integral of the absolute value of FUN(X).  Usually,
C              smaller values of ERR yield more accuracy and require
C              more function evaluations.
C
C              A negative value for ERR causes an estimate of the
C              absolute error in ANS to be returned in ERR.  Note that
C              ERR must be a variable (not a constant) in this case.
C              Note also that the user must reset the value of ERR
C              before making any more calls that use the variable ERR.
C
C        Output--* ERR,ANS are double precision *
C        ERR - will be an estimate of the absolute error in ANS if the
C              input value of ERR was negative.  (ERR is unchanged if
C              the input value of ERR was non-negative.)  The estimated
C              error is solely for information to the user and should
C              not be used as a correction to the computed integral.
C        ANS - computed value of integral
C        IERR- a status code
C            --Normal codes
C               1 ANS most likely meets requested error tolerance,
C                 or A=B.
C              -1 A and B are too nearly equal to allow normal
C                 integration.  ANS is set to zero.
C            --Abnormal code
C               2 ANS probably does not meet requested error tolerance.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, I1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   810223  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890911  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C***END PROLOGUE  DGAUS8
      INTEGER IERR, K, KML, KMX, L, LMN, LMX, LR, MXL, NBITS,
     1 NIB, NLMN, NLMX
      INTEGER I1MACH
      DOUBLE PRECISION A,AA,AE,ANIB,ANS,AREA,B,C,CE,EE,EF,
     1 EPS, ERR, EST, GL, GLR, GR, HH, SQ2, TOL, VL, VR, W1, W2, W3,
     2 W4, X1, X2, X3, X4, X, H
      DOUBLE PRECISION D1MACH, G8, FUN
      DIMENSION AA(60), HH(60), LR(60), VL(60), GR(60)
      SAVE X1, X2, X3, X4, W1, W2, W3, W4, SQ2,
     1 NLMN, KMX, KML
      DATA X1, X2, X3, X4/
     1     1.83434642495649805D-01,     5.25532409916328986D-01,
     2     7.96666477413626740D-01,     9.60289856497536232D-01/
      DATA W1, W2, W3, W4/
     1     3.62683783378361983D-01,     3.13706645877887287D-01,
     2     2.22381034453374471D-01,     1.01228536290376259D-01/
      DATA SQ2/1.41421356D0/
      DATA NLMN/1/,KMX/5000/,KML/6/
      G8(X,H)=H*((W1*(FUN(X-X1*H) + FUN(X+X1*H))
     1           +W2*(FUN(X-X2*H) + FUN(X+X2*H)))
     2          +(W3*(FUN(X-X3*H) + FUN(X+X3*H))
     3           +W4*(FUN(X-X4*H) + FUN(X+X4*H))))
C***FIRST EXECUTABLE STATEMENT  DGAUS8
C
C     Initialize
C
      K = I1MACH(14)
      ANIB = D1MACH(5)*K/0.30102000D0
      NBITS = ANIB
      NLMX = MIN(60,(NBITS*5)/8)
      ANS = 0.0D0
      IERR = 1
      CE = 0.0D0
      IF (A .EQ. B) GO TO 140
      LMX = NLMX
      LMN = NLMN
      IF (B .EQ. 0.0D0) GO TO 10
      IF (SIGN(1.0D0,B)*A .LE. 0.0D0) GO TO 10
      C = ABS(1.0D0-A/B)
      IF (C .GT. 0.1D0) GO TO 10
      IF (C .LE. 0.0D0) GO TO 140
      ANIB = 0.5D0 - LOG(C)/0.69314718D0
      NIB = ANIB
      LMX = MIN(NLMX,NBITS-NIB-7)
      IF (LMX .LT. 1) GO TO 130
      LMN = MIN(LMN,LMX)
   10 TOL = MAX(ABS(ERR),2.0D0**(5-NBITS))/2.0D0
      IF (ERR .EQ. 0.0D0) TOL = SQRT(D1MACH(4))
      EPS = TOL
      HH(1) = (B-A)/4.0D0
      AA(1) = A
      LR(1) = 1
      L = 1
      EST = G8(AA(L)+2.0D0*HH(L),2.0D0*HH(L))
      K = 8
      AREA = ABS(EST)
      EF = 0.5D0
      MXL = 0
C
C     Compute refined estimates, estimate the error, etc.
C
   20 GL = G8(AA(L)+HH(L),HH(L))
      GR(L) = G8(AA(L)+3.0D0*HH(L),HH(L))
      K = K + 16
      AREA = AREA + (ABS(GL)+ABS(GR(L))-ABS(EST))
C     IF (L .LT .LMN) GO TO 11
      GLR = GL + GR(L)
      EE = ABS(EST-GLR)*EF
      AE = MAX(EPS*AREA,TOL*ABS(GLR))
      IF (EE-AE) 40, 40, 50
   30 MXL = 1
   40 CE = CE + (EST-GLR)
      IF (LR(L)) 60, 60, 80
C
C     Consider the left half of this level
C
   50 IF (K .GT. KMX) LMX = KML
      IF (L .GE. LMX) GO TO 30
      L = L + 1
      EPS = EPS*0.5D0
      EF = EF/SQ2
      HH(L) = HH(L-1)*0.5D0
      LR(L) = -1
      AA(L) = AA(L-1)
      EST = GL
      GO TO 20
C
C     Proceed to right half at this level
C
   60 VL(L) = GLR
   70 EST = GR(L-1)
      LR(L) = 1
      AA(L) = AA(L) + 4.0D0*HH(L)
      GO TO 20
C
C     Return one level
C
   80 VR = GLR
   90 IF (L .LE. 1) GO TO 120
      L = L - 1
      EPS = EPS*2.0D0
      EF = EF*SQ2
      IF (LR(L)) 100, 100, 110
  100 VL(L) = VL(L+1) + VR
      GO TO 70
  110 VR = VL(L+1) + VR
      GO TO 90
C
C     Exit
C
  120 ANS = VR
      IF ((MXL.EQ.0) .OR. (ABS(CE).LE.2.0D0*TOL*AREA)) GO TO 140
      IERR = 2
      write (*,*)  'DGAUS8: ',
     +   'ANS is probably insufficiently accurate.'
      GO TO 140
  130 IERR = -1
      write (*,*)   'DGAUS8: ',
     +   'A and B are too nearly equal to allow normal integration.'
  140 IF (ERR .LT. 0.0D0) ERR = CE
      RETURN
      END
*DECK I1MACH
      INTEGER FUNCTION I1MACH (I)
C***BEGIN PROLOGUE  I1MACH
C***PURPOSE  Return integer machine dependent constants.
C***LIBRARY   SLATEC
C***CATEGORY  R1
C***TYPE      INTEGER (I1MACH-I)
C***KEYWORDS  MACHINE CONSTANTS
C***AUTHOR  Fox, P. A., (Bell Labs)
C           Hall, A. D., (Bell Labs)
C           Schryer, N. L., (Bell Labs)
C***DESCRIPTION
C
C   I1MACH can be used to obtain machine-dependent parameters for the
C   local machine environment.  It is a function subprogram with one
C   (input) argument and can be referenced as follows:
C
C        K = I1MACH(I)
C
C   where I=1,...,16.  The (output) value of K above is determined by
C   the (input) value of I.  The results for various values of I are
C   discussed below.
C
C   I/O unit numbers:
C     I1MACH( 1) = the standard input unit.
C     I1MACH( 2) = the standard output unit.
C     I1MACH( 3) = the standard punch unit.
C     I1MACH( 4) = the standard error message unit.
C
C   Words:
C     I1MACH( 5) = the number of bits per integer storage unit.
C     I1MACH( 6) = the number of characters per integer storage unit.
C
C   Integers:
C     assume integers are represented in the S-digit, base-A form
C
C                sign ( X(S-1)*A**(S-1) + ... + X(1)*A + X(0) )
C
C                where 0 .LE. X(I) .LT. A for I=0,...,S-1.
C     I1MACH( 7) = A, the base.
C     I1MACH( 8) = S, the number of base-A digits.
C     I1MACH( 9) = A**S - 1, the largest magnitude.
C
C   Floating-Point Numbers:
C     Assume floating-point numbers are represented in the T-digit,
C     base-B form
C                sign (B**E)*( (X(1)/B) + ... + (X(T)/B**T) )
C
C                where 0 .LE. X(I) .LT. B for I=1,...,T,
C                0 .LT. X(1), and EMIN .LE. E .LE. EMAX.
C     I1MACH(10) = B, the base.
C
C   Single-Precision:
C     I1MACH(11) = T, the number of base-B digits.
C     I1MACH(12) = EMIN, the smallest exponent E.
C     I1MACH(13) = EMAX, the largest exponent E.
C
C   Double-Precision:
C     I1MACH(14) = T, the number of base-B digits.
C     I1MACH(15) = EMIN, the smallest exponent E.
C     I1MACH(16) = EMAX, the largest exponent E.
C
C   To alter this function for a particular environment, the desired
C   set of DATA statements should be activated by removing the C from
C   column 1.  Also, the values of I1MACH(1) - I1MACH(4) should be
C   checked for consistency with the local operating system.
C
C***REFERENCES  P. A. Fox, A. D. Hall and N. L. Schryer, Framework for
C                 a portable library, ACM Transactions on Mathematical
C                 Software 4, 2 (June 1978), pp. 177-188.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   750101  DATE WRITTEN
C   891012  Added VAX G-floating constants.  (WRB)
C   891012  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900618  Added DEC RISC constants.  (WRB)
C   900723  Added IBM RS 6000 constants.  (WRB)
C   901009  Correct I1MACH(7) for IBM Mainframes. Should be 2 not 16.
C           (RWC)
C   910710  Added HP 730 constants.  (SMR)
C   911114  Added Convex IEEE constants.  (WRB)
C   920121  Added SUN -r8 compiler option constants.  (WRB)
C   920229  Added Touchstone Delta i860 constants.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C   920625  Added Convex -p8 and -pd8 compiler option constants.
C           (BKS, WRB)
C   930201  Added DEC Alpha and SGI constants.  (RWC and WRB)
C   930618  Corrected I1MACH(5) for Convex -p8 and -pd8 compiler
C           options.  (DWL, RWC and WRB).
C***END PROLOGUE  I1MACH
C
      INTEGER IMACH(16),OUTPUT
      SAVE IMACH
      EQUIVALENCE (IMACH(4),OUTPUT)
C
C     MACHINE CONSTANTS FOR THE AMIGA
C     ABSOFT COMPILER
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -126 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1022 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE APOLLO
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        129 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1025 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 1700 SYSTEM
C
C     DATA IMACH( 1) /          7 /
C     DATA IMACH( 2) /          2 /
C     DATA IMACH( 3) /          2 /
C     DATA IMACH( 4) /          2 /
C     DATA IMACH( 5) /         36 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         33 /
C     DATA IMACH( 9) / Z1FFFFFFFF /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -256 /
C     DATA IMACH(13) /        255 /
C     DATA IMACH(14) /         60 /
C     DATA IMACH(15) /       -256 /
C     DATA IMACH(16) /        255 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 5700 SYSTEM
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         48 /
C     DATA IMACH( 6) /          6 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         39 /
C     DATA IMACH( 9) / O0007777777777777 /
C     DATA IMACH(10) /          8 /
C     DATA IMACH(11) /         13 /
C     DATA IMACH(12) /        -50 /
C     DATA IMACH(13) /         76 /
C     DATA IMACH(14) /         26 /
C     DATA IMACH(15) /        -50 /
C     DATA IMACH(16) /         76 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 6700/7700 SYSTEMS
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         48 /
C     DATA IMACH( 6) /          6 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         39 /
C     DATA IMACH( 9) / O0007777777777777 /
C     DATA IMACH(10) /          8 /
C     DATA IMACH(11) /         13 /
C     DATA IMACH(12) /        -50 /
C     DATA IMACH(13) /         76 /
C     DATA IMACH(14) /         26 /
C     DATA IMACH(15) /     -32754 /
C     DATA IMACH(16) /      32780 /
C
C     MACHINE CONSTANTS FOR THE CDC 170/180 SERIES USING NOS/VE
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         64 /
C     DATA IMACH( 6) /          8 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         63 /
C     DATA IMACH( 9) / 9223372036854775807 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         47 /
C     DATA IMACH(12) /      -4095 /
C     DATA IMACH(13) /       4094 /
C     DATA IMACH(14) /         94 /
C     DATA IMACH(15) /      -4095 /
C     DATA IMACH(16) /       4094 /
C
C     MACHINE CONSTANTS FOR THE CDC 6000/7000 SERIES
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /    6LOUTPUT/
C     DATA IMACH( 5) /         60 /
C     DATA IMACH( 6) /         10 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         48 /
C     DATA IMACH( 9) / 00007777777777777777B /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         47 /
C     DATA IMACH(12) /       -929 /
C     DATA IMACH(13) /       1070 /
C     DATA IMACH(14) /         94 /
C     DATA IMACH(15) /       -929 /
C     DATA IMACH(16) /       1069 /
C
C     MACHINE CONSTANTS FOR THE CELERITY C1260
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          0 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / Z'7FFFFFFF' /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -126 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1022 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -fn COMPILER OPTION
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1023 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -fi COMPILER OPTION
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -p8 COMPILER OPTION
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         64 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         63 /
C     DATA IMACH( 9) / 9223372036854775807 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         53 /
C     DATA IMACH(12) /      -1023 /
C     DATA IMACH(13) /       1023 /
C     DATA IMACH(14) /        113 /
C     DATA IMACH(15) /     -16383 /
C     DATA IMACH(16) /      16383 /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -pd8 COMPILER OPTION
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         64 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         63 /
C     DATA IMACH( 9) / 9223372036854775807 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         53 /
C     DATA IMACH(12) /      -1023 /
C     DATA IMACH(13) /       1023 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1023 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE CRAY
C     USING THE 46 BIT INTEGER COMPILER OPTION
C
C     DATA IMACH( 1) /        100 /
C     DATA IMACH( 2) /        101 /
C     DATA IMACH( 3) /        102 /
C     DATA IMACH( 4) /        101 /
C     DATA IMACH( 5) /         64 /
C     DATA IMACH( 6) /          8 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         46 /
C     DATA IMACH( 9) / 1777777777777777B /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         47 /
C     DATA IMACH(12) /      -8189 /
C     DATA IMACH(13) /       8190 /
C     DATA IMACH(14) /         94 /
C     DATA IMACH(15) /      -8099 /
C     DATA IMACH(16) /       8190 /
C
C     MACHINE CONSTANTS FOR THE CRAY
C     USING THE 64 BIT INTEGER COMPILER OPTION
C
C     DATA IMACH( 1) /        100 /
C     DATA IMACH( 2) /        101 /
C     DATA IMACH( 3) /        102 /
C     DATA IMACH( 4) /        101 /
C     DATA IMACH( 5) /         64 /
C     DATA IMACH( 6) /          8 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         63 /
C     DATA IMACH( 9) / 777777777777777777777B /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         47 /
C     DATA IMACH(12) /      -8189 /
C     DATA IMACH(13) /       8190 /
C     DATA IMACH(14) /         94 /
C     DATA IMACH(15) /      -8099 /
C     DATA IMACH(16) /       8190 /
C
C     MACHINE CONSTANTS FOR THE DATA GENERAL ECLIPSE S/200
C
C     DATA IMACH( 1) /         11 /
C     DATA IMACH( 2) /         12 /
C     DATA IMACH( 3) /          8 /
C     DATA IMACH( 4) /         10 /
C     DATA IMACH( 5) /         16 /
C     DATA IMACH( 6) /          2 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         15 /
C     DATA IMACH( 9) /      32767 /
C     DATA IMACH(10) /         16 /
C     DATA IMACH(11) /          6 /
C     DATA IMACH(12) /        -64 /
C     DATA IMACH(13) /         63 /
C     DATA IMACH(14) /         14 /
C     DATA IMACH(15) /        -64 /
C     DATA IMACH(16) /         63 /
C
C     MACHINE CONSTANTS FOR THE DEC ALPHA
C     USING G_FLOAT
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1023 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE DEC ALPHA
C     USING IEEE_FLOAT
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE DEC RISC
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE DEC VAX
C     USING D_FLOATING
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         56 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE DEC VAX
C     USING G_FLOATING
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1023 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE ELXSI 6400
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         32 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -126 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1022 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE HARRIS 220
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          0 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         24 /
C     DATA IMACH( 6) /          3 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         23 /
C     DATA IMACH( 9) /    8388607 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         23 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         38 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE HONEYWELL 600/6000 SERIES
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /         43 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         36 /
C     DATA IMACH( 6) /          6 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         35 /
C     DATA IMACH( 9) / O377777777777 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         27 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         63 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE HP 730
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE HP 2100
C     3 WORD DOUBLE PRECISION OPTION WITH FTN4
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          4 /
C     DATA IMACH( 4) /          1 /
C     DATA IMACH( 5) /         16 /
C     DATA IMACH( 6) /          2 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         15 /
C     DATA IMACH( 9) /      32767 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         23 /
C     DATA IMACH(12) /       -128 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         39 /
C     DATA IMACH(15) /       -128 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE HP 2100
C     4 WORD DOUBLE PRECISION OPTION WITH FTN4
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          4 /
C     DATA IMACH( 4) /          1 /
C     DATA IMACH( 5) /         16 /
C     DATA IMACH( 6) /          2 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         15 /
C     DATA IMACH( 9) /      32767 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         23 /
C     DATA IMACH(12) /       -128 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         55 /
C     DATA IMACH(15) /       -128 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE HP 9000
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          7 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         32 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -126 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1015 /
C     DATA IMACH(16) /       1017 /
C
C     MACHINE CONSTANTS FOR THE IBM 360/370 SERIES,
C     THE XEROX SIGMA 5/7/9, THE SEL SYSTEMS 85/86, AND
C     THE PERKIN ELMER (INTERDATA) 7/32.
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          7 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) /  Z7FFFFFFF /
C     DATA IMACH(10) /         16 /
C     DATA IMACH(11) /          6 /
C     DATA IMACH(12) /        -64 /
C     DATA IMACH(13) /         63 /
C     DATA IMACH(14) /         14 /
C     DATA IMACH(15) /        -64 /
C     DATA IMACH(16) /         63 /
C
C     MACHINE CONSTANTS FOR THE IBM PC
C
      DATA IMACH( 1) /          5 /
      DATA IMACH( 2) /          6 /
      DATA IMACH( 3) /          0 /
      DATA IMACH( 4) /          0 /
      DATA IMACH( 5) /         32 /
      DATA IMACH( 6) /          4 /
      DATA IMACH( 7) /          2 /
      DATA IMACH( 8) /         31 /
      DATA IMACH( 9) / 2147483647 /
      DATA IMACH(10) /          2 /
      DATA IMACH(11) /         24 /
      DATA IMACH(12) /       -125 /
      DATA IMACH(13) /        127 /
      DATA IMACH(14) /         53 /
      DATA IMACH(15) /      -1021 /
      DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE IBM RS 6000
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          0 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE INTEL i860
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KA PROCESSOR)
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         36 /
C     DATA IMACH( 6) /          5 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         35 /
C     DATA IMACH( 9) / "377777777777 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         27 /
C     DATA IMACH(12) /       -128 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         54 /
C     DATA IMACH(15) /       -101 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KI PROCESSOR)
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         36 /
C     DATA IMACH( 6) /          5 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         35 /
C     DATA IMACH( 9) / "377777777777 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         27 /
C     DATA IMACH(12) /       -128 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         62 /
C     DATA IMACH(15) /       -128 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRAN SUPPORTING
C     32-BIT INTEGER ARITHMETIC.
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         56 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRAN SUPPORTING
C     16-BIT INTEGER ARITHMETIC.
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          5 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         16 /
C     DATA IMACH( 6) /          2 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         15 /
C     DATA IMACH( 9) /      32767 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         56 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C     MACHINE CONSTANTS FOR THE SILICON GRAPHICS
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE SUN
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -125 /
C     DATA IMACH(13) /        128 /
C     DATA IMACH(14) /         53 /
C     DATA IMACH(15) /      -1021 /
C     DATA IMACH(16) /       1024 /
C
C     MACHINE CONSTANTS FOR THE SUN
C     USING THE -r8 COMPILER OPTION
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          6 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         32 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         31 /
C     DATA IMACH( 9) / 2147483647 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         53 /
C     DATA IMACH(12) /      -1021 /
C     DATA IMACH(13) /       1024 /
C     DATA IMACH(14) /        113 /
C     DATA IMACH(15) /     -16381 /
C     DATA IMACH(16) /      16384 /
C
C     MACHINE CONSTANTS FOR THE UNIVAC 1100 SERIES FTN COMPILER
C
C     DATA IMACH( 1) /          5 /
C     DATA IMACH( 2) /          6 /
C     DATA IMACH( 3) /          1 /
C     DATA IMACH( 4) /          6 /
C     DATA IMACH( 5) /         36 /
C     DATA IMACH( 6) /          4 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         35 /
C     DATA IMACH( 9) / O377777777777 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         27 /
C     DATA IMACH(12) /       -128 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         60 /
C     DATA IMACH(15) /      -1024 /
C     DATA IMACH(16) /       1023 /
C
C     MACHINE CONSTANTS FOR THE Z80 MICROPROCESSOR
C
C     DATA IMACH( 1) /          1 /
C     DATA IMACH( 2) /          1 /
C     DATA IMACH( 3) /          0 /
C     DATA IMACH( 4) /          1 /
C     DATA IMACH( 5) /         16 /
C     DATA IMACH( 6) /          2 /
C     DATA IMACH( 7) /          2 /
C     DATA IMACH( 8) /         15 /
C     DATA IMACH( 9) /      32767 /
C     DATA IMACH(10) /          2 /
C     DATA IMACH(11) /         24 /
C     DATA IMACH(12) /       -127 /
C     DATA IMACH(13) /        127 /
C     DATA IMACH(14) /         56 /
C     DATA IMACH(15) /       -127 /
C     DATA IMACH(16) /        127 /
C
C***FIRST EXECUTABLE STATEMENT  I1MACH
      IF (I .LT. 1  .OR.  I .GT. 16) GO TO 10
C
      I1MACH = IMACH(I)
      RETURN
C
   10 CONTINUE
      WRITE (UNIT = OUTPUT, FMT = 9000)
 9000 FORMAT ('1ERROR    1 IN I1MACH - I OUT OF BOUNDS')
C
C     CALL FDUMP
C
      STOP
      END
*DECK D1MACH
      DOUBLE PRECISION FUNCTION D1MACH (I)
C***BEGIN PROLOGUE  D1MACH
C***PURPOSE  Return floating point machine dependent constants.
C***LIBRARY   SLATEC
C***CATEGORY  R1
C***TYPE      DOUBLE PRECISION (R1MACH-S, D1MACH-D)
C***KEYWORDS  MACHINE CONSTANTS
C***AUTHOR  Fox, P. A., (Bell Labs)
C           Hall, A. D., (Bell Labs)
C           Schryer, N. L., (Bell Labs)
C***DESCRIPTION
C
C   D1MACH can be used to obtain machine-dependent parameters for the
C   local machine environment.  It is a function subprogram with one
C   (input) argument, and can be referenced as follows:
C
C        D = D1MACH(I)
C
C   where I=1,...,5.  The (output) value of D above is determined by
C   the (input) value of I.  The results for various values of I are
C   discussed below.
C
C   D1MACH( 1) = B**(EMIN-1), the smallest positive magnitude.
C   D1MACH( 2) = B**EMAX*(1 - B**(-T)), the largest magnitude.
C   D1MACH( 3) = B**(-T), the smallest relative spacing.
C   D1MACH( 4) = B**(1-T), the largest relative spacing.
C   D1MACH( 5) = LOG10(B)
C
C   Assume double precision numbers are represented in the T-digit,
C   base-B form
C
C              sign (B**E)*( (X(1)/B) + ... + (X(T)/B**T) )
C
C   where 0 .LE. X(I) .LT. B for I=1,...,T, 0 .LT. X(1), and
C   EMIN .LE. E .LE. EMAX.
C
C   The values of B, T, EMIN and EMAX are provided in I1MACH as
C   follows:
C   I1MACH(10) = B, the base.
C   I1MACH(14) = T, the number of base-B digits.
C   I1MACH(15) = EMIN, the smallest exponent E.
C   I1MACH(16) = EMAX, the largest exponent E.
C
C   To alter this function for a particular environment, the desired
C   set of DATA statements should be activated by removing the C from
C   column 1.  Also, the values of D1MACH(1) - D1MACH(4) should be
C   checked for consistency with the local operating system.
C
C***REFERENCES  P. A. Fox, A. D. Hall and N. L. Schryer, Framework for
C                 a portable library, ACM Transactions on Mathematical
C                 Software 4, 2 (June 1978), pp. 177-188.
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   750101  DATE WRITTEN
C   890213  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900618  Added DEC RISC constants.  (WRB)
C   900723  Added IBM RS 6000 constants.  (WRB)
C   900911  Added SUN 386i constants.  (WRB)
C   910710  Added HP 730 constants.  (SMR)
C   911114  Added Convex IEEE constants.  (WRB)
C   920121  Added SUN -r8 compiler option constants.  (WRB)
C   920229  Added Touchstone Delta i860 constants.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C   920625  Added CONVEX -p8 and -pd8 compiler option constants.
C           (BKS, WRB)
C   930201  Added DEC Alpha and SGI constants.  (RWC and WRB)
C***END PROLOGUE  D1MACH
C
      INTEGER SMALL(4)
      INTEGER LARGE(4)
      INTEGER RIGHT(4)
      INTEGER DIVER(4)
      INTEGER LOG10(4)
C
      DOUBLE PRECISION DMACH(5)
      SAVE DMACH
C
      EQUIVALENCE (DMACH(1),SMALL(1))
      EQUIVALENCE (DMACH(2),LARGE(1))
      EQUIVALENCE (DMACH(3),RIGHT(1))
      EQUIVALENCE (DMACH(4),DIVER(1))
      EQUIVALENCE (DMACH(5),LOG10(1))
C
C     MACHINE CONSTANTS FOR THE AMIGA
C     ABSOFT FORTRAN COMPILER USING THE 68020/68881 COMPILER OPTION
C
C     DATA SMALL(1), SMALL(2) / Z'00100000', Z'00000000' /
C     DATA LARGE(1), LARGE(2) / Z'7FEFFFFF', Z'FFFFFFFF' /
C     DATA RIGHT(1), RIGHT(2) / Z'3CA00000', Z'00000000' /
C     DATA DIVER(1), DIVER(2) / Z'3CB00000', Z'00000000' /
C     DATA LOG10(1), LOG10(2) / Z'3FD34413', Z'509F79FF' /
C
C     MACHINE CONSTANTS FOR THE AMIGA
C     ABSOFT FORTRAN COMPILER USING SOFTWARE FLOATING POINT
C
C     DATA SMALL(1), SMALL(2) / Z'00100000', Z'00000000' /
C     DATA LARGE(1), LARGE(2) / Z'7FDFFFFF', Z'FFFFFFFF' /
C     DATA RIGHT(1), RIGHT(2) / Z'3CA00000', Z'00000000' /
C     DATA DIVER(1), DIVER(2) / Z'3CB00000', Z'00000000' /
C     DATA LOG10(1), LOG10(2) / Z'3FD34413', Z'509F79FF' /
C
C     MACHINE CONSTANTS FOR THE APOLLO
C
C     DATA SMALL(1), SMALL(2) / 16#00100000, 16#00000000 /
C     DATA LARGE(1), LARGE(2) / 16#7FFFFFFF, 16#FFFFFFFF /
C     DATA RIGHT(1), RIGHT(2) / 16#3CA00000, 16#00000000 /
C     DATA DIVER(1), DIVER(2) / 16#3CB00000, 16#00000000 /
C     DATA LOG10(1), LOG10(2) / 16#3FD34413, 16#509F79FF /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 1700 SYSTEM
C
C     DATA SMALL(1) / ZC00800000 /
C     DATA SMALL(2) / Z000000000 /
C     DATA LARGE(1) / ZDFFFFFFFF /
C     DATA LARGE(2) / ZFFFFFFFFF /
C     DATA RIGHT(1) / ZCC5800000 /
C     DATA RIGHT(2) / Z000000000 /
C     DATA DIVER(1) / ZCC6800000 /
C     DATA DIVER(2) / Z000000000 /
C     DATA LOG10(1) / ZD00E730E7 /
C     DATA LOG10(2) / ZC77800DC0 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 5700 SYSTEM
C
C     DATA SMALL(1) / O1771000000000000 /
C     DATA SMALL(2) / O0000000000000000 /
C     DATA LARGE(1) / O0777777777777777 /
C     DATA LARGE(2) / O0007777777777777 /
C     DATA RIGHT(1) / O1461000000000000 /
C     DATA RIGHT(2) / O0000000000000000 /
C     DATA DIVER(1) / O1451000000000000 /
C     DATA DIVER(2) / O0000000000000000 /
C     DATA LOG10(1) / O1157163034761674 /
C     DATA LOG10(2) / O0006677466732724 /
C
C     MACHINE CONSTANTS FOR THE BURROUGHS 6700/7700 SYSTEMS
C
C     DATA SMALL(1) / O1771000000000000 /
C     DATA SMALL(2) / O7770000000000000 /
C     DATA LARGE(1) / O0777777777777777 /
C     DATA LARGE(2) / O7777777777777777 /
C     DATA RIGHT(1) / O1461000000000000 /
C     DATA RIGHT(2) / O0000000000000000 /
C     DATA DIVER(1) / O1451000000000000 /
C     DATA DIVER(2) / O0000000000000000 /
C     DATA LOG10(1) / O1157163034761674 /
C     DATA LOG10(2) / O0006677466732724 /
C
C     MACHINE CONSTANTS FOR THE CDC 170/180 SERIES USING NOS/VE
C
C     DATA SMALL(1) / Z"3001800000000000" /
C     DATA SMALL(2) / Z"3001000000000000" /
C     DATA LARGE(1) / Z"4FFEFFFFFFFFFFFE" /
C     DATA LARGE(2) / Z"4FFE000000000000" /
C     DATA RIGHT(1) / Z"3FD2800000000000" /
C     DATA RIGHT(2) / Z"3FD2000000000000" /
C     DATA DIVER(1) / Z"3FD3800000000000" /
C     DATA DIVER(2) / Z"3FD3000000000000" /
C     DATA LOG10(1) / Z"3FFF9A209A84FBCF" /
C     DATA LOG10(2) / Z"3FFFF7988F8959AC" /
C
C     MACHINE CONSTANTS FOR THE CDC 6000/7000 SERIES
C
C     DATA SMALL(1) / 00564000000000000000B /
C     DATA SMALL(2) / 00000000000000000000B /
C     DATA LARGE(1) / 37757777777777777777B /
C     DATA LARGE(2) / 37157777777777777777B /
C     DATA RIGHT(1) / 15624000000000000000B /
C     DATA RIGHT(2) / 00000000000000000000B /
C     DATA DIVER(1) / 15634000000000000000B /
C     DATA DIVER(2) / 00000000000000000000B /
C     DATA LOG10(1) / 17164642023241175717B /
C     DATA LOG10(2) / 16367571421742254654B /
C
C     MACHINE CONSTANTS FOR THE CELERITY C1260
C
C     DATA SMALL(1), SMALL(2) / Z'00100000', Z'00000000' /
C     DATA LARGE(1), LARGE(2) / Z'7FEFFFFF', Z'FFFFFFFF' /
C     DATA RIGHT(1), RIGHT(2) / Z'3CA00000', Z'00000000' /
C     DATA DIVER(1), DIVER(2) / Z'3CB00000', Z'00000000' /
C     DATA LOG10(1), LOG10(2) / Z'3FD34413', Z'509F79FF' /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -fn OR -pd8 COMPILER OPTION
C
C     DATA DMACH(1) / Z'0010000000000000' /
C     DATA DMACH(2) / Z'7FFFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3CC0000000000000' /
C     DATA DMACH(4) / Z'3CD0000000000000' /
C     DATA DMACH(5) / Z'3FF34413509F79FF' /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -fi COMPILER OPTION
C
C     DATA DMACH(1) / Z'0010000000000000' /
C     DATA DMACH(2) / Z'7FEFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3CA0000000000000' /
C     DATA DMACH(4) / Z'3CB0000000000000' /
C     DATA DMACH(5) / Z'3FD34413509F79FF' /
C
C     MACHINE CONSTANTS FOR THE CONVEX
C     USING THE -p8 COMPILER OPTION
C
C     DATA DMACH(1) / Z'00010000000000000000000000000000' /
C     DATA DMACH(2) / Z'7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3F900000000000000000000000000000' /
C     DATA DMACH(4) / Z'3F910000000000000000000000000000' /
C     DATA DMACH(5) / Z'3FFF34413509F79FEF311F12B35816F9' /
C
C     MACHINE CONSTANTS FOR THE CRAY
C
C     DATA SMALL(1) / 201354000000000000000B /
C     DATA SMALL(2) / 000000000000000000000B /
C     DATA LARGE(1) / 577767777777777777777B /
C     DATA LARGE(2) / 000007777777777777774B /
C     DATA RIGHT(1) / 376434000000000000000B /
C     DATA RIGHT(2) / 000000000000000000000B /
C     DATA DIVER(1) / 376444000000000000000B /
C     DATA DIVER(2) / 000000000000000000000B /
C     DATA LOG10(1) / 377774642023241175717B /
C     DATA LOG10(2) / 000007571421742254654B /
C
C     MACHINE CONSTANTS FOR THE DATA GENERAL ECLIPSE S/200
C     NOTE - IT MAY BE APPROPRIATE TO INCLUDE THE FOLLOWING CARD -
C     STATIC DMACH(5)
C
C     DATA SMALL /    20K, 3*0 /
C     DATA LARGE / 77777K, 3*177777K /
C     DATA RIGHT / 31420K, 3*0 /
C     DATA DIVER / 32020K, 3*0 /
C     DATA LOG10 / 40423K, 42023K, 50237K, 74776K /
C
C     MACHINE CONSTANTS FOR THE DEC ALPHA
C     USING G_FLOAT
C
C     DATA DMACH(1) / '0000000000000010'X /
C     DATA DMACH(2) / 'FFFFFFFFFFFF7FFF'X /
C     DATA DMACH(3) / '0000000000003CC0'X /
C     DATA DMACH(4) / '0000000000003CD0'X /
C     DATA DMACH(5) / '79FF509F44133FF3'X /
C
C     MACHINE CONSTANTS FOR THE DEC ALPHA
C     USING IEEE_FORMAT
C
C     DATA DMACH(1) / '0010000000000000'X /
C     DATA DMACH(2) / '7FEFFFFFFFFFFFFF'X /
C     DATA DMACH(3) / '3CA0000000000000'X /
C     DATA DMACH(4) / '3CB0000000000000'X /
C     DATA DMACH(5) / '3FD34413509F79FF'X /
C
C     MACHINE CONSTANTS FOR THE DEC RISC
C
C     DATA SMALL(1), SMALL(2) / Z'00000000', Z'00100000'/
C     DATA LARGE(1), LARGE(2) / Z'FFFFFFFF', Z'7FEFFFFF'/
C     DATA RIGHT(1), RIGHT(2) / Z'00000000', Z'3CA00000'/
C     DATA DIVER(1), DIVER(2) / Z'00000000', Z'3CB00000'/
C     DATA LOG10(1), LOG10(2) / Z'509F79FF', Z'3FD34413'/
C
C     MACHINE CONSTANTS FOR THE DEC VAX
C     USING D_FLOATING
C     (EXPRESSED IN INTEGER AND HEXADECIMAL)
C     THE HEX FORMAT BELOW MAY NOT BE SUITABLE FOR UNIX SYSTEMS
C     THE INTEGER FORMAT SHOULD BE OK FOR UNIX SYSTEMS
C
C     DATA SMALL(1), SMALL(2) /        128,           0 /
C     DATA LARGE(1), LARGE(2) /     -32769,          -1 /
C     DATA RIGHT(1), RIGHT(2) /       9344,           0 /
C     DATA DIVER(1), DIVER(2) /       9472,           0 /
C     DATA LOG10(1), LOG10(2) /  546979738,  -805796613 /
C
C     DATA SMALL(1), SMALL(2) / Z00000080, Z00000000 /
C     DATA LARGE(1), LARGE(2) / ZFFFF7FFF, ZFFFFFFFF /
C     DATA RIGHT(1), RIGHT(2) / Z00002480, Z00000000 /
C     DATA DIVER(1), DIVER(2) / Z00002500, Z00000000 /
C     DATA LOG10(1), LOG10(2) / Z209A3F9A, ZCFF884FB /
C
C     MACHINE CONSTANTS FOR THE DEC VAX
C     USING G_FLOATING
C     (EXPRESSED IN INTEGER AND HEXADECIMAL)
C     THE HEX FORMAT BELOW MAY NOT BE SUITABLE FOR UNIX SYSTEMS
C     THE INTEGER FORMAT SHOULD BE OK FOR UNIX SYSTEMS
C
C     DATA SMALL(1), SMALL(2) /         16,           0 /
C     DATA LARGE(1), LARGE(2) /     -32769,          -1 /
C     DATA RIGHT(1), RIGHT(2) /      15552,           0 /
C     DATA DIVER(1), DIVER(2) /      15568,           0 /
C     DATA LOG10(1), LOG10(2) /  1142112243, 2046775455 /
C
C     DATA SMALL(1), SMALL(2) / Z00000010, Z00000000 /
C     DATA LARGE(1), LARGE(2) / ZFFFF7FFF, ZFFFFFFFF /
C     DATA RIGHT(1), RIGHT(2) / Z00003CC0, Z00000000 /
C     DATA DIVER(1), DIVER(2) / Z00003CD0, Z00000000 /
C     DATA LOG10(1), LOG10(2) / Z44133FF3, Z79FF509F /
C
C     MACHINE CONSTANTS FOR THE ELXSI 6400
C     (ASSUMING REAL*8 IS THE DEFAULT DOUBLE PRECISION)
C
C     DATA SMALL(1), SMALL(2) / '00100000'X,'00000000'X /
C     DATA LARGE(1), LARGE(2) / '7FEFFFFF'X,'FFFFFFFF'X /
C     DATA RIGHT(1), RIGHT(2) / '3CB00000'X,'00000000'X /
C     DATA DIVER(1), DIVER(2) / '3CC00000'X,'00000000'X /
C     DATA LOG10(1), LOG10(2) / '3FD34413'X,'509F79FF'X /
C
C     MACHINE CONSTANTS FOR THE HARRIS 220
C
C     DATA SMALL(1), SMALL(2) / '20000000, '00000201 /
C     DATA LARGE(1), LARGE(2) / '37777777, '37777577 /
C     DATA RIGHT(1), RIGHT(2) / '20000000, '00000333 /
C     DATA DIVER(1), DIVER(2) / '20000000, '00000334 /
C     DATA LOG10(1), LOG10(2) / '23210115, '10237777 /
C
C     MACHINE CONSTANTS FOR THE HONEYWELL 600/6000 SERIES
C
C     DATA SMALL(1), SMALL(2) / O402400000000, O000000000000 /
C     DATA LARGE(1), LARGE(2) / O376777777777, O777777777777 /
C     DATA RIGHT(1), RIGHT(2) / O604400000000, O000000000000 /
C     DATA DIVER(1), DIVER(2) / O606400000000, O000000000000 /
C     DATA LOG10(1), LOG10(2) / O776464202324, O117571775714 /
C
C     MACHINE CONSTANTS FOR THE HP 730
C
C     DATA DMACH(1) / Z'0010000000000000' /
C     DATA DMACH(2) / Z'7FEFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3CA0000000000000' /
C     DATA DMACH(4) / Z'3CB0000000000000' /
C     DATA DMACH(5) / Z'3FD34413509F79FF' /
C
C     MACHINE CONSTANTS FOR THE HP 2100
C     THREE WORD DOUBLE PRECISION OPTION WITH FTN4
C
C     DATA SMALL(1), SMALL(2), SMALL(3) / 40000B,       0,       1 /
C     DATA LARGE(1), LARGE(2), LARGE(3) / 77777B, 177777B, 177776B /
C     DATA RIGHT(1), RIGHT(2), RIGHT(3) / 40000B,       0,    265B /
C     DATA DIVER(1), DIVER(2), DIVER(3) / 40000B,       0,    276B /
C     DATA LOG10(1), LOG10(2), LOG10(3) / 46420B,  46502B,  77777B /
C
C     MACHINE CONSTANTS FOR THE HP 2100
C     FOUR WORD DOUBLE PRECISION OPTION WITH FTN4
C
C     DATA SMALL(1), SMALL(2) /  40000B,       0 /
C     DATA SMALL(3), SMALL(4) /       0,       1 /
C     DATA LARGE(1), LARGE(2) /  77777B, 177777B /
C     DATA LARGE(3), LARGE(4) / 177777B, 177776B /
C     DATA RIGHT(1), RIGHT(2) /  40000B,       0 /
C     DATA RIGHT(3), RIGHT(4) /       0,    225B /
C     DATA DIVER(1), DIVER(2) /  40000B,       0 /
C     DATA DIVER(3), DIVER(4) /       0,    227B /
C     DATA LOG10(1), LOG10(2) /  46420B,  46502B /
C     DATA LOG10(3), LOG10(4) /  76747B, 176377B /
C
C     MACHINE CONSTANTS FOR THE HP 9000
C
C     DATA SMALL(1), SMALL(2) / 00040000000B, 00000000000B /
C     DATA LARGE(1), LARGE(2) / 17737777777B, 37777777777B /
C     DATA RIGHT(1), RIGHT(2) / 07454000000B, 00000000000B /
C     DATA DIVER(1), DIVER(2) / 07460000000B, 00000000000B /
C     DATA LOG10(1), LOG10(2) / 07764642023B, 12047674777B /
C
C     MACHINE CONSTANTS FOR THE IBM 360/370 SERIES,
C     THE XEROX SIGMA 5/7/9, THE SEL SYSTEMS 85/86, AND
C     THE PERKIN ELMER (INTERDATA) 7/32.
C
C     DATA SMALL(1), SMALL(2) / Z00100000, Z00000000 /
C     DATA LARGE(1), LARGE(2) / Z7FFFFFFF, ZFFFFFFFF /
C     DATA RIGHT(1), RIGHT(2) / Z33100000, Z00000000 /
C     DATA DIVER(1), DIVER(2) / Z34100000, Z00000000 /
C     DATA LOG10(1), LOG10(2) / Z41134413, Z509F79FF /
C
C     MACHINE CONSTANTS FOR THE IBM PC
C     ASSUMES THAT ALL ARITHMETIC IS DONE IN DOUBLE PRECISION
C     ON 8088, I.E., NOT IN 80 BIT FORM FOR THE 8087.
C
c      DATA SMALL(1) / 2.23D-308  /
c      DATA LARGE(1) / 1.79D+308  /
c
c      DATA RIGHT(1) / 1.11D-16   /
c      DATA DIVER(1) / 2.22D-16   /
c      DATA LOG10(1) / 0.301029995663981195D0 /
C
C     MACHINE CONSTANTS FOR THE IBM RS 6000
C
      DATA DMACH(1) / Z'0010000000000000' /
      DATA DMACH(2) / Z'7FEFFFFFFFFFFFFF' /
      DATA DMACH(3) / Z'3CA0000000000000' /
      DATA DMACH(4) / Z'3CB0000000000000' /
      DATA DMACH(5) / Z'3FD34413509F79FF' /
C
C     MACHINE CONSTANTS FOR THE INTEL i860
C
C     DATA DMACH(1) / Z'0010000000000000' /
C     DATA DMACH(2) / Z'7FEFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3CA0000000000000' /
C     DATA DMACH(4) / Z'3CB0000000000000' /
C     DATA DMACH(5) / Z'3FD34413509F79FF' /
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KA PROCESSOR)
C
C     DATA SMALL(1), SMALL(2) / "033400000000, "000000000000 /
C     DATA LARGE(1), LARGE(2) / "377777777777, "344777777777 /
C     DATA RIGHT(1), RIGHT(2) / "113400000000, "000000000000 /
C     DATA DIVER(1), DIVER(2) / "114400000000, "000000000000 /
C     DATA LOG10(1), LOG10(2) / "177464202324, "144117571776 /
C
C     MACHINE CONSTANTS FOR THE PDP-10 (KI PROCESSOR)
C
C     DATA SMALL(1), SMALL(2) / "000400000000, "000000000000 /
C     DATA LARGE(1), LARGE(2) / "377777777777, "377777777777 /
C     DATA RIGHT(1), RIGHT(2) / "103400000000, "000000000000 /
C     DATA DIVER(1), DIVER(2) / "104400000000, "000000000000 /
C     DATA LOG10(1), LOG10(2) / "177464202324, "476747767461 /
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRAN SUPPORTING
C     32-BIT INTEGERS (EXPRESSED IN INTEGER AND OCTAL).
C
C     DATA SMALL(1), SMALL(2) /    8388608,           0 /
C     DATA LARGE(1), LARGE(2) / 2147483647,          -1 /
C     DATA RIGHT(1), RIGHT(2) /  612368384,           0 /
C     DATA DIVER(1), DIVER(2) /  620756992,           0 /
C     DATA LOG10(1), LOG10(2) / 1067065498, -2063872008 /
C
C     DATA SMALL(1), SMALL(2) / O00040000000, O00000000000 /
C     DATA LARGE(1), LARGE(2) / O17777777777, O37777777777 /
C     DATA RIGHT(1), RIGHT(2) / O04440000000, O00000000000 /
C     DATA DIVER(1), DIVER(2) / O04500000000, O00000000000 /
C     DATA LOG10(1), LOG10(2) / O07746420232, O20476747770 /
C
C     MACHINE CONSTANTS FOR PDP-11 FORTRAN SUPPORTING
C     16-BIT INTEGERS (EXPRESSED IN INTEGER AND OCTAL).
C
C     DATA SMALL(1), SMALL(2) /    128,      0 /
C     DATA SMALL(3), SMALL(4) /      0,      0 /
C     DATA LARGE(1), LARGE(2) /  32767,     -1 /
C     DATA LARGE(3), LARGE(4) /     -1,     -1 /
C     DATA RIGHT(1), RIGHT(2) /   9344,      0 /
C     DATA RIGHT(3), RIGHT(4) /      0,      0 /
C     DATA DIVER(1), DIVER(2) /   9472,      0 /
C     DATA DIVER(3), DIVER(4) /      0,      0 /
C     DATA LOG10(1), LOG10(2) /  16282,   8346 /
C     DATA LOG10(3), LOG10(4) / -31493, -12296 /
C
C     DATA SMALL(1), SMALL(2) / O000200, O000000 /
C     DATA SMALL(3), SMALL(4) / O000000, O000000 /
C     DATA LARGE(1), LARGE(2) / O077777, O177777 /
C     DATA LARGE(3), LARGE(4) / O177777, O177777 /
C     DATA RIGHT(1), RIGHT(2) / O022200, O000000 /
C     DATA RIGHT(3), RIGHT(4) / O000000, O000000 /
C     DATA DIVER(1), DIVER(2) / O022400, O000000 /
C     DATA DIVER(3), DIVER(4) / O000000, O000000 /
C     DATA LOG10(1), LOG10(2) / O037632, O020232 /
C     DATA LOG10(3), LOG10(4) / O102373, O147770 /
C
C     MACHINE CONSTANTS FOR THE SILICON GRAPHICS
C
C     DATA SMALL(1), SMALL(2) / Z'00100000', Z'00000000' /
C     DATA LARGE(1), LARGE(2) / Z'7FEFFFFF', Z'FFFFFFFF' /
C     DATA RIGHT(1), RIGHT(2) / Z'3CA00000', Z'00000000' /
C     DATA DIVER(1), DIVER(2) / Z'3CB00000', Z'00000000' /
C     DATA LOG10(1), LOG10(2) / Z'3FD34413', Z'509F79FF' /
C
C     MACHINE CONSTANTS FOR THE SUN
C
C     DATA DMACH(1) / Z'0010000000000000' /
C     DATA DMACH(2) / Z'7FEFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3CA0000000000000' /
C     DATA DMACH(4) / Z'3CB0000000000000' /
C     DATA DMACH(5) / Z'3FD34413509F79FF' /
C
C     MACHINE CONSTANTS FOR THE SUN
C     USING THE -r8 COMPILER OPTION
C
C     DATA DMACH(1) / Z'00010000000000000000000000000000' /
C     DATA DMACH(2) / Z'7FFEFFFFFFFFFFFFFFFFFFFFFFFFFFFF' /
C     DATA DMACH(3) / Z'3F8E0000000000000000000000000000' /
C     DATA DMACH(4) / Z'3F8F0000000000000000000000000000' /
C     DATA DMACH(5) / Z'3FFD34413509F79FEF311F12B35816F9' /
C
C     MACHINE CONSTANTS FOR THE SUN 386i
C
C     DATA SMALL(1), SMALL(2) / Z'FFFFFFFD', Z'000FFFFF' /
C     DATA LARGE(1), LARGE(2) / Z'FFFFFFB0', Z'7FEFFFFF' /
C     DATA RIGHT(1), RIGHT(2) / Z'000000B0', Z'3CA00000' /
C     DATA DIVER(1), DIVER(2) / Z'FFFFFFCB', Z'3CAFFFFF'
C     DATA LOG10(1), LOG10(2) / Z'509F79E9', Z'3FD34413' /
C
C     MACHINE CONSTANTS FOR THE UNIVAC 1100 SERIES FTN COMPILER
C
C     DATA SMALL(1), SMALL(2) / O000040000000, O000000000000 /
C     DATA LARGE(1), LARGE(2) / O377777777777, O777777777777 /
C     DATA RIGHT(1), RIGHT(2) / O170540000000, O000000000000 /
C     DATA DIVER(1), DIVER(2) / O170640000000, O000000000000 /
C     DATA LOG10(1), LOG10(2) / O177746420232, O411757177572 /
C
C***FIRST EXECUTABLE STATEMENT  D1MACH
      IF (I .LT. 1 .OR. I .GT. 5) write (*,*)   'D1MACH',
     +   'I OUT OF BOUNDS'
C
      D1MACH = DMACH(I)
      RETURN
C
      END

C ______________________________	
       INCLUDE 'PMbox.h'
       REAL     INPUT
       Character*90 Line
       PI =3.1415926535
C...................................................................
C			Read data and open files
       
      Box =160.      
      BoxV =Box*100.    ! Box size in km/s
      write(*,*) ' Enter: Center(xyz) Radius N_part_limit V_circ_limit '
      read (*,*) Xc,Yc,Zc,Rsphere,N_plim,V_clim
c      Open(1,file='Catshort.999.small.DAT')
      Open(1,file='Catshort.DAT')
      open(18,file='Box.dat')
      CALL ReadHalos(N_plim,V_clim)

c      CALL CONE(ux,uy,uz,ACone,ScaleC)
      CALL SPHERE(Rsphere,Xc,Yc,Zc)
c      CALL DumpParticles(z0,dz0,ScaleC)
      STOP
      END


C---------------------------------------
C                                                       Read Particles 
      SUBROUTINE ReadHalos(N_plim,V_clim)
C---------------------------------------
      INCLUDE 'PMbox.h'
      Character*90 Line
      Lines_header =20
      Do i=1,Lines_header
         Read(1,'(A)') Line
         If(i.le.4)write(18,'(A)') Line
         write(*,'(A)') Line
      ENDDO 
      Nh =0
 10   read(1,*,err=20,end=20) a,x,y,z,vvx,vvy,vvz,am,ar,v1,v2,n1,n2
      If(n2.ge.N_plim.and.v2.ge.V_clim) Then    ! take the halo
         Nh =Nh + 1
         Xm(Nh) =x
         Ym(Nh) =y
         Zm(Nh) =z
         Vx(Nh) =vvx
         Vy(Nh) =vvy
         Vz(Nh) =vvz
         Amc(Nh) =am
         Rmc(Nh) =ar
         Vrm(Nh) =v2
      Endif
      goto 10
 20   write (*,*)'Number of halos read =',Nh,' Np>',N_plim,' Vc>',V_clim
        RETURN
      END
C---------------------------------------
C                              Particles in a sphere
      SUBROUTINE Sphere(Rsphere,Xc,Yc,Zc)
C---------------------------------------
C                 Find points close to the center
      INCLUDE 'PMbox.h'
      write (*,*) ' Center=',Xc,Yc,Zc,' R=',Rsphere

      V  =0.
      V2 =0.
      Vm =0.
      Vm2=0.
      Nn  = 0
      R2 = Rsphere**2
      Ic =0
      Vvx =0.
      Vvy =0.
      Vvz =0.
      Vcx =-215.1
      Vcy =72.3
      Vcz =-5.6
	   DO   IN=1,Nh              ! find central halo
	        dX=(Xm(IN)-Xc)            
	        dY=(Ym(IN)-Yc)
	        dZ=(Zm(IN)-Zc)
           dd =dX**2 +dY**2 +dZ**2
c           write (*,50)IN,Xm(IN),Ym(IN),Zm(IN),dX,dY,dZ
c 50        format(i5,3f8.2,3g11.3)
           If(dd.lt.R2)Then
                Nn =Nn +1
                Vvx =Vvx +Vx(IN)
                Vvy =Vvy +Vy(IN)
                Vvz =Vvz +Vz(IN)
c             If(dd.lt.1.e-4)Then 
c                Ic  =IN
c                Vcx =Vx(Ic)
c                Vcy =Vy(Ic)
c                Vcz =Vz(Ic)
c            Endif
            EndIf
         ENDDO 
         If(Nn.le.1)Then
            write(*,*) '    Too few halos inside the radius: ',Nn
            stop
         Endif
         Vvx =Vvx/Nn
         Vvy =Vvy/Nn
         Vvz =Vvz/Nn
         If(Ic.eq.0)Then     ! no center halo was found
            Vcx =Vvx
            Vcy =Vvy
            Vcz =Vvz
         endif 

         Nc = 0
	   DO   IN=1,Nh            ! Main statistics
	        dX=(Xm(IN)-Xc)            
	        dY=(Ym(IN)-Yc)
	        dZ=(Zm(IN)-Zc)
             dd =dX**2 +dY**2 +dZ**2
             If(dd.lt.R2.and.dd.gt.1.e-4)Then
                d   = max(sqrt(dd+1.e-10),1.e-10)
                Nc =Nc +1
                wx =Vx(IN)-Vcx
                wy =Vy(IN)-Vcy
                wz =Vz(IN)-Vcz
                vr  =(dX*wx+dY*wy+dZ*wz)/d
                ww =sqrt(wx**2+wy**2+wz**2)
c                Xn =dX*(1.+vr/100./d)+Xc
c                Yn =dY*(1.+vr/100./d)+Yc
c                Zn =dZ*(1.+vr/100./d)+Zc
                
                write (*,90)d,ww,vr,100.*d+vr,Amc(IN),Vrm(IN)
 90           format(f8.3,f9.2,2f8.2,
     &              g11.3,f7.2)
                V2 = V2   + ww**2
                Vm2= Vm2  + vr**2
             endif 
      Enddo 

      write (*,*) ' There are ',Nc,' particles inside R=',Rsphere
      write (*,*)
     &               ' Center(Mpc/h) =',Xc,Yc,Zc
      write (*,*)
     &               ' V(km/s)=', Vcx, Vcy, Vcz
      write (*,*) ' Rms Radial velocity=',sqrt(Vm2/Nc),
     &               ' Rms total velocity=',sqrt(V2/Nc)
      Return
      End
C---------------------------------------
C                            write particles in a slice
      SUBROUTINE DumpParticles(z0,dz0,ScaleC)
C---------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMfields.h'
C                 Find points close to the center
      Xc =NGRID/2.+1.
      Yc =NGRID/2.+1.
      Zc =NGRID/2.+1.
      Rc =1.
 10   R2 =Rc**2
C				       Loop over particles
      Nc =0
      Vxc =0.
      Vyc =0.
      Vzc =0.
	   DO   IN=1,Np
	        dX=(Xp(IN)-Xc)            !coords
	        dY=(Yp(IN)-Yc)
	        dZ=(Zp(IN)-Zc)
           dd =dX**2 +dY**2 +dZ**2
             If(dd.lt.R2)Then
                Nc =Nc+1
                Vxc =Vxc +Vxp(IN)
                Vyc =Vyc +Vyp(IN)
                Vzc =Vzc +Vzp(IN)
             endif 
      Enddo 
      If(Nc.eq.0)Then
         Rcold =Rc
         Rc       =Rc*1.2
         write (*,*) ' Too small radius=',Rcold,' Increase it to ',Rc
         goto 10
      endif 
      Vxc =Vxc/Nc
      Vyc =Vyc/Nc
      Vzc =Vzc/Nc
      Xc   =ScaleC*(Xc-1.)
      Yc   =ScaleC*(Yc-1.)
      Zc   =ScaleC*(Zc-1.)

      write (*,*) ' There are ',Nc,' particles inside Rc=',Rc*ScaleC,
     &               ' Center(Mpc/h) =',Xc,
     &               Yc,Zc,
     &               ' V(km/s)=', Vxc, Vyc, Vzc
C				       Loop over particles
	   DO   IN=1,Np
	        X=ScaleC*(Xp(IN)-1.)            !coords
	        Y=ScaleC*(Yp(IN)-1.)
	        Z=ScaleC*(Zp(IN)-1.)
             If(Z.gt.z0.and.Z.lt.z0+dz0)Then
	        dX=(X-Xc)            !coords
	        dY=(Y-Yc)
	        dZ=(Z-Zc)
              dd =dX**2 +dY**2 +dZ**2
              d   =max(sqrt(dd+1.e-10),1.e-10)
                ux =Vxp(IN)-Vxc
                uy =Vyp(IN)-Vyc
                uz =Vzp(IN)-Vxc
                vr  =(dX*ux+dY*uy+dZ*uz)/d
                Xn =dX*(1.+vr/100./d)+Xc
                Yn =dY*(1.+vr/100./d)+Yc
                Zn =dZ*(1.+vr/100./d)+Zc

                write (18,100) X,Y,Z,ux,uy,uz,Wp(IN),vr,
     &                 Xn,Yn,Zn
 100            format(3f8.3,3f8.1,g11.3,4f8.3)
             endif 
      Enddo 
      Return
      End
C---------------------------------------
C                          Rotate around Y-axis by angle alpha
      SUBROUTINE RotateYParticles(alpha)
C---------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMfields.h'
      XN =NGRID+1
c      XC =(NGRID+1.)/2.     ! center of rotation
c      ZC =(NGRID+1.)/2.
      cosA =cos(alpha*3.1415926/180.)
      sinA =sin(alpha*3.1415926/180.)
C				       Loop over particles
	   DO   IN=1,Np
	        X=Xp(IN) -XC            !coords
	        Y=Yp(IN)
	        Z=Zp(IN) -ZC
           Xnew =X*cosA -Z*sinA + XC
           Znew =Z*cosA +X*sinA + ZC
           Vxp(IN) =Vxp(IN)*cosA-Vzp(IN)*sinA
           Vyp(IN) =Vyp(IN) 
           Vzp(IN) =Vzp(IN)*cosA+Vxp(IN)*sinA
           
           X =Xnew
              If(X.ge.XN)X=X-NGRID
              If(X.lt.1.)X=X+NGRID
           Z =Znew
              If(Z.ge.XN)Z=Z-NGRID
              If(Z.lt.1.)Z=Z+NGRID
           Xp(IN) =X
           Yp(IN) =Y
           Zp(IN) =Z

      Enddo 
      Return
      End
C---------------------------------------
C                          Shift particles with periodical conditions
      SUBROUTINE ShiftParticles(xsh,ysh,zsh)
C---------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMfields.h'
      XN =NGRID+1
C				       Loop over particles
	   DO   IN=1,Np
	        X=Xp(IN)             !coords
	        Y=Yp(IN)
	        Z=Zp(IN)
           X =X+xsh
              If(X.ge.XN)X=X-NGRID
              If(X.lt.1.)X=X+NGRID
           Y =Y+ysh
              If(Y.ge.XN)Y=Y-NGRID
              If(Y.lt.1.)Y=Y+NGRID
           Z =Z+zsh
              If(Z.ge.XN)Z=Z-NGRID
              If(Z.lt.1.)Z=Z+NGRID
           Xp(IN) =X
           Yp(IN) =Y
           Zp(IN) =Z
c           Vxpb(IN) =Vxp(IN)
c           Vypb(IN) =Vyp(IN) 
c           Vzpb(IN) =Vzp(IN)

      Enddo 
      Return
      End
C---------------------------------- Read in variables      
      REAL FUNCTION INPUT(text)
C------------------------------------------------
      Character text*(*)
          write (*,'(A,$)')text
          read (*,*) x
          INPUT =x
      Return
      End

C _______________________ START 3-D SIMULATIONS
C
C                         Klypin, Jenuary 1997
C
      INCLUDE 'PMparameters.h'
C		   NROW = number of particles per row
C		   NGRID= number of cells on a side (normal grid)
C		   Npage =  number of points per page of the grid
C
      COMMON / GRID/	GRX(NROW,NROW,NROW),GRY(NROW,NROW,NROW),
     +			GRZ(NROW,NROW,NROW)
      COMMON / GRIV/	GVX(NROW,NROW,NROW),GVY(NROW,NROW,NROW),
     +			GVZ(NROW,NROW,NROW)
      COMMON / ROW2/	XPAR2(NPAGE),YPAR2(NPAGE),ZPAR2(NPAGE),
     +			VX2(NPAGE),VY2(NPAGE),VZ2(NPAGE)
      COMMON / KINENRG/ SKINE,SX,SY,SZ,SX2,SY2,SZ2
      DATA PI		/3.1415926535/
      CALL InitValues(NBYTE,SCALEL)  ! Set parameters of the run
         write (*,*) '  InitValues is done. N bytes=',NBYTE
         write (*,*) '  Nspecies =',Nspecies
         write (16,*) ' Seed=',Nseed
      OPEN(UNIT=9,FILE='PMcrd.DAT',form='unformatted')
      write (9)                ! this   clears old header file
      CLOSE (9)
      CALL RDTAPE                  ! this opens files on disk         
      OPEN(UNIT=16,FILE='RESNEW.DAT') ! open protocol
C
        AEXP0 = AEXPN            ! expansion parameter for coords
        AEXPV = AEXPN - ASTEP/2. !                     for veloc
C----                        Cold Particles --------------------------      
        NRAND =Nseed             ! store the initial seed
      CALL SPECTR(ALPHA,NRAND) ! get a realization of spectrum
        IFOUR = INT(ALOG(FLOAT(NROW))/ALOG(2.)+0.5)
        write (*,*) ' Ifour =',IFOUR,' Nrow=',NROW
      CALL VECTOR(IFOUR)       ! get displacement vector by FFT
   	write (*,*) ' SPECTR is done. IFOUR = ',IFOUR,' Alpha=',ALPHA
        VCONS = -ALPHA/(2.*PI/NGRID)*(AEXPV/AEXP0)*SQRT(AEXPV)
        XCONS =	ALPHA/(2.*PI/NGRID)*(AEXPN/AEXP0)
        QFACT = FLOAT(NGRID)/FLOAT(NROW)
        write (*,*) ' Aexp=',AEXPN,AEXP0,AEXPV,ASTEP
                      SKINE = 0.   ! set counters to zero
                      SX    = 0.
                      SY    = 0.
                      SZ    = 0.
                      SX2   = 0.
                      SY2   = 0.
                      SZ2   = 0.
      DO  KROW = 1, NROW  ! find x,v and write to file, page by page
	     CALL SETXV(XCONS,VCONS,KROW)
	     CALL WRIROW(KROW,1)
      ENDDO
      EKIN = 0.5*SKINE/AEXPV**2*PARTW !kinet.energy at A(i-1/2)
      DP   = NROW**3
      SX   = SX/DP                    ! mean displacement
      SY   = SY/DP
      SZ   = SZ/DP
      SX2  = SQRT(SX2/DP)             ! rms displacement
      SY2  = SQRT(SY2/DP)
      SZ2  = SQRT(SZ2/DP)
      WRITE (*,'('' Displacement of a particle: MEAN'',3F9.4)')
     .	     SX,SY,SZ
      WRITE (*,'(''                             RMS '',3F9.4)')
     .	     SX2,SY2,SZ2
      WRITE (16,'('' Displacement of a particle: MEAN'',3F9.4)')
     .	     SX2,SY2,SZ2
      Veloc=sqrt( SKINE/AEXPV**2/NROW**3)*SCALEL/NGRID*50.
      WRITE (*,'('' Ekin='',E12.4,'' Veloc_cold(km/s)='',F8.2)')
     .       EKIN,Veloc
      WRITE (16,'('' Ekin='',E12.4,'' Veloc_cold(km/s)='',F8.2)')
     .       EKIN,Veloc

C----                        Neutrino ------------------------------      
        NRAND =Nseed       !  Restore initial seed
      CALL SPECNU(NRAND) !  Renormalize the spectrum for neutrino
      CALL VECTOR(IFOUR) !   get displacement vector by FFT
	     write (*,*) ' Neutrino SPECTRUM is done.'
C			     find x,v and write to file, page by page
         Svel =SKINE
         SKINE=0.
         DO  KROW = 1, NROW
           Do js=1,Nspecies,2
              CALL SETXVN(XCONS,VCONS,KROW,NRAND)
              CALL WRIROW(KROW,js+1)
              If(Nspecies.ne.js)Then ! write another pair of
                 Do I=1,NPAGE        ! particles
                    XPAR(I)=XPAR2(I)
                    YPAR(I)=YPAR2(I)
                    ZPAR(I)=ZPAR2(I)
                    VX(I)  =VX2(I)
                    VY(I)  =VY2(I)
                    VZ(I)  =VZ2(I)
                 EndDo
                 CALL WRIROW(KROW,js+2)
              EndIf
           EndDo
         ENDDO
      W    = (FLOAT(NGRID)/FLOAT(NROW))**3         
      EKIN = 0.5*(Svel*PARTW+SKINE*(W-PARTW)/Nspecies)/AEXPV**2
      Veloc= sqrt( SKINE/AEXPV**2/NROW**3/Float(Nspecies))
     .           *SCALEL/NGRID*50. 
      WRITE (16,'('' Ekin='',E12.4,'' Veloc_hot(km/s)='',F8.2)')
     .       EKIN,Veloc
      WRITE (*,'('' Ekin='',E12.4,'' Veloc_hot(km/s)='',F8.2)')
     .       EKIN,Veloc
      CALL WRTAPE    !   write header and control data
      STOP
      END
C************************** MDM:    0.1-0.3-0.6    7eV
c      FUNCTION TRUNF(wk)
c      INCLUDE 'PMparameters.h'
c      PARAMETER (NSPEC =NROW/2)
c      COMMON / TRUNCOM/ QSCALE, ns
c      DATA A1,A2,A3,A4,A5 
c     .         /3.93, - 60.2, 409., -17.1, 12.5/
c       IF (WK.GE.FLOAT(NSPEC)) THEN
c	  TRUNF =0.
c	  RETURN
c       ENDIF
c       Q = QSCALE *WK
c       sk=sqrt(Q)
c       TRUNF = sqrt(LOG(1.+A5*g*Q) / (A5*g)) /
c     .         (1.+sk*(A1*(1.-g/3.2)
c     .            +sk*(A2*(1.-g/3.5)
c     .            +sk*(A3*(1.-g/5.)
c     .            +sk*(A4*(1.-g**2/15.) )))) )
c      RETURN
c      END
C************************** MDM: Om_nu=0.2, z=30. 
      FUNCTION TRUNF(wk)      
      INCLUDE 'PMparameters.h'
      PARAMETER (NSPEC =NROW/2)
      COMMON / TRUNCOM/ QSCALE, ns
      DIMENSION          PP(6)
      REAL                ns
      DATA   PP/1.,-1.464,19.81,154.5,143.6,0.961/
       IF (WK.GE.FLOAT(NSPEC)) THEN
	      TRUNF =0. ! truncate above nyquist frequency
	      RETURN
       ENDIF
       Q = QSCALE*WK
       sk= sqrt(Q)
       TRUNF= sqrt(wk**ns/
     .        (1.+sk*(PP(2) +sk*(PP(3) +sk*(PP(4)
     .           +sk*PP(5) ))))**(2.*PP(6)) )
      RETURN
      END
C**************************:  Approx for Growth rate for MDM cold
      FUNCTION GrPcold(wk)
c      PARAMETER (C1=0.805,C2=0.195,C3=0.3,C4=0.70803)
      PARAMETER (C1=0.8736,C2=1.-C1,C3=0.0891,C4=0.7347)
      COMMON / TRUNCOM/ QSCALE, ns
      REAL                ns
         Q = QSCALE*WK
         GrPcold =C1+C2/(1. +exp(LOG(Q/C3)/C4))
      Return
      End
C**************************:  Approx for Growth rate for MDM hot
      FUNCTION GrPhot(wk)
c      PARAMETER (C1=1.80,C2=-0.8,C3=1.4,C4=1.065)
      PARAMETER (C1=1.75,C2=-0.75,C3=0.2165,C4=0.88)
      COMMON / TRUNCOM/ QSCALE, ns
      REAL                ns
         Q = QSCALE*WK
         GrPhot =C1+C2/(1. +exp(LOG(Q/C3)/C4))
      Return
      End
C************************** Neutrino:   Cold * correction factor
      FUNCTION TRUNU(WK)
      INCLUDE 'PMparameters.h'
      COMMON / TRUNCOM/ QSCALE, ns
      DIMENSION PP(6)
      REAL                ns
      DATA PP/1.442,-0.651,4.03,1.553,-35.50,141.7/
         Q = QSCALE*WK
         sk= (Q)**0.33333
         TRUNU =TRUNF(WK)  *
     .                    sqrt( exp(-PP(1)*Q)
     .                   /(1.+sk*(PP(2) +sk*(PP(3)
     .                       +sk*(PP(4) +sk*(PP(5) 
     .                       +sk*PP(6)    ))))) )
      RETURN
      END
C*************************************** Velocity distribution
      SUBROUTINE VELCT(Wx,Wy,Wz,NRAND)
      COMMON / FERMI  / Vscale
C                                       get random unit vector
 1    x =(RANDd(NRAND)-0.5)*2.
      y =(RANDd(NRAND)-0.5)*2.
      z =(RANDd(NRAND)-0.5)*2.
      r2 =x**2 +y**2 +z**2
            If(r2 .gt. 1.)goto1
C                                      Fermi distribution            
      p  =RANDd(NRAND)
      v  =Vscale *Vfermi(p)/sqrt(r2)
      Wx =x *v
      Wy =y *v
      Wz =z *v

      Return
      End
C*********************************************************************
C			  INITIALIZE CONSTANTS:
C			 Scalel -length of square in MPC
C			 AEXPN	-expansion factor (current)
C			 ASTEP	-increment of expansion factor
C			 PARTW	-weight of a particle
C			 AMPLT	-amplitude of perturbations
C			 NBYTE	-record length in bytes
C
      SUBROUTINE InitValues(NBYTE,SCALEL)
      INCLUDE 'PMparameters.h'
      COMMON / TRUNCOM/ QSCALE, ns
      COMMON / FERMI  / Vscale
      REAL                INPUT, ns
      DATA PI		 /3.1415926535/
C                          '123456789012345678901234567890123456789012345'   
       HEADER='N=256x512 L=50/hsig=0.174totCHDM2nu z0=30Ns=3'
       Om0   = 1.         ! \Omega_0 at z=0
       Oml0  = 0.         ! \Omega_lambda at z=0
       Ocurv = 0.
       hubble= 0.5          
       write (*,*) '------ Enter Header for the run up to 45 characters'
       write (*,*) '       Example:'
       write (*,'(A)') HEADER
       read  (*,'(A)') HEADER
       write (*,'(A)') HEADER
       AEXPN =1./(1.+30.)   !  z_init = 30.
       write (*,*) ' Initial expansion parameter     =',AEXPN
       ASTEP =INPUT(' Step of the expansion parameter  =')
       AMPLT =INPUT(' Amplitude of density fluctuations=')
       ns    =INPUT(' Slope of the power spectrum      =')
       SCALEL=INPUT(' Box size (Mpc/h)                 =')
       Nseed =INPUT(' Random seed (Integer  1-2^31)    =') 
       Nspecies =INPUT(' Number of neutrino/cold_part(1-6)=') 
       SCALEL=SCALEL/hubble   ! scale it to real megaparsecs  
       write (*,*) ' Aexpn=',AEXPN,' dA=',ASTEP
C                          Velocity scale for neutrino thermal vel.
C                          Vrms = 3.59*Vscale
C                          No dependance on Aexpn (P, not V)       
c       Vscale= 7.2/(SCALEL*50./NGRID)
c       Vscale= 8.82/(SCALEL*50./NGRID)  ! m_nu=5.72eV, Omega_nu=0.25
       Vscale= 22.0/(SCALEL*50./NGRID) ! m_nu=2.29eV, Omega_nu=0.1x2
       NBYTE = NPAGE*6*4
       W     = (FLOAT(NGRID)/FLOAT(NROW))**3
       PARTW = W *0.80       ! this is for 20% neutrino
c                                 W1    = (W -Partw)/Nspecies
       ISTEP = 0
       TINTG = 0.
       AU0   = 0.
       AEU0  = 0.
       EKIN  = 0.
       EKIN1 = 0.
       EKIN2 = 0.
       NROWC = NROW
       NGRIDC= NGRID
	    QSCALE = 2.*PI/SCALEL
      RETURN
      END
C*********************************************************************
C		    Set spectrum of perturbations:
      SUBROUTINE SPECTR(ALPHA,NRAND)
      INCLUDE 'PMparameters.h'
      PARAMETER (NSPEC = NROW/2 )
      COMMON / GRID/	GRX(NROW,NROW,NROW),GRY(NROW,NROW,NROW),
     +			GRZ(NROW,NROW,NROW)
      COMMON / GRIV/	GVX(NROW,NROW,NROW),GVY(NROW,NROW,NROW),
     +			GVZ(NROW,NROW,NROW)
C						    Set spectrum
      SUMM = 0.
      DO  MK3 = 1,NROW
      DO  MK2 = 1,NROW
      DO  MK1 = 1,NROW
	       GRX(MK1,MK2,MK3) =0.
	       GRY(MK1,MK2,MK3) =0.
	       GRZ(MK1,MK2,MK3) =0.
      ENDDO
      ENDDO
      ENDDO

      DO  k = 1,NROW
         ksign = -1
         kz    = k +NSPEC
         k3    = k - 1
         If(k3.GT.NSPEC)k3=k3-NSPEC
           IF(kz.gt.NROW)THEN
              kz    =kz -NROW
              ksign =1
           ENDIF
           WK3= K3**2
           DO  j = 1,NROW
              jsign = -1
              jz    = j +NSPEC
              j3    = j - 1
              If(j3.GT.NSPEC)j3=j3-NSPEC
                IF(jz.gt.NROW)THEN
                   jz    =jz -NROW
                   jsign =1
                ENDIF
                WJ3= j3**2
                DO  i = 1,NROW
                   isign = -1
                   iz    = i +NSPEC
                   i3    = i - 1
                   If(i3.GT.NSPEC)i3=i3-NSPEC
                     IF(iz.gt.NROW)THEN
                        iz    =iz -NROW
                        isign =1
                     ENDIF
                     WI3= i3**2

	       IF(i3+j3+k3.EQ.0)THEN
		  GRX(1,1,1) = 0.
		  GRY(1,1,1) = 0.
		  GRZ(1,1,1) = 0.
	       ELSE
		  WD = WI3 + WJ3 + WK3
		  WK = SQRT(WD)

		  TS = TRUNF(WK) * GAUSS(NRAND)
		  TRX = TS / WD
                  TV = GrPcold(WK)
		  GRX(iz, j, k) = i3 * TRX *isign
		  GRY( i,jz, k) = j3 * TRX *jsign
		  GRZ( i, j,kz) = k3 * TRX *ksign
		  GVX(iz, j, k) = TV * GRX(iz, j, k)
		  GVY( i,jz, k) = TV * GRY( i,jz, k)
		  GVZ( i, j,kz) = TV * GRZ( i, j,kz)
		  SUMM = SUMM + TS**2
	       ENDIF
	    ENDDO
	   ENDDO
      ENDDO
      IF(SUMM.LE.0.)WRITE (*,*) ' Error!!! Summ over spectrum = 0'
         write (*,*) ' ==== SPECTR ===  SUMM=',SUMM
      ALPHA = AMPLT / SQRT(SUMM) *sqrt(8.)
      RETURN
      END
C*********************************************************************
C		    Set spectrum of perturbations:
      SUBROUTINE SPECNU(NRAND)
      INCLUDE 'PMparameters.h'
      PARAMETER (NSPEC = NROW/2 )
      COMMON / GRID/	GRX(NROW,NROW,NROW),GRY(NROW,NROW,NROW),
     +			GRZ(NROW,NROW,NROW)
      COMMON / GRIV/	GVX(NROW,NROW,NROW),GVY(NROW,NROW,NROW),
     +			GVZ(NROW,NROW,NROW)
C						    Set spectrum
      SUMM = 0.
      DO  MK3 = 1,NROW
      DO  MK2 = 1,NROW
      DO  MK1 = 1,NROW
	      GRX(MK1,MK2,MK3) =0.
	      GRY(MK1,MK2,MK3) =0.
	      GRZ(MK1,MK2,MK3) =0.
      ENDDO
      ENDDO
      ENDDO

      DO  k = 1,NROW
         ksign = -1
         kz    = k +NSPEC
         k3    = k - 1
         If(k3.GT.NSPEC)k3=k3-NSPEC
           IF(kz.gt.NROW)THEN
              kz    =kz -NROW
              ksign =1
           ENDIF
           WK3= K3**2
           DO  j = 1,NROW
              jsign = -1
              jz    = j +NSPEC
              j3    = j - 1
              If(j3.GT.NSPEC)j3=j3-NSPEC
                IF(jz.gt.NROW)THEN
                   jz    =jz -NROW
                   jsign =1
                ENDIF
                WJ3= j3**2
                DO  i = 1,NROW
                   isign = -1
                   iz    = i +NSPEC
                   i3    = i - 1
                   If(i3.GT.NSPEC)i3=i3-NSPEC
                     IF(iz.gt.NROW)THEN
                        iz    =iz -NROW
                        isign =1
                     ENDIF
                     WI3= i3**2

	       IF(i3+j3+k3.EQ.0)THEN
		  GRX(1,1,1) = 0.
		  GRY(1,1,1) = 0.
		  GRZ(1,1,1) = 0.
	       ELSE
		  WD = WI3 + WJ3 + WK3
		  WK = SQRT(WD)

		  TS = TRUNU(WK) * GAUSS(NRAND)
		  TRX = TS / WD
                  TV = GrPhot(WK)
		  GRX(iz, j, k) = i3 * TRX *isign
		  GRY( i,jz, k) = j3 * TRX *jsign
		  GRZ( i, j,kz) = k3 * TRX *ksign
		  GVX(iz, j, k) = TV * GRX(iz, j, k)
		  GVY( i,jz, k) = TV * GRY( i,jz, k)
		  GVZ( i, j,kz) = TV * GRZ( i, j,kz)
		  SUMM = SUMM + TS**2
	       ENDIF
	    ENDDO
	   ENDDO
      ENDDO
      IF(SUMM.LE.0.)WRITE (*,*) ' Error!!! Summ over spectrum = 0'
         write (*,*) ' ==== SPECTR ===  SUMM=',SUMM
      RETURN
      END
C*********************************************************************
C		   Define coordinates and velosities for
C		   all particles of current row (given q2)
C			  x = q - amplt*b(t)/b(t0)*S(q1,q2)
C			  momentum = a**2*deriv x
C
C		   Twidled variables:
C		   x= q - {1/(2 pi Ngrid)}{Alpha*a(t)/a(0)}*S
C		   P=	- {1/(2 pi Ngrid)}{Alpha*a(t)**1.5/a(0)}*S
C
C		   q(i) = Ngrid/Nrow*(i-1) + 1
C		   x = q - xcons*S
C		   P =	   vcons*S
      SUBROUTINE SETXV(XCONS,VCONS,K)
      INCLUDE 'PMparameters.h'
      COMMON / KINENRG/ SKINE,SX,SY,SZ,SX2,SY2,SZ2
      COMMON / GRID/	GRX(NROW,NROW,NROW),GRY(NROW,NROW,NROW),
     +			GRZ(NROW,NROW,NROW)
      COMMON / GRIV/	GVX(NROW,NROW,NROW),GVY(NROW,NROW,NROW),
     +			GVZ(NROW,NROW,NROW)

      QFACT = FLOAT(NGRID)/FLOAT(NROW)
      XMAX  = FLOAT(NGRID) + 1.
      XSHF  = FLOAT(NGRID)
      Q3    = QFACT*(K-1.) +1.
      DO  J = 1,NROW
	     Q2 = QFACT*(J-1.) +1.
	     DO  I = 1,NROW
	       Q1       = QFACT*(I-1.) +1.
          IJ       =      I +(J-1)*NROW
	       DX	    =      XCONS*GRX(I,J,K)
	       DY	    =      XCONS*GRY(I,J,K)
	       DZ	    =      XCONS*GRZ(I,J,K)
	       XPAR(IJ) = Q1 - DX       + 1.E-4 +0.5
	       YPAR(IJ) = Q2 - DY       + 1.E-4 +0.5
	       ZPAR(IJ) = Q3 - DZ       + 1.E-4 +0.5
	       VX(IJ)   =      VCONS*GVX(I,J,K)
	       VY(IJ)   =      VCONS*GVY(I,J,K)
	       VZ(IJ)   =      VCONS*GVZ(I,J,K)
	       IF(XPAR(IJ).GT.XMAX)	XPAR(IJ)=XPAR(IJ)-XSHF
	       IF(XPAR(IJ).LE.1.)	XPAR(IJ)=XPAR(IJ)+XSHF
	       IF(YPAR(IJ).GT.XMAX)	YPAR(IJ)=YPAR(IJ)-XSHF
	       IF(YPAR(IJ).LE.1.)	YPAR(IJ)=YPAR(IJ)+XSHF
	       IF(ZPAR(IJ).GT.XMAX)	ZPAR(IJ)=ZPAR(IJ)-XSHF
	       IF(ZPAR(IJ).LE.1.)	ZPAR(IJ)=ZPAR(IJ)+XSHF
	       SX	    = SX    + DX
	       SY	    = SY    + DY
	       SZ	    = SZ    + DZ
	       SX2      = SX2   + DX**2
	       SY2      = SY2   + DY**2
	       SZ2      = SZ2   + DZ**2
	       SKINE    = SKINE + VX(IJ)**2 +VY(IJ)**2 +VZ(IJ)**2
	     ENDDO
      ENDDO
      RETURN
      END
C*********************************************************************
C		   Define coordinates and velosities for
C		   neutrino in the current row 
C
      SUBROUTINE SETXVN(XCONS,VCONS,K,NRAND)
      INCLUDE 'PMparameters.h'
      COMMON / KINENRG/ SKINE,SX,SY,SZ,SX2,SY2,SZ2
      COMMON / GRID/	GRX(NROW,NROW,NROW),GRY(NROW,NROW,NROW),
     +			GRZ(NROW,NROW,NROW)
      COMMON / GRIV/	GVX(NROW,NROW,NROW),GVY(NROW,NROW,NROW),
     +			GVZ(NROW,NROW,NROW)
      COMMON / ROW2/	XPAR2(NPAGE),YPAR2(NPAGE),ZPAR2(NPAGE),
     +			VX2(NPAGE),VY2(NPAGE),VZ2(NPAGE)

      QFACT = FLOAT(NGRID)/FLOAT(NROW)
      XMAX  = FLOAT(NGRID) + 1.
      XSHF  = FLOAT(NGRID)
      Q3    = QFACT*(K-1.) +1.
            
      DO  J = 1,NROW
	     Q2 = QFACT*(J-1.) +1.
	     DO  I = 1,NROW
	       Q1 = QFACT*(I-1.) +1.
          IJ       =      I +(J-1)*NROW
	       DX	    =      XCONS*GRX(I,J,K)
	       DY	    =      XCONS*GRY(I,J,K)
	       DZ	    =      XCONS*GRZ(I,J,K)
	       XPAR(IJ) = Q1 - DX       + 1.E-4 +0.5
	       YPAR(IJ) = Q2 - DY       + 1.E-4 +0.5
	       ZPAR(IJ) = Q3 - DZ       + 1.E-4 +0.5
          CALL VELCT(Wx,Wy,Wz,NRAND)
	       VX(IJ)   =      VCONS*GVX(I,J,K) +Wx
	       VY(IJ)   =      VCONS*GVY(I,J,K) +Wy
	       VZ(IJ)   =      VCONS*GVZ(I,J,K) +Wz
	       VX2(IJ)  =      VCONS*GVX(I,J,K) -Wx
	       VY2(IJ)  =      VCONS*GVY(I,J,K) -Wy
	       VZ2(IJ)  =      VCONS*GVZ(I,J,K) -Wz
	          IF(XPAR(IJ).GT.XMAX)	XPAR(IJ)=XPAR(IJ)-XSHF
	          IF(XPAR(IJ).LE.1.)	XPAR(IJ)=XPAR(IJ)+XSHF
	          IF(YPAR(IJ).GT.XMAX)	YPAR(IJ)=YPAR(IJ)-XSHF
	          IF(YPAR(IJ).LE.1.)	YPAR(IJ)=YPAR(IJ)+XSHF
	          IF(ZPAR(IJ).GT.XMAX)	ZPAR(IJ)=ZPAR(IJ)-XSHF
	          IF(ZPAR(IJ).LE.1.)	ZPAR(IJ)=ZPAR(IJ)+XSHF
          XPAR2(IJ)=      XPAR(IJ)
          YPAR2(IJ)=      YPAR(IJ)
          ZPAR2(IJ)=      ZPAR(IJ)
	       SKINE    = SKINE + VX(IJ)**2 +VY(IJ)**2 +VZ(IJ)**2
     .                     + VX2(IJ)**2+VY2(IJ)**2+VZ2(IJ)**2
   	  ENDDO
      ENDDO
      RETURN
      END
C*********************************************************************
C				   FFT of the spectrum
      SUBROUTINE VECTOR(IFOUR)
      INCLUDE 'PMparameters.h'
      COMMON / GRID/	GRX(NROW,NROW,NROW),GRY(NROW,NROW,NROW),
     +			GRZ(NROW,NROW,NROW)
      COMMON / GRIV/	GVX(NROW,NROW,NROW),GVY(NROW,NROW,NROW),
     +			GVZ(NROW,NROW,NROW)
      CALL SETF67(4,IFOUR)
C				       x-component
      DO K=1,NROW
	   DO J=1,NROW
	    DO I=1,NROW
	       Zf(I) =GRX(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO I=1,NROW
	       GRX(I,J,K) = Yf(I)
	    ENDDO
	    DO I=1,NROW
	       Zf(I) =GVX(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO I=1,NROW
	       GVX(I,J,K) = Yf(I)
	    ENDDO
   	ENDDO
      ENDDO
      DO K=1,NROW
	   DO I=1,NROW
	    DO J=1,NROW
	       Zf(J) =GRX(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO J=1,NROW
	       GRX(I,J,K) = Yf(J)
	    ENDDO
	    DO J=1,NROW
	       Zf(J) =GVX(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO J=1,NROW
	       GVX(I,J,K) = Yf(J)
	    ENDDO
	   ENDDO
      ENDDO
      DO J=1,NROW
	   DO I=1,NROW
	    DO K=1,NROW
	       Zf(K) =GRX(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO K=1,NROW
	       GRX(I,J,K) = Yf(K)/8.
	    ENDDO
	    DO K=1,NROW
	       Zf(K) =GVX(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO K=1,NROW
	       GVX(I,J,K) = Yf(K)/8.
	    ENDDO
	   ENDDO
      ENDDO
				       write (*,*) ' x is done'
C				       Y-component
      DO K=1,NROW
	   DO J=1,NROW
	    DO I=1,NROW
	       Zf(I) =GRY(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO I=1,NROW
	       GRY(I,J,K) = Yf(I)
	    ENDDO
	    DO I=1,NROW
	       Zf(I) =GVY(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO I=1,NROW
	       GVY(I,J,K) = Yf(I)
	    ENDDO
	   ENDDO
      ENDDO
      DO K=1,NROW
	   DO I=1,NROW
	    DO J=1,NROW
	       Zf(J) =GRY(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO J=1,NROW
	       GRY(I,J,K) = Yf(J)
	    ENDDO
	    DO J=1,NROW
	       Zf(J) =GVY(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO J=1,NROW
	       GVY(I,J,K) = Yf(J)
	    ENDDO
	   ENDDO
      ENDDO
      DO J=1,NROW
	   DO I=1,NROW
	    DO K=1,NROW
	       Zf(K) =GRY(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO K=1,NROW
	       GRY(I,J,K) = Yf(K)/8.
	    ENDDO
	    DO K=1,NROW
	       Zf(K) =GVY(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO K=1,NROW
	       GVY(I,J,K) = Yf(K)/8.
	    ENDDO
	   ENDDO
      ENDDO
				       write (*,*) ' y is done'
C				       Z-component
      DO K=1,NROW
	   DO J=1,NROW
	    DO I=1,NROW
	       Zf(I) =GRZ(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO I=1,NROW
	       GRZ(I,J,K) = Yf(I)
	    ENDDO
	    DO I=1,NROW
	       Zf(I) =GVZ(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO I=1,NROW
	       GVZ(I,J,K) = Yf(I)
	    ENDDO
	   ENDDO
      ENDDO
      DO K=1,NROW
	   DO I=1,NROW
	    DO J=1,NROW
	       Zf(J) =GRZ(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO J=1,NROW
	       GRZ(I,J,K) = Yf(J)
	    ENDDO
	    DO J=1,NROW
	       Zf(J) =GVZ(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO J=1,NROW
	       GVZ(I,J,K) = Yf(J)
	    ENDDO
	   ENDDO
      ENDDO
      DO J=1,NROW
	   DO I=1,NROW
	    DO K=1,NROW
	       Zf(K) =GRZ(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO K=1,NROW
	       GRZ(I,J,K) = Yf(K)/8.
	    ENDDO
	    DO K=1,NROW
	       Zf(K) =GVZ(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO K=1,NROW
	       GVZ(I,J,K) = Yf(K)/8.
	    ENDDO
	   ENDDO
      ENDDO
				       write (*,*) ' z is done'
      RETURN
      END

C_________________________________________ Fermi distribution
C                                y - random number (0-1)
C                            dn = v^2dv/(exp(v)+1)/1.8036
C                                 \int_0^\infty dn =1      
      FUNCTION Vfermi(y)
         z  = y**0.333
         d  = MAX(1.-y,1.e-6)
            Vfermi = -1.15*log(d) +3.7e-4+z*(2.219+0.396*z) 
         IF( y.gt. 0.35)Then
            IF(y .gt. 0.55)Then
               Vfermi =Vfermi+2.04-1.937*sqrt(d)-1.24*y
            Else
               Vfermi =Vfermi+(2.04-1.937*sqrt(d)-1.24*y)*
     .                        (y-0.35)/0.2               
            EndIf
         Endif
      RETURN
      END

C---------------------------------------------------
C                                  Read  current data from disk/tape,
C                                  Open files
C                                  Nrecl is the number of values in a record
C                                  Npage is the number of particles in a page
      SUBROUTINE RDTAPE
C---------------------------------------------------
      INCLUDE 'PMparameters.h'
C                                     Open file on a tape
      OPEN(UNIT=9,FILE='PMcrd.DAT',
     +                FORM='UNFORMATTED', STATUS='UNKNOWN')
C                                 Read control information
C                                 and see whether it has proper
C                                 structure
      READ  (9,err=20,end=20) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  TINTG,EKIN,EKIN1,EKIN2,AU0,AEU0,
     +                  NROWC,NGRIDC,Nspecies,Nseed,Om0,Oml0,hubble,Wp5
     +                   ,Ocurv,extras
      WRITE (*,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,EKIN1,EKIN2,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
      WRITE (16,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,EKIN1,EKIN2,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
100   FORMAT(1X,'Header=>',A45,/
     +          1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',3E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I9,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3)
      IF(NROW.NE.NROWC) THEN
         WRITE (*,*)
     +            ' NROW in PARAMETER and in TAPE-FILE are different'
      ENDIF
      IF(NGRID.NE.NGRIDC) THEN
         WRITE (*,*)
     +           ' NGRID in PARAMETER and in TAPE-FILE are different:'
         write (*,*) ' Ngrid=',NGRID,' NgridC=',NGRIDC
      ENDIF
C                                         Open work file on disk
      write (*,*)  ' start openning PMcrs0'
 10   NBYTE = NRECL*4
      NACCES= NBYTE / nbyteword

      OPEN(UNIT=21,FILE='PMcrs0.DAT',ACCESS='DIRECT',
     +	               STATUS='UNKNOWN',RECL=NACCES)


      REWIND 9
       write (*,*)  ' done openning PMcrs0'
      RETURN
 20   write (*,*) ' Error reading the header file: Abort'
      stop
      END
C---------------------------------------------
C                       Write current data to  disk/tape
C
      SUBROUTINE WRTAPE
C----------------------------------------------
      INCLUDE 'PMparameters.h'
C                                       write header and control data
      WRITE (9) HEADER,
     +           AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +           TINTG,EKIN,EKIN1,EKIN2,AU0,AEU0,
     +           NROWC,NGRIDC,Nspecies,Nseed,Om0,Oml0,hubble,Wp5,
     +           Ocurv,extras
      REWIND 9
      RETURN
      END
C--------------------------------------------------
C                             Write current PAGE of particles (x,v) to disk
C                             NRECL - length of ROW block in words
      SUBROUTINE WRIROW(IROW,Ifile)
C--------------------------------------------------
      INCLUDE 'PMparameters.h'
        WRITE (20+Ifile,REC=IROW) RECDAT
      RETURN
      END
C--------------------------------------------------
C                             Set Weights of particles for
C                             fast access
      SUBROUTINE SetWeight
C--------------------------------------------------
      INCLUDE 'PMparameters.h'
      If(Nspecies.eq.0)Then  ! old  constant weights
         N_particles =lspecies(1)
         Do i=1,N_particles
            iWeight(i) =PARTW
         EndDo
      Else
         N_particles =lspecies(Nspecies)
         jstart =1
         Do j=1,Nspecies
            jend =lspecies(j)
            Do k=jstart ,jend
               iWeight(k) =wspecies(j)
            EndDo
            jstart =jend
         EndDo
      EndIf
      write (*,*) ' Set Weights for ',N_particles,' particles'
      RETURN
      END
C--------------------------------------------
C                            Read current PAGE of particles  from disk
C                            NRECL - length of ROW block in words
      SUBROUTINE GETROW(IROW,Ifile)
C--------------------------------------------
      INCLUDE 'PMparameters.h'
         READ  (20+Ifile,REC=IROW) RECDAT
      RETURN
      END
C------------------------------------------------
C				                                       random number generator
      FUNCTION RANDd(M)
C------------------------------------------------
      DATA LC,AM,KI,K1,K2,K3,K4,L1,L2,L3,L4
     +	/453815927,2147483648.,2147483647,536870912,131072,256,
     +	 16777216,4,16384,8388608,128/
      ML=M/K1*K1
      M1=(M-ML)*L1
      ML=M/K2*K2
      M2=(M-ML)*L2
      ML=M/K3*K3
      M3=(M-ML)*L3
      ML=M/K4*K4
      M4=(M-ML)*L4
      M5=KI-M
      IF(M1.GE.M5)M1=M1-KI-1
      ML=M+M1
      M5=KI-ML
      IF(M2.GE.M5)M2=M2-KI-1
      ML=ML+M2
      M5=KI-ML
      IF(M3.GE.M5)M3=M3-KI-1
      ML=ML+M3
      M5=KI-ML
      IF(M4.GE.M5)M4=M4-KI-1
      ML=ML+M4
      M5=KI-ML
      IF(LC.GE.M5)ML=ML-KI-1
      M=ML+LC
      RANDd=M/AM
      RETURN
      END
C--------------------------------------
C				normal random numbers
      FUNCTION GAUSS(M)
C--------------------------------------
      X=0.
      DO  I=1,5
         X=X+RANDd(M)
      EndDo
      X2   =1.5491933*(X-2.5)
      GAUSS=X2*(1.-0.01*(3.-X2*X2))
      RETURN
      END

C---------------------------------- Read in variables      
      REAL FUNCTION INPUT(text)
C------------------------------------------------
      Character text*(*)
          write (*,'(A,$)')text
          read (*,*) x
          INPUT =x
      Return
      End
C--------------------------------------   Fourier Transorm
      SUBROUTINE SETF67(IBC1,IQ1)
C----------------------------------------------------
      INCLUDE 'PMparameters.h'
      PI=DATAN(1.D0)*4.
       IBC=IBC1
       IQ=IQ1
       IF(IBC.LT.3) GO TO 101
       IQ=IQ-1
  101      N3=2**IQ
       N7=N3/2
       N5=N3/4
       I=1
       INDEX(I)=N5
       SI(I)=0.5*SQRT(2.)
       K=I
       I=I+1
  102     IL=I
       IF(I.EQ.N7) GO TO 104
  103     K1=INDEX(K)/2
       INDEX(I)=K1
       SI(I)=SIN(PI*FLOAT(K1)/FLOAT(N3))
       K1=N7-K1
       I=I+1
       INDEX(I)=K1
       SI(I)=SIN(PI*FLOAT(K1)/FLOAT(N3))
       K=K+1
       I=I+1
       IF(K.EQ.IL) GO TO 102
       GO TO 103
  104     RETURN
       END
C-----------------------------------------
       SUBROUTINE TFOLD(IS,L,ZZZ)
       INCLUDE 'PMparameters.h'
       DIMENSION ZZZ(NARR)
       IH2=N2/2-1
       DO 100 I=IS,IH2
       I1=I+L
       I2=N2-I+L
       A=ZZZ(I1)
       ZZZ(I1)=A-ZZZ(I2)
       ZZZ(I2)=A+ZZZ(I2)
  100     CONTINUE
       RETURN
       END
C------------------------------------
       SUBROUTINE NEG(I1,I3,I2)
       INCLUDE 'PMparameters.h'
       DO 100 K=I1,I3,I2
       Yf(K)=-Yf(K)
  100     CONTINUE
       RETURN
       END
C-------------------------------------
       SUBROUTINE REVNEG
       INCLUDE 'PMparameters.h'
       DO 100 I=1,N7
       J=N3+1+I
       K=N4+1-I
       A=Yf(J)
       Yf(J)=-Yf(K)
       Yf(K)=-A
  100     CONTINUE
       RETURN
       END
C-------------------------------------
       SUBROUTINE ZEERO(L)
       INCLUDE 'PMparameters.h'
       DO 100 I=1,N2
       LI=L+I
       Zf(LI-1)=0.0
  100     CONTINUE
       RETURN
       END
C------------------------------------------
       SUBROUTINE TFOLD1
       INCLUDE 'PMparameters.h'
       II=N2-1
       DO 100 I=1,II
       I1=ISL+I
       I2=L1-I
       A=Zf(I1)
       Zf(I1)=A+Zf(I2)
       Zf(I2)=A-Zf(I2)
  100     CONTINUE
      RETURN
       END
C-------------------------------------
      SUBROUTINE KFOLD
       INCLUDE 'PMparameters.h'
       JS1=N2
       I=1
       J5=ISL+N2
       IS1=ISL
       IC1=L1
       JS1=JS1/2
       IF(JS1.NE.1) GO TO 200
       K1=INDEX(I)
       SN=SI(I)
       IS0=IS1
       IS1=IS1+JS1
       IC0=IC1
       IC1=IC1+JS1
       ODD1=SN*(Zf(IC1)-Zf(IS1))
       Yf(K1+1)=Zf(IC0)+ODD1
       N3MK1=N3-K1
       Yf(N3MK1+1)=Zf(IC0)-ODD1
       IF(IBC.LT.3) GO TO 110
       ODD2=SN*(Zf(IC1)+Zf(IS1))
       N3PK1=N3+K1
       Yf(N3PK1+1)=Zf(IS0)+ODD2
       N4MK1=N4-K1
       Yf(N4MK1+1)=-Zf(IS0)+ODD2
  110     RETURN
  200     SN=SI(I)
       IS1=IS1+JS1
       IC1=IC1+JS1
       J3=IS1+JS1
  210     IS0=IS1-JS1
       IC0=IC1-JS1
       ODD1=SN*(Zf(IC1)-Zf(IS1))
       ODD2=SN*(Zf(IC1)+Zf(IS1))
       Zf(IC1)=Zf(IC0)-ODD1
       Zf(IS1)=-Zf(IS0)+ODD2
       Zf(IC0)=Zf(IC0)+ODD1
       Zf(IS0)=Zf(IS0)+ODD2
       IS1=IS1+1
       IC1=IC1+1
       IF(IS1.NE.J3) GO TO 210
       I=I+1
  300     IS1=ISL
       IC1=L1
       JS1=JS1/2
       IF(JS1.EQ.1) GO TO 400
  310     SN=SI(I)
       I=I+1
       CS=SI(I)
       IS1=IS1+JS1
       IC1=IC1+JS1
       J3=IS1+JS1
  320     IS0=IS1-JS1
       IC0=IC1-JS1
       ODD1=CS*Zf(IC1)-SN*Zf(IS1)
       ODD2=SN*Zf(IC1)+CS*Zf(IS1)
       Zf(IC1)=Zf(IC0)-ODD1
       Zf(IC0)=Zf(IC0)+ODD1
       Zf(IS1)=-Zf(IS0)+ODD2
       Zf(IS0)=Zf(IS0)+ODD2
       IS1=IS1+1
       IC1=IC1+1
       IF(IS1.NE.J3) GO TO 320
       IS1=IS1+JS1
       IC1=IC1+JS1
       J3=IS1+JS1
  330     IS0=IS1-JS1
       IC0=IC1-JS1
       ODD1=SN*Zf(IC1)-CS*Zf(IS1)
       ODD2=CS*Zf(IC1)+SN*Zf(IS1)
       Zf(IC1)=Zf(IC0)-ODD1
       Zf(IC0)=Zf(IC0)+ODD1
       Zf(IS1)=-Zf(IS0)+ODD2
       Zf(IS0)=Zf(IS0)+ODD2
       IS1=IS1+1
       IC1=IC1+1
       IF(IS1.NE.J3) GO TO 330
       I=I+1
       IF(IS1.EQ.J5) GO TO 300
       GO TO 310
  400     K1=INDEX(I)
       SN=SI(I)
       I=I+1
       CS=SI(I)
       IS0=IS1
       IS1=IS1+JS1
       IC0=IC1
       IC1=IC1+JS1
       ODD1=CS*Zf(IC1)-SN*Zf(IS1)
       Yf(K1+1)=Zf(IC0)+ODD1
       N3MK1=N3-K1
       Yf(N3MK1+1)=Zf(IC0)-ODD1
       IF(IBC.LT.3) GO TO 410
       ODD2=SN*Zf(IC1)+CS*Zf(IS1)
       N3PK1=N3+K1
       Yf(N3PK1+1)=Zf(IS0)+ODD2
       N4MK1=N4-K1
       Yf(N4MK1+1)=-Zf(IS0)+ODD2
  410     IS1=IS1+1
       IC1=IC1+1
       K1=INDEX(I)
       IS0=IS1
       IS1=IS1+JS1
       IC0=IC1
       IC1=IC1+JS1
       ODD1=SN*Zf(IC1)-CS*Zf(IS1)
       Yf(K1+1)=Zf(IC0)+ODD1
       N3MK1=N3-K1
       Yf(N3MK1+1)=Zf(IC0)-ODD1
       IF(IBC.LT.3) GO TO 420
       ODD2=CS*Zf(IC1)+SN*Zf(IS1)
       N3PK1=N3+K1
       Yf(N3PK1+1)=Zf(IS0)+ODD2
       N4MK1=N4-K1
       Yf(N4MK1+1)=-Zf(IS0)+ODD2
  420     IS1=IS1+1
       IC1=IC1+1
       I=I+1
       IF(IS1.NE.J5) GO TO 400
       RETURN
       END
C-----------------------------------------
       SUBROUTINE FOUR67(IBC1,IQ1)
       INCLUDE 'PMparameters.h'
       IBC=IBC1
       IQ=IQ1
       A5=0.5*SQRT(2.0)
       N4=2**IQ
       N3=N4
       GO TO (103,103,101,102),IBC
  101     Zf(1)=Zf(1)/2.0
       Zf(N3+1)=Zf(1)
       N2=N3
       CALL TFOLD(0,1,Zf)
       N3=N3/2
       IQ=IQ-1
       GO TO 103
  102     N3=N3/2
       IQ=IQ-1
  103     N5=N3/4
       N7=N3/2
       N11=3*N7
       N31=N3+1
       GO TO(300,400,500,600),IBC
  300     Zf(N31)=0.0
       Zf(1)=0.0
       N2=N3
       DO 301 I=2,IQ
       CALL TFOLD(1,1,Zf)
  301     N2=N2/2
       Yf(N7+1)=Zf(2)
       JF=N5
       ISL=1
       DO 302 IP=2,IQ
       L1=N2+1
       CALL ZEERO(1)
       CALL KFOLD
       I1=3*JF+1
       I2=4*JF
       I3=I1+(N2/2-1)*I2
       CALL NEG(I1,I3,I2)
       N2=N2+N2
  302     JF=JF/2
       RETURN
  400     Zf(1)=Zf(1)/2.0
       Zf(N31)=Zf(N31)/2.0
       N2=N3
       DO 401 I=2,IQ
       CALL TFOLD(0,N31-N2,Zf)
  401     N2=N2/2
       L1=N31-N2
       A=Zf(L1)+Zf(L1+2)
       Yf(1)=-A-Zf(L1+1)
       Yf(N31)=-A+Zf(L1+1)
       Yf(N7+1)=Zf(L1)-Zf(L1+2)
       DO 402 IP=2,IQ
       ISL=N31-N2
       L1=ISL-N2
       CALL ZEERO(ISL)
       CALL KFOLD
  402     N2=N2+N2
       CALL NEG(1,N31,2)
       RETURN
  500     N2=N3
       L2=N4
       DO 501 IP=2,IQ
       CALL TFOLD(1,1,Zf)
       CALL TFOLD(0,L2-N2+1,Zf)
  501     N2=N2/2
       L1=L2-N2+1
       A=Zf(L1)+Zf(L1+2)
       Yf(N7+1)=2.0*(-Zf(L1)+Zf(L1+2))
       Yf(1)=2.0*(A+Zf(L1+1))
       Yf(N31)=2.0*(A-Zf(L1+1))
       Yf(N11+1)=2.0*Zf(2)
       DO 502 IP=2,IQ
       Zf(N2+1)=2.0*Zf(N2+1)
       ISL=N2+1
       CALL TFOLD1
       L1=L1-N2
       Zf(L1)=-2.0*Zf(L1)
       CALL KFOLD
  502     N2=N2+N2
       Yf(1)=Yf(1)*A5
       Yf(N31)=Yf(N31)*A5
       RETURN
  600     Zf(1)=Zf(1)*A5
       Zf(N31)=Zf(N31)*A5
       N2=N3
       DO 601 IP=2,IQ
       CALL TFOLD(0,N31-N2,Zf)
       CALL TFOLD(1,N31,Zf)
  601     N2=N2/2
       L1=N31-N2
       A=Zf(L1)+Zf(L1+2)
       Yf(1)=2.0*(A+Zf(L1+1))
       Yf(N31)=2.0*(A-Zf(L1+1))
       Yf(N7+1)=2.0*(-Zf(L1)+Zf(L1+2))
       Yf(N11+1)=2.0*Zf(N3+2)
       DO 602 IP=2,IQ
       ISL=N31+N2
       Zf(ISL)=2.0*Zf(ISL)
       CALL TFOLD1
       L1=L1-N2
       Zf(L1)=-2.0*Zf(L1)
       CALL KFOLD
  602     N2=N2+N2
       CALL REVNEG
       CALL NEG(2,N3,2)
       N2=N4
       CALL TFOLD(1,1,Yf)
       Yf(N4+1)=0.0
       RETURN
       END

c-------------------------------------------------------------------- 
c                 Test OMP parallelization
c-------------------------------------------------------------------- 
      parameter (N = 950 )
      COMMON /aa/ A(N,N,N)
      COMMON /bb/ B(N,N,N)
      real*8    sum,sum1

      write (*,*)  ' Required Memory=',8.*N**3/1024.**2,'Mb'
cC$OMP PARALLEL DO DEFAULT(SHARED) 
cC$OMP+PRIVATE (i,j,k)
      Do j=1,N
      Do i=1,N
         Do k=1,N
            A(i,k,j)=0
         EndDo 
      EndDo 
      EndDo 

cC$OMP PARALLEL DO DEFAULT(SHARED) 
cC$OMP+PRIVATE (i,j,k)
      Do j=1,N
      Do i=1,N
         Do k=1,N
            B(i,k,j)=0
         EndDo 
      EndDo 
      EndDo 
      sum = 0.
      Do j=1,N
      Do i=1,N
         Do k=1,N
            A(i,k,j) = ((mod(i,5)+mod(j,5)+mod(k,5))/100.)
            sum =sum + A(i,k,j)**2
         EndDo 
      EndDo 
      EndDo 

      m=3
      CALL SMOOTH(m)
      sum1 = 0.
      Do j=1,N
      Do i=1,N
         Do k=1,N
            sum1 =sum1 + A(i,k,j)**2
         EndDo 
      EndDo 
      EndDo 
      write (*,*)  ' smoothing=',m
      write (*,*)  ' average=',sqrt(sum/N**2)
      write (*,*)  ' average=',sqrt(sum1/N**2)
           stop
           end

c-------------------------------------------------------------------- 
c
      SUBROUTINE SMOOTH(m)
      parameter (N = 950 )
      COMMON /aa/ A(N,N,N)
      COMMON /bb/ B(N,N,N)
      real*8    sum,norm

      norm =(2.*m+1)**3
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP+PRIVATE (i,j,k,sum,i1,j1,k1,ii,jj,kk)
      Do i=1,N,4
         Do j=1,N,4
            Do k=1,N,4
               sum =0.
               Do i1=-m,m,2
               Do j1=-m,m,2
               Do k1=-m,m,2
                 ii = min(max(i+i1,1),N)
                 jj = min(max(j+j1,1),N)
                 kk = min(max(k+k1,1),N)
                 sum = sum+A(ii,jj,kk)
               EndDo 
               EndDo 
               EndDo 
               B(i,j,k) =sum/norm
            EndDo 
         EndDo 
      EndDo 
      Do j=1,N
      Do i=1,N
         Do k=1,N
            A(i,k,j)=B(i,j,k)
         EndDo 
      EndDo 
      EndDo 

      Return
      end

c-------------------------------------------------------------------- 
c                        Fit halo profiles,
c                        use simple minimization
c-------------------------------------------------------------------- 
      PARAMETER (Nmax = 200000) ! 
      PARAMETER (Nbinmax = 85) !
      PARAMETER (Nqual   = 13) ! 
      COMMON  /HALOS/hals(Nqual,Nmax),Nhbin(Nmax),
     &       Prof(7,Nbinmax,Nmax)
      COMMON  /Binn/ Radout(Nbinmax)
      COMMON /APPROX/rsh(Nmax),Vmaxh(Nmax)
      DIMENSION Nin(Nbinmax),Radden(Nbinmax),Vc(Nbinmax),Dens(Nbinmax)
      DIMENSION VVmax(Nmax),Rs(Nmax),r1(Nmax),rho1(Nmax),x2c(Nmax),
     &               a2c(Nmax),error(Nmax)
      Character  Header*100

      Open(1,file='CatalogA.999.DAT')
      Open(2,file='CatFitAf.999.dat')
      Open(3,file='CatOut.999.dat')

      Lines =14    ! number of lines in the header preceeding radial bins
      lbins =85    ! number of bins along radius
      Lskip =4     ! number of header lines between bins and catalog

      Do i=1,Lines
         read(1,'(a)') Header
         write (*,'(a)')  Header
         write (2,'(a)')  Header
      EndDo
      read(1,*) (Radout(i),i=1,lbins)
      write(2,'(10f8.2)') (Radout(i),i=1,lbins)
      write (*,'(10f8.2)') (Radout(i),i=1,lbins)
      Do i=1,Lskip
         read(1,'(a)') Header
         write (2,'(a)')  Header
         write (*,'(a)')  Header
      EndDo

      Nh =0
 100  Nh =Nh+1
      read(1,*,err=400,end=400) (hals(i,Nh),i=1,Nqual),Nhbin(Nh)
c         write(*,'(" Halo=",i8," coords=",3f8.3," bins=",i3)')
c     &              Nh,(hals(i,Nh),i=1,3),Nhbin(Nh)
         do i=1,Nhbin(Nh)
            read(1,*) (Prof(j,i,Nh),j=1,7)
         EndDo 
      If(Nh.lt.Nmax)goto100
c      If(Nh.lt.1000)goto100
      Nh =Nh +1
 400  Nh =Nh -1

      write (*,*)  ' Number of halos read =',Nh
      factor = 8.23e10
      Nchunk = max(Nh/20,100)
C.... Open_MP
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP+PRIVATE (ih,Umax,Rumax,Rvir,Nbin,Radden)
C$OMP+PRIVATE (Nin,Vc,Dens)
C$OMP+SCHEDULE(DYNAMIC,Nchunk)
      Do ih=1,Nh
         If(mod(ih,Nchunk/2).eq.0)write(*,*) ' halo=',ih
         Umax = hals(10,ih)
         Rumax= hals(12,ih)
         Rvir = hals(8,ih)
         Nbin = Nhbin(ih)
         do i=1,Nbin
            Radden(i) = Prof(1,i,ih)
            Nin(i)    = Prof(2,i,ih)
            Vc(i)     = Prof(6,i,ih)
            Dens(i)   = Prof(7,i,ih)/factor
         EndDo 
         if(hals(7,ih).lt.1.e12)Then
            CALL HaloFit(Umax,Rumax,Rvir,Radden,Radout,Nin,Dens,Vc,
     &                  Rs(ih),VVmax(ih),Nbin,error(ih))
            r1(ih) = 0.
            rho1(ih) =0.
            x2c(ih) =0.
            a2c(ih) =0.
         Else
            CALL HaloFitExp(Umax,Rumax,Rvir,Radden,Radout,Nin,Dens,Vc,
     &                      Rs(ih),VVmax(ih),r1(ih),rho1(ih),x2c(ih),
     &                      a2c(ih),Nbin,error(ih))
         EndIf
      EndDo 

      Do ih=1,Nh
         Rvir = hals(8,ih)
         Conc = Rvir/Rs(ih)
         error(ih) =min(error(ih),1.e0)
      write(2,20) (hals(i,ih),i=1,9),
     &    VVmax(ih),INT(hals(11,ih)),Rs(ih)*2.15,Conc,Nhbin(ih),
     &    sqrt(error(ih))
     &    ,r1(ih),rho1(ih),x2c(ih),a2c(ih)
 20   format(3f8.3,3F8.1,g11.3,f8.2,2f8.1,i9,f8.1,f8.2,i4,f8.3
     &       f7.3,g11.4,f7.2,f7.4)

          If((Conc.lt.4..or.Conc.gt.25.).and.hals(7,ih).gt.1.e12)Then
             write(3,'(" Halo=",i8," coords=",3f8.3," M=",g11.4,
     &                 " C=",f8.3," R1,Rs,Rvir=",3f8.3)')
     &                  ih,(hals(i,ih),i=1,3),hals(7,ih),
     &                  Conc,r1(ih),Rs(ih),hals(8,ih)
             write (3,'(5x,"r      Nin   Dens     Dens_4exp",
     &              6x,"Vc  Vc_4exp")')
        do i=1,Nhbin(ih)
             Radd = Prof(1,i,ih)
            Ni    = Prof(2,i,ih)
            Vcc   = Prof(6,i,ih)
            Den   = Prof(7,i,ih)/factor
          
         write(3,50) Radd,Ni,Den,
     &             RhoExp(Radd,r1(ih),rho1(ih),x2c(ih),a2c(ih)),
     &      Vcc,VcExp(Radd,r1(ih),rho1(ih),x2c(ih),a2c(ih))
        EndDo 
        EndIf
      enddo

 50   format(f8.3,i7,2g11.4,2f9.2)
            
             
       stop
      end
c-------------------------------------------------------------------- 
c                       Fit halo profile
      SUBROUTINE HaloFit(Umax,Rumax,Rvir,Radden,Radout,Nin,Dens,Vc,
     &                  Rs,VVmax,Nbin,error)
c                 output:  Rs    = estimate of NFW core radius,
c                          Vvmax = estimate of Vmax  
c-------------------------------------------------------------------- 
      PARAMETER (Nbinmax = 85) !
      PARAMETER (facV    = 1.25) ! max variation for Vmax
      PARAMETER (facR    = 3.0)  ! max variation for rs
c      PARAMETER (facRvir = 2.0)  ! max radius for fit in units of Rvir
      PARAMETER (facRvir = 1.0)  ! max radius for fit in units of Rvir
      PARAMETER (nStepR  = 50)   ! number of bins in radius 
      PARAMETER (nStepV  = 20)   ! number of bins in Vmax 
      DIMENSION Radden(Nbin),Nin(Nbin),Dens(Nbin),Vc(Nbin),
     &          Radout(Nbinmax)

      rs    = Rumax/2.15       ! initial guess for rs
      VVmax = Umax
      Vcmax = Umax
      Vmin  = Umax/facV
      dV    = Umax/nStepV*(facV -1./facV) ! step in Vmax
      Rmin  = rs/facR
      dR    = rs/nStepR*(facR -1./facR)   ! step in rs

      error = 1.e10
      istart= 1
      Do istart =1,Nbin
         If(Nin(istart).gt.200)goto20
      EndDo 
      return           ! not enough particles; get back
 20   Rmax = min(Rvir/facRvir,Radout(Nbin))  ! max radius for the fit
      do i=Nbin,1,-1
         if(Radout(i).lt.Rmax)goto30
      EndDo 
 30   imax = i

      if(imax.le.istart)Then
c         write (*,*)'not enough particles. Bins=',istart,imax
         return
      EndIf 
      Do iv =0,nStepV
         Vmaxx = Vmin +iv*dV
      Do ir =0,nStepR
         rss   = Rmin +ir*dR
         rho_0 = 1.022e3*(Vmaxx/rss)**2
         ee =0.
         ww =0.
         do i=istart,imax
            w  = (Radout(i)-Radout(i-1))/Radden(i) 
            ee = ee + w*(log10(RhoNFW(Radden(i),rho_0,rss)/Dens(i)))**2
            ww = ww + w
         EndDo
c         ee =ee/(imax-istart)
         ee =ee/ww
         If(ee.lt.error)then
            error = ee
            Rs    = rss
            VVmax = Vmaxx
            ivv   = iv
            irr   = ir
            rho   = rho_0
c          write (*,'(10x,"V=",f8.3," r=",f8.3," err=",3g11.3)')
c     &          Vmaxx,rss,ee,rho_0
        EndIf 
      EndDo 
      EndDo 
c         write (*,'(10x,"V=",f8.3," r=",f8.3," err=",3g11.3)')
c     &          VVmax,Rs,error,rho
c      write(*,*) ' after ----'
c      do i=1,Nbin
c         x  = Radden(i)/rs
c         F  = log(1.+x)-x/(1.+x)
c         write(*,50) i,Radden(i),Dens(i),rho/x/(1.+x)**2,
c     &      Vc(i),VVmax*sqrt(4.62*F/x)
c      enddo
 50   format(i3,' r=',f8.3,' dens=',2g11.4,' v=',3f8.2)

         Return
         End
c-------------------------------------------------------------------- 
c                         NFW density profile
      FUNCTION RhoNFW(r,rho_0,rs)
c                 output:  Rs    = estimate of NFW core radius,
c                          Vvmax = estimate of Vmax  
c-------------------------------------------------------------------- 
      x = r/rs
      RhoNFW = rho_0/x/(1.+x)**2

      Return
      End
c-------------------------------------------------------------------- 
c                       Double Exp-Fit for halo profile
      SUBROUTINE HaloFitExp(Umax,Rumax,Rvir,Radden,Radout,Nin,Dens,Vc,
     &           Rs,VVmax,r1,rho1,x2c,a2c,Nbin,error)
c                 output:  Rs    = estimate of NFW core radius,
c                          Vvmax = estimate of Vmax  
c                 Uses 4 parameters:
c                         rho_1, r_1, a_2, x_2
c-------------------------------------------------------------------- 
      PARAMETER (Nbinmax = 85) !
      PARAMETER (facRho  = 10.) ! max variation for density
      PARAMETER (facR    = 10.0)  ! max variation for r1
c      PARAMETER (facRvir = 2.0)  ! max radius for fit in units of Rvir
      PARAMETER (facRvir = 0.5)  ! max radius for fit in units of Rvir
 
      DIMENSION Radden(Nbin),Nin(Nbin),Dens(Nbin),Vc(Nbin),
     &          Radout(Nbinmax)
      Logical   Converge

      rs    = Rumax/2.15       ! initial guess for rs
      VVmax = Umax
      r1    = min(max(Rumax/2.15,Radden(2)),Rvir/5.)       ! initial guess for r1
      dR    = r1/20.
      rho1  = 1.022e3*(Umax/r1)**2 ! initial guess for rho_1
      dRho  = rho1/10.
      x2c   = 5.   
      a2c   = 1./10. 
      dx2   = x2c/10.
      da2   = a2c/10.
      error = 100.
c      write (*,*)  
c      write(*,'(" Guess: R,rho,a2,x2=",4g11.3)')r1,rho1,a2c,x2c
c      write(*,'(" steps: R,rho,a2,x2=",4g11.3)')dR,dRho,da2,dx2

      istart= 1
      Do istart =1,Nbin
         If(Nin(istart).gt.100)goto20
      EndDo 
      return           ! not enough particles; get back
 20   Rmax = min(Rvir/facRvir,Radout(Nbin))  ! max radius for the fit
      do i=Nbin,1,-1
         if(Radout(i).lt.Rmax)goto30
      EndDo 
 30   imax = i
c      write (*,*)  ' max bin=',imax,' Rout=',Radout(imax),Rmax
      if(imax.le.istart.or.Nin(imax).lt.1000)Then
c         write (*,*)'not enough particles. Bins=',istart,imax
         return
      EndIf 

      Do iter =1,100
         r1_old   = r1
         rho1_old = rho1
         a2c_old  = a2c
         x2c_old  = x2c
         e_old    = error
c         write (*,*)  ' ==== iteration=== ',iter,error
      CALL LocalFit(Radden,Radout,Dens,istart,imax,Nbin,
     &        r1,rho1,a2c,x2c,dR,dRho,dx2,da2,error,iFlag)
c          write (*,'(10x,"r1=",f8.4," rho1=",7g11.4," err=",g11.4,i2)')
c     &          r1,rho1,a2c,x2c,dR,dRho,dx2,da2,error,iFlag
         quality = (r1/r1_old-1.)**2+(rho1/rho1_old-1.)**2+
     &             (a2c/a2c_old-1)**2+(x2c/x2c_old-1)**2
         Converge = (quality.lt.1.e-4).and.
     &              (abs(error/e_old-1.).lt.1.e-3).and.
     &              (iter.gt.10).and.(iFlag.eq.0)
        dRho =max(min(dRho,rho1/10.),rho1/30.) 
         If(Converge)Goto40
      If(error.ge.e_old.and.iter.gt.10)Then
           r1  = r1_old  
           rho1= rho1_old
           a2c = a2c_old 
           x2c = x2c_old 
         dR =dR/1.21
         dRho =dRho/1.21
         dx2 =dx2/1.21
         da2 =da2/1.15
c          write (*,*)  '        restore center, reduce steps'
      EndIf
      If(iFlag.eq.0)Then
         dR =min(dR/1.41,r1/20.)
         dRho =min(dRho/1.41,rho1/20.)
         dx2 =dx2/1.41
         da2 =min(da2/1.25,a2c/20.)
c         write (*,*)  '        changed steps'
c      Else
c         dR =dr/1.01
c         dRho =drho/1.01
      EndIf 
      EndDo 

 40   Rs =r_1
c       write (*,'(10x,"r1=",f8.3," rho1=",7g11.4," err=",g11.3,2i4)')
c     &          r1,rho1,a2c,x2c,dR,dRho,dx2,da2,error,iFlag,iter

      CALL  FindVcMax(rmax,Vcmax,Rvir,r_s,r1,rho1,x2c,a2c,0.05)
      Rout =  Radden(imax)
      rhs  =  RhoExp(Rout,r1,rho1,x2c,a2c)/4.
      CALL FindRs(r_s2,r1,rho1,x2c,a2c,0.5,rhs,Rout)
      r_s =(r_s+r_s2)/2.
c      r_s =min(r_s,r_s2)
c      r_s =r_s2
c      If(Rvir/r_s.lt.4.)Then
c      write (*,'(" rmax,Vmax=",2f8.3," rs=",3g11.3)')rmax,Vcmax,
c     &                         r_s,Rout,Dens(imax)
c      do i=istart,imax
c         write(*,50) i,Radden(i),Dens(i),
c     &             RhoExp(Radden(i),r1,rho1,x2c,a2c),
c     &            rhs*Rout/Radden(i)*(1.+Rout/Radden(i))**2,
c     &      Vc(i),VcExp(Radden(i),r1,rho1,x2c,a2c)
c      enddo
c         EndIf
c 50   format(i3,' r= ',f8.3,' dens=',3g11.4,' v=',3f8.2)
      Rs    = r_s
      VVmax = Vcmax

      Return
      End
c-------------------------------------------------------------------- 
c                       Fit halo profile
      SUBROUTINE LocalFit(Radden,Radout,Dens,istart,imax,Nbin,
     &        Rc,Rhoc,a2c,x2c,dR,dRho,dx2,da2,error,iFlag)
      PARAMETER (Nbinmax = 85) !
      PARAMETER (nStepR  = 6)   ! number of bins in radius 
      PARAMETER (nStepRho= 6)   ! number of bins in Rho
      PARAMETER (nStepa2 = 6)   ! number of bins in a2
      PARAMETER (nStepx2 = 6)   ! number of bins in x2
      DIMENSION Radden(Nbin),Dens(Nbin),Radout(Nbinmax)
      Logical on_boundary

      Rmin = max(Rc -dR*nStepR/2.,Rc/10.)
      Rhomin = max(Rhoc -dRho*nStepRho/2.,Rhoc/10.)
      x2min = max(x2c - dx2*nStepx2/2.,1.e-2)
      a2min = max(a2c - da2*nStepa2/2.,a2c/10.)

c      write (*,'(5x," Rmin/max  =",4g11.4)')
c     &          Rmin,Rmin +nStepR*dR,Rc 
c      write (*,'(5x," Rhomin/max=",4g11.4)')
c     &          Rhomin,Rhomin +nStepRho*dRho,Rhoc 
c      write (*,'(5x," amin/max  =",4g11.4)')
c     &          a2min,a2min +nStepa2*da2,a2c 
c      write (*,'(5x," xmin/max  =",4g11.4)')
c     &          x2min,x2min +nStepx2*dx2,x2c 
      error =1.e+10
      Do ir =0,nStepR
         r11   = Rmin +ir*dR
         e_old = error
      Do irho =0,nStepRho
         rho11   = Rhomin +irho*dRho
      
      Do ix2  = 0,nStepx2
         x2   = x2min +ix2*dx2

      Do ia2  = 0,nStepa2
         a2   = a2min +ia2*da2
c         write (*,'(4g11.3,4i4)') r11,rho11,x2,a2,ir,irho,ix2,ia2
         ee =0.
         ww =0.
         do i=istart,imax
            w  = (Radout(i)-Radout(i-1))/Radden(i) 
            ee = ee + w*(log10(RhoExp( Radden(i),r11,rho11,x2,a2)/
     &                         Dens(i)))**2
            ww = ww + w
         EndDo
c         ee =ee/(imax-istart)
         ee =ee/ww
         If(ee.lt.error)then
            error = ee
            r_1   = r11
            rho_1 = rho11 
            a_2   = a2
            x_2   = x2
            ir_1  = ir
            irho_1= irho
            ix_1  = ix2
            ia_1  = ia2
        EndIf 
      EndDo 
      EndDo 

      EndDo
c          write (*,'(10x,"r1=",f8.3," rho1=",3g11.3," err=",g11.3,4i4)')
c     &          r_1,rho_1,a_2,x_2,error,ir_1,irho_1,ix_1,ia_1
c         If(abs(error-e_old).lt.1.e-5)Goto100 
      EndDo 

 100  on_boundary = .false.
      if(ir_1.eq.0.or.ir_1.eq.nStepR)on_boundary = .true.
      if(irho_1.eq.0.or.irho_1.eq.nStepRho)on_boundary = .true.
      if(ix_1.eq.0.or.ix_1.eq.nStepx2)on_boundary = .true.
      if(ia_1.eq.0.or.ia_1.eq.nStepa2)on_boundary = .true.
      iFlag = 0
      If(on_boundary)iFlag =1
      Rc  = r_1
      Rhoc= rho_1
      a2c = a_2
      x2c = x_2
c          write (*,'(10x,"r1=",f8.3," rho1=",3g11.3," err=",g11.3,4i4)')
c     &          r_1,rho_1,a_2,x_2,error,ir_1,irho_1,ix_1,ia_1

         Return
         End

c-------------------------------------------------------------------- 
c                         Exp-fit density profile
      FUNCTION RhoExp(r,r1,rho_1,x2,a2)
c                 input:  
c                          Vvmax = estimate of Vmax  
c-------------------------------------------------------------------- 
      x = r/r1
      RhoExp = rho_1/x*(exp(-x)+a2*exp(-x/x2))+1.

      Return
      End
c-------------------------------------------------------------------- 
c                         Exp-fit mass profile: dimensionless
c                         F =1-(1+x)exp(-x)
      FUNCTION FExp(x)
c-------------------------------------------------------------------- 
      real*8 y,Yexp
      y= x
      YExp = 1.d0-(1.d0+y)*exp(-y)
      FExp = YExp
      Return
      End
c-------------------------------------------------------------------- 
c                         Exp-fit velocity profile
      FUNCTION VcExp(r,r1,rho_1,x2,a2)
c                 output:  Vcirc in km/s
c                          
c-------------------------------------------------------------------- 
      x = r/r1
      VcExp = 6.698e-2*r1*sqrt(rho_1/x*(FExp(x)+a2*x2**2*FExp(x/x2)))

      Return
      End
c-------------------------------------------------------------------- 
c                        Vmax and effective r_s for Exp-fit velocity profile
      SUBROUTINE FindVcMax(r,Vcmax,Rvir,r_s,r_1,rho_1,x2,a2,dr)
c                 output:  Vcirc in km/s
c                          
c-------------------------------------------------------------------- 

      Vmax =0.
      iter =0
      r    = r_1
      Vv0  = VcExp(r,r_1,rho_1,x2,a2)
      Vv1  = VcExp(r+dr,r_1,rho_1,x2,a2)
      If(Vv1.gt.Vv0)Then
         r = r-dr
      Else
         r = 0
      EndIf
 10   iter =iter +1    ! Find Vcmax using the approximation
      r = r +dr
      Vv= VcExp(r,r_1,rho_1,x2,a2)
c      write (*,*)  '         VV,r=',Vv,r,Vmax
         If(Vv.gt.Vmax.and.r.lt.1.e4.and.r.lt.Rvir)Then
            Vmax = Vv
            GoTo 10
         EndIf 

         Vcmax = Vmax
         rmax  = r
c         write (*,*)  ' Vmax=',Vmax,' r=',r
c         r0 = r-dr/2.
c         V0= VcExp(r0,r_1,rho_1,x2,a2)  
c         r1 = r-dr
c         V1= VcExp(r1,r_1,rho_1,x2,a2)        
c         write (*,*)  ' V0=',V0,' r0=',r0      
c         write (*,*)  ' V1=',V1,' r1=',r1
      
      Vmax =0.945*Vcmax
      V2   = Vmax
      iter =0
      r    =0.
c      write (*,*)  ' V(rs)=',V2
 20   iter =iter +1    ! Find r_s: Vc(rs)=0.945Vmax
      r = r +dr
      Vv= VcExp(r,r_1,rho_1,x2,a2)
         If(Vv.lt.Vmax.and.r.lt.1.e4)Then
            GoTo 20
         EndIf 
         r_s =r
         r   =rmax
      Return
      End
c-------------------------------------------------------------------- 
c               Using density profile find Vmax and effective r_s for Exp-fit velocity profile
      SUBROUTINE FindRs(r_s,r_1,rho_1,x2,a2,dr,rhs,Rout)
c                 output:  Vcirc in km/s, r_s (kpc)
c               solve eq: rho(rs) = rho(Rout)/4*Rout/rs*(1+Rout/rs)**2               
c-------------------------------------------------------------------- 

      Vmax =0.
      iter =0
c      write (*,*)  ' Rout=',Rout,' rhs=',rhs
      r    = r_1/2.
 10   rho  = RhoExp(r,r_1,rho_1,x2,a2)
      rho_a= rhs*Rout/r*(1.+Rout/r)**2
c      write (*,*)  '     rho=',rho,' rho_a=',rho_a,r
      if(rho_a.lt.rho)Then
         r =r/2.
         If(r.lt.1.e-2)Then
            write (*,*)   'FindRs: initial guess failed'
            r_s = r_1/2
            return
         EndIf 
         goto 10
      EndIf 

 20   iter =iter +1    ! Find Vcmax using the approximation
      r = r +dr
      rho  = RhoExp(r,r_1,rho_1,x2,a2)
      rho_a= rhs*Rout/r*(1.+Rout/r)**2
c      write (*,*)  '     rho=',rho,' rho_a=',rho_a,r
      if(rho_a.gt.rho.and.r.lt.1.e3)goto20


         r_s =r
      Return
      End

C ______________________________ Profiles for 'Cooled' Simulations
C		             
C		                     
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMcool.h'
      REAL         AMprevious(Np),AMlast(Np),Daverg(0:500)
      Real*8       Xc,Yc,Zc
      DIMENSION    Iaverg(0:500)
      REAL         INPUT
      Character    FileASCII*100
      Character  File1*100,File2*100
      EQUIVALENCE (Ndisk,extras(90)),
     &               (Nbulge,extras(97)),(aMassDisk,extras(93)),
     &               (Box,extras(100))


c      aMassDisk =3.36e10/0.7     ! MOVIE mass of disk in real Msun
c      aMassDisk =1.e10    ! "Bulge"
c      aMassDisk =5.71e8      ! "Dwarf"
c      aMassDisk =4.8e10      ! "MW_LARGE"

C...................................................................
C			Read data and open files
       write(*,*)' enter 4 digits of the snapshot'
       read(*,*) moment
         write(File1,'("FILES/PMcrda.",i4.4,".DAT")')moment
         write(File2,'("FILES/PMcrs0a.",i4.4,".DAT")')moment
         write(*,*) File1
         write(*,*) File2

c      File1 ='PMcrd.DAT'
c      File2 ='PMcrs0.DAT'


      CALL RDTAPE(File1,File2)
         write(FileASCII,'("RESULTS/Result.DM.",i4.4,".dat")')
     &    INT(AEXPN*10000.)
      OPEN(37,FILE=FileASCII,STATUS='UNKNOWN') 
 
        write(FileASCII,'("RESULTS/Result.SPH.",i4.4,".dat")')
     &    INT(AEXPN*10000.)
      OPEN(39,FILE=FileASCII,STATUS='UNKNOWN') 

         write(FileASCII,'("RESULTS/Result.CYL.",i4.4,".dat")')
     &    INT(AEXPN*10000.)
      OPEN(41,FILE=FileASCII,STATUS='UNKNOWN') 

      OPEN(18,FILE='Stat.dat',STATUS='UNKNOWN',access='append')
      OPEN(20,FILE='particles.dat',STATUS='UNKNOWN')
      OPEN(30,FILE='particlesu.dat',STATUS='UNKNOWN',form='UNFORMATTED')
      OPEN(40,FILE='FILES/cooling_part.dat',STATUS='UNKNOWN',
     &              form='UNFORMATTED')

      CALL ReadCool
      time      = (age(AEXPN)-age(0.6))/1.e9
      
      aMassOne= Om0*(Box/NGRID)**3 *wspecies(1)*2.746e+11/hubble ! mass scale
      write (*,'(6x,"Mass of smallest particle",/9x,
     +    "in units M_sun/h is   =",3x,g10.3)') 
     +      aMassOne
      ScaleM = aMassOne

      xfrac        = extras(51) ! fraction of particles to be cooled
      cool_frac    = extras(52) ! total cooling
      cfrac        = extras(53) ! cooling per step
      aexpn_s      = extras(54) ! start cooling
      aexpn_e      = extras(55) ! and cooling
      xm_part      = extras(59) ! particle weight (h^-1 M_s)
      i_cool_all    = INT(extras(58) + 0.1)  !total # of cooling steps
      

      write (*,*) ' RDTAPE is done Time=',time,' a=',AEXPN
      write (*,*)  ' mass particle(extr(59))=',xm_part
      Do i=37,41,2
          WRITE (i,100) HEADER,AEXPN,ASTEP,time,
     +                  ISTEP,
     +                  NROWC,NGRID,Om0,Oml0,hubble,
     +                  Ocurv
      write (i,104) xfrac
      write (i,105) cool_frac 
      write (i,106) cfrac 
      write (i,107) i_cool_all
      write (i,108) aexpn_s
      write (i,109) aexpn_e
      a_cool= cfrac
      b_cool= cfrac
      c_cool= 0.1*cfrac
      write (i,110) a_cool
      write (i,111) b_cool
      write (i,112) c_cool

      EndDo 
100   FORMAT(1X,'Header=>',A45,/
     +    T2,'Aexp',T12,'dA',T22,'Time(Gyrs)',T35,'Step',/
     &    T2,f8.4,T12,f8.5,T22,g11.3,T35,i4,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3)
 104  FORMAT ( ' frac. cooled particles  = ',F6.3 )
 105  FORMAT ( ' total amount of cooling = ',F6.3 )
 106  FORMAT ( ' cooling per step        = ',F6.3 )
 107  FORMAT ( ' total # of cooling steps= ',I6)
 108  FORMAT ( ' start cooling aexpn     = ',F6.3 )
 109  FORMAT ( ' end   cooling aexpn     = ',F6.3 )
 110  FORMAT ( ' a_cool                  = ',F6.3 )
 111  FORMAT ( ' b_cool                  = ',F6.3 )
 112  FORMAT ( ' c_cool                  = ',F6.3 )
      BoxV   = Box*100.    ! Box size in km/s
      ScaleV = BoxV/AEXPN/NGRID      ! scale factor for Velocities (km/s)
      ScaleC = Box/NGRID*AEXPN/hubble  ! scale factor for Coordinates (real Mpc)
      ScaleH  = 100.*hubble*sqrt(Om0/AEXPN**3+Oml0) ! H(a)=km/s/Mpc

      i_halo = 1   ! read and analyze this halo
      kkF    = iph_cool(i_halo,2)  ! first particle
      kkL    = iph_cool(i_halo,3)  ! last particle
      CALL ReadPnts(N,ScaleC,ScaleV,ScaleM)
      Call ChangePnts(N,Box,ScaleH,Ndisk)
      Call DumpPnts(N,Box,ScaleM,Ndisk)
c      Call Statist(N,Box,ScaleM,Ndisk)
c      Call AngMom(N,30000,3.,Box,ScaleM)
      Call Profile(N,Box,ScaleM,Ndisk)
c      Call Projection(N,Box,0.)
c      Call Projection(N,Box,5.)

      END

c-------------------------------------------------------------------- 
c                 Test OMP parallelization
c-------------------------------------------------------------------- 
      parameter (N = 500 )
      parameter (NN= N**3)
      COMMON /aa/ A(NN)
      real*8    sum,sum1

      write (*,*)  ' Required Memory=',4.*N**3/1024.**2,'Mb'
      w =NN
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP+PRIVATE (i)
      Do i=1,NN
            A(i)=i/5.
      EndDo 

      sum = 0.
      Do i=1,NN
            sum =sum + A(i)**2
      EndDo 

      m=1e4
      CALL SMOOTH(m)
      sum1 = 0.
      Do i=1,NN
            sum1 =sum1 + A(i)**2
      EndDo 
      write (*,*)  ' smoothing=',m
      write (*,*)  ' average=',sqrt(sum/NN)
      write (*,*)  ' average=',sqrt(sum1/NN)
      write (*,*) 'Test: serial mode'
           stop
           end

c-------------------------------------------------------------------- 
c
      SUBROUTINE SMOOTH(m)
      parameter (N = 500 )
      parameter (NN= N**3)
      COMMON /aa/ A(NN)
      real*8    sum,norm

      istep = 1 ! max((2.*m+1)/100.,1.)+1
      norm =(2.*m+1)/istep
      write (*,*)  ' istep =',istep,m
      write (*,*)  ' steps=',norm
      Ns =5e7
      Ne =Ns+4e6
      Ne =min(Ne,NN)
      write (*,*)  ' Start,End=',Ns,Ne
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP+PRIVATE (i,sum,i1,ii,j,ic,cpucost)
      Do i=Ns,Ne
         if(mod(i-Ns,100).eq.0) write (*,*)  ' i=',i

               sum =0.
               Do i1=-m,m,10
                 ii = max(min(max(i+i1,1),N),1)

		do ic =1,100000
			cpucost =log10(float(ic))**2
		enddo
                 sum = sum +A(ii)*cpucost
               EndDo 


		A(i) =sum/norm








      EndDo 

      Return
      end

C-------------------------------------------------
C        A.Klypin 25 Nov.1997 (NMSU)
C                            Bound-Density-Maxima code:
C                            Find  maxima of mass in spheres of radius Rsearch1 
C                            for particles in a periodic cube     of size     Box
C                           Coordinates: 0-NGRID,  Box =NGRID
C       All variables and constants are scaled to the Hubble constant of your
C       model. Only FINAL values are rescled to H=100km/s/Mpc
C       More detailed description of the algorithm and the code can be
C       found in file BDM_describe
C--------------------------------------------------   
C       Arrays Label and Lst provide quick access to neibhor particles
C       Label(i,j,k) = number of the first particle in
c                      the cell (i,j,k), if Label .ne. 0
C                    = 0 - empty cell
C       Cell         = size of a cell for Label
C       Lst(i)       = number of the next particle in the cell,
C                      where i-th was found.
C                      If Lst=0 - last point in the cell was found.
C     
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      Real             INPUT,Mhalo
      Real             Overdens(Nrad),Mass(Nrad),MnMass(Nrad)
      COMMON /OVER/ Ovlim,Ovcnt
      DIMENSION      Radsc(Nrad)

      Ovcnt   =INPUT('Enter Min. Center Overdensity for Halos   => ')
      Ovlim   =INPUT('Enter Overdensity Threshold for Halos     => ')
      Amassl  =INPUT('Enter Minimum halo mass in Msun/h         => ')      
      Rsearch1=INPUT('Enter comoving search radius(Mpc/h)       => ')
      Rsearch2=INPUT('Enter smaller radius(Mpc/h) of final halos=> ')
      Rminhalo=INPUT('Enter min.radius for halos(Mpc/h)         => ')
      Fract   =INPUT('Enter fraction of DM particles (1/4,1/2,1)=> ')
      Fract   =Min(Max(Fract,0.),1.0)                             
      Toohot  =INPUT('Enter rejection velocity limit (V/Vescape)=> ')
      dRdubl  =INPUT('Distance to check for Velocity duplicates => ')
      fVdubl  =INPUT('Define duplicates if  (v1-v2)/Vrms   <       ')     
      Box     =INPUT('Enter Comoving Box size(Mpc/h)            => ')
      write (*,*)
C     ------------------------------------------ Open files
      Open( 2,file='Catshort.DAT')   ! short list of halos
      Open( 3,file='Catshort.1.5Mpc.DAT')   !  list of centers
c      Open( 3,file='SelSph.DAT',FORM='UNFORMATTED')   ! short list of particles
      Open(20,file='Catalog.DAT')   ! complete catalog with data for shells
C     ------------------------------------------ Read data
      CALL RDTAPE
            write (*,*) ' RDTAPE is done'
            write (*,*) ' Nnu=Number of Species=',Nspecies
      CALL ReadPnt(N,Fract)                     ! particles
c       CALL ReadMax(N,Fract)                     ! particles
         WRITE (2,100) HEADER,
     +               AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +               EKIN,NROW,NGRID,Om0,Oml0,hubble
         WRITE (20,100) HEADER,
     +               AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +               EKIN,NROW,NGRID,Om0,Oml0,hubble
100      FORMAT(1X,'Header=>',A45,/
     +         ' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +         ' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,
     +         ' Nrow=',I4,' Ngrid=',I4,/' Omega_0=',f6.3,
     +         ' Omega_L=',f6.3,' h=',f6.3)
C     ------------------------------------------ Constants ---------
           hsmall= hubble            ! Hubble/100.
           Box   = Box /hsmall       ! Scale to real Mpc          
           Omcold= Om0 
           Omhot = 0.
           Amassl= Amassl/hsmall     ! Scale to real masses
           Radius= Rsearch1/hsmall  ! Comoving Search radius in real Mpc
           Rminhalo=Rminhalo/hsmall
           dRdubl= dRdubl/hsmall
           Xscale= Box/Ngrid        ! Scale for comoving coordinates
           Vscale= 100.*hsmall*Xscale/AEXPN ! Scale for velocities
           Dscale= 2.746e+11*hsmall**2*(Box/NROW)**3 ! mass scale
C                            Dscale is a factor used to convert particles to mass 
C                                       =  mass of a particle for Omega=1 model
C                            Xscale is a factor to convert PM coordinates into Mpc
C                                       = Box / Ngrid = length of a PM cell in Mpc
C                           Vscale is a factor to convert PM pomenta to V (km/sec)
C                                       = the Hubble velocity at the distance of 1 PM cell
C                              the factor AEXPN is needed to go from momenta to pec.velocity
           write (*,*) ' Vscale=',Vscale, ' X=',Xscale,' Box(Mpc)=',Box
           Radius=Radius/Xscale    ! comoving radius in cell units
           RadSr1 =Rsearch1/hsmall/Xscale ! max Min search radii
           RadSr2 =Rsearch2/hsmall/Xscale           
           Cell  =2.0              ! Cell-size for Linker List in grid units
           Box   =NGRID            ! all internal variables are in Grid units
           Riter =0.0001           ! Error for iteration of radius in cell units
           Rmax  =Radius           ! Treat maxima Identical  if dR<Rmax
           imin  =INT(-Radius/Cell)! Make recommendations. Code works 
           imax  =INT((Box+Radius)/Cell) ! if the limits are not optimal
                   If(imin.lt.Nm)Write(*,*)
     .               ' Wrong low limit:',Nm,' better be',imin
                   If(imax.gt.Nb)Write(*,*)
     .               ' Wrong upper limit:',Nb,' better be',imax
           write (*,*) 
     .        ' Box(cells)=',Box,' Cell=',Cell,' Rad(cells)=',Radius
         DtoNscale = Om0*Dscale/Fract ! scale dark matter particles
         ANlimit_0 =5.         ! and this
         ANlimit =Amassl/(DtoNscale)         ! and this
            R0    =0.004
           Rnrad =R0*((Nrad-1)/2.+1.)**1.5 
           Expect =10.*Ovlim*(NROW/float(NGRID))**3/Fract *
     &                   (4.1888* (R0/hsmall/Xscale)**3 )
           write (*,'(/" The first and the last shells have radii:",
     &                   2f8.4," Mpc/h, comoving")')  R0,Rnrad
           write (*,'( " Mass of a particle is                    ",
     &                   g11.3," M_sun/h")')          Om0*Dscale*hsmall

           write (*,'( " Halos will have more than                ",
     &                   g11.3," particles",/
     &                  "     inside search radius=                ",
     &                   F7.3," Mpc/h =", F7.2," cell units")')
     &                   ANlimit_0,Rsearch1,Rsearch1/hsmall/Xscale
           write (*,'( " Expected Nparticles in the first shell   ",
     &                   g11.3)') Expect
           write (*,'( "     assuming overdensity                 ",
     &                   g11.3)') Ovlim*10.     
           write (*,*) '   If you want to change shells, enter a factor'
           write (*,'(A,$)') '    or 1 to keep current radii : '
           read  (*,*) factor
           If(abs(factor-1.).ge.1.e-3.and.factor.gt.0.)Then
              R0    =0.004 * factor
              Rnrad =R0*((Nrad-1)/2.+1.)**1.5           
              write (*,*) '   The first and the last radii for halos'
              write (*,*) '   will be',R0,Rnrad,' Mpc/h, comoving'
           EndIf
           Do ir=1,Nrad                            ! Radii for halo shells
              Rad(ir) =R0/hsmall*((ir-1)/2.+1.)**1.5/Xscale ! comoving
              Rad2(ir)=Rad(ir)**2
           EndDo
           write (*,*) ' Radii(Mpc/h): 1st=',Rad(1)*Xscale*hsmall,
     +                  ' last=',Rad(Nrad)*Xscale*hsmall,' h=',hsmall
c------------------------------------------ Prepare Data
           RadOld =Radius
           Radius  =Rad(Nrad)            ! Make radius temporarily bigger
      CALL Points(Box,N,Ncp)            ! Make more points periodically
          write (*,*) ' Nparticles in periodic set=',Ncp,
     .              '( Maximim =',Np,')'
          write (2,*) ' Nparticles in periodic set=',Ncp,
     .              '( Maximum =',Np,')'
           Radius =RadOld                ! Restore radius
      Call List(Box,Ncp)                ! make linker List, Label
c                 CALL ReadMax(Ncentr,Xscale)                  ! read centers from a file
      CALL ReadCent(N,Ncentr)   ! read initial centers
c      CALL ReadMax(Ncentr,Xscale*hsmall)   ! read initial centers

          write (*,*) ' Nparticles=',N,' Ncenters=',Ncentr
C----------------------------- Find maxima
      CALL Pairs(Box,N,Ncentr,Riter)       ! find maxima 
      write (*,16)  Amassl*hsmall,ANlimit,Rminhalo*hsmall,
     &               Rsearch1,Rsearch2,Toohot
      write (2,16)  Amassl*hsmall,ANlimit,Rminhalo*hsmall,
     &               Rsearch1,Rsearch2,Toohot
      write (20,16) Amassl*hsmall,ANlimit,Rminhalo*hsmall,
     &               Rsearch1,Rsearch2,Toohot
      write (*,*) ' Om0=',Om0,' Dscale=',Dscale
 16   format(5x,'Small halos with Mass(M_sun/h) less than',
     .       g10.3,'(N_eff<',g11.3,') were removed',/
     .       5x,'Minimum Radius of Halo(Mpc/h)=',f7.4,/
     .       5x,'Comov.Search radius(Mpc/h)=',f7.4,
     .         ' Second radius(Mpc/h)=',f7.4,/
     .       5x,'Particles with V>',f5.1,'V_escape were removed')
      CALL SmallRem(ANlimit_0,Ncentr)  ! Remove small halos
      CALL CATALOG(Box,Ncentr)      ! Remove duplicates
C                                         Final touch: if Rsearch1 and Rsearch2 are different
C                                               then  improve position of halos by shrinking
C                                              the search Radius to Rsearch2 in three steps
      IF(ABS(Rsearch1-Rsearch2).gt.0.001*Rsearch1)Then
         Nit =5
         hNit =(Rsearch1/Rsearch2)**(1./Nit)
         write (*,*) ' Nit =',Nit,hNit
        Do ii =1,Nit
            n1 = 0
            r1  =0.
            Do i=1,Ncentr
      	     If(Rmc(i).gt.RadSr2)Then
                    n1       =n1 +1
                    Rmc(i)=Rmc(i)/hNit
                    r1        =r1 +Rmc(i)
                 Endif
             Enddo 
          write (*,*)'Iterate:',
     &               ' Mean Comoving Radius for halos(Mpc/h)=',
     &                   r1/(max(n1,1))*Xscale*hsmall,' n=',n1
          CALL Pairs(Box,N,Ncentr,Riter) 
        EndDo
        Radius=Rsearch1
        CALL CATALOG(Box,Ncentr)      !  Remove duplicates
      EndIf
       write (*,20) N,Ncentr,Box*Xscale*hsmall,Ovlim,Fract
       write (2,20) N,Ncentr,Box*Xscale*hsmall,Ovlim,Fract
       write (20,20)N,Ncentr,Box*Xscale*hsmall,Ovlim,Fract
20         Format(5x,'Statistics for ',i9,' points. Maxima=',i6,/
     .         5x,'Box(Mpc)=',f6.1,
     .            5x,'Overdensity Limit=',f6.1,
     .             ' Fraction of DM particles=',f5.3)
      CALL SPairs(Box,N,Ncentr)  ! Accumulate  statistics 
 
C-----------------------------      Auxiliary Settings
      nfalse =0
      Do ir=1,Nrad                  ! all scaled to hubble, not h^(-1)
         Radsc(ir) =Rad(ir) *Xscale ! scale radii to comoving Mpc
         MnMass(ir)=Om0*4.188*2.746e+11*hubble**2*Radsc(ir)**3 
c                                   mass at the mean density
      EndDo
      write (*,12) (Radsc(i)*hsmall*1000.,i=1,Nrad)
      write (2,12) (Radsc(i)*hsmall*1000.,i=1,Nrad)
      write (20,12) (Radsc(i)*hsmall*1000.,i=1,Nrad)
 12   Format(5x,'Radii of shells in comoving kpc/h:',/20(4x,10f7.2/))
      write (*,15) Radsc(min(Nrad_lim,Nrad))*hsmall*1000.
      write (2,15) Radsc(min(Nrad_lim,Nrad))*hsmall*1000.
      write (20,15) Radsc(min(Nrad_lim,Nrad))*hsmall*1000.
 15   Format(5x,'Maximum Radius for Finding V_circ (kpc/h)=',f8.2)
C---------------------------- Process Halos : Undind, Dublicates 
      CALL CLEAN(Ncentr,Xscale,Vscale,Dscale, 
     +            Fract,Radsc,MnMass,Toohot,Rminhalo)
      IF(fVdubl .gt.0. .and. dRdubl.gt.0.)Then    !  Remove VelDublicates
          dRdubl =dRdubl/Xscale                       ! scale to cell units
         CALL RemVelDubl(Box,Ncentr,dRdubl,fVdubl,Xscale,Vscale) 
         write (*,25) Ncentr,dRdubl*Xscale*hsmall ,fVdubl
         write (2,25) Ncentr,dRdubl*Xscale*hsmall ,fVdubl
         write (20,25)Ncentr,dRdubl*Xscale*hsmall ,fVdubl
 25       Format(5x,'Number of centers=',i6,
     &                   2x,'Velocity Duplicates: dR(Mpc/h)<',f6.3,
     &                   2x,'dV/Vrms<',f6.3)
       ENDIF
C------------------------------- Print Results
      write ( 2,13)
      write (20,13)
 13   Format(6x,'Coordinates Mpc',9x,'Velocity km/s',7x,
     &   'Mass   Rad(kpc/h) Vrms(3D) Vcirc Npart')
       write (20,14)
 14   Format('R(kpc/h)',' N(<R)    M/Msun   Overdens   Vrms  Vcirc',
     &                  ' Dens(R)Msun/Mpc^3')
      Do i=1,Ncentr          ! Scale all to physical units
         Xc    =Xm(i)  *Xscale
         Yc    =Ym(i)  *Xscale
         Zc    =Zm(i)  *Xscale
         irad  =iRadius(i)
         Mhalo =Amc(i)
         Rhalo =Rmc(i)
         Vcirc =Vrm(i)
         Do ir =1,Nrad
            Summass     = Om0*Nbc(i,ir)/Fract
            Mass(ir)    = Dscale*Summass
            Overdens(ir)= Mass(ir)/MnMass(ir)
         EndDo

c         write (*,*) i,Xc*hsmall,Yc*hsmall,Zc*hsmall,
c     &                ' R=',Rhalo,Rminhalo
c         write (*,*) '        ',
c     &                ' M=',Mhalo*hsmall,Amassl*hsmall

         If(irad.eq.0.or.Rhalo.le.Rminhalo
     .         .or.Mhalo.le.Amassl.and.Vcirc.gt.140.)nfalse=nfalse+1
c      .         .or.Mhalo.le.Amassl)nfalse=nfalse+1
        If((irad.ne.0.and.Rhalo.gt.Rminhalo)
     .                .and.Mhalo.gt.Amassl.and.Vcirc.gt.140.)Then
c     .                .and.Mhalo.gt.Amassl)Then
            irr =Max(irad,2)         ! don't take V from the first bin
            VXc =Wxc(i,irr)   *Vscale
            VYc =Wyc(i,irr)   *Vscale
            VZc =Wzc(i,irr)   *Vscale

            Nnp =INT(Mhalo/(Dscale*Om0))
             write (20,45) Xc*hsmall,Yc*hsmall,Zc*hsmall,
     &                      VXc,VYc,VZc,Mhalo*hsmall,
     &                      Rhalo*hsmall*1000.,Vrmc(i,irr),
     &                      Vcirc,Nnp
             write ( 2,45) Xc*hsmall,Yc*hsmall,Zc*hsmall,
     &                      VXc,VYc,VZc,Mhalo*hsmall,
     &                      Rhalo*hsmall*1000.,Vrmc(i,irr),
     &                      Vcirc,Nnp

            Do ir=1,Nrad
               If(ir.eq.1)Then
                  Vvc =Vrmc(i,ir)
                  Volume =4.188*Radsc(ir)**3
                  DenDm=Mass(ir)/Volume
                  If(Nbc(i,ir).le.2)Then ! too few particles
                      Radmean =Radsc(ir)/2.**0.3333
                  Else         ! take real mean radius
                      Radmean  =Rrc(i,ir)*Xscale/Nbc(i,ir)
                  EndIf
                  Vcr    =sqrt(Mass(1)/Radsc(1)/AEXPN)*6.58e-5
               Else              ! remove contribution from inner rad
                  Vvc =sqrt(MAX((Vrmc(i,ir)**2*Nbc(i,ir) -
     .              Vrmc(i,ir-1)**2*Nbc(i,ir-1))/
     .              max(Nbc(i,ir) -Nbc(i,ir-1),1),1.e-10))
                  Volume =4.188*(Radsc(ir)**3- Radsc(ir-1)**3) 
                  DenDm  =(Mass(ir)-Mass(ir-1)) /Volume
                  If(Nbc(i,ir) -Nbc(i,ir-1).le.2)Then ! too few particles
                     Radmean=((Radsc(ir)**3+Radsc(ir-1)**3)/2.)**0.333
                  Else         ! take real mean radius
                     Radmean=(Rrc(i,ir)-Rrc(i,ir-1))*Xscale/
     .                        (Nbc(i,ir)-Nbc(i,ir-1))
                  EndIf
                  Vcr    =sqrt(Mass(ir)/Radsc(ir)/AEXPN)*6.58e-5
                EndIf
c                Bmx =Agx(i,ir)*Xscale*Vscale ! Rescale angular momentum
c                Bmy =Agy(i,ir)*Xscale*Vscale
c                Bmz =Agz(i,ir)*Xscale*Vscale
c                BmT = SQRT(Bmx**2 +Bmy**2 +Bmz**2)
               write (20,40) Radmean*hsmall*1000.,
     .                       Nbc(i,ir),Mass(ir)*hsmall,Overdens(ir),
     .                       Vvc,Vcr,DenDm/hsmall**2
c     .               ,Bmx*hsmall,Bmy*hsmall,Bmz*hsmall,BmT*hsmall
            EndDo  ! end loop ir
45          Format(F7.4,2F8.4,3F8.1,g11.3,f7.1,2f7.1,I7,I7)
40          Format(f8.2,I7,g11.3,g10.3,2f7.1,3g10.3,4g10.3)
41          Format(f7.4,I7,I6,g11.3,g10.3,2f7.1,f6.3,g11.3,4G11.3)
         Endif
      EndDo    !  end loop Ncentr
      write (*,50) Ncentr-nfalse,nfalse
c      write (2,50) Ncentr,nfalse
 50   Format('---------- Final Catalog has ',i7,' halos ------------',
     .      /'                    ',i7,' were too puffy or too small') 
      Stop
      End
C--------------------------------------------------------------
C                                           Make linker lists of particles in each cell
      SUBROUTINE List(Box,Ncp)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
             Do i=1,Ncp
                Lst(i)=-1
             EndDo

             Do k=Nm,Nb
             Do j=Nm,Nb
             Do i=Nm,Nb
                Label(i,j,k)=0
             EndDo
             EndDo
             EndDo  
      Do jp=1,Ncp
         i=INT(Xp(jp)/Cell)
         j=INT(Yp(jp)/Cell)
         k=INT(Zp(jp)/Cell)
         i=MIN(MAX(Nm,i),Nb)
         j=MIN(MAX(Nm,j),Nb)
         k=MIN(MAX(Nm,k),Nb)
         Lst(jp)      =Label(i,j,k)
         Label(i,j,k) =jp
      EndDo

      Return
      End
C--------------------------------------------------------------
C                                Find all neibhours for a center
C                                Xc,Yc,Zc - center; a0 -its weight
C
      SUBROUTINE Neib(Xnew,Ynew,Znew,Amnew)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
C                                       Initiate counters
        Xnew =0.
        Ynew =0.
        Znew =0.
  	     Amnew=0.
        Radius2=Radius**2
c                      limits for Label
         i1=INT((Xc-Radius)/Cell)
         j1=INT((Yc-Radius)/Cell)
         k1=INT((Zc-Radius)/Cell)
            i1=MIN(MAX(Nm,i1),Nb)
            j1=MIN(MAX(Nm,j1),Nb)
            k1=MIN(MAX(Nm,k1),Nb)
         i2=INT((Xc+Radius)/Cell)
         j2=INT((Yc+Radius)/Cell)
         k2=INT((Zc+Radius)/Cell)
            i2=MIN(MAX(Nm,i2),Nb)
            j2=MIN(MAX(Nm,j2),Nb)
            k2=MIN(MAX(Nm,k2),Nb)
C                                        Look for neibhours
            nn =0
         Do k=k1,k2
         Do j=j1,j2
         Do i=i1,i2
            jp =Label(i,j,k)
 10         If(jp.ne.0)Then
               dd =(Xc-Xp(jp))**2+(Yc-Yp(jp))**2+(Zc-Zp(jp))**2
               If(dd.lt.Radius2)Then
                  nn =nn +1
	             Xnew =Xnew +Xp(jp)
	             Ynew =Ynew +Yp(jp)
	             Znew =Znew +Zp(jp)
	             Amnew=Amnew+1.
               EndIf  
                  jp =Lst(jp)
               GoTo10
            EndIf
         EndDo
         EndDo
         EndDo
         	If(Amnew.GT.0.)Then
	            Xnew =Xnew /Amnew
	            Ynew =Ynew /Amnew
	            Znew =Znew /Amnew
            EndIf
      Return
      End
C--------------------------------------------------------------
C                                Find all neibhours for a center
C                                Xc,Yc,Zc - center; 
C                               
      SUBROUTINE SNeib
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'

         Radmax =Rad(Nrad)
         Do i=1,Nrad
              Nob1(i) =0
              Rob1(i) =0.
              Vx1(i)  =0.
              Vy1(i)  =0.
              Vz1(i)  =0.
              Vxx(i)  =0.
         EndDo
c                      limits for Label
         i1=INT((Xc-Radmax)/Cell)
         j1=INT((Yc-Radmax)/Cell)
         k1=INT((Zc-Radmax)/Cell)
            i1=MIN(MAX(Nm,i1),Nb)
            j1=MIN(MAX(Nm,j1),Nb)
            k1=MIN(MAX(Nm,k1),Nb)
         i2=INT((Xc+Radmax)/Cell)
         j2=INT((Yc+Radmax)/Cell)
         k2=INT((Zc+Radmax)/Cell)
            i2=MIN(MAX(Nm,i2),Nb)
            j2=MIN(MAX(Nm,j2),Nb)
            k2=MIN(MAX(Nm,k2),Nb)
C                                        Look for neibhours
         Do k=k1,k2
         Do j=j1,j2
         Do i=i1,i2
            jp =Label(i,j,k)   !  Dark matter
 10         If(jp.ne.0)Then
               dd =(Xc-Xp(jp))**2+(Yc-Yp(jp))**2+(Zc-Zp(jp))**2
               Do ir =1,Nrad
                  If(dd.lt.Rad2(ir))Then
                    Nob1(ir)= Nob1(ir)+ 1
                    Rob1(ir)= Rob1(ir)+ sqrt(dd)
                    Vxx(ir) = Vxx(ir) +VXp(jp)**2+VYp(jp)**2+VZp(jp)**2
                    Vx1(ir) = Vx1(ir) +VXp(jp)  
                    Vy1(ir) = Vy1(ir) +VYp(jp)
                    Vz1(ir) = Vz1(ir) +VZp(jp)
                  EndIf
               EndDo
               jp =Lst(jp)
               GoTo10
            EndIf
         EndDo
         EndDo
         EndDo
         Do ir=1,Nrad
            Vmn =0.
	         If(Nob1(ir).GT.0)Then
               Nobj    = Nob1(ir)
               Vx1(ir) = Vx1(ir)/Nobj
               Vy1(ir) = Vy1(ir)/Nobj
               Vz1(ir) = Vz1(ir)/Nobj
               Vmn     = Vx1(ir)**2+Vy1(ir)**2+Vz1(ir)**2
               Vxx(ir) = SQRT(ABS(Vxx(ir)/Nobj -Vmn))
	         EndIf
         EndDo
      Return
      End
C--------------------------------------------------------------
C                       Add points around the Box to take into account periodical conditions
C  It replicates points periodically and keeps those which are at  distance
C  less than Radius from the Box. 
C                        N     = number of points inside the Box
C                        Ncp = total number of points
      SUBROUTINE Points(Box,N,Ncp)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      Logical    Inside
         B1  =-Radius
         B2  =Box+Radius
         B3  =Box-Radius
         Ncp =N
      Do i=1,N               ! Add dark matter particles
         x0 =xp(i)
         y0 =yp(i)
         z0 =zp(i)
         Inside =            (x0.gt.Radius).and.(x0.lt.B3)
         Inside =Inside.and.((y0.gt.Radius).and.(y0.lt.B3))
         Inside =Inside.and.((z0.gt.Radius).and.(z0.lt.B3))
         If(.not.Inside)THEN         
         ux =VXp(i)
         uy =VYp(i)
         uz =VZp(i)
            Do k1 = -1,1
               zr =z0+k1*Box
               If(zr.GT.B1.AND.zr.LT.B2)Then
               kk =k1**2
               Do j1 = -1,1
                  yr =y0+j1*Box
                  If(yr.GT.B1.AND.yr.LT.B2)Then
                     jj = kk +j1**2
                     Do i1 = -1,1
                        xr =x0+i1*Box
                        ii =jj +i1**2
                        If((xr.GT.B1.AND.xr.LT.B2).AND.ii.ne.0)
     .                     Then
                             Ncp =Ncp +1
                             If(Ncp.le.Np)Then
                               xp(Ncp)  =xr
                               yp(Ncp)  =yr
                               zp(Ncp)  =zr
                               VXp(Ncp)  =ux
                               VYp(Ncp)  =uy
                               VZp(Ncp)  =uz
                             EndIf
                        EndIf
                     EndDo
                  EndIf
               EndDo
               EndIf
            EndDo
         EndIf
      EndDo
      If(Ncp.Gt.Np)Then
         write(*,*)' Too many points:',Ncp,' Maximum is =', Np
         STOP
      EndIf
      Return
      End
C-------------------------------------------------------------
C                     Find positions of 'Ncentr' spheres, which maximize number of particles
C                    inside 'radius Radius'. 
C                    Iterations are repeated until 1) mass stops increasing   OR
C                                                       2) the sphere stops moving: dR is less than Riter 
C                    Looks for all particles inside Radius for periodical set 
      SUBROUTINE Pairs(Box,N,Ncentr,Riter)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      INTEGER Lab(Nc)
      Do i=1,Ncentr
      	Lab(i) =1
         Amc(i) =0
         If(Rmc(i).lt.1.e-8)write (*,*) ' Error in Rmc: zero',Rmc(i),i
         If(Rmc(i).le.0.5*RadSr2)
     &               write (*,*) ' Error in Rmc: too small ',Rmc(i),i
         If(Rmc(i).gt.RadSr1)write (*,*) ' Error in Rmc: big ',Rmc(i),i
c         Rmc(i) =Radius
      EndDo
      Niter =0
10    Iter  =0
      Niter =Niter +1
      Do i=1,Ncentr
         Xc =Xm(i)
         Yc =Ym(i)
         Zc =Zm(i)
         a0 =Amc(i)
         in =Lab(i)
         Radius =Rmc(i)
         If(Radius.lt.0.999*RadSR2)in =-Niter
         If(in.gt.0)Then         ! If not converged, keep iterating
            Call Neib(Xnew,Ynew,Znew,Amnew) ! new center of mass
            Dr =MAX(ABS(Xnew-Xc),ABS(Ynew-Yc),ABS(Znew-Zc))
            IF(Dr.LT.Riter.or.Amnew.lt.Amc(i))
     .                  Lab(i)=-Niter     ! iterations converged
            Iter =Iter +1
	         IF(Xnew.lt.0.)Xnew =Xnew+Box
	         IF(Ynew.lt.0.)Ynew =Ynew+Box
	         IF(Znew.lt.0.)Znew =Znew+Box
	         IF(Xnew.gt.Box)Xnew =Xnew-Box
	         IF(Ynew.gt.Box)Ynew =Ynew-Box
	         IF(Znew.gt.Box)Znew =Znew-Box
            Xm(i)  = Xnew
            Ym(i)  = Ynew
            Zm(i)  = Znew
            Amc(i) = Amnew
         EndIf
      EndDo
      Write (*,*) ' Iteration=',Niter,' Centers left=',Iter
      If(Iter.GE.1 .and. Niter.LT.100)Goto10
      Return
      End

C-------------------------------- Remove dublicates in Velocity
C                   If distance is less than 'dRdubl' and 
C                   if difference in velocitiy is less than a fraction
C                   'fVdubl' of the velocity dispersion -->
C                   dublicates: keep only one (largest) halo
C
C  Condition of proximity in velocity depends on how close are halos
C  in space. Halos with velocity difference dv =sqrt(vx_1-vx_2)^2 +(y)+ (z)),
C  at distance d one from the other, with mass ratio 1/1.5 < M1/M2 < 1.5
C   and with internal velocity dispersions Vrms_1 and Vrms_2
C   are considered too close ('dublicates')
C  if     dv < fVdubl*max(Vrms_1,Vrms_2)*sqrt(6-5(d/dRdubl)^2)

      SUBROUTINE RemVelDubl(Box,Ncentr,dRdubl,fVdubl,Xscale,Vscale)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      Logical    Lab(Nc)
      Real      Mhalo,Mhalo2

      dR2 = dRdubl**2
      fV2 = fVdubl**2
      Vol_2 =Rad(2)**3-Rad(1)**3
      nrem= 0
      Do i=1,Ncentr
         Lab(i) =.true.
      EndDo
      write (*,50)
 50   format(5X,'<========  Remove fake halos ========>',
     &     /17x,'difference in velocities dV is small as compared with',
     &     /17x,'internal rms velocity Vrms',
     &          ' and halos are close in space',/
     &     4x,'dR(Mpc)',' dV(km/s)',' Vrms(km/s)',
     &        ' N_part_halo_1',' N_part_halo_2',
     &        ' dVx(km/s) dVy(km/s) dVz(km/s)') 
      Do i=1,Ncentr-1
         If(i.eq.87.or.i.eq.88)Then
            write (*,*)
         Endif 
        Mhalo  =Amc(i)
        irad   =Max(iRadius(i),2)
        Rh_1 =Rad(irad)
        Vrh2   =(Vrmc(i,irad)/Vscale)**2
        If(Mhalo.eq.0. .or. irad.eq.0)Lab(i) =.false.
       If(Lab(i))Then
       Do j=i+1,Ncentr
          dd =(Xm(j)-Xm(i))**2 +
     .        (Ym(j)-Ym(i))**2 +      
     .        (Zm(j)-Zm(i))**2     
          Mhalo2 =Amc(j)
          If(dd.lt.dR2.and.Mhalo2.gt.Mhalo/1.5)Then    ! close distance pair
          If(Mhalo2.lt.Mhalo*1.5)Then                         ! close mass range
             jrad=Max(iRadius(j),2)
             Rh_2 =Rad(jrad)
             Rhh =MAX(Rh_1,Rh_2,1.e-8)
             dv =(Wxc(j,jrad)-Wxc(i,irad))**2 +
     .           (Wyc(j,jrad)-Wyc(i,irad))**2 +      
     .           (Wzc(j,jrad)-Wzc(i,irad))**2
             VV =MAX(Vrh2,(Vrmc(j,jrad)/Vscale)**2) ! max Vrms of the two
c             If(dv.lt.(6.-5.*dd/dR2)*fV2*VV)Then   ! close in velocity
             If(dv.lt.(2.-dd/(dRdubl*Rhh))*fV2*VV)Then ! close in velocity
                If(Nbc(i,2).gt.Nbc(j,2))Then ! find if density at the distance
                   idens =i                       ! between halos does not change more than 
                 Else                              ! three times -- then this is dublicates
                    idens =j
                 Endif 
                 dist =sqrt(dd)
                 Do irr =1,Nrad
                    If(dist.lt.rad(irr))Then
                       idist =irr
                       goto 300
                    Endif 
                 Enddo
 300          irr=max(irr,2)
                 rho_cent =(Nbc(idens,2)-Nbc(idens,1))/Vol_2
                 rho_dist  =(Nbc(idens,irr)-Nbc(idens,irr-1))/
     +                           (Rad(irr)**3-Rad(irr-1)**3)
                IF(rho_dist.gt.rho_cent/5.)Then ! dublicates   
                nrem = nrem +1
 30             format(f10.4,f9.3,f11.2,2i14,6f10.3)                
c                If(Mhalo.gt.Mhalo2)Then ! choose the biggest
                If(Nbc(i,2).gt.Nbc(j,2))Then ! choose the densiest
                   Lab(j)=.false.               
                   write (*,30) sqrt(dd)*Xscale,sqrt(dv)*Vscale,
     +                            sqrt(VV)*Vscale,
     .                 Nbc(i,irad),Nbc(j,jrad),
     .               (Wxc(j,jrad)-Wxc(i,irad))*Vscale,
     +              (Wyc(j,jrad)-Wyc(i,irad))*Vscale,
     +              (Wzc(j,jrad)-Wzc(i,irad))*Vscale,
     +              rho_cent,rho_dist,irr
c        +              Xm(j)*Xscale,Ym(j)*Xscale,Zm(j)*Xscale
                Else
                   Lab(i)=.false.
                   write (*,30) sqrt(dd)*Xscale,sqrt(dv)*Vscale,
     +                            sqrt(VV)*Vscale,
     .                 Nbc(i,irad),Nbc(j,jrad),
     .               (Wxc(j,jrad)-Wxc(i,irad))*Vscale,
     +              (Wyc(j,jrad)-Wyc(i,irad))*Vscale,
     +              (Wzc(j,jrad)-Wzc(i,irad))*Vscale, 
     +              rho_cent,rho_dist,irr
c        +              Xm(i)*Xscale,Ym(i)*Xscale,Zm(i)*Xscale
                EndIf
             EndIf
             EndIf
          EndIf
          EndIf
        EndDo
      EndIf
      EndDo
      m  =0
      meanmass =0
      Do i=1,Ncentr
         If(i.eq.87.or.i.eq.88)Then
            write (*,*)
         Endif 
         If(Lab(i))Then
            m = m +1
            Xm(m)      =Xm(i)
            Ym(m)      =Ym(i)
            Zm(m)      =Zm(i)
            Amc(m)     =Amc(i)   
            Rmc(m)     =Rmc(i)  
            Vrm(m)     =Vrm(i) 
            iRadius(m) =iRadius(i)
            Do ir=1,Nrad  !  Store Results 
               Wxc(m,ir)  =Wxc(i,ir) 
               Wyc(m,ir)  =Wyc(i,ir) 
               Wzc(m,ir)  =Wzc(i,ir) 
               Nbc(m,ir)  =Nbc(i,ir) 
               NbcM(m,ir)  =NbcM(i,ir) 
               NbcG(m,ir)  =NbcG(i,ir) 
               Rrc(m,ir)  =Rrc(i,ir)
               Vrmc(m,ir) =Vrmc(i,ir)
            EndDo
            meanmass =meanmass +Nbc(m,Nrad)
         EndIf
      EndDo
      xmeanmass = FLOAT(meanmass)/FLOAT(m)      
      write(*,10) m,Ncentr,xmeanmass
      write(20,10) m,Ncentr,xmeanmass
      write(*,20) dRdubl*Xscale*hubble,fVdubl
 10   format(5x,'Vel.Dublicates: New number of objects=',i6,' Old=',i6,
     .       ' mean N_particles=',g11.3)
 20   format('     Distance Difference=',f8.4,/
     .       '     Vrelative/Vrms <    ',f8.4)
      Ncentr =m
      Return
      End

C-------------------------------- Update Statistics of pairs 
C                   
      SUBROUTINE SPairs(Box,N,Ncentr)
C---------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'

      If(Ncentr.gt.Ncc)Then
         write (*,*) ' Number of centers is too large:'
         write (*,*) '         Ncentr =',Ncentr,' Max=Ncc=',Ncc,' STOP'
         STOP
      EndIf
         Do i=1,Ncentr
               Do ir=1,Nrad
                  Wxc(i,ir) = 0.
                  Wyc(i,ir) = 0.
                  Wzc(i,ir) = 0.
                  Nbc(i,ir) = 0
                  Rrc(i,ir) = 0.
                  Vrmc(i,ir)= 0.
               EndDo
         EndDo
      Do i=1,Ncentr
         Xc =Xm(i)
         Yc =Ym(i)
         Zc =Zm(i)
         Call SNeib
            Do ir=1,Nrad  !  Store Results 
               Wxc(i,ir) =Vx1(ir)
               Wyc(i,ir) =Vy1(ir)
               Wzc(i,ir) =Vz1(ir)
               Nbc(i,ir) =Nob1(ir)
               Rrc(i,ir) =Rob1(ir)
               Vrmc(i,ir)=Vxx(ir)
            EndDo
      EndDo
      Return
      End

C-------------------------------- Remove small halos
C           
C           
      SUBROUTINE SmallRem(ANlimit,Ncentr)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'

      New =0
      Do i=1,Ncentr
         If(Amc(i).GT.ANlimit)Then
          New =New +1
          Xm(New) =Xm(i)
          Ym(New) =Ym(i)
          Zm(New) =Zm(i)
          Amc(New)=Amc(i)
          Rmc(New)=Rmc(i)
         EndIf
      EndDo
      Ncentr =New
      Return
      End
C-------------------------------- Get Catalog of Halos
C                        Remove close centers, keep only the largest
C                        Emass - small difference in mass
      SUBROUTINE CATALOG(Box,Ncentr)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      Dimension    Lab(Nc)

      New =0
      Do i=1,Ncentr
        Lab(i) =1
      EndDo
      Do i=1,Ncentr
         If(Rmc(i).lt.1.e-5)Lab(i)=0
            Xc =Xm(i)
            Yc =Ym(i)
            Zc =Zm(i)
            a0 =Amc(i)
            Rh =Rmc(i)
            Do j=1,Ncentr
               If(i.ne.j)Then
                dd =((Xc-Xm(j))**2+(Yc-Ym(j))**2+(Zc-Zm(j))**2)
                IF(dd.lt.( (Rh+Rmc(j))/2. )**2 )Then
                      If(a0.GT.Amc(j))Then! take largest of maxima
                         Lab(j)=0
                      Else
                         If(a0.lt.Amc(j))Then
                            Lab(i)=0
                         Else   ! equal masses -> take max(i,j)
                            Lab(min(i,j)) =0
                         EndIf
                      EndIf
                 EndIf
              EndIf
            EndDo            
      EndDo
C                                 Remove maxima with Label =0
      Do i=1,Ncentr
        If(Lab(i).eq.1)Then
          New =New +1
          Xm(New) =Xm(i)
          Ym(New) =Ym(i)
          Zm(New) =Zm(i)
          Amc(New)=Amc(i)
          Rmc(New)=Rmc(i)
          Vrm(New)=Vrm(i)
          Wxc(New,1)=Wxc(i,1)
          Wyc(New,1)=Wyc(i,1)
          Wzc(New,1)=Wzc(i,1)
        EndIf
      EndDo
      Ncentr =New
      Return
      End
C---------------------------------------------------------
C                                                  Select particles
c                                                   as initial seeds of centers
      SUBROUTINE ReadCent(N,Ncentr)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      Real INPUT
      Logical      Ldiff
c     Xccc =4.746/7.5*256.
c     Yccc =3.938/7.5*256.
c     Zccc =0.539/7.5*256.
c     Rccc =0.200/7.5*256.
      Ncentr =0
      If(RadSr1.lt.1.1*RadSr2.or.ABS(RadSr2).lt.1.e-8)Then ! there is only one radius
         Ldiff =.false.
         Radius = RadSr1
      Else
        Ldiff =.true.
        R1       = 1.1*RadSr2
        R2       = 0.9*RadSr1
        Rhalf   =(RadSr1+RadSr2)/2.
        n1        = 0  
        nhalf    = 0
        n2        = 0
        ialpha =3
        RRs  = (RadSr1-RadSr2)
	  write(*,*) ' Min Radius=',RadSr2,' Max=',RadSr1
	  write(*,*) ' Power index =',ialpha
      Endif 
      Nline=INPUT('  Number of particles for initial seeds= ')
      jneib=INPUT('  Number of neibhours for a seed= ')
      If(Nline.eq.0)Return
         fr    = N/FLOAT(Nline)
         xrand =1.00001
         Nstep =MAX(INT(fr+1.),1)
         fr    =1./fr
         Nseed = 121071
         write (*,*) ' Every ',Nstep,' particle is used',
     &                ' as initial center',' Fraction=',fr
C         Do i=1,N,Nstep
          Do i=1,N
             If(fr.lt.0.999)xrand =RANDd(Nseed) 
               IF(xrand.lt.fr)Then 
c                IF(ABS(Xp(i)-Xccc).lt.Rccc.and. 
c    .                ABS(Yp(i)-Yccc).lt.Rccc.and.
c    .                ABS(Zp(i)-Zccc).lt.Rccc)THEN
                  Ncentr           =Ncentr+1
                  IF(Ldiff)Then           ! different radii
                        Rrrr   =RadSr2+
     &                            RRs*(MAX(RANDd(Nseed),1.e-8))**ialpha
                        Rmc(Ncentr) = Rrrr

                        If(Rrrr.lt.R1)n1 = n1+1
                        If(Rrrr.lt.Rhalf)nhalf = nhalf+1
                        If(Rrrr.gt.R2)n2 = n2+1
                  Else
                        Rmc(Ncentr) =Radius
                  Endif 
                  Amc(Ncentr) =1.
c                  Rmc(Ncentr) =1.
                  Xm(Ncentr)   =Xp(i)
                  Ym(Ncentr)   =Yp(i)
                  Zm(Ncentr)   =Zp(i)
                  j=Ncentr
c                EndIf      ! endif for small box test
               EndIf
         EndDo

      If(jneib.eq.0)goto 150               ! No more points

      Imax =MIN(INT(NGRID/Cell),Nb)
      write (*,*) ' Size of Grid centers=',Imax,Cell,NGRID
      Do k=0,Imax
      Do j=0,Imax
      Do i=0,Imax
         jp =Label(i,j,k)
         Ncount  =0
         jcount    =0
 10       jcount= jcount+1
              If(jp.ne.0.and.jcount.lt.jneib)Then
                     jp=Lst(jp) ! find if there are enough neib
                     goto 10
              endif 
               jcount    =0
          If(jp.ne.0)Then 
              Ncount =Ncount +1
c                 IF(ABS(Xp(jp)-Xccc).lt.Rccc.and. 
c    .                 ABS(Yp(jp)-Yccc).lt.Rccc.and.
c    .                 ABS(Zp(jp)-Zccc).lt.Rccc)THEN
                Ncentr=Ncentr+1
                If(Ncentr.le.Nc)Then
                  IF(Ldiff)Then           ! different radii
                        Rrrr   =RadSr2+
     &                            RRs*(MAX(RANDd(Nseed),1.e-8))**ialpha
                        Rmc(Ncentr) = Rrrr

                        If(Rrrr.lt.R1)n1 = n1+1
                        If(Rrrr.lt.Rhalf)nhalf = nhalf+1
                        If(Rrrr.gt.R2)n2 = n2+1
                  Else
                        Rmc(Ncentr) =Radius
                  Endif 
                        Amc(Ncentr) =1.
                        Xm(Ncentr)  =Xp(jp)
                        Ym(Ncentr)  =Yp(jp)
                        Zm(Ncentr)  =Zp(jp)
                EndIf
c                 EndIf           ! endif for small-box test
c                  write (*,*) ' Count=',Ncount,i,j,k,Ncentr
                  Goto 10
          EndIf
      EndDo
      EndDo
      EndDo
150   write(*,*) ' Ncentr=',Ncentr,' Max=',Nc
      If(Ncentr.gt.Nc)Then
         write (*,*) ' Too many centers'
         pause
      Endif 
         If(Ncentr.gt.0)Then
            write (*,200) RadSR2,R1,n1,Rhalf,nhalf,R2,RadSR1,n2
            write (2,200) RadSR2,R1,n1,Rhalf,nhalf,R2,RadSR1,n2
            write (20,200) RadSR2,R1,n1,Rhalf,nhalf,R2,RadSR1,n2
 200   format(' Number of centers with radii between ',3x,2f7.4,
     &                ' was ',i6,
     &              /18x,' with radius less than ',f7.4,7x,' was ',i6,
     &              /18x,' with radii between ',3x,2f7.4,' was ',i6)
          Endif 
      Return
      End

C---------------------------------------------------------
C                                        Read list of maxima
c                                     Xnew =X-1: coord. now are 0-NGRID       
      SUBROUTINE ReadMax(Ncentr,Xscale)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      Character*79 Text
      Do i=1,22
         read(3,'(A)') Text
         write(*,'(A)') Text
      enddo 
       Ncentr =0
      xxm =1000.
      xxn =-1000.
 10   read (3,*,err=5,end=5) X0, Y0, Z0, VvX,VvY,VvZ,
     &                                     amh,rh,wvel,wwvel,ihh
            Ncentr=Ncentr+1
            If(Ncentr.le.Ncc)Then
            Xm(Ncentr)  =X0/Xscale/hubble
            Ym(Ncentr)  =Y0/Xscale/hubble
            Zm(Ncentr)  =Z0/Xscale/hubble
            Amc(Ncentr) =1.
            Rmc(Ncentr) =1.
            xxm    =min(xxm,Xm(Ncentr))
            xxn     =max(xxn,Xm(Ncentr))
            EndIf
            If(Ncentr.lt.Ncc)GoTo 10
 5    write(*,*) ' Read Centers: X{Min,Max}=',xxm,xxn,' N=',Ncentr
      If(Ncentr.GT.Ncc)Then
         write (*,*) ' Too many particles: Max=',Ncc
         Stop
      EndIf
      Return
      End
C---------------------------------------------------------
C                                        Read particles
      SUBROUTINE ReadPnt(N,Fract)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'

      N =0
      Iz=1
      Iy=1
      Ff=1.
      If(Fract.le.0.666)Then
         Iz=2
         Ff=0.5
         If(Fract.le.0.333)Then
            Iy=2
            Ff=0.25
         Endif
      EndIf
      Fract =Ff
C				       Loop over particles
      DO 10 IROW=1,NROW,Iz
         READ  (21,REC=IROW) RECDAT
	   DO   IN=1,NPAGE,Iy
            N   = N +1
            Xp(N)  =XPAR(IN)-1.
            Yp(N)  =YPAR(IN)-1.
            Zp(N)  =ZPAR(IN)-1.
            VXp(N)=VX(IN)
            VYp(N)=VY(IN)
            VZp(N)=VZ(IN)
         ENDDO
 10   CONTINUE
      Return
      End

C---------------------------------------------------
C                                Remove Unbound particles, find radius and mass
C                                No removal of unbound particles If:
C                                       Toohot =< 0 or Toohot =>5
C                             Vscale =100.*hsmall*Xscale/AEXPN 
C                              Xscale=Box/Ngrid 
C                              Dscale=2.75e+11*hsmall**2*(Box/NROW)**3 
      SUBROUTINE CLEAN(Ncentr,Xscale,Vscale,Dscale,
     +     Fract,Radsc,MnMass,Toohot,Rminhalo)  
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      dimension Mass(Nrad),MnMass(Nrad),Overdens(Nrad),Radsc(Nrad)
      Real          Mass,MnMass,Mhalo

      NSrad =min(Nrad,Nrad_lim)
c      NSrad =Nrad
      Do i=1,Ncentr          
         Xc =Xm(i)  *Xscale !          Scale all to physical units: comoving
         Yc =Ym(i)  *Xscale
         Zc =Zm(i)  *Xscale
         Do ir =1,Nrad
            Vrmc(i,ir)=Vrmc(i,ir) *Vscale   !  Scale to km/s
            Summass     = Om0*Nbc(i,ir)/Fract
            Mass(ir)    = Dscale*Summass
            Overdens(ir)= Mass(ir)/MnMass(ir)
         EndDo  
C                                     find size, mass, rad ... for a halo
         Call Decide(Mass,Radsc,Overdens,NSrad,irad,Mhalo,Rhalo,
     +                                       Vmaxrot,Rmaxrot )
         Vcirc=sqrt(Vmaxrot/AEXPN)*6.58e-5 ! =10^-5*sqrt(G 2e33/3.08e24) 
         If(Toohot.gt.0. .and. Toohot.lt.5.)Then
            Do iter =0,4        !  Remove High Energy particles from halos
         If(irad .ge.1 .and. Rhalo.gt.Rminhalo)Then
           Vcc =Vcirc/Vscale          ! back to dimensionless units
c           Vmaxrot=Vcc*Toohot*1.3**(4-iter) ! Increase the Rotatioanl Vel.
           Vmaxrot=Vcc*Toohot*exp(0.0433*(4-iter)**2) ! Increase the Rotatioanl Vel.
            Call RemEng(i,Vmaxrot,Rmaxrot/Xscale)  ! Remove Unbound Particles
           Do ir =1,Nrad
             Vrmc(i,ir)=Vrmc(i,ir) *Vscale
             Summass     =Om0*Nbc(i,ir)/Fract
             Mass(ir)    = Dscale*Summass
             Overdens(ir)=Mass(ir)/MnMass(ir)
           EndDo  
          Call Decide(Mass,Radsc,Overdens,NSrad,irad,Mhalo,Rhalo,
     +                                       Vmaxrot,Rmaxrot)
          Vcirc=sqrt(Vmaxrot/AEXPN)*6.58e-5 !=10^-5*sqrt(2e33/3.08e24)
         EndIf
         EndDo       ! end iter energy
         EndIf
         Amc(i)     =Mhalo ! store results
         Rmc(i)     =Rmaxrot  !Rhalo
         Vrm(i)     =Vcirc
         iRadius(i) =irad
c         write (*,*) '         ',Mhalo,Rhalo,Vcirc,irad
       Enddo   ! end i (Ncentr)
       Return
       End
C------------------------------------------------------------- 
C                                                             Find  halo radius and mass
      SUBROUTINE Decide(Mass,Rad,Overdens,Nrad,irad,Mhalo,Rhalo,
     +                                       Vmaxrot,Rmaxrot )
C--------------------------------------------------------------
      COMMON /OVER/ Ovlim,Ovcnt
      Real   Rad(Nrad),Overdens(Nrad),Mass(Nrad),Mhalo
      DATA  slope/0.999/
         Vmaxrot =0
         Rmaxrot =0. 
         Mhalo=0.
         Rhalo=0.   
      If(MAX(Overdens(1),Overdens(2)).LT.Ovcnt)Then
         irad =0         ! max overdensity is less then Ovcnt
         RETURN
      EndIf
      iov  =0
      Do ir=Nrad,1,-1
         If(Overdens(ir).gt.Ovlim .and. iov.eq.0)Then
            iov  =ir
         EndIf
      EndDo
      If(iov.eq.0)Then
         irad =0         ! max overdensity is less then Ovlim
         RETURN
      EndIf
      iovv =0
      Do ir=1,iov
         irleft =max(ir-1,1)
         irr1   =min(ir+1,Nrad)
         irr2   =min(ir+2,Nrad)
         Overright =(Overdens(irr1)+Overdens(irr2))/2.
         Overleft  =(Overdens(ir)+Overdens(irleft))/2.
         If(Overright.gt.0.97*Overleft)Then !stop:rising profile
            If(ir.eq.1)Then ! softer conditions for the first bin
               If(Overright.gt.1.2*Overleft)Then
                   iovv =ir
                   goto 20
               EndIf
            else 
                iovv =ir
               goto 20
            EndIf
         EndIf
      EndDo
 20   If(iovv.ne.0)iov =iovv
         irad =iov
 30      irleft  =max(irad-2,1)  ! check if overdens is steep
         irright =min(irad+1,Nrad)
         gradlf  =Overdens(irleft) * (Rad(irleft))**slope
         gradrt  =Overdens(irright)* (Rad(irright))**slope
         If(gradlf.lt.gradrt)Then  ! not a steep gradient
            irad =irad -1        ! reduce radius
            iovv =irad
            If(irad.eq.0)Then   ! zero radius -> quit
               RETURN
            Else
               goto 30             ! iterate
            EndIf
         EndIf
         If(irad.lt.Nrad)Then    ! interpolate to Overlim
            If(Ovlim.gt.Overdens(irad+1) .and.
     .         Overdens(irad).gt.Ovlim)Then       
              Mhalo=(Mass(irad)*(Ovlim-Overdens(irad+1))+
     .             Mass(irad+1)*(Overdens(irad)-Ovlim)) /
     .             (Overdens(irad)-Overdens(irad+1))
              Rhalo=(Rad(irad)*(Ovlim-Overdens(irad+1))+
     .             Rad(irad+1)*(Overdens(irad)-Ovlim)) /
     .             (Overdens(irad)-Overdens(irad+1))
            Else                 ! Overdens is > Overlim 
              Mhalo =Mass(irad)
              Rhalo =Rad(irad)
            EndIf
         Else                 ! Overdens is > Overlim 
            Mhalo =Mass(irad)
            Rhalo =Rad(irad)
         EndIf
         Do ir =1,irad  ! find max rotational velocity
            V2    = Mass(ir)/Rad(ir)
            If (V2.gt.Vmaxrot)Then
               Vmaxrot =V2               
               Rmaxrot =Rad(ir)
            EndIf
          EndDo
      Return
      End
C------------------------------------------------
C                                  Remove unbound particles for i-th halo
C                                  irad   = radius of the halo
C                                 Vmaxrot = max rotational Velocity
C                                 Rmaxrot = radius at max rot.velocity
      SUBROUTINE RemEng(i,Vmaxrot,Rmaxrot)
C-----------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      DIMENSION VXxc(Nrad), VYyc(Nrad), VZzc(Nrad),
     &                     Anx(Nrad),Any(Nrad),Anz(Nrad)
         Xc  =Xm(i)  ! store center of mass and velocity      
         Yc  =Ym(i)     
         Zc  =Zm(i)     
         Do ir =1,Nrad ! store mean velocity
            VXxc(ir) =Wxc(i,ir) 
            VYyc(ir) =Wyc(i,ir) 
            VZzc(ir) =Wzc(i,ir) 
                                         ! escape velocity for NFW profile
            Vescape2(ir) = (2.15*Vmaxrot)**2 * 
     &           log(1.0+2.*Rad(ir)/Rmaxrot)/(Rad(ir)/Rmaxrot) 
               Wxc(i,ir) = 0.
               Wyc(i,ir) = 0.
               Wzc(i,ir) = 0.
               Nbc(i,ir) = 0
               Rrc(i,ir) = 0.
               Vrmc(i,ir)= 0.
            EndDo
            Call SrejNeib(VXxc,VYyc,VZzc)
c            Call SrejNeib_m(VXxc,VYyc,VZzc,Anx,Any,Anz)
            Do ir=1,Nrad  !  Store Results 
               Wxc(i,ir) =Vx1(ir)
               Wyc(i,ir) =Vy1(ir)
               Wzc(i,ir) =Vz1(ir)
               Nbc(i,ir) =Nob1(ir)
               Rrc(i,ir) =Rob1(ir)
               Vrmc(i,ir)=Vxx(ir)
c               Agx(i,ir) = Anx(ir)    ! angular momentum
c               Agy(i,ir) = Any(ir) 
c               Agz(i,ir) = Anz(ir) 
            EndDo
      Return
      End
C--------------------------------------------------------------
C                                Accumilate statistics only
C                                if relative velocity is not large
C                                Xc,Yc,Zc - center; 
C                               
      SUBROUTINE SrejNeib(VXxc,VYyc,VZzc)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      DIMENSION VXxc(Nrad), VYyc(Nrad), VZzc(Nrad)
         Radmax =Rad(Nrad)
         Do i=1,Nrad
              Nob1(i) =0
              Rob1(i) =0.
              Vx1(i)  =0.
              Vy1(i)  =0.
              Vz1(i)  =0.
              Vxx(i)  =0.
         EndDo
c                                           limits for Label
         i1=INT((Xc-Radmax)/Cell)
         j1=INT((Yc-Radmax)/Cell)
         k1=INT((Zc-Radmax)/Cell)
            i1=MIN(MAX(Nm,i1),Nb)
            j1=MIN(MAX(Nm,j1),Nb)
            k1=MIN(MAX(Nm,k1),Nb)
         i2=INT((Xc+Radmax)/Cell)
         j2=INT((Yc+Radmax)/Cell)
         k2=INT((Zc+Radmax)/Cell)
            i2=MIN(MAX(Nm,i2),Nb)
            j2=MIN(MAX(Nm,j2),Nb)
            k2=MIN(MAX(Nm,k2),Nb)
C                                        Look for neibhours
         Do k=k1,k2
         Do j=j1,j2
         Do i=i1,i2
           jp =Label(i,j,k)       !  Dark matter
 10        If(jp.ne.0)Then
             dd =(Xc-Xp(jp))**2+(Yc-Yp(jp))**2+(Zc-Zp(jp))**2
             If(dd.lt.Rad2(Nrad))Then
             iov =0
             Do ir =1,Nrad          ! find bin
                If(dd.le.Rad2(ir))Then
                   iov =ir
                   goto 30
                EndIf
             EndDo
 30          If(iov.eq. 0)Then   ! error
                write (*,*) ' Error SrejNeib: iov =',iov,' d=',sqrt(dd)
                Stop
             EndIf
             dv =  (VXxc(iov)-VXp(jp))**2+
     +             (VYyc(iov)-VYp(jp))**2+
     +             (VZzc(iov)-VZp(jp))**2
             If(dv .lt. Vescape2(iov))Then
              Do ir =iov,Nrad   ! Nrad
c                 If(dd.lt.Rad2(ir))Then
                   Nob1(ir)= Nob1(ir)+ 1
                   Rob1(ir)= Rob1(ir)+ sqrt(dd)
                   Vxx(ir) = Vxx(ir) +VXp(jp)**2+VYp(jp)**2+VZp(jp)**2
                   Vx1(ir) = Vx1(ir) +VXp(jp)  
                   Vy1(ir) = Vy1(ir) +VYp(jp)
                   Vz1(ir) = Vz1(ir) +VZp(jp)
c                 EndIf
              EndDo
             EndIf
             EndIf
           jp =Lst(jp)
           GoTo10
           EndIf
         EndDo
         EndDo
         EndDo
         Do ir=1,Nrad
            Vmn =0.
     	      If(Nob1(ir).GT.0)Then
               Nobj =Nob1(ir)
               Vx1(ir) = Vx1(ir)/Nobj
               Vy1(ir) = Vy1(ir)/Nobj
               Vz1(ir) = Vz1(ir)/Nobj
               Vmn     = Vx1(ir)**2+Vy1(ir)**2+Vz1(ir)**2
               Vxx(ir) = SQRT(ABS(Vxx(ir)/Nobj -Vmn))
	         EndIf
         EndDo
      Return
      End
C--------------------------------------------------------------
C                                Accumilate statistics only
C                                if relative velocity is not large
C                                Xc,Yc,Zc - center; 
C                                Get angular momentum     
      SUBROUTINE SrejNeib_m(VXxc,VYyc,VZzc,Anx,Any,Anz)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      DIMENSION VXxc(Nrad), VYyc(Nrad), VZzc(Nrad),
     &                     Anx(Nrad), Any(Nrad),Anz (Nrad)
         Radmax =Rad(Nrad)
         Do i=1,Nrad
              Nob1(i) =0
              Rob1(i) =0.
              Vx1(i)  =0.
              Vy1(i)  =0.
              Vz1(i)  =0.
              Vxx(i)  =0.
              Anx(i)  =0.
              Any(i)  =0.
              Anz(i)  =0.
         EndDo
c                                           limits for Label
         i1=INT((Xc-Radmax)/Cell)
         j1=INT((Yc-Radmax)/Cell)
         k1=INT((Zc-Radmax)/Cell)
            i1=MIN(MAX(Nm,i1),Nb)
            j1=MIN(MAX(Nm,j1),Nb)
            k1=MIN(MAX(Nm,k1),Nb)
         i2=INT((Xc+Radmax)/Cell)
         j2=INT((Yc+Radmax)/Cell)
         k2=INT((Zc+Radmax)/Cell)
            i2=MIN(MAX(Nm,i2),Nb)
            j2=MIN(MAX(Nm,j2),Nb)
            k2=MIN(MAX(Nm,k2),Nb)
C                                        Look for neibhours
         Do k=k1,k2
         Do j=j1,j2
         Do i=i1,i2
           jp =Label(i,j,k)       !  Dark matter
 10        If(jp.ne.0)Then
             dd =(Xc-Xp(jp))**2+(Yc-Yp(jp))**2+(Zc-Zp(jp))**2
             If(dd.lt.Rad2(Nrad))Then
             iov =0
             Do ir =1,Nrad          ! find bin
                If(dd.le.Rad2(ir))Then
                   iov =ir
                   goto 30
                EndIf
             EndDo
 30          If(iov.eq. 0)Then   ! error
                write (*,*) ' Error SrejNeib: iov =',iov,' d=',sqrt(dd)
                Stop
             EndIf
             dv =  (VXxc(iov)-VXp(jp))**2+
     +             (VYyc(iov)-VYp(jp))**2+
     +             (VZzc(iov)-VZp(jp))**2
             If(dv .lt. Vescape2(iov))Then
              Do ir =iov,Nrad   ! Nrad
c                 If(dd.lt.Rad2(ir))Then
                   Nob1(ir)= Nob1(ir)+ 1
                   Rob1(ir)= Rob1(ir)+ sqrt(dd)
                   Vxx(ir) = Vxx(ir) +VXp(jp)**2+VYp(jp)**2+VZp(jp)**2
                   Vx1(ir) = Vx1(ir) +VXp(jp)  
                   Vy1(ir) = Vy1(ir) +VYp(jp)
                   Vz1(ir) = Vz1(ir) +VZp(jp)
                   Anx(ir) = Anx(ir) +(Yp(jp)-Yc)*(VZp(jp)-VZzc(iov))-
     +                                (Zp(jp)-Zc)*(VYp(jp)-VYyc(iov))
                   Any(ir) = Any(ir) +(Zp(jp)-Zc)*(VXp(jp)-VXxc(iov))-
     +                                (Xp(jp)-Xc)*(VZp(jp)-VZzc(iov))
                   Anz(ir) = Anz(ir) +(Xp(jp)-Xc)*(VYp(jp)-VYyc(iov))-
     +                                (Yp(jp)-Yc)*(VXp(jp)-VXxc(iov))
c                 EndIf
              EndDo
             EndIf
             EndIf
           jp =Lst(jp)
           GoTo10
           EndIf
         EndDo
         EndDo
         EndDo
         Do ir=1,Nrad
            Vmn =0.
     	      If(Nob1(ir).GT.0)Then
               Nobj =Nob1(ir)
               Vx1(ir) = Vx1(ir)/Nobj
               Vy1(ir) = Vy1(ir)/Nobj
               Vz1(ir) = Vz1(ir)/Nobj
               Vmn     = Vx1(ir)**2+Vy1(ir)**2+Vz1(ir)**2
               Vxx(ir) = SQRT(ABS(Vxx(ir)/Nobj -Vmn))
	         EndIf
         EndDo
      Return
      End

C ______________________________	Select particles, find density
C		             
C		                     
C          Scales internal PM coordinates and velocities 
C          to  coordinates in Mpc/h and km/s

      INCLUDE 'PMparameters.h'
      INCLUDE 'PMlists.h'
      REAL        AMprevious(Np),AMprevious2(Np)
      REAL        INPUT
      Character   FileASCII*50
C...................................................................
C			Read data and open files
      WRITE (*,'(A,$)') 'Enter File Name for  processed data = '
      READ  (*,'(A)') FileASCII
      OPEN(17,FILE=FileASCII,STATUS='UNKNOWN')
c      OPEN(17,FILE=FileASCII,STATUS='UNKNOWN',FORM='UNFORMATTED')
      CALL RDTAPE

      Cell   = 0.15     ! Cell size in Mpc/h
      write (*,*) ' RDTAPE is done'
      Fraction = 1.
c      Fraction =INPUT(' Enter fraction of particles     =')
      If(Fraction.le.0.)Stop
      Ifraction = INT(1./Fraction+0.1)
      write (*,*) ' Every ',Ifraction,' particle will be selected'
      write (*,*)
     +     ' Enter  Center and Radius XYZ R (Mpc/h)=' 
      read (*,*) Xc,Yc,Zc,Radius
c      Rsearch =0.001
      Rsearch =INPUT(' Enter radius to look for neighbors (Mpc/h)=')
       WRITE (17,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv,Xc,Yc,Zc,Radius,Rsearch
100   FORMAT(1X,'Header=>',A45,/
     +            1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I6,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3,
     +                 ' Center=',3f8.3,' Rad=',f7.2,' Rsearch=',f7.3)
      Box  =INPUT(' Enter box size in comoving Mpc/h =')

      BoxV =Box*100.    ! Box size in km/s
      ScaleV = BoxV/AEXPN/NGRID  ! scale factor for Velocities
      ScaleC = Box/NGRID         ! scale factor for Coordinates
      xshift =0. 
      yshift =0. 
      zshift =0.
c      CALL GetCentre(ScaleC,ScaleV,Xc,Yc,Zc,
c     &          xshift, yshift ,  zshift  )
c      write (*,*) ' Center=',Xc,Yc,Zc
c      Radius =0.5
      CALL ReadPnts(N,Nsm,ScaleC,ScaleV,xmin,ymin,zmin,
     &             xshift,yshift,zshift,Xc,Yc,Zc,Radius,Ifraction)
      CALL List(Box,N,xmin,ymin,zmin)
      ScaleInc = 4.
c      ScaleInc =INPUT(' Enter factor for larger radius or 1 for none=')
c       WRITE (17) AEXPN,ISTEP,Box,Rsearch,ScaleInc
      write (*,*) ' Center=',Xc,Yc,Zc
      If(ScaleInc.lt.1.1)ScaleInc=1.  ! background scale
      Radius =Rsearch *ScaleInc
      If(ScaleInc.gt.1.1)Then
        write (*,*) ' Search neighbors inside large radius=',Radius
        Do i=1,Nsm
c           if(i.eq.100000)STOP
          if(i/100000*100000.eq.i)write (*,*) '   particle=',i,' of ',N
            X =Xp(i)
            Y =Yp(i)
            Z =Zp(i)
           Call Neib(Amnew,xmin,ymin,zmin,X,Y,Z,Radius)
           AMprevious(i)=AMnew
c            Rr =Radius *ScaleInc
c           Call Neib(Amnew,xmin,ymin,zmin,X,Y,Z,Rr)
           AMprevious2(i)=Amnew
        Enddo 
      Else
      write (*,*) ' Center=',Xc,Yc,Zc
         Do i=1,Nsm
           AMprevious(i)=0. 
           AMprevious2(i)=0. 
         EndDo
      Endif 
      Radius =Rsearch
      write (*,*) ' Search neighbors inside small radius=',Radius
      Do i=1,Nsm
          if(i/100000*100000.eq.i)write (*,*) '   particle=',i,' of ',N
         X =Xp(i)
         Y =Yp(i)
         Z =Zp(i)
         Call Neib(Amnew,xmin,ymin,zmin,X,Y,Z,Radius)
         If(ScaleInc.lt.1.1)AMprevious(i)=0.
         Amextr =Amnew -AMprevious(i)/ScaleInc**3
         If(AMprevious(i).lt.1.05*Amnew)Amextr =0.001
         If(Amextr.lt.0.01)Amextr=0.001
         NpMax = INT(MAX(Amnew,AMprevious(i)))
c         If(iWeight(i).lt.2.)
c     &         write (17) X-Xc,Y-Yc,Z-Zc,Int(Amnew),
c     &                 INT(AMprevious(i)),INT(AMprevious2(i)) !,AMextr,

         If(NpMax.gt.1.and.iWeight(i).lt.2.)
     &      write (17,200) X-Xc,Y-Yc,Z-Zc,Int(Amnew),
     &            INT(AMprevious(i)),AMextr,
     &            INT(iWeight(i))
 200       Format(3F9.4,i6,i7,g11.3,i3)
      Enddo 
      write (*,*) ' Scaled Coordinates were written to:',
     &            FileASCII
      write (*,*) ' Number of particles          =',N

      END

C------------------------------------------
C                                                      Read particles
C
      SUBROUTINE GetCentre(ScaleC,ScaleV,Xc,Yc,Zc,
     &          xshift, yshift ,  zshift  )
C------------------------------------------
       INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      Dimension ListPart(10000)
      Character*90 Line
      Logical Tcen
      Open(18,file='CenterParticles.dat')

      Tcen =.false.
      Box =ScaleC*NGRID
         ifile      =1
      If(Nspecies.eq.0)Then ! old case: 1 complete set
         Npages =NROW          ! Number of pages
         N_in_last=NPAGE       ! Number of particles in last page
      Else                             ! multiple masses
         N_particles =lspecies(Nspecies)   ! Total number of particles
         Npages = (N_particles -1)/NPAGE +1
         N_in_last=N_particles -NPAGE*(Npages-1)
      EndIf
      write (*,*) ' Pages=',Npages,' Species=',Nspecies
C                      --------------------------------------
      If(Tcen)Then                ! assign the center
         Xc = 0.988 + xshift
         Yc = 0.923 + yshift
         Zc = 11.638 + zshift
         Vxcc = -98.643
         Vycc = 110.17
         Vzcc = 35.71
         Radius = 0.002
c                                  find particles close to the center
         Radius2 = Radius**2                       ! square of radius
         write (*,*) '    Center =',Xc,Yc,Zc,' shift=',xshift,
     &                   yshift, zshift,' Radius=',  Radius  
         write (18,*) '    Center =',Xc,Yc,Zc,' shift=',xshift,
     &                   yshift, zshift,' Radius=',  Radius  
         Vxcen =0.
         Vycen =0.
         Vzcen =0.
         Ncen  =0

C				       Loop over particles
       DO IROW=1,Npages
            In_page =NPAGE
            If(IROW.eq.Npages)In_page =N_in_last
            write (*,*)' Read page=',IROW,' file=',ifile,' N=',N
            iL = NPAGE*(IROW-1)
	      CALL GETROW(IROW,ifile)
	      DO IN=1,In_page
	        X  =ScaleC* (XPAR(IN)-1.)
	        Y  =ScaleC* (YPAR(IN)-1.)
	        Z  =ScaleC* (ZPAR(IN)-1.)
                  X =X+xshift 
                  Y =Y+yshift 
                  Z =Z+zshift
                  IF(X.lt.0.)X=X +Box 
                  IF(Y.lt.0.)Y=Y +Box 
                  IF(Z.lt.0.)Z=Z +Box
                  IF(X.GE.Box)X=X -Box 
                  IF(Y.GE.Box)Y=Y -Box 
                  IF(Z.GE.Box)Z=Z -Box
                Vxs=ScaleV* VX(IN)
                Vys=ScaleV* VY(IN)
                Vzs=ScaleV* VZ(IN)
                If(Nspecies.eq.0)Then   ! find weight of particle
                   W =PARTW
                Else
                   Ipart =IN+iL             ! current particle number
                   Do i =1,Nspecies
                      if(Ipart.le.lspecies(i))Then
                         W =wspecies(i)
                         goto 50
                      endif 
                   EndDo 
                EndIf
 50         Ipart  =IN+iL                     ! current particle number
                  iWeigh = INT(W/wspecies(1)+0.1) ! W  ! ! W  ! particles weight   iWeight(Ipart)   
                  If(iWeigh.lt.1.001)Then
                    DD =(X-Xc)**2+(Y-(Yc))**2
     &                     +(Z-(Zc))**2
                    If(DD.lt.Radius2)Then !  inside the limits -- take it
                       Ncen =Ncen +1
                       Vxcen = Vxcen +Vxs
                       Vycen = Vycen +Vys
                       Vzcen = Vzcen +Vzs
                       Vv  = SQRT((Vxs-Vxcc)**2+
     &                       (Vys-Vycc)**2+(Vzs-Vzcc)**2)
        If(Vv.lt.30.)   write (18,'(i8,3f9.4,4f8.2)') Ipart,X,Y,Z,
     &                Vxs-Vxcc,Vys-Vycc,Vzs-Vzcc,Vv
                   EndIf
                 Endif
	      ENDDO
        ENDDO 
 300  write (*,*) '  Number of particle at the center=',Ncen
        write (*,*) '  Radius      =',Radius,' Centre=',Xc,Yc,Zc
        write (*,*) '  Vmean       =',
     &          Vxcen/Ncen,Vycen/Ncen,Vzcen/Ncen
        Close (18)
        Return
c
      ELSE                      ! read the list of particles and find the center
C                      --------------------------------------
c
         read(18,'(A)') Line
         read(18,'(A)') Line
         Ncen =0
         Xc = 0.
         Yc = 0.
         Zc = 0.
 400     read(18,*,err=410,end=410) In,X,Y,Z
               Ncen =Ncen +1
               ListPart(Ncen) =In
         goto 400
c                                           find coords of the particles
 410     Ncurrent =1
         IpCurrent =ListPart(Ncurrent)
C				       Loop over particles
          DO IROW=1,Npages
            In_page =NPAGE
            If(IROW.eq.Npages)In_page =N_in_last
            write (*,*)' Read page=',IROW,' file=',ifile,' Nc=',Ncurrent
            iL = NPAGE*(IROW-1)
	      CALL GETROW(IROW,ifile)
	      DO IN=1,In_page
                Ipart =IN+iL             ! current particle number
                If(Ipart.eq.IpCurrent)Then
	            X  =ScaleC* (XPAR(IN)-1.)
	            Y  =ScaleC* (YPAR(IN)-1.)
	            Z  =ScaleC* (ZPAR(IN)-1.)
                  X =X+xshift 
                  Y =Y+yshift 
                  Z =Z+zshift
                  IF(X.lt.0.)X=X +Box 
                  IF(Y.lt.0.)Y=Y +Box 
                  IF(Z.lt.0.)Z=Z +Box
                  IF(X.GE.Box)X=X -Box 
                  IF(Y.GE.Box)Y=Y -Box 
                  IF(Z.GE.Box)Z=Z -Box
                  Xc =Xc +X
                  Yc =Yc +Y
                  Zc =Zc +Z
                  If(Ncurrent.ge.Ncen) Goto 500
                  Ncurrent =Ncurrent +1
                  IpCurrent =ListPart(Ncurrent)
                EndIf
         EndDo
         EndDo
 500     write (*,*) ' Number of centers found=',Ncurrent
         write(*,*) '    it should be equal to =',Ncen
         Xc =Xc/Ncurrent
         Yc =Yc/Ncurrent
         Zc =Zc/Ncurrent
         write (*,*) ' Center=',Xc,Yc,Zc
      ENDIF   
        Return
        End
C------------------------------------------
C                                                      Read particles
C
      SUBROUTINE ReadPnts(N,Nsm,ScaleC,ScaleV,xmin,ymin,zmin,
     &          xshift,yshift ,zshift ,Xc,Yc,Zc,Radius,Ifraction)
C------------------------------------------
       INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
      Integer Xdist(0:25),Ydist(0:25),Zdist(0:25)

      Box =ScaleC*NGRID
      Radius2 =Radius**2
      N =0                                             ! Number of particles
      Nsm = 0
      xmax =-1.e+9
      xmin = 1.e+9
      ymax =-1.e+9
      ymin = 1.e+9
      zmax =-1.e+9
      zmin = 1.e+9
      vmax =-1.e+9
      vmin = 1.e+9
      Do i=0,25
         Xdist(i) =0
         Ydist(i) =0
         Zdist(i) =0
      Enddo 
      Icount =0
      Icount_p =Icount-1
      ifile      =1
      If(Nspecies.eq.0)Then ! old case: 1 complete set
         Npages =NROW          ! Number of pages
         N_in_last=NPAGE       ! Number of particles in last page
      Else                             ! multiple masses
         N_particles =lspecies(Nspecies)   ! Total number of particles
         Npages = (N_particles -1)/NPAGE +1
         N_in_last=N_particles -NPAGE*(Npages-1)
      EndIf
      write (*,*) ' Pages=',Npages,' Species=',Nspecies
      write (*,*) ' N_in_last=',N_in_last
C				       Loop over particles
       DO IROW=1,Npages
            In_page =NPAGE
            If(IROW.eq.Npages)In_page =N_in_last
            write (*,*)' Read page=',IROW,' file=',ifile,' N=',N
            iL = NPAGE*(IROW-1)
            if(Icount_p.eq.Icount.and.Icount_p.gt.100)goto300  ! stop if number does not change
	      CALL GETROW(IROW,ifile)
                  Icount_p=Icount
	      DO IN=1,In_page
	        X  =ScaleC* (XPAR(IN)-1.)
	        Y  =ScaleC* (YPAR(IN)-1.)
	        Z  =ScaleC* (ZPAR(IN)-1.)
C           write (*,'(i8,10g11.4)') IN+iL,
c     &              X,Y,Z,XPAR(IN),YPAR(IN),ZPAR(IN)
                  X =X+xshift 
                  Y =Y+yshift 
                  Z =Z+zshift
                  IF(X.lt.0.)X=X +Box 
                  IF(Y.lt.0.)Y=Y +Box 
                  IF(Z.lt.0.)Z=Z +Box
                  IF(X.GE.Box)X=X -Box 
                  IF(Y.GE.Box)Y=Y -Box 
                  IF(Z.GE.Box)Z=Z -Box
              DD =(X-Xc)**2+(Y-(Yc))**2
     &                     +(Z-(Zc))**2
              If(DD.lt.Radius2)Then !  inside the limits -- take it
                Vxs=ScaleV* VX(IN)
                Vys=ScaleV* VY(IN)
                Vzs=ScaleV* VZ(IN)
                Icount =Icount +1
                vmax =MAX(vmax,Vxs,Vys,Vzs)
                vmin =MIN(vmin,Vxs,Vys,Vzs)
                If(Nspecies.eq.0)Then   ! find weight of particle
                   W =PARTW
                Else
                   Ipart =IN+iL             ! current particle number
                   Do i =1,Nspecies
                      if(Ipart.le.lspecies(i))Then
                         W =wspecies(i)
                         goto 50
                      endif 
                   EndDo 
                EndIf
 50         If(Icount/Ifraction*Ifraction.eq.Icount)Then
                  N   = N +1
                  If(Ipart.le.lspecies(1))Nsm=Nsm +1
                  IF(N.gt.Np)Then    ! too many particles
                           write (*,*) ' Too many particles. Max=',Np
                           STOP
                  Endif 
                  Xp(N)  =X   
                  Yp(N)  =Y   
                  Zp(N)  =Z   
                  Ipart  =IN+iL                     ! current particle number
                  iWeight(N) = INT(W/wspecies(1)+0.1) ! W  ! ! W  ! particles weight   iWeight(Ipart)   
                  If(iWeight(N).lt.1.001)Then
                     xmax =MAX(xmax,Xp(N))
                     xmin  =MIN(xmin,Xp(N))
                     ymax =MAX(ymax,Yp(N))
                     ymin  =MIN(ymin,Yp(N))
                     zmax =MAX(zmax,Zp(N))
                     zmin  =MIN(zmin,Zp(N))
                     ii =Min(INT(X/Box*25.),25)
                     jj =Min(INT(Y/Box*25.),25)
                     kk =Min(INT(Z/Box*25.),25)
                     Xdist(ii) =Xdist(ii) +1
                     Ydist(jj) =Ydist(jj) +1
                     Zdist(kk) =Zdist(kk) +1
                   EndIf
                 Endif
              Endif      ! end test for center
	      ENDDO
        ENDDO 
 300    write (*,*) ' Number of particles selected:=',N,' Small=',Nsm
        write (*,*) ' Limits                              =',xmin,xmax       
        write (*,*) '                                     =',ymin,ymax
        write (*,*) '                                     =',zmin,zmax
        write (*,*) '  Radius      =',Radius,' Centre=',Xc,Yc,Zc
        write (*,'(i3,2x,i9,2x,i9,2x,i9)')
     &             (i,Xdist(i),Ydist(i),Zdist(i),i=0,25)
        Return
        End
C--------------------------------------------------------------
C                                           Make linker lists of particles in each cell
      SUBROUTINE List(Box,N,xmin,ymin,zmin)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
             Do i=1,N
                Lst(i)=-1
             EndDo

             Do k=Nm,Nb
             Do j=Nm,Nb
             Do i=Nm,Nb
                Label(i,j,k)=0
             EndDo
             EndDo
             EndDo  
      Do jp=1,N
         i=INT((Xp(jp)-xmin)/Cell)
         j=INT((Yp(jp)-ymin)/Cell)
         k=INT((Zp(jp)-zmin)/Cell)
         i=MIN(MAX(Nm,i),Nb)
         j=MIN(MAX(Nm,j),Nb)
         k=MIN(MAX(Nm,k),Nb)
         Lst(jp)      =Label(i,j,k)
         Label(i,j,k) =jp
      EndDo

      Return
      End
C--------------------------------------------------------------
C                                Find all neibhours for a center
C                                Xc,Yc,Zc - center; ww-its weight
C
      SUBROUTINE Neib(Amnew,xmin,ymin,zmin,Xc,Yc,Zc,Radius)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMlists.h'
C                                       Initiate counters
  	  Amnew =0.
        Radius2=Radius**2
c                      limits for Label
         i1=INT((Xc-xmin-Radius)/Cell)
         j1=INT((Yc-ymin-Radius)/Cell)
         k1=INT((Zc-zmin-Radius)/Cell)
            i1=MIN(MAX(Nm,i1),Nb)
            j1=MIN(MAX(Nm,j1),Nb)
            k1=MIN(MAX(Nm,k1),Nb)
         i2=INT((Xc-xmin+Radius)/Cell)
         j2=INT((Yc-ymin+Radius)/Cell)
         k2=INT((Zc-zmin+Radius)/Cell)
            i2=MIN(MAX(Nm,i2),Nb)
            j2=MIN(MAX(Nm,j2),Nb)
            k2=MIN(MAX(Nm,k2),Nb)
C                                        Look for neibhours
c            nn =0
         Do k=k1,k2
         Do j=j1,j2
         Do i=i1,i2
            jp =Label(i,j,k)
 10         If(jp.ne.0)Then
               dd =(Xc-Xp(jp))**2+(Yc-Yp(jp))**2+(Zc-Zp(jp))**2
               If(dd.lt.Radius2)Then
c                  nn =nn +1
	             Amnew=Amnew + iWeight(jp)
               EndIf  
                  jp =Lst(jp)
               GoTo10
            EndIf
         EndDo
         EndDo
         EndDo

c         write (*,100) nn,i1,i2,j1,j2,k1,k2,Xc,Yc,Zc
c 100     format(' Nn=',i6,3(2i4,2x),3f8.3)
      Return
      End

c-------------------------------------------------------------------- 
c                        Distribution functions
c                        in halo catalogs
c-------------------------------------------------------------------- 
      PARAMETER (Nmax = 300000) ! 
      PARAMETER (Nbinmax = 70) !
      PARAMETER (Nqual   = 13) ! 
      DIMENSION Nin(Nbinmax),NinC(Nbinmax),Vc(Nbinmax),
     &           Conc(Nbinmax), hals(Nqual)
      Character  File1*100,File2*100
      DATA      Nin,NinC,Vc,Conc/Nbinmax*0,Nbinmax*0,Nbinmax*0.,
     &                          Nbinmax*0./
      Character Header*100

      write (*,'(" Enter Name of halo Catalog=",$)')
      read(*,'(A)') File1
      File2 = 'distr'//File1
      Open(1,file=File1)
      Open(2,file=File2)

      Lines = 22
      dlog  = 0.05
      Do i=1,Lines
         read(1,'(a)') Header
         write (*,'(a)')  Header
         if(i.le.3)write (2,'(a)')  Header
      EndDo


      Nh =0
 100  Nh =Nh+1
 105  read(1,*,err=400,end=400) (hals(i),i=1,Nqual)
      if(hals(13).lt.2.5)Goto105    ! skip halos wih too small C
c         write(*,'(" Halo=",i8," coords=",3f8.3," bins=",i3)')
c     &              Nh,(hals(i,Nh),i=1,3),Nhbin(Nh)
         ind =min(max(INT(log10(hals(10))/dlog),1),Nbinmax)
c         write(*,*) ' halo=',Nh,hals(10),ind
         Nin(ind) = Nin(ind) +1
         Vc(ind)  = Vc(ind)  +hals(10)
         If(hals(13).gt.3.0)Then   ! drop halos with too small C
            Conc(ind)= Conc(ind)+hals(13) 
            NinC(ind)= NinC(ind)+1
         EndIf 
      If(Nh.lt.Nmax)goto100
      Nh =Nh +1
 400  Nh =Nh -1

      write (*,*)  ' Number of halos read =',Nh
      write (2,*)  ' Number of halos =',Nh
      write(2,'(" Bin",6x,"Nhalos",5x,"V",8x,"Vhals",
     &                    5x,"dN/dV",8x,"<C>")')  
      Do i=1,Nbinmax
        V0  =10.**(i*dlog)      
        V1  =10.**((i+1.)*dlog) 
        If(V0.gt.30..and.V0.lt.1500.)Then
           dd  =Nin(i)/(V1-V0)
           If(Nin(i).gt.0)Then
              Vcav = Vc(i)/Nin(i)
           Else
              Vcav = (V1+V0)/2.
           EndIf
           write(2,'(2i6,10g11.4)') i,Nin(i),(V1+V0)/2.,
     &             Vcav,dd,Conc(i)/max(NinC(i),1)
           write(*,'(2i6,10g11.4)') i,Nin(i),(V1+V0)/2.,
     &             Vcav,dd,Conc(i)/max(NinC(i),1)
        EndIf
      EndDo 
      stop
      end

*DECK DGAUS8
      SUBROUTINE DGAUS8 (FUN, A, B, ERR, ANS, IERR)
C***BEGIN PROLOGUE  DGAUS8
C***PURPOSE  Integrate a real function of one variable over a finite
C            interval using an adaptive 8-point Legendre-Gauss
C            algorithm.  Intended primarily for high accuracy
C            integration or integration of smooth functions.
C***LIBRARY   SLATEC
C***CATEGORY  H2A1A1
C***TYPE      DOUBLE PRECISION (GAUS8-S, DGAUS8-D)
C***KEYWORDS  ADAPTIVE QUADRATURE, AUTOMATIC INTEGRATOR,
C             GAUSS QUADRATURE, NUMERICAL INTEGRATION
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C     Abstract  *** a DOUBLE PRECISION routine ***
C        DGAUS8 integrates real functions of one variable over finite
C        intervals using an adaptive 8-point Legendre-Gauss algorithm.
C        DGAUS8 is intended primarily for high accuracy integration
C        or integration of smooth functions.
C
C        The maximum number of significant digits obtainable in ANS
C        is the smaller of 18 and the number of digits carried in
C        double precision arithmetic.
C
C     Description of Arguments
C
C        Input--* FUN, A, B, ERR are DOUBLE PRECISION *
C        FUN - name of external function to be integrated.  This name
C              must be in an EXTERNAL statement in the calling program.
C              FUN must be a DOUBLE PRECISION function of one DOUBLE
C              PRECISION argument.  The value of the argument to FUN
C              is the variable of integration which ranges from A to B.
C        A   - lower limit of integration
C        B   - upper limit of integration (may be less than A)
C        ERR - is a requested pseudorelative error tolerance.  Normally
C              pick a value of ABS(ERR) so that DTOL .LT. ABS(ERR) .LE.
C              1.0D-3 where DTOL is the larger of 1.0D-18 and the
C              double precision unit roundoff D1MACH(4).  ANS will
C              normally have no more error than ABS(ERR) times the
C              integral of the absolute value of FUN(X).  Usually,
C              smaller values of ERR yield more accuracy and require
C              more function evaluations.
C
C              A negative value for ERR causes an estimate of the
C              absolute error in ANS to be returned in ERR.  Note that
C              ERR must be a variable (not a constant) in this case.
C              Note also that the user must reset the value of ERR
C              before making any more calls that use the variable ERR.
C
C        Output--* ERR,ANS are double precision *
C        ERR - will be an estimate of the absolute error in ANS if the
C              input value of ERR was negative.  (ERR is unchanged if
C              the input value of ERR was non-negative.)  The estimated
C              error is solely for information to the user and should
C              not be used as a correction to the computed integral.
C        ANS - computed value of integral
C        IERR- a status code
C            --Normal codes
C               1 ANS most likely meets requested error tolerance,
C                 or A=B.
C              -1 A and B are too nearly equal to allow normal
C                 integration.  ANS is set to zero.
C            --Abnormal code
C               2 ANS probably does not meet requested error tolerance.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  D1MACH, I1MACH, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   810223  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890911  Removed unnecessary intrinsics.  (WRB)
C   890911  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C***END PROLOGUE  DGAUS8
      INTEGER IERR, K, KML, KMX, L, LMN, LMX, LR, MXL, NBITS,
     1 NIB, NLMN, NLMX
      INTEGER I1MACH
      DOUBLE PRECISION A,AA,AE,ANIB,ANS,AREA,B,C,CE,EE,EF,
     1 EPS, ERR, EST, GL, GLR, GR, HH, SQ2, TOL, VL, VR, W1, W2, W3,
     2 W4, X1, X2, X3, X4, X, H
      DOUBLE PRECISION D1MACH, G8, FUN
      DIMENSION AA(60), HH(60), LR(60), VL(60), GR(60)
      SAVE X1, X2, X3, X4, W1, W2, W3, W4, SQ2,
     1 NLMN, KMX, KML
      DATA X1, X2, X3, X4/
     1     1.83434642495649805D-01,     5.25532409916328986D-01,
     2     7.96666477413626740D-01,     9.60289856497536232D-01/
      DATA W1, W2, W3, W4/
     1     3.62683783378361983D-01,     3.13706645877887287D-01,
     2     2.22381034453374471D-01,     1.01228536290376259D-01/
      DATA SQ2/1.41421356D0/
      DATA NLMN/1/,KMX/5000/,KML/6/
      G8(X,H)=H*((W1*(FUN(X-X1*H) + FUN(X+X1*H))
     1           +W2*(FUN(X-X2*H) + FUN(X+X2*H)))
     2          +(W3*(FUN(X-X3*H) + FUN(X+X3*H))
     3           +W4*(FUN(X-X4*H) + FUN(X+X4*H))))
C***FIRST EXECUTABLE STATEMENT  DGAUS8
C
C     Initialize
C
      K = I1MACH(14)
      ANIB = D1MACH(5)*K/0.30102000D0
      NBITS = ANIB
      NLMX = MIN(60,(NBITS*5)/8)
      ANS = 0.0D0
      IERR = 1
      CE = 0.0D0
      IF (A .EQ. B) GO TO 140
      LMX = NLMX
      LMN = NLMN
      IF (B .EQ. 0.0D0) GO TO 10
      IF (SIGN(1.0D0,B)*A .LE. 0.0D0) GO TO 10
      C = ABS(1.0D0-A/B)
      IF (C .GT. 0.1D0) GO TO 10
      IF (C .LE. 0.0D0) GO TO 140
      ANIB = 0.5D0 - LOG(C)/0.69314718D0
      NIB = ANIB
      LMX = MIN(NLMX,NBITS-NIB-7)
      IF (LMX .LT. 1) GO TO 130
      LMN = MIN(LMN,LMX)
   10 TOL = MAX(ABS(ERR),2.0D0**(5-NBITS))/2.0D0
      IF (ERR .EQ. 0.0D0) TOL = SQRT(D1MACH(4))
      EPS = TOL
      HH(1) = (B-A)/4.0D0
      AA(1) = A
      LR(1) = 1
      L = 1
      EST = G8(AA(L)+2.0D0*HH(L),2.0D0*HH(L))
      K = 8
      AREA = ABS(EST)
      EF = 0.5D0
      MXL = 0
C
C     Compute refined estimates, estimate the error, etc.
C
   20 GL = G8(AA(L)+HH(L),HH(L))
      GR(L) = G8(AA(L)+3.0D0*HH(L),HH(L))
      K = K + 16
      AREA = AREA + (ABS(GL)+ABS(GR(L))-ABS(EST))
C     IF (L .LT .LMN) GO TO 11
      GLR = GL + GR(L)
      EE = ABS(EST-GLR)*EF
      AE = MAX(EPS*AREA,TOL*ABS(GLR))
      IF (EE-AE) 40, 40, 50
   30 MXL = 1
   40 CE = CE + (EST-GLR)
      IF (LR(L)) 60, 60, 80
C
C     Consider the left half of this level
C
   50 IF (K .GT. KMX) LMX = KML
      IF (L .GE. LMX) GO TO 30
      L = L + 1
      EPS = EPS*0.5D0
      EF = EF/SQ2
      HH(L) = HH(L-1)*0.5D0
      LR(L) = -1
      AA(L) = AA(L-1)
      EST = GL
      GO TO 20
C
C     Proceed to right half at this level
C
   60 VL(L) = GLR
   70 EST = GR(L-1)
      LR(L) = 1
      AA(L) = AA(L) + 4.0D0*HH(L)
      GO TO 20
C
C     Return one level
C
   80 VR = GLR
   90 IF (L .LE. 1) GO TO 120
      L = L - 1
      EPS = EPS*2.0D0
      EF = EF*SQ2
      IF (LR(L)) 100, 100, 110
  100 VL(L) = VL(L+1) + VR
      GO TO 70
  110 VR = VL(L+1) + VR
      GO TO 90
C
C     Exit
C
  120 ANS = VR
      IF ((MXL.EQ.0) .OR. (ABS(CE).LE.2.0D0*TOL*AREA)) GO TO 140
      IERR = 2
      write (*,*)  'DGAUS8: ',
     +   'ANS is probably insufficiently accurate.'
      GO TO 140
  130 IERR = -1
      write (*,*)   'DGAUS8: ',
     +   'A and B are too nearly equal to allow normal integration.'
  140 IF (ERR .LT. 0.0D0) ERR = CE
      RETURN
      END

C---------------------------------------------------
C                           Spectrum of perturbations: P(k), sigma_8,V(50h-1Mpc)
C     Anatoly Klypin December 1997
C                                                       Holtzman           appoximation  
C                                             or       BBKS-style + Hu&Sugiyama approx
C                            Needs cdm.fit file -- parameters of models and fitting 
C-----------------------------------------------------
C                            Om   = Omega_0                Omc   = Omega_cdm_present
C                            Omb = Omega_baryon     Omnu =Omega_neutrino_present
C                            Ocurv = Omega_curvature_present
C                            hsmall = H_0/100km/s/Mpc = the Hubble constant
C                            ns    = slope of the power spectum (ns=1 for Harr-Zeld)
C                            AEXPN = expansion parameter = 1/(1+z), z =redshift
C                            All calculations are done in real Mpc,
C                            Only final outputs are scaled to  h^{-1} 
C-----------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (NtabM = 100000)
      PARAMETER (Nm    = 100)
      PARAMETER (Na    = 10)
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Ocurv,Par(6),AEXPN,Sn,ns,hsmall
      COMMON / Coeff/   deltac22,deltac,rf,Uklow,Ukup,GrowthDen_0
      COMMON /PTABLE/xkt(0:NtabM),Pkt(0:NtabM),StepK,alog0,iFlag,Ntab 
      CHARACTER         Name*16,Answer*1,Header*45,StartFile*16
      REAL*8              INTG,ns,INPUT,P2,P,Ptophat,Pgauss,Vtophat
      DIMENSION       aNdens(Nm,Na),aMasses(Nm),aRedshifts(Na)
      EXTERNAL           INTG,P2,P,Ptophat,Pgauss,Vtophat
      DATA                StartFile/'InStart.dat'/
      WRITE (*,*) '================< Enter File Name for output file: '
      READ  (*,'(a)') Name
      OPEN(1,file=Name)
      OPEN(10,file='number'//Name)
      OPEN(2,file='cdm.fit') !  parameters of models
      
C                                                     Constants
      PI     =3.1415926535
      AEXPN =1.
      WRITE (*,'(A,$)') ' Enter sigma_8 and slope n: '
      READ  (*,*) Sigma8,ns
      CALL MODEL(Line)
      H      =100.*hsmall     ! Hubble constant
      DO a=0.1,1.,0.1
         z =1./a-1.
         CALL AGE(t0,GrowthDen,GrowthVel,a)
         write (*,20) t0,z,a,GrowthDen,GrowthVel
         write (1,20) t0,z,a,GrowthDen,GrowthVel
         write (10,20) t0,z,a,GrowthDen,GrowthVel
 20      format(' Age=',f8.3,' z=',f6.2,' a=',f6.3,
     .          ' GrowthRateDen=',f7.4,
     .          ' GrowthRateVelocity=',f7.4)
      ENDDO
      AEXPN =1.
      a =AEXPN
      z =1./a-1.
      write (*,*) ' a=',a,' Aexpn=',AEXPN
      CALL AGE(t0,GrowthDen_0,GrowthVel_0,a)
         write (*,20) t0,z,a,GrowthDen,GrowthVel
         write (1,20) t0,z,a,GrowthDen,GrowthVel
         write (10,20) t0,z,a,GrowthDen,GrowthVel
 
      rf    =8./hsmall        ! top-hat for sigma_8
      Sn    = (Sigma8)**2 / 
     &          INTG(Ptophat,1.d-5,5.d+1) ! normalization of P(k)
c                                             bias parameter      
      Sigma8 = sqrt(Sn*(
     &          INTG(Ptophat,1.d-5,5.d+1)))
      write (*,10) hsmall,Sigma8,ns  ! check if all is self-consistent
      write (1,10) hsmall,Sigma8,ns
      write (10,10) hsmall,Sigma8,ns
 10   Format(' Hubble=',f7.3,' Sigma_8 =',G11.3,
     &       ' Slope n=',f7.2)

c                       Evolution of Sigma(mass,a),Fraction_collapsed(a)
      write(1,15)'    Z       a'
 15   format(a,T17,3(3x,'Mass',7x,'Sigma',
     &       '    FracMass'))
      Do i=0,30
         z =i/3.
         AEXPN    = 1./(1.+z)
         aMass1   = 1.e10
         ss1      = SigMass(aMass1)
         fr_mass1 = 0.5*derfc(1.68d0/sqrt(2.)/ss1)
         aMass2   = 1.e11
         ss2      = SigMass(aMass2)
         fr_mass2 = 0.5*derfc(1.68d0/sqrt(2.)/ss2)
         aMass3   = 1.e12
         ss3      = SigMass(aMass3)
         fr_mass3 = 0.5*derfc(1.68d0/sqrt(2.)/ss3)

         write (1,'(2f8.3,3(g11.3,f9.3,g11.3))')z,AEXPN,
     &          aMass1,ss1,fr_mass1,
     &          aMass2,ss2,fr_mass2,aMass3,ss3,fr_mass3
      EndDo 

C                      Mass function at different redshifts
      Do i=1,Nm
         aMasses(i) = 1.d10*10.**(i/float(Nm)*4.)
      EndDo 
      Do i=1,Na
         aRedshifts(i) = (i/float(Na)*10.)
      EndDo 
      aRedshifts(1) =0.

      Do j=1,Na
         z     = aRedshifts(j)
         AEXPN = 1./(1.+z) 
      Do i=1,Nm
         aMass = aMasses(i)
         aNdens(i,j) = aNumber(aMass)
      EndDo 
      EndDo 
      write (10,'(2a)')' M(sun/h)','  Redshifts'
      write (10,'(11x,16g11.3)') aRedshifts 
      Do i=1,Nm
         write (10,'(g11.3,16g11.3)')
     &    aMasses(i)*hsmall,(aNdens(i,j)/hsmall**3,j=1,Na)
      EndDo 


      rf =50./hsmall           ! top-hat for bulk velocity
      Veloc = GrowthVel*H*
     &           sqrt(Sn*(INTG(Vtophat,1.d-5,1.d+0)))      
      write (*,30) Veloc,rf*hsmall
      write (1,30) Veloc,rf*hsmall
 30   Format(' Bulk Velocity =',F8.2,
     .       'km/s for radius top-hat=',f8.1,'h-1Mpc')
      write (1,*) ' k/h        Pk*h^3   Power Spectrum at z=',1/AEXPN-1.
      DO i=1,110
        w =1.e-4*10.**(i/20.)
        Pk0  =P(w)*Sn*hsmall**3*(2.*pi**2) 
        write (1,14) w/hsmall,Pk0
      ENDDO
 14   Format(2G11.4,5G12.4)
C..........................................................Power spectrum and  
C                                                         Amplitude of fluctuations in a Box at redshift z
      WRITE (*,'(A,$)')
     &         'Enter Box(h^-1Mpc), Nparticles(1D) and redshift:'
      READ  (*,*) Box, NROW, z
      Box   =Box/hsmall           ! scale it to real Mpc
      Uklow =2.*pi/Box            ! frequency range for integrals
      Ukup  =2.*pi/Box*(NROW/2.)
      AEXPN =1./(1.+z)            ! expansion parameter
      a     =AEXPN
      CALL AGE(t0,GrowthDen,GrowthVel,a)
      sigma =(GrowthDen/GrowthDen_0)*
     &             sqrt(Sn*INTG(P2,Uklow/sqrt(2.),Ukup))
      WRITE (*,40) z,sigma,NROW,Box*hsmall
 40   format('  z=',f8.3,' delta\rho/rho in box=',f9.5,/
     .       5X,'Particles=',i4,' Box=',f8.2)
      write (1,*) ' k/h        Pk*h^3   Power Spectrum at z=',1/AEXPN-1.
      DO i=1,130
        w =1.e-4*10.**(i/20.)
        Pk0  =(GrowthDen/GrowthDen_0)**2*P(w)*Sn*hsmall**3*(2.*pi**2) 
        write (1,14) w/hsmall,Pk0
      ENDDO
C............................................................................................      
      WRITE (*,'(A,$)') ' Do you need a file to run PMstart (Yes/No) '
      READ  (*,'(a)') Answer
      IF(Answer.eq.'Y'.or.Answer.eq.'y')Then ! prepare input file
         OPEN(30,file=StartFile)        !  parameters of a run
         write(30,'(A)') 'Yes           Read parameters from cdm.fit'
         HEADER='N=128x256 L=20h-1CDMsig=0.239 z=30-----------'
         write (*,*) '------ Enter Header up to 45 characters'
         write (*,*) '       Example:'
         write (*,'(A)') HEADER 
         read  (*,'(A)') HEADER
         write (30,'(A)') HEADER
         write (30,*) AEXPN,'    Expansion Parameter'
         ASTEP =INPUT(' Step of the expansion parameter  =')
         write (30,*) ASTEP,'    Step in dAEXPN    '
         write (30,*) sigma,'    DRho/rho in box   '
         write (30,*) ns,   '    Slope of P(k)     '
         write (30,*) Box*hsmall,'    Box in  Mpc/h   '
         write (30,*) Ocurv,'    Omega_curvature   '
         Nseed =INPUT(' Enter random seed integer 1-2^31 =')
         write (30,*) Nseed,'    Random seed       '
         write (30,*) Line,'     Line number in cdm.fit'
         Write (*,'(A,$)') ' Enter Min and Max number of mass species ='
         read (*,*) Nmin_lev,Nmax_lev       
         write (30,*) Nmin_lev,Nmax_lev,' Min and Max number of species'
         write (*,*) ' Results were written to file: ',StartFile
         CLOSE (30)
      ENDIF
      STOP
	   END
c-----------------------------------  Pcold(k)*k^2
      REAL*8 FUNCTION P2(WK)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Ocurv,Par(6),AEXPN,Sn,ns,hsmall
      COMMON / Coeff/   deltac22,deltac,rf,Uklow,Ukup,GrowthDen_0
      Real*8 ns
        P2=WK**2*P(WK)
      RETURN
      END

C---------------------------------------------
C                                                                 Power spectrum
C                                                                wk = k= in real Mpc
      REAL*8 FUNCTION P(wk)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (NtabM = 100000)
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Ocurv,Par(6),AEXPN,Sn,ns,hsmall
      COMMON / FACT/    qqscaleb
      COMMON /PTABLE/xkt(0:NtabM),Pkt(0:NtabM),StepK,alog0,iFlag,Ntab  

      Real*8 ns
      If(iFlag.gt.0)Then       ! use approximations
      If(Par(6).ne.0.)Then   ! Holtzman approx
        sk= sqrt(wk)
        P = wk**ns /
     .         (1.+sk*(Par(2)
     .            +sk*(Par(3)
     .            +sk*(Par(4)
     .            +sk*(Par(5) )))) )**(2.*Par(6))
      Else                   ! BBKS + Sugiyama approx
c        Gammaeff =Om*hsmall/exp(Omb*(1.+sqrt(hsmall/0.5)/Om))
c        Q = wk/hsmall/Gammaeff
        Q = wk*qqscaleb
        
        P = wk**ns*( LOG(1.+Par(1)*Q)/(Par(1)*Q) )**2/
     .          sqrt(1.+Q*(Par(2)+
     .                  Q*(Par(3)**2+
     .                  Q*(Par(4)**3+
     .                  Q*(Par(5)**4) ))))
      EndIf
      Else                ! use table for P(k)
         P = Ppk(wk)
      EndIf 
      RETURN
      END
C-------------------------------------------------
C                                  Age of the Universe: t0 (z=0)
C                                  Expansion parameter: a =1/(1+z)
C                                  Growth_Rate_Density at a: GrowthDen
C                                     GrowthDen =\delta\rho/\rho
C                                     normalized to GrowthDen =a for Omega=1
C                                     GrowthDen < 1 at a=1 for Lcdm or OCDM
C                                  Growth_Rate_velocity at a: GrowthVel
C                                     GrowthVel = V_peculiar= (a/delta)(d delta/d a)
      SUBROUTINE AGE(t0,GrowthDen,GrowthVel,a)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (zero =1.d-12)
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Ocurv,Par(6),AEXPN,Sn,ns,hsmall
      Common /OmegRat/ OmLOm0,OmcOm0
      Real*8  INTG,ns
      External Hnorm,Hage,Hgrow

      Oml    =Max(Abs(1.-Om-Ocurv),zero)
      OmLOm0 =Oml/Om
      OmcOm0 =Ocurv/Om
      t0     =9.766/hsmall/sqrt(Om)*INTG(Hage,zero,a)
      z      =1./a-1.
      Hubble = hsmall*sqrt(Om/a**3)*Hnorm(a)
         ww  =INTG(Hgrow,zero,a)
      GrowthVel = -(1.5+OmcOm0*a)/Hnorm(a)**2+
     &                 sqrt(a**5)/Hnorm(a)**3/ww
      GrowthDen =2.5*Hnorm(a)/sqrt(a**3)*ww
c         write (*,20) t0,z,a,Hubble,GrowthDen,GrowthVel
c         write (1,20) t0,z,a,Hubble,GrowthDen,GrowthVel
c 20      format(' Age=',f8.3,' z=',f6.2,' a=',f6.3,
c     .          ' Hubble/100=',f8.3,' GrowthRateDen=',f7.4,
c     .          ' GrowthRateVelocity=',f7.4)
      Return
      End
c-----------------------------------  P(k)*k^2*gauss(rf)
      REAL*8 FUNCTION Pgauss(WK)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Ocurv,Par(6),AEXPN,Sn,ns,hsmall
      COMMON / Coeff/   deltac22,deltac,rf,Uklow,Ukup,GrowthDen_0
      Real*8 ns
        Pgauss=WK**2*P(WK)*EXP(-(rf*WK)**2)
      RETURN
      END
c-----------------------------------  P(k)*k^4*gauss(rf)
      REAL*8 FUNCTION P4gauss(WK)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Ocurv,Par(6),AEXPN,Sn,ns,hsmall
      COMMON / Coeff/   deltac22,deltac,rf,Uklow,Ukup,GrowthDen_0
      Real*8 ns
        P4gauss=WK**4*P(WK)*EXP(-(rf*WK)**2)
      RETURN
      END
C-------------------------------------- P*k^2*Top-Hat Filter
      REAL*8 FUNCTION Ptophat(wk)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Ocurv,Par(6),AEXPN,Sn,ns,hsmall
      COMMON / Coeff/   deltac22,deltac,rf,Uklow,Ukup,GrowthDen_0
      Real*8 ns
	   IF (wk.lt.1.d-4) THEN
            Ptophat =wk**ns*wk**2
        ELSE
            X      =wk*rf
	         TOPHAT =( (SIN(X)-x*COS(X))*3./X**3 )**2
            Ptophat=P(wk)*wk**2*TOPHAT
        ENDIF
      RETURN
      END
C-------------------------------------- Number-density of halos
C                              Gives M*dN/dM in units Mpc**-3
C                              aMass is in real Msun units
c                              Calls function Fn(sigma)
      REAL*8 FUNCTION aNumber(aMass)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (pi = 3.1415926535d0)
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Ocurv,Par(6),AEXPN,Sn,ns,hsmall
      COMMON / Coeff/   deltac22,deltac,rf,Uklow,Ukup,GrowthDen_0
      REAL*8            INTG,ns,INPUT,Ptophat
      EXTERNAL          INTG,Ptophat

      rf = (aMass/(1.154e12*Om*hsmall**2))**0.33333333
      a  = AEXPN

      CALL AGE(t0,GrowthDen,GrowthVel,a)
      Sig =(GrowthDen/GrowthDen_0)*
     &           sqrt(Sn*INTG(Ptophat,1.d-4,2.d+2))
      aM1 = aMass*1.03
      rf  = (aM1/(1.154e12*Om*hsmall**2))**0.33333333
      Sig1=(GrowthDen/GrowthDen_0)*
     &           sqrt(Sn*INTG(Ptophat,1.d-4,2.d+2))

      aM0 = aMass/1.03
      rf  = (aM0/(1.154e12*Om*hsmall**2))**0.33333333
      Sig0=(GrowthDen/GrowthDen_0)*
     &           sqrt(Sn*INTG(Ptophat,1.d-4,2.d+2))

      derivative = (Sig0-Sig1)/Sig/(aM1-aM0)
      factor     = Fn(Sig)
      aNumber    = 2.75e11*(Om*hsmall**2)*
     &             derivative * factor

c      write (*,'(9g12.4)')aMass,Sig,Sig0,Sig1,
c     &          derivative,factor,aNumber 
      if(aNumber.lt.0..or.derivative.lt.0.)
     &    write (*,'(a,12g12.4)')' Error PS:',aMass,Sig,Sig1,Sig0,
     &           derivative,factor,aNumber,aM0,aM1
      RETURN
      END
C-------------------------------------- Auxiliary for aNumber()
C                              Gives dependance on sigma(M)
C
      REAL*8 FUNCTION Fn(sigma)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (pi = 3.1415926535d0)
      PARAMETER (Deltac = 1.68)

      x  = Deltac/sigma
      Fn =sqrt(2./pi)*x*exp(-0.5*x**2)

      RETURN
      END
 
C-------------------------------------- rms fluctuations
C                                       for mass aMass
C                              aMass is in real Msun units
      REAL*8 FUNCTION SigMass(aMass)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (pi = 3.1415926535d0)
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Ocurv,Par(6),AEXPN,Sn,ns,hsmall
      COMMON / Coeff/   deltac22,deltac,rf,Uklow,Ukup,GrowthDen_0
      REAL*8            INTG,ns,INPUT,Ptophat
      EXTERNAL          INTG,Ptophat

            rf= (aMass/(1.154e12*Om*hsmall**2))**0.33333333
            a     =AEXPN
      CALL AGE(t0,GrowthDen,GrowthVel,a)
      SigMass =(GrowthDen/GrowthDen_0)*
     &           sqrt(Sn*INTG(Ptophat,1.d-5,2.d+2))

      RETURN
      END

C-------------------------------------- P*Top-Hat Filter
      REAL*8 FUNCTION Vtophat(wk)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Ocurv,Par(6),AEXPN,Sn,ns,hsmall
      COMMON / Coeff/   deltac22,deltac,rf,Uklow,Ukup,GrowthDen_0
      Real*8 ns
   	IF (wk.lt.1.d-4) THEN
            Vtophat =wk**ns
        ELSE
            X=wk*rf
	    TOPHAT=( (SIN(X)-x*COS(X))*3./X**3 )**2
            Vtophat=P(wk)*TOPHAT
        ENDIF
      RETURN
      END
C-------------------------------------- Linear Pair-wise V
      REAL*8 FUNCTION Vpairwise(wk)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Ocurv,Par(6),AEXPN,Sn,ns,hsmall
      COMMON / Coeff/   deltac22,deltac,rf,Uklow,Ukup,GrowthDen_0
      Real*8 ns
            X        =wk*rf
            Vpairwise=P(wk)*(1.-sin(X)/X)
      RETURN
      END
C________________________________________Read parameters of the model
C                                 Om       = Omega_0
C                                 Omb     = Omega_baryon
C                                 Omnu  = Omega_neutrino
C                                 hsmall  = hubble constant
C                                 Par      = fitting parameters
C                                 Par(6) = 0  --- bbks-style+Hu&Sugiyama
C                                 Par(6) ne 0 --- holtzman-style
      SUBROUTINE MODEL(Line)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (NtabM = 100000)
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Ocurv,Par(6),AEXPN,Sn,ns,hsmall
      COMMON / FACT/    qqscaleb
      COMMON /PTABLE/xkt(0:NtabM),Pkt(0:NtabM),StepK,alog0,iFlag,Ntab  

      Real*8 ns,INPUT
      Character             Header*79      

      Line =INPUT(' Enter Line Number in  cdm.fit=   ')
      If(Line.gt.0)Then
         iFlag = Line
      Read(2,'(A)') Header
      If(Line.gt.2)Then
         Do i=1,Line -2
            Read (2,*) a
         EndDo
      EndIf
      Read (2,*) Om,Omb,Omc,Omnu,hsmall,Par
       
      Ocurv =INPUT(' Enter Omega curvature at z=0  =>')
      theta = 2.726/2.7  ! = T_cmb/2.7
      Ob0   =Omb/Om      ! Hu&Sugiyama fitting
      Omh2  =Om*hsmall**2
      a1    =(46.9*Omh2)**0.670*(1.+(32.1*Omh2)**(-0.532))
      a2    =(12.0*Omh2)**0.424*(1.+(45.*Omh2)**(-0.582))
      alpha =1./a1**Ob0/a2**(Ob0**3)
c      qqscaleb = theta**2/(1.-Ob0)**0.60/sqrt(alpha)/Omh2
      qqscaleb = 1./Omh2*exp(Omb*(1.+sqrt(2*hsmall)/Om))

      Write (*,20)Om,Omb,Omc,Omnu,hsmall,Par
      Write (1,20)Om,Omb,Omc,Omnu,hsmall,Par
      Write (10,20)Om,Omb,Omc,Omnu,hsmall,Par
 20   Format(' Model: Om_0=',F5.3,' Om_baryon=',F5.3,
     .       ' Om_cold=',F5.3,' O_nu=',F5.3,
     .       ' hsmall=',F4.2,/8x,'Parameters=',(6G9.3))
      Else
         iFlag = Line
         If(iFlag.lt.-3)Stop ' Error: model Line # less than -3'
         If(iFlag.eq.-1)Then  ! W.Hu table
            hsmall = 0.7
            Omb = 0.024/hsmall**2
            Om   = 0.3
            Ocurv = 0.
            Omc  = Om
         EndIf
         If(iFlag.eq.-2)Then  ! Eis.Hu approximation
            hsmall = 0.7
            Omb = 0.04
            Om   = 0.3
            Ocurv = 0.
            Omc  = Om
         EndIf
         If(iFlag.eq.-3)Then  ! Eis.Hu approximation: WMAP
            hsmall = 0.73
            Omb = 0.04
            Om   = 0.24
            Ocurv = 0.
            Omc  = Om
         EndIf
 
      CALL ReadTable(hsmall)

      Write (*,22)Om,Omb,hsmall
      Write (1,22)Om,Omb,hsmall
 22   Format(' Model: Om_0=',F5.3,' Om_baryon=',F5.3,
     .       ' hsmall=',F4.2, ' <== Using table for P(k)')
      EndIf
      Return
      End
C-------------------------------------------- Simpson integration
      REAL*8 FUNCTION INTG(FUNC,A,B)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (EPS=5.0d-4, JMAX=22)
      EXTERNAL FUNC
      OST=-1.D30
      OS= -1.D30
      ST =0.
      DO 11 J=1,JMAX
        CALL TRAPZD(FUNC,A,B,ST,J)
        INTG=(4.0d0*ST-OST)/3.0d0
        IF (ABS(INTG-OS).Le.EPS*ABS(OS)) RETURN
        OS=INTG
        OST=ST
11    CONTINUE
      WRITE (*,*)'Integration did not converge'
      RETURN
      END
C----------------------------------------------
      SUBROUTINE TRAPZD(FUNCC,A,B,S,N)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
        SAVE IT
        EXTERNAL FUNCC
      IF (N.EQ.1) THEN
        S=0.5d0*(B-A)*(FUNCC(A)+FUNCC(B))
        IT=1
      ELSE
        TNM=IT
        DEL=(B-A)/TNM
        X=A+0.5D0*DEL
        SUM=0.0D0
        DO 11 J=1,IT
          SUM=SUM+FUNCC(X)
          X=X+DEL
11      CONTINUE
        S=0.5D0*(S+(B-A)*SUM/TNM)
        IT=2*IT
      ENDIF
      RETURN
      END

C-------------------------------------------- Simpson integration
      REAL*8 FUNCTION INTG1(FUNC,A,B)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (EPS=1.0d-3, JMAX=22)
      EXTERNAL FUNC
      OST=-1.d30
      OS= -1.d30
      ST =0.
      DO 11 J=1,JMAX
        CALL TRAPZD1(FUNC,A,B,ST,J)
        INTG1=(4.0D0*ST-OST)/3.0D0
        IF (ABS(INTG1-OS).Le.EPS*ABS(OS)) RETURN
        OS=INTG1
        OST=ST
11    CONTINUE
c      WRITE (1,*)'Integration did not converge'
      RETURN
      END
C----------------------------------------------
      SUBROUTINE TRAPZD1(FUNCC,A,B,S,N)
C---------------------------------------
	IMPLICIT Real*8 (A-H,O-Z)
        SAVE IT
        EXTERNAL FUNCC
      IF (N.EQ.1) THEN
        S=0.5D0*(B-A)*(FUNCC(A)+FUNCC(B))
        IT=1
      ELSE
        TNM=IT
        DEL=(B-A)/TNM
        X=A+0.5D0*DEL
        SUM=0.0D0
        DO 11 J=1,IT
          SUM=SUM+FUNCC(X)
          X=X+DEL
11      CONTINUE
        S=0.5D0*(S+(B-A)*SUM/TNM)
        IT=2*IT
      ENDIF
      RETURN
      END
C---------------------------------- Read in variables      
      REAL*8 FUNCTION INPUT(text)
C-----------------------------------------
      Character text*(*)
          write (*,'(A,$)')text
          read (*,*) x
          INPUT =x
      Return
      End
C-----------------------------------------
      REAL*8 FUNCTION sinhh(x)
C-----------------------------------------
      IMPLICIT REAL*8 (A-H,P-Z)
         sinhh =0.5*(exp(MIN(x,33.d+0))-exp(-MIN(x,33.d+0)))
      RETURN
      END
C---------------------------------------
      REAL*8 FUNCTION Hh(x)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
         Hh =(sqrt(x/(1.d+0 +x**3)))**3 
      Return
      End
C---------------------------------------
      REAL*8 FUNCTION Hnorm(x)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      Common /OmegRat/ OmLOm0,OmcOm0
         Hnorm =sqrt(1.d+0 
     &                  +OmLOm0*x**3
     &                  +OmcOm0*x )
      Return
      End
C---------------------------------------
      REAL*8 FUNCTION Hage(x)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
         Hage =sqrt(x)/Hnorm(x) 
      Return
      End
C---------------------------------------
      REAL*8 FUNCTION Hgrow(x)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
         Hgrow =(sqrt(x)/Hnorm(x))**3 
      Return
      End
C---------------------------------------
      REAL*8 FUNCTION Ppk(x)
c                     interpolate table with p(k)
c                       x is in real 1/Mpc
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (NtabM = 100000)
      COMMON /PTABLE/xkt(0:NtabM),Pkt(0:NtabM),StepK,alog0,iFlag,Ntab  

      If(x.ge.xkt(Ntab))Then  ! slope is ns =-3
         Ppk =Pkt(Ntab)/(x/xkt(Ntab))**3
         Return
      EndIf
      If(x.lt.xkt(1))Then                ! slope is ns=1
         Ppk =Pkt(1)*(x/xkt(1))
         Return
      EndIf
      ind = INT((log10(x)-alog0)/StepK) +1
      dk  = xkt(ind+1)-xkt(ind)
        Ppk   = (Pkt(ind)*(xkt(ind+1)-x)+Pkt(ind+1)*(x-xkt(ind)))/dk
c        write (*,'(5x," k=",g12.4," table=",2g12.4,"  P=",3g12.4)') 
c     &    x,xkt(ind),xkt(ind+1),
c     &    Ppk,Pkt(ind),Pkt(ind+1)
      Return
      End
C---------------------------------------
      SUBROUTINE  ReadTable
c                     interpolate table with p(k)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (NtabM = 100000)
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Ocurv,Par(6),AEXPN,Sn,ns,hsmall
      COMMON /PTABLE/xkt(0:NtabM),Pkt(0:NtabM),StepK,alog0,iFlag,Ntab  
      REAL*8              ns
      If(iFlag.eq.-1)Then  ! W.Hu table      
        Open(50,file='WHUpk.dat')
        twop = 2.*3.14145926**2

        Ntab =0
 10     read(50,*,end=30,err=30)xx,pp
        Ntab =Ntab +1
        xkt(Ntab) =xx   *hsmall             ! scale to real Mpc
        Pkt(Ntab) = pp    /xx**3*twop
        goto 10
 30     write (*,*)  ' Read ',Ntab,' lines from file WHUpk.dat'
        Goto 50
      EndIf 
      If(iFlag.eq.-2)Then  ! Eis.Hu table      
           Open(50,file='pk_EHu_Om0.3_Omb0.043_s8=0.9.dat')
           write (*,*)'  Read data from file',
     &                ' pk_EHu_Om0.3_Omb0.043_s8=0.9.dat'
      Else
           Open(50,file='pk_EHu_WMAP06.dat')
           write (*,*)'  Read data from file',
     &                ' pk_EHu_WMAP06.dat'

      EndIf 
           Do i=1,9              ! read header
              read(50,'(a)',end=100,err=100) Line
           EndDo 
           Ntab =0
 12        read(50,*,end=32,err=32)xx,pp
           Ntab =Ntab +1
           xkt(Ntab) =xx   *hsmall             ! scale to real Mpc
           Pkt(Ntab) = pp                      !  Pk
           goto 12
 32        write (*,*)  
           write (*,*)  ' Read ',Ntab,' lines from file ...'
           write (*,*)  ' hsmall =',hsmall


 50     If(Ntab.le.1)stop 'wrong table for p(k)'
        StepK =log10(xkt(2)/xkt(1))
        alog0   = log10(xkt(1))
        
        Do k =2,Ntab-1      ! test that spacing is the same
           ss =log10(xkt(k+1)/xkt(k))
c           write (80,'(5g12.4)') xkt(k),xkt(k+1)-xkt(k),ss,
c     &            abs(ss/StepK-1.) 
           If(abs(ss/StepK-1.).gt.2.e-2)Then
              write (*,*)  ' error in K spacing. k=',k,xkt(k+1),xkt(k)
              STOP
           EndIf
        EndDo 
        close(50)
      Return
 100    write (*,*)  ' Error reading table of P(k)'
        stop
      End

c-------------------------------------------------------------------- 
c                    Test runlux routines
c-------------------------------------------------------------------- 
      PARAMETER (Ntot =20 ) ! total number of rand numbs
      DIMENSION RanNum(5)   ,RR(Ntot)
      real*8 sig, xmean
      iseed = 9121071
      CALL rluxgo(2,iseed,0,0)
      icurr = 0
 10   call ranlux(RanNum,5)
c      icurr=icurr +1
         do i=1,5
            icurr=icurr +1
            RR(icurr) = RanNum(i)
         EndDo 
         If(icurr.le.Ntot-5)goto 10

         write (*,*)  ' done'
c         open(1,file='set2.dat')
c         write (1,*) RR
         sig =0.
         xmean =0.
         i1 = 0
         im1 = 0
         i15 = 0
         im15 = 0
         i2 = 0
         im2 = 0
         i25 = 0
         im25 = 0
         i3 = 0
         im3 = 0
         i4 = 0
         im4 = 0
         Ntry =1e8
         s1  = 0.15866
         s15 = 6.681e-2
         s2   = 2.275e-2
         s25 = 6.21e-3
         s3  = 1.35e-3
         s4  = 3.17e-5
         Do i=1,Ntry
c           xx =  GAUSS(iseed)
            xx =  GAUSS3()
            sig = sig +xx**2
            xmean = xmean + xx
            if(xx.gt.1.d+0)i1 =i1+1
            if(xx.lt.-1.d+0)im1 =im1+1
            if(xx.gt.1.5d+0)i15 =i15+1
            if(xx.lt.-1.5d+0)im15 =im15+1
            if(xx.gt.2.d+0)i2 =i2+1
            if(xx.lt.-2.d+0)im2 =im2+1
            if(xx.lt.-2.5d+0)im25 =im25+1
            if(xx.gt.2.5d+0)i25 =i25+1
            if(xx.gt.3.d+0)i3 =i3+1
            if(xx.lt.-3.d+0)im3 =im3+1
            if(xx.gt.4.d+0)i4 =i4+1
            if(xx.lt.-4.d+0)im4 =im4+1
         EndDo
         write (*,*)  ' N=    ',Ntry,' GAUSS3+ranlux ------'
         at =float (Ntry)
         write (*,'("  sigma=",g12.5," mean=",g12.5)') sig/at,xmean/at
         write (*,*)  ' sigma Frac(>sig) Frac(<-sig)   True',
     &                      '       n(>)    n(<)'
         write (*,'(f6.2,3g11.4,2i9)') 1.0,i1/at, im1/at,s1,i1,im1
         write (*,'(f6.2,3g11.4,2i9)') 1.5,i15/at, im15/at,s15,i15,im15
         write (*,'(f6.2,3g11.4,2i9)') 2.0,i2/at, im2/at,s2,i2,im2
         write (*,'(f6.2,3g11.4,2i9)') 2.5,i25/at, im25/at,s25,i25,im25
         write (*,'(f6.2,3g11.4,2i9)') 3.0,i3/at, im3/at,s3,i3,im3
         write (*,'(f6.2,3g11.4,2i9)') 4.0,i4/at, im4/at,s4,i4,im4

         Stop
         End
c-------------------------------------------------------------------- 
            
!   LUXURY LEVELS.
!  level 0  (p=24): equivalent to the original RCARRY of Marsaglia
!           and Zaman, very long period, but fails many tests.
!  level 1  (p=48): considerable improvement in quality over level 0,
!           now passes the gap test, but still fails spectral test.
!  level 2  (p=97): passes all known tests, but theoretically still
!           defective.
!  level 3  (p=223): DEFAULT VALUE.  Any theoretically possible
!           correlations have very small chance of being observed.
!  level 4  (p=389): highest possible luxury, all 24 bits chaotic.
c---------------------------------------------
      SUBROUTINE ranlux(rvec, lenv)
c                    returns a vector RVEC of LEN   
c                   32-bit random floating point numbers between 
c                   zero (not included) and one (also not incl.).
c           Next call to ranlux gives next LEN of random numbers
c---------------------------------------------
      INTEGER  lenv
      REAL        rvec(lenv)
      INTEGER  iseeds(24)
      INCLUDE 'luxury.h'
      DATA ndskip/ 0, 24, 73, 199, 365 /
      DATA i24,j24,luxlev/24,10,lxdflt/
      DATA notyet/.true./
      DATA in24,kount,mkount,carry/0,0,0,0./


!  NOTYET is .TRUE. if no initialization has been performed yet.
!              Default Initialization by Multiplicative Congruential

      IF (notyet) THEN
        notyet = .false.
        jseed = jsdflt
        inseed = jseed
        WRITE (6,'(A,I12)') ' RANLUX DEFAULT INITIALIZATION: ', jseed
        luxlev = lxdflt
        nskip = ndskip(luxlev)
        lp = nskip + 24
        in24 = 0
        kount = 0
        mkount = 0
      WRITE (6,'(A,I2,A,I4)') ' RANLUX DEFAULT LUXURY LEVEL= ', luxlev,   
     &                            '    p =', lp
      twom24 = 1.
        DO i = 1, 24
          twom24 = twom24 * 0.5
          k = jseed / 53668
          jseed = 40014 * (jseed-k*53668) - k * 12211
          IF (jseed.LT.0) jseed = jseed + icons
          iseeds(i) = MOD(jseed,itwo24)
        END DO
        twom12 = twom24 * 4096.
        DO i = 1, 24
          seeds(i) = REAL(iseeds(i)) * twom24
          next(i) = i - 1
        END DO
        next(1) = 24
        i24 = 24
        j24 = 10
        carry = 0.
        IF (seeds(24).EQ.0.) carry = twom24
      END IF

!          The Generator proper: "Subtract-with-borrow",
!          as proposed by Marsaglia and Zaman,
!          Florida State University, March, 1989

      DO ivec = 1, lenv
        uni = seeds(j24) - seeds(i24) - carry
        IF (uni.LT.0.) THEN
          uni = uni + 1.0
          carry = twom24
        ELSE
          carry = 0.
        END IF
        seeds(i24) = uni
        i24 = next(i24)
        j24 = next(j24)
        rvec(ivec) = uni
      !  small numbers (with less than 12 "significant" bits) are "padded".
        IF (uni.LT.twom12) THEN
          rvec(ivec) = rvec(ivec) + twom24 * seeds(j24)
      !        and zero is forbidden in case someone takes a logarithm
          IF (rvec(ivec).EQ.0.) rvec(ivec) = twom24 * twom24
        END IF
      !        Skipping to luxury.  As proposed by Martin Luscher.
        in24 = in24 + 1
        IF (in24.EQ.24) THEN
          in24 = 0
          kount = kount + nskip
          DO isk = 1, nskip
            uni = seeds(j24) - seeds(i24) - carry
            IF (uni.LT.0.) THEN
              uni = uni + 1.0
              carry = twom24
            ELSE
              carry = 0.
            END IF
            seeds(i24) = uni
            i24 = next(i24)
            j24 = next(j24)
          END DO
        END IF
      END DO
      kount = kount + lenv
      IF (kount.GE.igiga) THEN
        mkount = mkount + 1
        kount = kount - igiga
      END IF
      RETURN

      END ! SUBROUTINE ranlux

c---------------------------------------------
c                    Subroutine to initialize from one or three integers
      SUBROUTINE rluxgo(lux, ins, k1, k2)
c                initializes the generator from  
c               one 32-bit integer INT and sets Luxury Level LUX
c               which is integer between zero and MAXLEV, or if
c               LUX .GT. 24, it sets p=LUX directly.  K1 and K2
c               should be set to zero unless restarting at a break
c               point given by output of RLUXAT
c---------------------------------------------
      INCLUDE 'luxury.h'
      INTEGER  iseeds(24)
      
      IF (lux.LT.0) THEN
        luxlev = lxdflt
      ELSE IF (lux.LE.maxlev) THEN
        luxlev = lux
      ELSE IF (lux.LT.24.OR.lux.GT.2000) THEN
        luxlev = maxlev
        WRITE (6,'(A,I7)') ' RANLUX ILLEGAL LUXURY RLUXGO: ', lux
      ELSE
        luxlev = lux
        DO ilx = 0, maxlev
          IF (lux.EQ.ndskip(ilx)+24) luxlev = ilx
        END DO
      END IF
      IF (luxlev.LE.maxlev) THEN
        nskip = ndskip(luxlev)
        WRITE (6,'(A,I2,A,I4)') ' RANLUX LUXURY LEVEL SET BY RLUXGO :',
     &              luxlev,'     P=', nskip + 24
      ELSE
        nskip = luxlev - 24
        WRITE (6,'(A,I5)') ' RANLUX P-VALUE SET BY RLUXGO TO:', luxlev
      END IF
      in24 = 0
      IF (ins.LT.0) WRITE (6,'(A)')
     &        ' Illegal initialization by RLUXGO, negative input seed'
      IF (ins.GT.0) THEN
        jseed = ins
        WRITE (6,'(A,3I12)')' RANLUX INITIALIZED BY RLUXGO FROM SEEDS',
     &                                    jseed, k1, k2
      ELSE
        jseed = jsdflt
       WRITE (6,'(A)')' RANLUX INITIALIZED BY RLUXGO FROM DEFAULT SEED'
      END IF
      inseed = jseed
      notyet = .false.
      twom24 = 1.
      DO i = 1, 24
        twom24 = twom24 * 0.5
        k = jseed / 53668
        jseed = 40014 * (jseed-k*53668) - k * 12211
        IF (jseed.LT.0) jseed = jseed + icons
        iseeds(i) = MOD(jseed,itwo24)
      END DO
      twom12 = twom24 * 4096.
      DO i = 1, 24
        seeds(i) = REAL(iseeds(i)) * twom24
        next(i) = i - 1
      END DO
      next(1) = 24
      i24 = 24
      j24 = 10
      carry = 0.
      IF (seeds(24).EQ.0.) carry = twom24
      !        If restarting at a break point, skip K1 + IGIGA*K2
      !        Note that this is the number of numbers delivered to
      !        the user PLUS the number skipped (if luxury .GT. 0).
      kount = k1
      mkount = k2
      IF (k1+k2.NE.0) THEN
        DO iouter = 1, k2 + 1
          inner = igiga
          IF (iouter.EQ.k2+1) inner = k1
          DO isk = 1, inner
            uni = seeds(j24) - seeds(i24) - carry
            IF (uni.LT.0.) THEN
              uni = uni + 1.0
              carry = twom24
            ELSE
              carry = 0.
            END IF
            seeds(i24) = uni
            i24 = next(i24)
            j24 = next(j24)
          END DO
        END DO
      !         Get the right value of IN24 by direct calculation
        in24 = MOD(kount,nskip+24)
        IF (mkount.GT.0) THEN
          izip = MOD(igiga, nskip+24)
          izip2 = mkount * izip + in24
          in24 = MOD(izip2, nskip+24)
        END IF
      !       Now IN24 had better be between zero and 23 inclusive
        IF (in24.GT.23) THEN
          WRITE (6,'(A/A,3I11,A,I5)') 
     &       '  Error in RESTARTING with RLUXGO:', '  The values', ins, 
     &                k1, k2, ' cannot occur at luxury level', luxlev
          in24 = 0
        END IF
      END IF
      RETURN
      
      END ! SUBROUTINE rluxgo

C--------------------------------------
C		normal random numbers
      FUNCTION GAUSS1()
C                          Uses ranlux for homogenous rand numbers
C                          sum of 5 random numbers + corrections
C                          It is quite slow: needs 5 calls to ranlux  
C         N =1e8
C  sigma Frac(>sig) Frac(<-sig)   True       n(>)    n(<)
c  1.00 0.1580     0.1580     0.1587          15796874 15798080
c 1.50 0.6674E-01 0.6676E-01 0.6681E-01  6673965  6675533
c  2.00 0.2279E-01 0.2281E-01 0.2275E-01  2278910  2281013
c  2.50 0.6106E-02 0.6108E-02 0.6210E-02   610575   610813
c  3.00 0.1153E-02 0.1151E-02 0.1350E-02   115341   115052
c  4.00 0.2230E-05 0.2070E-05 0.3170E-04      223      207
C--------------------------------------
      DIMENSION RanNum(5) 
      X=0.
      CALL ranlux(RanNum,5)
      DO  I=1,5
         X=X+RanNum(I)
      EndDo
      X2   =1.5491933*(X-2.5)
      GAUSS1=X2  *(1.-0.012*(3.-X2*X2))
      RETURN
      END
C--------------------------------------
C		normal random numbers
      FUNCTION GAUSS2(M)
C                        Uses ranndd for homogenous rand numbers
C                          sum of 12 random numbers + corrections
C                          It is  slow: very (10 times than GAUSS3)
C                          Quality is very good: upto 4 sigma
c  sigma Frac(>sig) Frac(<-sig)   True       n(>)    n(<)
c  1.00 0.1586     0.1586     0.1587     15857116 15857711
c  1.50 0.6678E-01 0.6680E-01 0.6681E-01  6678110  6679725
c  2.00 0.2277E-01 0.2275E-01 0.2275E-01  2277430  2274868
c  2.50 0.6197E-02 0.6189E-02 0.6210E-02   619732   618895
c  3.00 0.1327E-02 0.1319E-02 0.1350E-02   132713   131929
c  4.00 0.2664E-04 0.2727E-04 0.3170E-04     2664     2727
C                   
c-------------------------------------------------------------------- 
      X=0.
      DO  I=1,12
         X=X+Randd(M)
      EndDo
      X2 = X-6.0
      GAUSS2   =X2 *(1.-0.0045*(3.-X2*X2))
      RETURN
      END
C--------------------------------------
C		normal random numbers
      FUNCTION GAUSS3()
C                        Uses ranlux for homogenous rand numbers   
C                        Uses Box-Muller inversion for gaussian
C                 Excellent quality and speed
c  N=       100000000  GAUSS3+ranlux ------
c  sigma= 0.99997     mean= 0.18692E-03
c  sigma Frac(>sig) Frac(<-sig)   True       n(>)    n(<)
c  1.00 0.1587     0.1586     0.1587     15869095 15857724
c  1.50 0.6682E-01 0.6680E-01 0.6681E-01  6681652  6679768
c  2.00 0.2277E-01 0.2273E-01 0.2275E-01  2276651  2273197
c  2.50 0.6222E-02 0.6206E-02 0.6210E-02   622190   620610
c  3.00 0.1356E-02 0.1347E-02 0.1350E-02   135628   134674
c  4.00 0.3242E-04 0.3145E-04 0.3170E-04     3242     3145
c
C--------------------------------------
      DIMENSION RanNum(2) 
      DATA iFlag/0/
      SAVE gSet
      If(iFlag.eq.0)Then
 1       CALL ranlux(RanNum,2)
         x1 = 2.*RanNum(1)-1.
         x2 = 2.*RanNum(2)-1.
         R =x1**2+x2**2
         If(R.ge.1.)GoTo 1
         F =sqrt(-2.*LOG(R)/R)
         gSet    = x1*F
         GAUSS3 = x2*F
         iFlag = 1
      Else
         GAUSS3 = gSet
         iFlag = 0
      EndIf 
      RETURN
      END

C-------------------------------------------               random number generator
      FUNCTION RANDd(M)
C------------------------------------------------
      DATA LC,AM,KI,K1,K2,K3,K4,L1,L2,L3,L4
     +	/453815927,2147483648.,2147483647,536870912,131072,256,
     +	 16777216,4,16384,8388608,128/
      ML=M/K1*K1
      M1=(M-ML)*L1
      ML=M/K2*K2
      M2=(M-ML)*L2
      ML=M/K3*K3
      M3=(M-ML)*L3
      ML=M/K4*K4
      M4=(M-ML)*L4
      M5=KI-M
      IF(M1.GE.M5)M1=M1-KI-1
      ML=M+M1
      M5=KI-ML
      IF(M2.GE.M5)M2=M2-KI-1
      ML=ML+M2
      M5=KI-ML
      IF(M3.GE.M5)M3=M3-KI-1
      ML=ML+M3
      M5=KI-ML
      IF(M4.GE.M5)M4=M4-KI-1
      ML=ML+M4
      M5=KI-ML
      IF(LC.GE.M5)ML=ML-KI-1
      M=ML+LC
      RANDd=M/AM
      RETURN
      END
C--------------------------------------
C		normal random numbers
      FUNCTION GAUSS(M)
C                    Uses RANDd() + 5 random numbers with correction
C                    Old code used in many simulations
C   N=1e8  sigma= 0.99556     mean= 0.10542E-03
c  sigma Frac(>sig) Frac(<-sig)   True       n(>)    n(<)
c  1.00 0.1589     0.1589     0.1587     15894145 15889594
c  1.50 0.6704E-01 0.6702E-01 0.6681E-01  6703736  6702430
c  2.00 0.2258E-01 0.2256E-01 0.2275E-01  2258038  2256030
c  2.50 0.5841E-02 0.5843E-02 0.6210E-02   584148   584264
c  3.00 0.1031E-02 0.1028E-02 0.1350E-02   103141   102783
c  4.00 0.5900E-06 0.6100E-06 0.3170E-04       59       61
C
C--------------------------------------
      X=0.
      DO  I=1,5
         X=X+RANDd(M)
      EndDo
      X2   =1.5491933*(X-2.5)
      GAUSS=X2*(1.-0.01*(3.-X2*X2))
      RETURN
      END

! _______________________ START 3-D SIMULATIONS                         
!                                                                       
!                         Klypin, August 1993                           
!                                                                       
!-------------------------------------------------------------
MODULE Random
Contains
!--------------------------------------                                 
!				normal random numbers                                              
      FUNCTION GAUSS (M) 
!--------------------------------------                                 
      X = 0. 
      DO I = 1, 5 
      X = X + RANDd (M) 
      EndDo 
      X2 = 1.5491933 * (X - 2.5) 
      GAUSS = X2 * (1. - 0.01 * (3. - X2 * X2) ) 
      RETURN 
      END FUNCTION GAUSS                            

!------------------------------------------------                       
!				                                       random number generator     
      FUNCTION RANDd (M) 
!------------------------------------------------                       
      DATA LC, AM, KI, K1, K2, K3, K4, L1, L2, L3, L4	 / 453815927,     &
      2147483648., 2147483647, 536870912, 131072, 256, 	16777216, 4,    &
      16384, 8388608, 128 /
      ML = M / K1 * K1 
      M1 = (M - ML) * L1 
      ML = M / K2 * K2 
      M2 = (M - ML) * L2 
      ML = M / K3 * K3 
      M3 = (M - ML) * L3 
      ML = M / K4 * K4 
      M4 = (M - ML) * L4 
      M5 = KI - M 
      IF (M1.GE.M5) M1 = M1 - KI - 1 
      ML = M + M1 
      M5 = KI - ML 
      IF (M2.GE.M5) M2 = M2 - KI - 1 
      ML = ML + M2 
      M5 = KI - ML 
      IF (M3.GE.M5) M3 = M3 - KI - 1 
      ML = ML + M3 
      M5 = KI - ML 
      IF (M4.GE.M5) M4 = M4 - KI - 1 
      ML = ML + M4 
      M5 = KI - ML 
      IF (LC.GE.M5) ML = ML - KI - 1 
      M = ML + LC 
      RANDd = M / AM 
      RETURN 
      END FUNCTION RANDd                            
end module Random
!
!
!------------------------------------------------------------------
MODULE   setInitialConditions
PUBLIC
Character (LEN=12), DIMENSION(2) :: NamesDir=(/ &
       'PMstartX.DAT',&                                                                 
       'PMstartY.DAT'/)                                                                 

INCLUDE 'PMinitialp.h'
      INTEGER, PARAMETER :: NPAGE = NROW**2,  & ! # particles in a record
                            NMAX  = NGRID/2,     & 
                            NRECL = NPAGE*6,   & ! # particles in a record
                            NARR  = MAX(2*NROW+1,NGRID+1), & ! FFT
                            NF67  = MAX(NROW,NGRID/2), &  
                            Nblocks=NROW/Lblock,       &
                            NSPEC = NROW/2,            &  ! No waves shorter than Ny
                            marr  = NROW+1,            &  ! Arrays for FFT
                            mf67  = NROW/2

      REAL, DIMENSION(10) ::   timing =0.
      COMMON / CONTROL/ AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW, & 
                       TINTG,EKIN,EKIN1,EKIN2,AU0,AEU0, &
                       NROWC,NGRIDC,Nspecies,Nseed,Om0,Oml0,hubble,Wp5 &
                       ,Ocurv,extras(100)
      COMMON / HEADDR/  HEADER
      CHARACTER*45      HEADER
      COMMON /FOURAR/Zf(NARR),Yf(NARR)
      COMMON /F67COM/ &
                      IBC,      IP,       ISL,     L1,     N2, &
                      N3,       N4,        N7, &
                      SI(NF67),    INDEX(NF67)

      COMMON / ROW /	XPAR(NPAGE),YPAR(NPAGE),ZPAR(NPAGE),&
     			VX(NPAGE),VY(NPAGE),VZ(NPAGE)
      DIMENSION     RECDAT(NRECL),wspecies(10),lspecies(10)
      EQUIVALENCE    (RECDAT(1),XPAR(1)) &
                                    ,(wspecies(1),extras(1)), &
                                    (lspecies(1),extras(11))
      COMMON / MASK/	iMask(Nblocks,Nblocks,Nblocks) ! Refinement Mask
      REAL, ALLOCATABLE  :: GR(:,:,:)
      COMMON / BUFFx /	XPt(Nmaxpart)
      COMMON / BUFFv/   VXt(Nmaxpart)
      COMMON /SeedsPage/ NseedP(NROW)
      COMMON / LevelsM/ Max_lev_abs,Nmin_lev,Nmax_lev

Contains

!--------------------------------------------------                     
!                    : Store and retrieve seeds for parallelization 
!                      of random number generator
!--------------------------------------------------                     
      SUBROUTINE SetRandom(iCont)
use     Random

INCLUDE 'luxuryp.h' 
Character (LEN=70) :: FileName
Logical            :: FileExists =.false., RNGluxury =.false. 
Logical            :: iCont
REAL               ::    t0=0,t1=0.        ! counters for timing

      CALL CPU_TIME(t0)                    ! initialize time counter
      write(FileName,'(a,i1.1,".",i4.4,".",i8.8,".dat")')        &
                     'Seeds.',INT(extras(80)),NROW,Nseed
INQUIRE(file=FileName,EXIST=FileExists)

If(abs(extras(80)-1.) < 1.e-5)RNGluxury =.true.

If(FileExists==.true.)Then            ! read the data
      write(*,'(10x,2a)')'Open Existing FileName=',FileName
      Open(62,file=FileName,form='unformatted')
   read(62)NROWdummy,Nseeddummy
   if(NROWdummy /= NROW .or. Nseeddummy /= Nseed)Then
      write(*,*) ' File with seeds does not match parameters'
      write(*,*) ' Read Nrow =',NROWdummy,' Internal=',NROW
      write(*,*) ' Read Nseed=',Nseeddummy,' Internal=',Nseed
      STOP
   endIf
   If(RNGluxury)Then ! 
      read(62)i24A,j24A,in24A,kountA,carryA,gsetA,iFlagA
      read(62)SeedsPage
      Close(62)
   Else
      read(62)i24A
   EndIf
   Close(62)
Else
                       ! open file with seeds 
      write(*,'(10x,2a)')'Create FileName=',FileName
      Open(62,file=FileName,form='unformatted')
                                  ! generate seeds 
   If(RNGluxury)Then !  Detect random generator: luxury or nrandd 
      iFlag = 0
      gSet  = 0.
      Do k=1,NROW                               ! luxury
          i24A(k)    = i24
          j24A(k)    = j24
          in24A(k)  = in24
          kountA(k) = kount
          carryA(k) = carry
          gsetA(k)  = gSet
          iFlagA(k) = iFlag
             Do m=1,24
                 SeedsPage(m,k) = seeds(m)
             EndDo    
             Do j=1,NROW
                Do i=1,NROW
                  If(i+j+k.ne.3)Then
                    x = GAUSS3(gSet,iFlag)
                  EndIf
                EndDo
             EndDo
      EndDo
      write(62)NROW,Nseed
      write(62)i24A,j24A,in24A,kountA,carryA,gsetA,iFlagA
      write(62)SeedsPage
      Close(62)
   Else 
   write(*,*) ' Nseed=',Nseed
       NRAND = Nseed                  
      Do k=1,NROW                               ! gauss and randd
             i24A(k)  = NRAND
             Do j=1,NROW
                Do i=1,NROW
                   If(i+j+k.ne.3)Then
                      x = GAUSS(NRAND)
                   EndIf
                EndDo
             EndDo
      EndDo
      write(62)NROW,Nseed
      write(62)i24A
      Close(62)

   EndIf                                       ! end luxury/randd switch
      write(*,'(/2(20("-"),a/))')'File with seeds was created. STOP',  &
         'Do not change anything. Just restart the code to produce Initial Conditions'
      iCont = .false.
EndIf                                          ! file exists switch
      CALL CPU_TIME(t1)
      timing(2) = t1-t0             ! time for setting random numbers 

        Return
        End SUBROUTINE SetRandom
!--------------------------------------------------                     
!                                                     sqrt(Power spectrum)
!                                                           k = (2pi/L) 
!--------------------------------------------------                     
      FUNCTION TRUNF (WK) 
!-------------------------------------------------
      PARAMETER (NtabM = 100000) 
      COMMON / PTABLE / xkt (0:NtabM), Pkt (0:NtabM), Ntab, StepK,      &
                                           alog0, iFlag                       
      COMMON / TRUNCOM / Om, Omb, Omc, Omnu, Par (6), ns, qqscaleb,     &
                                           QSCALE
      Real ns, k 
                                                                        
      IF (WK.GE.FLOAT (NSPEC) ) THEN 
         TRUNF = 0. 
         RETURN 
      ENDIF 
      k = QSCALE * wk 
                                                                        
                               ! use approximations                     
      If (iFlag.gt.0) Then 
                             ! Holtzman approx                          
      If (Par (6) .ne.0.) Then 
      sk = sqrt (k) 
      TRUNF = k** (ns / 2.) / (1. + sk * (Par (2) + sk * (Par (3)       &
      + sk * (Par (4) + sk * (Par (5) ) ) ) ) ) ** (Par (6) )           
                             ! BBKS + Sugiyama approx                   
      Else 
!        Gammaeff =Om*hsmall/exp(Omb*(1.+sqrt(hsmall/0.5)/Om))          
!        Q = wk/hsmall/Gammaeff                                         
      Q = k * qqscaleb 
      TRUNF = k** (ns / 2.) * LOG (1. + Par (1) * Q) / (Par (1) * Q)    &
      / sqrt (sqrt (1. + Q * (Par (2) + Q * (Par (3) **2 + Q * (Par (4) &
      **3 + Q * (Par (5) **4) ) ) ) ) )                                 
      EndIf 
                         ! use table for P(k)                           
      Else 
         TRUNF = sqrt (Ppk (k) ) 
      EndIf 
      RETURN 
      END FUNCTION TRUNF                            
!---------------------------------------                                
      FUNCTION Ppk (x) 
!                     interpolate table with p(k)                       
!                       x is in real 1/Mpc                              
!---------------------------------------                                
      PARAMETER (NtabM = 100000) 
      COMMON / PTABLE / xkt (0:NtabM), Pkt (0:NtabM), Ntab, StepK,      &
      alog0, iFlag                                                      
                                                                        
                              ! slope is ns =-3                         
      If (x.ge.xkt (Ntab) ) Then 
         Ppk = Pkt (Ntab) / (x / xkt (Ntab) ) **3 
         Return 
      EndIf 
                                         
      If (x.lt.xkt (1) ) Then    ! slope is ns=1                
         Ppk = Pkt (1) * (x / xkt (1) ) 
         Return 
      EndIf 
      ind = INT ( (log10 (x) - alog0) / StepK) + 1 
      dk = xkt (ind+1) - xkt (ind) 
      Ppk = (Pkt (ind) * (xkt (ind+1) - x) + Pkt (ind+1) * (x - xkt (   &
      ind) ) ) / dk                                                     
!        write (*,'(5x," k=",g12.4," table=",2g12.4,"  P=",3g12.4)')    
!     &    x,xkt(ind),xkt(ind+1),                                       
!     &    Ppk,Pkt(ind),Pkt(ind+1)                                      
      Return 
      END FUNCTION Ppk                              
!---------------------------------------                                
      SUBROUTINE ReadTable (hsmall) 
!                     interpolate table with p(k)                       
!---------------------------------------                                
      PARAMETER (NtabM = 100000) 
      COMMON / PTABLE / xkt (0:NtabM), Pkt (0:NtabM), Ntab, StepK,      &
      alog0, iFlag                                                      
      CHARACTER(80) Line 
                                                                        
                           ! W.Hu table                                 
      If (iFlag.eq. - 1) Then 
         Open (50, file = 'WHUpk.dat') 
         twop = 2. * 3.14145926**2 
         Ntab = 0 
   10    READ (50, *, end = 30, err = 30) xx, pp 
            Ntab = Ntab + 1 
            xkt (Ntab) = xx * hsmall     ! scale to real Mpc      
            Pkt (Ntab) = pp / xx**3 * twop ! k^3Pk -> Pk                
         GOTO 10 
   30    Write (*,*) 
         Write (*,*) ' Read ', Ntab, ' lines from file WHUpk.dat' 
         Write (*,*) ' hsmall =', hsmall 
         Goto 50
      EndIf 
                           ! Eis.Hu table                               
      If (iFlag.eq. - 2) Then 
         Open (50, file = 'pk_EHu_Om0.3_Omb0.043_s8=0.9.dat') 
      Else 
         Open (50, file = 'pk_EHu_WMAP06.dat') 
      EndIf 
                                 ! read header                          
      Do i = 1, 9 
         READ (50, '(a)', end = 100, err = 100) Line 
      EndDo 
      Ntab = 0 
   12 READ (50, *, end = 32, err = 32) xx, pp 
      Ntab = Ntab + 1 
      xkt (Ntab) = xx * hsmall   ! scale to real Mpc      
      Pkt (Ntab) = pp                !  Pk 
      GOTO 12 
   32 Write (*,*) 
      Write (*,*) ' Read ', Ntab, ' lines from file pk_EHu_Om0.3...'
      Write (*,*) ' hsmall =', hsmall 
                                                                        
                                                                        
   50 If (Ntab.le.1) stop'wrong table for p(k)' 
      StepK = log10 (xkt (2) / xkt (1) ) 
      alog0 = log10 (xkt (1) ) 
                                                                        
                            ! test that spacing is the same             
      Do k = 2, Ntab - 1 
        ss = log10 (xkt (k + 1) / xkt (k) ) 
        If (abs (ss / StepK - 1.) .gt.2.e-2) Then 
        Write (*,*) ' error in K spacing. k=', k, xkt (k + 1),xkt (k)
        STOP 
      EndIf 
      EndDo 
      CLOSE (50) 
      Return 
  100 Write (*,*) ' Error reading table of P(k)' 
      STOP 
                                                                        
      END SUBROUTINE ReadTable                      
                                                                        
                                                                        
!*********************************************************************  
!	   Power spectrum for CDM. Wk-  wavenumber(Mpc^-1, h=0.5)             
!                         P = wk *T^2(k)                                
!                         QSCALE = 2pi/Box_size,  QS =hubble**(-2)      
!      FUNCTION TRUNF(WK)                                               
!      COMMON / TRUNCOM/ QSCALE,g,gy                                    
!      COMMON / TRUNCDM/ QS,A1,A2,A3,A4,A5,A32,A43,A54                  
!       Q = QSCALE*QS*WK                                                
!       TRUNF = sqrt( WK*                                               
!     +		 (LOG(1.+A1*Q)/(A1*Q))**2/                                     
!     +		 SQRT(1.+Q*(A2 +Q*(A32   +Q*(A43+Q*A54)))) )                   
!                                                                       
!      RETURN                                                           
!      END                                                              
                                                                        
!*********************************************************************  
!			  INITIALIZE CONSTANTS:                                             
!			      Scalel    =length of square in MPC                            
!			      AEXPN =expansion factor (current)                             
!			      ASTEP	  =increment of expansion factor: AEXPN =AEXP_0+N*ASTEP 
!                     PARTW	=weight of a particle: total 'mass' per cell
!                                          even for LCDM or OCDM        
!			      AMPLT	=amplitude of perturbations inside the simulation box   
!			      NBYTE	=record length in bytes                                 
!                                                                       
      SUBROUTINE InitValues (NBYTE, SCALEL) 
!--------------------------------------------
      PARAMETER (NtabM = 100000) 
      COMMON / PTABLE / xkt (0:NtabM), Pkt (0:NtabM), Ntab, StepK,      &
                                           alog0, iFlag                                                      
      COMMON / TRUNCOM / Om, Omb, Omc, Omnu, Par (6), ns, qqscaleb,     &
                                                QSCALE                                                            
      COMMON / FERMI / Vscale 
      Real           ns 
      Character Answer*1 
      Real          INPUT 
      DATA PI  / 3.1415926535 / 
                                                                        
      Do i = 1, 100 
         extras (i) = 0. 
      enddo 
      Write (*,  * ) 'Would you like to use a model provided in cdm.fi&
     &t '                                                               
      Write (*,*) 'or your own model?' 
      Write (*, '(A,$)') ' Enter Yes for cdm.fit;  No for your model =&
     &'                                                                 
      Read (*, '(A)') Answer 
      HEADER = 'N=128x256 L=20h-1CDMsig=0.239 z=30-----------' 
      Write (*,  * ) '------ Enter Header for the run up to 45 characters'
      Write (*,  * ) '       Example:' 
      Write (*, '(A)') HEADER 
      READ (*, '(A)') HEADER 
      Write (*, '(A)') HEADER 
      AEXPN = INPUT (' Initial expansion parameter (0-1)=') 
      ASTEP = INPUT (' Step of the expansion parameter  =') 
      AMPLT = INPUT (' Amplitude of density fluctuations=') 
      ns = INPUT (' Slope of the Power spectrum     n=') 
      SCALEL = INPUT (' Box size (Mpc/h)                 =') 
      Ocurv = INPUT (' Omega_curvature   at present     =') 
                                                                        
      Nseed = INPUT (' Random seed (Integer  1-2^31)    =') 
      If (Nseed.le.0) Then 
         lux             = 2                              ! level for luxury 
         extras (80) = 1. 
         extras (81) = lux 
         If (Nseed.eq.0) Nseed = 121071 
         Nseed        = ABS (Nseed) 
         CALL rluxgo (lux, Nseed, 0, 0)      ! initialize luxury 
      Else                                                    ! use randd and gauss
          extras (80) = 0. 
      EndIf 
!                       extras(80) is used as switch for                
!                                        random numbers generators      
!                         = 0 - old Randd+Gauss                         
!                         = 1 - luxury+Gauss3                           
!                        extras(81) = lux - level of luxury             
                                                                        
                                              ! store the box size      
      extras (100) = SCALEL 
      If (Answer.eq.'Y'.or.Answer.eq.'y') Then 
         CALL MODEL (hsmall) 
         hubble = hsmall 
         Om0 = Om 
         Oml0 = 1. - Om0 - Ocurv 
      Else 
         Write (*,*) ' You use your cosmological model.' 
         Write (*,*) ' Be sure you provide routine TRUNF' 
         hubble = INPUT (' The Hubble constant (h=H/100)    =') 
         Om0 = INPUT (' Omega_0 matter    at present     =') 
         Oml0 = INPUT (' Omega_lambda      at present     =') 
      EndIf 
                              ! scale it to real megaparsecs            
      SCALEL = SCALEL / hubble 
      NBYTE = NPAGE * 6 * 4 
                                                                        
      Write (*, '(A,$)') ' Enter Min and Max number of mass species =' 
      READ ( *, * ) Nmin_lev, Nmax_lev 
      W = (FLOAT (NGRID) / FLOAT (NROW) ) **3 
      PARTW = W 
                                       ! multiple mass resolution       
      If (Nmin_lev.lt.Nmax_lev) Then 
         Write ( *, * ) 
         Write (*,*) ' You use multiple mass resolution' 
      ENDIF 
                                    ! change the order of levels        
       If(Nmin_lev.gt.Nmax_lev)Then                                     
          i = Nmax_lev                                                  
          Nmax_lev = Nmin_lev                                           
          Nmin_lev = i                                                  
       endif                                                            
                                                                        
       ISTEP = 0                                                        
       TINTG = 0.                                                       
       AU0   = 0.                                                       
       AEU0  = 0.                                                       
       EKIN  = 0.                                                       
       EKIN1 = 0.                                                       
       EKIN2 = 0.                                                       
       NROWC = NROW                                                     
       NGRIDC= NGRID                                                    
           QSCALE = 2.*PI/SCALEL                                        
           QS     = hubble**(-2)                                        
        write (*,'(/3x,3(a,g12.3))') ' Qscale=',QSCALE,                &
                                     ' Box=',SCALEL,' slope=',ns                         
                                                                        
      RETURN                                                            
      END  SUBROUTINE InitValues                                         
!________________________________________Read parameters of the model   
!                                 Om       = Omega_0                    
!                                 Omb     = Omega_baryon                
!                                 Omnu  = Omega_neutrino                
!                                 hsmall  = hubble constant             
!                                 Par      = fitting parameters         
!                                 Par(6) = 0  --- bbks-style+Hu&Sugiyama
!                                 Par(6) ne 0 --- holtzman-style        
      SUBROUTINE MODEL (hsmall) 
!---------------------------------------                                
      COMMON / TRUNCOM / Om, Omb, Omc, Omnu, Par (6), ns, qqscaleb,     &
      QSCALE                                                            
      PARAMETER (NtabM = 100000) 
      COMMON / PTABLE / xkt (0:NtabM), Pkt (0:NtabM), Ntab, StepK,      &
      alog0, iFlag                                                      
      Real ns, INPUT 
      Character Header1*79 
                                                                        
      Line1 = INPUT (' Enter Line Number in cdm.fit     =') 
      If (Line1.gt.0) Then                 ! use analytical approximation
         iFlag = Line1 
         OPEN (2, file = 'cdm.fit') 
         Read (2, '(A)') Header1 
         If (Line1.gt.2) Then 
            Do i = 1, Line1 - 2 
               Read (2, * ) a 
            EndDo 
         EndIf 
         Read (2, * ) Om, Omb, Omc, Omnu, hsmall, Par 
         CLOSE (2) 
                                                                           
                            ! = T_cmb/2.7                                  
         theta = 2.726 / 2.7 
                            ! Hu&Sugiyama fitting                          
         Ob0 = Omb / Om 
         Omh2 = Om * hsmall**2 
         a1 = (46.9 * Omh2) **0.670 * (1. + (32.1 * Omh2) ** ( - 0.532) ) 
         a2 = (12.0 * Omh2) **0.424 * (1. + (45. * Omh2) ** ( - 0.582) ) 
         alpha = 1. / a1**Ob0 / a2** (Ob0**3) 
         qqscaleb = theta**2 / (1. - Ob0) **0.60 / sqrt (alpha) / Omh2 
                                                                           
         Write ( *, 20) Om, Omb, Omc, Omnu, hsmall, Par 
!         Write (16,20)Om,Omb,Omc,Omnu,hsmall,Par                          
   20    Format (' Model: Om_0=', F5.3, ' Om_baryon=', F5.3, ' Om_cold=',  &
                F5.3, ' O_nu=', F5.3, ' hsmall=', F4.2, / 8x, 'Parameters=',    &
               (6G9.3) )                                                         
                                  
      Else                      ! read spectrum from table               
         iFlag = Line1 
         If (iFlag.lt. - 3) Stop' Error: model Line # less than -3' 
                                 ! W.Hu table                              
         If (iFlag.eq. - 1) Then 
            hsmall = 0.7 
            Omb = 0.024 / hsmall**2 
            Om = 0.3 
            Ocurv = 0. 
            Omc = Om 
         EndIf 
                                 ! Eis.Hu approximation                    
         If (iFlag.eq. - 2) Then 
            hsmall = 0.7 
            Omb = 0.04 
            Om = 0.3 
            Ocurv = 0. 
            Omc = Om 
         EndIf 
                                 ! Eis.Hu approximation: WMAP              
         If (iFlag.eq. - 3) Then 
            hsmall = 0.73 
            Omb = 0.04 
            Om = 0.24 
            Ocurv = 0. 
            Omc = Om 
         EndIf 
                                                                              
         CALL ReadTable (hsmall) 
                                                                           
         Write ( *, 22) Om, Omb, hsmall 
         Write (1, 22) Om, Omb, hsmall 
   22    Format (' Model: Om_0=', F5.3, ' Om_baryon=', F5.3, ' hsmall=',   &
         F4.2, ' <== Using table for P(k)')                                
      EndIf 
                                                                        
      Return 
      END SUBROUTINE MODEL                          
!------------------------------------------------                       
!                              Clear MASK for multiple mass resolution  
!                               Initiat to level Nmin_lev               
      SUBROUTINE ZeroMask 
!------------------------------------------------                       
!      INCLUDE 'PMinitialp.h'	 
                                                                        
      DO MK3 = 1, Nblocks 
      DO MK2 = 1, Nblocks 
      DO MK1 = 1, Nblocks 
         iMask (MK1, MK2, MK3) = Nmin_lev 
      ENDDO 
      ENDDO 
      ENDDO 
      RETURN 
      END SUBROUTINE ZeroMask                       
!------------------------------------------------                       
!                       Set MASK for multiple mass resolution           
!                               Read particles with lagrangian coordinat
!                                                to set the mask        
!                               Block   = 1 = low resolution            
!                                       = 2 = higher resolution         
!                                       = 3 = even higher resolution    
!               After the mask is set, make maximum resolution Nmax_lev 
!                                                                       
      SUBROUTINE SetMask 
!------------------------------------------------                       
      Dimension nLevel (10) 
      Character *70 Line 
                                                                        
      Do i = 1, 5 
         Read (30, '(A)') Line 
         Write (*, '(A)') Line 
      EnDDo 
      Nlines = 0 
   10 Read (30, *, end = 50, err = 50) i, xw, yw, zw, vwx, vwy, vwz, im,&
      jm, km                                                            
      Nlines = Nlines + 1 
!           write (*,*) ' Block=',im,jm,km                              
      If (im.lt.0.or.im.gt.Nblocks) Then 
         Write (*,*) ' wrong x_block: ', im, jm, km, ' Line=', Nlines 
         Stop 
      EndIf 
      If (jm.lt.0.or.jm.gt.Nblocks) Then 
         Write (*,*) ' wrong y_block: ', im, jm, km, ' Line=', Nlines 
         Stop 
      EndIf 
      If (km.lt.0.or.km.gt.Nblocks) Then 
         Write (*,*) ' wrong z_block: ', im, jm, km, ' Line=', Nlines 
         Stop 
      EndIf 
!             If(iMask(im,jm,km).ne.0)Then                              
!              write (*,*) ' Occupied block: ',im,jm,km,' Line=',Nlines 
!              write (*,*) '                 Block=',iMask(im,jm,km)    
!              Stop                                                     
!           EndIf                                                       
                                                                        
                                        ! mark high resolution block    
      iMask (im, jm, km) = Nmax_lev 
      Do ik = - 1, 1 
         k = km + ik 
         If (k.le.0) k = k + Nblocks 
         If (k.gt.Nblocks) k = k - Nblocks 
         Do ij = - 1, 1 
            j = jm + ij 
            If (j.le.0) j = j + Nblocks 
            If (j.gt.Nblocks) j = j - Nblocks 
            Do ii = - 1, 1 
               i = im + ii 
               If (i.le.0) i = i + Nblocks 
               If (i.gt.Nblocks) i = i - Nblocks 
                                                            
               ind = abs (ik) + abs (ij) + abs (ii) ! only seven blocks 
                                                                   ! are marked out                        
!                               If(iMask(i,j,k).le.0.or.iMask(i,j,k).gt.Nspecies)
!              +                     Then                                        
!                                  Stop                                          
!                               Endif                                            
               If (ind.le.1) Then 
                   iMask (i, j, k) = Nmax_lev ! change mask           
               Endif 
            ENDDO 
         ENDDO 
      ENDDO 
      GoTo 10 

   50 Write (*,*) ' Total Lines read=', Nlines 
!                      Change the mask: iteratevely add layers of lower resolution. 
!                       Find blocks adjasent to filled blocks and
!                       mark them with kSpec =Nspecies-1, -2,
!                      
                                     !                                  
   DO kSpec = Nmax_lev - 1, 2, - 1 
      DO MK3 = 1, Nblocks 
      DO MK2 = 1, Nblocks 
      DO MK1 = 1, Nblocks 
         iM = iMask (MK1, MK2, MK3) 
         If (iM.eq.kSpec + 1) Then           !  change to kSpec if not high res
            Do ik = - 1, 1 
               k = MK3 + ik 
               If (k.le.0) k = k + Nblocks 
               If (k.gt.Nblocks) k = k - Nblocks 
                  Do ij = - 1, 1 
                     j = MK2 + ij 
                     If (j.le.0) j = j + Nblocks 
                     If (j.gt.Nblocks) j = j - Nblocks 
                     Do ii = - 1, 1 
                        i = MK1 + ii 
                        If (i.le.0) i = i + Nblocks 
                        If (i.gt.Nblocks) i = i - Nblocks 
                                                                                   ! chang
                        If (iMask (i, j, k) .lt.kSpec) iMask (i, j, k) = kSpec 
                     ENDDO 
                  ENDDO 
            ENDDO 
         EndIf                   ! end iM=kSpec+1 test
      ENDDO                  ! end MK1
      ENDDO                  ! end MK2
      ENDDO                  ! end MK3
  Enddo                        ! end kSpec 
                                                                        
      Do i = 1, Max_lev_abs  ! count marked blocks              
         nLevel (i) = 0 
      Enddo 
      DO MK3 = 1, Nblocks 
      DO MK2 = 1, Nblocks 
      DO MK1 = 1, Nblocks 
         iM = iMask (MK1, MK2, MK3) 
         If (iM.le.Nmax_lev.and.iM.ge.Nmin_lev) Then 
            nLevel (iM) = nLevel (iM) + 1 
         Else 
            Write (*,*) 'wrong mask: ', iM, ' block=', MK1, MK2, MK3 
            Write (*,  * ) '      it should be within limits:', Nmin_lev, Nmax_lev
            Stop 
         EndIf 
      ENDDO 
      ENDDO 
      ENDDO 
                                                                        
      Ntot = 0 
      Do i = Max_lev_abs, 1, - 1 
         icurrent = nLevel (i) * 8** (i - 1) 
         Write (*,*) ' Level=', i, ' Number of Blocks=', nLevel (i) ,  &
         ' N_Particles=', icurrent                                         
         Ntot = Ntot + icurrent 
      Enddo 
      Write (*,*) ' Total expected particles =', Ntot 
      RETURN 
      END SUBROUTINE SetMask                        
!------------------------------------------------                       
!                             Make a realization of spectrum of perturbations
!                             ALPHA  = normalization factor for displacement
!                             NRAND = seed for random numbers           
      SUBROUTINE SPECTR (ALPHA, NRAND, iDirection) 
!------------------------------------------------                       
use Random

INCLUDE 'luxuryp.h' 
      REAL(8)   :: SUMM=0., Wi3, Wj3, Wk3, WD, TS, TRX 
      REAL      ::    t0=0,t1=0.        ! counters for timing
      INTEGER, DIMENSION(NROW) :: mapz, map3

      CALL CPU_TIME(t0)                    ! initialize time counter
      iRandom = INT (extras (80) + 1.e-5) ! set type of Random Numbers       
                                          ! 0 - old GAUSS 1-GAUSS3(ranlux)
      Do j=1,NROW
         jsign = - 1 
         jz = j + NSPEC 
         j3 = j - 1 
         If (j3.GT.NSPEC) j3 = j3 - NSPEC 
         IF (jz.gt.NROW) THEN 
            jz = jz - NROW 
            jsign = 1 
         ENDIF 
         mapz(j) = jz
         map3(j) = j3*jsign  
      EndDo
!.... Open_MP                                                           
!$OMP PARALLEL DO DEFAULT(SHARED)  &                                     
!$OMP PRIVATE(Mk3,Mk2,Mk1)                                            
      DO Mk3 = 1, NROW 
      DO Mk2 = 1, NROW 
      DO Mk1 = 1, NROW 
          GR (Mk1, Mk2, Mk3) = 0. 
      ENDDO 
      ENDDO 
      ENDDO 
!                                      Set Spectrum                     
!.... Open_MP                                                           
!$OMP PARALLEL DO DEFAULT(SHARED)  &                                     
!$OMP PRIVATE(k,ksign,kz,k3,Wk3,j,jsign,jz,j3,Wj3,i,isign,iz,i3,Wi3)  &
!$OMP PRIVATE(WD,Wk,TS,TRX,m,NRAND,gSet,iFlag)           &
!$OMP REDUCTION(+:SUMM)
      DO k = 1, NROW 
         If (iRandom.eq.0) Then 
            NRAND = i24A(k)
         Else 
           i24      = i24A(k) 
           j24      = j24A(k) 
           in24    = in24A(k) 
           kount   = kountA(k)
           mkount  = 0 
           carry  = carryA(k)
           iflag  = iFlagA(k)
           gset   = gSetA(k)
              Do m=1,24
                  seeds(m) =SeedsPage(m,k) 
              EndDo    
         EndIf         ! end iRandom

         Wk3 = map3(k)**2 

         DO j = 1, NROW 
            Wj3 = map3(j)**2 
            DO i = 1, NROW 
               Wi3 = map3(i)**2 
                                                                                 
               IF (i + j + k.EQ.3) THEN 
                  GR (1, 1, 1) = 0. 
               ELSE 
                  WD = Wi3 + Wj3 + Wk3 
                  Wk = SQRT (WD) 
                  If (iRandom.eq.0) Then 
                     TS = TRUNF (Wk) * GAUSS (NRAND) 
                  Else 
                     TS = TRUNF (Wk) * GAUSS3 (gSet,iFlag) 
                  EndIf 
                  TRX = TS / WD 
                                                                   ! start switch
                  If (iDirection.eq.1) Then 
                     GR (mapz(i), j, k) = TRX * map3(i) 
                  ElseIF (iDirection.eq.2) Then 
                     GR (i, mapz(j), k) = TRX * map3(j) 
                  Else 
                     GR (i, j, mapz(k)) = TRX * map3(k)
                  EndIf       ! end iDirection
                  SUMM = SUMM + TS**2 
               ENDIF        ! end kx=ky=kz=0 switch
            ENDDO         ! i
         ENDDO            ! j
      ENDDO               ! k
                                                                        
      IF (SUMM.LE.0.) Write (*,  * ) ' Error!!! Summ over spectrum = 0'
      ALPHA = AMPLT / SQRT (SUMM) * sqrt (8.) 
      Write (*,'(10x,a20,3g12.4)') 'SPECTR ==>  SUMM=', SUMM, ALPHA 
      CALL CPU_TIME(t1)
      timing(3) = timing(3) +t1-t0        ! time for setting SPECTR
                                                                        
      RETURN 
      END SUBROUTINE SPECTR                         
!------------------------------------------------                       
!		                        Define coordinates and velosities for        
!                                  particles with resolution = Indx     
!                                  Indx =1 = high resolution            
!                                  Indx =2 = medium resolution          
!                                  Icurrent = number of particles       
      SUBROUTINE BLOCKS (XCONS, VCONS, Indx, Icurrent, iDirection) 
!------------------------------------------------                       
      Dimension nLevel (10) 
      Real(8)       :: sDispl =0. 
      REAL          ::    t0=0,t1=0.        ! counters for timing
                                 
      CALL CPU_TIME(t0)                    ! initialize time counter   
      Do i = 1, Max_lev_abs   ! number of particles at           
         nLevel (i) = 0               ! different levels               
      Enddo 
      Boff = Lblock / 2 + 0.5 
      sDispl = 0. 
                                                                        
      QFACT = FLOAT (NGRID) / FLOAT (NROW) 
      DO Mk3 = 1, Nblocks 
         M3 = (Mk3 - 1) * Lblock       ! part of offset
      DO Mk2 = 1, Nblocks 
         M2 = (Mk2 - 1) * Lblock      ! part of offset
      DO Mk1 = 1, Nblocks 
         M1 = (Mk1 - 1) * Lblock     ! part of offset
         iM = iMask (Mk1, Mk2, Mk3) 
!                                             --------------------------
!                     M1 + Boff  = lagrangian coordinate of 'mean' particle
!                     Lblock**3 = total number of averaged cells        
         If (iM.eq.Indx) Then 

         If (iM.eq.1) Then        !-------------- Low resolution: one particle               
         kp = M3 + (Lblock + 1) / 2 
         jp = M2 + (Lblock + 1) / 2 
         ip = M1 + (Lblock + 1) / 2 
         DX = GR (ip, jp, kp) 
                                                                           
         Icurrent = Icurrent + 1 
         If (Icurrent.gt.Nmaxpart) Then 
             Write (*,*) 'Too many particles:', Icurrent, ' block=',      &
                                   Mk1,Mk2, Mk3                                                          
             STOP 
         EndIf 
         nLevel (Indx) = nLevel (Indx) + 1 
         If (iDirection.eq.1) Then 
            Q = QFACT * (M1 + Boff - 1.) + 1. 
         ElseIF (iDirection.eq.2) Then 
            Q = QFACT * (M2 + Boff - 1.) + 1. 
         Else 
            Q = QFACT * (M3 + Boff - 1.) + 1. 
         EndIf	 
         XPt (Icurrent)  = Q - XCONS * DX + 1.E-4 + 0.5 
         VXt (Icurrent) = VCONS * DX 
          sDispl            = sDispl + DX**2                                                                 
      Else 
                                      ! --------------- Highest resolution:             
      If (iM.eq.Max_lev_abs) Then 
      Do kp = M3 + 1, M3 + Lblock 
      Do jp = M2 + 1, M2 + Lblock 
      Do ip = M1 + 1, M1 + Lblock 
         DX = GR (ip, jp, kp)              !  find displacements 
         Icurrent = Icurrent + 1 
         If (Icurrent.gt.Nmaxpart) Then 
            Write (*,*) 'Too many particles:', Icurrent, ' block=',      &
                                 Mk1,Mk2, Mk3                                                          
            STOP 
         EndIf 
         nLevel (Indx) = nLevel (Indx) + 1 
         If (iDirection.eq.1) Then 
            Q = QFACT * (ip - 1.) + 1. 
         ElseIF (iDirection.eq.2) Then 
            Q = QFACT * (jp - 1.) + 1. 
         Else 
            Q = QFACT * (kp - 1.) + 1. 
         EndIf 
         XPt (Icurrent) = Q - XCONS * DX + 1.E-4 + 0.5 
         VXt (Icurrent) = VCONS * DX 
         sDispl = sDispl + DX**2
      EndDo        ! end ip
      EndDo        ! end jp
      EndDo        ! end kp
                                                                        
      Else 
            !-------------------            Medium resolution:                                         
            !                   KBlock = 2**(iM-1)        = number of particles in 1
            !                   Nbcells= Lblock/KBlock = number of cells per particl
            !                   (MK-1)*Lblock +(i-1)*Nbcells = offset of cells in 1D
            !                   (MK-1)*Lblock +(i-1)*Nbcells +Nbcells/2 +1/2 = lagra
            !                                                                 coordi
            !                    M1   = (Mk1-1)*Lbloc                               
      KBlock    = 2** (iM - 1)          ! number of particles in 1D per block
      Nbcells   = Lblock / KBlock   ! number of cells per particle in  1D
      Xlag        = Nbcells / 2 + 0.5   ! offset for lagrangian coordinates
      Nbcells3 = Nbcells**3            ! total number of cells per particle
                                                                        
      Do i = 1, KBlock                                ! loop over particles
         i1 = M1 + (i - 1) * Nbcells               ! offset for cells in X 
        Q1 = QFACT * (i1 + Xlag - 1.) + 1. ! scale it to box size 
           Do j = 1, KBlock 
               j1 = M2 + (j - 1) * Nbcells         ! offset for cells in Y
              Q2 = QFACT * (j1 + Xlag - 1.) + 1. 
              Do k = 1, KBlock 
                 k1 = M3 + (k - 1) * Nbcells     ! offset for cells in Z
                 Q3 = QFACT * (k1 + Xlag - 1.) + 1. 
                                                                                   
                 kp = k1 + (Nbcells + 1) / 2 
                 jp = j1 + (Nbcells + 1) / 2 
                 ip = i1 + (Nbcells + 1) / 2 
                 DX = GR (ip, jp, kp) 
                                                                                   
                 Icurrent = Icurrent + 1 
                 If (Icurrent.gt.Nmaxpart) Then 
                    Write (*,*) 'Too many particles:', Icurrent, ' block=', Mk1,  &
                    Mk2, Mk3                                                          
                    STOP 
                 EndIf 
                 nLevel (Indx) = nLevel (Indx) + 1 
                 If (iDirection.eq.1) Then 
                    Q = Q1 
                 ElseIF (iDirection.eq.2) Then 
                    Q = Q2 
                 Else 
                    Q = Q3 
                 EndIf	 
                 XPt (Icurrent) = Q - XCONS * DX + 1.E-4 + 0.5 
                 VXt (Icurrent) = VCONS * DX 
                 sDispl = sDispl + DX**2
            EndDo            ! end k
         EndDo               ! end j
      EndDo                  ! end i
      EndIf                    ! end iM=Max_lev_abs
      EndIf                    ! end iM = 1
      EndIf                    ! end iM = Indx  
      EndDo                 ! end Mk1 =1,Nblocks
      EndDo                 ! end Mk2 =1,Nblocks
      EndDo                 ! end Mk3 =1,Nblocks
                                                                        
      If (nLevel (indx) .gt.0) Then 
         Nspecies = Nspecies + 1 
         lspecies (Nspecies) = Icurrent 
         wspecies (Nspecies) = PARTW * Lblock**3 / 8** (Indx - 1) 
         Write (*, '(10x,a20,g12.4)') ' RMS 3d diplacement=',              &
                        XCONS*sqrt (sDispl/nLevel (indx) )   
         write (*,'(10x,a20,i4,a,i10,a,6i10)') ' Species=',Nspecies,   &
                         ' Current Particles=',Icurrent,' on  all levels:',         &
                          (nLevel(i),i=1,Max_lev_abs   )     
      EndIf 

      CALL CPU_TIME(t1)
      timing(4) = timing(4) +t1-t0        ! time for setting SPECTR
                                                                        
      RETURN                                                            
      END  SUBROUTINE BLOCKS                                         
!------------------------------------------------                       
!                                              				   FFT of the spectru
      SUBROUTINE VECTOR (IFOUR) 
!------------------------------------------------                       
      DIMENSION Uf (marr), Vf (marr) 
      DIMENSION Qi (mf67), jndx (mf67) 
      REAL               ::    t0=0,t1=0.        ! counters for timing
                          
      CALL CPU_TIME(t0)                                        
      jb1 = 4 
      jq = IFOUR 
      CALL SETF67 (jb1, jq, jbc, jp, jsl, ll1, k2, k3, k4, k7, Qi, jndx,&
      Uf, Vf)                                                           
                                                                        
!			                                                                    
!.... Open_MP                                                   -1-     
!$OMP PARALLEL DO DEFAULT(SHARED)   &                                    
!$OMP PRIVATE ( k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )                          
      DO K = 1, NROW 
      DO J = 1, NROW 
      DO I = 1, NROW 
         Uf (I) = GR (I, J, K) 
      ENDDO 
      CALL FOUR67 (jb1, jq, jp, jsl, ll1, k2, k7, Qi, jndx, Uf, Vf) 
      DO I = 1, NROW 
         GR (I, J, K) = Vf (I) 
      ENDDO 
      ENDDO 
      ENDDO 
      Write (*,'(10x,a)') 'Xfft is done' 
!.... Open_MP                                                  -2-      
!$OMP PARALLEL DO DEFAULT(SHARED)   &                                    
!$OMP PRIVATE ( k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )                          
      DO K = 1, NROW 
      DO I = 1, NROW 
      DO J = 1, NROW 
         Uf (J) = GR (I, J, K) 
      ENDDO 
      CALL FOUR67 (jb1, jq, jp, jsl, ll1, k2, k7, Qi, jndx, Uf, Vf) 
      DO J = 1, NROW 
         GR (I, J, K) = Vf (J) 
      ENDDO 
      ENDDO 
      ENDDO 
      Write (*,'(10x,a)') 'Yfft is done' 

      write (*,'(10x,a)') 'Swap k<->i'
!.... Open_MP
!$OMP PARALLEL DO DEFAULT(SHARED) &
!$OMP PRIVATE ( k,j,i,aa)
      DO J=1,NROW
      DO K=1,NROW-1
            DO I=K+1,NROW
               aa = GR(I,J,K)
               GR(I,J,K) =GR(K,J,I)
               GR(K,J,I) =aa
            ENDDO
         ENDDO
      ENDDO

!.... Open_MP                                                  -3-      
!$OMP PARALLEL DO DEFAULT(SHARED)   &                                    
!$OMP PRIVATE ( k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )                          
      DO K = 1, NROW 
      DO J = 1, NROW 
      DO I = 1, NROW 
         Uf (I) = GR (I, J, K) 
      ENDDO 
      CALL FOUR67 (jb1, jq, jp, jsl, ll1, k2, k7, Qi, jndx, Uf, Vf) 
      DO I = 1, NROW 
         GR (I, J, K) = Vf (I) / 8. 
      ENDDO 
      ENDDO 
      ENDDO 

      write (*,'(10x,a)') 'Swap i<->k'
!.... Open_MP
!$OMP PARALLEL DO DEFAULT(SHARED) &
!$OMP PRIVATE ( k,j,i,aa)
      DO J=1,NROW
      DO K=1,NROW-1
            DO I=K+1,NROW
               aa = GR(I,J,K)
               GR(I,J,K) =GR(K,J,I)
               GR(K,J,I) =aa
            ENDDO
         ENDDO
      ENDDO

!!.... Open_MP                                                  -3-      
!!$OMP PARALLEL DO DEFAULT(SHARED)   &                                    
!!$OMP PRIVATE ( k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )                          
!      DO J = 1, NROW 
!      DO I = 1, NROW 
!      DO K = 1, NROW 
!         Uf (K) = GR (I, J, K) 
!      ENDDO 
!      CALL FOUR67 (jb1, jq, jp, jsl, ll1, k2, k7, Qi, jndx, Uf, Vf) 
!      DO K = 1, NROW 
!         GR (I, J, K) = Vf (K) / 8. 
!      ENDDO 
!      ENDDO 
!      ENDDO 

      Write (*,'(10x,a)') ' FFT is done' 
      CALL CPU_TIME(t1)
      timing(5) = timing(5) +t1-t0        ! time for VECTOR

      RETURN 
      END SUBROUTINE VECTOR                         
!---------------------------------------------                          
!               1)    Update SKINE and Wtotal
!               2)    Write current data to  disk/tape                
!                   do not write files for 3rd direction
      SUBROUTINE WriteData (Vscale, AexpV, Wtotal,SKINE,iDirection) 
!----------------------------------------------                         
DOUBLE PRECISION    Wtotal,SKINE,vvx,vx2
REAL               ::    t0=0,t1=0.        ! counters for timing


!        write(30,*) ' XXX'       ! test data 
!        write(30,'(10g12.5)') (XPt(i),i=1,lspecies(Nspecies),5000)
!        write(30,*) ' VVV'
!        write(30,'(10g12.5)') (VXt(i),i=1,lspecies(Nspecies),5000)

      CALL CPU_TIME(t0)                    ! initialize time counter
      jstart = 1 
Do j = 1, Nspecies 
      vvx  = 0. 
      vx2  = 0. 
      jend = lspecies (j) 
      W    = wspecies (j) 
      If (jend.gt.jstart) Then 
            Do i = jstart, jend 
               vvx = vvx + VXt (i) 
               vx2 = vx2 + VXt (i) **2 
               SKINE = SKINE+W * VXt (i) **2
               Wtotal = Wtotal + w 
            EndDo                             ! end current species
         npp  = max (jend-jstart + 1, 1) 
         v2    = sqrt ( vx2 / npp) / AexpV * Vscale 
         vvx  = vvx / npp / AexpV * Vscale 
         Write ( *,'(22x,"V(km/s)=",2g11.3," Npart=",i10," Species=",i3)')   & 
                                        vvx, v2, jend-jstart + 1, j 
         jstart = jend+1 
      Endif 
EndDo                                       ! end all species
If(iDirection == 3)Then
      CALL CPU_TIME(t1)
      timing(6) = timing(6) +t1-t0        ! time for VECTOR
   Return                   ! do not write the last page
EndIf

      Ibuff = 0                              ! write data page by page
      KROW = 0 
Do i = 1, lspecies (Nspecies) 
        Ibuff = Ibuff + 1          ! buffer counter
        XPAR (Ibuff) = XPt (i) 
        VX (Ibuff)     = VXt (i) 
        If(Ibuff.ge.NPAGE)Then                                      
            KROW = KROW +1                                          
            write (*,*) ' Write page=',KROW,' i=',i,Ibuff           
            CALL WRIROW                                             
            Ibuff     =0                 ! initialize buffer counter                                           
         EndIf                                                      
EndDo                            ! end lspecies loop                             
          If(Ibuff.ne.0)Then          ! write leftover                                  
                KROW = KROW +1                                          
                write (*,*) ' Write page=',KROW,' i_buff=',Ibuff        
                CALL WRIROW                                             
                Ibuff     =0                                            
          EndIf                                                         
      RETURN                                                            
      CALL CPU_TIME(t1)
      timing(6) = timing(6) +t1-t0        ! time for VECTOR

      END  SUBROUTINE WriteData                                         
!--------------------------------------------------                     
!                    Write current  page of particles (x,v) to disk 
!                                                                       
      SUBROUTINE WRIROW 
         Write (1) XPAR 
         Write (1) VX
      RETURN 
      END SUBROUTINE WRIROW  
!--------------------------------------------------
!                             Write current PAGE of particles (x,v) to disk
!                             NRECL - length of ROW block in words
      SUBROUTINE WRIROWd(IROW)
        WRITE (21,REC=IROW) RECDAT
      RETURN
      END SUBROUTINE WRIROWd
!-------------------------------------------------------                
!                                                                       
!                                     Print statistics of spicies       
      Subroutine Species_Change (Wtotal) 

DOUBLE PRECISION Wtotal	 
                                                                        
      Write ( *, 300) Nspecies 
      Write (16, 300) Nspecies 
  300 FORMAT     ('--- New number of species=',i3,/                     &
               3x,'Specie',2x,                                         &
               'Nparticles Ntotal  Weight/part Weight_Total ')         
  310 FORMAT     (T5,i3,T13,i8,T22,i8,T30,2g10.3) 
      Wtotal = 0. 
      Do i = 1, Nspecies 
          If (i.eq.1) Then 
             Wtotal = wspecies (i) * lspecies (i) 
             Write ( *, 310) i, lspecies (i), lspecies (i), wspecies (i),      &
                                       Wtotal                                                            
            Write (16, 310) i, lspecies (i), lspecies (i), wspecies (i),      &
                                      Wtotal                                                            
         Else 
            ww = wspecies (i) * (lspecies (i) - lspecies (i - 1) ) 
           Write ( *, 310) i, lspecies (i) - lspecies (i - 1), lspecies (i), &
                                      wspecies (i), ww                                                  
            Write (16, 310) i, lspecies (i) - lspecies (i - 1), lspecies (i), &
                                     wspecies (i), ww                                                  
            Wtotal = Wtotal + ww 
      Endif 
      Enddo 
      Write (*,*) ' Total weight =', Wtotal 
                                                                        
      Return 
      END  Subroutine Species_Change                                         
                                                                        
!---------------------------------------------------                    
!                                  Read  current data from disk/tape,   
!                                  Open files                           
!                                  Nrecl is the number of values in a re
!                                  Npage is the number of particles in a
      SUBROUTINE FilesOpen 

Character (LEN=50) :: FileName
Logical            :: FileExists 

      write(*,'(10x,a/,2(30x,a/))')'Create temporary Files====>',NamesDir



!                                     Open file on a tape               
      OPEN (UNIT = 9, FILE = 'PMcrd.DAT', form = 'unformatted') 
                            ! this clears old header file               
      Write (9) 
      CLOSE (9) 
      OPEN (9, FILE = 'PMcrd.DAT', FORM = 'UNFORMATTED', STATUS =       &
         'UNKNOWN')                                                        
      OPEN (UNIT = 16, FILE = 'RESNEW.DAT') 
      OPEN (60, file = 'pt.dat', form = 'unformatted') 
                              

      RETURN 
      END SUBROUTINE FilesOpen                      
!---------------------------------------------                          
!                       Write current data to  disk/tape                
!                                                                       
      SUBROUTINE FilesWrite 
!----------------------------------------------                         
!                                       write header and control data   
REAL               ::    t0=0,t1=0.        ! counters for timing

      CALL CPU_TIME(t0)                    ! initialize time counter

      Write (9) HEADER, AEXPN, AEXP0, AMPLT, ASTEP, ISTEP, PARTW, TINTG,&
      EKIN, EKIN1, EKIN2, AU0, AEU0, NROWC, NGRIDC, Nspecies, Nseed,    &
      Om0, Oml0, hubble, Wp5, Ocurv, extras                             
      REWIND 9 

      NBYTE = NRECL*4
      NACCES= NBYTE / nbyteword

      OPEN(UNIT=21,FILE='PMcrs0.DAT',ACCESS='DIRECT', &
     	               FORM='unformatted',STATUS='UNKNOWN',RECL=NACCES)
      OPEN(31,FILE=NamesDir(1),form='unformatted')  ! x coord and veloc
      OPEN(32,FILE=NamesDir(2),form='unformatted')  ! y
      XMAX = FLOAT (NGRID) + 1. 
      XSHF = FLOAT (NGRID) 
      Ibuff =0
      KROW =0


   Npages  = (lspecies (Nspecies)-1)/NPAGE+1
   If(Npages.eq.0)stop ' Zero number of pages requested. Stop'
Do i=1,Npages
   If(i==Npages)Then
      NinPage = lspecies (Nspecies) -(i-1)*NPAGE  ! # particles in the current page
   Else
      NinPage = NPAGE
   EndIf
   jfirst  = (i-1)*NPAGE +1
   jlast   = jfirst + NinPage-1
   write(*,'(10x,a,i5,a,4i9)')'Write page=',i,' Particles=',NinPage,jfirst,jlast
   read(31)XPAR
   read(31)VX
   read(32)YPAR
   read(32)VY
   Do j = jfirst,jlast
      ZPAR(j-jfirst+1) =XPt(j)
      VZ (j-jfirst+1) =Vxt(j)
   EndDo
   Do j=1,NinPage
!                       Impose  Periodical boundary conditions         
        IF (XPAR(j) .GT.XMAX) XPAR(j) = XPAR(j) - XSHF 
        IF (XPAR(j) .LE.1.)   XPAR(j) = XPAR(j) + XSHF 
        If (XPAR (j) .lt.1.)write(*,*) ' Boundary Error X!!', i,j,XPAR(j)
        If (XPAR (j) .ge.XMAX)Then
            write (*,*)' Fixing Boundary:', j, XPAR(j)  
            XPAR (j) = XPAR (j) - 1.e-4 
        ENDIF
        IF (YPAR(j) .GT.XMAX) YPAR(j) = YPAR(j) - XSHF 
        IF (YPAR(j) .LE.1.)   YPAR(j) = YPAR(j) + XSHF 
        If (YPAR (j) .lt.1.)write(*,*) ' Boundary Error Y!!', i,j,YPAR(j)
        If (YPAR (j) .ge.XMAX)Then
            write (*,*)' Fixing Boundary:', j, YPAR(j)  
            YPAR (j) = YPAR (j) - 1.e-4 
        ENDIF
        IF (ZPAR(j) .GT.XMAX) ZPAR(j) = ZPAR(j) - XSHF 
        IF (ZPAR(j) .LE.1.)   ZPAR(j) = ZPAR(j) + XSHF 
        If (ZPAR (j) .lt.1.)write(*,*) ' Boundary Error Z!!', i,j,ZPAR(j)
        If (ZPAR (j) .ge.XMAX)Then
            write (*,*)' Fixing Boundary:', j, ZPAR(j)  
            ZPAR (j) = ZPAR (j) - 1.e-4 
        ENDIF
   EndDo                                    
   WRITE (21,REC=i) RECDAT
EndDo                            ! end lspecies loop                             
rewind(31)                       ! erase temporary files
write(31)NROW
rewind(32)
write(32)NROW
      CALL CPU_TIME(t1)
      timing(7) = timing(7) +t1-t0        ! time for VECTOR

      RETURN 
      END SUBROUTINE FilesWrite                     
!--------------------------------------                                 
!		normal random numbers                                                
      FUNCTION GAUSS3 (gSet,iFlag) 
!                        Uses ranlux for homogenous rand numbers        
!                        Uses Box-Muller inversion for gaussian         
!                 Excellent quality and speed                           
!  N=       100000000  GAUSS3+ranlux ------                             
!  sigma= 0.99997     mean= 0.18692E-03                                 
!  sigma Frac(>sig) Frac(<-sig)   True       n(>)    n(<)               
!  1.00 0.1587     0.1586     0.1587     15869095 15857724              
!  1.50 0.6682E-01 0.6680E-01 0.6681E-01  6681652  6679768              
!  2.00 0.2277E-01 0.2273E-01 0.2275E-01  2276651  2273197              
!  2.50 0.6222E-02 0.6206E-02 0.6210E-02   622190   620610              
!  3.00 0.1356E-02 0.1347E-02 0.1350E-02   135628   134674              
!  4.00 0.3242E-04 0.3145E-04 0.3170E-04     3242     3145              
!                                                                       
!--------------------------------------                                 
      DIMENSION RanNum (2)
      If (iFlag.eq.0) Then 
    1    CALL ranlux (RanNum, 2 ) 
         x1 = 2. * RanNum (1) - 1. 
         x2 = 2. * RanNum (2) - 1. 
         R = x1**2 + x2**2 
         If (R.ge.1.) GoTo 1 
         F              = sqrt ( - 2. * LOG (R) / R) 
         gSet        = x1 * F 
         GAUSS3 = x2 * F 
         iFlag        = 1 
      Else 
         GAUSS3 = gSet 
         iFlag        = 0 
      EndIf 
      RETURN 
      END FUNCTION GAUSS3                           
                                                                        
                                                                        
!--------------------------------------------------------------------   
                                                                        
!   LUXURY LEVELS.                                                      
!  level 0  (p=24): equivalent to the original RCARRY of Marsaglia      
!           and Zaman, very long period, but fails many tests.          
!  level 1  (p=48): considerable improvement in quality over level 0,   
!           now passes the gap test, but still fails spectral test.     
!  level 2  (p=97): passes all known tests, but theoretically still     
!           defective.                                                  
!  level 3  (p=223): DEFAULT VALUE.  Any theoretically possible         
!           correlations have very small chance of being observed.      
!  level 4  (p=389): highest possible luxury, all 24 bits chaotic.      
!---------------------------------------------                          
      SUBROUTINE ranlux (rvec, lenv) 
!                    returns a vector RVEC of LEN                       
!                   32-bit random floating point numbers between        
!                   zero (not included) and one (also not incl.).       
!           Next call to ranlux gives next LEN of random numbers        
!---------------------------------------------                          
      INTEGER lenv 
      REAL rvec (lenv)
      INTEGER iseeds (24) 

INCLUDE 'luxuryp.h' 

      DATA ndskip / 0, 24, 73, 199, 365 / 
      DATA i24, j24, luxlev / 24, 10, lxdflt / 
      DATA notyet / .true. / 
      DATA in24, kount, mkount, carry / 0, 0, 0, 0. / 
                                                                        
                                                                        
!  NOTYET is .TRUE. if no initialization has been performed yet.        
!              Default Initialization by Multiplicative Congruential    
                                                                        
      IF (notyet) THEN 
         stop ' Access to runlux before initialization STOP'
      ENDIF 
                                                                        
!          The Generator proper: "Subtract-with-borrow",                
!          as proposed by Marsaglia and Zaman,                          
!          Florida State University, March, 1989                        
                                                                        
      DO ivec = 1, lenv 
      uni = seeds (j24) - seeds (i24) - carry 
      IF (uni.LT.0.) THEN 
         uni = uni + 1.0 
         carry = twom24 
      ELSE 
         carry = 0. 
      ENDIF 
      seeds (i24) = uni 
      i24 = next (i24) 
      j24 = next (j24) 
      rvec (ivec) = uni 
      !  small numbers (with less than 12 "significant" bits) are "padde
      IF (uni.LT.twom12) THEN 
         rvec (ivec) = rvec (ivec) + twom24 * seeds (j24) 
      !        and zero is forbidden in case someone takes a logarithm  
         IF (rvec (ivec) .EQ.0.) rvec (ivec) = twom24 * twom24 
      ENDIF 
      !        Skipping to luxury.  As proposed by Martin Luscher.      
      in24 = in24 + 1 
      IF (in24.EQ.24) THEN 
         in24 = 0 
         kount = kount + nskip 
         DO isk = 1, nskip 
         uni = seeds (j24) - seeds (i24) - carry 
         IF (uni.LT.0.) THEN 
            uni = uni + 1.0 
            carry = twom24 
         ELSE 
            carry = 0. 
         ENDIF 
         seeds (i24) = uni 
         i24 = next (i24) 
         j24 = next (j24) 
         ENDDO 
      ENDIF 
      ENDDO 
      kount = kount + lenv 
      IF (kount.GE.igiga) THEN 
         mkount = mkount + 1 
         kount = kount - igiga 
      ENDIF 
      RETURN 
                                                                        
          ! SUBROUTINE ranlux                                           
      END SUBROUTINE ranlux                         
                                                                        
!---------------------------------------------                          
!                    Subroutine to initialize from one or three integers
      SUBROUTINE rluxgo (lux, ins, k1, k2) 
!                initializes the generator from                         
!               one 32-bit integer INT and sets Luxury Level LUX        
!               which is integer between zero and MAXLEV, or if         
!               LUX .GT. 24, it sets p=LUX directly.  K1 and K2         
!               should be set to zero unless restarting at a break      
!               point given by output of RLUXAT                         
!---------------------------------------------                          
INCLUDE'luxuryp.h' 
      INTEGER iseeds (24)
                                                                        
      IF (lux.LT.0) THEN 
         luxlev = lxdflt 
      ELSEIF (lux.LE.maxlev) THEN 
         luxlev = lux 
      ELSEIF (lux.LT.24.OR.lux.GT.2000) THEN 
         luxlev = maxlev 
         Write (6, '(A,I7)') ' RANLUX ILLEGAL LUXURY RLUXGO: ', lux 
      ELSE 
         luxlev = lux 
         DO ilx = 0, maxlev 
         IF (lux.EQ.ndskip (ilx) + 24) luxlev = ilx 
         ENDDO 
      ENDIF 
      IF (luxlev.LE.maxlev) THEN 
         nskip = ndskip (luxlev) 
      Write (6, '(A,I2,A,I4)') ' RANLUX LUXURY LEVEL SET BY RLUXGO :', &
                       luxlev, '     P=', nskip + 24                                      
      ELSE 
         nskip = luxlev - 24 
         Write (6, '(A,I5)') ' RANLUX P-VALUE SET BY RLUXGO TO:',       &
         luxlev                                                         
      ENDIF 
      in24 = 0 
      IF (ins.LT.0) Write (6,'(A)')' Illegal initialization by RLUXGO,'&
                               'negative input seed'                                             
      IF (ins.GT.0) THEN 
         jseed = ins 
      Write (6, '(A,3I12)') ' RANLUX INITIALIZED BY RLUXGO FROM SEEDS', &
                                        jseed, k1, k2                                                     
      ELSE 
         jseed = jsdflt 
      Write (6, '(A)') ' RANLUX INITIALIZED BY RLUXGO FROM DEFAULT SEED' 
      ENDIF 
      inseed = jseed 
      notyet = .false. 
      twom24 = 1. 
      DO i = 1, 24 
      twom24 = twom24 * 0.5 
      k = jseed / 53668 
      jseed = 40014 * (jseed-k * 53668) - k * 12211 
      IF (jseed.LT.0) jseed = jseed+icons 
      iseeds (i) = MOD (jseed, itwo24) 
      ENDDO 
      twom12 = twom24 * 4096. 
      DO i = 1, 24 
      seeds (i) = REAL (iseeds (i) ) * twom24 
      next (i) = i - 1 
      ENDDO 
      next (1) = 24 
      i24 = 24 
      j24 = 10 
      carry = 0. 
      IF (seeds (24) .EQ.0.) carry = twom24 
      !        If restarting at a break point, skip K1 + IGIGA*K2       
      !        Note that this is the number of numbers delivered to     
      !        the user PLUS the number skipped (if luxury .GT. 0).     
      kount = k1 
      mkount = k2 
      IF (k1 + k2.NE.0) THEN 
         DO iouter = 1, k2 + 1 
         inner = igiga 
         IF (iouter.EQ.k2 + 1) inner = k1 
         DO isk = 1, inner 
         uni = seeds (j24) - seeds (i24) - carry 
         IF (uni.LT.0.) THEN 
            uni = uni + 1.0 
            carry = twom24 
         ELSE 
            carry = 0. 
         ENDIF 
         seeds (i24) = uni 
         i24 = next (i24) 
         j24 = next (j24) 
         ENDDO 
         ENDDO 
      !         Get the right value of IN24 by direct calculation       
         in24 = MOD (kount, nskip + 24) 
         IF (mkount.GT.0) THEN 
            izip = MOD (igiga, nskip + 24) 
            izip2 = mkount * izip + in24 
            in24 = MOD (izip2, nskip + 24) 
         ENDIF 
      !       Now IN24 had better be between zero and 23 inclusive      
         IF (in24.GT.23) THEN 
      Write (6, '(A/A,3I11,A,I5)') '  Error in RESTARTING with RLUXGO:',&
           '  The values', ins, k1, k2, ' cannot occur at luxury level', luxlev 
            in24 = 0 
         ENDIF 
      ENDIF 
      RETURN 
                                                                        
          ! SUBROUTINE rluxgo                                           
      END SUBROUTINE rluxgo                         
                                                                        
!---------------------------------- Read in variables                   
      REAL FUNCTION INPUT (text) 
!------------------------------------------------                       
      Character text * (*) 
         Write (*,'(A,$)') text 
         READ (*,*) x 
         INPUT = x 
      Return 
      END FUNCTION INPUT                            
!--------------------------------------   Fourier Transform             
      SUBROUTINE SETF67 (JBC1, JQ1, jbc, jp, jsl, ll1, k2, k3, k4, k7,  &
      Qi, jndx, Uf, Vf)                                                 
!     -----------------------------------------------------             
                                                                        
      DIMENSION Uf (marr), Vf (marr) 
      DIMENSION Qi (mf67), jndx (mf67) 
                                                                        
      PI = DATAN (1.D0) * 4. 
      JBC = JBC1 
      JQ = JQ1 
      IF (JBC.LT.3) GOTO 101 
      JQ = JQ - 1 
  101 K3 = 2**JQ 
      K7 = K3 / 2 
      N5 = K3 / 4 
      I = 1 
      JNDX (I) = N5 
      QI (I) = 0.5 * SQRT (2.) 
      K = I 
      I = I + 1 
  102 IL = I 
      IF (I.EQ.K7) GOTO 104 
  103 K1 = JNDX (K) / 2 
      JNDX (I) = K1 
      QI (I) = SIN (PI * FLOAT (K1) / FLOAT (K3) ) 
      K1 = K7 - K1 
      I = I + 1 
      JNDX (I) = K1 
      QI (I) = SIN (PI * FLOAT (K1) / FLOAT (K3) ) 
      K = K + 1 
      I = I + 1 
      IF (K.EQ.IL) GOTO 102 
      GOTO 103 
  104 RETURN 
      END SUBROUTINE SETF67                         
!-----------------------------------------                              
      SUBROUTINE TFOLD (IS, L, ZZZ, k2) 
                                                                        
      DIMENSION ZZZ (MARR) 
      IH2 = K2 / 2 - 1 
      DO 100 I = IS, IH2 
         I1 = I + L 
         I2 = K2 - I + L 
         A = ZZZ (I1) 
         ZZZ (I1) = A - ZZZ (I2) 
         ZZZ (I2) = A + ZZZ (I2) 
  100 END DO 
      RETURN 
      END SUBROUTINE TFOLD                          
!------------------------------------                                   
      SUBROUTINE NEG (I1, I3, I2, jbc, jp, jsl, ll1, k2, k3, k4, k7, Qi,&
      jndx, Uf, Vf)                                                     

      DIMENSION Uf (marr), Vf (marr) 
      DIMENSION Qi (mf67), jndx (mf67) 
                                                                        
      DO  K = I1, I3, I2 
         Vf (K) = - Vf (K) 
      END DO 
      RETURN 
      END SUBROUTINE NEG                            
!-------------------------------------                                  
      SUBROUTINE REVNEG (jbc, jp, jsl, ll1, k2, k3, k4, k7, Qi, jndx,   &
      Uf, Vf)                                                           

      DIMENSION Uf (marr), Vf (marr) 
      DIMENSION Qi (mf67), jndx (mf67) 
                                                                        
      INTEGER jbc, jp, jsl, ll1, k2, k3, k4, k7 
                                                                        
      DO  I = 1, K7 
         J = K3 + 1 + I 
         K = K4 + 1 - I 
         A = Vf (J) 
         Vf (J) = - Vf (K) 
         Vf (K) = - A 
      END DO 
      RETURN 
      END SUBROUTINE REVNEG                         
!-------------------------------------                                  
      SUBROUTINE ZEERO (L, jbc, jp, jsl, ll1, k2, k3, k4, k7, Qi, jndx, &
      Uf, Vf)                                                           

      DIMENSION Uf (marr), Vf (marr) 
      DIMENSION Qi (mf67), jndx (mf67) 
                                                                        
      INTEGER jbc, jp, jsl, ll1, k2, k3, k4, k7 
                                                                        
      DO I = 1, K2 
         LI = L + I 
         Uf (LI - 1) = 0.0 
      END DO 
      RETURN 
      END SUBROUTINE ZEERO                          
!------------------------------------------                             
      SUBROUTINE TFOLD1 (jbc, jp, jsl, ll1, k2, k3, k4, k7, Qi, jndx,   &
      Uf, Vf)                                                           

      DIMENSION Uf (marr), Vf (marr) 
      DIMENSION Qi (mf67), jndx (mf67) 
                                                                        
      INTEGER jbc, jp, jsl, ll1, k2, k3, k4, k7 
                                                                        
      II = K2 - 1 
      DO  I = 1, II 
         I1 = JSL + I 
         I2 = LL1 - I 
         A = Uf (I1) 
         Uf (I1) = A + Uf (I2) 
         Uf (I2) = A - Uf (I2) 
      END DO 
      RETURN 
      END SUBROUTINE TFOLD1                         
!-------------------------------------                                  
      SUBROUTINE KFOLD (jbc, jp, jsl, ll1, k2, k3, k4, k7, Qi, jndx, Uf,&
      Vf)                                                               

      DIMENSION Uf (marr), Vf (marr) 
      DIMENSION Qi (mf67), jndx (mf67) 
                                                                        
      INTEGER jbc, jp, jsl, ll1, k2, k3, k4, k7 
                                                                        
      JS1 = K2 
      I = 1 
      J5 = JSL + K2 
      IS1 = JSL 
      IC1 = LL1 
      JS1 = JS1 / 2 
      IF (JS1.NE.1) GOTO 200 
      K1 = JNDX (I) 
      SN = QI (I) 
      IS0 = IS1 
      IS1 = IS1 + JS1 
      IC0 = IC1 
      IC1 = IC1 + JS1 
      ODD1 = SN * (Uf (IC1) - Uf (IS1) ) 
      Vf (K1 + 1) = Uf (IC0) + ODD1 
      K3MK1 = K3 - K1 
      Vf (K3MK1 + 1) = Uf (IC0) - ODD1 
      IF (JBC.LT.3) GOTO 110 
      ODD2 = SN * (Uf (IC1) + Uf (IS1) ) 
      K3PK1 = K3 + K1 
      Vf (K3PK1 + 1) = Uf (IS0) + ODD2 
      K4MK1 = K4 - K1 
      Vf (K4MK1 + 1) = - Uf (IS0) + ODD2 
  110 RETURN 
  200 SN = QI (I) 
      IS1 = IS1 + JS1 
      IC1 = IC1 + JS1 
      J3 = IS1 + JS1 
  210 IS0 = IS1 - JS1 
      IC0 = IC1 - JS1 
      ODD1 = SN * (Uf (IC1) - Uf (IS1) ) 
      ODD2 = SN * (Uf (IC1) + Uf (IS1) ) 
      Uf (IC1) = Uf (IC0) - ODD1 
      Uf (IS1) = - Uf (IS0) + ODD2 
      Uf (IC0) = Uf (IC0) + ODD1 
      Uf (IS0) = Uf (IS0) + ODD2 
      IS1 = IS1 + 1 
      IC1 = IC1 + 1 
      IF (IS1.NE.J3) GOTO 210 
      I = I + 1 
  300 IS1 = JSL 
      IC1 = LL1 
      JS1 = JS1 / 2 
      IF (JS1.EQ.1) GOTO 400 
  310 SN = QI (I) 
      I = I + 1 
      CS = QI (I) 
      IS1 = IS1 + JS1 
      IC1 = IC1 + JS1 
      J3 = IS1 + JS1 
  320 IS0 = IS1 - JS1 
      IC0 = IC1 - JS1 
      ODD1 = CS * Uf (IC1) - SN * Uf (IS1) 
      ODD2 = SN * Uf (IC1) + CS * Uf (IS1) 
      Uf (IC1) = Uf (IC0) - ODD1 
      Uf (IC0) = Uf (IC0) + ODD1 
      Uf (IS1) = - Uf (IS0) + ODD2 
      Uf (IS0) = Uf (IS0) + ODD2 
      IS1 = IS1 + 1 
      IC1 = IC1 + 1 
      IF (IS1.NE.J3) GOTO 320 
      IS1 = IS1 + JS1 
      IC1 = IC1 + JS1 
      J3 = IS1 + JS1 
  330 IS0 = IS1 - JS1 
      IC0 = IC1 - JS1 
      ODD1 = SN * Uf (IC1) - CS * Uf (IS1) 
      ODD2 = CS * Uf (IC1) + SN * Uf (IS1) 
      Uf (IC1) = Uf (IC0) - ODD1 
      Uf (IC0) = Uf (IC0) + ODD1 
      Uf (IS1) = - Uf (IS0) + ODD2 
      Uf (IS0) = Uf (IS0) + ODD2 
      IS1 = IS1 + 1 
      IC1 = IC1 + 1 
      IF (IS1.NE.J3) GOTO 330 
      I = I + 1 
      IF (IS1.EQ.J5) GOTO 300 
      GOTO 310 
  400 K1 = JNDX (I) 
      SN = QI (I) 
      I = I + 1 
      CS = QI (I) 
      IS0 = IS1 
      IS1 = IS1 + JS1 
      IC0 = IC1 
      IC1 = IC1 + JS1 
      ODD1 = CS * Uf (IC1) - SN * Uf (IS1) 
      Vf (K1 + 1) = Uf (IC0) + ODD1 
      K3MK1 = K3 - K1 
      Vf (K3MK1 + 1) = Uf (IC0) - ODD1 
      IF (JBC.LT.3) GOTO 410 
      ODD2 = SN * Uf (IC1) + CS * Uf (IS1) 
      K3PK1 = K3 + K1 
      Vf (K3PK1 + 1) = Uf (IS0) + ODD2 
      K4MK1 = K4 - K1 
      Vf (K4MK1 + 1) = - Uf (IS0) + ODD2 
  410 IS1 = IS1 + 1 
      IC1 = IC1 + 1 
      K1 = JNDX (I) 
      IS0 = IS1 
      IS1 = IS1 + JS1 
      IC0 = IC1 
      IC1 = IC1 + JS1 
      ODD1 = SN * Uf (IC1) - CS * Uf (IS1) 
      Vf (K1 + 1) = Uf (IC0) + ODD1 
      K3MK1 = K3 - K1 
      Vf (K3MK1 + 1) = Uf (IC0) - ODD1 
      IF (JBC.LT.3) GOTO 420 
      ODD2 = CS * Uf (IC1) + SN * Uf (IS1) 
      K3PK1 = K3 + K1 
      Vf (K3PK1 + 1) = Uf (IS0) + ODD2 
      K4MK1 = K4 - K1 
      Vf (K4MK1 + 1) = - Uf (IS0) + ODD2 
  420 IS1 = IS1 + 1 
      IC1 = IC1 + 1 
      I = I + 1 
      IF (IS1.NE.J5) GOTO 400 
      RETURN 
      END SUBROUTINE KFOLD                          
                                                                        
!      ------------------------------------------------------           
      SUBROUTINE FOUR67 (JBC1, JQ1, jp1, jsl1, ll11, k21, k71, Qi, jndx,&
      Uf, Vf)                                                           
!      ------------------------------------------------------           

      DIMENSION Uf (marr), Vf (marr) 
      DIMENSION Qi (mf67), jndx (mf67) 
                                                                        
      INTEGER jbc, jp, jsl, ll1, k2, k3, k4, k7 
                                                                        
      JBC = JBC1 
      JQ = JQ1 
      jp = jp1 
      jsl = jsl1 
      ll1 = ll11 
      k2 = k21 
      k7 = k71 
      A5 = 0.5 * SQRT (2.0) 
      K4 = 2**JQ 
      K3 = K4 
      GOTO (103, 103, 101, 102), JBC 
  101 Uf (1) = Uf (1) / 2.0 
      Uf (K3 + 1) = Uf (1) 
      K2 = K3 
                                                                        
      CALL TFOLD (0, 1, Uf, k2) 
                                                                        
      K3 = K3 / 2 
      JQ = JQ - 1 
      GOTO 103 
  102 K3 = K3 / 2 
      JQ = JQ - 1 
  103 N5 = K3 / 4 
      K7 = K3 / 2 
      N11 = 3 * K7 
      K31 = K3 + 1 
      GOTO (300, 400, 500, 600), JBC 
  300 Uf (K31) = 0.0 
      Uf (1) = 0.0 
      K2 = K3 
      DO 301 I = 2, JQ 
                                                                        
         CALL TFOLD (1, 1, Uf, k2) 
                                                                        
  301 K2 = K2 / 2 
      Vf (K7 + 1) = Uf (2) 
      JF = N5 
      JSL = 1 
      DO 302 JP = 2, JQ 
         LL1 = K2 + 1 
                                                                        
         CALL ZEERO (1, jbc, jp, jsl, ll1, k2, k3, k4, k7, Qi, jndx, Uf,&
         Vf)                                                            
         CALL KFOLD (jbc, jp, jsl, ll1, k2, k3, k4, k7, Qi, jndx, Uf,   &
         Vf)                                                            
                                                                        
         I1 = 3 * JF + 1 
         I2 = 4 * JF 
         I3 = I1 + (K2 / 2 - 1) * I2 
                                                                        
         CALL NEG (I1, I3, I2, jbc, jp, jsl, ll1, k2, k3, k4, k7, Qi,   &
         jndx, Uf, Vf)                                                  
                                                                        
         K2 = K2 + K2 
  302 JF = JF / 2 
      RETURN 
  400 Uf (1) = Uf (1) / 2.0 
      Uf (K31) = Uf (K31) / 2.0 
      K2 = K3 
      DO 401 I = 2, JQ 
                                                                        
         CALL TFOLD (0, K31 - K2, Uf, k2) 
                                                                        
  401 K2 = K2 / 2 
      LL1 = K31 - K2 
      A = Uf (LL1) + Uf (LL1 + 2) 
      Vf (1) = - A - Uf (LL1 + 1) 
      Vf (K31) = - A + Uf (LL1 + 1) 
      Vf (K7 + 1) = Uf (LL1) - Uf (LL1 + 2) 
      DO 402 JP = 2, JQ 
         JSL = K31 - K2 
         LL1 = JSL - K2 
         idum = jsl 
                                                                        
         CALL ZEERO (idum, jbc, jp, jsl, ll1, k2, k3, k4, k7, Qi, jndx, &
         Uf, Vf)                                                        
         CALL KFOLD (jbc, jp, jsl, ll1, k2, k3, k4, k7, Qi, jndx, Uf,   &
         Vf)                                                            
                                                                        
  402 K2 = K2 + K2 
                                                                        
      CALL NEG (1, K31, 2, jbc, jp, jsl, ll1, k2, k3, k4, k7, Qi, jndx, &
      Uf, Vf)                                                           
                                                                        
      RETURN 
  500 K2 = K3 
      L2 = K4 
      DO 501 JP = 2, JQ 
                                                                        
         CALL TFOLD (1, 1, Uf, k2) 
         CALL TFOLD (0, L2 - K2 + 1, Uf, k2) 
                                                                        
  501 K2 = K2 / 2 
      LL1 = L2 - K2 + 1 
      A = Uf (LL1) + Uf (LL1 + 2) 
      Vf (K7 + 1) = 2.0 * ( - Uf (LL1) + Uf (LL1 + 2) ) 
      Vf (1) = 2.0 * (A + Uf (LL1 + 1) ) 
      Vf (K31) = 2.0 * (A - Uf (LL1 + 1) ) 
      Vf (N11 + 1) = 2.0 * Uf (2) 
      DO 502 JP = 2, JQ 
         Uf (K2 + 1) = 2.0 * Uf (K2 + 1) 
         JSL = K2 + 1 
                                                                        
         CALL TFOLD1 (jbc, jp, jsl, ll1, k2, k3, k4, k7, Qi, jndx, Uf,  &
         Vf)                                                            
                                                                        
         LL1 = LL1 - K2 
         Uf (LL1) = - 2.0 * Uf (LL1) 
                                                                        
         CALL KFOLD (jbc, jp, jsl, ll1, k2, k3, k4, k7, Qi, jndx, Uf,   &
         Vf)                                                            
                                                                        
  502 K2 = K2 + K2 
      Vf (1) = Vf (1) * A5 
      Vf (K31) = Vf (K31) * A5 
      RETURN 
  600 Uf (1) = Uf (1) * A5 
      Uf (K31) = Uf (K31) * A5 
      K2 = K3 
      DO 601 JP = 2, JQ 
                                                                        
         CALL TFOLD (0, K31 - K2, Uf, k2) 
         CALL TFOLD (1, K31, Uf, k2) 
                                                                        
  601 K2 = K2 / 2 
      LL1 = K31 - K2 
      A = Uf (LL1) + Uf (LL1 + 2) 
      Vf (1) = 2.0 * (A + Uf (LL1 + 1) ) 
      Vf (K31) = 2.0 * (A - Uf (LL1 + 1) ) 
      Vf (K7 + 1) = 2.0 * ( - Uf (LL1) + Uf (LL1 + 2) ) 
      Vf (N11 + 1) = 2.0 * Uf (K3 + 2) 
      DO 602 JP = 2, JQ 
         JSL = K31 + K2 
         Uf (JSL) = 2.0 * Uf (JSL) 
                                                                        
         CALL TFOLD1 (jbc, jp, jsl, ll1, k2, k3, k4, k7, Qi, jndx, Uf,  &
         Vf)                                                            
                                                                        
         LL1 = LL1 - K2 
         Uf (LL1) = - 2.0 * Uf (LL1) 
                                                                        
         CALL KFOLD (jbc, jp, jsl, ll1, k2, k3, k4, k7, Qi, jndx, Uf,   &
         Vf)                                                            
                                                                        
  602 K2 = K2 + K2 
                                                                        
      CALL REVNEG (jbc, jp, jsl, ll1, k2, k3, k4, k7, Qi, jndx, Uf, Vf) 
                                                                        
      idum = k3 
                                                                        
      CALL NEG (2, idum, 2, jbc, jp, jsl, ll1, k2, k3, k4, k7, Qi, jndx,&
      Uf, Vf)                                                           
                                                                        
      K2 = K4 
                                                                        
      CALL TFOLD (1, 1, Vf, k2) 
                                                                        
      Vf (K4 + 1) = 0.0 
                                                                        
      RETURN 
      END SUBROUTINE FOUR67                         
end module setInitialConditions
!
!
!
!-------------------------------------------------------------------------
PROGRAM  PMstartMp

use      setInitialConditions

!		   NROW = number of particles in 1 dimension                         
!		   NGRID= number of cells        in 1 dimension                      
!		   Npage =  number of particles per page = NROW**2               
!                                                                       
COMMON / TRUNCOM / Om, Omb, Omc, Omnu, Par (6), ns, qqscaleb,QSCALE
DOUBLE PRECISION ::    Wtotal=0., SKINE=0.
REAL, PARAMETER  ::    PI=3.1415926535
REAL             ::    t0=0,t1=0.        ! counters for timing
Logical          ::    iCont =.true.     ! continue (true) after setting seeds

      CALL CPU_TIME(t0)
      Open(30,file='TestDataParallel.dat')
      Wtotal = (float(NROW)**3*4+2.*Nmaxpart*4. &
                + 31.*NROW*4 +float(Nblocks)**3*4 &
                + 6. *NPAGE*4)/1024.**3
      write (*,'(//10x,a,g13.4,a/)') ' Memory required=',Wtotal,'Gb'
      CALL InitValues (NBYTE, SCALEL) 
      Write (*,*) ' InitValues is done. N bytes=', NBYTE 
      Max_lev_abs = INT (ALOG (REAL (Lblock) ) / ALOG (2.) + 1.1) 
      Write (*,'(10x,a,2i4)') 'Absolute Limits on mass resolution levels: ', 1,&
                            Max_lev_abs
      Write (*,'(10x,2(a,i4))') 'Actual Max resolution Level=', Nmax_lev, & 
                              ' Min Level=', Nmin_lev
      Write (16,'(10x,2(a,i4))') 'Actual Max resolution Level=', Nmax_lev, &
                              ' Min Level=', Nmin_lev
      If (Nmax_lev.gt.Max_lev_abs) Then 
               Write (*,*) ' Wrong number of Levels for mass refinement (',  &
                                  Nmax_lev, ') Block size =', Lblock, ' Use Absolute value=', &
                Max_lev_abs                                                       
                Nmax_lev = Max_lev_abs 
      Endif 
                                                                        
      CALL FilesOpen                   ! this opens files on disk        
         Write (16, * ) ' Seed=', Nseed 
         AEXP0 = AEXPN 
         AEXPV = AEXPN - ASTEP / 2. 

      CALL ZeroMASK                ! set mask for multiple mass resolution
      If (Nmax_lev.ne.Nmin_lev) Then 
         Open (30, file = 'SelCoords.DAT', status = 'unknown') 
         CALL SetMASK 
      EndIf 
                                     ! set scaling constants for coordinates and velocities
         IFOUR = INT (ALOG (FLOAT (NROW) ) / ALOG (2.) + 0.5) 
            Write (*,'(3x,a12,i4,a,i4)') ' Ifour =', IFOUR, ' Nrow=', NROW 
         Fact   = sqrt (Om0 + Oml0 * AEXPV**3 + Ocurv * AEXPV) 
         QFACT  = FLOAT (NGRID) / FLOAT (NROW) 
         Vscale = ScaleL * 100. * hubble / NGRID 

			      !  get a realization of spectrum in /GRID/          
         NRAND = Nseed 
      CALL CPU_TIME(t1)
      timing(1) = t1-t0       ! time for intialization

      CALL SetRandom(iCont)            ! set seeds for ramdom numbers

         If(.NOT.iCont)Then
            write(*,'(2(10x,a,f10.2/))') &
                     'cpu_time for init =',timing(1), &
                     'cpu_time for seeds=',timing(2)
            Stop
         EndIf
         SKINE   = 0.                              ! counter for  kinetic energy
         Wtotal  = 0.                             ! counter for  total weight

      ALLOCATE(GR(NROW,NROW,NROW))     ! allocate memory for spectrum

      Do iDirection = 1, 3                  ! ----------------- loop over x,y,z directions 
          Write(*,'(//3x,a12,i3,15("-"))' )'- Direction=',iDirection
          If(iDirection < 3)  &          
                 OPEN(1,FILE=NamesDir(iDirection), FORM='UNFORMATTED',        &
                        STATUS ='UNKNOWN')                                  

          CALL SPECTR (ALPHA, NRAND, iDirection) 
			       !   get the displacement vector by FFT 
          VCONS = - ALPHA/(2.*PI/NGRID)*(AEXPV/AEXP0)*SQRT(AEXPV)*Fact
          XCONS = 	ALPHA / (2. * PI / NGRID) * (AEXPN / AEXP0) 
            Write(*,'(3x,a12,g12.4,a,g12.4)' ) 'Scaling:(x)=', XCONS, ' (v)=', VCONS 

          CALL VECTOR (IFOUR) 
             Write (*,'(3x,a12,i4,a,g12.4)' ) 'SPECTR done:', IFOUR, ' Alpha=', ALPHA 
            write(*,'(2(a,f8.3))')' Spectr t=',timing(3),' FFT=',timing(5)
			       !    find x,v and write to file, page by page
          Do i = 1, Max_lev_abs 
                lspecies (i) = 0 
          Enddo 
          Nspecies = 0 
          Icurrent = 0                            ! current particle   
          Do kSpec = Max_lev_abs, 1, - 1 
             CALL BLOCKS (XCONS, VCONS, kSpec, Icurrent, iDirection) 
          Enddo 
          CALL WriteData (Vscale, AexpV, Wtotal,SKINE,iDirection)
          CLOSE(1) 
      EndDo 
      
      DEALLOCATE (GR)                                   
      CALL Species_Change (Wtotal)     ! print info on species
      EKIN = 0.5 * SKINE / AEXPV**2 
         Write (*, '('' Ekin='',E12.4,'' Weght per cell='',g12.5,        &
                 '' (must be 1)'')') EKIN, Wtotal / NGRID**3            
         Write (16, '('' Ekin='',E12.4,'' Weght per cell='',g12.5,         &
     &         '' (must be 1)'')') EKIN, Wtotal / NGRID**3              

                       
      CALL FilesWrite           ! write header and control data
      Write (60) astep        ! write pt.dat file: time-step for particles             

      CALL CPU_TIME(t1)
            write(*,'(10x,a/,(10x,a15,f10.2))') &
                     'Wall cpu_time (seconds) ', &
                     'Init        =',timing(1), &
                     'Seeds       =',timing(2), &
                     'Spectr      =',timing(3), &
                     'Coords      =',timing(4), &
                     'FFT         =',timing(5), &
                     'Write temp  =',timing(6), &
                     'Write final =',timing(7), &
                     'Total       =',t1-t0

      STOP 
      END                                           

C ______________________________	 Selects and Scales PM particles 
C                       For setting refinement in initial conditions
C		             December 1998        A. Klypin (aklypin@nmsu.edu) 
C          Input: 1) catalog of halos, which define what regions should be
C                                 selected for mass refinement
C                     2) PMcrd.DAT and PMcrs0.DAT -- 
C                                 lowest resolution run with one specie
c                                 of particles covering all the computational Box
C
C          Output: File with lagrangian coordinates of selected particles.
C                     These coordinates are used by PMstartM to make mass refinement
C          Format of halo catalog:
C                        First 16 lines -- any text (ignored)
C                        Next line(s): one line per halo (=center):
C                        x,y,z,vx,vy,vz,Mass,Radius,v1,v2
C                            Only coordinates (x,y,z) and Radius are used.
C                            (x,y,z) = center of sphere of radius Radius
C                        Units: (x,y,z) are in Mpc/h; Radius is in kpc/h
C  Within the sphere(s) all particles are selected. In the lagrangian
C  space occupied by the particles mass resolution will be increased.
C  Spheres may overlap in any possible way    
       INCLUDE 'PMparameters.h'
       REAL     INPUT
       Character*70  FileASCII,Line,FileCatalog
C...................................................................
C			Read data and open files
       WRITE (*,'(A,$)') ' Enter Output File Name = '
      READ  (*,'(A)') FileASCII
      OPEN(17,FILE=FileASCII,STATUS='UNKNOWN')
       WRITE (*,'(A,$)') ' Enter File Name for Input Halo Catalog = '
      READ  (*,'(A)') FileCatalog
      OPEN(18,FILE=FileCatalog,STATUS='UNKNOWN')
      CALL RDTAPE
      CALL SetWeight
      write (*,*) ' RDTAPE is done'
      WRITE (17,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
100   FORMAT(1X,'Header=>',A45,/
     +            1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I6,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,
     +            1x,' Omega_curvature=',F7.3,/
     +            1x,'   Npart   Euler Coordinates (Mpc/h)',
     +                 '      Velocities (km/s)',
     +                 '    Lagrangian Coords (limits: 1-N_1d)')
      If(extras(100).gt.0.)Then
         Box =extras(100)
         write(*,*) '  Box size =',Box,' Mpc/h'
      Else
         Box  =INPUT(' Enter box size in comoving Mpc/h =')
      EndIf

      IF(Nspecies.ne.1)Then
         write (*,*) '--- You can use this program only for runs with',
     &     ' one specie of particles at the lowest mass resolution.'
         write (*,*)' --- The number of species is ',Nspecies,' STOP'
         Stop
      Endif 
      BoxV    = Box*100.    ! Box size in km/s
      ScaleV = BoxV/AEXPN/NGRID  ! scale factor for Velocities
      ScaleC = Box/NGRID         ! scale factor for Coordinates
      Do i=1,17       ! skip header lines
         read(18,'(A)') Line
         write(*,'(A)') Line
      EndDo
 200  read(18,*,err=300,end=300) Xcentr,Ycentr,Zcentr,
     +                   Vvx0,Vvy0,Vvz0,Am,Radius,Vrms,Vcirc
c 200  read(18,*,err=300,end=300) Xcentr,Ycentr,Zcentr,
c     +                   Am,Vcir,Radius
         Radius =Radius/1000.  ! Scale radius to Mpc/h
         rad2   = Radius**2
         xxmax  =-1.e+9
         xxmin  = 1.e+9
         vmax   =-1.e+9
         vmin   = 1.e+9
         xrand  =0.
         Icount =0
         ifile  =1

            N_particles =lspecies(Nspecies)   ! Total number of particles
            Npages = (N_particles -1)/NPAGE +1
            N_in_last=N_particles -NPAGE*(Npages-1)
            N_line=INT((lspecies(1))**0.33333+0.5)
            N2          =N_line**2
      write (*,*) ' Pages=',Npages,' Species=',Nspecies
      write (*,*) ' Nparticles=',N_particles,' N_in_last=',N_in_last
      write (*,*) ' Particles_1d=',N_line


      DO  IROW=1, Npages         ! Loop over particle pages
            In_page =NPAGE
            If(IROW.eq.Npages)In_page =N_in_last
c            write (*,*)' Move page=',IROW,' file=',ifile,' N=',In_page
            iL = NPAGE*(IROW-1)
         CALL GETROW(IROW,ifile) ! read in a page of particles
	    DO  IN=1, In_page          ! Loop over particles
	        X  =ScaleC* (XPAR(IN)-1.)         ! scale coordinates
	        Y  =ScaleC* (YPAR(IN)-1.)
	        Z  =ScaleC* (ZPAR(IN)-1.)
                                                                     ! periodical conditions
              dX =min(ABS(X-Xcentr),Box-ABS(X-Xcentr))
              dY =min(ABS(Y-Ycentr),Box-ABS(Y-Ycentr))
              dZ =min(ABS(Z-Zcentr),Box-ABS(Z-Zcentr))
              dd =dx**2 +dY**2 +dZ**2
              IF(dd.lt.rad2)Then                !  get the particle
                 Ipart =IN+iL                     ! current particle number
                WPAR =iWeight(Ipart)   ! particles weight
                 Vxs=ScaleV* VX(IN)                    ! scale velocities
                 Vys=ScaleV* VY(IN)
                 Vzs=ScaleV* VZ(IN)
                 Icount =Icount +1                          ! count particles
                 xxmax =MAX(xxmax,X,Y,Z)
                 xxmin =MIN(xxmin,X,Y,Z)
                 vmax =MAX(vmax,Vxs,Vys,Vzs)
                 vmin =MIN(vmin,Vxs,Vys,Vzs)
                                                                    ! find lagrangian coords
c                   Jpart =N_particles -Ipart+1 ! reverse the order of particles
                   Jpart =Ipart ! direct  order of particles
                    k1 =INT((Jpart-1)/N2)+1
                    jj   =Jpart-(k1-1)*N2
                    j1  =INT((jj-1)/N_line)+1
                    i1  =jj-(j1-1)*N_line
                   write (17,250) Ipart,X,Y,Z,Vxs,Vys,Vzs,i1,j1,k1
     &                                                  ! write to a file
              EndIf
 250          Format(i9,3F9.4,3F9.2,3i5,3i9)
        ENDDO 
      ENDDO
      write (*,*) ' Scaled Coordinates were written to:',
     &            FileASCII
      write (*,*) ' Number of particles          =',Icount
      write (*,*) ' Center: ', Xcentr,Ycentr,Zcentr,' R=',Radius
      write (*,*) ' Min/Max of coordinates(Mpc/h)=',xxmin,xxmax
      write (*,*) ' Min/Max of velocities (km/s) =',vmin,vmax

      goto 200      ! get next center
 300  write (*,*) ' <======= the End ========> '
      END

C-----------------------------------------------------
C                                Spectrum of perturbations: P(k), sigma_8,V(50h-1Mpc)  
C        Anatoly Klypin December 1997   
C 	                 <<<  CHDM 2 neutrino model  >>>    Holtzman    appoximation  
C-----------------------------------------------------
C                            Om   = Omega_0                Omc   = Omega_cdm_present
C                            Omb = Omega_baryon     Omnu =Omega_neutrino_present
C                            Ocurv = 0
C                            hsmall = H_0/100km/s/Mpc = the Hubble constant
C                            ns    = slope of the power spectum (ns=1 for Harr-Zeld)
C                            AEXPN = expansion parameter = 1/(1+z), z =redshift
C                            All calculations are done in real Mpc,
C                            Only final outputs are scaled to  h^{-1} 
C-----------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (hsmall=0.5, pi =3.14159265)
      COMMON / TRUNCOM/ Omb,Omc,Omhot,Par(18),AEXPN,Sn,ns
      COMMON / Coeff/   deltac22,deltac,rf,Uklow,Ukup
      DIMENSION  Hms(5)
      DATA        Hms/3.d+10,1.d+11,3.d+11,2.d+12,1.d+15/
      REAL*8      INTG,ns,Nhalos1,Nhalos2,Nhalos3
      Character     Name*16,Answer*1,Header*45,StartFile*16
      REAL*8      INPUT
      EXTERNAL   PS,P,Ptophat,Pgauss,Vtophat,dxi,P2cold,
     .             Vpairwise
      DATA        StartFile/'InStart.dat'/ 
C                                                     Constants
      write (*,'(" Enter Quadrupole in muK and slope n =",$)')
      read  (*,*) Q2,ns
      RH    =6.e+3/hsmall    ! radius of the horizon
      H     =100.*hsmall     ! Hubble constant
c                 A     =1.2*(pi*Q2*1.d-6/2.726*RH**2)**2 ! normalization for n=1
      Q     =Q2*1.e-6/2.726       ! gives Q2 in DT/T
      A     =Q**2*(4.*pi)/5./fact(ns,2)*RH**(ns+3.) ! = amplitude
      Sn    =A/(2.*pi**2)
      AEXPN =1.
      AEXP  =AEXPN
c                                                                             Cosmological model      
      write (*,*) '================< Enter Output File Name'
      read  (*,'(A)') Name
      write (*,*)     Name
      OPEN(1,file=Name)
      OPEN(2,file='chdm.fit')
      Call MODEL
      Om      =1.0
      deltac  =INPUT(' Enter delta_c (gaussian filter) =')
      deltac22=deltac**2/2.
c                                             bias parameter      
      rf      =8./hsmall
      Sigma8  = sqrt(Sn*(
     .          INTG(Ptophat,1.d-4,1.d-2)+
     .          INTG(Ptophat,1.d-2,2.d-1)+
     .          INTG(Ptophat,2.d-1,2.d+1)))      
      write (*,10) deltac,Q2,hsmall,Sigma8,Sn,ns,RH
      write (1,10) deltac,Q2,hsmall,Sigma8,Sn,ns,RH
 10   Format(' Press-Schecter approximation for delta_c=',f8.3,/
     .       ' Q2=',f7.3,' Hubble=',f7.3,' Sigma_8 =',G11.3,/
     .       ' normalization constant=',G11.3,' n=',f7.2,
     .       ' Horizon=',G11.3)
      rf =50./hsmall
      Veloc = H*sqrt(Sn*(
     .          INTG(Vtophat,1.d-4,1.d-2)+
     .          INTG(Vtophat,1.d-2,2.d-1)+
     .          INTG(Vtophat,2.d-1,2.d+1)))      
      write (*,30) Veloc,rf*hsmall
      write (1,30) Veloc,rf*hsmall
 30   Format(' Bulk Velocity =',F8.2,' for top-hat radius=',f8.1,
     .        ' Mpc/h')

      write (1,*) ' k/h      Pk*h^3(z=0) Pk(z=30) Power Spectrum'
      DO i=1,110
        z=0.
        AEXPN=1./(1.+z)
        w =1.e-4*10.**(i/20.)
        Pk0  =P(w)*Sn*hsmall**3*(2.*pi**2)
        AEXPN=0.03226
        Pk1  =P(w)*Sn*hsmall**3*(2.*pi**2) ! /AEXPN**2
        write (1,14) w/hsmall,Pk0,Pk1
      EndDo
 14   Format(G11.3,5G12.4)
c                                                     
      write (*,'(" Enter Box(Mpc/h) and N particles =>",$)')
      read  (*,*) Box, NROW
      Box   = Box/hsmall     ! scale to real Mpc
      Uklow =2.*pi/Box
      Ukup  =2.*pi/Box*(NROW/2.)
      write (1,12) Box*hsmall,NROW, Uklow,Ukup
 12   Format(' Box=',f7.1,' Nparticles=',i4,' Klimits=',2f8.3)
         z=30.
         AEXPN=1./(1.+z)
         sigBox =sqrt(Sn*INTG(P2cold,Uklow/sqrt(2.),Ukup))
         write (*,*)' Amplitude of fluctuations in Box: sigma_cold=',
     &                 sigBox
         write (*,76)
         write (1,76)
 76   Format('   z      ',3(2x,'Mass    n(>Mass)',4x),
     .       'All for h=1')
      DO i=0,20
         z       =i/4.
         AEXPN   =1/(1+z)
         HaloM   =Hms(2)
         Nhalos1 =PreSch(HaloM,z,r,hsmall)
         HaloM   =Hms(3)
         Nhalos2 =PreSch(HaloM,z,r,hsmall)
         HaloM   =Hms(4)
         Nhalos3 =PreSch(HaloM,z,r,hsmall)
         WRITE(*,77) z,Hms(2)*hsmall,Nhalos1,
     .                  Hms(3)*hsmall,Nhalos2,
     .                  Hms(4)*hsmall,Nhalos3 
         WRITE(1,77) z,Hms(2)*hsmall,Nhalos1,
     .                  Hms(3)*hsmall,Nhalos2,
     .                  Hms(4)*hsmall,Nhalos3 
 77      Format(f8.2,3(2G11.3))
      ENDDO
C............................................................................................      
      WRITE (*,'(A,$)') ' Do you need a file to run PMstart (Yes/No) '
      READ  (*,'(a)') Answer
      IF(Answer.eq.'Y'.or.Answer.eq.'y')Then ! prepare input file
         OPEN(30,file=StartFile)        !  parameters of a run
         HEADER='N=128x256 L=20h-1CDMsig=0.239 z=30-----------'
         write (*,*) '------ Enter Header up to 45 characters'
         write (*,*) '       Example:'
         write (*,'(A)')  HEADER 
         read  (*,'(A)')  HEADER
         write (30,'(A)') HEADER
         ASTEP =INPUT(' Step of the expansion parameter  =')
         write (30,*) ASTEP,'    Step in dAEXPN    '
         write (30,*) sigBox,'    DRho/rho in box of CDM '
         write (30,*) ns,   '    Slope of P(k)     '
         write (30,*) Box*hsmall,'    Box in  Mpc/h   '
         Nseed =INPUT(' Enter random seed integer 1-2^31 =')
         write (30,*) Nseed,'    Random seed       '
         Nspecies =INPUT(' Enter number of neutrino/cdm_part =')
         write (30,*) Nspecies,'  number of neutrino/cdm_part'
         write (*,*) ' Results were written to file: ',StartFile
         CLOSE (30)
      ENDIF

 90     STOP
	END

C--------------------------------------------- Press-Schecter n(>M,z)
C               gives N(>M) normalized for h=1.
C               M =HaloM is for hsmall (not scaled to h=1) INPUT
C               r is the filter size (not scaled to h=1)   OUTPUT
C               Upper limit for integral is at the radius
C               where the contribution to N(>M) is 10^-8 of
c               that at the low limit r        
      REAL*8 FUNCTION PreSch(HaloM,z,r,hsmall)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (pi=3.14159265d+0)
      COMMON / TRUNCOM/ Omb,Omc,Omhot,Par(18),AEXPN,Sn,ns
      COMMON / Coeff/   deltac22,deltac,rf,Uklow,Ukup
      REAL*8      INTG
      Real*8 ns
      EXTERNAL PS
         r=6.12d-5*HaloM**0.333333/hsmall**0.6667 ! radius of filter
         AEXPN=1./(1.+z)
c                                       find limits of integration         
         p0 =PS(r)
         rup=r*25.
         ruplim=rup
         ind=0
         Do j=1,30
            If(rup.gt.r)Then
            p1 =PS(rup)
            If(p1.gt.1.d-9*p0.and.ind.eq.0)Then
               ind =1
               ruplim=rup
            EndIf
            rup =rup/1.1
            EndIf
         EndDo
         S =INTG(PS,r,ruplim)
         PreSch =deltac/(2.*pi**2)*S/hsmall**3      
      RETURN
      END
C--------------------------------------------- Contribution to PS
      REAL*8 FUNCTION PS(r)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / TRUNCOM/ Omb,Omc,Omhot,Par(18),AEXPN,Sn,ns
      COMMON / Coeff/   deltac22,deltac,rf,Uklow,Ukup
      REAL*8              INTG1, ns 
      EXTERNAL P4gauss,Pgauss
         rf     =r
         Uplimit=MIN(6.0d0/rf,40.0D+0) !  upper limit for integrals
         Uplimit=MIN(Uplimit,Ukup)
         sigma2 =Sn*INTG1(Pgauss,Uklow,Uplimit)
         sigma  =sqrt(sigma2)
         epsilon=Sn*INTG1(P4gauss,Uklow,Uplimit)/sigma2
         PS=epsilon*EXP(-deltac22/sigma2)/sigma/rf**2
      RETURN
      END
c-----------------------------------  Pcold(k)*k^2
      REAL*8 FUNCTION P2cold(WK)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / TRUNCOM/ Omb,Omc,Omhot,Par(18),AEXPN,Sn,ns
      COMMON / Coeff/   deltac22,deltac,rf,Uklow,Ukup
      Real*8 ns
        P2cold=WK**2*Pcold(WK)*AEXPN**2
      RETURN
      END
c-----------------------------------  P(k)*k^2*gauss(rf)
      REAL*8 FUNCTION Pgauss(WK)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / TRUNCOM/ Omb,Omc,Omhot,Par(18),AEXPN,Sn,ns
      COMMON / Coeff/   deltac22,deltac,rf,Uklow,Ukup
      Real*8               ns
        Pgauss=WK**2*P(WK)*EXP(-(rf*WK)**2)
      RETURN
      END
c-----------------------------------  P(k)*k^4*gauss(rf)
      REAL*8 FUNCTION P4gauss(WK)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / TRUNCOM/ Omb,Omc,Omhot,Par(18),AEXPN,Sn,ns
      COMMON / Coeff/   deltac22,deltac,rf,Uklow,Ukup
      Real*8               ns
        P4gauss=WK**4*P(WK)*EXP(-(rf*WK)**2)
      RETURN
      END
C-------------------------------------- P*k^2*Top-Hat Filter
      REAL*8 FUNCTION Ptophat(wk)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / TRUNCOM/ Omb,Omc,Omhot,Par(18),AEXPN,Sn,ns
      COMMON / Coeff/   deltac22,deltac,rf,Uklow,Ukup
      Real*8               ns
	     IF (wk.lt.1.d-4) THEN
            Ptophat =wk**ns*wk**2
        ELSE
            X=wk*rf
	         TOPHAT=( (SIN(X)-x*COS(X))*3./X**3 )**2
            Ptophat=P(wk)*wk**2*TOPHAT
        ENDIF
      RETURN
      END
C-------------------------------------- P*Top-Hat Filter
      REAL*8 FUNCTION Vtophat(wk)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / TRUNCOM/ Omb,Omc,Omhot,Par(18),AEXPN,Sn,ns
      COMMON / Coeff/   deltac22,deltac,rf,Uklow,Ukup
      Real*8               ns
	     IF (wk.lt.1.d-4) THEN
            Vtophat =wk**ns
        ELSE
            X=wk*rf
	         TOPHAT=( (SIN(X)-x*COS(X))*3./X**3 )**2
            Vtophat=P(wk)*TOPHAT
        ENDIF
      RETURN
      END

C________________________________________Read parameters of the model
      SUBROUTINE MODEL
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / TRUNCOM/ Omb,Omcold,Omhot,Par(18),AEXPN,Sn,ns
      DIMENSION          ParC(11),ParH(7)
      Real*8               ns
      character*80          a
      Equivalence (ParC(1),Par(1)),(ParH(1),Par(12))

      Do i=1,1                   ! read the header
         Read (2,'(A)') a
      EndDo
      Read (2,*) Om,Omb,Omc,Omnu,h,ParC,ParH
      Omhot  =Omnu
      Omcold =1. -Omhot
      Write (*,20)Omb,Omc,Omnu,h,Par
      Write (1,20)Omb,Omc,Omnu,h,Par
 20   Format(' Model: O_b=',F5.2,' O_cold=',F5.2,' O_nu=',F5.2,
     .       ' h=',F5.2,/(7G11.3))
      Return
      End
C--------------------------:  Power spectrum CHDM cold + hot
      REAL*8 FUNCTION P(wk)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / TRUNCOM/ Omb,Omc,Omhot,Par(18),AEXPN,Sn,ns
      Real*8               ns
         P =(AEXPN*(Omc*Sqrt(Pcold(wk)) +Omhot*Sqrt(Phot(wk))))**2         
      Return
      End
C--------------------------:  Power spectrum CHDM cold
      REAL*8 FUNCTION Pcold(wk)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / TRUNCOM/ Omb,Omc,Omhot,Par(18),AEXPN,Sn,ns
      Real*8               ns
      DIMENSION          PP(6)
      DATA   PP/1.,-1.464,19.81,154.5,143.6,0.961/

      If(AEXPN.GT.0.035)THEN
       x =AEXPN**Par(10)
       sk=wk**0.33333 
       Pcold = LOG(1.+Par(1)*x*wk) / (Par(1)*x) /
     .         (1.+sk*(Par(18)
     .            +sk*(Par(2)*(1.+Par(3)*x)
     .            +sk*(Par(4)*(1.+Par(5)*x)
     .            +sk*(Par(6)*(1.+Par(7)*x)
     .            +sk*(Par(8)*(1.+Par(9)*x**2) ))))) )**2
      Else                      ! z=30
         sk =sqrt(wk)
         Pcold=wk/
     .        (1.+sk*(PP(2) +sk*(PP(3) +sk*(PP(4)
     .           +sk*PP(5) ))))**(2.*PP(6))
      EndIf
       Pcold =Pcold*wk**(ns-1.)
      RETURN
      END
C----------------------Neutrino:   Cold * correction factor=hot
      REAL*8 FUNCTION Phot(WK)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / TRUNCOM/ Omb,Omc,Omhot,Par(18),AEXPN,Sn,ns
      Real*8               ns
      DIMENSION          PP(6)
      DATA PP/1.442,-0.651,4.03,1.553,-35.50,141.7/

      If(AEXPN.GT.0.035)THEN
         sk =sqrt(wk)
        y  =(wk*AEXPN**Par(17))**0.3333
      Phot =  Pcold(WK)  * 
     .                 exp(-Par(12)*y**2)
     .                /(1.+   y*(Par(13)+y*
     .                          (Par(14)+y*
     .                          (Par(15)+y*Par(16) ))))
      Else                      ! z=30
           sk =(wk)**0.333
         Phot =  Pcold(wk)  * 
     .                    exp(-PP(1)*wk)
     .                   /(1.+sk*(PP(2) +sk*(PP(3)
     .                       +sk*(PP(4) +sk*(PP(5) 
     .                       +sk*PP(6)    )))))
      EndIf
      Phot =ABS(Phot)
      RETURN
      END
C-------------------------------------------- Simpson integration
      REAL*8 FUNCTION INTG(FUNC,A,B)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (EPS=2.0d-4, JMAX=20)
      EXTERNAL FUNC
      OST=-1.E30
      OS= -1.E30
      ST =0.
      DO 11 J=1,JMAX
        CALL TRAPZD(FUNC,A,B,ST,J)
        INTG=(4.0d0*ST-OST)/3.0d0
        IF (ABS(INTG-OS).Le.EPS*ABS(OS).and.J.GT.6) RETURN
        OS=INTG
        OST=ST
11    CONTINUE
      WRITE (1,*)'Integration did not converge'
      RETURN
      END
C----------------------------------------------
      SUBROUTINE TRAPZD(FUNCC,A,B,S,N)
	   IMPLICIT REAL*8 (A-H,O-Z)
        SAVE IT
        EXTERNAL FUNCC
      IF (N.EQ.1) THEN
        S=0.5d0*(B-A)*(FUNCC(A)+FUNCC(B))
        IT=1
      ELSE
        TNM=IT
        DEL=(B-A)/TNM
        X=A+0.5D0*DEL
        SUM=0.0D0
        DO 11 J=1,IT
          SUM=SUM+FUNCC(X)
          X=X+DEL
11      CONTINUE
        S=0.5D0*(S+(B-A)*SUM/TNM)
        IT=2*IT
      ENDIF
      RETURN
      END

C-------------------------------------------- Simpson integration
      REAL*8 FUNCTION INTG1(FUNC,A,B)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (EPS=2.0d-4, JMAX=17)
      OST=-1.d30
      OS= -1.d30
      ST =0.
      DO 11 J=1,JMAX
        CALL TRAPZD1(FUNC,A,B,ST,J)
        INTG1=(4.0D0*ST-OST)/3.0D0
        IF (ABS(INTG1-OS).Le.EPS*ABS(OS)) RETURN
        OS=INTG1
        OST=ST
11    CONTINUE
      WRITE (1,*)'Integration did not converge'
      RETURN
      END
C----------------------------------------------
      SUBROUTINE TRAPZD1(FUNCC,A,B,S,N)
	   IMPLICIT Real*8 (A-H,O-Z)
        SAVE IT
        EXTERNAL FUNCC
      IF (N.EQ.1) THEN
        S=0.5D0*(B-A)*(FUNCC(A)+FUNCC(B))
        IT=1
      ELSE
        TNM=IT
        DEL=(B-A)/TNM
        X=A+0.5D0*DEL
        SUM=0.0D0
        DO 11 J=1,IT
          SUM=SUM+FUNCC(X)
          X=X+DEL
11      CONTINUE
        S=0.5D0*(S+(B-A)*SUM/TNM)
        IT=2*IT
      ENDIF
      RETURN
      END

C------------------------------  Gamma Function
c                  two expansions: |x|<1 and |x|>1
c                  for x<0 : G(x)G(-x)=-pi/(xsin(pi*x))
      
      REAL*8 Function gamma(x)
      IMPLICIT REAL*8 (A-H,O-Z)
      DATA pi,c1,c3,c5,c7,c9/3.14159265d+0,0.422784335d+0,
     .        0.067352301d+0,7.385551d-3,1.192754d-3,2.23155d-4/ 

      If(x.lt.0.)Then
         isign =-1
         x= -x
      Else
         isign =1
      EndIf
      z=x-1.
        If(z.lt.0.9999d+0)Then
           z2=z*z
           pz=pi*z
           If(abs(z).lt.1.d-4)Then
              p2 =pz*pz
              ratio=1./(1.-p2/6.*(1.-p2/20.*(1.-p2/42.)))
           Else
              ratio=pz/sin(pz)
           EndIf
           gamma= sqrt(ratio*(1.-z)/(1.+z))*
     .            exp(z*(c1-z2*(c3+z2*(c5+z2*(c7+z2*c9)))))
        Else
           z2 =x*x
           gamma=sqrt(2.*pi/x)/exp(x)*(x**x)*
     .      exp((1.-
     .        (1./30.-
     .          (1./105.-
     .            (1./140.-(1./99.-(691./30030.-1./13./4./z2)/z2)/z2)
     .            /z2)
     .          /z2)
     .        /z2)/x/12.)
        EndIf
        If(isign.eq.-1) Then
           gamma =-pi/(x*sin(pi*x)*gamma)
           x=-x
        EndIf
        
        Return
        End
C------------------------------------            exact factor
      REAL*8 Function fact(n,l)
      IMPLICIT REAL*8 (A-H,O-Z)
      Real*8 n
         eps =(n-1.)/2.
         fact =gamma(3.-n)*gamma(l+eps)/
     .          (2.**(1.-n)*gamma(1.5-eps)**2*gamma(l+2-eps))
      Return
      End
C---------------------------------     Delt^2/k*sin(kr)/kr
      REAL*8 FUNCTION dxi(x)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / Coeff/   deltac22,deltac,rf,Uklow,Ukup
       dxi =x**2*P(x)*sin(x*rf)/(x*rf)
      Return
      End
C---------------------------------- Read in variables      
      REAL*8 FUNCTION INPUT(text)
C-----------------------------------------
      Character text*(*)
          write (*,'(A,$)')text
          read (*,*) x
          INPUT =x
      Return
      End

c-----------------------
c                           read density. produce projection file for sm
c
      PARAMETER (N=64)
      Dimension dens(N,N,N)
      Dimension pr(N,N)

      open(1,file='dens_cr.dat')
      open(2,file='pr.dat')


      read (1,*) dens
      Do i=1,N
         i1 =i-1
         if(i1.lt.1)i1=i1+N
         i2 =i+1
         if(i2.gt.N)i2=i2-N
      Do j=1,N
         j1 =j-1
         if(j1.lt.1)j1=j1+N
         j2 =j+1
         if(j2.gt.N)j2=j2-N
          s=0.
      Do k = (32-8),(32)
          k1 =k-1
         if(k1.lt.1)k1=k1+N
         k2 =k+1
         if(k2.gt.N)k2=k2-N
        
         s = s+dens(i,j,k)+dens(i1,j,k)+dens(i2,j,k)+
     &                              dens(i,j1,k)+dens(i,j2,k)+
     &                              dens(i,j,k1)+dens(i,j,k2)
      EndDo
c      if(i.eq.1)s=1000.
         write(2,*) i, j, s/7.
         EndDo
         EndDo


         stop
         end

C ______________________________	 Selects and Scales PM particles 
C		             December 1997         A. Klypin (aklypin@nmsu.edu) 
C		 Get a random fraction of particles from a parallelipiped:
C            Xmin < x < Xmax, Ymin < y < Ymax, Zmin < z < Zmax
C          Scales internal PM coordinates and velocities 
C          to  coordinates in Mpc/h and km/s
C          In PM the coordinates are in the range 1 - (NGRID+1)
C                     velocities are P = a_expansion*V_pec/(x_0H_0)
C                     where     x_0 = comoving cell_size=Box/Ngrid
C                                    H_0 = Hubble at z=0
C                   
C	     NROW = number of particles in 1D
C	     NGRID= number of cells        in 1D
       INCLUDE 'PMparameters.h'
       REAL     INPUT
       Character*50  FileASCII
       Logical    Inside

C...................................................................
C			Read data and open files
       WRITE (*,'(A,$)') 'Enter File Name for new file = '
      READ  (*,'(A)') FileASCII
      OPEN(17,FILE=FileASCII,STATUS='UNKNOWN',FORM='UNFORMATTED')
      CALL RDTAPE
      write (*,*) ' RDTAPE is done'
      WRITE (17) 
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
100   FORMAT(1X,'Header=>',A45,/
     +            1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I6,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3)
      Box  =INPUT(' Enter box size in comoving Mpc/h =')
      write (*,*)
     +     ' Enter Limits for box (XYZ_min/max)',
     +     ' or Center and Radius (XYZ R 0 0)' 
      Xmin =INPUT('  X_min (Mpc/h)=')
      Xmax =INPUT(' X_max (Mpc/h)=')
      Ymin =INPUT(' Y_min (Mpc/h)=')
      Ymax =INPUT(' Y_max (Mpc/h)=')
      Zmin =INPUT(' Z_min (Mpc/h)=')
      Zmax =INPUT(' Z_max (Mpc/h)=')
      Fraction =INPUT(' Enter fraction of particles=')
      
      IF(ABS(Zmin-Zmax).lt.1.e-3)Then ! treat as coordinate of center +radius
         Radius =Ymax
         Xcentr  =Xmin
         Ycentr  =Xmax
         Zcentr   =Ymin
         Xmin     =Xcentr -Radius
         Xmax    =Xcentr +Radius
         Ymin     =Ycentr -Radius
         Ymax    =Ycentr +Radius
         Zmin     =Zcentr -Radius
         Zmax    =Zcentr +Radius
      Else
         Radius =0.
      EndIf
      BoxV    = Box*100.    ! Box size in km/s
      ScaleV = BoxV/AEXPN/NGRID  ! scale factor for Velocities
      ScaleC = Box/NGRID         ! scale factor for Coordinates
      Fraction =MAX(Min(Fraction,1.),0.)
      rad2      = Radius**2
      xxmax =-1.e+9
      xxmin = 1.e+9
      vmax  =-1.e+9
      vmin  = 1.e+9
      xrand=0.
      Icount =0
      Nseed =12071
      inside   = .true.
      DO ifile =1,Nspecies+1                         ! Loop over all files
       DO IROW=1,NROW                           ! Loop over all pages
c                   write (*,*) ' Read page=',IROW,' file=',ifile
	      CALL GETROW(IROW,ifile)
	      DO IN=1,NPAGE                           !Loop over particles
	        X  =ScaleC* (XPAR(IN)-1.)         ! scale coordinates
	        Y  =ScaleC* (YPAR(IN)-1.)
	        Z  =ScaleC* (ZPAR(IN)-1.)
           If(Z.gt.Zmin .and. Z.le.Zmax)Then    ! take particles only 
           If(Y.gt.Ymin .and. Y.le.Ymax)Then   ! inside the box
           If(X.gt.Xmin .and. X.le.Xmax)Then
              If(Radius.gt.0.)Then
                 dd =(X-Xcentr)**2+(Y-Ycentr)**2+(Z-Zcentr)**2
                 inside = dd.lt.rad2
              EndIf
              If(Fraction.lt.0.999)xrand =RANDd(Nseed) ! random fraction
              IF(inside.and.xrand.lt.Fraction)Then                !  get the particle
                 Vxs=ScaleV* VX(IN)                    ! scale velocities
                 Vys=ScaleV* VY(IN)
                 Vzs=ScaleV* VZ(IN)
                 Icount =Icount +1                          ! count particles
                 xxmax =MAX(xxmax,X,Y,Z)
                 xxmin =MIN(xxmin,X,Y,Z)
                 vmax =MAX(vmax,Vxs,Vys,Vzs)
                 vmin =MIN(vmin,Vxs,Vys,Vzs)
c                 write (17,200) IN,X,Y,Z,Vxs,Vys,Vzs  ! write to a file
                  write (17) XPAR(IN),YPAR(IN),ZPAR(IN), ! write to a file
     &                VX(IN),VY(IN),VZ(IN)

              EndIf
 200          Format(i8,3F9.4,3F9.2)
           EndIf
           EndIf
           EndIf
	      ENDDO
        ENDDO 
      ENDDO

      write (*,*) ' Scaled Coordinates were written to:',
     &            FileASCII
      write (*,*) ' Number of particles          =',Icount,
     &               ' Fraction=',Fraction
      write (*,*) ' Limits:', Xmin,Xmax
      write (*,*) '        ', Ymin,Ymax              
      write (*,*) '        ', Zmin,Zmax
      write (*,*) ' Min/Max of coordinates(Mpc/h)=',xxmin,xxmax
      write (*,*) ' Min/Max of velocities (km/s) =',vmin,vmax

      END

c-------------------------------------------------------------------- 
c                                   Satellites in N-body simulations
c                                   Make dV-dR diagram
c-------------------------------------------------------------------- 
      include 'satellites.h' 
      INTEGER   listfiles(4)
      DATA dR/10.d0/            ! Mpc/h: width of buffer for volume replication
      DATA listfiles/2,30,31,32/
c      Open(1,file='hlist_0.9996.20.dat')
c      Open(1,file='CatshortA.DAT')
      Open(1,file='CatFit.dat')
      Open(2,file='resultsAllClout.500.dat')
      Open(30,file='isoV180dx.dat')
      Open(31,file='isoV180dy.dat')
      Open(32,file='isoV180dz.dat')
      Open(4,file='sample2.dat')
      Open(10,file='part1.000.dat',form='unformatted')
c      Open(10,file='partL.9996.dat',form='unformatted')
c      Open(10,file='part10.dat')
 

      Do i=1,4
      write (listfiles(i),'(T10,"Hubble=",f8.2,T25,"Box=",f8.2,"Mpc/h",
     &             /T10,"Selection: Mass limit=",g11.3,"Msun/h",
     &              T55,"Vc limit=",f8.2,"km/s",
     &              T77,"width of buffer=",f8.2,"Mpc/h",
     &             /T10,"Isolation: Radii=",f8.1,"kpc/h ",f8.2,"Mpc/h",
     &             T55,"los Velocity= ",f8.3,"km/s",
     &            /T10,"Clusters: Vcirc >",f8.1,"km/s  Remove halos if",
     &             " distance <=",f8.2,"Mpc/h")')
     &               hubble,Box, aMasslimit,Vclimit,
     &               dR,Radlimit,RadLmax,Vlimit,Vcl,Dcl
      EndDo 
      Lines =22
      Do i=1,Lines
         read(1,'(A)')Line
         Do j=1,4
            if(i.le.4)write(listfiles(j),*)Line
         ENDDO 
      EndDo 

      Nh = 1
 10   read(1,*,end=100,err=100)xc(Nh),yc(Nh),zc(Nh),
     &                    vxc(Nh),vyc(Nh),vzc(Nh),aMass(Nh),
     &                    vvv,vc(Nh)
      if(vc(Nh).lt.Vclimit)goto 10  ! do not take halo if too small
      if(Nh.ge.Nmax)goto100
      Nh =Nh +1
      goto 10

 100  Nh =Nh -1
      write (2,'("  Number of halos read=",T30,i8)')Nh
      write (*,*)  '<====== Number of halos read=',Nh
      write (*,30)  (i,xc(i),yc(i),zc(i),aMass(i),vc(i),i=1,1)
      write (*,30)  (i,xc(i),yc(i),zc(i),aMass(i),vc(i),i=Nh,Nh)
 30   format(' halo=',i8,' x=',3g11.3,' M=',g11.3,' Vc=',g11.3)

      CALL ReadParticles(dR)
      CALL ExpandSample(dR)
      CALL ListClusters
      Vc1 =450.
      Vc2 =550.
      CALL Isolated3D(Vc1,Vc2,Nx,Ny,Nz)
c      CALL Satellites
c      CALL OutSatellites(Nx,Ny,Nz)
      CALL SatellitesP

      stop
      end
c-------------------------------------------------------------------- 
c                      read particlesNx,Ny,Nz and
c                      replicate in buffer of width dR Mpc
      SUBROUTINE ReadParticles(dR)
c-------------------------------------------------------------------- 
      include 'satellites.h' 
      Logical inx,iny,inz

      Lines =1
      Do i=1,Lines
c         read(10,'(A)')Line
         read(10)AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW
c     +                  EKIN,
c     +                  NROWC,NGRID,NRECL,Om0,Oml0,hub,
c     +                  Ocurv
         write(*,*)' a=',AEXPN,' dA=',ASTEP,' i=',ISTEP
c         if(i.le.4)write(2,*)' a=',AEXPN,' dA=',ASTEP,' i=',ISTEP
c         if(i.le.4)write(3,*)' a=',AEXPN,' dA=',ASTEP,' i=',ISTEP
      EndDo 

      Np = 1
c 10   read(10,*,end=100,err=100)xp(Np),yp(Np),zp(Np),
  10   read(10,end=100,err=100)xp(Np),yp(Np),zp(Np),
     &                    vxp(Np),vyp(Np),vzp(Np)
      if(Np.ge.Nmaxp)goto100
      Np =Np +1
      goto 10

 100  Np =Np -1
      NpBox = Np
      write (2,'("  Number of particles read=",T30,i8)')  Np
      write (*,*)  '<====== Number of particles read=',Np
      write (*,30)  (i,xp(i),yp(i),zp(i),i=1,2)
      write (*,30)  (i,xp(i),yp(i),zp(i),i=Np-3,Np)
 30   format(' particle=',i8,' x=',3g11.3)

c                              now relpicate periodically

      Xleft =-dR             ! new boundaries for the catalog
      Xright =Box+dR
      Yleft =-dR
      Yright =Box+dR
      Zleft =-dR
      Zright =Box+dR
      write (*,*)  Xleft ,Xright
      Ne = Np

      Do ip =1,Np    ! go over all particles
         x =xp(ip)
         y =yp(ip)
         z =zp(ip)

      Do k=-1,1       ! go over all 27 periodical images
         dz = k*Box
         inz =(z+dz.gt.Zleft.and.z+dz.lt.Zright)
         Do j=-1,1
           dy = j*Box
           iny =(y+dy.gt.Yleft.and.y+dy.lt.Yright)
           Do i=-1,1
               dx =i*Box
               If(i**2+j**2+k**2.ne.0)Then
                  inx =(x+dx.gt.Xleft.and.x+dx.lt.Xright)
                  If(inx.and.iny.and.inz)Then  ! add this halo to the list
                     Ne =Ne +1
                     if(Ne.gt.Nmaxp) STOP 'too many particles'
                     xp(Ne) =x+dx
                     yp(Ne) =y+dy
                     zp(Ne) =z+dz
                     vxp(Ne) =vxp(ip)
                     vyp(Ne) =vyp(ip)
                     vzp(Ne) =vzp(ip)
                  EndIf               ! end inside box
               EndIf                  ! end exclude central box

            EndDo       ! end i
          EndDo       ! end j
        EndDo       ! end k
      EndDo         ! end ip
      write (*,*) 'Nparticles in extended sample=',Ne  
      write (2,'("  Npart in extended sample=",T30,i8)')Ne  
      Np =Ne     ! Np is the number of particles in extened set

      RETURN
      END
c-------------------------------------------------------------------- 
c                        make sample larger by replicating
c                        some halos using periodical
c                        boundary conditions
c          dR is the width of the buffer in Mpc/h
c          Next = new number of halos
      SUBROUTINE ExpandSample(dR)
c-------------------------------------------------------------------- 
      include 'satellites.h' 
      Logical inx,iny,inz

      Xleft =-dR             ! new boundaries for the catalog
      Xright =Box+dR
      Yleft =-dR
      Yright =Box+dR
      Zleft =-dR
      Zright =Box+dR
      write (*,*)  Xleft ,Xright
      Next = Nh

      Do ip =1,Nh    ! go over all halos
         x =xc(ip)
         y =yc(ip)
         z =zc(ip)

      Do k=-1,1       ! go over all 27 periodical images
         dz = k*Box
         inz =(z+dz.gt.Zleft.and.z+dz.lt.Zright)
         Do j=-1,1
           dy = j*Box
           iny =(y+dy.gt.Yleft.and.y+dy.lt.Yright)
           Do i=-1,1
               dx =i*Box
               If(i**2+j**2+k**2.ne.0)Then
                  inx =(x+dx.gt.Xleft.and.x+dx.lt.Xright)
                  If(inx.and.iny.and.inz)Then  ! add this halo to the list
                     Next =Next +1
                     if(Next.gt.Nmax) STOP 'too many halos'
                     xc(Next) =x+dx
                     yc(Next) =y+dy
                     zc(Next) =z+dz
                     vxc(Next) =vxc(ip)
                     vyc(Next) =vyc(ip)
                     vzc(Next) =vzc(ip)
                     aMass(Next) =aMass(ip)
                     vc(Next)        =vc(ip)
                  EndIf               ! end inside box
               EndIf                  ! end exclude central box

            EndDo       ! end i
          EndDo       ! end j
        EndDo       ! end k
      EndDo         ! end ip
      write (*,*) ' Nhalos in extended sample=',Next  
      write (2,'("  Nhalos in extended sample=",T30,i8)')Next  
      RETURN 
      END
c-------------------------------------------------------------------- 
c                  find 'clusters': halos with large Vcirc
c
      SUBROUTINE ListClusters
c-------------------------------------------------------------------- 
      include 'satellites.h' 
      Logical inx,iny,inz

      Nclusters  = 0
      Do ip =1,Next               ! look for clusters in extended halo list
         If(vc(ip).gt.Vcl)Then
            Nclusters = Nclusters + 1
            ListCl(Nclusters) = ip
       EndIf 
      EndDo 
      write (*,'(" N clusters=",i6," with Vc >=",2f8.3)')Nclusters,Vcl

      RETURN 
      End

c-------------------------------------------------------------------- 
c                  select isolated halos
c                  range of circular velocities Vc1<Vc< Vc2
c                  do it in 3D, not in projection
c                  Lox,y,z = 1 if halo is isolated
c                  Nx,Ny,Nz = number of isolated halos in each direction
      SUBROUTINE Isolated3D(Vc1,Vc2,Nx,Ny,Nz)
c-------------------------------------------------------------------- 
      include 'satellites.h' 
      Logical inx,iny,inz

      Nx = 0
      Ny = 0
      Nz = 0
      R2     = (RadLmax)**2  ! square of max distance in Mpc
 
      Do ip =1,Nh            ! Isolation away from clusters
            vv =vc(ip)
         If(vv.gt.Vc1.and.vv.lt.Vc2)Then
            If(DistanceCluster(ip).gt.Dcl)Then
              Lox(ip) =1
              Loy(ip) =1
              Loz(ip) =1
              Nx = Nx +1
           EndIf 
        Else
          Lox(ip) =0
          Loy(ip) =0
          Loz(ip) =0
       EndIf 
      EndDo 
      write(*,'(" NHalos=",i6," in Vc range=",2f8.3,"km/s")')Nx,Vc1,Vc2
      Nx =0
      Do ip =1,Nh              ! Test against other halos
         If(Lox(ip).eq.1)Then
            x =xc(ip)
            y =yc(ip)
            z =zc(ip)
            vv =vc(ip)
            aM =aMass(ip)
            Do jp =1,Next
               if(jp.ne.ip)Then
                                        ! distance
                  dd = (xc(jp)-x)**2+(yc(jp)-y)**2+(zc(jp)-z)**2
                 If(dd.lt.R2.and.vc(jp).gt.vv/Vratio)Lox(ip) =0
              EndIf                  ! jp=ip
            EndDo   ! jp loop
         EndIf         ! Lox(ip) =1
      EndDo      ! ip loop

      Do ip =1,Nh
         If(Lox(ip).eq.1)Nx =Nx+1
      EndDo
      write(*,'(" Nisolated=",3i7)') Nx
      write(2,'("  Nisolated halos =",T30,i4," Vc limits=",3f8.2)') 
     &             Nx,Vc1,Vc2

      RETURN 
      End
c-------------------------------------------------------------------- 
c                  select isolated halos
c                  range of circular velocities Vc1<Vc< Vc2
c                  do it in 3 projections: x y z
c                  Lox,y,z = 1 if halo is isolated
c                  Nx,Ny,Nz = number of isolated halos in each direction
      SUBROUTINE Isolated(Vc1,Vc2,Nx,Ny,Nz)
c-------------------------------------------------------------------- 
      include 'satellites.h' 
      Logical inx,iny,inz

      Nx = 0
      Ny = 0
      Nz = 0
      R2     = (RadLmax)**2  ! square of max distance in Mpc
 
      Do ip =1,Nh
            vv =vc(ip)
         If(vv.gt.Vc1.and.vv.lt.Vc2)Then
            If(DistanceCluster(ip).gt.Dcl)Then
              Lox(ip) =1
              Loy(ip) =1
              Loz(ip) =1
              Nx = Nx +1
           EndIf 
        Else
          Lox(ip) =0
          Loy(ip) =0
          Loz(ip) =0
       EndIf 
      EndDo 
      write(*,'(" NHalos=",i6," in Vc range=",2f8.3,"km/s")')Nx,Vc1,Vc2
      Nx =0
      Do ip =1,Nh
         If(Lox(ip).eq.1)Then
            x =xc(ip)
            y =yc(ip)
            z =zc(ip)
            vv =vc(ip)
            aM =aMass(ip)
            vx =vxc(ip)
            vy =vyc(ip)
            vz =vzc(ip)
            vlx =hubble*x+vx
            vly =hubble*y+vy
            vlz =hubble*z+vz
c            if(ip.eq.69)Then
c               write(*,*)' It is it: vv=',vv
c               write(*,*)' x=',x,y,z
c            EndIf 
            Do jp =1,Next
               if(jp.ne.ip)Then
                                        ! x - direction
                  dv =abs(vlx-hubble*xc(jp)-vxc(jp))
                 If(dv.lt.Vlimit)Then
                     dx2 = (yc(jp)-y)**2+(zc(jp)-z)**2
                     
                     if(dx2.lt.R2)Then
                       if(vc(jp).gt.vv/Vratio)Lox(ip) =0
                    EndIf            
c            if(ip.eq.69.and.jp.eq.10415)Then
c               write(*,*)' : vc=',vc(jp),sqrt(dx2),sqrt(R2)
c               write(*,*)' Lox(ip)=',Lox(ip)
c            EndIf 
                 EndIf           
                                        ! y - direction
                  dv =abs(vly-hubble*yc(jp)-vyc(jp))
                 If(dv.lt.Vlimit)Then
                     dy2 = (xc(jp)-x)**2+(zc(jp)-z)**2
                     if(dy2.lt.R2)Then
                       if(vc(jp).gt.vv/Vratio)Loy(ip) =0
                    EndIf        
                 EndIf           
                                        ! z - direction
                  dv =abs(vlz-hubble*zc(jp)-vzc(jp))
                 If(dv.lt.Vlimit)Then
                     dz2 = (xc(jp)-x)**2+(yc(jp)-y)**2
                     if(dz2.lt.R2)Then
                       if(vc(jp).gt.vv/Vratio)Loz(ip) =0
                    EndIf        
                 EndIf           

              EndIf                  ! jp=ip
            EndDo   ! jp loop
         EndIf         ! Lox(ip) =1
      EndDo      ! ip loop

      Do ip =1,Nh
         If(Lox(ip).eq.1)Nx =Nx+1
         If(Loy(ip).eq.1)Ny =Ny+1
         If(Loz(ip).eq.1)Nz =Nz+1
      EndDo
      write(*,'(" Nisolated=",3i7)') Nx,Ny,Nz
      write(2,'("  Nisolated halos =",T30,3i4," Vc limits=",3f8.2)') 
     &             Nx,Ny,Nz,Vc1,Vc2
      write(30,'("  N Halos=",i6," in Vc range=",2f8.3," km/s")')
     &    Nx,Vc1,Vc2
      write(31,'("  N Halos=",i6," in Vc range=",2f8.3," km/s")')
     &      Ny,Vc1,Vc2
      write(32,'("  N Halos=",i6," in Vc range=",2f8.3," km/s")')
     &    Nz,Vc1,Vc2
 
c      Do ip =1,Next
c         write(4,20) xc(ip),yc(ip),zc(ip),vc(ip),Lox(ip),Loy(ip),Loz(ip)
c 20      format(4g12.4,3i3)
c      EndDo

      RETURN 
      End


c-------------------------------------------------------------------- 
c                  Find satellites of isolated halos
c                  do it in 3 directions: x y z
c                  Lox,y,z = 1 if halos is isolated
      SUBROUTINE Satellites
c-------------------------------------------------------------------- 
      include 'satellites.h' 
      Logical inx,iny,inz

      Nx = 0
      Ny = 0
      Nz = 0
      R2     = (Radlimit/1000.)**2  ! square of max distance in Mpc
      write(3,*)' r_p(kpc) dv(km/s) Vcprime Vcsat  iprime   isat'
      Do ip =1,Nh                         ! x - direction
         If(Lox(ip).eq.1)Then
            x =xc(ip)
            y =yc(ip)
            z =zc(ip)
            vv =vc(ip)
            aM =aMass(ip)
            vx =vxc(ip)
            vlx =hubble*x+vx
            Do jp =1,Next
               if(jp.ne.ip)Then
                  dv =abs(vlx-hubble*xc(jp)-vxc(jp))
                  dx = abs(xc(jp)-x)
                 If(dv.lt.Vlimit.and.dx.lt.Box/2.)Then
                     dx2 = (yc(jp)-y)**2+(zc(jp)-z)**2
                     if(dx2.lt.R2.and.vc(jp).lt.vv/Vratio)Then
                        dd =sqrt(dx2 +(xc(jp)-x)**2)
c                        uv =(vx -vxc(jp))
                        uv =sqrt((vxc(ip)-vxc(jp))**2+
     &                  (vyc(ip) -vyc(jp))**2+(vzc(ip) -vzc(jp))**2)
 
c                    write(3,'(f8.2,f8.2,2f8.2,2f9.2,2i8,7f8.3)')
c     &                 1000.*sqrt(dx2)/(hubble/100.),dv,vv,vc(jp),
c     &                  1000.*dd,uv,ip,jp,
c     &                    x,y,z,xc(jp),yc(jp),zc(jp)
                     Nx = Nx +1
                    EndIf            
                 EndIf           
              EndIf                  ! jp=ip
            EndDo   ! jp loop
         EndIf         ! Lox(ip) =1
      EndDo      ! ip loop

      write (*,*)  ' Satellites in x-dir =',Nx
      write (2,*)  ' Satellites in x-dir =',Nx

      Do ip =1,Nh                         ! y - direction
         If(Loy(ip).eq.1)Then
            x =xc(ip)
            y =yc(ip)
            z =zc(ip)
            vv =vc(ip)
            aM =aMass(ip)
            vy =vyc(ip)
            vly =hubble*y+vy
            Do jp =1,Next
               if(jp.ne.ip)Then
                  dv =abs(vly-hubble*yc(jp)-vyc(jp))
                  dy = abs(yc(jp)-y)
                 If(dv.lt.Vlimit.and.dy.lt.Box/2.)Then
                     dy2 = (xc(jp)-x)**2+(zc(jp)-z)**2
                     if(dy2.lt.R2.and.vc(jp).lt.vv/Vratio)Then
                        dd =sqrt(dy2 +(yc(jp)-y)**2)
                        uv =sqrt((vxc(ip)-vxc(jp))**2+
     &                  (vyc(ip) -vyc(jp))**2+(vzc(ip) -vzc(jp))**2)
                     write(3,'(f8.2,f8.2,4f9.2,2i8,7f8.3))')
     &                 1000.*sqrt(dy2)/(hubble/100.),dv,vv,vc(jp),
     &                   1000.*dd,uv,ip,jp,
     &                    x,y,z,xc(jp),yc(jp),zc(jp)
                     Ny = Ny +1
                    EndIf            
                 EndIf           
              EndIf                  ! jp=ip
            EndDo   ! jp loop
         EndIf         ! Loy(ip) =1
      EndDo      ! ip loop

      write (*,*)  ' Satellites in y-dir =',Ny
      write (2,*)  ' Satellites in y-dir =',Ny

      Do ip =1,Nh                         ! z - direction
         If(Loz(ip).eq.1)Then
            x =xc(ip)
            y =yc(ip)
            z =zc(ip)
            vv =vc(ip)
            aM =aMass(ip)
            vz =vzc(ip)
            vlz =hubble*z+vz
            Do jp =1,Next
               if(jp.ne.ip)Then
                  dv =abs(vlz-hubble*zc(jp)-vzc(jp))
                  dz = abs(zc(jp)-z)
                 If(dv.lt.Vlimit.and.dz.lt.Box/2.)Then
                     dz2 = (xc(jp)-x)**2+(yc(jp)-y)**2
                     if(dz2.lt.R2.and.vc(jp).lt.vv/Vratio)Then
                        dd =sqrt(dz2 +(zc(jp)-z)**2)                        
c                      uv =(vz -vzc(jp))
                        uv =sqrt((vxc(ip)-vxc(jp))**2+
     &                  (vyc(ip) -vyc(jp))**2+(vzc(ip) -vzc(jp))**2)

c                     write(3,'(f8.2,f8.2,4f9.2,2i8,7f8.3)')
c     &                 1000.*sqrt(dz2)/(hubble/100.),dv,vv,vc(jp),
c     &                   1000.*dd,uv,ip,jp,
c     &                    x,y,z,xc(jp),yc(jp),zc(jp)
                     Nz = Nz +1
                    EndIf            
                 EndIf           
              EndIf                  ! jp=ip
            EndDo   ! jp loop
         EndIf         ! Loz(ip) =1
      EndDo      ! ip loop

      write (*,*)  ' Satellites in z-dir =',Nz
      write (2,*)  ' Satellites in z-dir =',Nz

      RETURN 
      End
c-------------------------------------------------------------------- 
c                  Find particles of isolated halos and
c                  Place them in a file
c                  Lox,y,z = 1 if halos is isolated
      SUBROUTINE OutSatellites(Nx,Ny,Nz)
c-------------------------------------------------------------------- 
      include 'satellites.h' 
      Logical inx,iny,inz

      Radmx = 15. ! in Mpc
      Nselect   = 100  ! number of particles to select
      Nseed = 12077121  ! initial seed for random numbers
      dRmax    = 0.500  ! max radius in projection
      dVmax    = 500.   ! velocity limit for particles km/s
      R2     = (Radmx)**2  ! square of max distance in Mpc
      Niso   = 0
      Do i=0,2
         write(30+i,*)' Number of particles per halo  =',Nselect
         write(30+i,*)' Max 3D radius around halo     =',Radmx,'Mpc/h'
         write(30+i,*)' Max projected radius          =',dRmax,'Mpc/h'
         write(30+i,*)' Format of tables:'
         write(30+i,*)' HaloNumb Vcirc  Mass(Msun/h) Coords(Mpc/h)'
         write(30+i,'("   dv(km/s) r_p(kpc/h)",3x,"dXYZ(kpc/h)",
     &          30x,"dVxyz(km/s)")')
      EndDo 

      Do ip =1,Nh
         If(Lox(ip).eq.1.or.Loy(ip).eq.1.or.Loz(ip).eq.1)Then
            x =xc(ip)
            y =yc(ip)
            z =zc(ip)
            vv =vc(ip)
            aM =aMass(ip)
            Niso = Niso +1
            Nnx   = 0
            Nny   = 0
            Nnz   = 0
            write (*,'(i8,f8.2,g11.4,3f8.3)') ip,vv,aM,x,y,z
            If(Lox(ip).eq.1)
     &        write (30,'(i8,f8.2,g11.4,3f8.3)') ip,vv,aM,x,y,z
            If(Loy(ip).eq.1)
     &        write (31,'(i8,f8.2,g11.4,3f8.3)') ip,vv,aM,x,y,z
            If(Loz(ip).eq.1)
     &        write (32,'(i8,f8.2,g11.4,3f8.3)') ip,vv,aM,x,y,z
            Do jp =1,Np    ! Find how many particles are in cylinder
               dd =(xp(jp)-x)**2+(yp(jp)-y)**2+(zp(jp)-z)**2
               if(dd.lt.R2)Then
                     dx = xp(jp)-x
                     dy = yp(jp)-y
                     dz = zp(jp)-z
                     dd = sqrt(dd)
                     dvx = vxp(jp)-vxc(ip) +hubble*dx
                     dvy = vyp(jp)-vyc(ip) +hubble*dy
                     dvz = vzp(jp)-vzc(ip) +hubble*dz
                     dxp = sqrt(dy**2+dz**2)
                     dyp = sqrt(dx**2+dz**2)
                     dzp = sqrt(dx**2+dy**2)
                  If(abs(dvx).lt.dVmax.and.dxp.lt.dRmax)Nnx = Nnx+1  
                  If(abs(dvy).lt.dVmax.and.dyp.lt.dRmax)Nny = Nny+1  
                  If(abs(dvz).lt.dVmax.and.dzp.lt.dRmax)Nnz = Nnz+1
               EndIf     
            EndDo 
            FractionX = 100./Nnx*1.05
            FractionY = 100./Nny*1.05
            FractionZ = 100./Nnz*1.05
            Nseed_a = Nseed
 200        Nnx   = 0
            Nny   = 0
            Nnz   = 0
            Nnxp   = 0
            Nnyp   = 0
            Nnzp   = 0
             Do jp=1,Np     ! select Nselect particles in each direction
              If(Nnx.lt.Nselect.or.Nny.lt.Nselect.or.Nnz.lt.Nselect)Then
                  dd =(xp(jp)-x)**2+(yp(jp)-y)**2+(zp(jp)-z)**2
                  if(dd.lt.R2)Then
                        dx = xp(jp)-x
                        dy = yp(jp)-y
                        dz = zp(jp)-z
                        dd = sqrt(dd)
                        dvx = vxp(jp)-vxc(ip) +hubble*dx
                        dvy = vyp(jp)-vyc(ip) +hubble*dy
                        dvz = vzp(jp)-vzc(ip) +hubble*dz
                        dxp = sqrt(dy**2+dz**2)
                        dyp = sqrt(dx**2+dz**2)
                        dzp = sqrt(dx**2+dy**2)
                     If(Lox(ip).eq.1)Then
                     If(abs(dvx).lt.dVmax.and.dxp.lt.dRmax
     &                 .and.RANDd(Nseed).lt.FractionX)Then
                     If(Nnx.lt.Nselect)Then
                      Nnx = Nnx+1  
                      If(dvx.gt.0.)Nnxp = Nnxp+1
                       write(30,'(f9.2,f9.2,2x,3f10.2,5x,9f9.2)')
     &                 dvx,1000.*dxp,
     &                 1.e3*dx,1.e3*dy,1.e3*dz,dvx,dvy,dvz
                     EndIf                        
                     EndIf 
                     EndIf    
                     If(Loy(ip).eq.1)Then
                     If(abs(dvy).lt.dVmax.and.dyp.lt.dRmax
     &                 .and.RANDd(Nseed).lt.FractionY)Then
                     If(Nny.lt.Nselect)Then
                      Nny = Nny+1  
                      If(dvy.gt.0.)Nnyp = Nnyp+1
                       write(31,'(f9.2,f9.2,2x,3f10.2,5x,3f9.2)')
     &                 dvy,1000.*dyp,
     &                 1.e3*dx,1.e3*dy,1.e3*dz,dvx,dvy,dvz
                     EndIf 
                     EndIf  
                     EndIf
                     If(Loz(ip).eq.1)Then    
                     If(abs(dvz).lt.dVmax.and.dzp.lt.dRmax
     &                 .and.RANDd(Nseed).lt.FractionZ)Then
                     If(Nnz.lt.Nselect)Then
                      Nnz = Nnz+1  
                      If(dvz.gt.0.)Nnzp = Nnzp+1
                       write(32,'(f9.2,f9.2,2x,3f10.2,5x,3f9.2)')
     &                 dvz,1000.*dzp,
     &                 1.e3*dx,1.e3*dy,1.e3*dz,dvx,dvy,dvz
                     EndIf 
                     EndIf  
                     EndIf    
                  EndIf    
              EndIf
            EndDo   ! jp loop
            iflag = 0
c       If(Nnx.ne.Nselect)write(*,*)'  wrong number of selected Nnx=',Nnx
c       If(Nny.ne.Nselect)write(*,*)'  wrong number of selected Nny=',Nny
c       If(Nnz.ne.Nselect)write(*,*)'  wrong number of selected Nnz=',Nnz
       If(Nnx.lt.Nselect.and.Nnx.ne.0)Then
          iflag =1
          FractionX =FractionX*1.05
          IF(FractionX.ge.1.)stop '-- Not enough particles X'
       EndIf
       If(Nny.lt.Nselect.and.Nny.ne.0)Then
          iflag =1
          FractionY =FractionY*1.05
          IF(FractionY.ge.1.)stop '-- Not enough particles Y'
       EndIf
       If(Nnz.lt.Nselect.and.Nnz.ne.0)Then
          iflag =1
          FractionZ =FractionZ*1.05
          IF(FractionZ.ge.1.)stop '-- Not enough particles Z'
       EndIf
       If(iflag.eq.1)Then
          write (*,'(15x,"Change fractions=",3f8.3," Nselected=",3i4)')
     &          FractionX,FractionY,FractionZ,Nnx,Nny,Nnz
          Nseed =Nseed_a
          Do i =1,Nnx
             BACKSPACE 30
          EndDo 
          Do i =1,Nny
             BACKSPACE 31
          EndDo
          Do i =1,Nnz
             BACKSPACE 32
          EndDo
 
          goto200
       EndIf 

         write (*,'(" Number of positives=",3i4," Total=",3i4)')
     &           Nnxp,Nnyp,Nnzp,Nnx,Nny,Nnz
         EndIf         ! Lox(ip) =1

      EndDo      ! ip loop
      write (*,*)  ' Number of isolated halos=',Niso
      write (2,'("  Number of isolated halos =",T30,i9)')Niso
c     write (*,*)  ' Particles used as satellites=',Nselect
c     write (2,'("  Particles used as satellites =",T30,i9)')Nx

      RETURN 
      End
c-------------------------------------------------------------------- 
c                  Find particles of isolated halos
c
c                  Lox,y,z = 1 if halos is isolated
      SUBROUTINE SatellitesP
c-------------------------------------------------------------------- 
      include 'satellites.h' 
      Logical inx,iny,inz
      DIMENSION sigV(Nshells),sigVr(Nshells),sigdV(Nshells),ns(Nshells)
      DIMENSION sigVp(0:1,Nshells),sigVrp(0:1,Nshells),
     &                  sigdVp(0:1,Nshells),nsp(0:1,Nshells),Nisop(0:1)
      DATA sigVp/Nshell2*0./,sigVrp/Nshell2*0./,sigdVp/Nshell2*0./
      DATA nsp/Nshell2*0/

      dRad = 50.    ! in kpc
      Radmx = 5. ! in Mpc
      Nx   = 0
      Nisop(0) = 0       ! number of isolated halos
      Nisop(1) = 0       ! number of isolated halos
      R2     = (Radmx)**2  ! square of max distance in Mpc
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP+PRIVATE ( k,jj,ip,jp,dd,dx,dy,dz,dvx,dvy,dvz)
C$OMP+PRIVATE (uv,uu,ur,ind,x,y,z,vv,aM)
      Do k=0,1    
      Do jj =1,Nh,2
         ip =jj+k
         If(Lox(ip).eq.1.and.Loy(ip).eq.1.and.Lox(ip).eq.1)Then
            Nisop(k) = Nisop(k) +1
            x =xc(ip)
            y =yc(ip)
            z =zc(ip)
            vv =vc(ip)
            aM =aMass(ip)
            Do jp =1,Np
                  dd =(xp(jp)-x)**2+(yp(jp)-y)**2+(zp(jp)-z)**2
                     if(dd.lt.R2)Then
                        dx = xp(jp)-x
                        dy = yp(jp)-y
                        dz = zp(jp)-z
                        dd =sqrt(dd)
                        dvx = vxp(jp)-vxc(ip) +hubble*dx
                        dvy = vyp(jp)-vyc(ip) +hubble*dy
                        dvz = vzp(jp)-vzc(ip) +hubble*dz
                        uv =dvx**2+dvy*2+dvz**2
                        uu =vxp(jp)**2+vyp(jp)**2+vzp(jp)**2
                        ur =(dvx*dx+dvy*dy+dvz*dz)/max(dd,1.e-2)
                        ind =min(INT(dd*1000./dRad)+1,Nshells)
                        nsp(k,ind)     =nsp(k,ind) +1
                        sigVp(k,ind) =sigVp(k,ind) +uu
                        sigdVp(k,ind) =sigdVp(k,ind) +uv
                        sigVrp(k,ind) =sigVrp(k,ind) +ur
 
c                    write(3,'(f8.2,f8.2,2f8.2,2f9.2,2i8,7f8.3)')
c     &                 1000.*sqrt(dx2)/(hubble/100.),dv,vv,vc(jp),
c     &                  1000.*dd,uv,ip,jp,
c     &                    x,y,z,xc(jp),yc(jp),zc(jp)
c                     Nx = Nx +1
                    EndIf            ! dd < R2
            EndDo   ! jp loop

         EndIf         ! Lox(ip) =1
      EndDo      ! ip loop
            EndDo   ! k loop
      Niso =Nisop(0)+Nisop(1)
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP+PRIVATE ( j)
      do j=1,Nshells
         sigV(j) =sigVp(0,j) + sigVp(1,j)
         ns(j)     =nsp(0,j)    + nsp(1,j)
         sigV(j)  =sigVp(0,j)+ sigVp(1,j)
         sigdV(j)  =sigdVp(0,j)+ sigdVp(1,j)
         sigVr(j)  =sigVrp(0,j)+ sigVrp(1,j)
      EndDo 

      write (*,*)  ' Number of isolated halos=',Niso
      write (2,'("  Number of isolated halos =",T30,i9)')Niso
c     write (*,*)  ' Particles used as satellites=',Nx
c     write (2,'("  Particles used as satellites =",T30,i9)')Nx
      write (*,*) ' n     R(kpc)  sigVpart     sigdV       Vr   Density'
      write (2,'(" n     R(kpc)  sigVpart     sigdV       Vr",
     &               "    OverDensity IntegratedoverDens  Nint")')
      nint =0
      Do i=1,Nshells
         Volume =4.1888*dRad**3*(i**3-max(0,i-1)**3)
         nint = nint +ns(i)        ! number of particles inside current radius 
         If(ns(i).gt.2) write(2,'(i6,6g11.4,i8,g12.4)')ns(i),
     &              (i-0.5)*dRad,sqrt(sigV(i)/ns(i)),
     &                   sqrt(sigdV(i)/ns(i)),sigVr(i)/ns(i),
     &              ns(i)/(Niso*float(NpBox)*Volume/(1000.*Box)**3),
     &              nint/(Niso*float(NpBox)*(4.1888*(dRad*i)**3)
     &                         /(1000.*Box)**3),
     &              nint

       EndDo
      RETURN 
      End
c-------------------------------------------------------------------- 
c                  find 'clusters': halos with large Vcirc
c
      Real Function DistanceCluster(i)
c-------------------------------------------------------------------- 
      include 'satellites.h' 
      Logical inx,iny,inz

      DistanceCluster =1.e10
      Do icl =1,Nclusters               ! look for clusters in extended halo list
         ip =ListCl(icl)                     ! pointer to cluster in full halo list 
         dd = (xc(i) -xc(ip))**2+
     &          (yc(i) -yc(ip))**2+(zc(i) -zc(ip))**2
         DistanceCluster =min(dd,DistanceCluster)
      EndDo 
      DistanceCluster =sqrt(DistanceCluster)

      RETURN 
      End

C------------------------------------------------
C				                                       random number generator
      FUNCTION RANDd(M)
C------------------------------------------------
      DATA LC,AM,KI,K1,K2,K3,K4,L1,L2,L3,L4
     +	/453815927,2147483648.,2147483647,536870912,131072,256,
     +	 16777216,4,16384,8388608,128/
      ML=M/K1*K1
      M1=(M-ML)*L1
      ML=M/K2*K2
      M2=(M-ML)*L2
      ML=M/K3*K3
      M3=(M-ML)*L3
      ML=M/K4*K4
      M4=(M-ML)*L4
      M5=KI-M
      IF(M1.GE.M5)M1=M1-KI-1
      ML=M+M1
      M5=KI-ML
      IF(M2.GE.M5)M2=M2-KI-1
      ML=ML+M2
      M5=KI-ML
      IF(M3.GE.M5)M3=M3-KI-1
      ML=ML+M3
      M5=KI-ML
      IF(M4.GE.M5)M4=M4-KI-1
      ML=ML+M4
      M5=KI-ML
      IF(LC.GE.M5)ML=ML-KI-1
      M=ML+LC
      RANDd=M/AM
      RETURN
      END

C ______________________________	  
C		                    
C	     NROW = number of particles per row
C	     NGRID= number of cells on a side (normal grid)
       INCLUDE 'PMparameters.h'
       INCLUDE 'PMfields.h'
       REAL     INPUT
       PI =3.1415926535
C...................................................................
C			Read data and open files
      CALL RDTAPE

      write (*,*) ' RDTAPE is done'
100   FORMAT(1X,'Header=>',A45,/
     +            1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I6,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3,/
     +            1x,' Number of part.1specie=',i8,' Nspecies=',i3)
c      Box =INPUT(' Enter box size in Mpc/h   =')
      Box =160.
c      alpha =INPUT(' Enter angle of rotation   =')
      
      BoxV =Box*100.    ! Box size in km/s
      ScaleV = BoxV/AEXPN/NGRID  ! scale factor for Velocities
      ScaleC = Box/NGRID         ! scale factor for Coordinates

C
      CALL ReadParticles(ScaleV)
      xsh = 3.2/ScaleC                   ! shift coordinates
      ysh = -12.3/ScaleC
      zsh = 0.8/ScaleC
c      Xc = -0.72                            !center of the VIRGO
c      Yc =14.43
c      Zc =0.83
      Xc = 0.                           !center of the cone
      Yc = 0.
      Zc = 0.
      Rsphere =5.
      Rc =40.
      ACone=20.
      ux =-1.                           ! direction of the cone
      uy =13.68
      uz =1.
c      ux =INPUT(' Enter x-direction   =')

      CALL ShiftParticles(xsh,ysh,zsh)
c      CALL RotateYParticles(alpha)

      open(18,file='Cone.dat')
      WRITE (18,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,wspecies(1),
     +                  EKIN,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv,lspecies(1),Nspecies
      WRITE (18,*) ' Angle=',alpha,' Cone=',Acone,'deg R=',
     +            Rc,' direction=',ux,uy,uz
      ACone=ACone*PI/180.
      Xc =(Xc/Box +0.5)*NGRID+0.5
      Yc =(Yc/Box +0.5)*NGRID+0.5
      Zc =(Zc/Box +0.5)*NGRID+0.5
      Rc =Rc/Box*NGRID
      CALL CONE(ux,uy,uz,ACone,ScaleC)
c      CALL SPHERE(Rsphere,ScaleC)
c      CALL DumpParticles(z0,dz0,ScaleC)
      STOP
      END


C---------------------------------------
C                                                       Read Particles 
      SUBROUTINE ReadParticles(ScaleV)
C---------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMfields.h'
      	XN   =FLOAT(NGRID)+1.-1.E-7
	      YN   =FLOAT(NGRID)

      W     = (FLOAT(NGRID)/FLOAT(NROW))**3
      PARTW = W  
      WPAR = wspecies(1)
      N =0
      xmin =1.e+5
      xmax =-1.e+5
      ymin =1.e+5
      ymax =-1.e+5
      zmin =1.e+5
      zmax =-1.e+5
      vxmin =1.e+15
      vxmax =-1.e+15
      vymin =1.e+15
      vymax =-1.e+15
      vzmin =1.e+15
      vzmax =-1.e+15

C				       Loop over particles
         N_particles =lspecies(Nspecies)   ! Total number of particles
         Npages = (N_particles -1)/NPAGE +1
         N_in_last=N_particles -NPAGE*(Npages-1)
      write (*,*) Nspecies,
     + lspecies(Nspecies),wspecies(Nspecies)
      Nsp_current =1
      WPAR     = wspecies(1)
      Lspec_next=lspecies(1)+1
      DO IROW=1,Npages
            In_page =NPAGE
            If(IROW.eq.Npages)In_page =N_in_last
            If(IROW/50*50.eq.IROW)
     +        write (*,*) ' Read page=',IROW,' N=',N,
     +             ' Npages=',Npages,In_page
            iL = NPAGE*(IROW-1)
C				       Loop over particles
         READ  (21,REC=IROW) RECDAT
	   DO   IN=1,In_page
            N   = N +1
            If(N.ge.Lspec_next)Then   ! next specie
               write (*,*) ' Another specie. Current=',Nsp_current
               write (*,*) '     Particle=',N,WPAR,
     &                         ' lspecies=',lspecies(Nsp_current),
     &                         ' next=',lspecies(Nsp_current+1)
               Nsp_current=Nsp_current+1
               Lspec_next =lspecies(Nsp_current)+1
               WPAR     = wspecies(Nsp_current)
            EndIf
	        X=XPAR(IN)
	        Y=YPAR(IN)
	        Z=ZPAR(IN)
           If(N.gt.Nmaxp)Then
              write (*,*) ' Error: not enough space for particles:',N
              stop
           Endif 
           Xp(N) =X                             ! coordinates in 1-NGRID
           Yp(N) =Y
           Zp(N) =Z
           Vxp(N)=ScaleV* VX(IN)    ! velocities in km/s
           Vyp(N)=ScaleV* VY(IN)
           Vzp(N)=ScaleV* VZ(IN)
           Wp(N) =WPAR                   ! particle weight

           xmin =MIN(xmin,X)
           ymin =MIN(ymin,Y)
           zmin =MIN(zmin,Z)
           xmax =MAX(xmax,X)
           ymax =MAX(ymax,Y)
           zmax =MAX(zmax,Z)
           vxmin =MIN(vxmin,Vxp(N))
           vymin =MIN(vymin,Vyp(N))
           vzmin =MIN(vzmin,Vzp(N))
           vxmax =MAX(vxmax,Vxp(N))
           vymax =MAX(vymax,Vyp(N))
           vzmax =MAX(vzmax,Vzp(N))
	        I=INT(X)
	        J=INT(Y)
	        K=INT(Z)
            If(I.le.0)write (*,*) ' X:',X,Y,Z,I,' Irow=',IROW,IN,ifile
            If(J.le.0)write (*,*) ' Y:',X,Y,Z,I,' Irow=',IROW,IN,ifile
            If(K.le.0)write (*,*) ' Z:',X,Y,Z,I,' Irow=',IROW,IN,ifile

	      ENDDO
        ENDDO 

        Np = N
      write (*,*) ' Number of particles read=', N
      write (*,*) ' X:',xmin,xmax,' V=',vxmin,vxmax
      write (*,*) ' Y:',ymin,ymax,' V=',vymin,vymax
      write (*,*) ' Z:',zmin,zmax,' V=',vzmin,vzmax
        RETURN
      END
C---------------------------------------
C                              Particles in a sphere
      SUBROUTINE Sphere(Rsphere,ScaleC)
C---------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMfields.h'

      Dimension Rline(0:100),Vline(0:100),Mline(0:100),
     &                V2line(0:100),Wline(0:100)
      Dimension Xq(250000),Yq(250000),Zq(250000),
     &               VXq(250000),VYq(250000),VZq(250000)
C                 Find points close to the center
      write (*,*) ' Center=',Xc,Yc,Zc,' R=',Rsphere
      write (*,*) ' ScaleC=',ScaleC
      dRline =0.15
      Do i=0,100
         Rline(i) =0.
         Vline(i) =0.
         Mline(i) =0
         V2line(i) =0.
         Wline(i) =0.
      Enddo 
      R =Rsphere /ScaleC/10.    ! Find velocity of the center
 10   R2 =R**2
C				       Loop over particles
      Nc =0
      Vxc =0.
      Vyc =0.
      Vzc =0.
	   DO   IN=1,Np
	        dX=(Xp(IN)-Xc)            !coords
	        dY=(Yp(IN)-Yc)
	        dZ=(Zp(IN)-Zc)
           dd =dX**2 +dY**2 +dZ**2
             If(dd.lt.R2)Then
                 dX =dX*ScaleC
                 dY =dY*ScaleC
                 dZ =dZ*ScaleC
c           write (*,90)IN,dX,dY,dZ,Vxp(IN),Vyp(IN),Vzp(IN)
c 90        format(' i=',i8,' x=',3f8.2,' V=',3f9.2)
                Nc =Nc+1
                Vxc =Vxc +Vxp(IN)
                Vyc =Vyc +Vyp(IN)
                Vzc =Vzc +Vzp(IN)
             endif 
      Enddo 
      If(Nc.lt.5)Then
         Rold =R
         R       =R*1.2
         write (*,*) ' Too small radius=',Rold,' Increase it to ',R
         goto 10
      endif 
      Vxc =Vxc/Nc                  ! This is the center
      Vyc =Vyc/Nc
      Vzc =Vzc/Nc
      Xc0   =ScaleC*(Xc-1.)
      Yc0   =ScaleC*(Yc-1.)
      Zc0   =ScaleC*(Zc-1.)

      write (*,*) ' There are ',Nc,' particles inside R=',R*ScaleC,
     &               ' Center(Mpc/h) =',Xc0,
     &               Yc0,Zc0,
     &               ' V(km/s)=', Vxc, Vyc, Vzc
C				    Find radial velocities of particles in the Sphere
      Nc =0
      Rsph =Rsphere/ScaleC
      R3    =Rsph**2 
	   DO   IN=1,Np             ! Loop over particles
	        X=Xp(IN)            !coords
	        Y=Yp(IN)
	        Z=Zp(IN)
	        dX=(X-Xc)            !coords
	        dY=(Y-Yc)
	        dZ=(Z-Zc)
              dd =dX**2 +dY**2 +dZ**2
              If(dd.lt.R3)Then
                 d     = max(sqrt(dd+1.d-10),1.d-10)
                    Nc =Nc +1
                wx =Vxp(IN)-Vxc
                wy =Vyp(IN)-Vyc
                wz =Vzp(IN)-Vzc
                vr  =(dX*wx+dY*wy+dZ*wz)/d
                ww =sqrt(wx**2+wy**2+wz**2)
c                Xn =dX*(1.+vr/100./d)+Xc
c                Yn =dY*(1.+vr/100./d)+Yc
c                Zn =dZ*(1.+vr/100./d)+Zc
                d =d*ScaleC
                dX =dX*ScaleC
                 dY =dY*ScaleC
                 dZ =dZ*ScaleC
              write (18,100) d,vr,ww,dX,dY,dZ,wx,wy,wz,Wp(IN)
 100            format(f8.2,2f9.2,3f8.3,3f8.1,g11.3,4f8.3)
                iL =max(min(int(d/dRline),100),0)
                Rline(iL) = Rline(iL) +d*Wp(IN)
                Wline(iL) = Wline(iL) +Wp(IN)
                Mline(iL) = Mline(iL) +1
                Vline(iL) = Vline(iL) +vr*Wp(IN)
                V2line(iL) = V2line(iL) +vr**2*Wp(IN)
c                write (*,*) d,dRline,
                If(Nc.gt.250000)Then
                   write (*,*) ' Not enough space'
                   stop
                endif 
                Xq(Nc) =dX
                Yq(Nc) =dY
                Zq(Nc) =dZ
                VXq(Nc) =wx
                VYq(Nc) =wy
                VZq(Nc) =wz
             endif 
      Enddo 
      write (*,*) ' N_inside_sphere=',Nc,' R=',Rsphere
      open(30,file='Sphere.dat')
      do i=0,99
         If(Mline(i).gt.3)Then
            Rline(i) =Rline(i)/Wline(i)
            Vline(i) = Vline(i)/Wline(i)
            V2line(i) =sqrt(V2line(i)/Wline(i)-Vline(i)**2)
            write(30,80) i,(i+0.5)*dRline,Rline(i),Vline(i), 
     &                        V2line(i),Mline(i),Wline(i)
 80         format(i3,f8.3,f8.3,2f9.2,i6,g11.3)
         EndIf
      Enddo 
      Rsmooth =0.15
      R2 =Rsmooth**2
      Do i=1,Nc
         x =Xq(i)
         y =Yq(i)
         z =Zq(i)
         Nn =0
         wx =0.
         wy =0.
         wz =0.
         Do j=1,Nc
            dd =(x-Xq(j))**2+(y-Yq(j))**2+(z-Zq(j))**2
            if(dd.lt.R2)Then
               Nn =Nn +1
               wx =wx+Vxq(j)
               wy =wy+Vyq(j)
               wz =wz+Vzq(j)
            endif 
         Enddo 
         If(Nn.eq.0)write(*,*) ' Error Nn'
               wx =wx/Nn
               wy =wy/Nn
               wz =wz/Nn
               d   =sqrt(x**2+y**2+z**2)
                vr  =(x*wx+y*wy+z*wz)/d
                ww =sqrt(wx**2+wy**2+wz**2)
                vra  =(x*Vxq(i)+y*Vyq(i)+z*Vzq(i))/d
                wwa=sqrt(Vxq(i)**2+Vyq(i)**2+Vzq(i)**2)
              write (30,110) d,vr,vra,ww,wwa,x,y,z,wx,wy,wz,Nn
 110            format(f8.2,4f9.2,3f8.3,3f8.1,i4)
          Enddo 
      Return
      End
C---------------------------------------
C                              Particles in a cone
      SUBROUTINE CONE(ux,uy,uz,ACone,ScaleC)
C---------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMfields.h'
      Dimension Rline(0:100),Vline(0:100),Mline(0:100),
     &                V2line(0:100),Wline(0:100)
C                 Find points close to the center
      write (*,*) ' Center=',Xc,Yc,Zc,' R=',Rc
      write (*,*) ' ScaleC=',ScaleC
      dRline =1.
      Do i=0,100
         Rline(i) =0.
         Vline(i) =0.
         Mline(i) =0
         V2line(i) =0.
         Wline(i) =0.
      Enddo 
      R =1.5
 10   R2 =R**2
C				       Loop over particles
      Nc =0
      Vxc =0.
      Vyc =0.
      Vzc =0.
	   DO   IN=1,Np
	        dX=(Xp(IN)-Xc)            !coords
	        dY=(Yp(IN)-Yc)
	        dZ=(Zp(IN)-Zc)
           dd =dX**2 +dY**2 +dZ**2
             If(dd.lt.R2)Then
                 dX =dX*ScaleC
                 dY =dY*ScaleC
                 dZ =dZ*ScaleC
c           write (*,90)IN,dX,dY,dZ,Vxp(IN),Vyp(IN),Vzp(IN)
 90        format(' i=',i8,' x=',3f8.2,' V=',3f9.2)
                Nc =Nc+1
                Vxc =Vxc +Vxp(IN)
                Vyc =Vyc +Vyp(IN)
                Vzc =Vzc +Vzp(IN)
             endif 
      Enddo 
      If(Nc.lt.5)Then
         Rold =R
         R       =R*1.2
         write (*,*) ' Too small radius=',Rold,' Increase it to ',R
         goto 10
      endif 
      Vxc =Vxc/Nc
      Vyc =Vyc/Nc
      Vzc =Vzc/Nc
      Xc0   =ScaleC*(Xc-1.)
      Yc0   =ScaleC*(Yc-1.)
      Zc0   =ScaleC*(Zc-1.)

      write (*,*) ' There are ',Nc,' particles inside R=',R*ScaleC,
     &               ' Center(Mpc/h) =',Xc0,
     &               Yc0,Zc0,
     &               ' V(km/s)=', Vxc, Vyc, Vzc
C				    Find radial velocities of particles in the Cone
      Nc =0
      R2 =Rc**2
      u = sqrt(ux**2 +uy**2 +uz**2)
      ux =ux/u                             ! unit vector for cone direction
      uy =uy/u
      uz =uz/u
      CosCone =COS(ACone)
      Rcyl =1.5/ScaleC
      R3    =Rcyl**2 
	   DO   IN=1,Np             ! Loop over particles
	        X=Xp(IN)            !coords
	        Y=Yp(IN)
	        Z=Zp(IN)
	        dX=(X-Xc)            !coords
	        dY=(Y-Yc)
	        dZ=(Z-Zc)
              dd =dX**2 +dY**2 +dZ**2
              If(dd.lt.R2.and.Wp(IN).lt.5.)Then
                 d     = max(sqrt(dd+1.d-10),1.d-10)
                 CosTh = (dX*ux+dY*uy+dZ*uz)/d
                 d2 =dd*(1.-CosTh**2)
                 If(d2.lt. R3)Then  ! inside the cylinder
c                 If(CosTh.gt. CosCone)Then  ! inside the cone
                    Nc =Nc +1
                wx =Vxp(IN)-Vxc
                wy =Vyp(IN)-Vyc
                wz =Vzp(IN)-Vxc
                vr  =(dX*wx+dY*wy+dZ*wz)/d
                ww =sqrt(wx**2+wy**2+wz**2)
c                Xn =dX*(1.+vr/100./d)+Xc
c                Yn =dY*(1.+vr/100./d)+Yc
c                Zn =dZ*(1.+vr/100./d)+Zc
                d =d*ScaleC
                dX =dX*ScaleC
                 dY =dY*ScaleC
                 dZ =dZ*ScaleC
              write (18,100) d,vr,ww,dX,dY,dZ,wx,wy,wz,Wp(IN)
 100            format(f8.2,2f9.2,3f8.3,3f8.1,g11.3,4f8.3)
                iL =max(min(int(d/dRline),100),0)
                Rline(iL) = Rline(iL) +d*Wp(IN)
                Wline(iL) = Wline(iL) +Wp(IN)
                Mline(iL) = Mline(iL) +1
                Vline(iL) = Vline(iL) +vr*Wp(IN)
                V2line(iL) = V2line(iL) +vr**2*Wp(IN)
c                write (*,*) d,dRline,
             endif 
             endif 
      Enddo 
      write (*,*) ' N_inside_cone=',Nc
      open(30,file='Line.dat')
      do i=0,99
         If(Mline(i).gt.3)Then
            Rline(i) =Rline(i)/Wline(i)
            Vline(i) = Vline(i)/Wline(i)
            V2line(i) =sqrt(V2line(i)/Wline(i)-Vline(i)**2)
            write(30,80) i,(i+0.5)*dRline,Rline(i),Vline(i), 
     &                        V2line(i),Mline(i),Wline(i)
 80         format(i3,f8.3,f8.3,2f9.2,i6,g11.3)
         EndIf
      Enddo 
      Return
      End
C---------------------------------------
C                            write particles in a slice
      SUBROUTINE DumpParticles(z0,dz0,ScaleC)
C---------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMfields.h'
C                 Find points close to the center
      Xc =NGRID/2.+1.
      Yc =NGRID/2.+1.
      Zc =NGRID/2.+1.
      Rc =1.
 10   R2 =Rc**2
C				       Loop over particles
      Nc =0
      Vxc =0.
      Vyc =0.
      Vzc =0.
	   DO   IN=1,Np
	        dX=(Xp(IN)-Xc)            !coords
	        dY=(Yp(IN)-Yc)
	        dZ=(Zp(IN)-Zc)
           dd =dX**2 +dY**2 +dZ**2
             If(dd.lt.R2)Then
                Nc =Nc+1
                Vxc =Vxc +Vxp(IN)
                Vyc =Vyc +Vyp(IN)
                Vzc =Vzc +Vzp(IN)
             endif 
      Enddo 
      If(Nc.eq.0)Then
         Rcold =Rc
         Rc       =Rc*1.2
         write (*,*) ' Too small radius=',Rcold,' Increase it to ',Rc
         goto 10
      endif 
      Vxc =Vxc/Nc
      Vyc =Vyc/Nc
      Vzc =Vzc/Nc
      Xc   =ScaleC*(Xc-1.)
      Yc   =ScaleC*(Yc-1.)
      Zc   =ScaleC*(Zc-1.)

      write (*,*) ' There are ',Nc,' particles inside Rc=',Rc*ScaleC,
     &               ' Center(Mpc/h) =',Xc,
     &               Yc,Zc,
     &               ' V(km/s)=', Vxc, Vyc, Vzc
C				       Loop over particles
	   DO   IN=1,Np
	        X=ScaleC*(Xp(IN)-1.)            !coords
	        Y=ScaleC*(Yp(IN)-1.)
	        Z=ScaleC*(Zp(IN)-1.)
             If(Z.gt.z0.and.Z.lt.z0+dz0)Then
	        dX=(X-Xc)            !coords
	        dY=(Y-Yc)
	        dZ=(Z-Zc)
              dd =dX**2 +dY**2 +dZ**2
              d   =max(sqrt(dd+1.d-10),1.d-10)
                ux =Vxp(IN)-Vxc
                uy =Vyp(IN)-Vyc
                uz =Vzp(IN)-Vxc
                vr  =(dX*ux+dY*uy+dZ*uz)/d
                Xn =dX*(1.+vr/100./d)+Xc
                Yn =dY*(1.+vr/100./d)+Yc
                Zn =dZ*(1.+vr/100./d)+Zc

                write (18,100) X,Y,Z,ux,uy,uz,Wp(IN),vr,
     &                 Xn,Yn,Zn
 100            format(3f8.3,3f8.1,g11.3,4f8.3)
             endif 
      Enddo 
      Return
      End
C---------------------------------------
C                          Rotate around Y-axis by angle alpha
      SUBROUTINE RotateYParticles(alpha)
C---------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMfields.h'
      XN =NGRID+1
c      XC =(NGRID+1.)/2.     ! center of rotation
c      ZC =(NGRID+1.)/2.
      cosA =cos(alpha*3.1415926/180.)
      sinA =sin(alpha*3.1415926/180.)
C				       Loop over particles
	   DO   IN=1,Np
	        X=Xp(IN) -XC            !coords
	        Y=Yp(IN)
	        Z=Zp(IN) -ZC
           Xnew =X*cosA -Z*sinA + XC
           Znew =Z*cosA +X*sinA + ZC
           Vxp(IN) =Vxp(IN)*cosA-Vzp(IN)*sinA
           Vyp(IN) =Vyp(IN) 
           Vzp(IN) =Vzp(IN)*cosA+Vxp(IN)*sinA
           
           X =Xnew
              If(X.ge.XN)X=X-NGRID
              If(X.lt.1.)X=X+NGRID
           Z =Znew
              If(Z.ge.XN)Z=Z-NGRID
              If(Z.lt.1.)Z=Z+NGRID
           Xp(IN) =X
           Yp(IN) =Y
           Zp(IN) =Z

      Enddo 
      Return
      End
C---------------------------------------
C                          Shift particles with periodical conditions
      SUBROUTINE ShiftParticles(xsh,ysh,zsh)
C---------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMfields.h'
      XN =NGRID+1
C				       Loop over particles
	   DO   IN=1,Np
	        X=Xp(IN)             !coords
	        Y=Yp(IN)
	        Z=Zp(IN)
           X =X+xsh
              If(X.ge.XN)X=X-NGRID
              If(X.lt.1.)X=X+NGRID
           Y =Y+ysh
              If(Y.ge.XN)Y=Y-NGRID
              If(Y.lt.1.)Y=Y+NGRID
           Z =Z+zsh
              If(Z.ge.XN)Z=Z-NGRID
              If(Z.lt.1.)Z=Z+NGRID
           Xp(IN) =X
           Yp(IN) =Y
           Zp(IN) =Z
c           Vxpb(IN) =Vxp(IN)
c           Vypb(IN) =Vyp(IN) 
c           Vzpb(IN) =Vzp(IN)

      Enddo 
      Return
      End

C-------------------------------------------------
C                                                     Serial PM code
C	     16 November 1997  Anatoly Klypin (aklypin@nmsu.edu)
C	                           Astronomy Department, NMSU
C-------------------------------------------------
C	       NROW = number of particles in one dimension
C	       NGRID= number of cells        in one dimension
C          AEXPN= expansion parameter = 1/(1+z)
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMmesh.h'

C			                                     Read data and open files
      OPEN(16,FILE='Result.DAT',STATUS='UNKNOWN')
      CALL RDTAPE
      CALL SetWeight
         write (*,*) ' RDTAPE is done'
      WRITE (*,'(A,$)') ' Enter number of steps to go => '
      READ (*,*) NUMBS		         ! Make this number of steps
      IF(AEXPN.GE.1.)THEN         ! change this if you need to run
	      WRITE (*,*) ' Cannot run over a=1' !  beyond a=1
	      STOP
      ENDIF

C					                                     Main loop
      DO 200 IRN=1,NUMBS
         CALL DENSIT            ! Define density
            write (*,*)         ' Density is ok'
         CALL POTENT            ! Define potential
            WRITE (*,*)         ' POTENT IS DONE'
         CALL MOVE              ! Move particles
            WRITE (*,*)         ' MOVE   IS DONE'
         CALL ADDTIME           ! Advance time 
      IF(AEXPN.GE.1.) GOTO 300  ! Do again if a < 1
200   CONTINUE

300   CALL WRTAPE               ! Write data to the disk
      STOP
      END
C--------------------------------------------------
C	                                               Advance Aexpn, Istep, tIntg,...
C	                                              AEXPN = currnet expansion parameter
C                                                   ISTEP = current step
C                                                  ASTEP = step in the expansion parameter			    
      SUBROUTINE ADDTIME
C--------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMmesh.h'
      COMMON /ENERG/	 ENKIN,ENPOT

      ISTEP = ISTEP + 1
      AEXPN = AEXPN + ASTEP
C		                     Energy conservation
      IF(ISTEP.EQ.1)THEN
        EKIN1 = EKIN
        EKIN2 = 0.
        EKIN  = ENKIN
        AU0   = AEXP0*ENPOT
        AEU0  = AEXP0*ENPOT + AEXP0*(EKIN+EKIN1)/2.
        TINTG = 0.
        WRITE (*,40) ISTEP,AEXPN,EKIN,ENPOT,AU0,AEU0
        WRITE (16,40) ISTEP,AEXPN,EKIN,ENPOT,AU0,AEU0
40      FORMAT('**** STEP=',I3,' A=',F10.4,' E KIN=',E12.4,
     .		    ' E POT=',E12.4,/'      AU0,AEU0=',2E12.4)
      ELSE
        EKIN2 = EKIN1
        EKIN1 = EKIN
        EKIN  = ENKIN
        TINTG = TINTG +ASTEP*(EKIN1 +(EKIN -2.*EKIN1 +EKIN2)/24.)
        ERROR = ((AEXPN-ASTEP)*((EKIN+EKIN1)/2.+ENPOT)-AEU0+TINTG)/
     .                  ((AEXPN-ASTEP)*ENPOT)*100.
        WRITE (*,50)  ISTEP,AEXPN,ERROR,EKIN,ENPOT,TINTG
        WRITE (16,50) ISTEP,AEXPN,ERROR,EKIN,ENPOT,TINTG
      ENDIF
50    FORMAT('*** ',I4,' A=',F7.4,' Error(%)=',f7.2,
     .		       ' Ekin=',E11.3,' Epot=',E11.3,' Intg=',E11.3)
      RETURN
      END
C------------------------------------------------------------
C
C     Advance each particle:	    dA	  AEXPN     dA
C	   by one step	     I______._______I_______.______I	  ->  A
C			    i-1     .	    i	    .	  i+1	step
C				    .	  {Fi}	    .	   .
C				  { vx }  { x }     .	   .
C				  { vy }  { y }     ^	   .
C				    ._______________^	   .
C					    .		   ^
C					    .______________^
C
C			  0.5
C		  dP = - A     * Grad(Fi) * dA ; A =AEXPN
C			  i		i
C				   3/2
C		  dX =	 P(new)/A	* dA ; A      =AEXPN+dA/2
C				 i+1/2		i+1/2
C
      SUBROUTINE MOVE
C------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMmesh.h'
      COMMON /ENERG/	ENKIN,ENPOT
C                                    PCONST = factor to change velocities
C                                   XCONST = factor to change coordinates
C	                               Note: 0.5 is needed in Pconst because
C		                          Fi(i+1)-Fi(i-1) is used as gradient
      PCONST = - SQRT(AEXPN/(Om0+Oml0*AEXPN**3+Ocurv*AEXPN))*ASTEP*0.5
      Ahalf  =   AEXPN+ASTEP/2.
      XCONST =   ASTEP/
     .           SQRT(Ahalf*(Om0+Oml0*Ahalf**3+Ocurv*Ahalf))/Ahalf
	   SVEL = 0.                      ! counter for \Sum(v_i**2)
	   SPHI = 0.                      ! counter for \Sum(phi_i)
	   XN   = FLOAT(NGRID)+1.-1.E-8   ! N+1
	   YN   = FLOAT(NGRID)            ! N
      ifile      =1
      If(Nspecies.eq.0)Then ! old case: 1 complete set
         Npages =NROW          ! Number of pages
         N_in_last=NPAGE       ! Number of particles in last page
      Else                             ! multiple masses
         N_particles =lspecies(Nspecies)   ! Total number of particles
         Npages = (N_particles -1)/NPAGE +1
         N_in_last=N_particles -NPAGE*(Npages-1)
      EndIf
c      write (*,*) ' Pages=',Npages,' Species=',Nspecies
c      write (*,*) ' N_in_last=',N_in_last

      DO  IROW=1, Npages         ! Loop over particle pages
            In_page =NPAGE
            If(IROW.eq.Npages)In_page =N_in_last
c            write (*,*)' Move page=',IROW,' file=',ifile,' N=',In_page
            iL = NPAGE*(IROW-1)
         CALL GETROW(IROW,ifile) ! read in a page of particles
	    DO  IN=1, In_page          ! Loop over particles
  	       X=XPAR(IN)
	       Y=YPAR(IN)
	       Z=ZPAR(IN)
	       VVX=VX(IN)
	       VVY=VY(IN)
	       VVZ=VZ(IN)
                Ipart =IN+iL                     ! current particle number
                WPAR =iWeight(Ipart)   ! particles weight
 	       I=INT(X)
	       J=INT(Y)
	       K=INT(Z)
	       D1=X-FLOAT(I)
	       D2=Y-FLOAT(J)
	       D3=Z-FLOAT(K)
	       T1=1.-D1
	       T2=1.-D2
	       T3=1.-D3
	       T2T1 =T2*T1
	       T2D1 =T2*D1
	       D2T1 =D2*T1
	       D2D1 =D2*D1
	       I1=I+1
	          IF(I1.GT.NGRID)I1=1
	       J1=J+1
	          IF(J1.GT.NGRID)J1=1
	       K1=K+1
	          IF(K1.GT.NGRID)K1=1
	       K2=K+2
	          IF(K2.GT.NGRID)K2=K2-NGRID
	       K3=K-1
	          IF(K3.LT.1    )K3=NGRID
	       F111 =FI(I ,J ,K )  !  Read potential to Fij vars
	       F211 =FI(I1,J ,K )
	       F121 =FI(I ,J1,K )
	       F221 =FI(I1,J1,K )
   
	       F112 =FI(I ,J ,K1)
	       F212 =FI(I1,J ,K1)
	       F122 =FI(I ,J1,K1)
	       F222 =FI(I1,J1,K1)
   
	       F113 =FI(I ,J ,K2)
	       F213 =FI(I1,J ,K2)
	       F123 =FI(I ,J1,K2)
	       F223 =FI(I1,J1,K2)
   
	       F110 =FI(I ,J ,K3)
	       F210 =FI(I1,J ,K3)
	       F120 =FI(I ,J1,K3)
	       F220 =FI(I1,J1,K3)
   
	       I2=I+2
	          IF(I2.GT.NGRID)I2=I2-NGRID
	       J2=J+2
	          IF(J2.GT.NGRID)J2=J2-NGRID
	       F311 =FI(I2,J ,K )
	       F321 =FI(I2,J1,K )
	       F131 =FI(I ,J2,K )
	       F231 =FI(I1,J2,K )
   
	       F312 =FI(I2,J ,K1)
	       F322 =FI(I2,J1,K1)
	       F132 =FI(I ,J2,K1)
	       F232 =FI(I1,J2,K1)
   
	       I0=I-1
	          IF(I0.LT.1)I0=NGRID
	       J0=J-1
	          IF(J0.LT.1)J0=NGRID
	       F011 =FI(I0,J ,K )
	       F021 =FI(I0,J1,K )
	       F101 =FI(I ,J0,K )
	       F201 =FI(I1,J0,K )
   
	       F012 =FI(I0,J ,K1)
	       F022 =FI(I0,J1,K1)
	       F102 =FI(I ,J0,K1)
	       F202 =FI(I1,J0,K1)
C				 Find {2*gradient} in nods
	          GX111 =F211 -F011
	          GX211 =F311 -F111
	          GX121 =F221 -F021
	          GX221 =F321 -F121
       
	          GX112 =F212 -F012
	          GX212 =F312 -F112
	          GX122 =F222 -F022
	          GX222 =F322 -F122
       
	          GY111 =F121 -F101
	          GY211 =F221 -F201
	          GY121 =F131 -F111
	          GY221 =F231 -F211
       
	          GY112 =F122 -F102
	          GY212 =F222 -F202
	          GY122 =F132 -F112
	          GY222 =F232 -F212
       
	          GZ111 =F112 -F110
	          GZ211 =F212 -F210
	          GZ121 =F122 -F120
	          GZ221 =F222 -F220
       
	          GZ112 =F113 -F111
	          GZ212 =F213 -F211
	          GZ122 =F123 -F121
	          GZ222 =F223 -F221
C				 Interpolate to the point
      GX=PCONST*(T3*(
     .		    T2T1*GX111+T2D1*GX211 +D2T1*GX121+D2D1*GX221 )+
     .		 D3*(
     .		    T2T1*GX112+T2D1*GX212 +D2T1*GX122+D2D1*GX222 ))

      GY=PCONST*(T3*(
     .		    T2T1*GY111+T2D1*GY211 +D2T1*GY121+D2D1*GY221 )+
     .		 D3*(
     .		    T2T1*GY112+T2D1*GY212 +D2T1*GY122+D2D1*GY222 ))

      GZ=PCONST*(T3*(
     .		    T2T1*GZ111+T2D1*GZ211 +D2T1*GZ121+D2D1*GZ221 )+
     .		 D3*(
     .		    T2T1*GZ112+T2D1*GZ212 +D2T1*GZ122+D2D1*GZ222 ))

C				 Find potential of the point
      FP=	 T3*(
     .		    T2T1*F111+T2D1*F211 +D2T1*F121+D2D1*F221 )+
     .		 D3*(
     .		    T2T1*F112+T2D1*F212 +D2T1*F122+D2D1*F222 )
	    SPHI = SPHI + FP*WPAR

          If(ipart.le.3)write (70,80) ipart,IROW,X,Y,Z,VVX,VVY,VVZ,
     &                     WPART,GX,GY,GZ,PCONST,XCONST
 80       format(' i=',2i7,' x=',3g11.4,' v=',3g11.4,/3x,f7.3,' g=',
     &                 3g11.4,' const=',2g11.4)

	    VVX =VVX+GX             ! Move points
	    VVY =VVY+GY
	    VVZ =VVZ+GZ
	    X	=X  +VVX*XCONST
	    Y	=Y  +VVY*XCONST
	    Z	=Z  +VVZ*XCONST
		  IF(X.LT.1.)X=X+YN     ! Periodical conditions
		  IF(X.GE.XN)X=X-YN
		  IF(Y.LT.1.)Y=Y+YN
		  IF(Y.GE.XN)Y=Y-YN
		  IF(Z.LT.1.)Z=Z+YN
		  IF(Z.GE.XN)Z=Z-YN
C			                                            Kinetic energy
	    SVEL=SVEL+(VVX**2+VVY**2+VVZ**2)*WPAR
C			                                        
	     XPAR(IN)=X            ! Write new coordinates
	     YPAR(IN)=Y
	     ZPAR(IN)=Z
	     VX(IN)=VVX
	     VY(IN)=VVY
	     VZ(IN)=VVZ
      ENDDO
C			   Write row to disk
       CALL WRIROW(IROW,ifile)
      ENDDO
C			   Set energies:
C			   Kin energy now at A(i+1/2)
C			   Pot energy		at A(i)
      ENKIN = SVEL / 2. / (AEXPN+ASTEP/2.)**2
      ENPOT = SPHI /2.
      RETURN
      END
C-------------------------------------------------
C	    Find potential on Grid FI:	DENSITY    ->	POTENTIAL
C
C		   O 1		    ^ - Fourier component
C		   |
C	     1	   |-4	 1	^      ^	2Pi
C	     O-----O-----O     Fi    =	Rho	/ (2cos(---  (i-1))+
C		   |	   i,j		i,j	Ngrid
C		   |
C		   O 1			  2Pi
C				       2cos(---  (j-1))-4)
C		       ^			Ngrid
C		       Fi	= 1 (?)
C			 11
C		   2
C		NABLA  Fi = 3/2  /A * (Rho - <Rho>) ;
C		   X
C			      <Rho> = 1

      SUBROUTINE POTENT
C---------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMmesh.h'
      DIMENSION       GREENC(NGRID)

C			Set  a coefficient in Poisson eq.
C	       		  (2*NGRID)**3 - from FFT
      TRFI=1.5/AEXPN/(2.*NGRID)**3*Om0
C			Set Green function components
      P16 = 2.*3.14159265
      NGRID2=NGRID/2+2
      DO I=1,NGRID
	       XX =P16*(I-1.)/NGRID
	       GREENC(I) =2.*COS(XX)
	       IF(I.GE.NGRID2) GREENC(I) =-GREENC(I)
      END DO
C			Ngrid = 2**IQ
		       IQ = INT(ALOG(FLOAT(NGRID))/ALOG(2.)+0.5)
      Ndex=1
      IB1  =3
C					  ALONG X-DIRECTION
      CALL SETF67(IB1,IQ)
100   CONTINUE
      DO K=1,NGRID
	    DO J=1,NGRID
		  DO I=1,NGRID
			Zf(I) =FI(I,J,K)
		  END DO

		  CALL FOUR67(IB1,IQ)

		  DO I=1,NGRID
			FI(I,J,K) =Yf(I)
		  END DO
	    END DO
C					  ALONG Y-DIRECTION
	    DO I=1,NGRID
		  DO J=1,NGRID
			Zf(J) =FI(I,J,K)
		  END DO

		  CALL FOUR67(IB1,IQ)

		  DO J=1,NGRID
			FI(I,J,K) =Yf(J)
		  END DO
	    END DO
      END DO
c					  EXIT IF IT IS THE SECOND LOOP
      IF(Ndex.EQ.2) RETURN
C					  ALONG Z-DIRECTION

      DO J=1,NGRID
	    IB1 =3
	    DO I=1,NGRID
		  DO K=1,NGRID
			Zf(K) =FI(I,J,K)
		  END DO

		  CALL FOUR67(IB1,IQ)

		  DO K=1,NGRID
			FI(I,J,K) =Yf(K)
		  END DO
	    END DO
C					  BACK IN Z
	    A3 = GREENC(J) -6.
	    IB1= 4
	    DO I=1,NGRID
		  A2 = GREENC(I) + A3
		  DO K=1,NGRID
			A1 =A2 +GREENC(K)
			IF(ABS(A1).LT.1.E-4) A1=1.
			Zf(K) =FI(I,J,K)*TRFI/A1
		  END DO

		  CALL FOUR67(IB1,IQ)

		  DO K=1,NGRID
			FI(I,J,K) =Yf(K)
		  END DO
	    END DO
      END DO
      Ndex =2
      GOTO 100

      END

C------------------------------------------------------
      SUBROUTINE DENSIT
C------------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMmesh.h'
      REAL*8      summass, summ2
	      XN   =FLOAT(NGRID)+1.-1.E-7
	      YN   =FLOAT(NGRID)
C				       Subtract mean density
      DO M3=1,NGRID
       DO M2=1,NGRID
	      DO M1=1,NGRID
	        FI(M1,M2,M3) = -1.
	      END DO
       END DO
      END DO

      ifile      =1
      If(Nspecies.eq.0)Then ! old case: 1 complete set
         Npages =NROW          ! Number of pages
         N_in_last=NPAGE       ! Number of particles in last page
      Else                             ! multiple masses
         N_particles =lspecies(Nspecies)   ! Total number of particles
         Npages = (N_particles -1)/NPAGE +1
         N_in_last=N_particles -NPAGE*(Npages-1)
      EndIf
c      write (*,*) ' Pages=',Npages,' Species=',Nspecies
c      write (*,*) ' N_in_last=',N_in_last

      DO  IROW=1, Npages         ! Loop over particle pages
            In_page =NPAGE
            If(IROW.eq.Npages)In_page =N_in_last
c            write (*,*)' Move page=',IROW,' file=',ifile,' N=',In_page
            iL = NPAGE*(IROW-1)
         CALL GETROW(IROW,ifile) ! read in a page of particles
	    DO  IN=1, In_page          ! Loop over particles
                Ipart =IN+iL                     ! current particle number
                WPAR =iWeight(Ipart)   ! particles weight
	       X=XPAR(IN)
	       Y=YPAR(IN)
	       Z=ZPAR(IN)
	       I=INT(X)
	       J=INT(Y)
	       K=INT(Z)
c                 If(I.le.0)write (*,*) ' X:',X,Y,Z,I,' Irow=',IROW,IN,ifile
c                 If(J.le.0)write (*,*) ' Y:',X,Y,Z,I,' Irow=',IROW,IN,ifile
c                 If(K.le.0)write (*,*) ' Z:',X,Y,Z,I,' Irow=',IROW,IN,ifile
	       D1=X-FLOAT(I)
	       D2=Y-FLOAT(J)
	       D3=Z-FLOAT(K)
	       T1=1.-D1
	       T2=1.-D2
	       T3=1.-D3
	       T2W =T2*WPAR
	       D2W =D2*WPAR
	       I1=I+1
	          IF(I1.GT.NGRID)I1=1
	       J1=J+1
	          IF(J1.GT.NGRID)J1=1
	       K1=K+1
	          IF(K1.GT.NGRID)K1=1
             IF(Ipart.eq.1)Then 
                write (70,90) ipart, WPAR,X,Y,Z,
     &                              i,j,k,T1,T2,T3
 90             format(' i=',i6,' w=',f8.2,3f8.3,3i3,/
     &                        12x,3f8.3)
c                STOP
             EndIf

		     FI(I ,J ,K ) =FI(I ,J ,K ) +T3*T1*T2W
		     FI(I1,J ,K ) =FI(I1,J ,K ) +T3*D1*T2W
		     FI(I ,J1,K ) =FI(I ,J1,K ) +T3*T1*D2W
		     FI(I1,J1,K ) =FI(I1,J1,K ) +T3*D1*D2W
   
		     FI(I ,J ,K1) =FI(I ,J ,K1) +D3*T1*T2W
		     FI(I1,J ,K1) =FI(I1,J ,K1) +D3*D1*T2W
		     FI(I ,J1,K1) =FI(I ,J1,K1) +D3*T1*D2W
		     FI(I1,J1,K1) =FI(I1,J1,K1) +D3*D1*D2W
	    ENDDO
      ENDDO 
      summass =0.
      summ2     =0.
      do k=1,NGRID
         Do j=1,NGRID
            Do i=1,NGRID
               dens =FI(i,j,k)
               summass =summass +dens
               summ2     =summ2     +dens**2
            Enddo 
            Enddo 
            Enddo 
            write (*,*) ' Summ density=',summass
            write (*,*) ' Sum2 density=',summ2

      RETURN
      END

C _______________________ START 3-D SIMULATIONS
C
C                         Klypin, August 1993
C
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR.h'	  
C		   NROW = number of particles in 1 dimension
C		   NGRID= number of cells        in 1 dimension
C		   Npage =  number of particles per page = NROW**2
C


      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Par(6),ns,qqscaleb,QSCALE
      COMMON / KINENRG/ SKINE,SX,SY,SZ,SX2,SY2,SZ2
      Character  Hd*5,Tail*4
      DATA PI		/3.1415926535/

      Hd  ='PMcrs'
      Tail='.DAT'
     
      CALL InitValues(NBYTE,SCALEL)
      write (*,*) ' InitValues is done. N bytes=',NBYTE
      NspecM   = Levels  ! Nspecies -1
      Nmin_lev = Levels  ! Nspecies
      write (*,*) ' Max resolution Level=',NspecM,
     &               ' Min Level=',Nmin_lev
      write (16,*) ' Max resolution Level=',NspecM,
     &               ' Min Level=',Nmin_lev
      If(Nspecies.ne.0.and.2**(Nspecies-1).ne.Lblock)Then
         write (*,*) ' Wrong number of Levels for mass refinement (',
     &                  Nspecies,') Block size =',Lblock,
     &                  '       2**(Levels-1) must = Block size'
      Endif 
      OPEN(UNIT=9,FILE='PMcrd.DAT',form='unformatted')
      write (9)             ! this clears old header file
      CLOSE (9)
      CALL RDTAPE                  ! this opens files on disk

      OPEN(UNIT=16,FILE='RESNEW.DAT')
      write (16,*) ' Seed=',Nseed
       AEXP0 = AEXPN
       AEXPV = AEXPN - ASTEP/2.
C                                    set mask for multiple mass resolution
       If(Nspecies.ne.0)Then
                CALL ZeroMASK(Nmin_lev)
c                If(Nspecies.ge.2)Then
c                   Open(30,file='SelCoords.DAT')
c                   CALL SetMASK(NspecM)
c                EndIf
      EndIf
C			                   get a realization of spectrum in /GRID/
       NRAND =Nseed
c       CALL SPectr_CR(NRAND)
c       If(Levels.gt.1)Then
           CALL SPECTR(NRAND,1)  ! set spectrum for higher levels
           CALL ZERO_SP         ! remove harmonics included at lower levels
c       Endif 
C			                        get the displacement vector by FFT
       IFOUR = INT(ALOG(FLOAT(NROW))/ALOG(2.)+0.5)
       Write (*,*) ' Ifour =',IFOUR,' Nrow=',NROW
       CALL VECTOR(IFOUR)
	    write (*,*) ' SPECTR is done. IFOUR = ',IFOUR,' Alpha=',
     &                   (ALPHA(i),i=1,Levels)
        Fact =  sqrt(Om0+Oml0*AEXPV**3+Ocurv*AEXPV)
        Do Lv =1,Levels
           VCONS(Lv) = -ALPHA(Lv)/(2.*PI/NGRID)*(AEXPV/AEXP0)*
     &                              SQRT(AEXPV)*Fact*2**(Lv-1)
           XCONS(Lv) =	 ALPHA(Lv)/(2.*PI/NGRID)*(AEXPN/AEXP0)
     &                               *2**(Lv-1)
        Enddo 
       QFACT =  FLOAT(NGRID)/FLOAT(NROW)
                      SKINE = 0.
                      SX    = 0.
                      SY    = 0.
                      SZ    = 0.
                      SX2   = 0.
                      SY2   = 0.
                      SZ2   = 0.

C			           find x,v and write to file, page by page
       Do i=1,Nspecies
          lspecies(i) =0
       Enddo 
       If(Nspecies.eq.0)Then     ! old code with one set                    
         DO  KROW = 1, NROW
            CALL SETXV(XCONS(1),VCONS(1),KROW)
c            CALL SETtest(XCONS,VCONS,KROW,NRAND)
	      CALL WRIROW(KROW,1)
         ENDDO
         lspecies(1) =NROW**3
         wspecies(1) =PARTW
         Wtotal = wspecies(1)*lspecies(1)
           EKIN = 0.5*SKINE/AEXPV**2*PARTW
           DP   = NROW**3
           SX   = SX/DP
           SY   = SY/DP
           SZ   = SZ/DP
           SX2  = SQRT(SX2/DP)
           SY2  = SQRT(SY2/DP)
           SZ2  = SQRT(SZ2/DP)
           WRITE (*,'('' Displacement of a particle: MEAN'',3F9.4)')
     .             SX,SY,SZ
           WRITE (*,'('' in cell units               RMS '',3F9.4)')
     .             SX2,SY2,SZ2
           WRITE (16,'('' Displacement of a particle: RMS'',3F9.4)')
     .             SX2,SY2,SZ2
           Veloc=sqrt( SKINE/AEXPV**2/NROW**3)*SCALEL/NGRID*
     .             100.*hubble
           WRITE (*,'('' Ekin='',E12.4,'' Veloc_cold(km/s)='',F8.2,
     .                     '' Weght per cell='',f8.2,'' (must be 1)'')')
     .            EKIN,Veloc,Wtotal/NGRID**3
           WRITE (16,'('' Ekin='',E12.4,'' Veloc_cold(km/s)='',F8.2,
     .                     '' Weght per cell='',f8.2,'' (must be 1)'')')
     .            EKIN,Veloc,Wtotal/NGRID**3
      Else
C                          find x,v for multiple mass resolution code 
         Icurrent    =0                         ! current particle
         Iprevious  =0
         Jspecies   = 0
            Do Lv =Levels,1,-1
               write (*,*) ' Go to BLOCKS. Level =',Lv
                CALL BLOCKS(Lv,Icurrent)   
                If(Icurrent.gt.Iprevious)Then
                   Jspecies             =Jspecies +1
                   lspecies(Jspecies)   =Icurrent
                   wspecies(Jspecies)   =PARTW *8/8**Lv
                   Iprevious            =Icurrent
                Endif 
            Enddo 
            Nspecies = Jspecies
           Vscale =ScaleL*100.*hubble/NGRID
      CALL WriteData(Vscale,AexpV,Wtotal)
      CALL Species_Print(Wtotal_o)      ! rearrange species                     
            EKIN = 0.5*SKINE/AEXPV**2       
           WRITE (*,'('' Ekin='',E12.4,'' Weght per cell='',g12.5,
     .                   '' (must be 1)'')')   EKIN,Wtotal/NGRID**3
           WRITE (16,'('' Ekin='',E12.4,'' Weght per cell='',g12.5,
     .                   '' (must be 1)'')')   EKIN,Wtotal/NGRID**3
      Endif 
C			        
      CALL WRTAPE   ! write header and control data
C                      write pt.dat file: time-step for particles
      If(Nspecies.eq.0)Then
         Nparticles =lspecies(1)
      Else
         Nparticles =lspecies(Nspecies)
      EndIf
      Do ic1 =1,Nparticles
         XPt(ic1) =astep
      Enddo 
      open ( 60 , file = 'pt.dat' , form = 'unformatted' )
      write(60) (XPt(ic1),ic1=1,Nparticles)
      write (*,*) ' pt=', (XPt(ic1),ic1=1,10)
      STOP
      END
C--------------------------------------------------
C                                                     sqrt(Power spectrum)
C                                                           k = (2pi/L) wk
      REAL  FUNCTION TRUNF(wk)
C--------------------------------------------------
      INCLUDE 'PMparameters.h'
      PARAMETER (NSPEC =NROW/2)
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Par(6),ns,qqscaleb,QSCALE
      Real                 ns,k
c      IF (WK.GE.FLOAT(NSPEC)) THEN
c	       TRUNF =0.
c	       RETURN
c      ENDIF
      If(Par(6).ne.0.)Then   ! Holtzman approx
        k = QSCALE*wk
        sk= sqrt(k)
        TRUNF = k**(ns/2.) /
     .         (1.+sk*(Par(2)
     .            +sk*(Par(3)
     .            +sk*(Par(4)
     .            +sk*(Par(5) )))) )**(Par(6))
      Else                   ! BBKS + Sugiyama approx
c        Gammaeff =Om*hsmall/exp(Omb*(1.+sqrt(hsmall/0.5)/Om))
c        Q = wk/hsmall/Gammaeff
        k = QSCALE*wk
        Q = k*qqscaleb
        TRUNF = k**(ns/2.)* LOG(1.+Par(1)*Q)/(Par(1)*Q)/
     .          sqrt(sqrt(1.+Q*(Par(2)+
     .                  Q*(Par(3)**2+
     .                  Q*(Par(4)**3+
     .                  Q*(Par(5)**4) )))))
      EndIf
      RETURN
      END
C*********************************************************************
C	   Power spectrum for CDM. Wk-  wavenumber(Mpc^-1, h=0.5)
C                         P = wk *T^2(k)
C                         QSCALE = 2pi/Box_size,  QS =hubble**(-2)
c      FUNCTION TRUNF(WK)
c      COMMON / TRUNCOM/ QSCALE,g,gy
c      COMMON / TRUNCDM/ QS,A1,A2,A3,A4,A5,A32,A43,A54
c       Q = QSCALE*QS*WK
c       TRUNF = sqrt( WK*
c     +		 (LOG(1.+A1*Q)/(A1*Q))**2/
c     +		 SQRT(1.+Q*(A2 +Q*(A32   +Q*(A43+Q*A54)))) )
c
c      RETURN
c      END

C*********************************************************************
C			  INITIALIZE CONSTANTS:
C			      Scalel    =length of square in MPC
C			      AEXPN =expansion factor (current)
C			      ASTEP	  =increment of expansion factor: AEXPN =AEXP_0+N*ASTEP
C                     PARTW	=weight of a particle: total 'mass' per cell must be unity
c                                          even for LCDM or OCDM 
C			      AMPLT	=amplitude of perturbations inside the simulation box
C			      NBYTE	=record length in bytes
C
      SUBROUTINE InitValues(NBYTE,SCALEL)
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR.h'
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Par(6),ns,qqscaleb,QSCALE
      COMMON / FERMI  / Vscale
      Real                 ns      
      Character            Answer*1
      Real                 INPUT
      DATA PI		         /3.1415926535/

       Write (*,*) 'Would you like to use a model provided in cdm.fit '
       Write (*,*) 'or your own model?' 
       Write (*,'(A,$)') ' Enter Yes for cdm.fit;  No for your model ='
       Read  (*,'(A)')  Answer
       HEADER='N=128x256 L=20h-1CDMsig=0.239 z=30-----------'
       write (*,*) '------ Enter Header for the run up to 45 characters'
       write (*,*) '       Example:'
       write (*,'(A)') HEADER                                   
       read  (*,'(A)') HEADER
       write (*,'(A)') HEADER
       AEXPN =INPUT(' Initial expansion parameter (0-1)=')
       ASTEP =INPUT(' Step of the expansion parameter  =')
       Do i=1,Levels
          AMPLT(i) =INPUT(' Amplitude of density fluctuations=')
       Enddo 
       ns    =INPUT(' Slope of the Power spectrum     n=')
       SCALEL=INPUT(' Box size (Mpc/h)                 =')
       Ocurv =INPUT(' Omega_curvature   at present     =')
       Nseed =INPUT(' Random seed (Integer  1-2^31)    =') 
       If(Answer.eq.'Y' .or. Answer.eq.'y')Then
          CALL MODEL(hsmall)
          hubble=hsmall
          Om0   =Om
          Oml0  =1. -Om0 -Ocurv
       Else
       write (*,*) ' You use your cosmological model.'
       write (*,*) ' Be sure you provide routine TRUNF'
       hubble=INPUT(' The Hubble constant (h=H/100)    =')
       Om0   =INPUT(' Omega_0 matter    at present     =')
       Oml0  =INPUT(' Omega_lambda      at present     =')
       EndIf
       SCALEL=SCALEL/hubble   ! scale it to real megaparsecs      
       NBYTE = NPAGE*6*4
       Nspecies =INPUT(' Number of mass species   = ')
             W     = (FLOAT(NGRID)/FLOAT(NROW))**3
            PARTW = W 
      If(Nspecies.eq.0)Then  ! old constant mass resolution
              write(*,*) ' You use PM code with one particle set '
       Else    ! multiple mass resolution
              write(*,*) 
              write(*,*) ' You use multiple mass resolution'
       endif 
       ISTEP = 0
       TINTG = 0.
       AU0   = 0.
       AEU0  = 0.
       EKIN  = 0.
       EKIN1 = 0.
       EKIN2 = 0.
       NROWC = NROW
       NGRIDC= NGRID
	     QSCALE = 2.*PI/SCALEL
	     QS     = hubble**(-2)
        write (*,*) ' Qscale=',QSCALE,SCALEL,ns

      RETURN
      END
C________________________________________Read parameters of the model
C                                 Om       = Omega_0
C                                 Omb     = Omega_baryon
C                                 Omnu  = Omega_neutrino
C                                 hsmall  = hubble constant
C                                 Par      = fitting parameters
C                                 Par(6) = 0  --- bbks-style+Hu&Sugiyama
C                                 Par(6) ne 0 --- holtzman-style
      SUBROUTINE MODEL(hsmall)
C---------------------------------------
      INCLUDE 'PMparameters.h'
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Par(6),ns,qqscaleb,QSCALE
      Real                 ns,INPUT
      Character             Header1*79

      OPEN(2,file='cdm.fit')
      Line1 =INPUT(' Enter Line Number in cdm.fit     =')
      Read(2,'(A)') Header1
      If(Line1.gt.2)Then
         Do i=1,Line1-2
            Read (2,*) a
         EndDo
      EndIf
      Read (2,*) Om,Omb,Omc,Omnu,hsmall,Par
      CLOSE (2) 
      
      theta = 2.726/2.7  ! = T_cmb/2.7
      Ob0   =Omb/Om      ! Hu&Sugiyama fitting
      Omh2  =Om*hsmall**2
      a1    =(46.9*Omh2)**0.670*(1.+(32.1*Omh2)**(-0.532))
      a2    =(12.0*Omh2)**0.424*(1.+(45.*Omh2)**(-0.582))
      alpha =1./a1**Ob0/a2**(Ob0**3)
      qqscaleb = theta**2/(1.-Ob0)**0.60/sqrt(alpha)/Omh2

      Write (*,20)Om,Omb,Omc,Omnu,hsmall,Par
c      Write (16,20)Om,Omb,Omc,Omnu,hsmall,Par
 20   Format(' Model: Om_0=',F5.3,' Om_baryon=',F5.3,
     .       ' Om_cold=',F5.3,' O_nu=',F5.3,
     .       ' hsmall=',F4.2,/8x,'Parameters=',(6G9.3))
      Return
      End
C------------------------------------------------
C                              Clear MASK for multiple mass resolution                             
C                               Initiat to level Nmin_lev
      SUBROUTINE ZeroMask(Nmin_lev)
C------------------------------------------------
      INCLUDE 'PMparameters.h'	    
      INCLUDE 'PMinitialCR.h'	  

C$omp  parallel do default(shared)
C$omp& private(MK3,MK2,MK1)
         DO  MK3 = 1,Nblocks
         DO  MK2 = 1,Nblocks
         DO  MK1 = 1,Nblocks
	        iMask(MK1,MK2,MK3) =Nmin_lev
         ENDDO
         ENDDO
         ENDDO
      RETURN
      END
C------------------------------------------------
C                       Set MASK for multiple mass resolution  
C                               Read particles with lagrangian coordinates
C                                                to set the mask                           
C                               Block   = 1 = low resolution
C                                       = 2 = higher resolution
C                                       = 3 = even higher resolution
C               After the mask is set, make maximum resolution NspecM
C
      SUBROUTINE SetMask(NspecM)
C------------------------------------------------
      INCLUDE 'PMparameters.h'	  
      INCLUDE 'PMinitialCR.h'	  
      Dimension nLevel(10)
      Character*70 Line

      Do i=1,5
         Read(30,'(A)') Line
         Write(*,'(A)') Line
      EnDDo
      Nlines =0
 10   Read(30,*,end=50,err=50) i,xw,yw,zw,
     +            vwx,vwy,vwz,ww,im,jm,km
           Nlines =Nlines +1
           write (*,*) ' Block=',im,jm,km
           If(im.lt.0.or.im.gt.Nblocks)Then
              write (*,*) ' wrong x_block: ',im,jm,km,' Line=',Nlines
              Stop
           EndIf
            If(jm.lt.0.or.jm.gt.Nblocks)Then
              write (*,*) ' wrong y_block: ',im,jm,km,' Line=',Nlines
              Stop
           EndIf
            If(km.lt.0.or.km.gt.Nblocks)Then
              write (*,*) ' wrong z_block: ',im,jm,km,' Line=',Nlines
              Stop
           EndIf
c             If(iMask(im,jm,km).ne.0)Then
c              write (*,*) ' Occupied block: ',im,jm,km,' Line=',Nlines
c              write (*,*) '                 Block=',iMask(im,jm,km)
c              Stop
c           EndIf
           
           iMask(im,jm,km) =NspecM     ! mark high resolution block
               Do ik =-1,1
               k =km +ik
               If(k.le.0)k=k+Nblocks
               If(k.gt.Nblocks)k=k-Nblocks
               Do ij =-1,1
                  j =jm +ij
                  If(j.le.0)j=j+Nblocks
                  If(j.gt.Nblocks)j=j-Nblocks
                  Do ii =-1,1
                      i =im +ii
                      If(i.le.0)i=i+Nblocks
                      If(i.gt.Nblocks)i=i-Nblocks
                      ind =abs(ik)+abs(ij)+abs(ii) ! only seven blocks in crest
                                ! are marked out
                      If(iMask(i,j,k).le.0.or.iMask(i,j,k).gt.Nspecies)
     +                     Then
                         Stop
                      Endif 
                      If(ind.le.1)Then
                          iMask(i,j,k)=NspecM ! change mask
                      Endif 
                  ENDDO
                ENDDO
                ENDDO
            GoTo 10
C                      Change the mask: iteratevely add layers of lower resolution
 50        write(*,*) ' Total Lines read=',Nlines
       DO kSpec =Nspecies-1,2,-1     !
         DO  MK3 = 1,Nblocks     ! find blocks adjasent to filled blocks
         DO  MK2 = 1,Nblocks     ! mark them with kSpec =Nspecies-1, -2, ..1
         DO  MK1 = 1,Nblocks
            iM =      iMask(MK1,MK2,MK3)
            If(iM.eq.kSpec+1)Then          ! change to kSpec if not high res
               Do ik =-1,1
               k =MK3 +ik
               If(k.le.0)k=k+Nblocks
               If(k.gt.Nblocks)k=k-Nblocks
               Do ij =-1,1
                  j =MK2 +ij
                  If(j.le.0)j=j+Nblocks
                  If(j.gt.Nblocks)j=j-Nblocks
                  Do ii =-1,1
                     i =MK1 +ii
                     If(i.le.0)i=i+Nblocks
                     If(i.gt.Nblocks)i=i-Nblocks
                     If(iMask(i,j,k).lt.kSpec)iMask(i,j,k)=kSpec ! change mask
                  ENDDO
               ENDDO
               ENDDO
            EndIf
         ENDDO
         ENDDO
         ENDDO
       Enddo 
       If(NspecM.lt.Nspecies)Then ! change maximum resolution to NspecM

C$omp  parallel do default(shared)
C$omp& private(MK3,MK2,MK1)
         DO  MK3 = 1,Nblocks     
         DO  MK2 = 1,Nblocks     
         DO  MK1 = 1,Nblocks
            iM =      iMask(MK1,MK2,MK3)
            If(iM.gt.NspecM)iMask(MK1,MK2,MK3)=NspecM
         ENDDO
         ENDDO
         ENDDO
       Endif 

       Do i=1,Nspecies            ! count marked blocks
          nLevel(i)=0
       Enddo 
         DO  MK3 = 1,Nblocks
         DO  MK2 = 1,Nblocks
         DO  MK1 = 1,Nblocks
            iM =      iMask(MK1,MK2,MK3)
            If(iM.le.Nspecies.and.iM.ge.1)Then
               nLevel(iM) = nLevel(iM) +1 
            Else
               write (*,*) 'wrong mask: ',iM, ' block=',MK1,MK2,MK3
               Stop
            EndIf
         ENDDO
         ENDDO
         ENDDO

         Ntot =0
       Do i=Nspecies,1,-1
          icurrent =nLevel(i)*8**(i-1)
         Write (*,*) ' Level=',i,' Number of Blocks=',nLevel(i),
     &                   ' N_Particles=', icurrent
         Ntot = Ntot + icurrent
       Enddo   
         Write (*,*) ' Total expected particles =',Ntot
      RETURN
      END
C------------------------------------------------
C                             Make a realization of spectrum of perturbations:
C                             ALPHA  = normalization factor for displacements
C                             NRAND = seed for random numbers
C                             Lstart   = start on level Lstart (=1 or 2) 
      SUBROUTINE SPECTR(NRAND,Lstart)
C------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR.h'
      REAL*8     SUMM, WI3,WJ3,WK3,WD,TS,TRX
c      Dimension SummA(100)
C						    Set spectrum
      If(Lstart.gt.Levels)Then
         write (*,*) ' Wrong range of levels in SPECTR: start/total=',
     &                   Lstart,Levels
         Return
      Endif 
      DO ML =Lstart,Levels
c.... Exemplar
c$DIR LOOP_PARALLEL
c$DIR LOOP_PRIVATE(MK3,MK2,MK1)
c.... Power Challenge
cc$DOACROSS LOCAL (MK3,MK2,MK1)      
C$omp  parallel do default(shared)
C$omp& private(MK3,MK2,MK1)
      DO  MK3 = 1,NROW
      DO  MK2 = 1,NROW
      DO  MK1 = 1,NROW
	     GRX(MK1,MK2,MK3,ML) =0.
	     GRY(MK1,MK2,MK3,ML) =0.
	     GRZ(MK1,MK2,MK3,ML) =0.
      ENDDO
      ENDDO
      ENDDO
      ENDDO

      DO Lv =Lstart,Levels     ! set spectrum for each level
c      DO Lv =2,2     ! set spectrum for each level
         SUMM = 0.

      DO  k = 1,NROW 
         ksign = -1
         kz    = k +NSPEC
         k3    = k - 1
         If(k3.GT.NSPEC)k3=k3-NSPEC
           IF(kz.gt.NROW)THEN
              kz    =kz -NROW
              ksign =1
           ENDIF
           WK3= K3**2
c	        write (*,*) '  K=',k,' K3=',K3,' Nspec=',NSPEC
           DO  j = 1,NROW
              jsign = -1
              jz    = j +NSPEC
              j3    = j - 1
              If(j3.GT.NSPEC)j3=j3-NSPEC
                IF(jz.gt.NROW)THEN
                   jz    =jz -NROW
                   jsign =1
                ENDIF
                WJ3= j3**2
                DO  i = 1,NROW
                   isign = -1
                   iz    = i +NSPEC
                   i3    = i - 1
                   If(i3.GT.NSPEC)i3=i3-NSPEC
                     IF(iz.gt.NROW)THEN
                        iz    =iz -NROW
                        isign =1
                     ENDIF
                     WI3= i3**2

	       IF(i3+j3+k3.EQ.0)THEN
		         GRX(1,1,1,Lv) = 0.
		         GRY(1,1,1,Lv) = 0.
		         GRZ(1,1,1,Lv) = 0.
	       ELSE
		  WD = (WI3 + WJ3 + WK3)*2**(2*Lv-2)
		  WK = SQRT(WD)
		  TS = TRUNF(WK) * GAUSS(NRAND)
		  TRX = TS / WD
		  GRX(iz, j, k,Lv) = i3 * TRX *isign
		  GRY( i,jz, k,Lv) = j3 * TRX *jsign
		  GRZ( i, j,kz,Lv) = k3 * TRX *ksign
		  SUMM = SUMM + TS**2
	       ENDIF
	    ENDDO
	   ENDDO
      ENDDO
      IF(SUMM.LE.0.)WRITE (*,*) ' Error!!! Summ over spectrum = 0'
         write (*,*) ' ==== SPECTR:  SUMM=',SUMM,' Level=',Lv
      ALPHA(Lv) = AMPLT(Lv) / SQRT(SUMM) *sqrt(8.)*1.087
      ENDDO

      RETURN
      END
C------------------------------------------------
C                             Make spectrum for Constrained Realizations
C                             
C                             
      SUBROUTINE SPectr_CR(NRAND)
C------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR.h'
      REAL*8     SUMM, WI3,WJ3,WK3,WD,TS,TRX
      Dimension DENS_CR(NROW,NROW,NROW)
C						    Set spectrum
      SUMM = 0.
      WD       =0.
      open(40,file='dens_cr.dat',status='unknown')
      read(40,*) DENS_CR
      Do k=1,NROW
      Do j=1,NROW
      Do i=1,NROW
         SUMM =SUMM +dens_cr(i,j,k)
         WD      =WD +dens_cr(i,j,k)**2
      EndDo
      EndDo
      EndDo
      sigma = sqrt(MAX(1.d-10,WD/NROW**3))
      write (*,*) ' Average density=',SUMM/NROW**3
      write (*,*) ' RMS density=',sigma
       IFOUR = INT(ALOG(FLOAT(NROW))/ALOG(2.)+0.5)
       Write (*,*) ' Ifour =',IFOUR,' Nrow=',NROW

      CALL VECTOR_dens(IFOUR,dens_cr)

C$omp  parallel do default(shared)
C$omp& private(MK3,MK2,MK1)
      DO  MK3 = 1,NROW
      DO  MK2 = 1,NROW
      DO  MK1 = 1,NROW
	     GRX(MK1,MK2,MK3,1) =0.
	     GRY(MK1,MK2,MK3,1) =0.
	     GRZ(MK1,MK2,MK3,1) =0.
      ENDDO
      ENDDO
      ENDDO

      DO  k = 1,NROW   
         ksign = -1
         kz    = k +NSPEC
         k3    = k - 1
         If(k3.GT.NSPEC)k3=k3-NSPEC
           IF(kz.gt.NROW)THEN
              kz    =kz -NROW
              ksign =1
           ENDIF
           WK3= K3**2
	        write (*,*) '  K=',k,' K3=',K3,' Nspec=',NSPEC
           DO  j = 1,NROW
              jsign = -1
              jz    = j +NSPEC
              j3    = j - 1
              If(j3.GT.NSPEC)j3=j3-NSPEC
                IF(jz.gt.NROW)THEN
                   jz    =jz -NROW
                   jsign =1
                ENDIF
                WJ3= j3**2
                DO  i = 1,NROW
                   isign = -1
                   iz    = i +NSPEC
                   i3    = i - 1
                   If(i3.GT.NSPEC)i3=i3-NSPEC
                     IF(iz.gt.NROW)THEN
                        iz    =iz -NROW
                        isign =1
                     ENDIF
                     WI3= i3**2

	       IF(i3+j3+k3.EQ.0)THEN
		         GRX(1,1,1,1) = 0.
		         GRY(1,1,1,1) = 0.
		         GRZ(1,1,1,1) = 0.
	       ELSE
		  WD = WI3 + WJ3 + WK3
		  WK = SQRT(WD)
		  TS = -dens_cr(i,j,k)
		  TRX = TS / WD
		  GRX(iz, j, k,1) = i3 * TRX *isign 
		  GRY( i,jz, k,1) = j3 * TRX *jsign
		  GRZ( i, j,kz,1) = k3 *TRX *ksign
		  SUMM = SUMM + TS**2
	       ENDIF
	    ENDDO
	   ENDDO
      ENDDO

      IF(SUMM.LE.0.)WRITE (*,*) ' Error!!! Summ over spectrum = 0'
         write (*,*) ' ==== SPECTR ===  SUMM=',SUMM
      ALPHA(1) = AMPLT(1) / SQRT(SUMM) *sqrt(8.)
      RETURN
      END
C------------------------------------------------
C                             Set to zero harmonics, which
C                             were included at previous level
C                             of resolution
C                             Lstart   = start on level Lstart (=1 or 2) 
      SUBROUTINE ZERO_SP
C------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR.h'
      Logical       in_x,in_y,in_z,inside


      If(Levels.lt.2)Then
         write (*,*) ' Wrong range of levels in ZERO_SP: =',
     &                   Levels
         Return
      Endif 
      J_cos = NROW/4 +1   ! limit for cosine harmonics
      J_sin_1 = NROW/2+2  ! limits for sin harmonics
      J_sin_2 = NROW/4*3


C$omp  parallel do default(shared)
C$omp& private(K,J,I,in_z,in_y,in_x,inside,Lv)
      DO  K = 1,NROW
         If(K.le.J_cos.or.(K.ge.J_sin_1.and.K.le.J_sin_2))Then
            in_z =.true.
         else
            in_z =.false.
         Endif 
      DO  J = 1,NROW
         If(J.le.J_cos.or.(J.ge.J_sin_1.and.J.le.J_sin_2))Then
            in_y =.true.
         else
            in_y =.false.
         Endif 
      DO  I = 1,NROW
         If(I.le.J_cos.or.(I.ge.J_sin_1.and.I.le.J_sin_2))Then
            in_x =.true.
         else
            in_x =.false.
         Endif 
         inside = (in_x.and.in_y.and.in_z)
         If(inside)Then
c            write (*,*) I,J,K, in_x,in_y,in_z
            DO Lv =2,Levels
	           GRX(I,J,K,Lv) =0.
	           GRY(I,J,K,Lv) =0.
	           GRZ(I,J,K,Lv) =0.
            ENDDO
         Endif 
      ENDDO
      ENDDO
      ENDDO

      RETURN
      END

C------------------------------------------------
C		                        Define coordinates and velosities for
C                                  particles with resolution = Indx
C                                  Indx =1 = high resolution
C                                  Indx =2 = medium resolution
C                                  Icurrent = number of particles
      SUBROUTINE BLOCKS(Indx,Icurrent)
C------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR.h'	  
      Dimension nLevel(10)
       Do i=1,Nspecies            ! number of particles at
          nLevel(i)=0                  ! different levels
       Enddo
       If(Indx.eq.Levels)Then
          Do i =1,Levels
             Delta(i)   = Float(NGRID)/NROW *2./2**i
             Delta2(i) = Delta(i)/2.
             iNROW(i) =NROW *2**i/2 
          Enddo 
       Endif 

      QFACT = FLOAT(NGRID)/FLOAT(NROW)
        DO  K = 1,Nblocks
           qq3 = Delta(1)*(K-1.) +1.
        DO  J = 1,Nblocks
           qq2 = Delta(1)*(J-1.) +1.
        DO  I  = 1,Nblocks
           qq1 = Delta(1)*(I-1.) +1.
	      iM =iMask(I,J,K)
C----------------------------------------
c                     
          If(iM.eq.Indx)Then 
          If(iM.eq.1)Then  ! Low resolution: one particle
               DX = GRX(I,J,K,1)
               DY = GRY(I,J,K,1)
               DZ = GRZ(I,J,K,1)
               Q3    = qq3 +Delta2(1)  ! scale them to box size
               Q2    = qq2 +Delta2(1)  
               Q1    = qq1 +Delta2(1) 
               Icurrent = Icurrent +1
               If(Icurrent.gt.Nmaxpart)Then
                    write (*,*)'Too many particles:',Icurrent,' block=',
     &                                            I,J,K, ' Level=',iM
                    STOP
               EndIf
               nLevel(Indx) =nLevel(Indx) +1
	         XPt(Icurrent) = Q1 - XCONS(1)*DX  + 1.E-3  +0.5 
	         YPt(Icurrent) = Q2 - XCONS(1)*DY  + 1.E-3  +0.5
	         ZPt(Icurrent) = Q3 - XCONS(1)*DZ  + 1.E-3  +0.5
	         VXt(Icurrent) =          VCONS(1)*DX
	         VYt(Icurrent) =          VCONS(1)*DY
	         VZt(Icurrent) =          VCONS(1)*DZ
           Else
C------------------------------- High resolution:
C                                          iM = current level ( > 1)
              Nlev =2**(iM-1)   ! number of particles in one dimenstion per Block
              Do kp =1,Nlev
               Q3    = qq3+Delta(iM)*(kp-1.) +Delta2(iM) ! scale them to box size
               kl       = INT((Q3-1.-Delta2(iM))/Delta(iM)) +1 ! inside large box 
                    if(kl.lt.1.or.kl.gt.NROW*2**(iM-1))
     &             write (*,*) ' error kl=',kl,' Lev=',iM,' k=',kp,K
               kll  = kl -INT((kl-1)/NROW)*NROW             ! inside small box of GRZ
                    if(kll.lt.1.or.kll.gt.NROW)
     &             write (*,*) ' error kll=',kll,' Lev=',iM,' kl=',kl

              Do jp =1,Nlev
               Q2    = qq2+Delta(iM)*(jp-1.) +Delta2(iM) 
               jl       = INT((Q2-1.-Delta2(iM))/Delta(iM)) +1 ! inside large box 
                    if(jl.lt.1.or.jl.gt.NROW*2**(iM-1))
     &             write (*,*) ' error jl=',jl,' Lev=',iM,' j=',jp,J
               jll  = jl -INT((jl-1)/NROW)*NROW             ! inside small box of GRY
                    if(jll.lt.1.or.jll.gt.NROW)
     &             write (*,*) ' error jll=',jll,' Lev=',iM,' jl=',jl

              Do ip =1,Nlev
               Q1    = qq1+Delta(iM)*(ip-1.) +Delta2(iM) 
               il       = INT((Q1-1.-Delta2(iM))/Delta(iM)) +1 ! inside large box 
                    if(il.lt.1.or.il.gt.NROW*2**(iM-1))
     &             write (*,*) ' error il=',il,' Lev=',iM,' j=',ip,I
               ill  = il -INT((il-1)/NROW)*NROW             ! inside small box of GRX
                    if(ill.lt.1.or.ill.gt.NROW)
     &             write (*,*) ' error ill=',ill,' Lev=',iM,' il=',il
               DX = XCONS(iM)*GRX(ill,jll,kll,iM)
               DY = XCONS(iM)*GRY(ill,jll,kll,iM)
               DZ = XCONS(iM)*GRZ(ill,jll,kll,iM)
               DvX = VCONS(iM)*GRX(ill,jll,kll,iM)
               DvY = VCONS(iM)*GRY(ill,jll,kll,iM)
               DvZ = VCONS(iM)*GRZ(ill,jll,kll,iM)
                 Do Lv =iM-1,1,-1 ! take contributions from lower levels

                    ii =INT((Q1-1.)/Delta(Lv)+1000.) -999 ! inside large box
                    jm   = INT((Q2-1.)/Delta(Lv)+1000.)-999 ! inside large box
                    km   = INT((Q3-1.)/Delta(Lv)+1000.)-999 ! inside large box

c                    ii =INT((Q1-1.-Delta2(Lv))/Delta(Lv)+1000.) -999 ! inside large box
c                    ii1     = ii +1
c                    dQ1    = Q1 - (Delta(Lv)*(ii-1)+Delta2(Lv)+1.)
c                    if(ii.lt.1)ii =ii+iNROW(Lv)
c                    if(ii.gt.iNROW(Lv))ii =ii - iNROW(Lv)
c                        if(ii.lt.1.or.ii.gt.iNROW(Lv))
c     &                 write (*,*) ' error ii=',ii,' Lev=',Lv,' j=',ip,I
                    iim  = ii  -INT((ii -1)/NROW)*NROW          ! inside small box of GRX
c                    iim1 = ii1-INT((ii1-1)/NROW)*NROW         
                   if(iim.lt.1.or.iim.gt.NROW)
     &             write (*,*) ' error iim=',iim,' Lev=',Lv,' ii=',ii

c                    jm   = INT((Q2-1.-Delta2(Lv))/Delta(Lv)+1000.)-999 ! inside large box
c                    jm1 = jm +1
c                    dQ2= Q2 - (Delta(Lv)*(jm-1)+Delta2(Lv)+1.)
c                    if(jm.lt.1)jm =jm+iNROW(Lv)
c                    if(jm.gt.iNROW(Lv))jm =jm - iNROW(Lv)
c                        if(jm.lt.1.or.jm.gt.iNROW(Lv))
c     &                 write (*,*) ' error jm=',jm,' Lev=',Lv,' j=',jp,J
                    jmm  = jm  -INT((jm -1)/NROW)*NROW          ! inside small box of GRY
c                    jmm1 = jm1-INT((jm1-1)/NROW)*NROW            
                   if(jmm.lt.1.or.jmm.gt.NROW)
     &             write (*,*) ' error jmm=',jmm,' Lev=',Lv,' jm=',jm

c                    km   = INT((Q3-1.-Delta2(Lv))/Delta(Lv)+1000.)-999 ! inside large box
c                    km1 = km +1
c                    dQ3 = Q3 - (Delta(Lv)*(km-1)+Delta2(Lv)+1.)
c                    if(km.lt.1)km =km+iNROW(Lv)
c                    if(km.gt.iNROW(Lv))km =km - iNROW(Lv)
c                        if(km.lt.1.or.km.gt.iNROW(Lv))
c     &                 write (*,*) ' error km=',km,' Lev=',Lv,' j=',jp,J
                    kmm  = km  -INT((km -1)/NROW)*NROW          ! inside small box of GRY
c                    kmm1 = km1-INT((km1-1)/NROW)*NROW            
                   if(kmm.lt.1.or.kmm.gt.NROW)
     &             write (*,*) ' error kmm=',kmm,' Lev=',Lv,' km=',km

c                   write (*,300) I,J,K,ip,jp,kp,Q1,Q2,Q3,
c     &                ill,jll,kll,ii,jm,km,iim,jmm,kmm
c 300               format(3x,' IJK=',3i3,' p=',3i3,' Q=',3f6.1,
c     &                  ' ill=',3i4,' i=',3i4,3i4)

                   uX  = GRX(iim ,jmm ,kmm ,Lv)
                   uY  = GRY(iim ,jmm ,kmm ,Lv)
                   uZ  = GRZ(iim ,jmm ,kmm ,Lv)

c                   dQ1 =dQ1/Delta(Lv)     ! normalize weights
c                   dQ2 =dQ2/Delta(Lv)
c                   dQ3 =dQ3/Delta(Lv)
c                   w111 = (1.-dQ1)  *(1.-dQ2)  *(1.-dQ3)
c                   w211 =  dQ1      *(1.-dQ2)  *(1.-dQ3)
c                   w121 = (1.-dQ1)  * dQ2      *(1.-dQ3)
c                   w221 =  dQ1      * dQ2      *(1.-dQ3)
c                   w112 = (1.-dQ1)  *(1.-dQ2)  * dQ3
c                   w212 =  dQ1      *(1.-dQ2)  * dQ3
c                   w122 = (1.-dQ1)  * dQ2      * dQ3
c                   w222 =  dQ1      * dQ2      * dQ3

c                                                        Interpolate displacements                   
c                   uX  = GRX(iim ,jmm ,kmm ,Lv)*w111 
c     &                   +GRX(iim1,jmm ,kmm ,Lv)*w211
c     &                   +GRX(iim ,jmm1,kmm ,Lv)*w121 
c     &                   +GRX(iim1,jmm1,kmm ,Lv)*w221
c     &                   +GRX(iim ,jmm ,kmm1,Lv)*w112 
c     &                   +GRX(iim1,jmm ,kmm1,Lv)*w212
c     &                   +GRX(iim ,jmm1,kmm1,Lv)*w122 
c     &                   +GRX(iim1,jmm1,kmm1,Lv)*w222
c                   uY  = GRY(iim ,jmm ,kmm ,Lv)*w111 
c     &                   +GRY(iim1,jmm ,kmm ,Lv)*w211
c     &                   +GRY(iim ,jmm1,kmm ,Lv)*w121 
c     &                   +GRY(iim1,jmm1,kmm ,Lv)*w221
c     &                   +GRY(iim ,jmm ,kmm1,Lv)*w112 
c     &                   +GRY(iim1,jmm ,kmm1,Lv)*w212
c     &                   +GRY(iim ,jmm1,kmm1,Lv)*w122 
c     &                   +GRY(iim1,jmm1,kmm1,Lv)*w222
c                   uZ  = GRZ(iim ,jmm ,kmm ,Lv)*w111 
c     &                   +GRZ(iim1,jmm ,kmm ,Lv)*w211
c     &                   +GRZ(iim ,jmm1,kmm ,Lv)*w121 
c     &                   +GRZ(iim1,jmm1,kmm ,Lv)*w221
c     &                   +GRZ(iim ,jmm ,kmm1,Lv)*w112 
c     &                   +GRZ(iim1,jmm ,kmm1,Lv)*w212
c     &                   +GRZ(iim ,jmm1,kmm1,Lv)*w122 
c     &                   +GRZ(iim1,jmm1,kmm1,Lv)*w222

                   DX  = DX  +XCONS(Lv)*uX       ! add contrubutions
                   DY  = DY  +XCONS(Lv)*uY
                   DZ  = DZ  +XCONS(Lv)*uZ
                   DvX = DvX +VCONS(Lv)*uX
                   DvY = DvY +VCONS(Lv)*uY
                   DvZ = DvZ +VCONS(Lv)*uZ
                Enddo                                         ! end Level

                 Icurrent = Icurrent +1
                 If(Icurrent.gt.Nmaxpart)Then
                    write (*,*)'Too many particles:',Icurrent,' block=',
     &                                    I,J,K,' Levels=',iM
                    STOP
                 EndIf
               nLevel(Indx) =nLevel(Indx) +1
	         XPt(Icurrent) = Q1 - DX  - 1.5999E-3  +0.5 
	         YPt(Icurrent) = Q2 - DY  - 1.5999E-3  +0.5
	         ZPt(Icurrent) = Q3 - DZ  - 1.5999E-3  +0.5
	         VXt(Icurrent) =          DvX
	         VYt(Icurrent) =          DvY
	         VZt(Icurrent) =          DvZ
               EndDo
              EndDo
              EndDo
              Endif   ! end iM =1

      EndIf         ! end iM = Indx 
      EndDo
      EndDo
      EndDo

           write (*,*) ' Particles=',Icurrent,' on  levels:',
     &                     (nLevel(i),i=1,Nspecies)
      RETURN
      END
C------------------------------------------------

      SUBROUTINE SETtest(K,NRAND)
C  place particles with small velocities in a sphere 
C  Radius = radius of the sphere in zero-level cell units
C  Xcentr  = position of the sphere
C  
C------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR.h'	  
      COMMON / KINENRG/ SKINE,SX,SY,SZ,SX2,SY2,SZ2


      QFACT = FLOAT(NGRID)/FLOAT(NROW)
      XMAX  = FLOAT(NGRID) + 1.
      XSHF  = FLOAT(NGRID)
      Xcentr  = NGRID/2.
      Vss       =1.
      Radius = 5.
      write (*,*) ' Xcentr=',Xcentr
      DO  J = 1,NROW
	   DO  I = 1,NROW
            IJ    =      I +(J-1)*NROW
	      DX	      =      Radius*(2.*RANDd(NRAND)-1.)
	      DY	      =      Radius*(2.*RANDd(NRAND)-1.)
	      DZ	      =      Radius*(2.*RANDd(NRAND)-1.)
c	      DX	      =      0.05*I
c	      DY	      =      0.05*J
c	      DZ	      =      0.05*K
C           the factor 0.5 in the following 3 lines places unperturbed
c           particle in the middle of a cell. This reduces the shot noise
C          Small number 1.E-4 is to avoid placing some particles
C          exactly in cell nodes. Does not make much differentce.
	      XPAR(IJ) = Xcentr+ DX    + 1.E-4  +0.5 
	      YPAR(IJ) = Xcentr+ DY    + 1.E-4  +0.5 
	      ZPAR(IJ) = Xcentr+ DZ    + 1.E-4  +0.5 
	      VX(IJ)   =      Vss*GAUSS(NRAND)
	      VY(IJ)   =      Vss*GAUSS(NRAND)
	      VZ(IJ)   =      Vss*GAUSS(NRAND)
C                                Periodical boundary conditions
	       IF(XPAR(IJ).GT.XMAX)	XPAR(IJ)=XPAR(IJ)-XSHF
	       IF(XPAR(IJ).LE.1.)	XPAR(IJ)=XPAR(IJ)+XSHF
	       IF(YPAR(IJ).GT.XMAX)	YPAR(IJ)=YPAR(IJ)-XSHF
	       IF(YPAR(IJ).LE.1.)	YPAR(IJ)=YPAR(IJ)+XSHF
	       IF(ZPAR(IJ).GT.XMAX)	ZPAR(IJ)=ZPAR(IJ)-XSHF
	       IF(ZPAR(IJ).LE.1.)	ZPAR(IJ)=ZPAR(IJ)+XSHF
	      SX	      = SX    + DX
	      SY	      = SY    + DY
	      SZ	      = SZ    + DZ
	      SX2      = SX2   + DX**2
	      SY2      = SY2   + DY**2
	      SZ2      = SZ2   + DZ**2
	      SKINE    = SKINE + VX(IJ)**2 +VY(IJ)**2 +VZ(IJ)**2
	   ENDDO
      ENDDO
      RETURN
      END
C------------------------------------------------
C		                        Define coordinates and velosities for
C		                        all particles of current row (given q2)
C			                       x = q - amplt*b(t)/b(t0)*S(q1,q2)
C			                       momentum = a**2*deriv x
C                     
C		                        Twidled variables:
C		                        x= q - {1/(2 pi Ngrid)}{Alpha*a(t)/a(0)}*S
C		                        P=	- {1/(2 pi Ngrid)}{Alpha*a(t)**1.5/a(0)}*S
C                     
C		                        q(i) = Ngrid/Nrow*(i-1) + 1
C		                        x = q - xcons*S
C		                        P =	   vcons*S
      SUBROUTINE SETXV(XCONS1,VCONS1,K)
C------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR.h'	  
      COMMON / KINENRG/ SKINE,SX,SY,SZ,SX2,SY2,SZ2

      QFACT = FLOAT(NGRID)/FLOAT(NROW)
      XMAX  = FLOAT(NGRID) + 1.
      XSHF  = FLOAT(NGRID)
      Q3    = QFACT*(K-1.) +1.
      DO  J = 1,NROW
	      Q2 = QFACT*(J-1.) +1.
	   DO  I = 1,NROW
	      Q1 = QFACT*(I-1.) +1.
            IJ    =      I +(J-1)*NROW
	      DX	      =      XCONS1*GRX(I,J,K,1)
	      DY	      =      XCONS1*GRY(I,J,K,1)
	      DZ	      =      XCONS1*GRZ(I,J,K,1)
C           the factor 0.5 in the following 3 lines places unperturbed
c           particle in the middle of a cell. This reduces the shot noise
C          Small number 1.E-4 is to avoid placing some particles
C          exactly in cell nodes. Does not make much differentce.
	      XPAR(IJ) = Q1 - DX    + 1.E-4  +0.5 
	      YPAR(IJ) = Q2 - DY    + 1.E-4  +0.5
	      ZPAR(IJ) = Q3 - DZ    + 1.E-4  +0.5
	      VX(IJ)   =      VCONS1*GRX(I,J,K,1)
	      VY(IJ)   =      VCONS1*GRY(I,J,K,1)
	      VZ(IJ)   =      VCONS1*GRZ(I,J,K,1)
C                                Periodical boundary conditions
	       IF(XPAR(IJ).GT.XMAX)	XPAR(IJ)=XPAR(IJ)-XSHF
	       IF(XPAR(IJ).LE.1.)	XPAR(IJ)=XPAR(IJ)+XSHF
	       IF(YPAR(IJ).GT.XMAX)	YPAR(IJ)=YPAR(IJ)-XSHF
	       IF(YPAR(IJ).LE.1.)	YPAR(IJ)=YPAR(IJ)+XSHF
	       IF(ZPAR(IJ).GT.XMAX)	ZPAR(IJ)=ZPAR(IJ)-XSHF
	       IF(ZPAR(IJ).LE.1.)	ZPAR(IJ)=ZPAR(IJ)+XSHF
	      SX	      = SX    + DX
	      SY	      = SY    + DY
	      SZ	      = SZ    + DZ
	      SX2      = SX2   + DX**2
	      SY2      = SY2   + DY**2
	      SZ2      = SZ2   + DZ**2
	      SKINE    = SKINE + VX(IJ)**2 +VY(IJ)**2 +VZ(IJ)**2
	   ENDDO
      ENDDO
      RETURN
      END
C------------------------------------------------
C                                              				   FFT of the spectrum
      SUBROUTINE VECTOR_dens(IFOUR,dens_cr)
C------------------------------------------------
      INCLUDE 'PMparameters.h'	  
      INCLUDE 'PMinitialCR.h'	  
      dimension Uf(marr) , Vf(marr)
      dimension Qi(mf67) , jndx(mf67),dens_cr(NROW,NROW,NROW)

      jb1 =3
      jq   =IFOUR
      CALL SETF67(jb1,jq,jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

C				       x-component
C.... Exemplar
C$DIR LOOP_PARALLEL
C$DIR LOOP_PRIVATE(j,i,Uf,Vf,jp,jsl,ll1,k2,k4)
C.... Power Challenge
Cc$DOACROSS LOCAL ( k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO K=1,NROW
	   DO J=1,NROW
	    DO I=1,NROW
	       Uf(I) =dens_cr(I,J,K)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO I=1,NROW
	       dens_cr(I,J,K) = Vf(I)
	    ENDDO
	   ENDDO
      ENDDO
      write (*,*) ' 1st is done'
C.... Exemplar
C$DIR LOOP_PARALLEL
C$DIR LOOP_PRIVATE(j,i,Uf,Vf,jp,jsl,ll1,k2,k4)
C.... Power Challenge
Cc$DOACROSS LOCAL ( k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO K=1,NROW
	   DO I=1,NROW
	    DO J=1,NROW
	       Uf(J) =dens_cr(I,J,K)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO J=1,NROW
	       dens_cr(I,J,K) = Vf(J)
	    ENDDO
	   ENDDO
      ENDDO
C.... Exemplar
C$DIR LOOP_PARALLEL
C$DIR LOOP_PRIVATE(i,k,Uf,Vf,jp,jsl,ll1,k2,k4)
C.... Power Challenge
Cc$DOACROSS LOCAL ( k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO J=1,NROW
	   DO I=1,NROW
	    DO K=1,NROW
	       Uf(K) =dens_cr(I,J,K)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO K=1,NROW
	       dens_cr(I,J,K) = Vf(K)/8.
	    ENDDO
	   ENDDO
      ENDDO
				       write (*,*) ' x is done'
                                       Return
                                       END
C------------------------------------------------
C                                              				   FFT of the spectrum
      SUBROUTINE VECTOR(IFOUR)
C------------------------------------------------
      INCLUDE 'PMparameters.h'	  
      INCLUDE 'PMinitialCR.h'	  
      dimension Uf(marr) , Vf(marr)
      dimension Qi(mf67) , jndx(mf67)

      jb1 =4
      jq   =IFOUR
      CALL SETF67(jb1,jq,jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

      DO Lv=1,Levels
C				       x-component
C.... Exemplar
C$DIR LOOP_PARALLEL
C$DIR LOOP_PRIVATE(j,i,Uf,Vf,jp,jsl,ll1,k2,k4)
C.... Power Challenge
Cc$DOACROSS LOCAL ( k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO K=1,NROW
	   DO J=1,NROW
	    DO I=1,NROW
	       Uf(I) =GRX(I,J,K,Lv)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO I=1,NROW
	       GRX(I,J,K,Lv) = Vf(I)
	    ENDDO
	   ENDDO
      ENDDO
      write (*,*) ' 1st is done Level=',Lv
C.... Exemplar
C$DIR LOOP_PARALLEL
C$DIR LOOP_PRIVATE(j,i,Uf,Vf,jp,jsl,ll1,k2,k4)
C.... Power Challenge
Cc$DOACROSS LOCAL ( k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO K=1,NROW
	   DO I=1,NROW
	    DO J=1,NROW
	       Uf(J) =GRX(I,J,K,Lv)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO J=1,NROW
	       GRX(I,J,K,Lv) = Vf(J)
	    ENDDO
	   ENDDO
      ENDDO
C.... Exemplar
C$DIR LOOP_PARALLEL
C$DIR LOOP_PRIVATE(i,k,Uf,Vf,jp,jsl,ll1,k2,k4)
C.... Power Challenge
Cc$DOACROSS LOCAL ( k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO J=1,NROW
	   DO I=1,NROW
	    DO K=1,NROW
	       Uf(K) =GRX(I,J,K,Lv)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO K=1,NROW
	       GRX(I,J,K,Lv) = Vf(K)/8.
	    ENDDO
	   ENDDO
      ENDDO
				       write (*,*) ' x is done ',Lv
C				       Y-component
C.... Exemplar
C$DIR LOOP_PARALLEL
C$DIR LOOP_PRIVATE(j,i,Uf,Vf,jp,jsl,ll1,k2,k4)
C.... Power Challenge
Cc$DOACROSS LOCAL ( k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO K=1,NROW
	   DO J=1,NROW
	    DO I=1,NROW
	       Uf(I) =GRY(I,J,K,Lv)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO I=1,NROW
	       GRY(I,J,K,Lv) = Vf(I)
	    ENDDO
	   ENDDO
      ENDDO
C.... Exemplar
C$DIR LOOP_PARALLEL
C$DIR LOOP_PRIVATE(j,i,Uf,Vf,jp,jsl,ll1,k2,k4)
C.... Power Challenge
Cc$DOACROSS LOCAL ( k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO K=1,NROW
	   DO I=1,NROW
	    DO J=1,NROW
	       Uf(J) =GRY(I,J,K,Lv)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO J=1,NROW
	       GRY(I,J,K,Lv) = Vf(J)
	    ENDDO
	   ENDDO
      ENDDO
C.... Exemplar
C$DIR LOOP_PARALLEL
C$DIR LOOP_PRIVATE(k,i,Uf,Vf,jp,jsl,ll1,k2,k4)
C.... Power Challenge
Cc$DOACROSS LOCAL ( k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO J=1,NROW
	   DO I=1,NROW
	    DO K=1,NROW
	       Uf(K) =GRY(I,J,K,Lv)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO K=1,NROW
	       GRY(I,J,K,Lv) = Vf(K)/8.
	    ENDDO
	   ENDDO
      ENDDO
				       write (*,*) ' y is done'
C				       Z-component
C.... Exemplar
C$DIR LOOP_PARALLEL
C$DIR LOOP_PRIVATE(j,i,Uf,Vf,jp,jsl,ll1,k2,k4)
C.... Power Challenge
Cc$DOACROSS LOCAL ( k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO K=1,NROW
	   DO J=1,NROW
	    DO I=1,NROW
	       Uf(I) =GRZ(I,J,K,Lv)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO I=1,NROW
	       GRZ(I,J,K,Lv) = Vf(I)
	    ENDDO
	   ENDDO
      ENDDO
C.... Exemplar
C$DIR LOOP_PARALLEL
C$DIR LOOP_PRIVATE(j,i,Uf,Vf,jp,jsl,ll1,k2,k4)
C.... Power Challenge
Cc$DOACROSS LOCAL ( k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO K=1,NROW
	   DO I=1,NROW
	    DO J=1,NROW
	       Uf(J) =GRZ(I,J,K,Lv)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO J=1,NROW
	       GRZ(I,J,K,Lv) = Vf(J)
	    ENDDO
	   ENDDO
      ENDDO
C.... Exemplar
C$DIR LOOP_PARALLEL
C$DIR LOOP_PRIVATE(k,i,Uf,Vf,jp,jsl,ll1,k2,k4)
C.... Power Challenge
Cc$DOACROSS LOCAL ( k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO J=1,NROW
	   DO I=1,NROW
	    DO K=1,NROW
	       Uf(K) =GRZ(I,J,K,Lv)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO K=1,NROW
	       GRZ(I,J,K,Lv) = Vf(K)/8.
	    ENDDO
	   ENDDO
      ENDDO
	   write (*,*) ' z is done. Level=',Lv
      ENDDO
      RETURN
      END
C------------------------------------------
c                      
c                                                     Print statistics of spicies
      Subroutine Species_Print
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR.h'	  

           write (*,300)Nspecies
           write (16,300)Nspecies
 300       format('---  Number of species=',i3,/
     &          3x,'Specie',2x,
     +          'Nparticles Ntotal  Weight/part Weight_Total ')
 310       format(T5,i3,T13,i8,T22,i8,T30,2g10.3)
           Wtotal =0.
           Do i=1,Nspecies
              If(i.eq.1)Then
              Wtotal =wspecies(i)*lspecies(i)
              write (*,310)i,lspecies(i),lspecies(i),wspecies(i),Wtotal
              write (16,310)i,lspecies(i),lspecies(i),wspecies(i),Wtotal
              Else
                 ww =wspecies(i)* (lspecies(i)-lspecies(i-1))
              write (*,310) i,lspecies(i)-lspecies(i-1),
     &                           lspecies(i),wspecies(i),ww
              write (16,310) i,lspecies(i)-lspecies(i-1),
     &                           lspecies(i),wspecies(i),ww
                  Wtotal =Wtotal + ww
              Endif 
           Enddo 
           write (*,*) ' Total weight =',Wtotal

       Return
       End
C---------------------------------------------------
C                                  Read  current data from disk/tape,
C                                  Open files
C                                  Nrecl is the number of values in a record
C                                  Npage is the number of particles in a page
      SUBROUTINE RDTAPE
C---------------------------------------------------
      INCLUDE 'PMparameters.h'
      Character  Hd*5,Tail*4,Nm*40
      Hd  ='PMcrs'
      Tail='.DAT'
C                                     Open file on a tape
      OPEN(UNIT=9,FILE='PMcrd.DAT',
     +                FORM='UNFORMATTED', STATUS='UNKNOWN')
C                                 Read control information
C                                 and see whether it has proper
C                                 structure
      READ  (9,err=10,end=10) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  TINTG,EKIN,EKIN1,EKIN2,AU0,AEU0,
     +                  NROWC,NGRIDC,Nspecies,Nseed,Om0,Oml0,hubble,Wp5
     +                   ,Ocurv,extras
      Ocurv =0.
      WRITE (*,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,EKIN1,EKIN2,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
      WRITE (16,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,EKIN1,EKIN2,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
100   FORMAT(1X,'Header=>',A45,/
     +            1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',3E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I6,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3)
      IF(NROW.NE.NROWC) THEN
         WRITE (*,*)
     +            ' NROW in PARAMETER and in TAPE-FILE are different'
      ENDIF
      IF(NGRID.NE.NGRIDC) THEN
         WRITE (*,*)
     +           ' NGRID in PARAMETER and in TAPE-FILE are different:'
         write (*,*) ' Ngrid=',NGRID,' NgridC=',NGRIDC
      ENDIF
C                                         Open work file on disk
 10   NBYTE = NRECL*4
      NACCES= NBYTE / nbyteword

         Nm =Hd//Char(48)//Tail
         iun=21
         write (*,*) ' File unit=',iun,' Name=',Nm
         OPEN(UNIT=iun,FILE=Nm,ACCESS='DIRECT',
     +	               STATUS='UNKNOWN',RECL=NACCES)

 
      REWIND 9
      RETURN
      END
C---------------------------------------------
C                       Write current data to  disk/tape
C
      SUBROUTINE WRTAPE
C----------------------------------------------
      INCLUDE 'PMparameters.h'
C                                       write header and control data
      WRITE (9) HEADER,
     +           AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +           TINTG,EKIN,EKIN1,EKIN2,AU0,AEU0,
     +           NROWC,NGRIDC,Nspecies,Nseed,Om0,Oml0,hubble,Wp5,
     +           Ocurv,extras
      REWIND 9
      RETURN
      END
C--------------------------------------------------
C                             Write current PAGE of particles (x,v) to disk
C                             NRECL - length of ROW block in words
      SUBROUTINE WRIROW(IROW,Ifile)
C--------------------------------------------------
      INCLUDE 'PMparameters.h'
        WRITE (20+Ifile,REC=IROW) RECDAT
      RETURN
      END
cC--------------------------------------------------
cC                             Set Weights of particles for
cC                             fast access
c      SUBROUTINE SetWeight
cC--------------------------------------------------
c      INCLUDE 'PMparameters.h'
c      If(Nspecies.eq.0)Then  ! old  constant weights
c         N_particles =lspecies(1)
c         Do i=1,N_particles
c            iWeight(i) =PARTW
c         EndDo
c      Else
c         N_particles =lspecies(Nspecies)
c         jstart =1
c         Do j=1,Nspecies
c            jend =lspecies(j)
c            Do k=jstart ,jend
c               iWeight(k) =wspecies(j)
c            EndDo
c            jstart =jend
c         EndDo
c      EndIf
c      write (*,*) ' Set Weights for ',N_particles,' particles'
c      RETURN
c      END
C--------------------------------------------
C                            Read current PAGE of particles  from disk
C                            NRECL - length of ROW block in words
      SUBROUTINE GETROW(IROW,Ifile)
C--------------------------------------------
      INCLUDE 'PMparameters.h'
         READ  (20+Ifile,REC=IROW) RECDAT
      RETURN
      END
C------------------------------------------------
C				                                       random number generator
      FUNCTION RANDd(M)
C------------------------------------------------
      DATA LC,AM,KI,K1,K2,K3,K4,L1,L2,L3,L4
     +	/453815927,2147483648.,2147483647,536870912,131072,256,
     +	 16777216,4,16384,8388608,128/
      ML=M/K1*K1
      M1=(M-ML)*L1
      ML=M/K2*K2
      M2=(M-ML)*L2
      ML=M/K3*K3
      M3=(M-ML)*L3
      ML=M/K4*K4
      M4=(M-ML)*L4
      M5=KI-M
      IF(M1.GE.M5)M1=M1-KI-1
      ML=M+M1
      M5=KI-ML
      IF(M2.GE.M5)M2=M2-KI-1
      ML=ML+M2
      M5=KI-ML
      IF(M3.GE.M5)M3=M3-KI-1
      ML=ML+M3
      M5=KI-ML
      IF(M4.GE.M5)M4=M4-KI-1
      ML=ML+M4
      M5=KI-ML
      IF(LC.GE.M5)ML=ML-KI-1
      M=ML+LC
      RANDd=M/AM
      RETURN
      END
C--------------------------------------
C				normal random numbers
      FUNCTION GAUSS(M)
C--------------------------------------
      X=0.
      DO  I=1,5
         X=X+RANDd(M)
      EndDo
      X2   =1.5491933*(X-2.5)
      GAUSS=X2*(1.-0.01*(3.-X2*X2))
      RETURN
      END

C---------------------------------- Read in variables      
      REAL FUNCTION INPUT(text)
C------------------------------------------------
      Character text*(*)
          write (*,'(A,$)')text
          read (*,*) x
          INPUT =x
      Return
      End
C--------------------------------------   Fourier Transform
      SUBROUTINE SETF67(JBC1,JQ1,jbc,jp,jsl,ll1,k2,k3,k4,k7,
     &                  Qi,jndx,Uf,Vf)
c     -----------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR.h'	  

      dimension Uf(marr) , Vf(marr)
      dimension Qi(mf67) , jndx(mf67)

      PI=DATAN(1.D0)*4.
       JBC=JBC1
       JQ=JQ1
       IF(JBC.LT.3) GO TO 101
       JQ=JQ-1
  101      K3=2**JQ
       K7=K3/2
       N5=K3/4
       I=1
       JNDX(I)=N5
       QI(I)=0.5*SQRT(2.)
       K=I
       I=I+1
  102     IL=I
       IF(I.EQ.K7) GO TO 104
  103     K1=JNDX(K)/2
       JNDX(I)=K1
       QI(I)=SIN(PI*FLOAT(K1)/FLOAT(K3))
       K1=K7-K1
       I=I+1
       JNDX(I)=K1
       QI(I)=SIN(PI*FLOAT(K1)/FLOAT(K3))
       K=K+1
       I=I+1
       IF(K.EQ.IL) GO TO 102
       GO TO 103
  104     RETURN
       END
C-----------------------------------------
       SUBROUTINE TFOLD(IS,L,ZZZ,k2)
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR.h'	  


       DIMENSION ZZZ(MARR)
       IH2=K2/2-1
       DO 100 I=IS,IH2
       I1=I+L
       I2=K2-I+L
       A=ZZZ(I1)
       ZZZ(I1)=A-ZZZ(I2)
       ZZZ(I2)=A+ZZZ(I2)
  100     CONTINUE
       RETURN
       END
C------------------------------------
       SUBROUTINE NEG(I1,I3,I2,jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR.h'	  
       dimension Uf(marr) , Vf(marr)
       dimension Qi(mf67) , jndx(mf67)
 
       DO 100 K=I1,I3,I2
       Vf(K)=-Vf(K)
  100     CONTINUE
       RETURN
       END
C-------------------------------------
       SUBROUTINE REVNEG(jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR.h'	  
       dimension Uf(marr) , Vf(marr)
       dimension Qi(mf67) , jndx(mf67)

       integer  jbc , jp, jsl , ll1 , k2 , k3 , k4 , k7

       DO 100 I=1,K7
       J=K3+1+I
       K=K4+1-I
       A=Vf(J)
       Vf(J)=-Vf(K)
       Vf(K)=-A
  100     CONTINUE
       RETURN
       END
C-------------------------------------
       SUBROUTINE ZEERO(L,jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR.h'	  
       dimension Uf(marr) , Vf(marr)
       dimension Qi(mf67) , jndx(mf67)

       integer  jbc , jp, jsl , ll1 , k2 , k3 , k4 , k7

       DO 100 I=1,K2
       LI=L+I
       Uf(LI-1)=0.0
  100     CONTINUE
       RETURN
       END
C------------------------------------------
       SUBROUTINE TFOLD1(jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR.h'	  
       dimension Uf(marr) , Vf(marr)
       dimension Qi(mf67) , jndx(mf67)

       integer  jbc , jp, jsl , ll1 , k2 , k3 , k4 , k7

       II=K2-1
       DO 100 I=1,II
       I1=JSL+I
       I2=LL1-I
       A=Uf(I1)
       Uf(I1)=A+Uf(I2)
       Uf(I2)=A-Uf(I2)
  100     CONTINUE
       RETURN
       END
C-------------------------------------
       SUBROUTINE KFOLD(jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR.h'	  
       dimension Uf(marr) , Vf(marr)
       dimension Qi(mf67) , jndx(mf67)

       integer  jbc , jp, jsl , ll1 , k2 , k3 , k4 , k7

       JS1=K2
       I=1
       J5=JSL+K2
       IS1=JSL
       IC1=LL1
       JS1=JS1/2
       IF(JS1.NE.1) GO TO 200
       K1=JNDX(I)
       SN=QI(I)
       IS0=IS1
       IS1=IS1+JS1
       IC0=IC1
       IC1=IC1+JS1
       ODD1=SN*(Uf(IC1)-Uf(IS1))
       Vf(K1+1)=Uf(IC0)+ODD1
       K3MK1=K3-K1
       Vf(K3MK1+1)=Uf(IC0)-ODD1
       IF(JBC.LT.3) GO TO 110
       ODD2=SN*(Uf(IC1)+Uf(IS1))
       K3PK1=K3+K1
       Vf(K3PK1+1)=Uf(IS0)+ODD2
       K4MK1=K4-K1
       Vf(K4MK1+1)=-Uf(IS0)+ODD2
  110     RETURN
  200     SN=QI(I)
       IS1=IS1+JS1
       IC1=IC1+JS1
       J3=IS1+JS1
  210     IS0=IS1-JS1
       IC0=IC1-JS1
       ODD1=SN*(Uf(IC1)-Uf(IS1))
       ODD2=SN*(Uf(IC1)+Uf(IS1))
       Uf(IC1)=Uf(IC0)-ODD1
       Uf(IS1)=-Uf(IS0)+ODD2
       Uf(IC0)=Uf(IC0)+ODD1
       Uf(IS0)=Uf(IS0)+ODD2
       IS1=IS1+1
       IC1=IC1+1
       IF(IS1.NE.J3) GO TO 210
       I=I+1
  300     IS1=JSL
       IC1=LL1
       JS1=JS1/2
       IF(JS1.EQ.1) GO TO 400
  310     SN=QI(I)
       I=I+1
       CS=QI(I)
       IS1=IS1+JS1
       IC1=IC1+JS1
       J3=IS1+JS1
  320     IS0=IS1-JS1
       IC0=IC1-JS1
       ODD1=CS*Uf(IC1)-SN*Uf(IS1)
       ODD2=SN*Uf(IC1)+CS*Uf(IS1)
       Uf(IC1)=Uf(IC0)-ODD1
       Uf(IC0)=Uf(IC0)+ODD1
       Uf(IS1)=-Uf(IS0)+ODD2
       Uf(IS0)=Uf(IS0)+ODD2
       IS1=IS1+1
       IC1=IC1+1
       IF(IS1.NE.J3) GO TO 320
       IS1=IS1+JS1
       IC1=IC1+JS1
       J3=IS1+JS1
  330     IS0=IS1-JS1
       IC0=IC1-JS1
       ODD1=SN*Uf(IC1)-CS*Uf(IS1)
       ODD2=CS*Uf(IC1)+SN*Uf(IS1)
       Uf(IC1)=Uf(IC0)-ODD1
       Uf(IC0)=Uf(IC0)+ODD1
       Uf(IS1)=-Uf(IS0)+ODD2
       Uf(IS0)=Uf(IS0)+ODD2
       IS1=IS1+1
       IC1=IC1+1
       IF(IS1.NE.J3) GO TO 330
       I=I+1
       IF(IS1.EQ.J5) GO TO 300
       GO TO 310
  400     K1=JNDX(I)
       SN=QI(I)
       I=I+1
       CS=QI(I)
       IS0=IS1
       IS1=IS1+JS1
       IC0=IC1
       IC1=IC1+JS1
       ODD1=CS*Uf(IC1)-SN*Uf(IS1)
       Vf(K1+1)=Uf(IC0)+ODD1
       K3MK1=K3-K1
       Vf(K3MK1+1)=Uf(IC0)-ODD1
       IF(JBC.LT.3) GO TO 410
       ODD2=SN*Uf(IC1)+CS*Uf(IS1)
       K3PK1=K3+K1
       Vf(K3PK1+1)=Uf(IS0)+ODD2
       K4MK1=K4-K1
       Vf(K4MK1+1)=-Uf(IS0)+ODD2
  410     IS1=IS1+1
       IC1=IC1+1
       K1=JNDX(I)
       IS0=IS1
       IS1=IS1+JS1
       IC0=IC1
       IC1=IC1+JS1
       ODD1=SN*Uf(IC1)-CS*Uf(IS1)
       Vf(K1+1)=Uf(IC0)+ODD1
       K3MK1=K3-K1
       Vf(K3MK1+1)=Uf(IC0)-ODD1
       IF(JBC.LT.3) GO TO 420
       ODD2=CS*Uf(IC1)+SN*Uf(IS1)
       K3PK1=K3+K1
       Vf(K3PK1+1)=Uf(IS0)+ODD2
       K4MK1=K4-K1
       Vf(K4MK1+1)=-Uf(IS0)+ODD2
  420     IS1=IS1+1
       IC1=IC1+1
       I=I+1
       IF(IS1.NE.J5) GO TO 400
       RETURN
       END

c      ------------------------------------------------------
       SUBROUTINE FOUR67(JBC1,JQ1,jp1,jsl1,ll11,k21,k71,
     &                   Qi,jndx,Uf,Vf)
c      ------------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR.h'	  
       dimension Uf(marr) , Vf(marr)
       dimension Qi(mf67) , jndx(mf67)

       integer  jbc , jp, jsl , ll1 , k2 , k3 , k4 , k7

       JBC=JBC1
       JQ=JQ1
       jp = jp1
       jsl = jsl1
       ll1 = ll11
       k2 = k21
       k7 = k71
       A5=0.5*SQRT(2.0)
       K4=2**JQ
       K3=K4
       GO TO (103,103,101,102),JBC
  101     Uf(1)=Uf(1)/2.0
       Uf(K3+1)=Uf(1)
       K2=K3

       CALL TFOLD(0,1,Uf,k2)

       K3=K3/2
       JQ=JQ-1
       GO TO 103
  102     K3=K3/2
       JQ=JQ-1
  103     N5=K3/4
       K7=K3/2
       N11=3*K7
       K31=K3+1
       GO TO(300,400,500,600),JBC
  300     Uf(K31)=0.0
       Uf(1)=0.0
       K2=K3
       DO 301 I=2,JQ

       CALL TFOLD(1,1,Uf,k2)

  301     K2=K2/2
       Vf(K7+1)=Uf(2)
       JF=N5
       JSL=1
       DO 302 JP=2,JQ
       LL1=K2+1

       CALL ZEERO(1,jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)
       CALL KFOLD(jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

       I1=3*JF+1
       I2=4*JF
       I3=I1+(K2/2-1)*I2

       CALL NEG(I1,I3,I2,jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

       K2=K2+K2
  302     JF=JF/2
       RETURN
  400     Uf(1)=Uf(1)/2.0
       Uf(K31)=Uf(K31)/2.0
       K2=K3
       DO 401 I=2,JQ

       CALL TFOLD(0,K31-K2,Uf,k2)

  401     K2=K2/2
       LL1=K31-K2
       A=Uf(LL1)+Uf(LL1+2)
       Vf(1)=-A-Uf(LL1+1)
       Vf(K31)=-A+Uf(LL1+1)
       Vf(K7+1)=Uf(LL1)-Uf(LL1+2)
       DO 402 JP=2,JQ
       JSL=K31-K2
       LL1=JSL-K2
       idum = jsl

       CALL ZEERO(idum,jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)
       CALL KFOLD(jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

  402     K2=K2+K2

       CALL NEG(1,K31,2,jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

       RETURN
  500     K2=K3
       L2=K4
       DO 501 JP=2,JQ

       CALL TFOLD(1,1,Uf,k2)
       CALL TFOLD(0,L2-K2+1,Uf,k2)

  501     K2=K2/2
       LL1=L2-K2+1
       A=Uf(LL1)+Uf(LL1+2)
       Vf(K7+1)=2.0*(-Uf(LL1)+Uf(LL1+2))
       Vf(1)=2.0*(A+Uf(LL1+1))
       Vf(K31)=2.0*(A-Uf(LL1+1))
       Vf(N11+1)=2.0*Uf(2)
       DO 502 JP=2,JQ
       Uf(K2+1)=2.0*Uf(K2+1)
       JSL=K2+1

       CALL TFOLD1(jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

       LL1=LL1-K2
       Uf(LL1)=-2.0*Uf(LL1)

       CALL KFOLD(jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

  502     K2=K2+K2
       Vf(1)=Vf(1)*A5
       Vf(K31)=Vf(K31)*A5
       RETURN
  600     Uf(1)=Uf(1)*A5
       Uf(K31)=Uf(K31)*A5
       K2=K3
       DO 601 JP=2,JQ

       CALL TFOLD(0,K31-K2,Uf,k2)
       CALL TFOLD(1,K31,Uf,k2)

  601     K2=K2/2
       LL1=K31-K2
       A=Uf(LL1)+Uf(LL1+2)
       Vf(1)=2.0*(A+Uf(LL1+1))
       Vf(K31)=2.0*(A-Uf(LL1+1))
       Vf(K7+1)=2.0*(-Uf(LL1)+Uf(LL1+2))
       Vf(N11+1)=2.0*Uf(K3+2)
       DO 602 JP=2,JQ
       JSL=K31+K2
       Uf(JSL)=2.0*Uf(JSL)

       CALL TFOLD1(jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

       LL1=LL1-K2
       Uf(LL1)=-2.0*Uf(LL1)

       CALL KFOLD(jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

  602     K2=K2+K2

       CALL REVNEG(jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

       idum = k3

       CALL NEG(2,idum,2,jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

       K2=K4

       CALL TFOLD(1,1,Vf,k2)

       Vf(K4+1)=0.0

       RETURN
       END

C---------------------------------------------
C                       Write current data to  disk/tape
C                        for PMstartM - multiple masses
      SUBROUTINE WriteData(Vscale,AexpV,Wtotal)
C----------------------------------------------
      INCLUDE 'PMparameters.h'
      COMMON / BUFF /	XPt(Nmaxpart),YPt(Nmaxpart),ZPt(Nmaxpart),
     +			VXt(Nmaxpart),VYt(Nmaxpart),VZt(Nmaxpart)
       COMMON / KINENRG/ SKINE,SX,SY,SZ,SX2,SY2,SZ2
C
      XMAX  = FLOAT(NGRID) + 1.
      XSHF  = FLOAT(NGRID)
      SKINE =0.
      Wtotal =0.
       jstart =1
       write (*,*) ' Nspecies=',Nspecies
       Do j =1,Nspecies
          vvx =0.
          vvy =0.
          vvz =0.
          vx2 =0.
          vy2 =0.
          vz2 =0.
          jend =lspecies(j)
          W     =wspecies(j)
          If(jend.gt.jstart)Then
             write (*,*)'  wrdata: jstart,jend=',jstart,jend
          Do i=jstart,jend
             vvx = vvx + VXt(i)
             vvy = vvy + VYt(i)
             vvz = vvz + VZt(i)
             vx2 = vx2 + VXt(i)**2
             vy2 = vy2 + VYt(i)**2
             vz2 = vz2 + VZt(i)**2
              SKINE    = SKINE + W*(VXt(i)**2 +VYt(i)**2 +VZt(i)**2)
              Wtotal =Wtotal +w 
          EndDo
           npp =max(jend-jstart+1,1)
           v2 = sqrt((vx2 +vy2+vz2)/npp)/AexpV*Vscale
           vvx =vvx/npp/AexpV*Vscale
           vvy =vvy/npp/AexpV*Vscale
           vvz =vvz/npp/AexpV*Vscale
           write (*,350) vvx,vvy,vvz,v2,jend-jstart+1,j
 350       format('       V(km/s)=',4g11.3, ' Npart=',i8,' Species=',i3)
          jstart =  jend+1
          Endif 
       EndDo
      Ibuff =0
      KROW =0
      write (*,*) ' lspecies(Nspecies)=',lspecies(Nspecies)
      Do i=1,lspecies(Nspecies)
C                                Periodical boundary conditions
	       IF(XPt(i).GT.XMAX)	      XPt(i)=XPt(i)-XSHF
	       IF(XPt(i).LE.1.)	            XPt(i)=XPt(i)+XSHF
	       IF(YPt(i).GT.XMAX)	      YPt(i)=YPt(i)-XSHF
	       IF(YPt(i).LE.1.)	            YPt(i)=YPt(i)+XSHF
	       IF(ZPt(i).GT.XMAX)	      ZPt(i)=ZPt(i)-XSHF
	       IF(ZPt(i).LE.1.)	            ZPt(i)=ZPt(i)+XSHF
             Ibuff              = Ibuff +1
             XPAR(Ibuff) = XPt(i)
             YPAR(Ibuff) = YPt(i)
             ZPAR(Ibuff) = ZPt(i)
             VX(Ibuff)      = VXt(i)
             VY(Ibuff)      = VYt(i)
             VZ(Ibuff)      = VZt(i)
             If(  XPAR(Ibuff).lt.1..or.YPAR(Ibuff).lt.1.
     &      .or.ZPAR(Ibuff).lt.1.)write (*,*) ' Error!!!',i, 
     &             XPAR(Ibuff),YPAR(Ibuff),ZPAR(Ibuff)
              If(  XPAR(Ibuff).ge.XMAX.or.YPAR(Ibuff).ge.XMAX
     &      .or.ZPAR(Ibuff).ge.XMAX)write (*,*) ' Error!!!',i, 
     &             XPAR(Ibuff),YPAR(Ibuff),ZPAR(Ibuff)
             If(  XPAR(Ibuff).ge.XMAX)Then
                XPAR(Ibuff) = XPAR(Ibuff) -1.e-4
                write (*,500) XPAR(Ibuff)
             endif 
             If(  YPAR(Ibuff).ge.XMAX)Then
                YPAR(Ibuff) = YPAR(Ibuff) -1.e-4
                write (*,500) YPAR(Ibuff)
             endif 
             If(  ZPAR(Ibuff).ge.XMAX)Then
                ZPAR(Ibuff) = ZPAR(Ibuff) -1.e-4
                write (*,500) ZPAR(Ibuff)
 500            format(' fixed boundary. It is now=',g14.7)
             endif 

            If(Ibuff.ge.NPAGE)Then
                KROW = KROW +1
                if(KROW/10*10.eq.KROW)
     &             write (*,*) ' Write page=',KROW,' i=',i,Ibuff
                CALL WRIROW(KROW,1)
                Ibuff     =0
             EndIf
          EndDo
          If(Ibuff.ne.0)Then    ! write last incomplete page
                KROW = KROW +1
                write (*,*) ' Write page=',KROW,' i_buff=',Ibuff
                CALL WRIROW(KROW,1)
                Ibuff     =0
          EndIf
      RETURN
      END

c----------------------------------------------------------------
c                                Find <r>, <M>, period  for
c                                trajectories in  NFW potential
c
      Include 'NFWr.h'
      EXTERNAL F, EUeff, AvRadius,AvMass,Period,AvMR

      CALL InitValues
      Open(1,file='Result.dat')
c
      write(*,'("x",T12,"<x>",T24,"ratio",
     &           T36,"Mass(x)",T48,"Mass(<x>)",
     &           T60,"ratio",T72,"V_c",T84,"RMS V   <r_min/r_max>")')
c                                                     Loop over radii
      do i=0,150
         x=0.001*10.**(i/10.)
         If(x.ge.1.d-3.and.x.lt.min(x_out,10.))Then
            Sigma =sqrt(Sigma_r(x))
            rRad =0.
            rMR  =0.
            eccen =0.
            aLs   = 0.
         Do j=1,norb
 1          CALL SetOrbit2(x)
            CALL Rminmax(r_min,r_max,EUeff)
            If(r_max.ge.x_out)GoTo1       ! take only orbit inside x_out
            If(r_max.gt.r_min*1.01)Then   ! non circular orbit
               r_max = r_max/1.001           ! slightly change limits 
               r_min = r_min*1.001             ! to avoid singularities

            CALL DGAUS8 (Period, r_min,r_max, eps2, Tperiod, IERR)
                  if(IERR.ne.1)write (*,*)  ' ERROR Period=',IERR
            CALL DGAUS8 (AvRadius, r_min,r_max, eps2, RadAver, IERR)
                  if(IERR.ne.1)write (*,*)  ' ERROR AvRadius=',IERR
c            CALL DGAUS8 (AvMR, r_min,r_max, eps2, aMRAver, IERR)
c                  if(IERR.ne.1)write (*,*)  ' ERROR AvMR=',IERR
c               rMR       = rMR  + aMRAver/Tperiod
                  RadAver = RadAver/Tperiod
            Else                ! circular orbit
                RadAver = r_min
                r_max      = r_min
            EndIf
               aLs        = aLs + aL2
               rRad      = rRad  + RadAver
               eccen = eccen + r_min/r_max
         EndDo
         rRad      = rRad/norb
         eccen    = eccen/norb
         aLs         = sqrt(aLs/norb)
               write(*,100) x,rRad,rRad/x,F(x),F(rRad),
     &               F(rRad)/F(x),sqrt(F(x)/x),sqrt(3.)*Sigma,eccen,
     &               aLs/sqrt(F(x)*x)
 100     format(g11.4,T12,g11.4,T24,f7.3,T36,g11.4,T48,g11.4,T60,g11.4,
     &                        T72,g11.4,T84,3g11.4)
         EndIf
      EndDo
      Stop
      End

C---------------------------------------
       SUBROUTINE SetOrbit
c                    set energy and angular momentum
c                    for orbit with given xmax and alpha
c                      L =alpha*L_circular(xmax)
C---------------------------------------
      Include 'NFWr.h'
         En  = Phi(xmax) + 0.5*alpha**2 *F(xmax)/xmax
         aL2 = alpha**2 *F(xmax)*xmax
      RETURN
      END

C---------------------------------------
       SUBROUTINE SetOrbit2(x)
c                    set energy and angular momentum
c                    for orbit with random rad and perp velocities
c                      L =alpha*L_circular(xmax)
C---------------------------------------
      Include 'NFWr.h'
 1      Vrad  = Gauss(Nseed)*Sigma
         Vperp= Gauss(Nseed)*Sigma*sq2
         aL2     = (Vperp*x)**2
         En       = Phi(x) + 0.5d0*(Vperp**2+Vrad**2)
         If(En.ge.Phimax)goto1
      RETURN
      END

C---------------------------------------
       SUBROUTINE InitValues
c                    Initialize parameters
c                    for NFW and truncated Isothermal
C---------------------------------------
      Include 'NFWr.h'

      x_out   =35.             ! truncation for NFW
      x1out = 1./(1.+x_out)
      
      norb = 50000
      Nseed = 121071

      eps1 = 1.d-7           ! errors of intigration
      eps2 = 1.d-5
      RETURN
      END

C---------------------------------------
       SUBROUTINE Rminmax(r_min,r_max,Func)
c                     Find r_min and r_max for NFW
C---------------------------------------
      Include 'NFWr.h'
      External Func
      r0 =3.e-5                  ! find radius r0 such that Func(r0) <0
      n = 0
 1    r0 =r0/1.5
      n = n+1
c      write (*,*)  '  Rminmax: r0=',r0,n,Func(r0)
         if(n.gt.100)Then
            write (*,*) '             r0=',r0,Func(r0)       
         Do i=1,30
            r= 0.001*10.**(i/15.)
            write (*,300) r,Func(r)
 300        format(' r=',g11.3,' F=',g11.3)
         EndDo
         Stop
         EndIf
      If(Func(r0).gt.0.)goto1

 6    fact =1.1
      r1 =r0
      n = 0
      ff0= -1.e+15 
 2    r1 =r1*fact
      ff = ff0
      n = n+1
      ff0 = Func(r1)
c      write (*,*)  '   r1=',r1,' F=',ff0
      If(ff0.lt.0.and.ff0.gt.ff)goto2
      If(ff0.lt.0.)Then
c         write(*,*) ' r1=',r1,' F=',ff0,' previous F=',ff
         fact =1.+(fact-1.)/15.
c         EnIso =EnIso/1.05

c         write(*,*) ' r1=',r1,' Fnew=',Func(r1)
         fact = 1./fact
c         write (*,*) '  change factor=',fact
         n =0
 5       r1 =r1*fact
         n = n +1
         ff0 = Func(r1)
         if(n.gt.50)Then ! this is circular orbit
                                  ! make it a bit elliptical
c           write (*,*) ' too many iterations for r1=',r1,ff0
           r1 =r0
          En =En-ff0+1.e-10
          fact =1./fact
          ff0 = -1.e+15
          goto2
         endIf
         If(ff0.lt.0.)Goto5
      EndIf
      If(Func(r0)*Func(r1).gt.0.)Then
         write(*,'(" error1: r=",2g11.3," Func=",2g11.3)')
     &   r0,r1, Func(r0),Func(r1)
         STOP
       EndIf
      n = 0
      r2 =r1
 3    r2 =r2*1.1
      n = n+1
      If(n.gt.250)Then
         write (*,*) '             r2=',r2, Func(r2)   
         write (*,*) '             r0=',r0, Func(r0),En
         rr =r0
         Do ii =0,1500
            rr =rr*1.02
            write (*,*) '             rr=',rr, Func(rr)
         EndDo 
         STOP
      EndIf 
      If(Func(r2).gt.0.)goto3
c      write (*,*) ' first guess =',r0,r1,r2,'   Functions=',Func(r0),
c     &        Func(r1), Func(r2)  
      rr = r1
      ru =r0
      r_guess =(r0+r1)/2.
      CALL DFZERO(Func,r0,rr,r_guess,1.d-8,1.d-8,iflag)
      If(iflag.ne.1)write(*,*)' error1 zero not reached',r0,ru,r1
      r_min =r0
      r_guess =(r1+r2)/2.
      CALL DFZERO(Func,r1,r2,r_guess,1.d-8,1.d-8,iflag)
      If(iflag.ne.1)write(*,*)' error2 zero not reached',r0,r1
      r_max =r1
c      write (*,50) r_min,r_max,Func(r_min) ,Func(r_max) 
c 50   format(' rmin/max=',2g11.4,' functions=',2g11.4)
c      write (*,*)  ' Func(xmax)=',Func(xmax),' xmax=',xmax
      RETURN
      END

C---------------------------------------
       DOUBLE PRECISION FUNCTION F(x)
c                              Mass for NFW
c                               x must be smaller than xout
C---------------------------------------
      Include 'NFWr.h'
      If(x.le.x_out)Then
         F = Log(1.+x) -x/(1.+x)
      Else
         F = Log(1.+x_out) -x_out/(1.+x_out)
      EndIf
      RETURN
      END

C---------------------------------------
       DOUBLE PRECISION FUNCTION Period(x)
c                              integrant for radial period
c                              
C---------------------------------------
      Include 'NFWr.h'
         Period = 1./sqrt(ABS(2.*EUeff(x)))
      RETURN
      END

C---------------------------------------
       DOUBLE PRECISION FUNCTION AvRadius(x)
c                              integrant for average radius
c                              
C---------------------------------------
      Include 'NFWr.h'
         AvRadius = x/sqrt(ABS(2.*EUeff(x)))
      RETURN
      END
C---------------------------------------
       DOUBLE PRECISION FUNCTION AvMass(x)
c                              integrant for average mass
c                              
C---------------------------------------
      Include 'NFWr.h'
         AvMass = F(x)/sqrt(ABS(2.*EUeff(x)))
      RETURN
      END

C---------------------------------------
       DOUBLE PRECISION FUNCTION AvMR(x)
c                              integrant for average massxRadius
c                              
C---------------------------------------
      Include 'NFWr.h'
         AvMR = F(x)*x/sqrt(ABS(2.*EUeff(x)))
      RETURN
      END

C---------------------------------------
       DOUBLE PRECISION FUNCTION Phi(x)
c                              Potential for truncated NFW
c                              Phi(x) < 0
C---------------------------------------
      Include 'NFWr.h'
      If(x.le.x_out)Then
         Phi = -Log(1.+x)/x +x1out
      Else
         Phi = -F(x_out)/x
      EndIf
      RETURN
      END

C---------------------------------------
       DOUBLE PRECISION FUNCTION EUeff(x)
c                    E-Ueff(x)
c                          
C---------------------------------------
      Include 'NFWr.h'
         EUeff = En -Phi(x)-aL2/2./x**2
      RETURN
      END

C---------------------------------- Read in variables      
      REAL FUNCTION INPUT(text)
C------------------------------------------------
      Character text*(*)
          write (*,'(A,$)')text
          read (*,*) x
          INPUT =x
      Return
      End
C---------------------------------------
      DOUBLE PRECISION  FUNCTION Sigma_r(x)
c            radial velocity dispersion for truncated NFW
C---------------------------------------
      Include 'NFWr.h'
      External Fsigma

      if(x.ge.x_out)Then
         Sigma_r =0.
      Else
         CALL DGAUS8 (Fsigma, x,x_out, eps2, Sigma_r, IERR)         
         Sigma_r =(x*(1.+x)**2) *Sigma_r
      EndIf

      RETURN
      END

C---------------------------------------
       DOUBLE PRECISION FUNCTION Fsigma(x)
c                     Integrant for Sigma_r f(x)/x^3/(1+x)^2
C---------------------------------------
      Include 'NFWr.h'
         z      = 1.+x
         Fsigma =(LOG(z)-x/z)/x**3/z**2 
      RETURN
      END
C------------------------------------------------
C				                                       random number generator
      DOUBLE PRECISION FUNCTION RANDd(M)
C------------------------------------------------
      DATA LC,AM,KI,K1,K2,K3,K4,L1,L2,L3,L4
     + /453815927,2147483648.,2147483647,536870912,131072,256,
     + 16777216,4,16384,8388608,128/
      ML=M/K1*K1
      M1=(M-ML)*L1
      ML=M/K2*K2
      M2=(M-ML)*L2
      ML=M/K3*K3
      M3=(M-ML)*L3
      ML=M/K4*K4
      M4=(M-ML)*L4
      M5=KI-M
      IF(M1.GE.M5)M1=M1-KI-1
      ML=M+M1
      M5=KI-ML
      IF(M2.GE.M5)M2=M2-KI-1
      ML=ML+M2
      M5=KI-ML
      IF(M3.GE.M5)M3=M3-KI-1
      ML=ML+M3
      M5=KI-ML
      IF(M4.GE.M5)M4=M4-KI-1
      ML=ML+M4
      M5=KI-ML
      IF(LC.GE.M5)ML=ML-KI-1
      M=ML+LC
      RANDd=M/AM
      RETURN
      END
C--------------------------------------
C	normal random numbers
      DOUBLE PRECISION  FUNCTION GAUSS(M)
C--------------------------------------
      DOUBLE PRECISION  RANDd
      X=0.
      DO  I=1,5
         X=X+RANDd(M)
      EndDo
      X2   =1.5491933*(X-2.5)
      GAUSS=X2*(1.-0.01*(3.-X2*X2))
      RETURN
      END

C ______________________________	   POWER SPECTRUM
C		                      25 april 1990
C		                     R. Kates (Potsdam), A. Klypin (NMSU)
C	     NROW = number of particles per row
C	     NGRID= number of cells on a side (normal grid)
       INCLUDE 'PMparameters.h'
       INCLUDE 'PMmesh.h'
       REAL     INPUT
C...................................................................
C			Read data and open files
      OPEN(17,FILE='Spectrum.DAT',STATUS='UNKNOWN')
      CALL RDTAPE

      write (*,*) ' RDTAPE is done'
      WRITE (17,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,wspecies(1),
     +                  EKIN,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv,lspecies(1),Nspecies
100   FORMAT(1X,'Header=>',A45,/
     +            1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I9,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3,/
     +            1x,' Number of part.1specie=',i10,' Nspecies=',i3)
      Box = extras(100)
      If(Box.le.1.e-3)Then
          Box =INPUT(' Enter box size in Mpc/h   =')
      EndIf 
C
         CALL DENSIT    !   Find density
            write (*,*) ' Density is ok'
c      Call DensCR
         CALL DENTES(DELR) ! Statistics
         CALL POWER(Box)   ! Power spectrum

      STOP
      END

C-----------------------------------------------------
C		                                                  Compute mean density and rms
      SUBROUTINE DENTES(DELR)
C-----------------------------------------------------
       INCLUDE 'PMparameters.h'
       INCLUDE 'PMmesh.h'
      Dimension x(44),amass(44),imass(44)
      real*8 SUM,SUM2

      Data x/  0.,  0.2, 0.4, 0.6, 0.7,  0.8,  0.9,  1.,  1.1,   1.2,
     .         1.3, 1.5, 1.75, 2., 2.25, 2.5,  3.0,  3.5,  4.,    5.,
     .         7.,  10., 12., 15., 20.,  25.,  30.,  40.,  50.,  70.,
     .       100., 120.,150.,200.,300., 500., 700.,1000.,1200.,1500.,
     .       2.e3, 3.e3,5.e3,1.e4/
      Do i=1,44
         amass(i) =0.
         imass(i) =0
      EndDo
      
      SUM = 0.
      SUM2= 0.
      Nn  = 0
      Am  = 0.
      DO K=1,NGRID
      DO J=1,NGRID
      DO I=1,NGRID
       SUM = SUM + FI(I,J,K)
       SUM2= SUM2+ FI(I,J,K)**2
       Do l=44,1,-1
          Dens =FI(I,J,K) +1.
          If(Dens .GT. x(l))Then
             Nn       =Nn +1
             Am       =Am +Dens
             imass(l) =imass(l) +1
             amass(l) =amass(l) +Dens
             GoTo 10
          EndIf
       EndDo
 10    Continue
      ENDDO
      ENDDO
      ENDDO
      Total =float(NGRID)**3
      DENM = SUM/Total
      DELR = DSQRT(SUM2/Total-DENM**2)
      DensAv=PARTW*NROW**3/float(NGRID)**3
      DensOne= float(NGRID)**3/NROW**3
         WRITE (*,150)  DELR,DENM,DensAv,DensOne
         WRITE (17,150) DELR,DENM,DensAv,DensOne
 150     format(20('-'),' Density Distribution',20('-'),/
     &   '              Density is in units of average density',
     &                       ' in the Box',/20x,
     &                     ' RMS Delta Rho/Rho   =',G11.4,/20x,
     &                     ' Mean Delta Rho/Rho  =',G11.4,/20x,
     &                     ' Average density     =',G11.4,/20x,
     &                     ' One particle density=',G11.4,/
     &' bin    Rho     Rho   Sum(rho_i)/dRho/TotMass        Sum',/
     &'      <center>< left > Normalized density     Number of cells ',/
     &'      < bin  ><border>   Distribution         With this density')  
      Do k=1,44-1
         drho =x(k+1)-x(k)
         rhom =x(k)+drho/2.
         Sn   =drho*Total
            If(Sn .lt.1.e-7)Sn=1.
         write (*,20)  k,rhom,x(k),amass(k)/Sn,imass(k)
         write (17,20) k,rhom,x(k),amass(k)/Sn,imass(k)
 20      Format(i3,2f8.1,2x,G12.3,12X,i12)
      EndDo
         k =44
         write (*,20)  k,x(k),x(k),amass(k),imass(k)
         write (17,20) k,x(k),x(k),amass(k),imass(k)
      RETURN
      END

C----------------------------------------------------
C                                                     power spectrum   P(k)
C                                                     for given density field FI
      SUBROUTINE POWER(Box)
C----------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMmesh.h'
      PARAMETER ( Pi=3.141592653, NPOWER =NGRID)
      DIMENSION   DPOWER(NPOWER),iVolume(NPOWER)
      DIMENSION   dk(NPOWER)
      REAL*8       SIGMA,DPOWER

      NSPEC = NGRID/2
      If(Box.le.0..or.Box.gt.1.e+4)Then
         write (*,*) ' Wrong Box size=',Box,' STOP'
         Return
      EndIf
      SIGMA =0.
      Scale = 2.*Pi/Box
      DO M =1,NPOWER
         iVolume(M) =0
         DPOWER(M)  =0.
         dk(M) =0.
      ENDDO
C                                               FFT of density field
      write (*,*) '     Do fft of rho along x-axis'
      IFOUR = INT(ALOG(FLOAT(NGRID))/ALOG(2.)+0.5)
      FT    = (2.*NGRID)**3*(1.*NGRID)**3
      CALL SETF67(3,IFOUR)
      DO K=1,NGRID
         DO J=1,NGRID
            DO I=1,NGRID
               Zf(I) =FI(I,J,K)
            ENDDO
            CALL FOUR67(3,IFOUR)
            DO I=1,NGRID
               FI(I,J,K) = Yf(I)
            ENDDO
         ENDDO
      ENDDO
      write (*,*) '     ....y'
      DO K=1,NGRID
         DO I=1,NGRID
            DO J=1,NGRID
               Zf(J) =FI(I,J,K)
            ENDDO
            CALL FOUR67(3,IFOUR)
            DO J=1,NGRID
               FI(I,J,K) = Yf(J)
            ENDDO
         ENDDO
      ENDDO
      write (*,*) '     ....z'
      DO J=1,NGRID
         IF(J.LE.(NSPEC+1)) THEN
            MJ =(J-1)**2
         ELSE
            MJ =(J-1-NSPEC)**2
         ENDIF
         DO I=1,NGRID
            IF(I.LE.(NSPEC+1)) THEN
               MI =(I-1)**2
            ELSE
               MI =(I-1-NSPEC)**2
            ENDIF
            DO K=1,NGRID
               Zf(K) =FI(I,J,K)
            ENDDO
            CALL FOUR67(3,IFOUR)
            DO K=1,NGRID
               AMP = Yf(K)**2/FT
               IF((I.EQ.1.AND.J.EQ.1).AND.K.EQ.1)THEN
                  FI(I,J,K) = 0.
               ELSE
C                                          AMP is DeltaRho^2
                  SIGMA = SIGMA +AMP
C                                          Find Abs(K)
                  IF(K.LE.(NSPEC+1)) THEN
                     RK =SQRT( FLOAT((K-1)**2     +MI+MJ) )
                  ELSE
                     RK =SQRT( FLOAT((K-1-NSPEC)**2+MI+MJ) )
                  ENDIF
C                                          devide DeltaRho^2 by Abs(K)
                  FI(I,J,K) = AMP / RK
C                                          Power Spectrum
                  MP =INT(RK +0.5)
                  IF(MP.LE.NPOWER)THEN
                     DPOWER(MP) =DPOWER(MP) +AMP
                     iVolume(MP) =iVolume(MP) +1
                     dk(MP)      =dk(MP)  + RK
                  ENDIF
               ENDIF
            ENDDO
         ENDDO
      ENDDO
 
      WRITE (*,100) SQRT(SIGMA),Scale*NROW/2.
      WRITE (17,100) SQRT(SIGMA),Scale*NROW/2.
100   FORMAT(5x,'RMS DRho/Rho=',g10.3,' k_Nyquist for Particles=',f6.2,
     &        /4X,'n',2X,'k(h/Mpc)',1X,
     &       'Harmonics ','Power Spectrum(h^3)')
110   FORMAT(1x,I4,F8.3,I8,3X,5G12.4)
      DO I=1,NPOWER
         IF(iVolume(I).GT.0)THEN
            wk  = dk(I)/iVolume(I)*Scale
            Pk  = Box**3*DPOWER(I)/iVolume(I)
             
            WRITE (*,110)  I,wk,iVolume(I),Pk
            WRITE (17,110) I,wk,iVolume(I),Pk
         ENDIF
      ENDDO
      RETURN
      END
C---------------------------------------
C                                                       Density Field    
      SUBROUTINE DENSIT
C---------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMmesh.h'
      	XN   =FLOAT(NGRID)+1.-1.E-7
	      YN   =FLOAT(NGRID)
C				       Subtract mean density
      DO M3=1,NGRID
       DO M2=1,NGRID
	      DO M1=1,NGRID
	        FI(M1,M2,M3) = -1.
	      END DO
       END DO
      END DO

      W     = (FLOAT(NGRID)/FLOAT(NROW))**3
      PARTW = W  
      WPAR = wspecies(1)
      N =0
      xmin =1.e+5
      xmax =-1.e+5
      ymin =1.e+5
      ymax =-1.e+5
      zmin =1.e+5
      zmax =-1.e+5

C				       Loop over particles
       If(Nspecies.eq.0)Then ! old case: 1 complete set
         Npages =NROW          ! Number of pages
         N_in_last=NPAGE       ! Number of particles in last page
      Else                             ! multiple masses
         N_particles =lspecies(Nspecies)   ! Total number of particles
         Npages = (N_particles -1)/NPAGE +1
         N_in_last=N_particles -NPAGE*(Npages-1)
      EndIf     
      write (*,*) Nspecies,
     + lspecies(Nspecies),wspecies(Nspecies)
      Nsp_current =1
      WPAR     = wspecies(1) !*8 *8. 
      Lspec_next=lspecies(1)+1
      DO IROW=1,Npages
            In_page =NPAGE
            If(IROW.eq.Npages)In_page =N_in_last
            If(IROW/50*50.eq.IROW)
     +        write (*,*) ' Read page=',IROW,' N=',N,
     +             ' Npages=',Npages,In_page
            iL = NPAGE*(IROW-1)
C				       Loop over particles
         READ  (21,REC=IROW) RECDAT
	   DO   IN=1,In_page
            N   = N +1
            If(N.ge.Lspec_next)Then   ! next specie
               write (*,*) ' Another specie. Current=',Nsp_current
               write (*,*) '     Particle=',N,WPAR,
     &                         ' lspecies=',lspecies(Nsp_current),
     &                         ' next=',lspecies(Nsp_current+1)
               Nsp_current=Nsp_current+1
               Lspec_next =lspecies(Nsp_current)+1
               WPAR     = wspecies(Nsp_current)
            EndIf
        X=(XPAR(IN)-1.)*NGRID/FLOAT(NGRIDC) +1.
        Y=(YPAR(IN)-1.)*NGRID/FLOAT(NGRIDC) +1.
        Z=(ZPAR(IN)-1.)*NGRID/FLOAT(NGRIDC) +1.
           xmin =MIN(xmin,X)
           ymin =MIN(ymin,Y)
           zmin =MIN(zmin,Z)
           xmax =MAX(xmax,X)
           ymax =MAX(ymax,Y)
           zmax =MAX(zmax,Z)
	        I=INT(X)
	        J=INT(Y)
	        K=INT(Z)
            If(I.le.0)write (*,*) ' X:',X,Y,Z,I,' Irow=',IROW,IN,ifile
            If(J.le.0)write (*,*) ' Y:',X,Y,Z,I,' Irow=',IROW,IN,ifile
            If(K.le.0)write (*,*) ' Z:',X,Y,Z,I,' Irow=',IROW,IN,ifile
	        D1=X-FLOAT(I)
	        D2=Y-FLOAT(J)
	        D3=Z-FLOAT(K)
	        T1=1.-D1
	        T2=1.-D2
	        T3=1.-D3
	        T2W =T2*WPAR
	        D2W =D2*WPAR
	        I1=I+1
	           IF(I1.GT.NGRID)I1=1
	        J1=J+1
	           IF(J1.GT.NGRID)J1=1
	        K1=K+1
	           IF(K1.GT.NGRID)K1=1
		      FI(I ,J ,K ) =FI(I ,J ,K ) +T3*T1*T2W
		      FI(I1,J ,K ) =FI(I1,J ,K ) +T3*D1*T2W
		      FI(I ,J1,K ) =FI(I ,J1,K ) +T3*T1*D2W
		      FI(I1,J1,K ) =FI(I1,J1,K ) +T3*D1*D2W
    
		      FI(I ,J ,K1) =FI(I ,J ,K1) +D3*T1*T2W
		      FI(I1,J ,K1) =FI(I1,J ,K1) +D3*D1*T2W
		      FI(I ,J1,K1) =FI(I ,J1,K1) +D3*T1*D2W
		      FI(I1,J1,K1) =FI(I1,J1,K1) +D3*D1*D2W
	      ENDDO
        ENDDO 

      write (*,*) ' Number of particles read=', N
      write (*,*) ' X:',xmin,xmax
      write (*,*) ' Y:',ymin,ymax
      write (*,*) ' Z:',zmin,zmax
        RETURN
      END

C------------------------------------
c      Subroutine densCR
c      INCLUDE 'PMparameters.h'
c      INCLUDE 'PMmesh.h'
c      	XN   =FLOAT(NGRID)+1.-1.E-7
c	      YN   =FLOAT(NGRID)

c      SUMM = 0.
c      WD       =0.
c      open(40,file='dens_cr.dat',status='unknown')
c      read(40,*) FI
c      Do k=1,NROW
c      Do j=1,NROW
c      Do i=1,NROW
c         SUMM =SUMM +FI(i,j,k)
c         WD      =WD +FI(i,j,k)**2
c      EndDo
c      EndDo
c      EndDo
c      sigma = sqrt(MAX(1.d-10,WD/NROW**3))
c      write (*,*) ' Average density=',SUMM/NROW**3
c      write (*,*) ' RMS density=',sigma
c       IFOUR = INT(ALOG(FLOAT(NROW))/ALOG(2.)+0.5)
c       Write (*,*) ' Ifour =',IFOUR,' Nrow=',NROW

c       Return
c       End

C    order_bdm.f                May 2004  S.G. 
C
C  This program orders bdm catalogs by mass



      CHARACTER*120   name1,name2,f_tmp
      CHARACTER*120   line
      CHARACTER*90    trash
      PARAMETER (nmax = 120000)
      DIMENSION r_bdm(3,nmax),r_prim(3,3),
     +          v_fof(nmax),
     +          v_bdm3(3,nmax),v_bdm(nmax),
     +          total_mass_bdm(nmax),rh_bdm(nmax), Vrms_bdm(nmax),
     +          vcirc_bdm(nmax),npar_bdm(nmax),
     +          npar_bdm1(nmax),npar_bdm2(nmax),npar_bdm3(nmax),
     +          indx(nmax), rmax(nmax),conc(nmax)

      
c      box = 50.

      write(*,*) 'filename of the catshort '
      READ (*,'(A)') f_tmp         
c     f_tmp = 'Catshort.DAT'
      CALL  get_name(f_tmp,i,j)
      name2 = f_tmp(i:j)
      name1 = f_tmp(i:j)//'_ord'

      CALL  get_name(name1,in,jn)
      OPEN(11,FILE= name1(in:jn),FORM='FORMATTED',
     +       STATUS='UNKNOWN')

      CALL  get_name(name2,in,jn)
      OPEN(10,FILE= name2(in:jn),FORM='FORMATTED',
     +       STATUS='OLD')

      i = 1
      Do k = 1,21
        READ(10,'(A)')  trash
        write(11,'(A)')  trash
      ENDDO
      READ(10,'(A)')  line
      WRITE(11,123)  line
      write(*,123)  line
  123 Format('    #    ',A120)
      DO WHILE (.TRUE.)
      READ(10,*,END=260)
     +            r_bdm(1,i),r_bdm(2,i),r_bdm(3,i),
     +            v_bdm3(1,i),v_bdm3(2,i),v_bdm3(3,i),
     +            total_mass_bdm(i),rh_bdm(i), Vrms_bdm(i),
     +            vcirc_bdm(i),npar_bdm(i),
     +            rmax(i),conc(i)
      i = i + 1
      ENDDO
  260 n_bdm = i - 1
      write(*,*) n_bdm,'  objects read from the bdm_catalog'

      CALL  indexx(n_bdm,vcirc_bdm,indx)

      n_40 = 0
      n_50 = 0
      n_80 = 0
      n_100 = 0

      kk = 0
      DO k = n_bdm,1,-1
      kk = kk + 1
        i = indx(k)
        write(11,200) kk,
     +            r_bdm(1,i),r_bdm(2,i),r_bdm(3,i),
     +            v_bdm3(1,i),v_bdm3(2,i),v_bdm3(3,i),
     +            total_mass_bdm(i),rh_bdm(i), Vrms_bdm(i),
     +            vcirc_bdm(i),npar_bdm(i),
     +            rmax(i),conc(i)
      IF(vcirc_bdm(i).GT.100.) n_100 = n_100 + npar_bdm(i)
      IF(vcirc_bdm(i).GT.80.) n_80 = n_80 + npar_bdm(i)
      IF(vcirc_bdm(i).GT.50.) n_50 = n_50 + npar_bdm(i)
      IF(vcirc_bdm(i).GT.40.) n_40 = n_40 + npar_bdm(i)

      ENDDO

      write(*,*) n_100,' particles in halos with v_circ > 100 km/s'
      write(*,*)  n_80,' particles in halos with v_circ >  80 km/s'
      write(*,*)  n_50,' particles in halos with v_circ >  50 km/s'
      write(*,*)  n_40,' particles in halos with v_circ >  40 km/s'



 200  FORMAT(I8,3F8.3,3X,3F8.1,G12.3,3F8.2,I8,2F8.1)

      STOP
      END


******************************************************************* 
c     distance with periodic boundary conditions

      FUNCTION DIST(boxsize,XI,XJ,YI,YJ,ZI,ZJ)

      DX = ABS(XI - XJ)
      DDX =ABS(DX - boxsize)
      DX = MIN(DX,DDX)
      DY = ABS(YI - YJ)
      DDY =ABS(DY - boxsize)
      DY = MIN(DY,DDY)
      DZ = ABS(ZI - ZJ)
      DDZ =ABS(DZ - boxsize)
      DZ = MIN(DZ,DDZ)
      DIST = SQRT(DX**2 + DY**2 + DZ**2)
      RETURN
      END

*******************************************************************
C    Ordering of a real array
C
C    Indexing  Sect. 8.4. of Numerical Recipis
C    Changed to integer field

      SUBROUTINE indexx(n,arr,indx)
      INTEGER n,indx(n),M,NSTACK
      REAL arr(n)                       
      PARAMETER (M=7,NSTACK=50)
      INTEGER i,indxt,ir,itemp,j,jstack,k,l,istack(NSTACK)
      REAL a                            
      do 11 j=1,n
        indx(j)=j
11    continue
      jstack=0
      l=1
      ir=n
1     if(ir-l.lt.M)then
        do 13 j=l+1,ir
          indxt=indx(j)
          a=arr(indxt)
          do 12 i=j-1,1,-1
            if(arr(indx(i)).le.a)goto 2
            indx(i+1)=indx(i)
12        continue
          i=0
2         indx(i+1)=indxt
13      continue
        if(jstack.eq.0)return
        ir=istack(jstack)
        l=istack(jstack-1)
        jstack=jstack-2
      else
        k=(l+ir)/2
        itemp=indx(k)
        indx(k)=indx(l+1)
        indx(l+1)=itemp
        if(arr(indx(l+1)).gt.arr(indx(ir)))then
          itemp=indx(l+1)
          indx(l+1)=indx(ir)
          indx(ir)=itemp
        endif
        if(arr(indx(l)).gt.arr(indx(ir)))then
          itemp=indx(l)
          indx(l)=indx(ir)
          indx(ir)=itemp
        endif
        if(arr(indx(l+1)).gt.arr(indx(l)))then
          itemp=indx(l+1)
          indx(l+1)=indx(l)
          indx(l)=itemp
        endif
        i=l+1
        j=ir
        indxt=indx(l)
        a=arr(indxt)
3       continue
          i=i+1
        if(arr(indx(i)).lt.a)goto 3
4       continue
          j=j-1
        if(arr(indx(j)).gt.a)goto 4
        if(j.lt.i)goto 5
        itemp=indx(i)
        indx(i)=indx(j)
        indx(j)=itemp
        goto 3
5       indx(l)=indx(j)
        indx(j)=indxt
        jstack=jstack+2
        if(jstack.gt.NSTACK)pause 'NSTACK too small in indexx'
        if(ir-i+1.ge.j-l)then
          istack(jstack)=ir
          istack(jstack-1)=i
          ir=j-1
        else
          istack(jstack)=j-1
          istack(jstack-1)=l
          l=i
        endif
      endif
      goto 1
      END
C  (C) Copr. 1986-92 Numerical Recipes Software .-35?421.1-9.

***********************************************************

      SUBROUTINE get_name(name,i,j)
      CHARACTER*120 name
      DO i=1,120
         IF(name(i:i).NE.' ') GOTO 1
      ENDDO
      i=1
      j=1
      RETURN
 1    CONTINUE
      DO j=i,120
         IF(name(j:j).EQ.' ') GOTO 2
      ENDDO
      j=121
 2    j=j-1
      IF(name(i:i).EQ.'''') i=i+1
      IF(name(j:j).EQ.'''') j=j-1
      END

C ______________________________	 Convert PM format to ASCII 
C		             November 1997         A. Klypin (aklypin@nmsu.edu) 
C		                     
C          Scales internal PM coordinates and velocities 
C          to  coordinates in Mpc/h and km/s
C          In PM the coordinates are in the range 1 - (NGRID+1)
C                     velocities are P = a_expansion*V_pec/(x_0H_0)
C                     where     x_0 = comoving cell_size=Box/Ngrid
C                                    H_0 = Hubble at z=0
C                   
C	     NROW = number of particles in 1D
C	     NGRID= number of cells        in 1D
       INCLUDE 'PMparameters.h'
       INCLUDE 'PMrotation.h'
       REAL     INPUT
       Character  FileASCII*50
C...................................................................
C			Read data and open files
      WRITE (*,'(A,$)') 'Enter Name for output ASCII file = '
      READ  (*,'(A)') FileASCII
      OPEN(17,FILE=FileASCII,STATUS='UNKNOWN')
      WRITE (*,'(A,$)') 'Enter Name for input Centers     = '
      READ  (*,'(A)') FileASCII
      OPEN(30,FILE=FileASCII,STATUS='UNKNOWN')
      CALL RDTAPE


      write (*,*) ' RDTAPE is done'
      WRITE (17,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
100   FORMAT(1X,'Header=>',A45,/
     +            1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I6,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3)

      Box  =25.
c      Box  =INPUT(' Enter box size in comoving Mpc/h =')
      BoxV =Box*100.    ! Box size in km/s
      ScaleV = BoxV/AEXPN/NGRID  ! scale factor for Velocities
      ScaleC = Box/NGRID         ! scale factor for Coordinates

      Nlines =25
      CALL ReadMax(Ncent,Nlines)
      Radius =0.
      Do i=1,Ncent
         Radius =MAX(Rmc(i),Radius)
      EndDo

      CALL SetWeights
      CALL ReadPnt(N,ScaleC,ScaleV)                     ! particles
      CALL Points(Box,N,Ncp,Radius)            ! Make more points periodically
      CALL Rotation(Ncent,Ncp)

      Stop
      END
C--------------------------------------------------------------
C
      SUBROUTINE Rotation(Ncent,Ncp)
C             Lambda = J*sqrt(<v^2>/2)/[V_circ_vir*R_vir]
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMrotation.h'
      real*8 wm,V2,ax,ay,az,Vvx,Vvy,Vvz,
     &                ddx,ddy,ddz

      Do i=1,Ncent             ! loop over centers
         nn =0
         wm=0.
         V2 =0.
         ax =0.
         ay =0.
         az =0.
         x = Xm(i)
         y = Ym(i)
         z = Zm(i)
         wx =Vmx(i)
         wy =Vmy(i)
         wz =Vmz(i)
         R   =Rmc(i)
         R2   =R**2
         Vvx =0.
         Vvy =0.
         Vvz =0.
         ddx =0.
         ddy =0.
         ddz =0.
         Do j=1,Ncp             ! loop over particles
           dx = Xp(j)-x
           dy = Yp(j)-y
           dz = Zp(j)-z
           dd =dx**2+dy**2+dz**2
           If(dd.lt.R2)Then   ! inside halo
               nn = nn+1
               ww=iWeight(i)
               ux =VXp(j)
               uy =VYp(j)
               uz =VZp(j)
               Vvx =ux*ww +Vvx
               Vvy =uy*ww +Vvy
               Vvz =uz*ww +Vvz
               ddx =ddx + dx*ww
               ddy =ddy + dy*ww
               ddz =ddz + dz*ww
               wm=wm +ww
               V2 =V2 + (ux**2+uy**2+uz**2)*ww
               ax = ax + (dy*uz-dz*uy)
               ay = ay + (dz*ux-dx*uz)
               az = az + (dx*uy-dy*ux)
            Endif 
         EndDo
         If(nn.eq.0)Then
            write(*,*) ' Error: no particles'
            stop
         Else
            ax = (ax - (ddy*Vvz-ddz*Vvy)/wm)/wm*AEXPN
            ay = (ay - (ddz*Vvx-ddx*Vvz)/wm)/wm*AEXPN
            az = (az - (ddx*Vvy-ddy*Vvx)/wm)/wm*AEXPN
            aJm = sqrt(ax**2+ay**2+az**2)
            V2 = (V2 - (Vvx**2+Vvy**2+Vvz**2)/wm)/wm
            V      =sqrt(max(V2,1.e-10))
            Vcirc =6.581e-5*sqrt(Amc(i)/Rmc(i)/AEXPN)
            aLambda1(i) =aJm*V/sqrt(2.)/Vcirc**2/Rmc(i)/AEXPN
            aLambda2(i) =aJm/Vcirc/Rmc(i)/AEXPN
            aJ(i) =aJm
            Vvx =Vvx/wm
            Vvy =Vvy/wm
            Vvz =Vvz/wm
            write (*,100) i,nn,wm,Vcirc,V,m1(i),m2(i),m3(i),
     &            aJ(i),aLambda1(i) ,aLambda2(i), 
     &            Vvx,Vvy,Vvz,Vmx(i),Vmy(i),Vmz(i)
            write (17,120) AEXPN,x,y,z, Vvx,Vvy,Vvz,aMc(i),
     &                          Rmc(i)*1000.,Vrm(i),Vcmax(i),
     &                          m1(i),m2(i),m3(i),m4(i),
     &                          aLambda1(i),aJ(i),ax,ay,az
      
         EndIf
       EndDo
 100   format(i3,i8,g11.3,2f8.2,2i8,i5,3g11.3,/
     &        3x,3F8.2,3x,3F8.2,g11.3)
 120   format(F7.4,F8.3,2F8.3,3F7.1,g10.3,f8.2,2F7.2,2i8,i7,i5,
     &       f7.4,4g12.4 )
      Return
      End
C--------------------------------------------------------------
C                       Add points around the Box to take into account periodical conditions
C  It replicates points periodically and keeps those which are at  distance
C  less than Radius from the Box. 
C                        N     = number of points inside the Box
C                        Ncp = total number of points
      SUBROUTINE Points(Box,N,Ncp,Radius)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMrotation.h'
      Logical    Inside
         B1  =-Radius
         B2  =Box+Radius
         B3  =Box-Radius
         Ncp =N
      Do i=1,N               ! Add dark matter particles
         x0 =xp(i)
         y0 =yp(i)
         z0 =zp(i)
         Inside =            (x0.gt.Radius).and.(x0.lt.B3)
         Inside =Inside.and.((y0.gt.Radius).and.(y0.lt.B3))
         Inside =Inside.and.((z0.gt.Radius).and.(z0.lt.B3))
         If(.not.Inside)THEN         
         ux =VXp(i)
         uy =VYp(i)
         uz =VZp(i)
         ww=iWeight(i)
            Do k1 = -1,1
               zr =z0+k1*Box
               If(zr.GT.B1.AND.zr.LT.B2)Then
               kk =k1**2
               Do j1 = -1,1
                  yr =y0+j1*Box
                  If(yr.GT.B1.AND.yr.LT.B2)Then
                     jj = kk +j1**2
                     Do i1 = -1,1
                        xr =x0+i1*Box
                        ii =jj +i1**2
                        If((xr.GT.B1.AND.xr.LT.B2).AND.ii.ne.0)
     .                     Then
                             Ncp =Ncp +1
                             If(Ncp.le.Np)Then
                               xp(Ncp)  =xr
                               yp(Ncp)  =yr
                               zp(Ncp)  =zr
                               VXp(Ncp)  =ux
                               VYp(Ncp)  =uy
                               VZp(Ncp)  =uz
                               iWeight(Ncp) =ww
                             EndIf
                        EndIf
                     EndDo
                  EndIf
               EndDo
               EndIf
            EndDo
         EndIf
      EndDo
      If(Ncp.Gt.Np)Then
         write(*,*)' Too many points:',Ncp,' Maximum is =', Np
         STOP
      EndIf
      Return
      End
C--------------------------------------------------
C                             Set Weights of particles for
C                             fast access
      SUBROUTINE SetWeights
C--------------------------------------------------
      INCLUDE 'PMparameters.h'

      Wpr =NGRID**3/FLOAT(NROW**3)
      If(Nspecies.eq.0)Then  ! old  constant weights
         N_particles =lspecies(1)
         Ww  = wspecies(1)/Wpr
         Do i=1,N_particles
            iWeight(i) =Ww
         EndDo
      Else
         N_particles =lspecies(Nspecies)
         jstart =1
         write (*,*) ' N_Particles=',N_particles
         If(N_particles.le.0)Then
            write (*,*) ' Wrong number of particles:',N_particles
            write (*,*) ' Nspecies=',Nspecies,' N=',lspecies
            STop
         endif 
         Do j=1,Nspecies
            jend =lspecies(j)
            Do k=jstart ,jend
               iWeight(k) =wspecies(j)/Wpr
            EndDo
            jstart =jend
         EndDo
      EndIf
      write (*,*) ' Set Weights for ',N_particles,' particles:',
     &       ' w_first=' ,iWeight(1),' w_last=',  iWeight(N_particles)
      RETURN
      END

C---------------------------------------------------------
C                                        Read particles
      SUBROUTINE ReadPnt(N,ScaleC,ScaleV)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMrotation.h'

      N =0
         N_particles =lspecies(Nspecies)   ! Total number of particles
         Npages = (N_particles -1)/NPAGE +1
         N_in_last=N_particles -NPAGE*(Npages-1)
      write (*,*) ' Pages=',Npages,' Species=',Nspecies
c      write (*,*) ' N_in_last=',N_in_last

      DO  IROW=1, Npages         ! Loop over particle pages
            In_page =NPAGE
            If(IROW.eq.Npages)In_page =N_in_last
            iL = NPAGE*(IROW-1)
C				       Loop over particles
         READ  (21,REC=IROW) RECDAT
	   DO   IN=1,In_page
            N   = N +1
            Xp(N)  =ScaleC*(XPAR(IN)-1.)
            Yp(N)  =ScaleC*(YPAR(IN)-1.)
            Zp(N)  =ScaleC*(ZPAR(IN)-1.)
            VXp(N)=ScaleV*VX(IN)
            VYp(N)=ScaleV*VY(IN)
            VZp(N)=ScaleV*VZ(IN)
                Ipart =IN+iL                     ! current particle number
             iWeight(N) =iWeight(Ipart)   ! particles weight            
         ENDDO
      ENDDO 
      Return
      End

C---------------------------------------------------------
C                                        Read list of maxima
c                                     Xnew =X-1: coord. now are 0-NGRID       
      SUBROUTINE ReadMax(Ncent,Nlines)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMrotation.h'
      Character*100 Line

      Do i=1,Nlines
         read(30,'(A)') Line
         write(*,'(A)') Line
      EndDo
       Ncent =0
      xxm =1000.
      xxn =-1000.
 10   read (30,*,err=5,end=5) Aa,X0, Y0, Z0, VvX,VvY,VvZ,aM,
     &                          Rv,V1,V2,nn1,nn2,nn3,nn4
            Ncent=Ncent+1
            If(Ncent.le.Nc)Then
               Xm(Ncent)  =X0
               Ym(Ncent)  =Y0
               Zm(Ncent)  =Z0
               Vmx(Ncent)=VvX
               Vmy(Ncent)=VvY
               Vmz(Ncent)=VvZ
               Amc(Ncent)=aM
               Rmc(Ncent)=Rv / 1000.   ! scale to Mpc/h
               Vrm(Ncent)=V1
               Vcmax(Ncent)=V2
               m1(Ncent)=nn1
               m2(Ncent)=nn2
               m3(Ncent)=nn3
               m4(Ncent)=nn4
               xxm    =min(xxm,Xm(Ncent))
               xxn     =max(xxn,Xm(Ncent))
            EndIf
            GoTo 10
 5    write(*,*) ' Read Centers: X{Min,Max}=',xxm,xxn,' Nc=',Ncent
      If(Ncent.GT.Nc)Then
         write (*,*) ' Too many centers: Max=',Nc
         Stop
      EndIf
      Return
      End

C ______________________________ Analysis of tables with profiles
C		                 for barred galaxies simulations
C		                     
c-------------------------------------------------------------------- 
      INCLUDE  'PMgalaxy2.h'
      REAL         INPUT,moment
      Character    FileASCII*100

       write(*,*)' enter 6 digits of the snapshot Example: 0.6235'
       read(*,*) moment

        write(FileASCII,'("RESULTS/Result.SPH.",f6.4,".dat")')
     &    moment
        write (*,*) FileASCII 
      OPEN(37,FILE=FileASCII,STATUS='UNKNOWN') 

         write(FileASCII,'("RESULTS/Result.CYL.",f6.4,".dat")')
     &    moment
      OPEN(39,FILE=FileASCII,STATUS='UNKNOWN') 


      CALL ReadSPH
      CALL FreqSPH


      Return
      End
c-------------------------------------------------------------------- 
c                     Read table SPH
      SUBROUTINE ReadSPH
      INCLUDE 'PMgalaxy2.h'
      Character    Line*100

      Do i=1,2
         Read(37,'(A)') Line
         write(*,*) Line
      EndDo 
      Read(37,*) AEXPN,dA,Time,iStep,Ndisk,Nbulge,aMdisk
      write (*,*)  
      write (*,*)  ' A    =',AEXPN
      write (*,*)  ' Time =',Time,'Gyrs'
      write (*,*)  ' Mdisk=',aMdisk,'Msun'
      Do i=1,5
         Read(37,'(A)') Line
c         write(*,*) Line
      EndDo 

      Ntab =1
 10   read(37,*,err=50,end=50)Radout(Ntab),Radd(Ntab),
     &         Vch(Ntab),Vcdisk(Ntab),Vcbulge(Ntab),
     &         Vctot(Ntab),Nradh(Ntab),Nradhout(Ntab),
     &         Nradd(Ntab),Nradout(Ntab),
     &         Nradb(Ntab),Nradbout(Ntab)
      Ntab =Ntab +1
      goto 10

 50   Ntab =Ntab -1
      write (*,*)  ' Read ',Ntab,' lines from table SPH'

      Return
      End
c-------------------------------------------------------------------- 
c                     Frequencies: Omega,epicycle
      SUBROUTINE FreqSPH
      INCLUDE 'PMgalaxy2.h'

      Do i=2,Ntab-1
         Omega = Vctot(i)/Radout(i)
         dVdRL = (Vctot(i)-Vctot(i-1))/(Radout(i)-Radout(i-1))
         dVdRR = (Vctot(i+1)-Vctot(i))/(Radout(i+1)-Radout(i))
         dVdR  = (dVdRR+dVdRL)/2.
         aKappa= sqrt(2.)*Omega*sqrt(1.+dVdR/Omega)
         write (*,100)i,Radout(i),Vctot(i),Omega,aKappa,Omega-aKappa/2.,
     &      dVdR,
     &      dVdRL,dVdRR
      EndDo 
 100     format(i3,8g12.4)
      Return
      End

c-------------------------------------------------------------------- 
c                    Make a density map using adaptive kernel
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMgalaxy.h'
      INCLUDE 'PMmap.h'
      REAL         INPUT,moment
      Character    FileASCII*100
      Character    File1*100,File2*100,Charyz*2,CharDM*2
      EQUIVALENCE (Ndisk,extras(90)),
     &               (Nbulge,extras(97)),(aMassDisk,extras(93)),
     &               (Box,extras(100))

C...................................................................
C			Read data and open files
       write(*,*)' enter 6 digits of the snapshot and two flags I J '
       write (*,*)  '     I=projection (0-xy,1-xz), J=Disk(0), DM(1)'
       read(*,*) moment,iZflag,iDMflag
       If(moment.lt.1.5)Then
         write(File1,'("FILES/PMcrda",f6.4,".DAT")')moment
         write(File2,'("FILES/PMcrs0a",f6.4,".DAT")')moment
       Else
          imoment =INT(moment+0.1)
c       read(*,*) imoment
         write(File1,'("FILES/PMcrda.",i4.4,".DAT")')imoment
         write(File2,'("FILES/PMcrs0a.",i4.4,".DAT")')imoment
       endIf
         write(*,*) File1
         write(*,*) File2

      CALL RDTAPE(File1,File2)
c      aMassDisk =3.00e10                       ! 
      Nbulge   = 0

      If(iZflag.eq.0)Then
         Charyz ='xy'
      Else
         Charyz ='xz'
      EndIf 
      If(iDMflag.eq.0)Then
         CharDM ='SK'
      Else
         CharDM ='DM'
      EndIf 

      write(FileASCII,'("RESULTS/DensityMap",2A2,".",f6.4,".dat")')
     &       Charyz,CharDM,AEXPN
      OPEN(37,FILE=FileASCII,STATUS='UNKNOWN') 
         write(FileASCII,'("RESULTS/Result.BAR.",f6.4,".dat")')
     &    AEXPN
      OPEN(43,FILE=FileASCII,STATUS='UNKNOWN') 

      time      = (age(AEXPN)-age(0.6))/1.e9
      aMassDisk = aMassDisk/hubble
c      Nbulge   = 33334
      write (*,*)  ' hubble =',hubble,' mass of disk=',aMassDisk
      write (*,*) ' RDTAPE is done Time=',time,' a=',AEXPN
          WRITE (37,100) HEADER,AEXPN,AEXP0,AMPLT,
     +                  ASTEP,ISTEP,PARTW,EKIN,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv,Ndisk,Nbulge,aMassDisk,time
100   FORMAT(1X,'Header=>',A45,/
     +           1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I8,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3,/
     + 1x,' Ndisk/bulge =',2i8,' Mass disk =',G11.3,' Age=',f7.3,'Gyr') 

c      Box  =INPUT(' Enter box size in comoving Mpc/h =')
c      Box =0.5 ! NG3109
c      Box = 2   ! 'bulge'

      BoxV   = Box*100.    ! Box size in km/s
      ScaleV = BoxV/AEXPN/NGRID      ! scale factor for Velocities (km/s)
      ScaleC = Box/NGRID*AEXPN/hubble  ! scale factor for Coordinates (real Mpc)
      ScaleH  = 100.*hubble*sqrt(Om0/AEXPN**3+Oml0) ! H(a)=km/s/Mpc
      if(Ndisk.le.0)write (*,*) ' wrong number of disk particles:',Ndisk
      if(Ndisk.le.0)Stop
      ScaleM = aMassDisk/Ndisk
c      Ndisk = Ndisk +Nbulge
 
      CALL ReadPnts(N,ScaleC,ScaleV,ScaleM)
      Call ChangePnts(N,Box,ScaleH)

      Call GetDensity2(Box)
      stop
      end
C--------------------------------------------------------------
C                      get density map in projection              
      SUBROUTINE GetDensity2(Box)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMgalaxy.h'
      INCLUDE 'PMmap.h'
      DIMENSION SURFA(Ndens,Ndens),SURFB(Ndens,Ndens)
      SAVE SURFA,SURFB
      EQUIVALENCE (Ndisk,extras(90))


      Cell    = 2.*RsurfD/Nblink      ! cell for linker list
      Sstep   = 2.*RsurfD/Ndens       ! cell for surface density
      xoffset = Box/2.-RsurfD
      yoffset = Box/2.-RsurfD
      zoffset = Box/2.-RsurfD
      dStep = 40.e-6
      Do i=1,Nsearch
         RadDens(i) =dStep*i  
      EndDo

      write (37,'("  i  j  SurfDensity  Filter(kpc)     X    Y(kpc)")')
      write (*,*)  ' GetDens: Cell,kpc=',Cell*1.e3,dStep*1.e3
      write (*,*)  ' Offsets          =',xoffset*1.e3,yoffset*1.e3
      write (*,*)  ' Sstep            =',Sstep*1.e3
      write (*,'(5f8.3)') (RadDens(i)*1.e3,i=1,Nsearch)
      Do j=1,Ndens
      Do i=1,Ndens
         SURFD(i,j)=0.
         SURFA(i,j)=0.
      EndDo 
      EndDo 

      nincr =0
      If(iDMflag.eq.0)Then
         CALL ListDisk(Box)
      else 
         CALL ListDM(Box)
      EndIf 
      write (*,*)  '   Linker List is done'
C                     Find radius of the filter
C                     Place it to SURFD
                           
cC$OMP PARALLEL DO DEFAULT(SHARED) 
cC$OMP+PRIVATE (i,j,xi,yj,indx,Density,nn,Rsmooth) 
cC$OMP+SCHEDULE (DYNAMIC,50)
      Do j=1,Ndens
         yj = yoffset +(j-1)*Sstep
         indx =0
         if(j.eq.100.or.j.eq.101)indx=1
      Do i=1,Ndens
         xi = xoffset +(i-1)*Sstep
         CALL Neib2(xi,yj,Density,Rsmooth,indx,nincr)
         SURFD(i,j) = Rsmooth 
c         write (30,'(6g11.3)')xi,yj,Density,Rsmooth
      EndDo 
      EndDo 

      write (*,*)' Finding smooting radius  Rsmooth is done'
      write (*,*)' Total number of cells                  =',Ndens**2
      write (*,*)' N cells with insufficently large radius=',nincr
      Do j=1,Ndens      ! Smooth map of Rsmooth
      Do i=1,Ndens
         SURFA(i,j) = SURFD(i,j)
      EndDo 
      EndDo 
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP+PRIVATE (i,j)
      Do j=2,Ndens-1
      Do i=2,Ndens-1
         SURFA(i,j) = (SURFD(i,j) +
     &       0.5*(SURFD(i-1,j)+SURFD(i+1,j)+SURFD(i,j-1)+SURFD(i,j+1))+
     &       0.25*(SURFD(i-1,j-1)+SURFD(i+1,j-1)
     &            +SURFD(i-1,j+1)+SURFD(i+1,j+1)))/4.
      EndDo 
      EndDo 

      write (*,*)  '   smoothing of filter radius is done'
C                    Find density using variable filter radius      
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP+PRIVATE (i,j,xi,yj,indx,Density,nn,Rsmooth) 
C$OMP+SCHEDULE (DYNAMIC,50)
      Do j=1,Ndens
         yj = yoffset +(j-1)*Sstep
         indx =0
c         if(j.eq.100.or.j.eq.101)indx=1
      Do i=1,Ndens
         xi = xoffset +(i-1)*Sstep
         CALL Neib3(xi,yj,Density,SURFA(i,j),indx)
         SURFD(i,j) = Density   
      EndDo 
      EndDo 
      write (*,*)  '   Density is done'
      Do j=1,Ndens      ! Smooth map of Density
      Do i=1,Ndens
         SURFB(i,j) = SURFD(i,j)
      EndDo 
      EndDo 
      Do iter =1,5
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP+PRIVATE (i,j)
      Do j=2,Ndens-1
      Do i=2,Ndens-1
         SURFB(i,j) = (SURFD(i,j) +
     &       0.5*(SURFD(i-1,j)+SURFD(i+1,j)+SURFD(i,j-1)+SURFD(i,j+1))+
     &       0.25*(SURFD(i-1,j-1)+SURFD(i+1,j-1)
     &            +SURFD(i-1,j+1)+SURFD(i+1,j+1)))/4.
      EndDo 
      EndDo 
      Do j=1,Ndens   
      Do i=1,Ndens
         SURFD(i,j) = SURFB(i,j)
      EndDo 
      EndDo 
      EndDo



      Do j=1,Ndens
         yj = (yoffset +(j-1)*Sstep-Box/2.)*1.e3
      Do i=1,Ndens
         xi = (xoffset +(i-1)*Sstep-Box/2.)*1.e3
         write(37,'(2i4,2g12.5,4f9.4)')i,j,SURFD(i,j),SURFA(i,j)*1.e3,
     &                                  xi,yj
      EndDo 
      EndDo 


      Return
      End
C--------------------------------------------------------------
C                    Make 2D linker lists of particles in each cell
      SUBROUTINE ListDisk(Box)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMgalaxy.h'
      INCLUDE 'PMmap.h'
      logical inside
      EQUIVALENCE (Ndisk,extras(90)),
     &               (Nbulge,extras(97)),(aMassDisk,extras(93))
             Do i=1,Np
                Lst(i)=-1
             EndDo
             Do k=Nmlink,Nblink
             Do j=Nmlink,Nblink
             Do i=Nmlink,Nblink
                Label(i,j,k)=0
             EndDo
             EndDo
             EndDo 
      k=1
      Do jp=1,Ndisk                   ! DISK particles
         i=INT((Xp(jp)-xoffset)/Cell)
         i=MIN(MAX(Nmlink,i),Nblink)
         If(iZFlag.eq.0)Then           ! x-y projection
           j=INT((Yp(jp)-yoffset)/Cell)
            If(abs(Zp(jp)-zoffset-RsurfD).lt.dslice)Then
              Ncount = Ncount +1
              Lst(jp)      =Label(i,j,k)
              Label(i,j,k) =jp
            EndIf
         else                          ! x-z projection
           j=INT((Zp(jp)-zoffset)/Cell)
            If(abs(Yp(jp)-yoffset-RsurfD).lt.dslice)Then
              Ncount = Ncount +1
              Lst(jp)      =Label(i,j,k)
              Label(i,j,k) =jp
            EndIf
         EndIf 

      EndDo
      Return
      End
C--------------------------------------------------------------
C                    Make 2D linker lists of particles in each cell
      SUBROUTINE ListDM(Box)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMgalaxy.h'
      INCLUDE 'PMmap.h'
      EQUIVALENCE (Ndisk,extras(90)),
     &               (Nbulge,extras(97)),(aMassDisk,extras(93))
             Do i=1,Np
                Lst(i)=-1
             EndDo
             Do k=Nmlink,Nblink
             Do j=Nmlink,Nblink
             Do i=Nmlink,Nblink
                Label(i,j,k)=0
             EndDo
             EndDo
             EndDo  
      Ncount = 0
      xright = xoffset + 2.*RsurfD
      If(iZFlag.eq.0)Then
        yright = yoffset + 2.*RsurfD
      Else
        yright = zoffset + 2.*RsurfD
      EndIf
        zleft  = Box/2.-dslice
        zright = Box/2.+dslice

      k=1
      Do jp=1+Ndisk+Nbulge,lspecies(Nspecies)  ! DM particles
         inside = (Xp(jp).gt.xoffset.and.Xp(jp).lt.xright)
         IF(iZFlag.eq.0)Then           ! x-y projection
            inside=inside.and.(Yp(jp).gt.yoffset.and.Yp(jp).lt.yright)
            inside=inside.and.(Zp(jp).gt.zleft.and.Zp(jp).lt.zright)
         Else
            inside=inside.and.(Zp(jp).gt.zoffset.and.Zp(jp).lt.yright)
            inside=inside.and.(Yp(jp).gt.zleft.and.Yp(jp).lt.zright)
         EndIf
         If(inside)Then
            i=INT((Xp(jp)-xoffset)/Cell)
            i=MIN(MAX(Nmlink,i),Nblink)
            If(iZFlag.eq.0)Then           ! x-y projection
              j=INT((Yp(jp)-yoffset)/Cell)
                 Ncount = Ncount +1
                 Lst(jp)      =Label(i,j,k)
                 Label(i,j,k) =jp
            else                          ! x-z projection
              j=INT((Zp(jp)-zoffset)/Cell)
                 Ncount = Ncount +1
                 Lst(jp)      =Label(i,j,k)
                 Label(i,j,k) =jp
            EndIf 
         EndIf
c         write (*,'(" xyz=",3g11.3," dy=",3g11.3)')
c     &  (Xp(jp)-Box/2.)*1.e3,(Yp(jp)-Box/2.)*1.e3,(Zp(jp)-Box/2.)*1.e3,
c     &    (Yp(jp)-yoffset-RsurfD)*1.e3,
c     &    (Xp(jp)-xoffset-RsurfD)*1.e3,
c     &    (Zp(jp)-zoffset-RsurfD)*1.e3

      EndDo

      write (*,*)  ' Number of particles in List=',Ncount
      Return
      End
C--------------------------------------------------------------
C                   Find smoothing radius Rsmooth for center
C                                
C   input: xc,yc - center
C   output:  Rsmooth (Mpc units), Density estimate of density
C            nincr = number of cells where radius was not
C                    sufficiently large
      SUBROUTINE Neib2(xi,yj,Density,Rsmooth,indx,nincr)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMgalaxy.h'
      INCLUDE 'PMmap.h'
      DIMENSION iDen(Nsearch)
C                                       Initiate counters
      iFlag = 0
        Radius = RadDens(15)
        Radius2= Radius**2
 50     Do i=1,Nsearch
           iDen(i) =0
        EndDo 
c        write (*,*)  '==== Neib:',Xc,Yc,Zc,dStep
c                      limits for Label
         i1=INT((xi-xoffset-Radius)/Cell)
         j1=INT((yj-yoffset-Radius)/Cell)
         k1=1
            i1=MIN(MAX(Nmlink,i1),Nblink)
            j1=MIN(MAX(Nmlink,j1),Nblink)
            k1=MIN(MAX(Nmlink,k1),Nblink)
         i2=INT((xi-xoffset+Radius)/Cell)
         j2=INT((yj-yoffset+Radius)/Cell)
         k2=1
            i2=MIN(MAX(Nmlink,i2),Nblink)
            j2=MIN(MAX(Nmlink,j2),Nblink)
            k2=MIN(MAX(Nmlink,k2),Nblink)
c            write (*,'("    limits=",6i5)')i1,i2,j1,j2,k1,k2
C                                        Look for neibhours
         Do k=k1,k2
         Do j=j1,j2
         Do i=i1,i2
            jp =Label(i,j,k)
 10         If(jp.ne.0)Then
              If(iZFlag.eq.0)Then           ! x-y projection          
                dd =(xi-Xp(jp))**2+(yj-Yp(jp))**2
              Else
                dd =(xi-Xp(jp))**2+(yj-Zp(jp))**2
              EndIf
               If(dd.lt.Radius2)Then
                  disd      = sqrt(dd)/dStep
                  ind       = min(INT(disd) +1,Nsearch)
                  iDen(ind) = iDen(ind) +1
               EndIf  
                  jp =Lst(jp)
               GoTo10
            EndIf
         EndDo
         EndDo
         EndDo

        Do i=2,Nsearch  ! make iDen the integal number 
           iDen(i) =iDen(i) +iDen(i-1)
        EndDo
                    ! Increase radius if there were not enough particles 
        If(iDen(Nsearch).lt.nfilter.and.iFlag.eq.0)Then
           nincr = nincr +1
           iFlag = 1
c           write (*,'(" Increase search rad: N=",i5," R=",6g11.3)')
c     &        iDen(Nsearch),Radius*1.e3,xi*1.e3,yj*1.e3,Cell*1.e3
           Radius = RadDens(Nsearch)
           Radius2= Radius**2
           GoTo 50
        EndIf
c        If(iDen(Nsearch).lt.nfilter)
c     &    write (*,'(" too small Rad=",3g11.3,2i4)')
c     &            Radius*1.e3,xi*1.e3,yj*1.e3,iDen(Nsearch),iFlag
         Do i=1,Nsearch
            nn =iDen(i)
            If(nn.ge.nfilter)Then
               if(i.eq.1)Then
                  Rsmooth = RadDens(1)*sqrt(nfilter/float(nn))
               else
                  Rsmooth =RadDens(i-1)+(RadDens(i)-RadDens(i-1))*
     &            sqrt((nfilter-iDen(i-1))/
     &                 float(max(iDen(i)-iDen(i-1),1)))   
               endif
c                  Rsmooth = min(max(Rsmooth,Sstep),RadDens(Nsearch))
                  Density = nfilter/Rsmooth**2
               goto 20
            EndIf
         EndDo
         Rsmooth =RadDens(Nsearch) 
         Density = nn/RadDens(Nsearch)**2
 20   Density =Density/4.188e9  ! number of particles per kpc**3
c      If(indx.eq.1)Then
c           write(*,'(/5x,"Dens=",2g11.3,6i8)')Density,Rsmooth*1.e3,i,nn
c           write (*,'(25i7)')(i,i=1,Nsearch)
c           write (*,'(25i7)')iDen
c           do i=2,Nsearch
c              iDen(i) = iDen(i) +iDen(i-1)
c           EndDo 
c           write (*,'(25i7)')iDen
c      endIf
      Return
      End
C--------------------------------------------------------------
C                   Find density for a center with given smoothing
C                   radius Rsmooth. Use Gaussian kernel with width
C                                sigma =alpha*Rsmooth, alpha =1/3-1/2
C   input: xc,yc - center
C   output:  Density estimate of density
      SUBROUTINE Neib3(xi,yj,Density,Rsmooth,indx)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMgalaxy.h'
      INCLUDE 'PMmap.h'
      REAL*8   W
C                                       Initiate counters
c        Radius = Rsmooth*2.5
        Radius = Rsmooth*1.5
        Radius2= Radius**2
        sigma  = Rsmooth
        aNorm  = 1./(6.283185*sigma**2*(1.-exp(-(Radius/sigma)**2/2.)))
        W      = 0.
        nn     = 0
        s2     = 2.*sigma**2
c        write (*,*)  '==== Neib:',Xc,Yc,Zc,dStep
c                      limits for Label
         i1=INT((xi-xoffset-Radius)/Cell)
         j1=INT((yj-yoffset-Radius)/Cell)
         k1=1
            i1=MIN(MAX(Nmlink,i1),Nblink)
            j1=MIN(MAX(Nmlink,j1),Nblink)
            k1=MIN(MAX(Nmlink,k1),Nblink)
         i2=INT((xi-xoffset+Radius)/Cell)
         j2=INT((yj-yoffset+Radius)/Cell)
         k2=1
            i2=MIN(MAX(Nmlink,i2),Nblink)
            j2=MIN(MAX(Nmlink,j2),Nblink)
            k2=MIN(MAX(Nmlink,k2),Nblink)
c            write (*,'("    limits=",6i5)')i1,i2,j1,j2,k1,k2
C                                        Look for neibhours
         Do k=k1,k2
         Do j=j1,j2
         Do i=i1,i2
            jp =Label(i,j,k)
 10         If(jp.ne.0)Then
               If(iZFlag.eq.0)Then           ! x-y projection 
                 dd =(xi-Xp(jp))**2+(yj-Yp(jp))**2
               Else
                 dd =(xi-Xp(jp))**2+(yj-Zp(jp))**2
               EndIf
               If(dd.lt.Radius2)Then
                  W =W +exp(-dd/s2)
                  nn = nn +1
               EndIf  
                  jp =Lst(jp)
               GoTo10
            EndIf
         EndDo
         EndDo
         EndDo

 
 20   Density =aNorm*W/1.e9
      If(indx.eq.1)Then
           write(*,'(5x,"Dens,Rs,W,xy,nn=",5g11.3,6i8)')
     &        Density,Rsmooth*1.e3,W,xi*1.e3,yj*1.e3,nn
      endIf
      Return
      End

C _______________________ START 3-D SIMULATIONS
C
C                         Klypin, August 1993
C
      INCLUDE 'PMparameters.h'
C		   NROW = number of particles in 1 dimension
C		   NGRID= number of cells        in 1 dimension
C		   Npage =  number of particles per page = NROW**2
C
      COMMON / GRID/	GRX(NROW,NROW,NROW),GRY(NROW,NROW,NROW),
     +			GRZ(NROW,NROW,NROW)
      COMMON / GRIV/	GVX(NROW,NROW,NROW),GVY(NROW,NROW,NROW),
     +			GVZ(NROW,NROW,NROW)
      COMMON / ROW2/	XPAR2(NPAGE),YPAR2(NPAGE),ZPAR2(NPAGE),
     +			VX2(NPAGE),VY2(NPAGE),VZ2(NPAGE)
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Par(6),ns,qqscaleb,QSCALE
      COMMON / KINENRG/ SKINE,SX,SY,SZ,SX2,SY2,SZ2
      Character  Hd*5,Tail*4,Nm*40
      DATA PI		/3.1415926535/

      Hd  ='PMcrs'
      Tail='.DAT'
     
      CALL InitValues(NBYTE,SCALEL)
      write (*,*) ' InitValues is done. N bytes=',NBYTE

      OPEN(UNIT=9,FILE='PMcrd.DAT',form='unformatted')
      write (9)             ! this clears old header file
      CLOSE (9)
      CALL RDTAPE                  ! this opens files on disk
      OPEN(UNIT=16,FILE='RESNEW.DAT')
      write (16,*) ' Seed=',Nseed
       AEXP0 = AEXPN
       AEXPV = AEXPN - ASTEP/2.
C			                   get a realization of spectrum in /GRID/
       NRAND =Nseed
       CALL SPECTR(ALPHA,NRAND)
C			                        get the displacement vector by FFT
       IFOUR = INT(ALOG(FLOAT(NROW))/ALOG(2.)+0.5)
       Write (*,*) ' Ifour =',IFOUR,' Nrow=',NROW
       CALL VECTOR(IFOUR)
	    write (*,*) ' SPECTR is done. IFOUR = ',IFOUR,' Alpha=',ALPHA
        Fact =  sqrt(Om0+Oml0*AEXPV**3+Ocurv*AEXPV)
       VCONS = -ALPHA/(2.*PI/NGRID)*(AEXPV/AEXP0)*SQRT(AEXPV)*Fact
       XCONS =	 ALPHA/(2.*PI/NGRID)*(AEXPN/AEXP0)
       QFACT =  FLOAT(NGRID)/FLOAT(NROW)
                      SKINE = 0.
                      SX    = 0.
                      SY    = 0.
                      SZ    = 0.
                      SX2   = 0.
                      SY2   = 0.
                      SZ2   = 0.

C			           find x,v and write to file, page by page
      DO  KROW = 1, NROW
      	CALL SETXV(XCONS,VCONS,KROW)
	      CALL WRIROW(KROW,1)
      ENDDO
C                                     EKIN is kinet.energy at A(i-1/2)
      EKIN = 0.5*SKINE/AEXPV**2*PARTW
      DP   = NROW**3
      SX   = SX/DP
      SY   = SY/DP
      SZ   = SZ/DP
      SX2  = SQRT(SX2/DP)
      SY2  = SQRT(SY2/DP)
      SZ2  = SQRT(SZ2/DP)
      WRITE (*,'('' Displacement of a particle: MEAN'',3F9.4)')
     .	     SX,SY,SZ
      WRITE (*,'('' in cell units               RMS '',3F9.4)')
     .	     SX2,SY2,SZ2
      WRITE (16,'('' Displacement of a particle: RMS'',3F9.4)')
     .	     SX2,SY2,SZ2
      Veloc=sqrt( SKINE/AEXPV**2/NROW**3)*SCALEL/NGRID*
     .        100.*hubble
      WRITE (*,'('' Ekin='',E12.4,'' Veloc_cold(km/s)='',F8.2)')
     .       EKIN,Veloc
      WRITE (16,'('' Ekin='',E12.4,'' Veloc_cold(km/s)='',F8.2)')
     .       EKIN,Veloc
C			       write header and control data -------
      CALL WRTAPE

      STOP
      END
C--------------------------------------------------
C                                                     sqrt(Power spectrum)
C                                                           k = (2pi/L) wk
      REAL  FUNCTION TRUNF(wk)
C--------------------------------------------------
      INCLUDE 'PMparameters.h'
      PARAMETER (NSPEC =NROW/2)
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Par(6),ns,qqscaleb,QSCALE
      Real                 ns,k
      IF (WK.GE.FLOAT(NSPEC)) THEN
	       TRUNF =0.
	       RETURN
      ENDIF
      If(Par(6).ne.0.)Then   ! Holtzman approx
        k = QSCALE*wk
        sk= sqrt(k)
        TRUNF = k**(ns/2.) /
     .         (1.+sk*(Par(2)
     .            +sk*(Par(3)
     .            +sk*(Par(4)
     .            +sk*(Par(5) )))) )**(Par(6))
      Else                   ! BBKS + Sugiyama approx
c        Gammaeff =Om*hsmall/exp(Omb*(1.+sqrt(hsmall/0.5)/Om))
c        Q = wk/hsmall/Gammaeff
        k = QSCALE*wk
        Q = k*qqscaleb
        TRUNF = k**(ns/2.)* LOG(1.+Par(1)*Q)/(Par(1)*Q)/
     .          sqrt(sqrt(1.+Q*(Par(2)+
     .                  Q*(Par(3)**2+
     .                  Q*(Par(4)**3+
     .                  Q*(Par(5)**4) )))))
      EndIf
      RETURN
      END
C*********************************************************************
C	   Power spectrum for CDM. Wk-  wavenumber(Mpc^-1, h=0.5)
C                         P = wk *T^2(k)
C                         QSCALE = 2pi/Box_size,  QS =hubble**(-2)
c      FUNCTION TRUNF(WK)
c      COMMON / TRUNCOM/ QSCALE,g,gy
c      COMMON / TRUNCDM/ QS,A1,A2,A3,A4,A5,A32,A43,A54
c       Q = QSCALE*QS*WK
c       TRUNF = sqrt( WK*
c     +		 (LOG(1.+A1*Q)/(A1*Q))**2/
c     +		 SQRT(1.+Q*(A2 +Q*(A32   +Q*(A43+Q*A54)))) )
c
c      RETURN
c      END

C*********************************************************************
C			  INITIALIZE CONSTANTS:
C			      Scalel    =length of square in MPC
C			      AEXPN =expansion factor (current)
C			      ASTEP	  =increment of expansion factor: AEXPN =AEXP_0+N*ASTEP
C                     PARTW	=weight of a particle: total 'mass' per cell must be unity
c                                          even for LCDM or OCDM 
C			      AMPLT	=amplitude of perturbations inside the simulation box
C			      NBYTE	=record length in bytes
C
      SUBROUTINE InitValues(NBYTE,SCALEL)
      INCLUDE 'PMparameters.h'
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Par(6),ns,qqscaleb,QSCALE
      COMMON / FERMI  / Vscale
      Real                 ns      
      Character            Answer*1
      Real                 INPUT
      DATA PI		         /3.1415926535/

       Write (*,*) 'Would you like to use a model provided in cdm.fit '
       Write (*,*) 'or your own model?' 
       Write (*,'(A,$)') ' Enter Yes for cdm.fit;  No for your model ='
       Read  (*,*)  Answer
       HEADER='N=128x256 L=20h-1CDMsig=0.239 z=30-----------'
       write (*,*) '------ Enter Header for the run up to 45 characters'
       write (*,*) '       Example:'
       write (*,'(A)') HEADER                                   
       read  (*,'(A)') HEADER
       write (*,'(A)') HEADER
       AEXPN =INPUT(' Initial expansion parameter (0-1)=')
       ASTEP =INPUT(' Step of the expansion parameter  =')
       AMPLT =INPUT(' Amplitude of density fluctuations=')
       ns    =INPUT(' Slope of the Power spectrum     n=')
       SCALEL=INPUT(' Box size (Mpc/h)                 =')
       Ocurv =INPUT(' Omega_curvature   at present     =')
       Nseed =INPUT(' Random seed (Integer  1-2^31)    =') 
       If(Answer.eq.'Y' .or. Answer.eq.'y')Then
          CALL MODEL(hsmall)
          hubble=hsmall
          Om0   =Om
          Oml0  =1. -Om0 -Ocurv
       Else
       write (*,*) ' You use your cosmological model.'
       write (*,*) ' Be sure you provide routine TRUNF'
       hubble=INPUT(' The Hubble constant (h=H/100)    =')
       Om0   =INPUT(' Omega_0 matter    at present     =')
       Oml0  =INPUT(' Omega_lambda      at present     =')
       EndIf
       SCALEL=SCALEL/hubble   ! scale it to real megaparsecs      
       NBYTE = NPAGE*6*4
       Nspecies =0
       W     = (FLOAT(NGRID)/FLOAT(NROW))**3
       PARTW = W 
c                                 W1    = (W -Partw)/Nspecies
       ISTEP = 0
       TINTG = 0.
       AU0   = 0.
       AEU0  = 0.
       EKIN  = 0.
       EKIN1 = 0.
       EKIN2 = 0.
       NROWC = NROW
       NGRIDC= NGRID
	     QSCALE = 2.*PI/SCALEL
	     QS     = hubble**(-2)
        write (*,*) ' Qscale=',QSCALE,SCALEL,ns

      RETURN
      END
C________________________________________Read parameters of the model
C                                 Om       = Omega_0
C                                 Omb     = Omega_baryon
C                                 Omnu  = Omega_neutrino
C                                 hsmall  = hubble constant
C                                 Par      = fitting parameters
C                                 Par(6) = 0  --- bbks-style+Hu&Sugiyama
C                                 Par(6) ne 0 --- holtzman-style
      SUBROUTINE MODEL(hsmall)
C---------------------------------------
      INCLUDE 'PMparameters.h'
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Par(6),ns,qqscaleb,QSCALE
      Real                 ns,INPUT
      Character             Header1*79

      OPEN(2,file='cdm.fit')
      Line1 =INPUT(' Enter Line Number in cdm.fit     =')
      Read(2,'(A)') Header1
      If(Line1.gt.2)Then
         Do i=1,Line1-2
            Read (2,*) a
         EndDo
      EndIf
      Read (2,*) Om,Omb,Omc,Omnu,hsmall,Par
      CLOSE (2) 
      
      theta = 2.726/2.7  ! = T_cmb/2.7
      Ob0   =Omb/Om      ! Hu&Sugiyama fitting
      Omh2  =Om*hsmall**2
      a1    =(46.9*Omh2)**0.670*(1.+(32.1*Omh2)**(-0.532))
      a2    =(12.0*Omh2)**0.424*(1.+(45.*Omh2)**(-0.582))
      alpha =1./a1**Ob0/a2**(Ob0**3)
      qqscaleb = theta**2/(1.-Ob0)**0.60/sqrt(alpha)/Omh2

      Write (*,20)Om,Omb,Omc,Omnu,hsmall,Par
      Write (1,20)Om,Omb,Omc,Omnu,hsmall,Par
 20   Format(' Model: Om_0=',F5.3,' Om_baryon=',F5.3,
     .       ' Om_cold=',F5.3,' O_nu=',F5.3,
     .       ' hsmall=',F4.2,/8x,'Parameters=',(6G9.3))
      Return
      End
C------------------------------------------------
C                             Make a realization of spectrum of perturbations:
C                             ALPHA  = normalization factor for displacements
C                             NRAND = seed for random numbers 
      SUBROUTINE SPECTR(ALPHA,NRAND)
C------------------------------------------------
      INCLUDE 'PMparameters.h'
      PARAMETER (NSPEC = NROW/2 ) ! No waves sharter than Ny
      COMMON / GRID/	GRX(NROW,NROW,NROW),GRY(NROW,NROW,NROW),
     +			         GRZ(NROW,NROW,NROW)
C						    Set spectrum
      SUMM = 0.
      DO  MK3 = 1,NROW
      DO  MK2 = 1,NROW
      DO  MK1 = 1,NROW
	     GRX(MK1,MK2,MK3) =0.
	     GRY(MK1,MK2,MK3) =0.
	     GRZ(MK1,MK2,MK3) =0.
      ENDDO
      ENDDO
      ENDDO

      DO  k = 1,NROW
         ksign = -1
         kz    = k +NSPEC
         k3    = k - 1
         If(k3.GT.NSPEC)k3=k3-NSPEC
           IF(kz.gt.NROW)THEN
              kz    =kz -NROW
              ksign =1
           ENDIF
           WK3= K3**2
c	        write (*,*) '  K=',k,' K3=',K3,' Nspec=',NSPEC
           DO  j = 1,NROW
              jsign = -1
              jz    = j +NSPEC
              j3    = j - 1
              If(j3.GT.NSPEC)j3=j3-NSPEC
                IF(jz.gt.NROW)THEN
                   jz    =jz -NROW
                   jsign =1
                ENDIF
                WJ3= j3**2
                DO  i = 1,NROW
                   isign = -1
                   iz    = i +NSPEC
                   i3    = i - 1
                   If(i3.GT.NSPEC)i3=i3-NSPEC
                     IF(iz.gt.NROW)THEN
                        iz    =iz -NROW
                        isign =1
                     ENDIF
                     WI3= i3**2

	       IF(i3+j3+k3.EQ.0)THEN
		         GRX(1,1,1) = 0.
		         GRY(1,1,1) = 0.
		         GRZ(1,1,1) = 0.
	       ELSE
		  WD = WI3 + WJ3 + WK3
		  WK = SQRT(WD)
		  TS = TRUNF(WK) * GAUSS(NRAND)
		  TRX = TS / WD
		  GRX(iz, j, k) = i3 * TRX *isign
		  GRY( i,jz, k) = j3 * TRX *jsign
		  GRZ( i, j,kz) = k3 * TRX *ksign
		  SUMM = SUMM + TS**2
	       ENDIF
	    ENDDO
	   ENDDO
      ENDDO
      IF(SUMM.LE.0.)WRITE (*,*) ' Error!!! Summ over spectrum = 0'
         write (*,*) ' ==== SPECTR ===  SUMM=',SUMM
      ALPHA = AMPLT / SQRT(SUMM) *sqrt(8.)
      RETURN
      END
C------------------------------------------------
C		                        Define coordinates and velosities for
C		                        all particles of current row (given q2)
C			                       x = q - amplt*b(t)/b(t0)*S(q1,q2)
C			                       momentum = a**2*deriv x
C                     
C		                        Twidled variables:
C		                        x= q - {1/(2 pi Ngrid)}{Alpha*a(t)/a(0)}*S
C		                        P=	- {1/(2 pi Ngrid)}{Alpha*a(t)**1.5/a(0)}*S
C                     
C		                        q(i) = Ngrid/Nrow*(i-1) + 1
C		                        x = q - xcons*S
C		                        P =	   vcons*S
      SUBROUTINE SETXV(XCONS,VCONS,K)
C------------------------------------------------
      INCLUDE 'PMparameters.h'
      COMMON / KINENRG/ SKINE,SX,SY,SZ,SX2,SY2,SZ2
      COMMON / GRID/	GRX(NROW,NROW,NROW),GRY(NROW,NROW,NROW),
     +			GRZ(NROW,NROW,NROW)

      QFACT = FLOAT(NGRID)/FLOAT(NROW)
      XMAX  = FLOAT(NGRID) + 1.
      XSHF  = FLOAT(NGRID)
      Q3    = QFACT*(K-1.) +1.
      DO  J = 1,NROW
	      Q2 = QFACT*(J-1.) +1.
	   DO  I = 1,NROW
	      Q1 = QFACT*(I-1.) +1.
            IJ    =      I +(J-1)*NROW
	      DX	      =      XCONS*GRX(I,J,K)
	      DY	      =      XCONS*GRY(I,J,K)
	      DZ	      =      XCONS*GRZ(I,J,K)
C           the factor 0.5 in the following 3 lines places unperturbed
c           particle in the middle of a cell. This reduces the shot noise
C          Small number 1.E-4 is to avoid placing some particles
C          exactly in cell nodes. Does not make much differentce.
	      XPAR(IJ) = Q1 - DX    + 1.E-4  +0.5 
	      YPAR(IJ) = Q2 - DY    + 1.E-4  +0.5
	      ZPAR(IJ) = Q3 - DZ    + 1.E-4  +0.5
	      VX(IJ)   =      VCONS*GRX(I,J,K)
	      VY(IJ)   =      VCONS*GRY(I,J,K)
	      VZ(IJ)   =      VCONS*GRZ(I,J,K)
C                                Periodical boundary conditions
	       IF(XPAR(IJ).GT.XMAX)	XPAR(IJ)=XPAR(IJ)-XSHF
	       IF(XPAR(IJ).LE.1.)	XPAR(IJ)=XPAR(IJ)+XSHF
	       IF(YPAR(IJ).GT.XMAX)	YPAR(IJ)=YPAR(IJ)-XSHF
	       IF(YPAR(IJ).LE.1.)	YPAR(IJ)=YPAR(IJ)+XSHF
	       IF(ZPAR(IJ).GT.XMAX)	ZPAR(IJ)=ZPAR(IJ)-XSHF
	       IF(ZPAR(IJ).LE.1.)	ZPAR(IJ)=ZPAR(IJ)+XSHF
	      SX	      = SX    + DX
	      SY	      = SY    + DY
	      SZ	      = SZ    + DZ
	      SX2      = SX2   + DX**2
	      SY2      = SY2   + DY**2
	      SZ2      = SZ2   + DZ**2
	      SKINE    = SKINE + VX(IJ)**2 +VY(IJ)**2 +VZ(IJ)**2
	   ENDDO
      ENDDO
      RETURN
      END
C------------------------------------------------
C                                              				   FFT of the spectrum
      SUBROUTINE VECTOR(IFOUR)
C------------------------------------------------
      INCLUDE 'PMparameters.h'
      COMMON / GRID/	GRX(NROW,NROW,NROW),GRY(NROW,NROW,NROW),
     +			GRZ(NROW,NROW,NROW)
      CALL SETF67(4,IFOUR)   ! initialize FFT
C				       x-component
      DO K=1,NROW
	   DO J=1,NROW
	    DO I=1,NROW
	       Zf(I) =GRX(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO I=1,NROW
	       GRX(I,J,K) = Yf(I)
	    ENDDO
	   ENDDO
      ENDDO
      DO K=1,NROW
	   DO I=1,NROW
	    DO J=1,NROW
	       Zf(J) =GRX(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO J=1,NROW
	       GRX(I,J,K) = Yf(J)
	    ENDDO
	   ENDDO
      ENDDO
      DO J=1,NROW
	   DO I=1,NROW
	    DO K=1,NROW
	       Zf(K) =GRX(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO K=1,NROW
	       GRX(I,J,K) = Yf(K)/8.
	    ENDDO
	   ENDDO
      ENDDO
				       write (*,*) ' x is done'
C				       Y-component
      DO K=1,NROW
	   DO J=1,NROW
	    DO I=1,NROW
	       Zf(I) =GRY(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO I=1,NROW
	       GRY(I,J,K) = Yf(I)
	    ENDDO
	   ENDDO
      ENDDO
      DO K=1,NROW
	   DO I=1,NROW
	    DO J=1,NROW
	       Zf(J) =GRY(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO J=1,NROW
	       GRY(I,J,K) = Yf(J)
	    ENDDO
	   ENDDO
      ENDDO
      DO J=1,NROW
	   DO I=1,NROW
	    DO K=1,NROW
	       Zf(K) =GRY(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO K=1,NROW
	       GRY(I,J,K) = Yf(K)/8.
	    ENDDO
	   ENDDO
      ENDDO
				       write (*,*) ' y is done'
C				       Z-component
      DO K=1,NROW
	   DO J=1,NROW
	    DO I=1,NROW
	       Zf(I) =GRZ(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO I=1,NROW
	       GRZ(I,J,K) = Yf(I)
	    ENDDO
	   ENDDO
      ENDDO
      DO K=1,NROW
	   DO I=1,NROW
	    DO J=1,NROW
	       Zf(J) =GRZ(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO J=1,NROW
	       GRZ(I,J,K) = Yf(J)
	    ENDDO
	   ENDDO
      ENDDO
      DO J=1,NROW
	   DO I=1,NROW
	    DO K=1,NROW
	       Zf(K) =GRZ(I,J,K)
	    ENDDO
	    CALL FOUR67(4,IFOUR)
	    DO K=1,NROW
	       GRZ(I,J,K) = Yf(K)/8.
	    ENDDO
	   ENDDO
      ENDDO
				       write (*,*) ' z is done'
      RETURN
      END

C ______________________________	 Selects a halo from a large Catalog.DAT
C	
C
C          Scales internal PM coordinates and velocities 
C          to  coordinates in Mpc/h and km/s
C          In PM the coordinates are in the range 1 - (NGRID+1)
C                     velocities are P = a_expansion*V_pec/(x_0H_0)
C                     where     x_0 = comoving cell_size=Box/Ngrid
C                                    H_0 = Hubble at z=0
C                   
C	     NROW = number of particles in 1D
C	     NGRID= number of cells        in 1D
      INCLUDE 'PMselect.h'
      REAL     INPUT
      Character*50  FileASCII
      Logical    Inside

C...................................................................
C			Read data and open files
      WRITE (*,'(A,$)') 'Enter Name for output file = '
      READ  (*,'(A)') FileASCII
      OPEN(17,FILE=FileASCII,STATUS='UNKNOWN')
      WRITE (*,'(A,$)') 'Enter Name of input file = '
      READ  (*,'(A)') FileASCII
      OPEN(20,FILE=FileASCII,STATUS='UNKNOWN')
      WRITE (*,'(A,$)') 'Enter Name of catalog with',
     &     ' corrected concentrations file = '
      READ  (*,'(A)') FileASCII
      OPEN(21,FILE=FileASCII,STATUS='UNKNOWN')

      Box  =INPUT(' Enter box size in comoving Mpc/h =')
      dBox = 10.  ! expand box by dBox Mpc/h
      write (*,'(A,$)')' Enter selection Limits: ',
     +     'Mass dM X Y Z dR C dC =>'
      read  (*,*) aMass, dM, X0, Y0, Z0, dR, Cc, dCc

      CALL ReadCatalog(Nh,Nhex)
      CALL ExpandSample(Nh,Nhex,dBox,Box)
      write(17,30)aMass-dM,aMass+dM,Cc-dCC,Cc+dCC,aMiso,Riso
c      CALL PrintSelected(Nh,Nhex)
      CALL AverageSelected(Nh,Nhex)
 30   format(' Mass range=',2g11.4,' Concentrations=',2g11.3,
     &  /' Vcirc_neighbor/Vcirc < ',f8.2,' Rneighbor/Rvir> ',f8.2)
      END
c-------------------------------------------------------------------- 
      SUBROUTINE AverageSelected(Nh,Nhex)
c-------------------------------------------------------------------- 
      INCLUDE 'PMselect.h'
      Logical inside,isolated
      COMMON /AVER/ Rapr(Nrmax),Napr(Nrmax),
     +             Vacpr(Nrmax),RHOapr(Nrmax),Varpr(Nrmax),
     +             bMa(Nrmax),Dapr(Nrmax),Vadpr(Nrmax),
     &             
      
      write (*,*)  ' Concentration limits=',Cc-dCc,Cc+dCc
      nn = 0
      aMav =0.
      rav  =0.
      Do i=1,Nh
         amm = aM(i)
         Cnc = Conc(i)
         x   = Xp(i)
         y   = Yp(i)
         z   = Zp(i)
         inside = (amm.gt.aMass-dM.and. amm.lt.aMass+dM )
         inside = (Cnc.gt.Cc-dCc.and.Cnc.lt.Cc+dCc.and.inside)
         inside = (x.gt.X0-dR.and. x.lt.X0+dR .and.inside)
         inside = (y.gt.Y0-dR.and. y.lt.Y0+dR .and.inside)
         inside = (z.gt.Z0-dR.and. z.lt.Z0+dR .and.inside)
         inside = (errFit(i).lt.errLimit.and.inside)
         If(inside)Then
          CALL CheckIsolated(i,Nh,Nhex,isolated)
c          isolated =.true.
          If(isolated)Then  
           write(*,50) Xp(i),Yp(i),Zp(i),
     &         VXp(i),VYp(i),VZp(i),
     &         aM(i),Radh(i),Vrms(i),Vcirc(i),
     &         Npart(i),Rmax(i),Conc(i),Nlines(i)
            nn = nn +1
            aMav = aMav + aM(i)
            rav  = rav  + Radh(i)
             If(nn.eq.1)Then
                ifirst = i
               Do j=1,Nlines(i)
                  Rapr(j)  = Rpr(j,i)/ Radh(i)
                  Vacpr(j) = Vcpr(j,i)
                  RHOapr(j)= RHOpr(j,i)
                  bMa(j)   = RHOpr(j,i)**2
                  Varpr(j) = Vrpr(j,i)
               EndDo
             else 
                ilast = i
               Do j=1,Nlines(i)
                  Rapr(j)  = Rapr(j)  +Rpr(j,i)/ Radh(i)
                  Vacpr(j) = Vacpr(j) +Vcpr(j,i)
                  RHOapr(j)= RHOapr(j)+RHOpr(j,i)
                  bMa(j)   = bMa(j)   +RHOpr(j,i)**2
                  Varpr(j) = Varpr(j) +Vrpr(j,i)
               EndDo
             EndIf 
          EndIf 
         EndIf 
      EndDo
      If(nn.eq.0)Then
         write (*,*)  ' no halos were selected'
         return
      EndIf 
      write (*,*)  nn,' halos were selected'
               Do j=1,Nlines(ifirst)
                  Rapr(j)  = Rapr(j)/nn
                  Vacpr(j) = Vacpr(j)/nn
                  RHOapr(j)= RHOapr(j)/nn
                  bMa(j)   = sqrt(bMa(j)/nn -RHOapr(j)**2)
                  Varpr(j) = Varpr(j)/nn
               EndDo
            aMav = aMav/nn
            rav  = rav/nn

          write(17,'(" Nselected=",i6," Mass=",g11.3," Rvir=",g11.3)')
     &              nn,aMav,rav
          write(17,50) Xp(ilast),Yp(ilast),Zp(ilast),
     &         VXp(ilast),VYp(ilast),VZp(ilast),
     &         aM(ilast),Radh(ilast),Vrms(ilast),Vcirc(ilast),
     &         Npart(ilast),Rmax(ilast),Conc(ilast),Nlines(ilast)
          Do j=1,Nlines(ilast)
            write(17,60) Rapr(j),Npr(j,ilast),
     &                bM(j,ilast),Dpr(j,ilast),Vdpr(j,ilast),
     &          Vacpr(j),RHOapr(j)*Dpr(1,1)/RHOpr(1,1),
     &          Npr(j,ilast),0,0,Varpr(j),bMa(j)*Dpr(1,1)/RHOpr(1,1)
          EndDo 

 40   Format(2i7,3g11.3,g12.4,f9.2)
 50   Format(F8.3,2F8.3,3F8.1,g11.3,f8.2,2f7.1,I9,f8.1,f8.2,i4)
 60   format(g11.4,I9,g11.3,g10.3,2f7.1,g10.3,i8,i7,i5,2g11.3)
      Return
      End
c-------------------------------------------------------------------- 
      SUBROUTINE PrintSelected(Nh,Nhex)
c-------------------------------------------------------------------- 
      INCLUDE 'PMselect.h'
      Logical inside,isolated

      nn = 0
      Do i=1,Nh
         amm = aM(i)
         Cnc = Conc(i)
         x   = Xp(i)
         y   = Yp(i)
         z   = Zp(i)
         inside = (amm.gt.aMass-dM.and. amm.lt.aMass+dM )
         inside = (Cnc.gt.Cc-dCc.and.Cnc.lt.Cc+dCc.and.inside)
         inside = (x.gt.X0-dR.and. x.lt.X0+dR .and.inside)
         inside = (y.gt.Y0-dR.and. y.lt.Y0+dR .and.inside)
         inside = (z.gt.Z0-dR.and. z.lt.Z0+dR .and.inside)
         inside = (errFit(i).lt.errLimit.and.inside)
         If(inside)Then
          CALL CheckIsolated(i,Nh,Nhex,isolated)
c          isolated =.true.
          If(isolated)Then  
             nn = nn +1
          write(*,40) nn,i,Conc(i),aM(i),Vcirc(i)
          write(17,50) Xp(i),Yp(i),Zp(i),
     &         VXp(i),VYp(i),VZp(i),
     &         aM(i),Radh(i),Vrms(i),Vcirc(i),
     &         Npart(i),Rmax(i),Conc(i),Nlines(i)
c          Do j=1,Nlines(i)
c            write(17,60) Rpr(j,i)/Radh(i),Npr(j,i),
c     &                bM(j,i),Dpr(j,i),Vdpr(j,i),
c     &          Vcpr(j,i),RHOpr(j,i)*Dpr(1,i)/RHOpr(1,i),
c     &          Npr(j,i),0,0,Vrpr(j,i)
c          EndDo 
         EndIf 
         EndIf 
      EndDo 
      write (*,*)  nn,' halos were selected'
 40   Format(2i7,3g11.3,g12.4,f9.2)
 50   Format(F8.3,2F8.3,3F8.1,g11.3,f8.2,2f7.1,I9,f8.1,f8.2,i4)
 60   format(g11.4,I9,g11.3,g10.3,2f7.1,g10.3,i8,i7,i5,g11.3)
      Return
      End
c-------------------------------------------------------------------- 
      SUBROUTINE CheckIsolated(i,Nh,Nhex,isolated)
c-------------------------------------------------------------------- 
      INCLUDE 'PMselect.h'
      Logical isolated

      isolated = .true.
      amm      = Vcirc(i) ! aM(i)
c      amm      = aM(i)
      Rhalo    = Radh(i)
         x   = Xp(i)
         y   = Yp(i)
         z   = Zp(i)

      Do j=1,Nhex
         If(i.ne.j.and.amm.lt.Vcirc(j)*aMiso)Then
            dd = (Xp(j)-x)**2+(Yp(j)-y)**2+(Zp(j)-z)**2
            diso = Riso*max(Rhalo,Radh(j))/1.e3  ! put it in Mpc
c            write (*,'(2i7,10g11.3)')i,j,sqrt(dd),diso,Rhalo,
c     &            Radh(j),Vcirc(i),Vcirc(j)
            If(dd.lt.diso**2)Then
               isolated = .false.
               return
            EndIf 
         EndIf 
      EndDo 
      If(Vrms(i).gt.1.4*Vcirc(i))write (*,*)' Unbound halo:',
     &                           i,Vrms(i),Vcirc(i)
      Return
      End
c-------------------------------------------------------------------- 
      SUBROUTINE ReadCatalog(Nh)
c-------------------------------------------------------------------- 
      INCLUDE 'PMselect.h'
      Character*120 Line

      Lines = 27

      Do i=1,Lines
         read(20,'(A)')Line
         read(21,'(A)')Line
         write(*,'(A)')Line
         write(17,'(A)')Line
      EndDo 
      Nh = 1

  10   read(20,*,end=100,err=100) Xp(Nh),Yp(Nh),Zp(Nh),
     &         VXp(Nh),VYp(Nh),VZp(Nh),
     &         aM(Nh),Radh(Nh),Vrms(Nh),Vcirc(Nh),
     &         Npart(Nh),Rmax(Nh),Conc(Nh),Nlines(Nh)

       read(21,*,end=100,err=100) Xp0,Yp0,Zp0,
     &         VXp0,VYp0,VZp0,
     &         aM0,Radh0,Vrms0,Vcirc0,
     &         Npart0,Rmax0,Conc0,Nlines0,errFit(Nh)

       If(Nh.lt.10.or.Nh/5000*5000.eq.Nh)
     &         write (*,'(" header=",i7,g11.3,i6,3g12.4)')
     &         Nh,aM(Nh),Nlines(Nh),Xp(Nh),Yp(Nh),Zp(Nh)
       If(Nh.lt.10.or.Nh/5000*5000.eq.Nh)
     &         write (*,'(" header=",i7,g11.3,i6,3g12.4)')
     &         Nh,aM0,Nlines0,Xp0,Yp0,Zp0

       If(abs(Xp(Nh)-Xp0).gt.1.e-2.or.abs(Yp(Nh)-Yp0).gt.1.e-2
     &    .or.abs(Zp(Nh)-Zp0).gt.1.e-2)stop 'Mismatch between catalogs'
       If(abs(aM(Nh)-aM0).gt.1.e-2*aM0.or.Nlines(Nh).ne.Nlines0)
     &       stop 'Mismatch between catalogs'
       Conc(Nh) =Conc0
       If(Nlines(Nh).gt.Nrmax) STOP ' wrong number of profile lines'
       If(Nlines(Nh).le.0) STOP ' wrong number of profile lines'
       Do i=1,Nlines(Nh)
          read (20,*) Rpr(i,Nh),Npr(i,Nh),
     &                bM(i,Nh),Dpr(i,Nh),Vdpr(i,Nh),
     &                Vcpr(i,Nh),RHOpr(i,Nh),
     &                nsm,nmed,nlg,Vrpr(i,Nh)
       EndDo

      if(Nh.ge.Np)goto100
      Nh =Nh +1
      goto 10

 100  Nh =Nh -1

      write (*,'("  Number of halos read=",T30,i8)')  Nh

      Return
      End
c-------------------------------------------------------------------- 
c                        make sample larger by replicating
c                        some halos using periodical
c                        boundary conditions
c          dR is the width of the buffer in Mpc/h
c          Next = new number of halos
      SUBROUTINE ExpandSample(Nh,Nhex,dBox,Box)
c-------------------------------------------------------------------- 
      INCLUDE 'PMselect.h'
      Logical inx,iny,inz

      Xleft =-dBox             ! new boundaries for the catalog
      Xright =Box+dBox
      Yleft =-dBox
      Yright =Box+dBox
      Zleft =-dBox
      Zright =Box+dBox
      write (*,*)  Xleft ,Xright
      Next = Nh

      Do ip =1,Nh    ! go over all halos
         x =Xp(ip)
         y =Yp(ip)
         z =Zp(ip)

      Do k=-1,1       ! go over all 27 periodical images
         dz = k*Box
         inz =(z+dz.gt.Zleft.and.z+dz.lt.Zright)
         Do j=-1,1
           dy = j*Box
           iny =(y+dy.gt.Yleft.and.y+dy.lt.Yright)
           Do i=-1,1
               dx =i*Box
               If(i**2+j**2+k**2.ne.0)Then
                  inx =(x+dx.gt.Xleft.and.x+dx.lt.Xright)
                  If(inx.and.iny.and.inz)Then  ! add this halo to the list
                     Next =Next +1
                     if(Next.gt.Np) STOP 'too many halos'
                     Xp(Next) =x+dx
                     Yp(Next) =y+dy
                     Zp(Next) =z+dz
                     VXp(Next) =VXp(ip)
                     VYp(Next) =VYp(ip)
                     VZp(Next) =VZp(ip)
                     aM(Next)  =aM(ip)
                     Radh(Next) =Radh(ip)
                     Vrms(Next) =Vrms(ip)
                     Vcirc(Next)=Vcirc(ip)
                     Conc(Next) =Conc(ip)
                  EndIf               ! end inside box
               EndIf                  ! end exclude central box

            EndDo       ! end i
          EndDo       ! end j
        EndDo       ! end k
      EndDo         ! end ip
      write (*,*) ' Nhalos in extended sample=',Next 
      Nhex =Next
      RETURN 
      END

C---------------------------------- Read in variables      
      REAL FUNCTION INPUT(text)
C------------------------------------------------
      Character text*(*)
          write (*,'(A,$)')text
          read (*,*) x
          INPUT =x
      Return
      End

C ______________________________ Profiles for Galaxy Simulations
C		             
C		                     
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMgalaxy.h'
      REAL         INPUT,moment
      Character    FileASCII*100,Analysis*3
      Character  File1*100,File2*100
      EQUIVALENCE (Ndisk,extras(90)),
     &               (Nbulge,extras(97)),(aMassDisk,extras(93)),
     &               (Box,extras(100))


      
c      aMassDisk =1.e10    ! "Bulge"
c      aMassDisk =5.71e8      ! "Dwarf"
c      aMassDisk =3.36e10/h      ! "MW_LARGE"
      Analysis ='AAB'

C...................................................................
C			Read data and open files
       write(*,*)' enter 6 digits of the snapshot Example: 0.6235'
       read(*,*) moment
       If(moment.lt.1.5)Then
         write(File1,'("FILES/PMcrda",f6.4,".DAT")')moment
         write(File2,'("FILES/PMcrs0a",f6.4,".DAT")')moment
       Else
          imoment =INT(moment+0.1)
c       read(*,*) imoment
         write(File1,'("FILES/PMcrda.",i4.4,".DAT")')imoment
         write(File2,'("FILES/PMcrs0a.",i4.4,".DAT")')imoment
       endIf
         write(*,*) File1
         write(*,*) File2

c      File1 ='PMcrd.DAT'
c      File2 ='PMcrs0.DAT'

      CALL BLOCK_DATA
      CALL RDTAPE(File1,File2)
c      Nbulge = 33409
c      aMassDisk =4.28e10*hubble      ! MOVIE
c      Ndisk     =199996
      time = Age(AEXPN)-Age(0.60)
         write(FileASCII,'("RESULTS/Result",a,".DM.",f6.4,".dat")')
     &    Analysis,AEXPN
      OPEN(37,FILE=FileASCII,STATUS='UNKNOWN') 
        write(FileASCII,'("RESULTS/Result",a,".SPH.",f6.4,".dat")')
     &    Analysis,AEXPN
      OPEN(39,FILE=FileASCII,STATUS='UNKNOWN') 

         write(FileASCII,'("RESULTS/Result",a,".CYL.",f6.4,".dat")')
     &    Analysis,AEXPN
      OPEN(41,FILE=FileASCII,STATUS='UNKNOWN') 

         write(FileASCII,'("RESULTS/Result",a,".BAR.",f6.4,".dat")')
     &    Analysis,AEXPN
      OPEN(43,FILE=FileASCII,STATUS='UNKNOWN') 
      OPEN(18,FILE='Stat.dat',STATUS='UNKNOWN',access='append')
         write(FileASCII,'("RESULTS/Result",a,".PRT.",f6.4,".dat")')
     &    Analysis,AEXPN
      OPEN(20,FILE=FileASCII,STATUS='UNKNOWN')
c      OPEN(30,FILE='particlesu.dat',STATUS='UNKNOWN',form='UNFORMATTED')

 
      time      = (age(AEXPN)-age(0.6))
      aMassDisk = aMassDisk/hubble
c      aMassDisk = 3.5e10/hubble

      write (*,*)  ' hubble =',hubble,' mass of disk=',aMassDisk
      write (*,*) ' RDTAPE is done Time=',time,' a=',AEXPN
          WRITE (*,100) HEADER,AEXPN,ASTEP,time,
     +                  ISTEP,Ndisk,Nbulge,aMassDisk,
     +                  NROWC,NGRID,bar_max*1.e3,dZ_slice*1.e3,
     +                  Om0,Oml0,hubble,Ocurv
      Do i=37,43,2
          WRITE (i,100) HEADER,AEXPN,ASTEP,time,
     +                  ISTEP,Ndisk,Nbulge,aMassDisk,
     +                  NROWC,NGRID,bar_max*1.e3,dZ_slice*1.e3,
     +                  Om0,Oml0,hubble,Ocurv
      EndDo 
100   FORMAT(1X,'Header=>',A45,/
     +    T2,'Aexp',T12,'dA',T22,'Time(Gyrs)',T35,'Step',
     &    T42,'Ndisk',T50,'Nbulge',T58'Mdisk(Msun)',/
     &    T1,f8.5,T10,f8.5,T22,g11.4,T35,i4,T40,i8,T48,i7,T58,g11.4,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Max Bar radius(kpc)=',
     &             f7.3,' Slice in Z for cylindr shells=',f8.3/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3)
c      Box  =INPUT(' Enter box size in comoving Mpc/h =')
c      Box =0.5 ! NG3109
c      Box = 2   ! 'bulge'

      BoxV   = Box*100.    ! Box size in km/s
      ScaleV = BoxV/AEXPN/NGRID      ! scale factor for Velocities (km/s)
      ScaleC = Box/NGRID*AEXPN/hubble  ! scale factor for Coordinates (real Mpc)
      ScaleH  = 100.*hubble*sqrt(Om0/AEXPN**3+Oml0) ! H(a)=km/s/Mpc
      if(Ndisk.le.0)write (*,*) ' wrong number of disk particles:',Ndisk
      if(Ndisk.le.0)Stop
      ScaleM = aMassDisk/Ndisk
      Ndisk = Ndisk +Nbulge
      Nbulge = 0

      CALL ReadPnts(N,ScaleC,ScaleV,ScaleM)
      Call ChangePnts(N,Box,ScaleH)
c      Call DumpPnts(N,Box,ScaleM)

c      Call AngMom(N,30000,3.,Box,ScaleM)
c      CALL PV(N,Box,ScaleM)
c      CALL RandV(N,Box,ScaleM)
      Call Profile(N,Box,ScaleM)
      Call Statist(N,Box,ScaleM)
c      Call Projection(N,Box,0.)
c      Call Projection(N,Box,5.)

      END

C ______________________________	 Convert PM format to ASCII 
C		             November 1997         A. Klypin (aklypin@nmsu.edu) 
C		                     
C          Scales internal PM coordinates and velocities 
C          to  coordinates in Mpc/h and km/s
C          In PM the coordinates are in the range 1 - (NGRID+1)
C                     velocities are P = a_expansion*V_pec/(x_0H_0)
C                     where     x_0 = comoving cell_size=Box/Ngrid
C                                    H_0 = Hubble at z=0
C                   
C	     NROW = number of particles in 1D
C	     NGRID= number of cells        in 1D
       INCLUDE 'PMparameters.h'
       REAL     INPUT
       logical inside
       Character  FileASCII*50,File1*120,File2*120
C...................................................................
C			Read data and open files
      WRITE (*,'(A,$)') 'Enter Name for output ASCII file = '
      READ  (*,'(A)') FileASCII
      OPEN(17,FILE=FileASCII,STATUS='UNKNOWN')
      WRITE (*,'(A,$)')'Enter snapshot (0-for standard files)= '
      READ  (*,*) moment
      If(moment.le.0)Then
         File1 ='PMcrd.DAT'
         File2 ='PMcrs0.DAT'
      Else
         write(File1,'(a,i5.5,a)')'PMcrd_',moment,'.DAT'
         write(File2,'(a,i5.5,a)')'PMcrs0_',moment,'.DAT'
      EndIf 
      write(*,*) ' Open files:'
      write (*,'(a)')  File1
      write (*,'(a)')  File2
      CALL RDdata(File1,File2)

      write (*,*) ' RDTAPE is done'
      Fraction =INPUT(' Enter fraction of particles     =')
      If(Fraction.le.0.)Stop
      Ifraction = INT(1./Fraction+0.01)
      Radius =INPUT(' Enter radius of sphere or zero for all in box  =')
      Rad2 = 0.
      If(Radius.gt.0.)Then    
         write (*,'(A,$)') ' Enter Center: x,y,z     ='
         read  (*,*) xc,yc,zc
         xl =xc -Radius
         xr =xc +Radius
         yl =yc -Radius 
         yr =yc +Radius 
         zl =zc -Radius  
         zr =zc +Radius  
         Rad2 = Radius**2

      EndIf
      xrand     = 0.
         ncount = 0
      write (*,*) ' Every ',Ifraction,' particle will be selected'
      WRITE (17,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  xc,yc,zc,Fraction
100   FORMAT(1X,'Header=>',A45,/
     +          1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +           1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,/
     +           1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I6,/
     +           1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +           1x,' Center=',3F7.3,' Fraction =',F7.3)

      If(extras(100).ne.0.)Then
         Box = extras(100)
      else
        Box =INPUT(' Enter box size in Mpc/h   =')
      endif 
      write (*,*) ' Box size is =  ',Box,'Mpc/h'
      BoxV =Box*100.    ! Box size in km/s
      ScaleV = BoxV/AEXPN/NGRID  ! scale factor for Velocities
      ScaleC = Box/NGRID         ! scale factor for Coordinates

      xmax =-1.e+9
      xmin = 1.e+9
      vmax =-1.e+9
      vmin = 1.e+9
      Icount =0
      ifile      =1
         N_particles =lspecies(Nspecies)   ! Total number of particles
         Npages = (N_particles -1)/NPAGE +1
         N_in_last=N_particles -NPAGE*(Npages-1)
      write (*,*) ' Pages=',Npages,' Species=',Nspecies
      write (*,*) ' N_in_last=',N_in_last
C				       Loop over particles
       DO IROW=1,Npages
            In_page =NPAGE
            If(IROW.eq.Npages)In_page =N_in_last
c            If(IROW.eq.2)
             write (*,'(" Read page=",i4," min/max=",10g11.3)')
     &             IROW,xmax,xmin,vmax,vmin
            iL = NPAGE*(IROW-1)
	      CALL GETROW(IROW,ifile)
	      DO IN=1,In_page
	        X  =ScaleC* (XPAR(IN)-1.)
	        Y  =ScaleC* (YPAR(IN)-1.)
	        Z  =ScaleC* (ZPAR(IN)-1.)
             Vxs=ScaleV* VX(IN)
             Vys=ScaleV* VY(IN)
             Vzs=ScaleV* VZ(IN)
             Icount =Icount +1

             xmax =MAX(xmax,X,Y,Z)
             xmin =MIN(xmin,X,Y,Z)
             vmax =MAX(vmax,Vxs,Vys,Vzs)
             vmin =MIN(vmin,Vxs,Vys,Vzs)
                Ipart =IN+iL             ! current particle number
                Do i =1,Nspecies
                   if(Ipart.le.lspecies(i))Then
                      W =wspecies(i)
                      goto 50
                   endif 
                EndDo 
 50        If(Fraction.lt.0.999)xrand =RANDd(Nseed) ! random fraction
           inside =.true.
           If(Radius.gt.0.)Then
              if(X.lt.xl.or.X.gt.xr)inside =.false.
              if(Y.lt.yl.or.Y.gt.yr)inside =.false.
              if(Z.lt.zl.or.Z.gt.zr)inside =.false.
           EndIf
              If(xrand.le.Fraction.and.inside)Then
                 rr = (X-xc)**2+(Y-yc)**2+(Z-zc)**2
                 If(rr.le.Rad2)ncount =ncount +1
c                 write (17,'(3f10.5,f8.3)') X,Y,Z,W
                         write (17,200) X,Y,Z,Vxs,Vys,Vzs,W
 200              Format(3F10.5,3F9.2,f8.4)
              EndIf  
c              If(X.lt.0..or.Y.lt.0..or.Z.lt.0.)
c     &              write(70,210)Ipart,X,Y,Z,Vxs,Vys,Vzs,W
c              If(X.gt.Box.or.Y.gt.Box.or.Z.gt.Box)
c     &              write(70,210)Ipart,X,Y,Z,Vxs,Vys,Vzs,W
              Vv =sqrt(Vxs**2+Vys**2+Vzs**2+0.001)
              If(VV.gt.10000.)
     &              write(70,210)Ipart,X,Y,Z,Vxs,Vys,Vzs,W
              
 210          format(i8,3G11.3,3G11.3,f8.3)
	      ENDDO
        ENDDO 

      write (*,*) ' Scaled Coordinates were written to:',
     &            FileASCII
      write (*,*) ' Number of particles          =',Icount
      IF(Radius.gt.0.)
     &write (*,*) ' Number of particles inside Rad=',ncount
      write (*,*) ' Min/Max of coordinates(Mpc/h)=',xmin,xmax
      write (*,*) ' Min/Max of velocities (km/s) =',vmin,vmax

      END


C---------------------------------------------------
C                                  Read  current data from disk/tape,
C                                  Open files
C                                  Nrecl is the number of values in a record
C                                  Npage is the number of particles in a page
      SUBROUTINE RDdata(File1,File2)
C---------------------------------------------------
      INCLUDE 'PMparameters.h'
      CHARACTER  File1*(*),File2*(*)
C                                     Open file on a tape
      OPEN(UNIT=9,FILE=File1,
     +                FORM='UNFORMATTED', STATUS='UNKNOWN')
C                                 Read control information
C                                 and see whether it has proper
C                                 structure
      READ  (9,err=20,end=20) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  TINTG,EKIN,EKIN1,EKIN2,AU0,AEU0,
     +                  NROWC,NGRIDC,Nspecies,Nseed,Om0,Oml0,hubble,Wp5
     +                   ,Ocurv,extras
      WRITE (*,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,EKIN1,EKIN2,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
      WRITE (16,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,EKIN1,EKIN2,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
100   FORMAT(1X,'Header=>',A45,/
     +          1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',3E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I9,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3)
      IF(NROW.NE.NROWC) THEN
         WRITE (*,*)
     +            ' NROW in PARAMETER and in TAPE-FILE are different'
         write (*,*)  ' NROW,NGRID (PMparamters.h)=',NROW,NGRID
         write (*,*)  ' NROW,NGRID (PMcrd.DAT)    =',NROWC,NGRIDC
      ENDIF
      IF(NGRID.NE.NGRIDC) THEN
         WRITE (*,*)
     +           ' NGRID in PARAMETER and in TAPE-FILE are different:'
         write (*,*) ' Ngrid=',NGRID,' NgridC=',NGRIDC
      ENDIF
C                                         Open work file on disk
 10   NBYTE = NRECL*4
      NACCES= NBYTE / nbyteword

      OPEN(UNIT=21,FILE=File2,ACCESS='DIRECT',
     +	               STATUS='UNKNOWN',RECL=NACCES)


      REWIND 9
      RETURN
 20   write (*,*) ' Error reading the header file: Abort'
      stop
      END

C _______________________ START 3-D SIMULATIONS
C
C                         Klypin, August 1993
C
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR2.h'	  
C		   NROW = number of particles in 1 dimension
C		   NGRID= number of cells        in 1 dimension
C		   Npage =  number of particles per page = NROW**2
C


      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Par(6),ns,qqscaleb,QSCALE
      COMMON / KINENRG/ SKINE,SX,SY,SZ,SX2,SY2,SZ2
      Character  Hd*5,Tail*4
      DATA PI		/3.1415926535/

      CALL InitValues(NBYTE,SCALEL)
      write (*,*) ' InitValues is done. N bytes=',NBYTE
      Max_lev_abs = INT(ALOG(REAL(Lblock))/ALOG(2.)+1.1)
      write (*,*) ' Absolute Limits on mass resolution levels: ',
     &                  1,Max_lev_abs

      write (*,*) ' Actual Max resolution Level=',Nmax_lev,
     &               '                Min Level=',Nmin_lev
      write (16,*) ' Actual Max resolution Level=',Nmax_lev,
     &               '                Min Level=',Nmin_lev
      If(Nmax_lev.gt.Max_lev_abs)Then
         write (*,*) ' Wrong number of Levels for mass refinement (',
     &                 Nmax_lev ,') Block size =',Lblock,
     &                ' Use Absolute value=',Max_lev_abs
         Nmax_lev =Max_lev_abs
      Endif 

      OPEN(UNIT=9,FILE='PMcrd.DAT',form='unformatted')
      write (9)             ! this clears old header file
      CLOSE (9)
      CALL RDTAPE                  ! this opens files on disk
      OPEN(UNIT=16,FILE='RESNEW.DAT')
       AEXP0 = AEXPN
       AEXPV = AEXPN - ASTEP/2.
C                                    set mask for multiple mass resolution
      CALL ZeroMASK
        If(Nmax_lev.ne.Nmin_lev)Then
          Open(30,file='SelCoords.DAT')
          CALL SetMASK
        EndIf
C			                   get a realization of spectrum in /GRID/
      NRAND =Nseed
      CALL SPectr_CR(NRAND)
           CALL SPECTR(NRAND,Levels)  ! set spectrum for higher levels
           CALL RELOCATE_SP         ! remove harmonics included at lower levels
C			                        get the displacement vector by FFT
       CALL VECTOR
	    write (*,*) ' SPECTR is done.  Alpha=',
     &                   (ALPHA(i),i=1,Levels)
        Fact =  sqrt(Om0+Oml0*AEXPV**3+Ocurv*AEXPV)
           VCONS = -1./(2.*PI/NGRID)*(AEXPV/AEXP0)*
     &                              SQRT(AEXPV)*Fact
           XCONS =	 1./(2.*PI/NGRID)*(AEXPN/AEXP0)
           write (*,*) ' Cons=', XCONS ,VCONS 
       QFACT =  FLOAT(NGRID)/FLOAT(NROW)
                      SKINE = 0.
                      SX    = 0.
                      SY    = 0.
                      SZ    = 0.
                      SX2   = 0.
                      SY2   = 0.
                      SZ2   = 0.

C			           find x,v and write to file, page by page
       Do i=1,Max_lev_abs
          lspecies(i) =0
       Enddo 
       Nspecies =0
C                          find x,v for multiple mass resolution code 
         Icurrent    =0                         ! current particle
            Do kSpec =Max_lev_abs,1,-1
                CALL BLOCKS(XCONS,VCONS,kSpec,Icurrent)   
                write (*,*) ' Level=',Max_lev_abs-kSpec+1, 
     &            ' Nparticles=',lspecies(Max_lev_abs-kSpec+1)
            Enddo 
           Vscale =ScaleL*100.*hubble/NGRID
      CALL WriteData(Vscale,AexpV,Wtotal)
      CALL Species_Change(Wtotal_o)      ! rearrange species
            EKIN = 0.5*SKINE/AEXPV**2       
           WRITE (*,'('' Ekin='',E12.4,'' Weght per cell='',g12.5,
     .                   '' (must be 1)'')')   EKIN,Wtotal/NGRID**3
           WRITE (16,'('' Ekin='',E12.4,'' Weght per cell='',g12.5,
     .                   '' (must be 1)'')')   EKIN,Wtotal/NGRID**3
C			        
      CALL WRTAPE   ! write header and control data
C                      write pt.dat file: time-step for particles
         Nparticles =lspecies(Nspecies)
c      Do ic1 =1,Nparticles
c         XPt(ic1) =astep
c      Enddo 
      open ( 60 , file = 'pt.dat' , form = 'unformatted' )
c      write(60) (XPt(ic1),ic1=1,Nparticles)
      write(60) astep
      write (*,*) ' pt=', astep   !(XPt(ic1),ic1=1,10)
      STOP
      END
C--------------------------------------------------
C                                                     sqrt(Power spectrum)
C                                                           k = (2pi/L) wk
      REAL  FUNCTION TRUNF(wk)
C--------------------------------------------------
      INCLUDE 'PMparameters.h'
      PARAMETER (NSPEC =NROW/2)
      PARAMETER (NtabM = 100000)
      COMMON /PTABLE/xkt(0:NtabM),Pkt(0:NtabM),Ntab,StepK,alog0,iFlag  
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Par(6),ns,qqscaleb,QSCALE
      Real                 ns,k
      IF(WK.GE.FLOAT(NSPEC)) THEN
	       TRUNF =0.
	       RETURN
      ENDIF
        k = QSCALE*wk
      If(iFlag.gt.0)Then       ! use approximations
      If(Par(6).ne.0.)Then   ! Holtzman approx
        sk= sqrt(k)
        TRUNF = k**(ns/2.) /
     .         (1.+sk*(Par(2)
     .            +sk*(Par(3)
     .            +sk*(Par(4)
     .            +sk*(Par(5) )))) )**(Par(6))
      Else                   ! BBKS + Sugiyama approx
c        Gammaeff =Om*hsmall/exp(Omb*(1.+sqrt(hsmall/0.5)/Om))
c        Q = wk/hsmall/Gammaeff

        Q = k*qqscaleb
        TRUNF = k**(ns/2.)* LOG(1.+Par(1)*Q)/(Par(1)*Q)/
     .          sqrt(sqrt(1.+Q*(Par(2)+
     .                  Q*(Par(3)**2+
     .                  Q*(Par(4)**3+
     .                  Q*(Par(5)**4) )))))

      EndIf
      Else               ! use table for P(k)
         TRUNF = sqrt(Ppk(k))
      EndIf  

      RETURN
      END
C---------------------------------------
      FUNCTION Ppk(x)
c                     interpolate table with p(k)
c                       x is in real 1/Mpc
C---------------------------------------
      PARAMETER (NtabM = 100000)
      COMMON /PTABLE/xkt(0:NtabM),Pkt(0:NtabM),Ntab,StepK,alog0,iFlag  

      If(x.ge.xkt(Ntab))Then  ! slope is ns =-3
         Ppk =Pkt(Ntab)/(x/xkt(Ntab))**3
         Return
      EndIf
      If(x.lt.xkt(1))Then                ! slope is ns=1
         Ppk =Pkt(1)*(x/xkt(1))
         Return
      EndIf
      ind = INT((log10(x)-alog0)/StepK) +1
      dk  = xkt(ind+1)-xkt(ind)
        Ppk   = (Pkt(ind)*(xkt(ind+1)-x)+Pkt(ind+1)*(x-xkt(ind)))/dk
c        write (*,'(5x," k=",g12.4," table=",2g12.4,"  P=",3g12.4)') 
c     &    x,xkt(ind),xkt(ind+1),
c     &    Ppk,Pkt(ind),Pkt(ind+1)
      Return
      End
C---------------------------------------
      SUBROUTINE  ReadTable(hsmall)
c                     interpolate table with p(k)
C---------------------------------------
      PARAMETER (NtabM = 100000)
      COMMON /PTABLE/xkt(0:NtabM),Pkt(0:NtabM),Ntab,StepK,alog0,iFlag  
  
       Open(50,file='WHUpk.dat')
        twop = 2.*3.14145926**2

        Ntab =0
 10     read(50,*,end=30,err=30)xx,pp
        Ntab =Ntab +1
        xkt(Ntab) =xx   *hsmall             ! scale to real Mpc
        Pkt(Ntab) = pp    /xx**3*twop   ! k^3Pk -> Pk
        goto 10
 30     write (*,*)  
        write (*,*)  ' Read ',Ntab,' lines from file WHUpk.dat'
        write (*,*)  ' hsmall =',hsmall
        If(Ntab.le.1)stop 'wrong table for p(k)'
        StepK =log10(xkt(2)/xkt(1))
        alog0   = log10(xkt(1))
        
        Do k =2,Ntab-1      ! test that spacing is the same
           ss =log10(xkt(k+1)/xkt(k))
           If(abs(ss/StepK-1.).gt.1.e-3)Then
              write (*,*)  ' error in K spacing. k=',k,xkt(k+1),xkt(k)
              STOP
           EndIf
        EndDo 
        close(50)
      Return
      End



C*********************************************************************
C	   Power spectrum for CDM. Wk-  wavenumber(Mpc^-1, h=0.5)
C                         P = wk *T^2(k)
C                         QSCALE = 2pi/Box_size,  QS =hubble**(-2)
c      FUNCTION TRUNF(WK)
c      COMMON / TRUNCOM/ QSCALE,g,gy
c      COMMON / TRUNCDM/ QS,A1,A2,A3,A4,A5,A32,A43,A54
c       Q = QSCALE*QS*WK
c       TRUNF = sqrt( WK*
c     +		 (LOG(1.+A1*Q)/(A1*Q))**2/
c     +		 SQRT(1.+Q*(A2 +Q*(A32   +Q*(A43+Q*A54)))) )
c
c      RETURN
c      END

C*********************************************************************
C			  INITIALIZE CONSTANTS:
C			      Scalel    =length of square in MPC
C			      AEXPN =expansion factor (current)
C			      ASTEP	  =increment of expansion factor: AEXPN =AEXP_0+N*ASTEP
C                     PARTW	=weight of a particle: total 'mass' per cell must be unity
c                                          even for LCDM or OCDM 
C			      AMPLT	=amplitude of perturbations inside the simulation box
C			      NBYTE	=record length in bytes
C
      SUBROUTINE InitValues(NBYTE,SCALEL)
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR2.h'
      PARAMETER (NtabM = 100000)
      COMMON /PTABLE/xkt(0:NtabM),Pkt(0:NtabM),Ntab,StepK,alog0,iFlag  
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Par(6),ns,qqscaleb,QSCALE
      COMMON / FERMI  / Vscale
      Real                 ns      
      Character            Answer*1
      Real                 INPUT
      DATA PI		         /3.1415926535/

      Do i=1,100
         extras(i) =0.
      enddo 
       Write (*,*) 'Would you like to use a model provided in cdm.fit '
       Write (*,*) 'or your own model?' 
       Write (*,'(A,$)') ' Enter Yes for cdm.fit;  No for your model ='
       Read  (*,'(A)')  Answer
       HEADER='N=128x256 L=20h-1CDMsig=0.239 z=30-----------'
       write (*,*) '------ Enter Header for the run up to 45 characters'
       write (*,*) '       Example:'
       write (*,'(A)') HEADER                                   
       read  (*,'(A)') HEADER
       write (*,'(A)') HEADER
       AEXPN =INPUT(' Initial expansion parameter (0-1)=')
       ASTEP =INPUT(' Step of the expansion parameter  =')

       AMPLT_CR(1)=INPUT(' Amplitude of density fluctuations CR  =')
       AMPLT_CR(2)=INPUT(' Amplitude of density fluctuations noCR=')
       ns    =INPUT(' Slope of the Power spectrum     n=')
       SCALEL=INPUT(' Box size (Mpc/h)                 =')
       Ocurv =INPUT(' Omega_curvature   at present     =')
       Nseed =INPUT(' Random seed (Integer  1-2^31)    =') 
       If(Nseed.le.0)Then
          lux = 2               ! level for luxury
          extras(80) = 1.
          extras(81) = lux
          If(Nseed.eq.0)Nseed = 121071
          Nseed = ABS(Nseed)
          CALL rluxgo(lux,Nseed,0,0) ! initialize luxury
       Else
          extras(80) = 0.
       EndIf
c                       extras(80) is used as switch for
c                                        random numbers generators
c                         = 0 - old Randd+Gauss
c                         = 1 - luxury+Gauss3
c                        extras(81) = lux - level of luxury
       extras(100) = SCALEL                   ! store the box size
       If(Answer.eq.'Y' .or. Answer.eq.'y')Then
          CALL MODEL(hsmall)
          hubble=hsmall
          Om0   =Om
          Oml0  =1. -Om0 -Ocurv
       Else
       write (*,*) ' You use your cosmological model.'
       write (*,*) ' Be sure you provide routine TRUNF'
       hubble=INPUT(' The Hubble constant (h=H/100)    =')
       Om0   =INPUT(' Omega_0 matter    at present     =')
       Oml0  =INPUT(' Omega_lambda      at present     =')
       EndIf
       SCALEL=SCALEL/hubble   ! scale it to real megaparsecs      
       NBYTE = NPAGE*6*4
        Write (*,'(A,$)') ' Enter Min and Max number of mass species ='
       read (*,*) Nmin_lev,Nmax_lev
             W     = (FLOAT(NGRID)/FLOAT(NROW))**3
            PARTW = W 
       If(Nmin_lev.lt.Nmax_lev)Then    ! multiple mass resolution
              write(*,*) 
              write(*,*) ' You use multiple mass resolution'
       endif 
       If(Nmin_lev.gt.Nmax_lev)Then ! change the order of levels
          i = Nmax_lev
          Nmax_lev = Nmin_lev
          Nmin_lev = i
       endif

       ISTEP = 0
       TINTG = 0.
       AU0   = 0.
       AEU0  = 0.
       EKIN  = 0.
       EKIN1 = 0.
       EKIN2 = 0.
       NROWC = NROW
       NGRIDC= NGRID
	     QSCALE = 2.*PI/SCALEL
	     QS     = hubble**(-2)
        write (*,*) ' Qscale=',QSCALE,SCALEL,ns
      RETURN
      END
C________________________________________Read parameters of the model
C                                 Om       = Omega_0
C                                 Omb     = Omega_baryon
C                                 Omnu  = Omega_neutrino
C                                 hsmall  = hubble constant
C                                 Par      = fitting parameters
C                                 Par(6) = 0  --- bbks-style+Hu&Sugiyama
C                                 Par(6) ne 0 --- holtzman-style
      SUBROUTINE MODEL(hsmall)
C---------------------------------------
      INCLUDE 'PMparameters.h'
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Par(6),ns,qqscaleb,QSCALE
      PARAMETER (NtabM = 100000)
      COMMON /PTABLE/xkt(0:NtabM),Pkt(0:NtabM),Ntab,StepK,alog0,iFlag  
      Real                 ns,INPUT
      Character             Header1*79

      Line1 =INPUT(' Enter Line Number in cdm.fit     =')
      write (*,*)  ' Line number=',Line1
      If(Line1.gt.0)Then
         iFlag = Line1
      OPEN(2,file='cdm.fit')
      Read(2,'(A)') Header1
      If(Line1.gt.2)Then
         Do i=1,Line1-2
            Read (2,*) a
         EndDo
      EndIf
      Read (2,*) Om,Omb,Omc,Omnu,hsmall,Par
      CLOSE (2) 
      
      theta = 2.726/2.7  ! = T_cmb/2.7
      Ob0   =Omb/Om      ! Hu&Sugiyama fitting
      Omh2  =Om*hsmall**2
      a1    =(46.9*Omh2)**0.670*(1.+(32.1*Omh2)**(-0.532))
      a2    =(12.0*Omh2)**0.424*(1.+(45.*Omh2)**(-0.582))
      alpha =1./a1**Ob0/a2**(Ob0**3)
      qqscaleb = theta**2/(1.-Ob0)**0.60/sqrt(alpha)/Omh2

      Write (*,20)Om,Omb,Omc,Omnu,hsmall,Par
c      Write (16,20)Om,Omb,Omc,Omnu,hsmall,Par
 20   Format(' Model: Om_0=',F5.3,' Om_baryon=',F5.3,
     .       ' Om_cold=',F5.3,' O_nu=',F5.3,
     .       ' hsmall=',F4.2,/8x,'Parameters=',(6G9.3))
      Else                     ! read spectrum from table
         iFlag = -1
         hsmall = 0.7
         Omb = 0.024/hsmall**2
         Om   = 0.3
         Ocurv = 0.
         Omc  = Om
         CALL ReadTable(hsmall)
      Write (*,22)Om,Omb,hsmall
      Write (1,22)Om,Omb,hsmall
 22   Format(' Model: Om_0=',F5.3,' Om_baryon=',F5.3,
     .       ' hsmall=',F4.2, ' <== Using table for P(k)')
      EndIf
      Return
      End
C------------------------------------------------
C                              Clear MASK for multiple mass resolution                             
C                               Initiat to level Nmin_lev
      SUBROUTINE ZeroMask
C------------------------------------------------
      INCLUDE 'PMparameters.h'	    
      INCLUDE 'PMinitialCR2.h'	  

         DO  MK3 = 1,Nblocks
         DO  MK2 = 1,Nblocks
         DO  MK1 = 1,Nblocks
	        iMask(MK1,MK2,MK3) =Nmin_lev
         ENDDO
         ENDDO
         ENDDO
      RETURN
      END
C------------------------------------------------
C                       Set MASK for multiple mass resolution  
C                               Read particles with lagrangian coordinates
C                                                to set the mask                           
C                               Block   = 1 = low resolution
C                                       = 2 = higher resolution
C                                       = 3 = even higher resolution
C               After the mask is set, make maximum resolution Nmax_lev
C
      SUBROUTINE SetMask
C------------------------------------------------
      INCLUDE 'PMparameters.h'	  
      INCLUDE 'PMinitialCR2.h'	  
      Dimension nLevel(10)
      Character*70 Line

      Do i=1,5
         Read(30,'(A)') Line
         Write(*,'(A)') Line
      EnDDo
      Nlines =0
      write (*,*)  ' Nblocks=',Nblocks
 10   Read(30,*,end=50,err=50) i,xw,yw,zw,
     +            vwx,vwy,vwz,im,jm,km
           Nlines =Nlines +1
c           write (*,*) ' Block=',im,jm,km
           If(im.lt.0.or.im.gt.Nblocks)Then
              write (*,*) ' wrong x_block: ',im,jm,km,' Line=',Nlines
              Stop
           EndIf
            If(jm.lt.0.or.jm.gt.Nblocks)Then
              write (*,*) ' wrong y_block: ',im,jm,km,' Line=',Nlines
              Stop
           EndIf
            If(km.lt.0.or.km.gt.Nblocks)Then
              write (*,*) ' wrong z_block: ',im,jm,km,' Line=',Nlines
              Stop
           EndIf
c             If(iMask(im,jm,km).ne.0)Then
c              write (*,*) ' Occupied block: ',im,jm,km,' Line=',Nlines
c              write (*,*) '                 Block=',iMask(im,jm,km)
c              Stop
c           EndIf
           
           iMask(im,jm,km) =Nmax_lev    ! mark high resolution block
               Do ik =-1,1
               k =km +ik
               If(k.le.0)k=k+Nblocks
               If(k.gt.Nblocks)k=k-Nblocks
               Do ij =-1,1
                  j =jm +ij
                  If(j.le.0)j=j+Nblocks
                  If(j.gt.Nblocks)j=j-Nblocks
                  Do ii =-1,1
                      i =im +ii
                      If(i.le.0)i=i+Nblocks
                      If(i.gt.Nblocks)i=i-Nblocks
                      ind =abs(ik)+abs(ij)+abs(ii) ! only seven blocks in crest
                                ! are marked out
c                      If(iMask(i,j,k).le.0.or.iMask(i,j,k).gt.Nspecies)
c     +                     Then
c                         Stop
c                      Endif 
                      If(ind.le.1)Then
                          iMask(i,j,k)=Nmax_lev ! change mask
                      Endif 
                  ENDDO
                ENDDO
                ENDDO
            GoTo 10
C                      Change the mask: iteratevely add layers of lower resolution
 50        write(*,*) ' Total Lines read=',Nlines
       DO kSpec =Nmax_lev-1,2,-1     !
         DO  MK3 = 1,Nblocks     ! find blocks adjasent to filled blocks
         DO  MK2 = 1,Nblocks     ! mark them with kSpec =Nspecies-1, -2, ..1
         DO  MK1 = 1,Nblocks
            iM =      iMask(MK1,MK2,MK3)
            If(iM.eq.kSpec+1)Then          ! change to kSpec if not high res
               Do ik =-1,1
               k =MK3 +ik
               If(k.le.0)k=k+Nblocks
               If(k.gt.Nblocks)k=k-Nblocks
               Do ij =-1,1
                  j =MK2 +ij
                  If(j.le.0)j=j+Nblocks
                  If(j.gt.Nblocks)j=j-Nblocks
                  Do ii =-1,1
                     i =MK1 +ii
                     If(i.le.0)i=i+Nblocks
                     If(i.gt.Nblocks)i=i-Nblocks
                     If(iMask(i,j,k).lt.kSpec)iMask(i,j,k)=kSpec ! change mask
                  ENDDO
               ENDDO
               ENDDO
            EndIf
         ENDDO
         ENDDO
         ENDDO
       Enddo 

       Do i=1,Max_lev_abs            ! count marked blocks
          nLevel(i)=0
       Enddo 
         DO  MK3 = 1,Nblocks
         DO  MK2 = 1,Nblocks
         DO  MK1 = 1,Nblocks
            iM =      iMask(MK1,MK2,MK3)
            If(iM.le.Nmax_lev.and.iM.ge.Nmin_lev)Then
               nLevel(iM) = nLevel(iM) +1 
            Else
               write (*,*) 'wrong mask: ',iM, ' block=',MK1,MK2,MK3
               write (*,*)'      it should be within limits:', 
     &                                Nmin_lev,Nmax_lev
               Stop
            EndIf
         ENDDO
         ENDDO
         ENDDO

         Ntot =0
       Do i=Max_lev_abs,1,-1
          icurrent =nLevel(i)*8**(i-1)
         Write (*,*) ' Level=',i,' Number of Blocks=',nLevel(i),
     &                   ' N_Particles=', icurrent
         Ntot = Ntot + icurrent
       Enddo   
         Write (*,*) ' Total expected particles =',Ntot
      RETURN
      END

C------------------------------------------------
C                             Make a realization of spectrum of perturbations:
C                             ALPHA  = normalization factor for displacements
C                             NRAND = seed for random numbers
C                             Lstart   = start on level Lstart (=1 or 2) 
      SUBROUTINE SPECTR(NRAND,Lstart)
C------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR2.h'
      REAL*8     SUMM, WI3,WJ3,WK3,WD,TS,TRX
c      Dimension SummA(100)
C						    Set spectrum
      If(Lstart.gt.Levels)Then
         write (*,*) ' Wrong  range of levels in SPECTR: start/total=',
     &                   Lstart,Levels
         stop
      Endif 

         write (*,*) ' range of levels in SPECTR: start/total=',
     &                   Lstart,Levels
      iRandom =INT(extras(80)+1.e-5) ! set type of Random Numbers
      write (*,*)' Random numbers=',iRandom,' (0=Randd/1=lux)'
C$omp  parallel do default(shared)
C$omp& private(MK3,MK2,MK1)
      DO  MK3 = 1,NROW
      DO  MK2 = 1,NROW
      DO  MK1 = 1,NROW
	     GRX(MK1,MK2,MK3) =0.
	     GRY(MK1,MK2,MK3) =0.
	     GRZ(MK1,MK2,MK3) =0.
      ENDDO
      ENDDO
      ENDDO
C---------------------------   first level
      If(Lstart.eq.1)Then
C$omp  parallel do default(shared)
C$omp& private(MK3,MK2,MK1)
      DO  MK3 = 1,NROW2
      DO  MK2 = 1,NROW2
      DO  MK1 = 1,NROW2
	     GRX2(MK1,MK2,MK3) =0.
	     GRY2(MK1,MK2,MK3) =0.
	     GRZ2(MK1,MK2,MK3) =0.
      ENDDO
      ENDDO
      ENDDO
         SUMM = 0.             ! set spectrum for first level
      DO  k = 1,NROW2 
         ksign = -1
         kz    = k +NSPEC2
         k3    = k - 1
         If(k3.GT.NSPEC2)k3=k3-NSPEC2
           IF(kz.gt.NROW2)THEN
              kz    =kz -NROW2
              ksign =1
           ENDIF
           WK3= K3**2
c	        write (*,*) '  K=',k,' K3=',K3,' Nspec=',NSPEC2
           DO  j = 1,NROW2
              jsign = -1
              jz    = j +NSPEC2
              j3    = j - 1
              If(j3.GT.NSPEC2)j3=j3-NSPEC2
                IF(jz.gt.NROW2)THEN
                   jz    =jz -NROW2
                   jsign =1
                ENDIF
                WJ3= j3**2
                DO  i = 1,NROW2
                   isign = -1
                   iz    = i +NSPEC2
                   i3    = i - 1
                   If(i3.GT.NSPEC2)i3=i3-NSPEC2
                     IF(iz.gt.NROW2)THEN
                        iz    =iz -NROW2
                        isign =1
                     ENDIF
                     WI3= i3**2

	       IF(i3+j3+k3.EQ.0)THEN
		         GRX2(1,1,1) = 0.
		         GRY2(1,1,1) = 0.
		         GRZ2(1,1,1) = 0.
	       ELSE
		  WD = (WI3 + WJ3 + WK3)
		  WK = SQRT(WD)
                     If(iRandom.eq.0)Then
                          TS = TRUNF(WK) * GAUSS(NRAND)
                     Else
                          TS = TRUNF(WK) * GAUSS3()
                     EndIf
		  TRX = TS / WD
	       IF(i.EQ.NSPEC2+1.or.
     &          j.EQ.NSPEC2+1.or.
     &          k.EQ.NSPEC2+1)TRX =0
		  GRX2(iz, j, k) = i3 * TRX *isign
		  GRY2(i,jz, k) = j3 * TRX *jsign
		  GRZ2(i, j,kz) = k3 * TRX *ksign
		  SUMM = SUMM + TS**2
	       ENDIF

	    ENDDO
	   ENDDO
      ENDDO
      IF(SUMM.LE.0.)WRITE (*,*) ' Error!!! Summ over spectrum = 0'
         write (*,*) ' ==== SPECTR:  SUMM=',SUMM,' Level=',Lstart
      ALPHA(Lstart) = AMPLT_CR(Lstart) / SQRT(SUMM) *sqrt(8.)
         write (*,*) ' ALPHA(Lstart)=',ALPHA(Lstart),AMPLT_CR(Lstart)
      DO  MK3 = 1,NROW2
      DO  MK2 = 1,NROW2
      DO  MK1 = 1,NROW2
	     GRX2(MK1,MK2,MK3) =GRX2(MK1,MK2,MK3)*ALPHA(Lstart) 
	     GRY2(MK1,MK2,MK3) =GRY2(MK1,MK2,MK3)*ALPHA(Lstart)
	     GRZ2(MK1,MK2,MK3) =GRZ2(MK1,MK2,MK3)*ALPHA(Lstart)
      ENDDO
      ENDDO
      ENDDO


      EndIf                                          ! end first level
C-------------------------  second level
      If(Levels.eq.1)Return
         SUMM = 0.            
      DO  k = 1,NROW 

         ksign = -1
         kz    = k +NSPEC
         k3    = k - 1
         If(k3.GT.NSPEC)k3=k3-NSPEC
           IF(kz.gt.NROW)THEN
              kz    =kz -NROW
              ksign =1
           ENDIF
           WK3= K3**2
c	        write (*,*) '  K=',k,' K3=',K3,' Nspec=',NSPEC
           DO  j = 1,NROW
              jsign = -1
              jz    = j +NSPEC
              j3    = j - 1
              If(j3.GT.NSPEC)j3=j3-NSPEC
                IF(jz.gt.NROW)THEN
                   jz    =jz -NROW
                   jsign =1
                ENDIF
                WJ3= j3**2
                DO  i = 1,NROW
                   isign = -1
                   iz    = i +NSPEC
                   i3    = i - 1
                   If(i3.GT.NSPEC)i3=i3-NSPEC
                     IF(iz.gt.NROW)THEN
                        iz    =iz -NROW
                        isign =1
                     ENDIF
                     WI3= i3**2

	       IF(i3+j3+k3.EQ.0)THEN
		         GRX(1,1,1) = 0.
		         GRY(1,1,1) = 0.
		         GRZ(1,1,1) = 0.
                     If(iRandom.eq.0)Then
                          TS =  GAUSS(NRAND)
                     Else
                          TS =  GAUSS3()
                     EndIf

	       ELSE
		  WD = (WI3 + WJ3 + WK3)
		  WK = SQRT(WD)
                     If(iRandom.eq.0)Then
                          TS = TRUNF(WK) * GAUSS(NRAND)
                     Else
                          TS = TRUNF(WK) * GAUSS3()
                     EndIf
		  TRX = TS / WD
	       IF(i.EQ.NSPEC+1.or.
     &          j.EQ.NSPEC+1.or.
     &          k.EQ.NSPEC+1)TRX =0
		  GRX(iz, j, k) = i3 * TRX *isign
		  GRY( i,jz, k) = j3 * TRX *jsign
		  GRZ( i, j,kz) = k3 * TRX *ksign
		  SUMM = SUMM + TS**2
c              write(*,'(4i5,3g12.4)')i,j,iz,jz,WD,TRX,TS/TRUNF(WK)
c                  If(k.eq.2)STOP

	       ENDIF
	    ENDDO
	   ENDDO
      ENDDO
      IF(SUMM.LE.0.)WRITE (*,*) ' Error!!! Summ over spectrum = 0'
         write (*,*) ' ==== SPECTR:  SUMM=',SUMM,' Level=',Levels

      ALPHA(Levels) = AMPLT_CR(Levels)/ SQRT(SUMM) *sqrt(8.)

      DO  MK3 = 1,NROW
      DO  MK2 = 1,NROW
      DO  MK1 = 1,NROW
	     GRX(MK1,MK2,MK3) =GRX(MK1,MK2,MK3)*ALPHA(Levels)
	     GRY(MK1,MK2,MK3) =GRY(MK1,MK2,MK3)*ALPHA(Levels)
	     GRZ(MK1,MK2,MK3) =GRZ(MK1,MK2,MK3)*ALPHA(Levels)
      ENDDO
      ENDDO
      ENDDO

c      write(50,'(12g12.4)')
c     &    (((GRX(i,j,k),i=1,NROW,2),j=1,NROW,2),k=1,NROW,2)
      RETURN
      END
C------------------------------------------------
C                             Make spectrum for Constrained Realizations
C                             
C                             
      SUBROUTINE SPectr_CR(NRAND)
C------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR2.h'
      COMMON / TRUNCOM/ Om,Omb,Omc,Omnu,Par(6),ns,qqscaleb,QSCALE
      REAL*8     SUMM, WI3,WJ3,WK3,WD,TS,TRX
      Dimension DENS_CR(NROW2,NROW2,NROW2)
C						    Set spectrum
c      R_f = 0.25/hubble           ! correction for gaussian filter; R_f
c      RR_f = QSCALE*R_f ! dimensionless gaussian radius
c      R_cor = RR_f**2/2. 
c      write (*,*) ' Apply correction for filter radius=',R_f,RR_f
 
      SUMM = 0.
      WD       =0.
      open(40,file='dens_cr.dat',status='unknown')
      read(40,*) DENS_CR
      Do k=1,NROW2
      Do j=1,NROW2
      Do i=1,NROW2
         SUMM = SUMM +dens_cr(i,j,k)
         WD   = WD   +dens_cr(i,j,k)**2
      EndDo
      EndDo
      EndDo
      sigma = sqrt(MAX(1.d-10,WD/NROW2**3))
      write (*,*) ' Average density=',SUMM/NROW2**3
      write (*,*) ' RMS density=',sigma
       IFOUR = INT(ALOG(FLOAT(NROW2))/ALOG(2.)+0.5)
       Write (*,*) ' Ifour =',IFOUR,' Nrow=',NROW2

      CALL VECTOR_dens(IFOUR,dens_cr)

C$omp  parallel do default(shared)
C$omp& private(MK3,MK2,MK1)
      DO  MK3 = 1,NROW2
      DO  MK2 = 1,NROW2
      DO  MK1 = 1,NROW2
	     GRX2(MK1,MK2,MK3) =0.
	     GRY2(MK1,MK2,MK3) =0.
	     GRZ2(MK1,MK2,MK3) =0.
      ENDDO
      ENDDO
      ENDDO

      DO  k = 1,NROW2   
         ksign = -1
         kz    = k +NSPEC2
         k3    = k - 1
         If(k3.GT.NSPEC2)k3=k3-NSPEC2
           IF(kz.gt.NROW2)THEN
              kz    =kz -NROW2
              ksign =1
           ENDIF
           WK3= K3**2
c	        write (*,*) '  K=',k,' K3=',K3,' Nspec=',NSPEC2
           DO  j = 1,NROW2
              jsign = -1
              jz    = j +NSPEC2
              j3    = j - 1
              If(j3.GT.NSPEC2)j3=j3-NSPEC2
                IF(jz.gt.NROW2)THEN
                   jz    =jz -NROW2
                   jsign =1
                ENDIF
                WJ3= j3**2
                DO  i = 1,NROW2
                   isign = -1
                   iz    = i +NSPEC2
                   i3    = i - 1
                   If(i3.GT.NSPEC2)i3=i3-NSPEC2
                     IF(iz.gt.NROW2)THEN
                        iz    =iz -NROW2
                        isign =1
                     ENDIF
                     WI3= i3**2

	       IF(i3+j3+k3.EQ.0)THEN
		         GRX2(1,1,1) = 0.
		         GRY2(1,1,1) = 0.
		         GRZ2(1,1,1) = 0.
	       ELSE
		  WD = WI3 + WJ3 + WK3
c            		  WK = SQRT(WD)
c		  TS = -dens_cr(i,j,k) * exp(WD*R_cor)
		  TS = -dens_cr(i,j,k)
		  TRX = TS / WD
	       IF(i.EQ.NSPEC2+1.or.
     &          j.EQ.NSPEC2+1.or.
     &          k.EQ.NSPEC2+1)TRX =0
		  GRX2(iz, j, k) = i3 * TRX *isign 
		  GRY2( i,jz, k) = j3 * TRX *jsign
		  GRZ2( i, j,kz) = k3 *TRX *ksign
		  SUMM = SUMM + TS**2
	       ENDIF
	    ENDDO
	   ENDDO
      ENDDO

      IF(SUMM.LE.0.)WRITE (*,*) ' Error!!! Summ over spectrum = 0'
         write (*,*) ' ==== SPECTR ===  SUMM=',SUMM
      ALPHA(1) = AMPLT_CR(1) / SQRT(SUMM) *sqrt(8.)  *1.08
       write (*,*) ' ALPHA(1) =',ALPHA(1) ,AMPLT_CR(1)
      DO  MK3 = 1,NROW2
      DO  MK2 = 1,NROW2
      DO  MK1 = 1,NROW2
	     GRX2(MK1,MK2,MK3) =GRX2(MK1,MK2,MK3)*ALPHA(1)
	     GRY2(MK1,MK2,MK3) =GRY2(MK1,MK2,MK3)*ALPHA(1)
	     GRZ2(MK1,MK2,MK3) =GRZ2(MK1,MK2,MK3)*ALPHA(1)
      ENDDO
      ENDDO
      ENDDO

      RETURN
      END
C------------------------------------------------
C                             Copy harmonics, which
C                             were included at previous level
C                             of resolution
C                             Lstart   = start on level Lstart (=1 or 2) 
      SUBROUTINE RELOCATE_SP
C------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR2.h'

c      If(Levels.lt.2)Then
c         write (*,*) ' Wrong range of levels in RELOCATE_SP: =',
c     &                   Levels
c         Return
c      Endif 
      J_cos = NROW/2 +1   ! limit for cosine harmonics
      J_sin_1 = NROW/2+2  ! limits for sin harmonics

      J2_cos = NROW2/2 +1   ! limit for cosine harmonics
      J2_sin_1 = NROW2/2+2  ! limits for sin harmonics


C$omp  parallel do default(shared)
C$omp& private(K,J,I,Ishift,Jshift,Kshift)
      DO  K = 1,NROW2
         Kshift = 0
         If(K.ge.J2_sin_1)Kshift =J_cos -J2_cos
      DO  J = 1,NROW2
         Jshift = 0
         If(J.ge.J2_sin_1)Jshift =J_cos -J2_cos
      DO  I = 1,NROW2
         Ishift = 0
         If(I.ge.J2_sin_1)Ishift =J_cos -J2_cos
	           GRX(I+Ishift,J+Jshift,K+Kshift) =GRX2(I,J,K)
	           GRY(I+Ishift,J+Jshift,K+Kshift) =GRY2(I,J,K)
	           GRZ(I+Ishift,J+Jshift,K+Kshift) =GRZ2(I,J,K)
      ENDDO
      ENDDO
      ENDDO


      RETURN
      END

C------------------------------------------------
C		                        Define coordinates and velosities for
C                                  particles with resolution = Indx
C                                  Indx =1 = high resolution
C                                  Indx =2 = medium resolution
C                                  Icurrent = number of particles
      SUBROUTINE BLOCKS(XCONS,VCONS,Indx,Icurrent)
C------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR2.h'	  
      Dimension nLevel(10)
       Do i=1, Max_lev_abs            ! number of particles at
          nLevel(i)=0                  ! different levels
       Enddo 
       Boff = Lblock/2 +0.5

c       write (*,*) ' Blocks:', Nblocks,Lblock

      QFACT = FLOAT(NGRID)/FLOAT(NROW)
        DO  MK3 = 1,Nblocks
            M3   = (MK3-1)*Lblock   ! part of offset
        DO  MK2 = 1,Nblocks
            M2   = (MK2-1)*Lblock   ! part of offset
        DO  MK1 = 1,Nblocks
            M1   = (MK1-1)*Lblock   ! part of offset
	      iM =iMask(MK1,MK2,MK3)
C----------------------------------------
c                     M1 + Boff  = lagrangian coordinate of 'mean' particle
c                     Lblock**3 = total number of averaged cells
          If(iM.eq.Indx)Then 
          If(iM.eq.1)Then  ! Low resolution: one particle
              DX =0.
              DY =0.
              DZ =0.
              kp=(M3+1 +M3+Lblock)/2
              jp=(M2+1 +M2+Lblock)/2
              ip=(M1+1 +M1+Lblock)/2
                 DX = GRX(ip,jp,kp)
                 DY = GRY(ip,jp,kp)
                 DZ = GRZ(ip,jp,kp)
                Q3    = QFACT*(kp-1.) +1. ! scale them to box size
	        Q2    = QFACT*(jp-1.) +1.
	        Q1    = QFACT*(ip-1.) +1.
               Icurrent = Icurrent +1
               If(Icurrent.gt.Nmaxpart)Then
                    write (*,*)'Too many particles:',Icurrent,' block=',
     &                                                     MK1,MK2,MK3
                    STOP
               EndIf
               nLevel(Indx) =nLevel(Indx) +1
	         XPt(Icurrent) = Q1 - XCONS*DX  + 1.E-4  +0.5 
	         YPt(Icurrent) = Q2 - XCONS*DY  + 1.E-4  +0.5
	         ZPt(Icurrent) = Q3 - XCONS*DZ  + 1.E-4  +0.5
	         VXt(Icurrent) =          VCONS*DX
	         VYt(Icurrent) =          VCONS*DY
	         VZt(Icurrent) =          VCONS*DZ

           Else
C------------------------------------------
           If(iM.eq.Max_lev_abs)Then  ! Highest resolution: 
              Do kp=M3+1,M3+Lblock 
              Do jp=M2+1,M2+Lblock 
              Do ip=M1+1,M1+Lblock 
                 DX = GRX(ip,jp,kp)     !  find displacements
                 DY = GRY(ip,jp,kp)
                 DZ = GRZ(ip,jp,kp)
                 Q3    = QFACT*(kp-1.) +1. ! scale them to box size
	           Q2    = QFACT*(jp-1.) +1.
	           Q1    = QFACT*(ip-1.) +1.
                 Icurrent = Icurrent +1
                 If(Icurrent.gt.Nmaxpart)Then
                    write (*,*)'Too many particles:',Icurrent,' block=',
     &                                                     MK1,MK2,MK3
                    STOP
                 EndIf
               nLevel(Indx) =nLevel(Indx) +1
	         XPt(Icurrent) = Q1 - XCONS*DX  + 1.E-4  +0.5 
	         YPt(Icurrent) = Q2 - XCONS*DY  + 1.E-4  +0.5
	         ZPt(Icurrent) = Q3 - XCONS*DZ  + 1.E-4  +0.5
	         VXt(Icurrent) =          VCONS*DX
	         VYt(Icurrent) =          VCONS*DY
	         VZt(Icurrent) =          VCONS*DZ
               EndDo
              EndDo
              EndDo

           Else
C-------------------------------------------
c            Medium resolution: 
c                   KBlock = 2**(iM-1)        = number of particles in 1D per block
c                   Nbcells= Lblock/KBlock = number of cells per particle
c                   (MK-1)*Lblock +(i-1)*Nbcells = offset of cells in 1D
c                   (MK-1)*Lblock +(i-1)*Nbcells +Nbcells/2 +1/2 = lagrangian
c                                                                 coordinate of particle
c                    M1   = (MK1-1)*Lbloc
              KBlock = 2**(iM-1)           ! number of particles in 1D per block
              Nbcells = Lblock/KBlock ! number of cells per particle in 1D
              Xlag     = Nbcells/2 +0.5 ! offset for lagrangian coordinates
              Nbcells3 =Nbcells**3      ! total number of cells per particle
c       write (*,*)' Lblock=',Lblock,' Nblocks=',Nblocks,
c     +                ' Npart/block/1D=',KBlock

              Do i =1,KBlock                          ! loop over particles
                 i1      =M1+(i-1)*Nbcells      ! offset for cells in X
              	  Q1  = QFACT*(i1+Xlag-1.) +1. ! scale it to box size
              Do j =1,KBlock
                 j1      =M2+(j-1)*Nbcells       ! offset for cells in X
 	              Q2  = QFACT*(j1+Xlag-1.) +1.
              Do k=1,KBlock
                 k1      =M3+(k-1)*Nbcells       ! offset for cells in X 
                 Q3    = QFACT*(k1+Xlag-1.) +1. 

                 Nncells =0
                 kp=(k1+1 +k1+Nbcells)/2 !  
                 jp=(j1+1 +j1+Nbcells)/2
                 ip=(i1+1 +i1+Nbcells)/2

                    Nncells =Nncells +1
                    If(ip.gt.NROW.or.ip.lt.1)Then
                       write (*,*) ' error'
                    endif 
                    If(jp.gt.NROW.or.jp.lt.1)Then
                       write (*,*) ' error'
                    endif 
                    If(kp.gt.NROW.or.kp.lt.1)Then
                       write (*,*) ' error'
                    endif 
                    DX = GRX(ip,jp,kp)
                    DY = GRY(ip,jp,kp)
                    DZ = GRZ(ip,jp,kp)


                 Icurrent = Icurrent +1
                 If(Icurrent.gt.Nmaxpart)Then
                    write (*,*)'Too many particles:',Icurrent,' block=',
     &                                                     MK1,MK2,MK3
                    STOP
                 EndIf
                nLevel(Indx) =nLevel(Indx) +1
	          XPt(Icurrent) = Q1 - XCONS*DX  + 1.E-4  +0.5 
	          YPt(Icurrent) = Q2 - XCONS*DY  + 1.E-4  +0.5
	          ZPt(Icurrent) = Q3 - XCONS*DZ  + 1.E-4  +0.5
	          VXt(Icurrent) =          VCONS*DX
	          VYt(Icurrent) =          VCONS*DY
	          VZt(Icurrent) =          VCONS*DZ
             EndDo
             EndDo
             EndDo
           EndIf
           EndIf

      EndIf         ! end iM = Indx 
      EndDo
      EndDo
      EndDo
      If(nLevel(indx).gt.0)Then
               Nspecies = Nspecies +1
                lspecies(Nspecies)   =Icurrent
                wspecies(Nspecies) =PARTW*
     &                                        Lblock**3/8**(Indx-1)
      endif 
      write(*,'(" Species=",i3," Particles=",i11," on levels=",10i11)')
     &       Nspecies,Icurrent,(nLevel(i),i=1,Max_lev_abs)

      RETURN
      END

C------------------------------------------------
C		                        Define coordinates and velosities for
C                                  particles with resolution = Indx
C                                  Indx =1 = high resolution
C                                  Indx =2 = medium resolution
C                                  Icurrent = number of particles
      SUBROUTINE BLOCKSaver(XCONS,VCONS,Indx,Icurrent)
C------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR2.h'	  
      Dimension nLevel(10)
       Do i=1, Max_lev_abs            ! number of particles at
          nLevel(i)=0                  ! different levels
       Enddo 
       Boff = Lblock/2 +0.5

c       write (*,*) ' Blocks:', Nblocks,Lblock

      QFACT = FLOAT(NGRID)/FLOAT(NROW)
        DO  MK3 = 1,Nblocks
            M3   = (MK3-1)*Lblock   ! part of offset
        DO  MK2 = 1,Nblocks
            M2   = (MK2-1)*Lblock   ! part of offset
        DO  MK1 = 1,Nblocks
            M1   = (MK1-1)*Lblock   ! part of offset
	      iM =iMask(MK1,MK2,MK3)
C----------------------------------------
c                     M1 + Boff  = lagrangian coordinate of 'mean' particle
c                     Lblock**3 = total number of averaged cells
          If(iM.eq.Indx)Then 
          If(iM.eq.1)Then  ! Low resolution: one particle
              DX =0.
              DY =0.
              DZ =0.
              Do kp=M3+1,M3+Lblock   !  sum of displacements
              Do jp=M2+1,M2+Lblock
              Do ip=M1+1,M1+Lblock
                 DX = DX +GRX(ip,jp,kp)
                 DY = DY +GRY(ip,jp,kp)
                 DZ = DZ +GRZ(ip,jp,kp)
              EndDo
              EndDo
              EndDo
              DX = DX/Lblock**3               ! mean displacement
              DY = DY/Lblock**3
              DZ = DZ/Lblock**3
              Q3    = QFACT*(M3+Boff-1.) +1. ! scale them to box size
	        Q2    = QFACT*(M2+Boff-1.) +1.
	        Q1    = QFACT*(M1+Boff-1.) +1.
               Icurrent = Icurrent +1
               If(Icurrent.gt.Nmaxpart)Then
                    write (*,*)'Too many particles:',Icurrent,' block=',
     &                                                     MK1,MK2,MK3
                    STOP
               EndIf
               nLevel(Indx) =nLevel(Indx) +1
	         XPt(Icurrent) = Q1 - XCONS*DX  + 1.E-4  +0.5 
	         YPt(Icurrent) = Q2 - XCONS*DY  + 1.E-4  +0.5
	         ZPt(Icurrent) = Q3 - XCONS*DZ  + 1.E-4  +0.5
	         VXt(Icurrent) =          VCONS*DX
	         VYt(Icurrent) =          VCONS*DY
	         VZt(Icurrent) =          VCONS*DZ

           Else
C------------------------------------------
           If(iM.eq.Max_lev_abs)Then  ! Highest resolution: 
              Do kp=M3+1,M3+Lblock 
              Do jp=M2+1,M2+Lblock 
              Do ip=M1+1,M1+Lblock 
                 DX = GRX(ip,jp,kp)     !  find displacements
                 DY = GRY(ip,jp,kp)
                 DZ = GRZ(ip,jp,kp)
                 Q3    = QFACT*(kp-1.) +1. ! scale them to box size
	           Q2    = QFACT*(jp-1.) +1.
	           Q1    = QFACT*(ip-1.) +1.
                 Icurrent = Icurrent +1
                 If(Icurrent.gt.Nmaxpart)Then
                    write (*,*)'Too many particles:',Icurrent,' block=',
     &                                                     MK1,MK2,MK3
                    STOP
                 EndIf
               nLevel(Indx) =nLevel(Indx) +1
	         XPt(Icurrent) = Q1 - XCONS*DX  + 1.E-4  +0.5 
	         YPt(Icurrent) = Q2 - XCONS*DY  + 1.E-4  +0.5
	         ZPt(Icurrent) = Q3 - XCONS*DZ  + 1.E-4  +0.5
	         VXt(Icurrent) =          VCONS*DX
	         VYt(Icurrent) =          VCONS*DY
	         VZt(Icurrent) =          VCONS*DZ
               EndDo
              EndDo
              EndDo

           Else
C-------------------------------------------
c            Medium resolution: 
c                   KBlock = 2**(iM-1)        = number of particles in 1D per block
c                   Nbcells= Lblock/KBlock = number of cells per particle
c                   (MK-1)*Lblock +(i-1)*Nbcells = offset of cells in 1D
c                   (MK-1)*Lblock +(i-1)*Nbcells +Nbcells/2 +1/2 = lagrangian
c                                                                 coordinate of particle
c                    M1   = (MK1-1)*Lbloc
              KBlock = 2**(iM-1)           ! number of particles in 1D per block
              Nbcells = Lblock/KBlock ! number of cells per particle in 1D
              Xlag     = Nbcells/2 +0.5 ! offset for lagrangian coordinates
              Nbcells3 =Nbcells**3      ! total number of cells per particle
c       write (*,*)' Lblock=',Lblock,' Nblocks=',Nblocks,
c     +                ' Npart/block/1D=',KBlock

              Do i =1,KBlock                          ! loop over particles
                 i1      =M1+(i-1)*Nbcells      ! offset for cells in X
              	  Q1  = QFACT*(i1+Xlag-1.) +1. ! scale it to box size
              Do j =1,KBlock
                 j1      =M2+(j-1)*Nbcells       ! offset for cells in X
 	              Q2  = QFACT*(j1+Xlag-1.) +1.
              Do k=1,KBlock
                 k1      =M3+(k-1)*Nbcells       ! offset for cells in X 
                 Q3    = QFACT*(k1+Xlag-1.) +1. 
                 DX =0.
                 DY =0.
                 DZ =0.
                 Nncells =0
                 Do  kp=k1+1,k1+Nbcells !  sum of displacements
                 Do  jp=j1+1,j1+Nbcells
                 Do  ip=i1+1,i1+Nbcells
                    Nncells =Nncells +1
                    If(ip.gt.NROW.or.ip.lt.1)Then
                       write (*,*) ' error'
                    endif 
                    If(jp.gt.NROW.or.jp.lt.1)Then
                       write (*,*) ' error'
                    endif 
                    If(kp.gt.NROW.or.kp.lt.1)Then
                       write (*,*) ' error'
                    endif 
                    DX = DX +GRX(ip,jp,kp)
                    DY = DY +GRY(ip,jp,kp)
                    DZ = DZ +GRZ(ip,jp,kp)
                 EndDo
                 EndDo
                 EndDo
                 DX = DX/ Nbcells3              ! mean displacement
                 DY = DY/ Nbcells3
                 DZ = DZ/ Nbcells3
                    If(Nncells.ne.Nbcells3)Then
                       write (*,*) ' error: wrong number of cells=',
     +                      Nncells,Nbcells3
                       stop
                    endif 

                 Icurrent = Icurrent +1
                 If(Icurrent.gt.Nmaxpart)Then
                    write (*,*)'Too many particles:',Icurrent,' block=',
     &                                                     MK1,MK2,MK3
                    STOP
                 EndIf
                nLevel(Indx) =nLevel(Indx) +1
	          XPt(Icurrent) = Q1 - XCONS*DX  + 1.E-4  +0.5 
	          YPt(Icurrent) = Q2 - XCONS*DY  + 1.E-4  +0.5
	          ZPt(Icurrent) = Q3 - XCONS*DZ  + 1.E-4  +0.5
	          VXt(Icurrent) =          VCONS*DX
	          VYt(Icurrent) =          VCONS*DY
	          VZt(Icurrent) =          VCONS*DZ
             EndDo
             EndDo
             EndDo
           EndIf
           EndIf

      EndIf         ! end iM = Indx 
      EndDo
      EndDo
      EndDo
      If(nLevel(indx).gt.0)Then
               Nspecies = Nspecies +1
                lspecies(Nspecies)   =Icurrent
                wspecies(Nspecies) =PARTW*
     &                                        Lblock**3/8**(Indx-1)
      endif 
      write(*,'(" Species=",i3," Particles=",i11," on levels=",10i11)')
     &       Nspecies,Icurrent,(nLevel(i),i=1,Max_lev_abs)

      RETURN
      END

C------------------------------------------------
      SUBROUTINE SETtest(K,NRAND)
C  place particles with small velocities in a sphere 
C  Radius = radius of the sphere in zero-level cell units
C  Xcentr  = position of the sphere
C  
C------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR2.h'	  
      COMMON / KINENRG/ SKINE,SX,SY,SZ,SX2,SY2,SZ2


      QFACT = FLOAT(NGRID)/FLOAT(NROW)
      XMAX  = FLOAT(NGRID) + 1.
      XSHF  = FLOAT(NGRID)
      Xcentr  = NGRID/2.
      Vss       =1.
      Radius = 5.
      write (*,*) ' Xcentr=',Xcentr
      DO  J = 1,NROW
	   DO  I = 1,NROW
            IJ    =      I +(J-1)*NROW
	      DX	      =      Radius*(2.*RANDd(NRAND)-1.)
	      DY	      =      Radius*(2.*RANDd(NRAND)-1.)
	      DZ	      =      Radius*(2.*RANDd(NRAND)-1.)
c	      DX	      =      0.05*I
c	      DY	      =      0.05*J
c	      DZ	      =      0.05*K
C           the factor 0.5 in the following 3 lines places unperturbed
c           particle in the middle of a cell. This reduces the shot noise
C          Small number 1.E-4 is to avoid placing some particles
C          exactly in cell nodes. Does not make much differentce.
	      XPAR(IJ) = Xcentr+ DX    + 1.E-4  +0.5 
	      YPAR(IJ) = Xcentr+ DY    + 1.E-4  +0.5 
	      ZPAR(IJ) = Xcentr+ DZ    + 1.E-4  +0.5 
	      VX(IJ)   =      Vss*GAUSS(NRAND)
	      VY(IJ)   =      Vss*GAUSS(NRAND)
	      VZ(IJ)   =      Vss*GAUSS(NRAND)
C                                Periodical boundary conditions
	       IF(XPAR(IJ).GT.XMAX)	XPAR(IJ)=XPAR(IJ)-XSHF
	       IF(XPAR(IJ).LE.1.)	XPAR(IJ)=XPAR(IJ)+XSHF
	       IF(YPAR(IJ).GT.XMAX)	YPAR(IJ)=YPAR(IJ)-XSHF
	       IF(YPAR(IJ).LE.1.)	YPAR(IJ)=YPAR(IJ)+XSHF
	       IF(ZPAR(IJ).GT.XMAX)	ZPAR(IJ)=ZPAR(IJ)-XSHF
	       IF(ZPAR(IJ).LE.1.)	ZPAR(IJ)=ZPAR(IJ)+XSHF
	      SX	      = SX    + DX
	      SY	      = SY    + DY
	      SZ	      = SZ    + DZ
	      SX2      = SX2   + DX**2
	      SY2      = SY2   + DY**2
	      SZ2      = SZ2   + DZ**2
	      SKINE    = SKINE + VX(IJ)**2 +VY(IJ)**2 +VZ(IJ)**2
	   ENDDO
      ENDDO
      RETURN
      END
C------------------------------------------------
C		                        Define coordinates and velosities for
C		                        all particles of current row (given q2)
C			                       x = q - amplt*b(t)/b(t0)*S(q1,q2)
C			                       momentum = a**2*deriv x
C                     
C		                        Twidled variables:
C		                        x= q - {1/(2 pi Ngrid)}{Alpha*a(t)/a(0)}*S
C		                        P=	- {1/(2 pi Ngrid)}{Alpha*a(t)**1.5/a(0)}*S
C                     
C		                        q(i) = Ngrid/Nrow*(i-1) + 1
C		                        x = q - xcons*S
C		                        P =	   vcons*S
      SUBROUTINE SETXV(XCONS1,VCONS1,K)
C------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR2.h'	  
      COMMON / KINENRG/ SKINE,SX,SY,SZ,SX2,SY2,SZ2

      QFACT = FLOAT(NGRID)/FLOAT(NROW)
      XMAX  = FLOAT(NGRID) + 1.
      XSHF  = FLOAT(NGRID)
      Q3    = QFACT*(K-1.) +1.
      DO  J = 1,NROW
	      Q2 = QFACT*(J-1.) +1.
	   DO  I = 1,NROW
	      Q1 = QFACT*(I-1.) +1.
            IJ    =      I +(J-1)*NROW
	      DX	      =      XCONS1*GRX(I,J,K)
	      DY	      =      XCONS1*GRY(I,J,K)
	      DZ	      =      XCONS1*GRZ(I,J,K)
C           the factor 0.5 in the following 3 lines places unperturbed
c           particle in the middle of a cell. This reduces the shot noise
C          Small number 1.E-4 is to avoid placing some particles
C          exactly in cell nodes. Does not make much differentce.
	      XPAR(IJ) = Q1 - DX    + 1.E-4  +0.5 
	      YPAR(IJ) = Q2 - DY    + 1.E-4  +0.5
	      ZPAR(IJ) = Q3 - DZ    + 1.E-4  +0.5
	      VX(IJ)   =      VCONS1*GRX(I,J,K)
	      VY(IJ)   =      VCONS1*GRY(I,J,K)
	      VZ(IJ)   =      VCONS1*GRZ(I,J,K)
C                                Periodical boundary conditions
	       IF(XPAR(IJ).GT.XMAX)	XPAR(IJ)=XPAR(IJ)-XSHF
	       IF(XPAR(IJ).LE.1.)	XPAR(IJ)=XPAR(IJ)+XSHF
	       IF(YPAR(IJ).GT.XMAX)	YPAR(IJ)=YPAR(IJ)-XSHF
	       IF(YPAR(IJ).LE.1.)	YPAR(IJ)=YPAR(IJ)+XSHF
	       IF(ZPAR(IJ).GT.XMAX)	ZPAR(IJ)=ZPAR(IJ)-XSHF
	       IF(ZPAR(IJ).LE.1.)	ZPAR(IJ)=ZPAR(IJ)+XSHF
	      SX	      = SX    + DX
	      SY	      = SY    + DY
	      SZ	      = SZ    + DZ
	      SX2      = SX2   + DX**2
	      SY2      = SY2   + DY**2
	      SZ2      = SZ2   + DZ**2
	      SKINE    = SKINE + VX(IJ)**2 +VY(IJ)**2 +VZ(IJ)**2
	   ENDDO
      ENDDO
      RETURN
      END
C------------------------------------------------
C                                              				   FFT of the spectrum
      SUBROUTINE VECTOR_dens(IFOUR,dens_cr)
C------------------------------------------------
      INCLUDE 'PMparameters.h'	  
      INCLUDE 'PMinitialCR2.h'	  
      dimension Uf(marr) , Vf(marr)
      dimension Qi(mf67) , jndx(mf67),dens_cr(NROW2,NROW2,NROW2)

      jb1 =3
      jq   =IFOUR
      CALL SETF67(jb1,jq,jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

      write (*,*) ' SETF67 is done'
C				       x-component
C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO K=1,NROW2
	   DO J=1,NROW2
	    DO I=1,NROW2
	       Uf(I) =dens_cr(I,J,K)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO I=1,NROW2
	       dens_cr(I,J,K) = Vf(I)
	    ENDDO
	   ENDDO
      ENDDO
      write (*,*) ' 1st is done'

C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO K=1,NROW2
	   DO I=1,NROW2
	    DO J=1,NROW2
	       Uf(J) =dens_cr(I,J,K)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO J=1,NROW2
	       dens_cr(I,J,K) = Vf(J)
	    ENDDO
	   ENDDO
      ENDDO

C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO J=1,NROW2
	   DO I=1,NROW2
	    DO K=1,NROW2
	       Uf(K) =dens_cr(I,J,K)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO K=1,NROW2
	       dens_cr(I,J,K) = Vf(K)/8.
	    ENDDO
	   ENDDO
      ENDDO
				       write (*,*) ' dens_cr is done'
                                       Return
                                       END
C------------------------------------------------
C                                              				   FFT of the spectrum
      SUBROUTINE VECTOR
C------------------------------------------------
      INCLUDE 'PMparameters.h'	  
      INCLUDE 'PMinitialCR2.h'	  
      dimension Uf(marr) , Vf(marr)
      dimension Qi(mf67) , jndx(mf67)

        IFOUR = INT(ALOG(FLOAT(NROW))/ALOG(2.)+0.5)
        jb1 =4
        jq   =IFOUR
        CALL SETF67(jb1,jq,jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

 
C				       x-component
C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO K=1,NROW
	   DO J=1,NROW
	    DO I=1,NROW
	       Uf(I) =GRX(I,J,K)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO I=1,NROW
	       GRX(I,J,K) = Vf(I)
	    ENDDO
	   ENDDO
      ENDDO
      write (*,*) ' 1st is done Level='
C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO K=1,NROW
	   DO I=1,NROW
	    DO J=1,NROW
	       Uf(J) =GRX(I,J,K)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO J=1,NROW
	       GRX(I,J,K) = Vf(J)
	    ENDDO
	   ENDDO
      ENDDO
C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO J=1,NROW
	   DO I=1,NROW
	    DO K=1,NROW
	       Uf(K) =GRX(I,J,K)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO K=1,NROW
	       GRX(I,J,K) = Vf(K)/8.
	    ENDDO
	   ENDDO
      ENDDO
				       write (*,*) ' x is done '
C				       Y-component
C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO K=1,NROW
	   DO J=1,NROW
	    DO I=1,NROW
	       Uf(I) =GRY(I,J,K)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO I=1,NROW
	       GRY(I,J,K) = Vf(I)
	    ENDDO
	   ENDDO
      ENDDO

C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO K=1,NROW
	   DO I=1,NROW
	    DO J=1,NROW
	       Uf(J) =GRY(I,J,K)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO J=1,NROW
	       GRY(I,J,K) = Vf(J)
	    ENDDO
	   ENDDO
      ENDDO

C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO J=1,NROW
	   DO I=1,NROW
	    DO K=1,NROW
	       Uf(K) =GRY(I,J,K)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO K=1,NROW
	       GRY(I,J,K) = Vf(K)/8.
	    ENDDO
	   ENDDO
      ENDDO
				       write (*,*) ' y is done'
C				       Z-component
C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO K=1,NROW
	   DO J=1,NROW
	    DO I=1,NROW
	       Uf(I) =GRZ(I,J,K)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO I=1,NROW
	       GRZ(I,J,K) = Vf(I)
	    ENDDO
	   ENDDO
      ENDDO

C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO K=1,NROW
	   DO I=1,NROW
	    DO J=1,NROW
	       Uf(J) =GRZ(I,J,K)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO J=1,NROW
	       GRZ(I,J,K) = Vf(J)
	    ENDDO
	   ENDDO
      ENDDO

C$omp  parallel do default(shared)
C$omp& private(k,j,i,Uf,Vf,jp,jsl,ll1,k2,k4 )
      DO J=1,NROW
	   DO I=1,NROW
	    DO K=1,NROW
	       Uf(K) =GRZ(I,J,K)
	    ENDDO
	    CALL FOUR67(jb1,jq,jp,jsl,ll1,k2,k7,Qi,jndx,Uf,Vf)
	    DO K=1,NROW
	       GRZ(I,J,K) = Vf(K)/8.
	    ENDDO
	   ENDDO
      ENDDO
	   write (*,*) ' z is done'
      RETURN
      END
C------------------------------------------
c                      Rearange species so that the highest resolution
c                                                      is fisrt, lowest resolution - last.
c                                                     Print statistics of spicies
      Subroutine Species_Change(Wtotal)
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR2.h'	  

           write (*,300)Nspecies
           write (16,300)Nspecies
 300       format('--- New number of species=',i3,/
     &          3x,'Specie',2x,
     +          'Nparticles Ntotal  Weight/part Weight_Total ')
 310       format(T5,i3,T13,i11,T26,i11,T40,2g10.3)
           Wtotal =0.
           Do i=1,Nspecies
              If(i.eq.1)Then
              Wtotal =wspecies(i)*lspecies(i)
              write (*,310)i,lspecies(i),lspecies(i),wspecies(i),Wtotal
              write (16,310)i,lspecies(i),lspecies(i),wspecies(i),Wtotal
              Else
                 ww =wspecies(i)* (lspecies(i)-lspecies(i-1))
              write (*,310) i,lspecies(i)-lspecies(i-1),
     &                           lspecies(i),wspecies(i),ww
              write (16,310) i,lspecies(i)-lspecies(i-1),
     &                           lspecies(i),wspecies(i),ww
                  Wtotal =Wtotal + ww
              Endif 
           Enddo 
           write (*,*) ' Total weight =',Wtotal

       Return
       End

C---------------------------------------------------
C                                  Read  current data from disk/tape,
C                                  Open files
C                                  Nrecl is the number of values in a record
C                                  Npage is the number of particles in a page
      SUBROUTINE RDTAPE
C---------------------------------------------------
      INCLUDE 'PMparameters.h'
      Character  Hd*5,Tail*4,Nm*40
      Hd  ='PMcrs'
      Tail='.DAT'
C                                     Open file on a tape
      OPEN(UNIT=9,FILE='PMcrd.DAT',
     +                FORM='UNFORMATTED', STATUS='UNKNOWN')
C                                 Read control information
C                                 and see whether it has proper
C                                 structure
      READ  (9,err=10,end=10) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  TINTG,EKIN,EKIN1,EKIN2,AU0,AEU0,
     +                  NROWC,NGRIDC,Nspecies,Nseed,Om0,Oml0,hubble,Wp5
     +                   ,Ocurv,extras
      Ocurv =0.
      WRITE (*,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,EKIN1,EKIN2,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
      WRITE (16,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,EKIN1,EKIN2,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
100   FORMAT(1X,'Header=>',A45,/
     +            1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',3E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I6,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3)
      IF(NROW.NE.NROWC) THEN
         WRITE (*,*)
     +            ' NROW in PARAMETER and in TAPE-FILE are different'
      ENDIF
      IF(NGRID.NE.NGRIDC) THEN
         WRITE (*,*)
     +           ' NGRID in PARAMETER and in TAPE-FILE are different:'
         write (*,*) ' Ngrid=',NGRID,' NgridC=',NGRIDC
      ENDIF
C                                         Open work file on disk
 10   NBYTE = NRECL*4
      NACCES= NBYTE  / nbyteword

      OPEN(UNIT=21,FILE='PMcrs0.DAT',ACCESS='DIRECT',
     +	               STATUS='UNKNOWN',RECL=NACCES)

 
      REWIND 9
      RETURN
      END
C---------------------------------------------
C                       Write current data to  disk/tape
C
      SUBROUTINE WRTAPE
C----------------------------------------------
      INCLUDE 'PMparameters.h'
C                                       write header and control data
      WRITE (9) HEADER,
     +           AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +           TINTG,EKIN,EKIN1,EKIN2,AU0,AEU0,
     +           NROWC,NGRIDC,Nspecies,Nseed,Om0,Oml0,hubble,Wp5,
     +           Ocurv,extras
      REWIND 9
      RETURN
      END
C--------------------------------------------------
C                             Write current PAGE of particles (x,v) to disk
C                             NRECL - length of ROW block in words
      SUBROUTINE WRIROW(IROW,Ifile)
C--------------------------------------------------
      INCLUDE 'PMparameters.h'
        WRITE (20+Ifile,REC=IROW) RECDAT
      RETURN
      END
cC--------------------------------------------------
cC                             Set Weights of particles for
cC                             fast access
c      SUBROUTINE SetWeight
cC--------------------------------------------------
c      INCLUDE 'PMparameters.h'
c      If(Nspecies.eq.0)Then  ! old  constant weights
c         N_particles =lspecies(1)
c         Do i=1,N_particles
c            iWeight(i) =PARTW
c         EndDo
c      Else
c         N_particles =lspecies(Nspecies)
c         jstart =1
c         Do j=1,Nspecies
c            jend =lspecies(j)
c            Do k=jstart ,jend
c               iWeight(k) =wspecies(j)
c            EndDo
c            jstart =jend
c         EndDo
c      EndIf
c      write (*,*) ' Set Weights for ',N_particles,' particles'
c      RETURN
c      END
C--------------------------------------------
C                            Read current PAGE of particles  from disk
C                            NRECL - length of ROW block in words
      SUBROUTINE GETROW(IROW,Ifile)
C--------------------------------------------
      INCLUDE 'PMparameters.h'
         READ  (20+Ifile,REC=IROW) RECDAT
      RETURN
      END
C------------------------------------------------
C				                                       random number generator
      FUNCTION RANDd(M)
C------------------------------------------------
      DATA LC,AM,KI,K1,K2,K3,K4,L1,L2,L3,L4
     +	/453815927,2147483648.,2147483647,536870912,131072,256,
     +	 16777216,4,16384,8388608,128/
      ML=M/K1*K1
      M1=(M-ML)*L1
      ML=M/K2*K2
      M2=(M-ML)*L2
      ML=M/K3*K3
      M3=(M-ML)*L3
      ML=M/K4*K4
      M4=(M-ML)*L4
      M5=KI-M
      IF(M1.GE.M5)M1=M1-KI-1
      ML=M+M1
      M5=KI-ML
      IF(M2.GE.M5)M2=M2-KI-1
      ML=ML+M2
      M5=KI-ML
      IF(M3.GE.M5)M3=M3-KI-1
      ML=ML+M3
      M5=KI-ML
      IF(M4.GE.M5)M4=M4-KI-1
      ML=ML+M4
      M5=KI-ML
      IF(LC.GE.M5)ML=ML-KI-1
      M=ML+LC
      RANDd=M/AM
      RETURN
      END
C--------------------------------------
C				normal random numbers
      FUNCTION GAUSS(M)
C--------------------------------------
      X=0.
      DO  I=1,5
         X=X+RANDd(M)
      EndDo
      X2   =1.5491933*(X-2.5)
      GAUSS=X2*(1.-0.01*(3.-X2*X2))
      RETURN
      END
C--------------------------------------
C		normal random numbers
      FUNCTION GAUSS3()
C                        Uses ranlux for homogenous rand numbers   
C                        Uses Box-Muller inversion for gaussian
C                 Excellent quality and speed
c  N=       100000000  GAUSS3+ranlux ------
c  sigma= 0.99997     mean= 0.18692E-03
c  sigma Frac(>sig) Frac(<-sig)   True       n(>)    n(<)
c  1.00 0.1587     0.1586     0.1587     15869095 15857724
c  1.50 0.6682E-01 0.6680E-01 0.6681E-01  6681652  6679768
c  2.00 0.2277E-01 0.2273E-01 0.2275E-01  2276651  2273197
c  2.50 0.6222E-02 0.6206E-02 0.6210E-02   622190   620610
c  3.00 0.1356E-02 0.1347E-02 0.1350E-02   135628   134674
c  4.00 0.3242E-04 0.3145E-04 0.3170E-04     3242     3145
c
C--------------------------------------
      DIMENSION RanNum(2) 
      DATA iFlag/0/
      SAVE gSet
      If(iFlag.eq.0)Then
 1       CALL ranlux(RanNum,2)
         x1 = 2.*RanNum(1)-1.
         x2 = 2.*RanNum(2)-1.
         R =x1**2+x2**2
         If(R.ge.1.)GoTo 1
         F =sqrt(-2.*LOG(R)/R)
         gSet    = x1*F
         GAUSS3 = x2*F
         iFlag = 1
      Else
         GAUSS3 = gSet
         iFlag = 0
      EndIf 
      RETURN
      END


c-------------------------------------------------------------------- 
            
!   LUXURY LEVELS.
!  level 0  (p=24): equivalent to the original RCARRY of Marsaglia
!           and Zaman, very long period, but fails many tests.
!  level 1  (p=48): considerable improvement in quality over level 0,
!           now passes the gap test, but still fails spectral test.
!  level 2  (p=97): passes all known tests, but theoretically still
!           defective.
!  level 3  (p=223): DEFAULT VALUE.  Any theoretically possible
!           correlations have very small chance of being observed.
!  level 4  (p=389): highest possible luxury, all 24 bits chaotic.
c---------------------------------------------
      SUBROUTINE ranlux(rvec, lenv)
c                    returns a vector RVEC of LEN   
c                   32-bit random floating point numbers between 
c                   zero (not included) and one (also not incl.).
c           Next call to ranlux gives next LEN of random numbers
c---------------------------------------------
      INTEGER  lenv
      REAL        rvec(lenv)
      INTEGER  iseeds(24)
      INCLUDE 'luxury.h'
      DATA ndskip/ 0, 24, 73, 199, 365 /
      DATA i24,j24,luxlev/24,10,lxdflt/
      DATA notyet/.true./
      DATA in24,kount,mkount,carry/0,0,0,0./


!  NOTYET is .TRUE. if no initialization has been performed yet.
!              Default Initialization by Multiplicative Congruential

      IF (notyet) THEN
        notyet = .false.
        jseed = jsdflt
        inseed = jseed
        WRITE (6,'(A,I12)') ' RANLUX DEFAULT INITIALIZATION: ', jseed
        luxlev = lxdflt
        nskip = ndskip(luxlev)
        lp = nskip + 24
        in24 = 0
        kount = 0
        mkount = 0
      WRITE (6,'(A,I2,A,I4)') ' RANLUX DEFAULT LUXURY LEVEL= ', luxlev,   
     &                            '    p =', lp
      twom24 = 1.
        DO i = 1, 24
          twom24 = twom24 * 0.5
          k = jseed / 53668
          jseed = 40014 * (jseed-k*53668) - k * 12211
          IF (jseed.LT.0) jseed = jseed + icons
          iseeds(i) = MOD(jseed,itwo24)
        END DO
        twom12 = twom24 * 4096.
        DO i = 1, 24
          seeds(i) = REAL(iseeds(i)) * twom24
          next(i) = i - 1
        END DO
        next(1) = 24
        i24 = 24
        j24 = 10
        carry = 0.
        IF (seeds(24).EQ.0.) carry = twom24
      END IF

!          The Generator proper: "Subtract-with-borrow",
!          as proposed by Marsaglia and Zaman,
!          Florida State University, March, 1989

      DO ivec = 1, lenv
        uni = seeds(j24) - seeds(i24) - carry
        IF (uni.LT.0.) THEN
          uni = uni + 1.0
          carry = twom24
        ELSE
          carry = 0.
        END IF
        seeds(i24) = uni
        i24 = next(i24)
        j24 = next(j24)
        rvec(ivec) = uni
      !  small numbers (with less than 12 "significant" bits) are "padded".
        IF (uni.LT.twom12) THEN
          rvec(ivec) = rvec(ivec) + twom24 * seeds(j24)
      !        and zero is forbidden in case someone takes a logarithm
          IF (rvec(ivec).EQ.0.) rvec(ivec) = twom24 * twom24
        END IF
      !        Skipping to luxury.  As proposed by Martin Luscher.
        in24 = in24 + 1
        IF (in24.EQ.24) THEN
          in24 = 0
          kount = kount + nskip
          DO isk = 1, nskip
            uni = seeds(j24) - seeds(i24) - carry
            IF (uni.LT.0.) THEN
              uni = uni + 1.0
              carry = twom24
            ELSE
              carry = 0.
            END IF
            seeds(i24) = uni
            i24 = next(i24)
            j24 = next(j24)
          END DO
        END IF
      END DO
      kount = kount + lenv
      IF (kount.GE.igiga) THEN
        mkount = mkount + 1
        kount = kount - igiga
      END IF
      RETURN

      END ! SUBROUTINE ranlux

c---------------------------------------------
c                    Subroutine to initialize from one or three integers
      SUBROUTINE rluxgo(lux, ins, k1, k2)
c                initializes the generator from  
c               one 32-bit integer INT and sets Luxury Level LUX
c               which is integer between zero and MAXLEV, or if
c               LUX .GT. 24, it sets p=LUX directly.  K1 and K2
c               should be set to zero unless restarting at a break
c               point given by output of RLUXAT
c---------------------------------------------
      INCLUDE 'luxury.h'
      INTEGER  iseeds(24)
      
      IF (lux.LT.0) THEN
        luxlev = lxdflt
      ELSE IF (lux.LE.maxlev) THEN
        luxlev = lux
      ELSE IF (lux.LT.24.OR.lux.GT.2000) THEN
        luxlev = maxlev
        WRITE (6,'(A,I7)') ' RANLUX ILLEGAL LUXURY RLUXGO: ', lux
      ELSE
        luxlev = lux
        DO ilx = 0, maxlev
          IF (lux.EQ.ndskip(ilx)+24) luxlev = ilx
        END DO
      END IF
      IF (luxlev.LE.maxlev) THEN
        nskip = ndskip(luxlev)
        WRITE (6,'(A,I2,A,I4)') ' RANLUX LUXURY LEVEL SET BY RLUXGO :',
     &              luxlev,'     P=', nskip + 24
      ELSE
        nskip = luxlev - 24
        WRITE (6,'(A,I5)') ' RANLUX P-VALUE SET BY RLUXGO TO:', luxlev
      END IF
      in24 = 0
      IF (ins.LT.0) WRITE (6,'(A)')
     &        ' Illegal initialization by RLUXGO, negative input seed'
      IF (ins.GT.0) THEN
        jseed = ins
        WRITE (6,'(A,3I12)')' RANLUX INITIALIZED BY RLUXGO FROM SEEDS',
     &                                    jseed, k1, k2
      ELSE
        jseed = jsdflt
       WRITE (6,'(A)')' RANLUX INITIALIZED BY RLUXGO FROM DEFAULT SEED'
      END IF
      inseed = jseed
      notyet = .false.
      twom24 = 1.
      DO i = 1, 24
        twom24 = twom24 * 0.5
        k = jseed / 53668
        jseed = 40014 * (jseed-k*53668) - k * 12211
        IF (jseed.LT.0) jseed = jseed + icons
        iseeds(i) = MOD(jseed,itwo24)
      END DO
      twom12 = twom24 * 4096.
      DO i = 1, 24
        seeds(i) = REAL(iseeds(i)) * twom24
        next(i) = i - 1
      END DO
      next(1) = 24
      i24 = 24
      j24 = 10
      carry = 0.
      IF (seeds(24).EQ.0.) carry = twom24
      !        If restarting at a break point, skip K1 + IGIGA*K2
      !        Note that this is the number of numbers delivered to
      !        the user PLUS the number skipped (if luxury .GT. 0).
      kount = k1
      mkount = k2
      IF (k1+k2.NE.0) THEN
        DO iouter = 1, k2 + 1
          inner = igiga
          IF (iouter.EQ.k2+1) inner = k1
          DO isk = 1, inner
            uni = seeds(j24) - seeds(i24) - carry
            IF (uni.LT.0.) THEN
              uni = uni + 1.0
              carry = twom24
            ELSE
              carry = 0.
            END IF
            seeds(i24) = uni
            i24 = next(i24)
            j24 = next(j24)
          END DO
        END DO
      !         Get the right value of IN24 by direct calculation
        in24 = MOD(kount,nskip+24)
        IF (mkount.GT.0) THEN
          izip = MOD(igiga, nskip+24)
          izip2 = mkount * izip + in24
          in24 = MOD(izip2, nskip+24)
        END IF
      !       Now IN24 had better be between zero and 23 inclusive
        IF (in24.GT.23) THEN
          WRITE (6,'(A/A,3I11,A,I5)') 
     &       '  Error in RESTARTING with RLUXGO:', '  The values', ins, 
     &                k1, k2, ' cannot occur at luxury level', luxlev
          in24 = 0
        END IF
      END IF
      RETURN
      
      END ! SUBROUTINE rluxgo


C---------------------------------- Read in variables      
      REAL FUNCTION INPUT(text)
C------------------------------------------------
      Character text*(*)
          write (*,'(A,$)')text
          read (*,*) x
          INPUT =x
      Return
      End
C--------------------------------------   Fourier Transform
      SUBROUTINE SETF67(JBC1,JQ1,jbc,jp,jsl,ll1,k2,k3,k4,k7,
     &                  Qi,jndx,Uf,Vf)
c     -----------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR2.h'	  

      dimension Uf(marr) , Vf(marr)
      dimension Qi(mf67) , jndx(mf67)

      PI=DATAN(1.D0)*4.
       JBC=JBC1
       JQ=JQ1
       IF(JBC.LT.3) GO TO 101
       JQ=JQ-1
  101      K3=2**JQ
       K7=K3/2
       N5=K3/4
       I=1
       JNDX(I)=N5
       QI(I)=0.5*SQRT(2.)
       K=I
       I=I+1
  102     IL=I
       IF(I.EQ.K7) GO TO 104
  103     K1=JNDX(K)/2
       JNDX(I)=K1
       QI(I)=SIN(PI*FLOAT(K1)/FLOAT(K3))
       K1=K7-K1
       I=I+1
       JNDX(I)=K1
       QI(I)=SIN(PI*FLOAT(K1)/FLOAT(K3))
       K=K+1
       I=I+1
       IF(K.EQ.IL) GO TO 102
       GO TO 103
  104     RETURN
       END
C-----------------------------------------
       SUBROUTINE TFOLD(IS,L,ZZZ,k2)
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR2.h'	  


       DIMENSION ZZZ(MARR)
       IH2=K2/2-1
       DO 100 I=IS,IH2
       I1=I+L
       I2=K2-I+L
       A=ZZZ(I1)
       ZZZ(I1)=A-ZZZ(I2)
       ZZZ(I2)=A+ZZZ(I2)
  100     CONTINUE
       RETURN
       END
C------------------------------------
       SUBROUTINE NEG(I1,I3,I2,jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR2.h'	  
       dimension Uf(marr) , Vf(marr)
       dimension Qi(mf67) , jndx(mf67)
 
       DO 100 K=I1,I3,I2
       Vf(K)=-Vf(K)
  100     CONTINUE
       RETURN
       END
C-------------------------------------
       SUBROUTINE REVNEG(jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR2.h'	  
       dimension Uf(marr) , Vf(marr)
       dimension Qi(mf67) , jndx(mf67)

       integer  jbc , jp, jsl , ll1 , k2 , k3 , k4 , k7

       DO 100 I=1,K7
       J=K3+1+I
       K=K4+1-I
       A=Vf(J)
       Vf(J)=-Vf(K)
       Vf(K)=-A
  100     CONTINUE
       RETURN
       END
C-------------------------------------
       SUBROUTINE ZEERO(L,jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR2.h'	  
       dimension Uf(marr) , Vf(marr)
       dimension Qi(mf67) , jndx(mf67)

       integer  jbc , jp, jsl , ll1 , k2 , k3 , k4 , k7

       DO 100 I=1,K2
       LI=L+I
       Uf(LI-1)=0.0
  100     CONTINUE
       RETURN
       END
C------------------------------------------
       SUBROUTINE TFOLD1(jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR2.h'	  
       dimension Uf(marr) , Vf(marr)
       dimension Qi(mf67) , jndx(mf67)

       integer  jbc , jp, jsl , ll1 , k2 , k3 , k4 , k7

       II=K2-1
       DO 100 I=1,II
       I1=JSL+I
       I2=LL1-I
       A=Uf(I1)
       Uf(I1)=A+Uf(I2)
       Uf(I2)=A-Uf(I2)
  100     CONTINUE
       RETURN
       END
C-------------------------------------
       SUBROUTINE KFOLD(jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR2.h'	  
       dimension Uf(marr) , Vf(marr)
       dimension Qi(mf67) , jndx(mf67)

       integer  jbc , jp, jsl , ll1 , k2 , k3 , k4 , k7

       JS1=K2
       I=1
       J5=JSL+K2
       IS1=JSL
       IC1=LL1
       JS1=JS1/2
       IF(JS1.NE.1) GO TO 200
       K1=JNDX(I)
       SN=QI(I)
       IS0=IS1
       IS1=IS1+JS1
       IC0=IC1
       IC1=IC1+JS1
       ODD1=SN*(Uf(IC1)-Uf(IS1))
       Vf(K1+1)=Uf(IC0)+ODD1
       K3MK1=K3-K1
       Vf(K3MK1+1)=Uf(IC0)-ODD1
       IF(JBC.LT.3) GO TO 110
       ODD2=SN*(Uf(IC1)+Uf(IS1))
       K3PK1=K3+K1
       Vf(K3PK1+1)=Uf(IS0)+ODD2
       K4MK1=K4-K1
       Vf(K4MK1+1)=-Uf(IS0)+ODD2
  110     RETURN
  200     SN=QI(I)
       IS1=IS1+JS1
       IC1=IC1+JS1
       J3=IS1+JS1
  210     IS0=IS1-JS1
       IC0=IC1-JS1
       ODD1=SN*(Uf(IC1)-Uf(IS1))
       ODD2=SN*(Uf(IC1)+Uf(IS1))
       Uf(IC1)=Uf(IC0)-ODD1
       Uf(IS1)=-Uf(IS0)+ODD2
       Uf(IC0)=Uf(IC0)+ODD1
       Uf(IS0)=Uf(IS0)+ODD2
       IS1=IS1+1
       IC1=IC1+1
       IF(IS1.NE.J3) GO TO 210
       I=I+1
  300     IS1=JSL
       IC1=LL1
       JS1=JS1/2
       IF(JS1.EQ.1) GO TO 400
  310     SN=QI(I)
       I=I+1
       CS=QI(I)
       IS1=IS1+JS1
       IC1=IC1+JS1
       J3=IS1+JS1
  320     IS0=IS1-JS1
       IC0=IC1-JS1
       ODD1=CS*Uf(IC1)-SN*Uf(IS1)
       ODD2=SN*Uf(IC1)+CS*Uf(IS1)
       Uf(IC1)=Uf(IC0)-ODD1
       Uf(IC0)=Uf(IC0)+ODD1
       Uf(IS1)=-Uf(IS0)+ODD2
       Uf(IS0)=Uf(IS0)+ODD2
       IS1=IS1+1
       IC1=IC1+1
       IF(IS1.NE.J3) GO TO 320
       IS1=IS1+JS1
       IC1=IC1+JS1
       J3=IS1+JS1
  330     IS0=IS1-JS1
       IC0=IC1-JS1
       ODD1=SN*Uf(IC1)-CS*Uf(IS1)
       ODD2=CS*Uf(IC1)+SN*Uf(IS1)
       Uf(IC1)=Uf(IC0)-ODD1
       Uf(IC0)=Uf(IC0)+ODD1
       Uf(IS1)=-Uf(IS0)+ODD2
       Uf(IS0)=Uf(IS0)+ODD2
       IS1=IS1+1
       IC1=IC1+1
       IF(IS1.NE.J3) GO TO 330
       I=I+1
       IF(IS1.EQ.J5) GO TO 300
       GO TO 310
  400     K1=JNDX(I)
       SN=QI(I)
       I=I+1
       CS=QI(I)
       IS0=IS1
       IS1=IS1+JS1
       IC0=IC1
       IC1=IC1+JS1
       ODD1=CS*Uf(IC1)-SN*Uf(IS1)
       Vf(K1+1)=Uf(IC0)+ODD1
       K3MK1=K3-K1
       Vf(K3MK1+1)=Uf(IC0)-ODD1
       IF(JBC.LT.3) GO TO 410
       ODD2=SN*Uf(IC1)+CS*Uf(IS1)
       K3PK1=K3+K1
       Vf(K3PK1+1)=Uf(IS0)+ODD2
       K4MK1=K4-K1
       Vf(K4MK1+1)=-Uf(IS0)+ODD2
  410     IS1=IS1+1
       IC1=IC1+1
       K1=JNDX(I)
       IS0=IS1
       IS1=IS1+JS1
       IC0=IC1
       IC1=IC1+JS1
       ODD1=SN*Uf(IC1)-CS*Uf(IS1)
       Vf(K1+1)=Uf(IC0)+ODD1
       K3MK1=K3-K1
       Vf(K3MK1+1)=Uf(IC0)-ODD1
       IF(JBC.LT.3) GO TO 420
       ODD2=CS*Uf(IC1)+SN*Uf(IS1)
       K3PK1=K3+K1
       Vf(K3PK1+1)=Uf(IS0)+ODD2
       K4MK1=K4-K1
       Vf(K4MK1+1)=-Uf(IS0)+ODD2
  420     IS1=IS1+1
       IC1=IC1+1
       I=I+1
       IF(IS1.NE.J5) GO TO 400
       RETURN
       END

c      ------------------------------------------------------
       SUBROUTINE FOUR67(JBC1,JQ1,jp1,jsl1,ll11,k21,k71,
     &                   Qi,jndx,Uf,Vf)
c      ------------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR2.h'	  
       dimension Uf(marr) , Vf(marr)
       dimension Qi(mf67) , jndx(mf67)

       integer  jbc , jp, jsl , ll1 , k2 , k3 , k4 , k7

       JBC=JBC1
       JQ=JQ1
       jp = jp1
       jsl = jsl1
       ll1 = ll11
       k2 = k21
       k7 = k71
       A5=0.5*SQRT(2.0)
       K4=2**JQ
       K3=K4
       GO TO (103,103,101,102),JBC
  101     Uf(1)=Uf(1)/2.0
       Uf(K3+1)=Uf(1)
       K2=K3

       CALL TFOLD(0,1,Uf,k2)

       K3=K3/2
       JQ=JQ-1
       GO TO 103
  102     K3=K3/2
       JQ=JQ-1
  103     N5=K3/4
       K7=K3/2
       N11=3*K7
       K31=K3+1
       GO TO(300,400,500,600),JBC
  300     Uf(K31)=0.0
       Uf(1)=0.0
       K2=K3
       DO 301 I=2,JQ

       CALL TFOLD(1,1,Uf,k2)

  301     K2=K2/2
       Vf(K7+1)=Uf(2)
       JF=N5
       JSL=1
       DO 302 JP=2,JQ
       LL1=K2+1

       CALL ZEERO(1,jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)
       CALL KFOLD(jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

       I1=3*JF+1
       I2=4*JF
       I3=I1+(K2/2-1)*I2

       CALL NEG(I1,I3,I2,jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

       K2=K2+K2
  302     JF=JF/2
       RETURN
  400     Uf(1)=Uf(1)/2.0
       Uf(K31)=Uf(K31)/2.0
       K2=K3
       DO 401 I=2,JQ

       CALL TFOLD(0,K31-K2,Uf,k2)

  401     K2=K2/2
       LL1=K31-K2
       A=Uf(LL1)+Uf(LL1+2)
       Vf(1)=-A-Uf(LL1+1)
       Vf(K31)=-A+Uf(LL1+1)
       Vf(K7+1)=Uf(LL1)-Uf(LL1+2)
       DO 402 JP=2,JQ
       JSL=K31-K2
       LL1=JSL-K2
       idum = jsl

       CALL ZEERO(idum,jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)
       CALL KFOLD(jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

  402     K2=K2+K2

       CALL NEG(1,K31,2,jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

       RETURN
  500     K2=K3
       L2=K4
       DO 501 JP=2,JQ

       CALL TFOLD(1,1,Uf,k2)
       CALL TFOLD(0,L2-K2+1,Uf,k2)

  501     K2=K2/2
       LL1=L2-K2+1
       A=Uf(LL1)+Uf(LL1+2)
       Vf(K7+1)=2.0*(-Uf(LL1)+Uf(LL1+2))
       Vf(1)=2.0*(A+Uf(LL1+1))
       Vf(K31)=2.0*(A-Uf(LL1+1))
       Vf(N11+1)=2.0*Uf(2)
       DO 502 JP=2,JQ
       Uf(K2+1)=2.0*Uf(K2+1)
       JSL=K2+1

       CALL TFOLD1(jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

       LL1=LL1-K2
       Uf(LL1)=-2.0*Uf(LL1)

       CALL KFOLD(jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

  502     K2=K2+K2
       Vf(1)=Vf(1)*A5
       Vf(K31)=Vf(K31)*A5
       RETURN
  600     Uf(1)=Uf(1)*A5
       Uf(K31)=Uf(K31)*A5
       K2=K3
       DO 601 JP=2,JQ

       CALL TFOLD(0,K31-K2,Uf,k2)
       CALL TFOLD(1,K31,Uf,k2)

  601     K2=K2/2
       LL1=K31-K2
       A=Uf(LL1)+Uf(LL1+2)
       Vf(1)=2.0*(A+Uf(LL1+1))
       Vf(K31)=2.0*(A-Uf(LL1+1))
       Vf(K7+1)=2.0*(-Uf(LL1)+Uf(LL1+2))
       Vf(N11+1)=2.0*Uf(K3+2)
       DO 602 JP=2,JQ
       JSL=K31+K2
       Uf(JSL)=2.0*Uf(JSL)

       CALL TFOLD1(jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

       LL1=LL1-K2
       Uf(LL1)=-2.0*Uf(LL1)

       CALL KFOLD(jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

  602     K2=K2+K2

       CALL REVNEG(jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

       idum = k3

       CALL NEG(2,idum,2,jbc,jp,jsl,ll1,k2,k3,k4,k7,Qi,jndx,Uf,Vf)

       K2=K4

       CALL TFOLD(1,1,Vf,k2)

       Vf(K4+1)=0.0

       RETURN
       END

C---------------------------------------------
C                       Write current data to  disk/tape
C                        for PMstartM - multiple masses
      SUBROUTINE WriteData(Vscale,AexpV,Wtotal)
C----------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMinitialCR2.h'
c      COMMON / BUFF /	XPt(Nmaxpart),YPt(Nmaxpart),ZPt(Nmaxpart),
c     +			VXt(Nmaxpart),VYt(Nmaxpart),VZt(Nmaxpart)
       COMMON / KINENRG/ SKINE,SX,SY,SZ,SX2,SY2,SZ2
C
      XMAX  = FLOAT(NGRID) + 1.
      XSHF  = FLOAT(NGRID)
      SKINE =0.
      Wtotal =0.
       jstart =1
       write (*,*) ' Nspecies=',Nspecies
       Do j =1,Nspecies
          vvx =0.
          vvy =0.
          vvz =0.
          vx2 =0.
          vy2 =0.
          vz2 =0.
          jend =lspecies(j)
          W     =wspecies(j)
          If(jend.gt.jstart)Then
             write (*,*)'  wrdata: jstart,jend=',jstart,jend
          Do i=jstart,jend
             vvx = vvx + VXt(i)
             vvy = vvy + VYt(i)
             vvz = vvz + VZt(i)
             vx2 = vx2 + VXt(i)**2
             vy2 = vy2 + VYt(i)**2
             vz2 = vz2 + VZt(i)**2
              SKINE    = SKINE + W*(VXt(i)**2 +VYt(i)**2 +VZt(i)**2)
              Wtotal =Wtotal +w 
          EndDo
           npp =max(jend-jstart+1,1)
           v2 = sqrt((vx2 +vy2+vz2)/npp)/AexpV*Vscale
           vvx =vvx/npp/AexpV*Vscale
           vvy =vvy/npp/AexpV*Vscale
           vvz =vvz/npp/AexpV*Vscale
           write (*,350) vvx,vvy,vvz,v2,jend-jstart+1,j
 350       format('       V(km/s)=',4g11.3, ' Npart=',i8,' Species=',i3)
          jstart =  jend+1
          Endif 
       EndDo
      Ibuff =0
      KROW =0
      write (*,*) ' lspecies(Nspecies)=',lspecies(Nspecies)
      Do i=1,lspecies(Nspecies)
C                                Periodical boundary conditions
	       IF(XPt(i).GT.XMAX)	      XPt(i)=XPt(i)-XSHF
	       IF(XPt(i).LE.1.)	            XPt(i)=XPt(i)+XSHF
	       IF(YPt(i).GT.XMAX)	      YPt(i)=YPt(i)-XSHF
	       IF(YPt(i).LE.1.)	            YPt(i)=YPt(i)+XSHF
	       IF(ZPt(i).GT.XMAX)	      ZPt(i)=ZPt(i)-XSHF
	       IF(ZPt(i).LE.1.)	            ZPt(i)=ZPt(i)+XSHF
             Ibuff              = Ibuff +1
             XPAR(Ibuff) = XPt(i)
             YPAR(Ibuff) = YPt(i)
             ZPAR(Ibuff) = ZPt(i)
             VX(Ibuff)      = VXt(i)
             VY(Ibuff)      = VYt(i)
             VZ(Ibuff)      = VZt(i)
             If(  XPAR(Ibuff).lt.1..or.YPAR(Ibuff).lt.1.
     &      .or.ZPAR(Ibuff).lt.1.)write (*,*) ' Error!!!',i, 
     &             XPAR(Ibuff),YPAR(Ibuff),ZPAR(Ibuff)
              If(  XPAR(Ibuff).ge.XMAX.or.YPAR(Ibuff).ge.XMAX
     &      .or.ZPAR(Ibuff).ge.XMAX)write (*,*) ' Error!!!',i, 
     &             XPAR(Ibuff),YPAR(Ibuff),ZPAR(Ibuff)
             If(  XPAR(Ibuff).ge.XMAX)Then
                XPAR(Ibuff) = XPAR(Ibuff) -1.e-4
                write (*,500) XPAR(Ibuff)
             endif 
             If(  YPAR(Ibuff).ge.XMAX)Then
                YPAR(Ibuff) = YPAR(Ibuff) -1.e-4
                write (*,500) YPAR(Ibuff)
             endif 
             If(  ZPAR(Ibuff).ge.XMAX)Then
                ZPAR(Ibuff) = ZPAR(Ibuff) -1.e-4
                write (*,500) ZPAR(Ibuff)
 500            format(' fixed boundary. It is now=',g14.7)
             endif 


            If(Ibuff.ge.NPAGE)Then
                KROW = KROW +1
                if(KROW/10*10.eq.KROW)
     &             write (*,*) ' Write page=',KROW,' i=',i,Ibuff
                CALL WRIROW(KROW,1)
                Ibuff     =0
             EndIf
          EndDo
          If(Ibuff.ne.0)Then    ! write last incomplete page
                KROW = KROW +1
                write (*,*) ' Write page=',KROW,' i_buff=',Ibuff
                CALL WRIROW(KROW,1)
                Ibuff     =0
          EndIf
      RETURN
      END

C _____________________________ Density and velocity fields on a mesh
C		                     

       INCLUDE 'PMparameters.h'
       INCLUDE 'PMfields.h'
       REAL     INPUT
C...................................................................
C			Read data and open files
      OPEN(17,FILE='Fields.DAT',STATUS='UNKNOWN')
      OPEN(19,FILE='Fields.small.DAT',STATUS='UNKNOWN')
      CALL RDTAPE

      write (*,*) ' RDTAPE is done'
      WRITE (17,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,wspecies(1),
     +                  EKIN,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv,lspecies(1),Nspecies
      WRITE (19,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,wspecies(1),
     +                  EKIN,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv,lspecies(1),Nspecies
100   FORMAT(1X,'Header=>',A45,/
     +            1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I6,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3,/
     +            1x,' Number of part.1specie=',i8,' Nspecies=',i3)
      Box =INPUT(' Enter box size in Mpc/h   =')
      alpha =INPUT(' Enter angle of rotation   =')
      z0 =INPUT(' Enter z_min   =')
      dz0=INPUT(' Enter dz      =')
      BoxV =Box*100.    ! Box size in km/s
      ScaleV = BoxV/AEXPN/NGRID  ! scale factor for Velocities
      ScaleC = Box/NGRID         ! scale factor for Coordinates
      write (*,*) Box,ScaleV,ScaleC

C
      CALL ReadParticles(ScaleV)
      xsh = 3.2/ScaleC
      ysh = -12.3/ScaleC
      zsh = 0.2/ScaleC
      CALL ShiftParticles(xsh,ysh,zsh)
      CALL RotateYParticles(alpha)
      Write (*,*) Xpb(1),Ypb(1),Zpb(1)
      Write (*,*) Xpb(2000),Ypb(2000),Zpb(2000)
      Write (*,*) Xpb(10000),Ypb(10000),Zpb(10000)
       CALL DENSIT    !   Find density
            write (*,*) ' Density is ok'
            Do i=1,1
              CALL SmoothDENSIT
            Enddo

            
      open(18,file='particlesZ.dat')
      WRITE (18,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,wspecies(1),
     +                  EKIN,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv,lspecies(1),Nspecies
      WRITE (17,*) ' Angle=',alpha,' Z=',z0,z0+dz0
      WRITE (19,*) ' Angle=',alpha,' Z=',z0,z0+dz0
      WRITE (18,*) ' Angle=',alpha,' Z=',z0,z0+dz0
      iz0 =INT(z0*Ndim1/Box+0.5)
      idz0 =INT(dz0/2.*Ndim1/Box+0.5)
      CALL DumpParticles(z0,dz0,ScaleC)
      CALL DumpDENSIT(iz0+idz0,idz0)
      STOP
      END


C---------------------------------------
C                                                       Read Particles 
      SUBROUTINE ReadParticles(ScaleV)
C---------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMfields.h'
      	XN   =FLOAT(NGRID)+1.-1.E-7
	      YN   =FLOAT(NGRID)

      W     = (FLOAT(NGRID)/FLOAT(NROW))**3
      PARTW = W  
      WPAR = wspecies(1)
      N =0
      xmin =1.e+5
      xmax =-1.e+5
      ymin =1.e+5
      ymax =-1.e+5
      zmin =1.e+5
      zmax =-1.e+5
      vxmin =1.e+15
      vxmax =-1.e+15
      vymin =1.e+15
      vymax =-1.e+15
      vzmin =1.e+15
      vzmax =-1.e+15

C				       Loop over particles
         N_particles =lspecies(Nspecies)   ! Total number of particles
         Npages = (N_particles -1)/NPAGE +1
         N_in_last=N_particles -NPAGE*(Npages-1)
      write (*,*) Nspecies,
     + lspecies(Nspecies),wspecies(Nspecies)
      Nsp_current =1
      WPAR     = wspecies(1)
      Lspec_next=lspecies(1)+1
      DO IROW=1,Npages
            In_page =NPAGE
            If(IROW.eq.Npages)In_page =N_in_last
            If(IROW/50*50.eq.IROW)
     +        write (*,*) ' Read page=',IROW,' N=',N,
     +             ' Npages=',Npages,In_page
            iL = NPAGE*(IROW-1)
C				       Loop over particles
         READ  (21,REC=IROW) RECDAT
	   DO   IN=1,In_page
            N   = N +1
            If(N.ge.Lspec_next)Then   ! next specie
               write (*,*) ' Another specie. Current=',Nsp_current
               write (*,*) '     Particle=',N,WPAR,
     &                         ' lspecies=',lspecies(Nsp_current),
     &                         ' next=',lspecies(Nsp_current+1)
               Nsp_current=Nsp_current+1
               Lspec_next =lspecies(Nsp_current)+1
               WPAR     = wspecies(Nsp_current)
            EndIf
	        X=XPAR(IN)
	        Y=YPAR(IN)
	        Z=ZPAR(IN)
           If(N.gt.Nmaxp)Then
              write (*,*) ' Error: not enough space for particles:',N
              stop
           Endif 
           Xp(N) =X                             ! coordinates in 1-NGRID
           Yp(N) =Y
           Zp(N) =Z
           Vxp(N)=ScaleV* VX(IN)    ! velocities in km/s
           Vyp(N)=ScaleV* VY(IN)
           Vzp(N)=ScaleV* VZ(IN)
           Wp(N) =WPAR                   ! particle weight

           xmin =MIN(xmin,X)
           ymin =MIN(ymin,Y)
           zmin =MIN(zmin,Z)
           xmax =MAX(xmax,X)
           ymax =MAX(ymax,Y)
           zmax =MAX(zmax,Z)
           vxmin =MIN(vxmin,Vxp(N))
           vymin =MIN(vymin,Vyp(N))
           vzmin =MIN(vzmin,Vzp(N))
           vxmax =MAX(vxmax,Vxp(N))
           vymax =MAX(vymax,Vyp(N))
           vzmax =MAX(vzmax,Vzp(N))
	        I=INT(X)
	        J=INT(Y)
	        K=INT(Z)
            If(I.le.0)write (*,*) ' X:',X,Y,Z,I,' Irow=',IROW,IN,ifile
            If(J.le.0)write (*,*) ' Y:',X,Y,Z,I,' Irow=',IROW,IN,ifile
            If(K.le.0)write (*,*) ' Z:',X,Y,Z,I,' Irow=',IROW,IN,ifile

	      ENDDO
        ENDDO 

        Np = N
      write (*,*) ' Number of particles read=', N
      write (*,*) ' X:',xmin,xmax,' V=',vxmin,vxmax
      write (*,*) ' Y:',ymin,ymax,' V=',vymin,vymax
      write (*,*) ' Z:',zmin,zmax,' V=',vzmin,vzmax
        RETURN
      END
C---------------------------------------
C                            write particles in a slice
      SUBROUTINE DumpParticles(z0,dz0,ScaleC)
C---------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMfields.h'
C                 Find points close to the center
      Xc =NGRID/2.+1.
      Yc =NGRID/2.+1.
      Zc =NGRID/2.+1.
      Rc =1.5
 10   R2 =Rc**2
C				       Loop over particles
      Nc =0
      Vxc =0.
      Vyc =0.
      Vzc =0.
	   DO   IN=1,Np
	        dX=(Xpb(IN)-Xc)            !coords
	        dY=(Ypb(IN)-Yc)
	        dZ=(Zpb(IN)-Zc)
           dd =dX**2 +dY**2 +dZ**2
             If(dd.lt.R2)Then
                Nc =Nc+1
                Vxc =Vxc +Vxpb(IN)
                Vyc =Vyc +Vypb(IN)
                Vzc =Vzc +Vzpb(IN)
             endif 
      Enddo 
      If(Nc.eq.0)Then
         Rcold =Rc
         Rc       =Rc*1.2
         write (*,*) ' Too small radius=',Rcold,' Increase it to ',Rc
         goto 10
      endif 
      Vxc =Vxc/Nc
      Vyc =Vyc/Nc
      Vzc =Vzc/Nc
      Xc   =ScaleC*(Xc-1.)
      Yc   =ScaleC*(Yc-1.)
      Zc   =ScaleC*(Zc-1.)

      write (*,*) ' There are ',Nc,' particles inside Rc=',Rc*ScaleC,
     &               ' Center(Mpc/h) =',Xc,
     &               Yc,Zc,
     &               ' V(km/s)=', Vxc, Vyc, Vzc
C				       Loop over particles
	   DO   IN=1,Np
	        X=ScaleC*(Xpb(IN)-1.)            !coords
	        Y=ScaleC*(Ypb(IN)-1.)
	        Z=ScaleC*(Zpb(IN)-1.)
             If(Z.gt.z0.and.Z.lt.z0+dz0)Then
	        dX=(X-Xc)            !coords
	        dY=(Y-Yc)
	        dZ=(Z-Zc)
              dd =dX**2 +dY**2 +dZ**2
              d   =sqrt(dd+1.d-10)
                ux =Vxpb(IN)  ! -Vxc
                uy =Vypb(IN)  ! -Vyc
                uz =Vzpb(IN)  ! -Vxc
c                vr  =(dX*ux+dY*uy+dZ*uz)/d
c                Xn =dX*(1.+vr/100./d)+Xc
c                Yn =dY*(1.+vr/100./d)+Yc
c                Zn =dZ*(1.+vr/100./d)+Zc

                write (18,100) X,Y,Z ! ,ux,uy,uz,Wp(IN) !,vr,
c     &                 Xn,Yn,Zn
 100            format(3f8.3,3f8.1,g11.3,4f8.3)
             endif 
      Enddo 
      Return
      End
C---------------------------------------
C                          Rotate around Y-axis by angle alpha
      SUBROUTINE RotateYParticles(alpha)
C---------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMfields.h'
      XN =NGRID+1
      XC =NGRID/2.+1.     ! center of rotation
      ZC =NGRID/2.+1.
      cosA =cos(alpha*3.1415926/180.)
      sinA =sin(alpha*3.1415926/180.)
C				       Loop over particles
	   DO   IN=1,Np
	        X=Xp(IN) -XC            !coords
	        Y=Yp(IN)
	        Z=Zp(IN) -ZC
           Xnew =X*cosA -Z*sinA + XC
           Znew =Z*cosA +X*sinA + ZC
           Vxpb(IN) =Vxp(IN)*cosA-Vzp(IN)*sinA
           Vypb(IN) =Vyp(IN) 
           Vzpb(IN) =Vzp(IN)*cosA+Vxp(IN)*sinA
           
           X =Xnew
              If(X.ge.XN)X=X-NGRID
              If(X.lt.1.)X=X+NGRID
           Z =Znew
              If(Z.ge.XN)Z=Z-NGRID
              If(Z.lt.1.)Z=Z+NGRID
           Xpb(IN) =X
           Ypb(IN) =Y
           Zpb(IN) =Z

      Enddo 
      Return
      End
C---------------------------------------
C                          Shift particles with periodical conditions
      SUBROUTINE ShiftParticles(xsh,ysh,zsh)
C---------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMfields.h'
      XN =NGRID+1
C				       Loop over particles
	   DO   IN=1,Np
	        X=Xp(IN)             !coords
	        Y=Yp(IN)
	        Z=Zp(IN)
           X =X+xsh
              If(X.ge.XN)X=X-NGRID
              If(X.lt.1.)X=X+NGRID
           Y =Y+ysh
              If(Y.ge.XN)Y=Y-NGRID
              If(Y.lt.1.)Y=Y+NGRID
           Z =Z+zsh
              If(Z.ge.XN)Z=Z-NGRID
              If(Z.lt.1.)Z=Z+NGRID
           Xp(IN) =X
           Yp(IN) =Y
           Zp(IN) =Z
c           Vxpb(IN) =Vxp(IN)
c           Vypb(IN) =Vyp(IN) 
c           Vzpb(IN) =Vzp(IN)

      Enddo 
      Return
      End
C---------------------------------------
C                                                       Density Field    
      SUBROUTINE SmoothDENSIT
C---------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMfields.h'
      	XN   =FLOAT(NGRID)+1.-1.E-7
	      YN   =FLOAT(NGRID)
         s    = 1.                 ! gaussian filter
         s2  = 2.*s**2
         w0 = 1.                 ! weights
         w1 = exp(-1./s2)
         w2 = exp(-2./s2)
         w3 = exp(-3./s2)
         sw = w0 +6.*w1 +12.*w2 +8.*w3
         w0 = w0/sw           ! normalize weights
         w1 = w1/sw
         w2 = w2/sw
         w3 = w3/sw
C				       sum contributions
C.... Open_MP
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP+PRIVATE (k,km,kp,j,jm,jp,i,im,ip)
       DO k=Nl+1,Nr-1
         km = k -1
         if(km.lt.1)km=km+Ndim1
         kp = k +1
         if(kp.gt.Ndim1)kp=kp-Ndim1
       DO j=1,Ndim1
         jm = j -1
         if(jm.lt.1)jm=jm+Ndim1
         jp = j +1
         if(jp.gt.Ndim1)jp=jp-Ndim1
	      DO i=1,Ndim1
            im = i -1
            if(im.lt.1)im=im+Ndim1
            ip = i +1
            if(ip.gt.Ndim1)ip=ip-Ndim1
	        Dens2(i,j,k) = Dens1(i,j,k)*w0 +
     &            ( Dens1(i,j,km) + Dens1(i,j,kp) +
     &              Dens1(im,j,k) + Dens1(ip,j,k) +                           
     &              Dens1(i,jm,k) + Dens1(i,jp,k) )*w1 +
     &            ( Dens1(i,jm,km) + Dens1(i,jp,km) +
     &              Dens1(im,j,km) + Dens1(ip,j,km) +                           
     &              Dens1(im,jm,k) + Dens1(ip,jm,k) +
     &              Dens1(im,jp,k) + Dens1(ip,jp,k) +
     &              Dens1(i,jm,kp) + Dens1(i,jp,kp) +
     &              Dens1(im,j,kp) + Dens1(ip,j,kp) )*w2 +                           
     &            ( Dens1(im,jm,km) + Dens1(ip,jm,km) +
     &              Dens1(im,jp,km) + Dens1(ip,jp,km) +                           
     &              Dens1(im,jm,kp) + Dens1(ip,jm,kp) +
     &              Dens1(im,jp,kp) + Dens1(ip,jp,kp) )*w3
	      END DO
       END DO
      END DO
c                                restore the density
      dav =0.
      DO k=Nl,Nr
       DO j=1,Ndim1
	      DO i=1,Ndim1
	        Dens1(i,j,k) = Dens2(i,j,k)
              dav =dav + Dens1(i,j,k)
	      END DO
       END DO
      END DO
      write (*,*) ' Done smooting with filter r=',s,
     &     ' Average=',dav/ Ndim1**2/(Nr-Nl+1)     
      Return
      End
C---------------------------------------
C                                                       Density Field    
      SUBROUTINE DENSIT
C---------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMfields.h'
      	XN   =FLOAT(NGRID)+1.-1.E-7
	      YN   =FLOAT(NGRID)
C				       
      DO M3=Nl,Nr
       DO M2=1,Ndim1
	      DO M1=1,Ndim1
	        Dens1(M1,M2,M3) = 0.
	        Vx1(M1,M2,M3) = 0.
	        Vy1(M1,M2,M3) = 0.
	        Vz1(M1,M2,M3) = 0.
	      END DO
       END DO
      END DO


      xmin =1.e+5
      xmax =-1.e+5
      ymin =1.e+5
      ymax =-1.e+5
      zmin =1.e+5
      zmax =-1.e+5
      Scale1 = Float(Ndim1)/float(NGRID)
      AvDens1 =NGRID**3/float(Ndim1)**3
C				       Loop over particles
	   DO   IN=1,Np
	        X=Xpb(IN)             !coords
	        Y=Ypb(IN)
	        Z=Zpb(IN)
              Ux =Vxpb(IN)        ! velocities
              Uy =Vypb(IN)
              Uz =Vzpb(IN)
              W  =Wp(IN)           ! weight
	        X1=(X-1.)*Scale1 +1.     ! scale to mesh 1
	        Y1=(Y-1.)*Scale1 +1.
	        Z1=(Z-1.)*Scale1 +1.
           xmin =MIN(xmin,X1)
           ymin =MIN(ymin,Y1)
           zmin =MIN(zmin,Z1)
           xmax =MAX(xmax,X1)
           ymax =MAX(ymax,Y1)
           zmax =MAX(zmax,Z1)
	        I1=INT(X1)                      ! fields for the first mesh
	        J1=INT(Y1)
	        K1=INT(Z1)
c           write(*,110) IN,X,Y,Z,X1,Y1,Z1,I1,J1,K1
c 110       format(i8,6f9.4,3i4)
            If(I1.le.0)write (*,*) ' Error X1:',X1,Y1,Z1,In,xmin,xmax
            If(J1.le.0)write (*,*) ' Error Y1:',X1,Y1,Z1,In,ymin,ymax
            If(K1.le.0)write (*,*) ' Error  Z1:',X1,Y1,Z1,In,zmin,zmax
	        D1=X1-FLOAT(I1)
	        D2=Y1-FLOAT(J1)
	        D3=Z1-FLOAT(K1)
	        T1=1.-D1
	        T2=1.-D2
	        T3=1.-D3
	        T2W =T2*W
	        D2W =D2*W
	        Ia=I1+1
	           IF(Ia.GT.Ndim1)Ia=1
	        Ja=J1+1
	           IF(Ja.GT.Ndim1)Ja=1
	        Ka=K1+1
	           IF(Ka.GT.Ndim1)Ka=1

              IF(K1.ge.Nl.and.K1.le.Nr)Then
		      Dens1(I1 ,J1 ,K1 ) =Dens1(I1 ,J1 ,K1 ) +T3*T1*T2W
		      Dens1(Ia,J1 ,K1 ) =Dens1(Ia,J1 ,K1 ) +T3*D1*T2W
		      Dens1(I1 ,Ja,K1 ) =Dens1(I1 ,Ja,K1 ) +T3*T1*D2W
		      Dens1(Ia,Ja,K1 ) =Dens1(Ia,Ja,K1 ) +T3*D1*D2W
		      Vx1(I1 ,J1 ,K1 ) =Vx1(I1 ,J1 ,K1 ) +T3*T1*T2W*Ux
		      Vx1(Ia,J1 ,K1 ) =Vx1(Ia,J1 ,K1 ) +T3*D1*T2W*Ux
		      Vx1(I1 ,Ja,K1 ) =Vx1(I1 ,Ja,K1 ) +T3*T1*D2W*Ux
		      Vx1(Ia,Ja,K1 ) =Vx1(Ia,Ja,K1 ) +T3*D1*D2W*Ux
		      Vy1(I1 ,J1 ,K1 ) =Vy1(I1 ,J1 ,K1 ) +T3*T1*T2W*Uy
		      Vy1(Ia,J1 ,K1 ) =Vy1(Ia,J1 ,K1 ) +T3*D1*T2W*Uy
		      Vy1(I1 ,Ja,K1 ) =Vy1(I1 ,Ja,K1 ) +T3*T1*D2W*Uy
		      Vy1(Ia,Ja,K1 ) =Vy1(Ia,Ja,K1 ) +T3*D1*D2W*Uy
		      Vz1(I1 ,J1 ,K1 ) =Vz1(I1 ,J1 ,K1 ) +T3*T1*T2W*Uz
		      Vz1(Ia,J1 ,K1 ) =Vz1(Ia,J1 ,K1 ) +T3*D1*T2W*Uz
		      Vz1(I1 ,Ja,K1 ) =Vz1(I1 ,Ja,K1 ) +T3*T1*D2W*Uz
		      Vz1(Ia,Ja,K1 ) =Vz1(Ia,Ja,K1 ) +T3*D1*D2W*Uz
            EndIf
    
              IF(Ka.ge.Nl.and.Ka.le.Nr)Then
		      Dens1(I1 ,J1 ,Ka) =Dens1(I1 ,J1 ,Ka) +D3*T1*T2W
		      Dens1(Ia,J1 ,Ka) =Dens1(Ia,J1 ,Ka) +D3*D1*T2W
		      Dens1(I1 ,Ja,Ka) =Dens1(I1 ,Ja,Ka) +D3*T1*D2W
		      Dens1(Ia,Ja,Ka) =Dens1(Ia,Ja,Ka) +D3*D1*D2W
    
		      Vx1(I1 ,J1 ,Ka) =Vx1(I1 ,J1 ,Ka) +D3*T1*T2W*Ux
		      Vx1(Ia,J1 ,Ka) =Vx1(Ia,J1 ,Ka) +D3*D1*T2W*Ux
		      Vx1(I1 ,Ja,Ka) =Vx1(I1 ,Ja,Ka) +D3*T1*D2W*Ux
		      Vx1(Ia,Ja,Ka) =Vx1(Ia,Ja,Ka) +D3*D1*D2W*Ux
    
		      Vy1(I1 ,J1 ,Ka) =Vy1(I1 ,J1 ,Ka) +D3*T1*T2W*Uy
		      Vy1(Ia,J1 ,Ka) =Vy1(Ia,J1 ,Ka) +D3*D1*T2W*Uy
		      Vy1(I1 ,Ja,Ka) =Vy1(I1 ,Ja,Ka) +D3*T1*D2W*Uy
		      Vy1(Ia,Ja,Ka) =Vy1(Ia,Ja,Ka) +D3*D1*D2W*Uy

    
		      Vz1(I1 ,J1 ,Ka) =Vz1(I1 ,J1 ,Ka) +D3*T1*T2W*Uz
		      Vz1(Ia,J1 ,Ka) =Vz1(Ia,J1 ,Ka) +D3*D1*T2W*Uz
		      Vz1(I1 ,Ja,Ka) =Vz1(I1 ,Ja,Ka) +D3*T1*D2W*Uz
		      Vz1(Ia,Ja,Ka) =Vz1(Ia,Ja,Ka) +D3*D1*D2W*Uz
            EndIf
            ENDDO 
      write (*,*) '    Min/Max coords for the first mesh'
      write (*,*) ' X:',xmin,xmax
      write (*,*) ' Y:',ymin,ymax
      write (*,*) ' Z:',zmin,zmax
C				                              Normalize the fields
      AvD = 0.
      Dmin =1.e+10
      Dmax =-1.e+10
      RD  =0.
      sx    =0.
      sy    =0.
      sz    =0.
      DO M3=Nl,Nr
       DO M2=1,Ndim1
	      DO M1=1,Ndim1
	        Vx1(M1,M2,M3) = Vx1(M1,M2,M3)/max(1.d-10,Dens1(M1,M2,M3))
	        Vy1(M1,M2,M3) = Vy1(M1,M2,M3)/max(1.d-10,Dens1(M1,M2,M3))
	        Vz1(M1,M2,M3) = Vz1(M1,M2,M3)/max(1.d-10,Dens1(M1,M2,M3))
              If(Dens1(M1,M2,M3).lt.1.d-10)Then
                 Vx1(M1,M2,M3) =0.
                 Vy1(M1,M2,M3) = 0.
      	        Vz1(M1,M2,M3) =0.
              endif 
	        Dens1(M1,M2,M3) = Dens1(M1,M2,M3)/Avdens1
              AvD =AvD + Dens1(M1,M2,M3)
              Dmin =MIN(Dmin,Dens1(M1,M2,M3))
              Dmax =MAX(Dmax,Dens1(M1,M2,M3))
              sx     =sx + Vx1(M1,M2,M3)**2
              sy     =sy + Vy1(M1,M2,M3)**2
              sz     =sz + Vz1(M1,M2,M3)**2
	      END DO
       END DO
      END DO
      AvD =AvD/Ndim1**2/(Nr-Nl+1)
      sx =sqrt(sx/Ndim1**2/(Nr-Nl+1))
      sy =sqrt(sy/Ndim1**2/(Nr-Nl+1))
      sz =sqrt(sz/Ndim1**2/(Nr-Nl+1))
      write (*,*) '<----------- Fields for Mesh=',Ndim1,' ------>' 
      write (*,*) '    Density: Max=',Dmax,' Min=',Dmin,' Average=',AvD
      write (*,*) '    Velocity: rms=',sx,sy,sz
      write (17,*) '<----------- Fields for Mesh=',Ndim1,' ------>' 
      write (17,*) '    Density: Max=',Dmax,' Min=',Dmin,' Average=',AvD
      write (17,*) '    Velocity: rms=',sx,sy,sz

c      enddo
        RETURN
      END

C---------------------------------------
C                                                     Dump  Density Field    
      SUBROUTINE DumpDENSIT(k,kd)
C---------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMfields.h'
      	XN   =FLOAT(NGRID)+1.-1.E-7
	      YN   =FLOAT(NGRID)

         write (*,*) ' dump Density limits:',max(k-kd,Nl),Min(k+kd,Nr)
      do j=1,Ndim1
      do i=1,Ndim1
         Dd =0.
         Wx =0.
         Wy =0.
         Wz =0.
         Do kk=k-kd,k+kd
            If(kk.ge.Nl.and.kk.le.Nr)Then
               Dd =Dd +Dens1(i,j,kk)
               Wx =Wx +Vx1(i,j,kk)*Dens1(i,j,kk)
               Wy =Wy +Vy1(i,j,kk)*Dens1(i,j,kk)
               Wz =Wz +Vz1(i,j,kk)*Dens1(i,j,kk)
            endif
         EndDo
            Dd =MAX(Dd,1.d-10)
        write (17,100) i,j,k,
     &           Dd,Wx/Dd,Wy/Dd,Wz/Dd
        if(i/2*2.eq.i.and.j/2*2.eq.j)
     &            write (19,100) i,j,k,
     &           Dd,Wx/Dd,Wy/Dd,Wz/Dd
 100     format(3i4,4g11.4)
      enddo 
      enddo 
      write (*,*) ' Done density dump for K=',k
        RETURN
      END

C-------------------------------------------------
c
C     
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMvlists.h'
      Real             INPUT

      Np_min  =INPUT('Enter Minimum number of particles in a halo => ')
      V_c_min=INPUT('Enter Minimum circular velocity             => ')  
      Radius  =INPUT('Enter comoving radius(Mpc/h) for spheres    => ')
      Nsph     =INPUT('Enter number of  random spheres           => ')
      Fract   =INPUT('Enter fraction of DM particles (1/4,1/2,1)=> ')
      Fract   =Min(Max(Fract,0.),1.0)                             
      Box     =INPUT('Enter Comoving Box size(Mpc/h)            => ')
      write (*,*)
C     ------------------------------------------ Open files
      Open( 2,file='Vresults.DAT')   ! short list of halos
      Open( 3,file='Catshort.DAT')
C     ------------------------------------------ Read data
      CALL RDTAPE
            write (*,*) ' RDTAPE is done'
            write (*,*) ' Nnu=Number of Species=',Nspecies
         WRITE (2,100) HEADER,
     +               AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +               EKIN,NROW,NGRID,Om0,Oml0,hubble
100      FORMAT(1X,'Header=>',A45,/
     +         ' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +         ' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,
     +         ' Nrow=',I4,' Ngrid=',I4,/' Omega_0=',f6.3,
     +         ' Omega_L=',f6.3,' h=',f6.3)
C     ------------------------------------------ Constants ---------
           hsmall= hubble            ! Hubble/100.
           Box   = Box /hsmall       ! Scale to real Mpc          
           Radius= Radius/hsmall  ! Comoving Search radius in real Mpc
           Xscale= Box/Ngrid        ! Scale for comoving coordinates
           Vscale= 100.*hsmall*Xscale/AEXPN ! Scale for velocities
           Dscale= 2.746e+11*hsmall**2*(Box/NROW)**3 ! mass scale
C                            Dscale is a factor used to convert particles to mass 
C                                       =  mass of a particle for Omega=1 model
C                            Xscale is a factor to convert PM coordinates into Mpc
C                                       = Box / Ngrid = length of a PM cell in Mpc
C                           Vscale is a factor to convert PM pomenta to V (km/sec)
C                                       = the Hubble velocity at the distance of 1 PM cell
C                              the factor AEXPN is needed to go from momenta to pec.velocity
           write (*,*) ' Vscale=',Vscale, ' X=',Xscale,' Box(Mpc)=',Box
           Radius=Radius/Xscale    ! comoving radius in cell units
           RadSr1 = Radius**2
           Cell  =2.0              ! Cell-size for Linker List in grid units
           Box   =NGRID            ! all internal variables are in Grid units
           imin  =INT(-Radius/Cell)! Make recommendations. Code works 
           imax  =INT((Box+Radius)/Cell) ! if the limits are not optimal
                   If(imin.lt.Nm)Write(*,*)
     .               ' Wrong low limit:',Nm,' better be',imin
                   If(imax.gt.Nb)Write(*,*)
     .               ' Wrong upper limit:',Nb,' better be',imax
           write (*,*) 
     .        ' Box(cells)=',Box,' Cell=',Cell,' Rad(cells)=',Radius
c         DtoNscale = Om0*Dscale/Fract ! scale dark matter particles
C 
C      CALL ReadCent(Nsph,Ncentr)                     ! random centers          
      CALL ReadMax(N,Xscale,Np_min,V_c_min)            ! read halos
      Open( 3,file='Catshort.DAT')
      Ncentr = N
          Do i=1,N
                  Rmc(i) =Radius
                  Amc(i) =1.
                  Xm(i)   =Xp(i)
                  Ym(i)   =Yp(i)
                  Zm(i)   =Zp(i)
         EndDo
          
      CALL ReadPnt(N,Fract,Vscale)                         ! read particles
      Ndm  = N
c----------------------------------   DM particles
      CALL Points(Box,N,Ncp)            ! Make more points periodically
          write (*,*) ' Nparticles in periodic set=',Ncp,
     .              '( Maximim =',Np,')'
          write (2,*) ' Ndm in periodic set=',Ncp,
     .              '( Maximum =',Np,')'
      Call List(Box,Ncp)                ! make linker List, Label

          write (*,*) ' Nparticles=',N,' Ncenters=',Ncentr
      CALL SPairs(Box,N,Ncentr,1)  ! Accumulate  statistics for particles 
 
C---------------------------------- Halos
      CALL ReadMax(N,Xscale,Np_min,V_c_min)            ! read halos
      Nhalos = N
      CALL Points(Box,N,Ncp)            ! Make more points periodically

          write (*,*) ' N_halos=',Nhalos,'  in periodic set=',Ncp,
     .              '( Maximum =',Np,')',' N_dm min=',Np_min,
     .              ' V_circ_min=',V_c_min
          write (2,*) ' N_halos=',Nhalos,'  in periodic set=',Ncp,
     .              '( Maximum =',Np,')'
          write (2,*) ' N_dm min=',Np_min,
     .              ' V_circ_min=',V_c_min
      Call List(Box,Ncp)                ! make linker List, Label

          write (*,*) ' Nparticles=',N,' Ncenters=',Ncentr
      CALL SPairs(Box,N,Ncentr,2)  ! Accumulate  statistics for halos
C------------------------------- Print Results
      write ( 2,13)
 13   Format(7x,'N_dm Contrast N_halos V_dm rmsV_dm',
     &                     ' V_halos rmsV_halos')
      AMmean =Ndm/FLOAT(NGRID**3)*4.188*Radius**3 
      Do i=1,Ncentr          ! Scale all to physical units
         Xc    =Xm(i)  *Xscale
         Yc    =Ym(i)  *Xscale
         Zc    =Zm(i)  *Xscale
         aM   =Nbc(i,1)
         Contrast = aM/AMmean
c         If(Contrast.ge.1.)Then
         VelocityD  = sqrt(max(1.e-10,
     &        Wxc(i,1)**2 +Wyc(i,1)**2 +Wzc(i,1)**2))/
     &         max(Nbc(i,1),1)
         VelocityH  = sqrt(max(1.e-10,
     &        Wxc(i,2)**2 +Wyc(i,2)**2 +Wzc(i,2)**2))/
     &         max(Nbc(i,2),1)
         rmsD=sqrt(max(1.e-10,Vrmc(i,1)/max(Nbc(i,1),1) -
     &                  VelocityD**2))   
         rmsH=sqrt(max(1.e-10,Vrmc(i,2)/max(Nbc(i,2),1) -
     &                  VelocityD**2))
         rmsH2=sqrt(max(1.e-10,Vrmc(i,2)/max(Nbc(i,2),1) -
     &                  VelocityH**2))
         rmsH3=sqrt(max(1.e-10,Vrmc(i,2)/max(Nbc(i,2),1) ))
c         write (*,200) i,Nbc(i,1),Contrast ,Nbc(i,2),
c     &                      VelocityD,rmsD, VelocityH, rmsH,rmsH2,rmsH3
         write (2,200) i,Nbc(i,1),Contrast ,Nbc(i,2),
     &                      VelocityD,rmsD, VelocityH, rmsH,rmsH2,rmsH3,
     &                      Xc,Yc,Zc
 200     format(i5,i7,f8.3,i5,2(f8.2,f8.2,2x),2f8.2,3f7.3)
c         Endif 
        Enddo 
      Stop
      End
C--------------------------------------------------------------
C                                           Make linker lists of particles in each cell
      SUBROUTINE List(Box,Ncp)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMvlists.h'
             Do i=1,Ncp
                Lst(i)=-1
             EndDo

             Do k=Nm,Nb
             Do j=Nm,Nb
             Do i=Nm,Nb
                Label(i,j,k)=0
             EndDo
             EndDo
             EndDo  
      Do jp=1,Ncp
         i=INT(Xp(jp)/Cell)
         j=INT(Yp(jp)/Cell)
         k=INT(Zp(jp)/Cell)
         i=MIN(MAX(Nm,i),Nb)
         j=MIN(MAX(Nm,j),Nb)
         k=MIN(MAX(Nm,k),Nb)
         Lst(jp)      =Label(i,j,k)
         Label(i,j,k) =jp
      EndDo

      Return
      End
C--------------------------------------------------------------
C                                Find all neibhours for a center
C                                Xc,Yc,Zc - center; 
C                                ic = center, js = 1 (dm), =2 (halos)    
      SUBROUTINE SNeib(ic,js)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMvlists.h'

         Radmax =Radius

c                      limits for Label
         i1=INT((Xc-Radmax)/Cell)
         j1=INT((Yc-Radmax)/Cell)
         k1=INT((Zc-Radmax)/Cell)
            i1=MIN(MAX(Nm,i1),Nb)
            j1=MIN(MAX(Nm,j1),Nb)
            k1=MIN(MAX(Nm,k1),Nb)
         i2=INT((Xc+Radmax)/Cell)
         j2=INT((Yc+Radmax)/Cell)
         k2=INT((Zc+Radmax)/Cell)
            i2=MIN(MAX(Nm,i2),Nb)
            j2=MIN(MAX(Nm,j2),Nb)
            k2=MIN(MAX(Nm,k2),Nb)
C                                        Look for neibhours
         Do k=k1,k2
         Do j=j1,j2
         Do i=i1,i2
            jp =Label(i,j,k)   !  Dark matter
 10         If(jp.ne.0)Then
               dd =(Xc-Xp(jp))**2+(Yc-Yp(jp))**2+(Zc-Zp(jp))**2
                  If(dd.lt.RadSr1)Then
                    Nbc(ic,js)= Nbc(ic,js)+ 1
                    Rrc(ic,js)= Rrc(ic,js)+ sqrt(dd)
                    Vrmc(ic,js) =Vrmc(ic,js) +
     &                                VXp(jp)**2+VYp(jp)**2+VZp(jp)**2
                    Wxc(ic,js) =Wxc(ic,js) +VXp(jp)  
                    Wyc(ic,js) =Wyc(ic,js) +VYp(jp)
                    Wzc(ic,js) =Wzc(ic,js) +VZp(jp)
                  EndIf
               jp =Lst(jp)
               GoTo10
            EndIf
         EndDo
         EndDo
         EndDo
      Return
      End
C--------------------------------------------------------------
C                       Add points around the Box to take into account periodical conditions
C  It replicates points periodically and keeps those which are at  distance
C  less than Radius from the Box. 
C                        N     = number of points inside the Box
C                        Ncp = total number of points
      SUBROUTINE Points(Box,N,Ncp)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMvlists.h'
      Logical    Inside
         B1  =-Radius
         B2  =Box+Radius
         B3  =Box-Radius
         Ncp =N
      Do i=1,N               ! Add dark matter particles
         x0 =xp(i)
         y0 =yp(i)
         z0 =zp(i)
         Inside =            (x0.gt.Radius).and.(x0.lt.B3)
         Inside =Inside.and.((y0.gt.Radius).and.(y0.lt.B3))
         Inside =Inside.and.((z0.gt.Radius).and.(z0.lt.B3))
         If(.not.Inside)THEN         
         ux =VXp(i)
         uy =VYp(i)
         uz =VZp(i)
            Do k1 = -1,1
               zr =z0+k1*Box
               If(zr.GT.B1.AND.zr.LT.B2)Then
               kk =k1**2
               Do j1 = -1,1
                  yr =y0+j1*Box
                  If(yr.GT.B1.AND.yr.LT.B2)Then
                     jj = kk +j1**2
                     Do i1 = -1,1
                        xr =x0+i1*Box
                        ii =jj +i1**2
                        If((xr.GT.B1.AND.xr.LT.B2).AND.ii.ne.0)
     .                     Then
                             Ncp =Ncp +1
                             If(Ncp.le.Np)Then
                               xp(Ncp)  =xr
                               yp(Ncp)  =yr
                               zp(Ncp)  =zr
                               VXp(Ncp)  =ux
                               VYp(Ncp)  =uy
                               VZp(Ncp)  =uz
                             EndIf
                        EndIf
                     EndDo
                  EndIf
               EndDo
               EndIf
            EndDo
         EndIf
      EndDo
      If(Ncp.Gt.Np)Then
         write(*,*)' Too many points:',Ncp,' Maximum is =', Np
         STOP
      EndIf
      Return
      End

C-------------------------------- Update Statistics of pairs 
C                   
      SUBROUTINE SPairs(Box,N,Ncentr,js)
C---------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMvlists.h'

      If(Ncentr.gt.Ncc)Then
         write (*,*) ' Number of centers is too large:'
         write (*,*) '         Ncentr =',Ncentr,' Max=Ncc=',Ncc,' STOP'
         STOP
      EndIf
         Do i=1,Ncentr
                  Wxc(i,js) = 0.
                  Wyc(i,js) = 0.
                  Wzc(i,js) = 0.
                  Nbc(i,js) = 0
                  Rrc(i,js) = 0.
                  Vrmc(i,js)= 0.
         EndDo
      Do ic=1,Ncentr
         Xc =Xm(ic)
         Yc =Ym(ic)
         Zc =Zm(ic)
         Call SNeib(ic,js)
      EndDo
      Return
      End

C---------------------------------------------------------
C                                                  Select random particles
c                                                   as initial seeds of centers
      SUBROUTINE ReadCent(N,Ncentr)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMvlists.h'
      
      Nseed =120731
          Do i=1,N
                  Rmc(i) =Radius
                  Amc(i) =1.
                  Xm(i)   =NGRID*RANDd(Nseed)
                  Ym(i)   =NGRID*RANDd(Nseed)
                  Zm(i)   =NGRID*RANDd(Nseed)
         EndDo
         Ncentr =N
      Return
      End

C---------------------------------------------------------
C                                        Read list of maxima
c                                     Xnew =X-1: coord. now are 0-NGRID       
      SUBROUTINE ReadMax(Ncentr,Xscale,Np_min,V_c_min)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMvlists.h'
      Character*79 Text
      Do i=1,16
         read(3,'(A)') Text
         write(*,'(A)') Text
      enddo 
       Ncentr =0
      xxm =1000.
      xxn =-1000.
 10   read (3,*,err=5,end=5) X0, Y0, Z0, VvX,VvY,VvZ,
     &                                     amh,rh,wvel,Vcirc,ihh
           If(ihh.ge.Np_min.and.Vcirc.ge.V_c_min)Then
            Ncentr=Ncentr+1
            If(Ncentr.le.Ncc)Then
            Xp(Ncentr)  =X0/Xscale/hubble
            Yp(Ncentr)  =Y0/Xscale/hubble
            Zp(Ncentr)  =Z0/Xscale/hubble
            VXp(Ncentr)=VvX
            VYp(Ncentr)=VvY
            VZp(Ncentr)=VvZ
            xxm    =min(xxm,Xp(Ncentr))
            xxn     =max(xxn,Xp(Ncentr))
            EndIf
            EndIf
            If(Ncentr.lt.Ncc)GoTo 10
 5    write(*,*) ' Read Halos: X{Min,Max}=',xxm,xxn,' N=',Ncentr
      CLOSE (3)
      If(Ncentr.GT.Ncc)Then
         write (*,*) ' Too many particles: Max=',Ncc
         Stop
      EndIf
      Return
      End
C---------------------------------------------------------
C                                        Read particles
      SUBROUTINE ReadPnt(N,Fract,Vscale)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMvlists.h'

      N =0
      Iz=1
      Iy=1
      Ff=1.
      If(Fract.le.0.666)Then
         Iz=2
         Ff=0.5
         If(Fract.le.0.333)Then
            Iy=2
            Ff=0.25
         Endif
      EndIf
      Fract =Ff
C				       Loop over particles
      DO 10 IROW=1,NROW,Iz
         READ  (21,REC=IROW) RECDAT
	   DO   IN=1,NPAGE,Iy
            N   = N +1
            Xp(N)  =XPAR(IN)-1.
            Yp(N)  =YPAR(IN)-1.
            Zp(N)  =ZPAR(IN)-1.
            VXp(N)=VX(IN)*Vscale
            VYp(N)=VY(IN)*Vscale
            VZp(N)=VZ(IN)*Vscale
         ENDDO
 10   CONTINUE
      Return
      End

!-------------------------------------------------------------------- 
!                 Test OMP parallelization
!
      INTEGER, PARAMETER           :: NROW=256
      COMMON /AllSeeds/i24A(NROW)
      REAL(8)                      :: SUMM
!$OMP threadprivate (/AllSeeds/)

      Nseed = 121071
      NRAND = Nseed
      DO k = 1, NROW
!         write(*,*) k,NRAND
          Do j=1,NROW
          DO i=1,NROW
             x =GAUSS(NRAND)
            SUMM = SUMM + x**2
          EndDo 
          EndDo 
      EndDo 
write(*,*) ' Summ=',SUMM,x,NRAND
      Nseed = 121071
      CALL SetRandom(Nseed)
      SUMM =0.
!.... Open_MP                                                           
!$OMP PARALLEL DO DEFAULT(SHARED)  &                                     
!$OMP PRIVATE(i,j,k,NRAND,x) &
!$OMP COPYIN(/AllSeeds/) &
!$OMP REDUCTION(+:SUMM)
      DO k = 1, NROW 
            NRAND = i24A(k)
!         write(*,*) k,NRAND
          Do j=1,NROW
          DO i=1,NROW
             x =GAUSS(NRAND)
            SUMM = SUMM + x**2
          EndDo 
          EndDo 
      EndDo 
write(*,*) ' Summ=',SUMM,x,NRAND
            Stop
            End
!--------------------------------------------------                     
!                    :                Store seeds for parallelization 
!                                     of random number generator
!--------------------------------------------------                     
      SUBROUTINE SetRandom(Nseed)
      INTEGER, PARAMETER           :: NROW=256
!$OMP threadprivate (/AllSeeds/)
      COMMON /AllSeeds/i24A(NROW)

    NRAND = Nseed                  
   Do k=1,NROW                               ! gauss and randd
          i24A(k)  = NRAND
          Do j=1,NROW
             Do i=1,NROW
                x = GAUSS(NRAND)
             EndDo
          EndDo
   EndDo

        Return
        End

!--------------------------------------                                 
!				normal random numbers                                              
      FUNCTION GAUSS (M) 
!--------------------------------------                                 
      X = 0. 
      DO I = 1, 5 
      X = X + RANDd (M) 
      EndDo 
      X2 = 1.5491933 * (X - 2.5) 
      GAUSS = X2 * (1. - 0.01 * (3. - X2 * X2) ) 
      RETURN 
      END FUNCTION GAUSS                            
!------------------------------------------------                       
!				                                       random number generator     
      FUNCTION RANDd (M) 
!------------------------------------------------                       
      DATA LC, AM, KI, K1, K2, K3, K4, L1, L2, L3, L4	 / 453815927,     &
      2147483648., 2147483647, 536870912, 131072, 256, 	16777216, 4,    &
      16384, 8388608, 128 /                                             
      ML = M / K1 * K1 
      M1 = (M - ML) * L1 
      ML = M / K2 * K2 
      M2 = (M - ML) * L2 
      ML = M / K3 * K3 
      M3 = (M - ML) * L3 
      ML = M / K4 * K4 
      M4 = (M - ML) * L4 
      M5 = KI - M 
      IF (M1.GE.M5) M1 = M1 - KI - 1 
      ML = M + M1 
      M5 = KI - ML 
      IF (M2.GE.M5) M2 = M2 - KI - 1 
      ML = ML + M2 
      M5 = KI - ML 
      IF (M3.GE.M5) M3 = M3 - KI - 1 
      ML = ML + M3 
      M5 = KI - ML 
      IF (M4.GE.M5) M4 = M4 - KI - 1 
      ML = ML + M4 
      M5 = KI - ML 
      IF (LC.GE.M5) ML = ML - KI - 1 
      M = ML + LC 
      RANDd = M / AM 
      RETURN 
      END FUNCTION RANDd                            

C ______________________________ Profiles for Galaxy Simulations
C		             
C		                     
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMcool.h'
      REAL         AMprevious(Np),AMlast(Np),Daverg(0:500)
      Real*8       Xc,Yc,Zc
      DIMENSION    Iaverg(0:500)
      REAL         INPUT
      Character    FileASCII*100
      Character  File1*100,File2*100,File3*100
      EQUIVALENCE (Box,extras(100))



C...................................................................
C			Read data and open files
       File3 ='cooling_part.dat' 
       write(*,*)' enter 3 digits of the snapshot'
       read(*,*) moment
         write(File1,'("FILES/PMcrda0.",i3.3,".DAT")')moment
         write(File2,'("FILES/PMcrs0a0.",i3.3,".DAT")')moment
         write(*,*) File1
         write(*,*) File2


c      File1 ='PMcrd.DAT'
c      File2 ='PMcrs0.DAT'


      CALL RDTAPE(File1,File2)
      iSnapshot =INT(AEXPN*10000.)
         write(FileASCII,'("RESULTS/Result.DM.",i5.5,".dat")')
     &    iSnapshot
      OPEN(37,FILE=FileASCII,STATUS='UNKNOWN') 
 
        write(FileASCII,'("RESULTS/Result.SPH.",i5.5,".dat")')
     &    iSnapshot
      OPEN(39,FILE=FileASCII,STATUS='UNKNOWN') 

         write(FileASCII,'("RESULTS/Result.CYL.",i5.5,".dat")')
     &    iSnapshot
      OPEN(41,FILE=FileASCII,STATUS='UNKNOWN') 

      OPEN(18,FILE='Stat.dat',STATUS='UNKNOWN',access='append')
      OPEN(20,FILE='particles.dat',STATUS='UNKNOWN')
      OPEN(30,FILE='particlesu.dat',STATUS='UNKNOWN',form='UNFORMATTED')
      OPEN(10,file=File3,form='UNFORMATTED',status='OLD')

       time      = (age(AEXPN)-age(0.6))/1.e9
      box          = extras(100)! simulation box
      xfrac        = extras(51) ! fraction of particles to be cooled
      cool_frac    = extras(52) ! total cooling
      cfrac        = extras(53) ! cooling per step
      aexpn_s      = extras(54) ! start cooling
      aexpn_e      = extras(55) ! and cooling
      i_cool_which = extras(57) ! cool every # step
      i_cool_all   = extras(58) ! total # of cooling steps
      xm_part      = extras(59) ! particle weight (h^-1 M_s)
      CALL ReadCool

      i_halo = 1   ! only one halo cooled
      n_cooled = iph_cool(i_halo,1)
      xm_part      =1.e12/lspecies(Nspecies)

      aMassDisk = xm_part/hubble*n_cooled
      write (*,*)  ' hubble =',hubble,' mass of disk=',aMassDisk
      write (*,*) ' RDTAPE is done Time=',time,' a=',AEXPN
c      Do i=37,41,2
c          WRITE (i,100) HEADER,AEXPN,AEXP0,AMPLT,
c     +                  ASTEP,ISTEP,PARTW,EKIN,
c     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
c     +                  Ocurv,n_cooled,aMassDisk,time
c      EndDo 
100   FORMAT(1X,'Header=>',A45,/
     +           1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I8,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3,/
     + 1x,' Ndisk =',i8,' Mass disk =',G11.3,' Age=',f7.3,'Gyr') 
c      Box  =INPUT(' Enter box size in comoving Mpc/h =')
c      Box =0.5 ! NG3109
c      Box = 2   ! 'bulge'

      BoxV   = Box*100.    ! Box size in km/s
      ScaleV = BoxV/AEXPN/NGRID      ! scale factor for Velocities (km/s)
      ScaleC = Box/NGRID*AEXPN/hubble  ! scale factor for Coordinates (real Mpc)
      ScaleH  = 100.*hubble*sqrt(Om0/AEXPN**3+Oml0) ! H(a)=km/s/Mpc
      ScaleM = xm_part/hubble

 
      CALL ReadPnts(N,ScaleC,ScaleV,ScaleM)

      Call ChangePnts(N,Box,ScaleH)
      Call DumpPnts(N,Box,ScaleM)
      Call Statist(N,Box,ScaleM)
c      Call AngMom(N,30000,3.,Box,ScaleM)
      Call Profile(N,Box,ScaleM)
c      Call Projection(N,Box,0.)
c      Call Projection(N,Box,5.)

      END
c-------------------------------------------------------------------- 
C                            Get basic statistics of the system
      SUBROUTINE Statist(N,Box,ScaleM)
c-------------------------------------------------------------------- 
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMcool.h'
      Real*8 Lx,Ly,Lz,aL,V2,Lz1,Lz2,Lz3,Lz5,aM1,aM2,aM3,aM5
      Real*8 Lxh,Lyh,Lzh,aLh,dRh,dR2h,Wh,Lhalo
      Real*8 Xcc,Ycc,Zcc,Vcx,Vcy,Vcz,dR,dR2,X,Y,Z
      Real*8 Lzh1,Lzh2,Lzh3,Lzh5,aMh1,aMh2,aMh3,aMh5
      Real*8 R1,R2,R3,R5,Rh1,Rh2,Rh3,Rh5
      Real*8 Xx2,Yy2,Zz2

      DATA Vcx,Vcy,Vc,dR,dR2,V2/6*0.d+0/
      DATA Lx,Ly,Lz,Lxh,Lyh,Lzh,Wh,dRh,dR2h/9*0.d+0/
      DATA Lz1,Lz2,Lz3,Lz5,aM1,aM2,aM3,aM5/8*0.d+0/
      DATA Lzh1,Lzh2,Lzh3,Lzh5,aMh1,aMh2,aMh3,aMh5/8*0.d+0/
      DATA R1,R2,R3,R5,Rh1,Rh2,Rh3,Rh5/8*0.d+0/

      Rad1 =1.
      Rad2 =2.
      Rad3 =3.
      Rad5 =5. 
      Xcc = Box/2.
      Ycc = Box/2.
      Zcc = Box/2.
      Xx2=0.               ! find moments of inertia
      Yy2=0.
      Zz2=0.
      n_cooled = 0

      Do jp=1,N
         X = (Xp(jp)- Xcc) *1000.  ! scale to kpc inits
         Y = (Yp(jp)- Ycc) *1000.
         Z = (Zp(jp)- Zcc) *1000.
            aLx =Y*VZp(jp)  -Z*VYp(jp)
            aLy =Z*VXp(jp)   -X*VZp(jp)
            aLz =X*VYp(jp)   -Y*VXp(jp)
             dd = X**2 + Y**2 + Z**2
             ds = sqrt(dd)
                     If(iMask(jp).gt.0)Then
                        n_cooled =n_cooled +1
                         Lx =Lx +aLx
                         Ly =Ly +aLy
                         Lz =Lz +aLz
                        dR = dR + ds
                        dR2= dR2+ dd
                        If(ds.le.Rad5)Then
                           Lz5 =Lz5 +aLz
                           aM5 = aM5 + 1
                           R5  = R5 + ds
                           If(ds.le.Rad3)Then
                              Lz3 =Lz3 +aLz
                              aM3 = aM3 + 1
                              R3  = R3 + ds
                               If(ds.le.Rad2)Then
                                 Lz2 =Lz2 +aLz
                                 aM2 = aM2 + 1
                                 R2  = R2 + ds
                                  If(ds.le.Rad1)Then
                                    Lz1 =Lz1 +aLz
                                    aM1 = aM1 + 1
                                    R1  = R1 + ds
                                  EndIf
                               EndIf
                            EndIf
                         EndIf
                    Else
                        W = iWeight(jp)
                         Lxh =Lxh +aLx*W
                         Lyh =Lyh +aLy*W
                         Lzh =Lzh +aLz*W
                        dRh = dRh + ds*W
                        dR2h= dR2h+ dd*W
                        Vcx  = Vcx + VXp(jp) *W
                        Vcy  = Vcy + VYp(jp) *W
                        Vcz  = Vcz + VZp(jp) *W
                        Wh = Wh + iWeight(jp)
                        If(ds.le.Rad5)Then
                           Lzh5 =Lzh5 +aLz*W
                           aMh5 = aMh5 + W
                           Rh5  = Rh5 + ds*W
                           If(ds.le.Rad3)Then
                              Lzh3 =Lzh3 +aLz*W
                              aMh3 = aMh3 + W
                              Rh3  = Rh3 + ds*W
                               If(ds.le.Rad2)Then
                                 Lzh2 =Lzh2 +aLz*W
                                 aMh2 = aMh2 + W
                                 Rh2  = Rh2 + ds*W
                                  If(ds.le.Rad1)Then
                                    Lzh1 =Lzh1 +aLz*W
                                    aMh1 = aMh1 + W
                                    Rh1  = Rh1 + ds*W
                                  EndIf
                               EndIf
                            EndIf
                         EndIf
                     EndIf
         V2 = V2 +  VXp(jp)**2 +VYp(jp)**2+VZp(jp)**2
      EndDo
      
      Lx =Lx/n_cooled
      Ly =Ly/n_cooled
      Lz =Lz/n_cooled
      V2 =sqrt(V2/N)
      aL = sqrt(Lx**2 +Ly**2 +Lz**2)
      dR = dR/n_cooled
      Lhalo = sqrt(Lxh**2 +Lyh**2 +Lzh**2)
      
      write (*,110) 
     &           dR,sqrt(dR2/n_cooled),
     &           V2,Lx/aL,Ly/aL,Lz/aL,aL/dR,aL*n_cooled,
     &            aL,
     &            Lhalo,Lxh,Lyh,Lzh,
     &            Lhalo/Wh,Lxh/Wh,Lyh/Wh,Lzh/Wh
      write (37,110) 
     &           dR,sqrt(dR2/n_cooled),
     &           V2,Lx/aL,Ly/aL,Lz/aL,aL/dR,aL*n_cooled,
     &            aL,
     &            Lhalo,Lxh,Lyh,Lzh,
     &            Lhalo/Wh,Lxh/Wh,Lyh/Wh,Lzh/Wh
 110  format(
     &           5x,' Aver Distance Disk Particles(kpc)=',g11.4,
     &                  ' rms distance(kpc)=',g11.4,/
     &           5x,' rms Velocity=',g11.4,' km/s',/
     &           5x,' Disk Ang.Momentum: direction=',3g11.3,/
     &           5x,' Disk Ang.Momentum: L/<R> =',g11.4,' km/s',/
     &           5x,' Disk Ang.Momentum: L     =',g11.4,' kpc*km/s',/
     &           5x,' Disk Ang.Momentum: L/M   =',g11.4,' kpc*km/s',/
     &           5x,' Halo Ang.Momentum: L     =',4g11.4,' kpc*km/s',/
     &           5x,' Halo Ang.Momentum: L/M   =',4g11.4,' kpc*km/s')
      write (*,120) Vcx/Wh, Vcy/Wh,Vcz/Wh,Wh
      write (37,120) Vcx/Wh, Vcy/Wh,Vcz/Wh,Wh

 120  format(
     &           5x,' Aver Velocity of Dm Particles(km/s)=',3g11.3,
     &              ' Total Weight=',g11.3)
      write (37,140)      
      write (37,130) Rad1,
     &           Lz1,Lz1/max(aM1,1.d+0),Lz1/max(R1,1.d-10),
     &           R1/max(aM1,1.d+0),aM1,
     &           Lzh1,Lzh1/max(aMh1,1.d+0),Lzh1/max(Rh1,1.d-10),
     &           Rh1/max(aMh1,1.d+0),aMh1
      write (37,130) Rad2,
     &           Lz2,Lz2/max(aM2,1.d+0),Lz2/max(R2,1.d-10),
     &           R2/max(aM2,1.d+0),aM2,
     &           Lzh2,Lzh2/max(aMh2,1.d+0),Lzh2/max(Rh2,1.d-10),
     &           Rh2/max(aMh2,1.d+0),aMh2
      write (37,130) Rad3,
     &           Lz3,Lz3/max(aM3,1.d+0),Lz3/max(R3,1.d-10),
     &           R3/max(aM3,1.d+0),aM3,
     &           Lzh3,Lzh3/max(aMh3,1.d+0),Lzh3/max(Rh3,1.d-10),
     &           Rh3/max(aMh3,1.d+0),aMh3
      write (37,130) Rad5,
     &           Lz5,Lz5/max(aM5,1.d+0),Lz5/max(R5,1.d-10),
     &           R5/max(aM5,1.d+0),aM5,
     &           Lzh5,Lzh5/max(aMh5,1.d+0),Lzh5/max(Rh5,1.d-10),
     &           Rh5/max(aMh5,1.d+0),aMh5
           time = Age(AEXPN)-Age(0.60)
      write (18,150) AEXPN,time/1.e9,ISTEP,aL*n_cooled,
     &           bar_angle*180./3.1415926,
     &           bar_length,sqrt(1.-bar_ecc),
     &           Rad1,Lz1/max(aM1,1.d+0),aM1,
     &           Rad2,Lz2/max(aM2,1.d+0),aM2,
     &           Rad5,Lz5/max(aM5,1.d+0),aM5


 150  format(2f8.4,i4,g12.5,3f8.3,4(2x,f6.1,g11.3,g11.3))
 140  format(' Rad(kpc) Disk:Lz',4x,'Lz/M',2x,'<Vrotat>km/s',1x,
     &           '<R>kpc  Npart',3x,' Halo:  Lz',4x,'Lz/M',2x,
     &           '<Vrotat>km/s',1x,'<R>kpc  Npart')
 130  format(f7.2,2(2g11.3,2f7.2,g11.3,3x))
      Return
      End
C------------------------------------------
C                  write particles in a file       
      SUBROUTINE DumpPnts(N,Box,ScaleM)
C------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMcool.h'
      Real*8 MassTot

      Xcc = Box/2.
      Ycc = Box/2.
      Zcc = Box/2.

      MassTot =0.
      Do jp=1,N
         MassTot = MassTot + iWeight(jp)
      EndDo
      MassTot = MassTot * ScaleM

      i_halo = 1   ! only one halo cooled
      n_cooled = iph_cool(i_halo,1)

      write(20,100)
      write(20,110) N,n_cooled,age(AEXPN)-age(0.6),ISTEP,
     &                  ScaleM, ScaleM*n_cooled, MassTot 
      write(20,115) 

c      CALL GetDensity(Box)
      Do jp=1,N
         If(iMask(jp).gt.0)Then   ! DM particle
         xx = (Xp(jp)-Xcc)*1000.
         yy = (Yp(jp)-Ycc)*1000.
         zz = (Zp(jp)-Zcc)*1000.


         write (20,130)  xx,yy,zz,
     &              VXp(jp) ,VYp(jp),VZp(jp)
c                   xx*VYp(jp)-yy*VXp(jp) 
c     &                          INT(iWeight(jp)+0.1)
         EndIf 
      EndDo

 100  format(' TotalPart  N: Disk ',
     &             T32,'Time',T42,'Step',
     &             T48,'MassParticle',T62,'MassDisk',
     &             T74,'MassTotal',/
     &             T32,'(yrs)',T48,'(Msun)',T62,'(Msun)',
     &             T74,'(Msun)')
 115  format(T3,'X(kpc)       Y          Z',
     &             T38,'Vx(kms)         Vy           Vz')
 110  format(i10,i7,T30,1P,g11.3,T41,i4,
     &              T48,g11.4,T62,g11.4,T74,g11.4)
 120  format(1P,3g13.5,2x,3g12.4,i3)
 130  format(3g13.5,2x,4g12.4,i3)
      Return
      End

C------------------------------------------
C                            Change positions: center, inclination
      SUBROUTINE ChangePnts(N,Box,ScaleH)
C------------------------------------------
      PARAMETER (pi =3.14159265) ! 
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMcool.h'
      Real*8 xshift,yshift,zshift,Lx,Ly,Lz,aL,Xc,Yc,Zc,V2
      Real*8 Xcc,Ycc,Zcc,Vcx,Vcy,Vcz,dR,dR2,aCos,Ld
      Real*8 Xx,Yy,Zz,XY

      Ncenter = N/2
      If(Ncenter.eq.0)write (*,*) ' Error!!  No particles in ChangePnts'

      Xcc = Box/2.
      Ycc = Box/2.
      Zcc = Box/2.
      V2 =0.
      xmax =-1.d+9
      xmin = 1.d+9
      ymax =-1.d+9
      ymin = 1.d+9
      zmax =-1.d+9
      zmin = 1.d+9
      Rselect = 0.250
      Xc0       = Xcc
      Yc0       = Ycc
      Zc0       = Zcc
      R2        = Rselect**2
      Ncount    = 0
      dn        =0.
 300  nn          = 0
      dn0 =dn
      Xc = 0.
      Yc = 0.
      Zc = 0.
      Lx = 0.
      Ly = 0.
      Lz = 0.
      dR = 0.
      dR2 = 0.
      Vcx = 0.
      Vcy = 0.
      Vcz = 0.
c                                         Find center of mass and mean V
      Do jp=1,Ncenter
         dd = (Xp(jp) -Xc0)**2 +(Yp(jp) -Yc0)**2 +(Zp(jp) -Zc0)**2
         If(dd.lt.R2)Then
            nn = nn + 1
           Xc = Xc +Xp(jp)
           Yc = Yc +Yp(jp)
           Zc = Zc +Zp(jp)
           Vcx = Vcx + Vxp(jp)
           Vcy = Vcy + Vyp(jp)
           Vcz = Vcz + Vzp(jp)
         EndIf
      EndDo
      If(nn.eq.0)write (*,*) ' Error:  no particles found. R=',Rselect
      Xc = Xc/nn
      Yc = Yc/nn
      Zc = Zc/nn
      Vcx = Vcx/nn
      Vcy = Vcy/nn
      Vcz = Vcz/nn
      xshift = Xcc - Xc   ! displacements to bring
      yshift = Ycc - Yc   ! the center to {Xcc,Ycc,Zcc}
      zshift = Zcc - Zc
c      write (*,100) nn,Rselect*1000.,nn/Rselect**3,Xc,Yc,Zc,
c     &                   1000.*xshift,1000.*yshift,1000.*zshift,
c     &                    Vcx,Vcy,Vcz
 100  format('--- Center: n=',i8,f7.2,g11.2,
     &                 '  X(Mpc)=',3g12.6,/
     &           25x,'shift(kpc)             =',3g11.5,/
     &           25x,' average Velocity(km/s)=',3g11.4)
      Xc0       = Xc
      Yc0       = Yc
      Zc0       = Zc
      Ncount = Ncount +1
      Rselect = Rselect/1.1
      R2         = Rselect**2
      dn          = nn/Rselect**3
      If(Ncount.lt.180.and.Rselect.gt.0.2e-3.and.nn.gt.20)goto300
       write (37,100) nn,Rselect*1000.,nn/Rselect**3,Xc,Yc,Zc,
     &                   1000.*xshift,1000.*yshift,1000.*zshift,
     &                    Vcx,Vcy,Vcz
       n_cooled =0
      Do jp=1,N
         Xp(jp) =Xp(jp) +xshift
         Yp(jp) =Yp(jp) +yshift
         Zp(jp) = Zp(jp) +zshift
         VXp(jp) = VXp(jp) +ScaleH*(Xp(jp) -Xcc)-Vcx
         VYp(jp) = VYp(jp) +ScaleH*(Yp(jp) -Ycc)-Vcy
         VZp(jp) = VZp(jp) +ScaleH*(Zp(jp) -Zcc)-Vcz
                  IF(Xp(jp).lt.0.)Xp(jp)=Xp(jp) +Box 
                  IF(Yp(jp).lt.0.)Yp(jp)=Yp(jp) +Box 
                  IF(Zp(jp).lt.0.)Zp(jp)=Zp(jp) +Box
                  IF(Xp(jp).GE.Box)Xp(jp)=Xp(jp) -Box 
                  IF(Yp(jp).GE.Box)Yp(jp)=Yp(jp) -Box 
                  IF(Zp(jp).GE.Box)Zp(jp)=Zp(jp) -Box
                     If(iMask(jp).gt.0)Then   ! cooled particle
                        n_cooled = n_cooled +1
                         Lx =Lx +(Yp(jp)-Ycc)*VZp(jp)
     &                             -(Zp(jp)-Zcc)*VYp(jp)
                         Ly =Ly +(Zp(jp)-Zcc)*VXp(jp)
     &                             -(Xp(jp)-Xcc)*VZp(jp)
                         Lz =Lz +(Xp(jp)-Xcc)*VYp(jp)
     &                             -(Yp(jp)-Ycc)*VXp(jp)
                        dd = (Xp(jp)-Xcc)**2 +
     &                        (Yp(jp)-Ycc)**2 + (Zp(jp)-Zcc)**2
                        dR = dR + sqrt(dd)
                        dR2= dR2+ dd
                        V2 = V2 + VXp(jp)**2+VYp(jp)**2+VZp(jp)**2
                     EndIf
         xmin =min(xmin,Xp(jp))
         ymin =min(ymin,Yp(jp))
         zmin =min(zmin,Zp(jp))
         xmax =max(xmax,Xp(jp))
         ymax =max(ymax,Yp(jp))
         zmax =max(zmax,Zp(jp))
      EndDo


     
      Lx =Lx/n_cooled
      Ly =Ly/n_cooled
      Lz =Lz/n_cooled
      V2 =sqrt(V2/n_cooled)
      aL = sqrt(Lx**2 +Ly**2 +Lz**2)
      dR = dR/n_cooled
      write (*,110) xmin,xmax,ymin,ymax,zmin,zmax,
     &           1000.*dR,1000.*sqrt(dR2/n_cooled),
     &           V2,Lx/aL,Ly/aL,Lz/aL,aL/dR,aL*1000.*n_cooled
 110  format(' --- All particles:  Xmin/max=',2g11.4,/
     &           30x,2g11.4,/30x,2g11.4/,
     &           25x,' Aver Distance Disk Particles(kpc)=',g11.4,
     &                  ' rms distance(kpc)=',g11.4,/
     &           25x,' rms Velocity=',g11.4,' km/s',/
     &           25x,' Disk Ang.Momentum: direction=',3g11.4,/
     &           25x,' Disk Ang.Momentum: L/<R> =',g11.4,' km/s',/
     &           25x,' Disk Ang.Momentum: L     =',g12.5,' kpc*km/s')
c                                      Rotate the system of coordinates
         return
c
      If(Lz.le.0.5*aL)Then
         write (*,*) '         z-component of angular momentum',
     &     '                is too small. Something is very wrong.'

c         Stop
      EndIf
      aCos = 0.99999d-0
      If(Lz.gt.aCos*aL)Then
         write (*,*) '     Tilt is too small (Cos>',aCos,'). No change' 
         Return
      EndIf
c                                 Find maxtrix for rotation
      Lx =Lx/aL
      Ly =Ly/aL
      Lz =Lz/aL
c      Ld =sqrt(Lx**2 +Ly**2)
c      If(Ly.gt.0.)Then
c         ex1 =  Ly/Ld
c         ey1 = -Lx/Ld
c         ex2 =  Lx*Lz/Ld
c         ey2 = Ly*Lz/Ld
c         ez2 = -Ld
c      Else
c         ex1 = -Ly/Ld
c         ey1 =  Lx/Ld
c         ex2 =  -Lx*Lz/Ld
c         ey2 = -Ly*Lz/Ld
c         ez2 =  Ld
c      EndIf
c      ez1 =0.
      Ld =sqrt(Lx**2 +Lz**2)
         ex1 =  Lz/Ld
         ey1 = 0.
         ez1 = -Lx/Ld
         ex2 = -Lx*abs(Ly)/Ld
         ey2 =  Ld
         ez2 = -Lz*abs(Ly)/Ld
c         If(Ly.lt.0.)ey2 = -Ld
      ex3 =Lx
      ey3 =Ly
      ez3 =Lz
c                     Check if the vectors are (1) unit (2) orthogonal
      prod1 = ex1*Lx +ey1*Ly +ez1*Lz
      prod2 = ex2*Lx +ey2*Ly +ez2*Lz
      prod3 = ex1*ex2 +ey1*ey2 +ez1*ez2
      a1       = Lx**2 +Ly**2 +Lz**2
      a2       = ex1**2 +ey1**2 +ez1**2
      a3       = ex2**2 +ey2**2 +ez2**2
      write (*,*) ' Vector 1=',ex1,ey1,ez1 
      write (*,*) ' Vector 2=',ex2,ey2,ez2 
      write (*,*) ' Vector 3=',ex3,ey3,ez3 
      write (*,*) ' Vector lengths=', a1,a2,a3,' must be 1'
      write (*,*) ' Vector products=', prod1,prod2,prod3,' must be 0'
      if(abs(a1-1.).gt.1.e-2)stop
      if(abs(a2-1.).gt.1.e-2)stop
      if(abs(a2-1.).gt.1.e-2)stop
      if(abs(prod1).gt.1.5e-1)stop
      if(abs(prod2).gt.1.5e-1)stop
      if(abs(prod3).gt.1.5e-1)stop
      xmax =-1.d+9
      xmin = 1.d+9
      ymax =-1.d+9
      ymin = 1.d+9
      zmax =-1.d+9
      zmin = 1.d+9
      dR = 0.
      dR2 = 0.
      V2 = 0.
      Lx = 0.
      Ly = 0.
      Lz = 0.
      Do jp=1,N
         Xnew = ex1*(Xp(jp)-Xcc) +ey1*(Yp(jp)-Ycc) +ez1*(Zp(jp)-Zcc)+Xcc
         Ynew = ex2*(Xp(jp)-Xcc) +ey2*(Yp(jp)-Ycc) +ez2*(Zp(jp)-Zcc)+Ycc
         Znew = ex3*(Xp(jp)-Xcc) +ey3*(Yp(jp)-Ycc) +ez3*(Zp(jp)-Zcc)+Zcc
         VXnew = ex1*Vxp(jp) +ey1*Vyp(jp) +ez1*Vzp(jp)
         VYnew = ex2*Vxp(jp) +ey2*Vyp(jp) +ez2*Vzp(jp)
         VZnew = ex3*Vxp(jp) +ey3*Vyp(jp) +ez3*Vzp(jp)
         Xp(jp) = Xnew
         Yp(jp) = Ynew
         Zp(jp) = Znew
                  IF(Xp(jp).lt.0.)Xp(jp)=Xp(jp) +Box 
                  IF(Yp(jp).lt.0.)Yp(jp)=Yp(jp) +Box 
                  IF(Zp(jp).lt.0.)Zp(jp)=Zp(jp) +Box
                  IF(Xp(jp).GE.Box)Xp(jp)=Xp(jp) -Box 
                  IF(Yp(jp).GE.Box)Yp(jp)=Yp(jp) -Box 
                  IF(Zp(jp).GE.Box)Zp(jp)=Zp(jp) -Box
         Vxp(jp) = VXnew 
         Vyp(jp) = VYnew 
         Vzp(jp) = VZnew 
                     xmax =MAX(xmax,Xp(jp))
                     xmin  =MIN(xmin,Xp(jp))
                     ymax =MAX(ymax,Yp(jp))
                     ymin  =MIN(ymin,Yp(jp))
                     zmax =MAX(zmax,Zp(jp))
                     zmin  =MIN(zmin,Zp(jp))
                     If(iMask(jp).gt.0)Then
                         Lx =Lx +(Yp(jp)-Ycc)*VZp(jp)
     &                             -(Zp(jp)-Zcc)*VYp(jp)
                         Ly =Ly +(Zp(jp)-Zcc)*VXp(jp)
     &                             -(Xp(jp)-Xcc)*VZp(jp)
                         Lz =Lz +(Xp(jp)-Xcc)*VYp(jp)
     &                             -(Yp(jp)-Ycc)*VXp(jp)
                        dd = (Xp(jp)-Xcc)**2 +
     &                        (Yp(jp)-Ycc)**2 + (Zp(jp)-Zcc)**2
                        dR = dR + sqrt(dd)
                        dR2= dR2+ dd
                     EndIf

         V2 = V2 +  VXp(jp)**2 +VYp(jp)**2+VZp(jp)**2         
      EndDo
      Lx =Lx/n_cooled
      Ly =Ly/n_cooled
      Lz =Lz/n_cooled
      V2 =sqrt(V2/N)
      aL = sqrt(Lx**2 +Ly**2 +Lz**2)
      dR = dR/n_cooled
      write (*,*) '--- After rotation of the coordinates'
      write (*,110) xmin,xmax,ymin,ymax,zmin,zmax,
     &           1000.*dR,1000.*sqrt(dR2/n_cooled),V2,
     &           Lx/aL,Ly/aL,Lz/aL,aL/dR,aL*1000.*n_cooled
      Return
      End
C------------------------------------------
C                    Distribution of the angular momentum
C                     of disk and halo particles
      SUBROUTINE AngMom(N,N1,R1,Box,ScaleM)
C------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMcool.h'
      PARAMETER ( Nang = 50, Ntang = 2*Nang+1 )
      PARAMETER ( aMax = 4000. )
      Real*8 Lzd(-Nang:Nang),Lzd1(-Nang:Nang),Lzd2(-Nang:Nang)
      Integer Mzd(-Nang:Nang),Mzd1(-Nang:Nang),Mzd2(-Nang:Nang)
      Real*8 Lzh(-Nang:Nang),Lzh1(-Nang:Nang),Lzh2(-Nang:Nang)
      Integer Mzh(-Nang:Nang),Mzh1(-Nang:Nang),Mzh2(-Nang:Nang)

      DATA Lzd/Ntang*0.d+0/,Lzd1/Ntang*0.d+0/,Lzd2/Ntang*0.d+0/
      DATA Lzh/Ntang*0.d+0/,Lzh1/Ntang*0.d+0/,Lzh2/Ntang*0.d+0/
      DATA Mzd/Ntang*0/,Mzd1/Ntang*0/,Mzd2/Ntang*0/
      DATA Mzh/Ntang*0/,Mzh1/Ntang*0/,Mzh2/Ntang*0/

      Xcc = Box/2.
      Ycc = Box/2.
      Zcc = Box/2.
      hz = aMax/Nang
      Do jp=1,N
         X = (Xp(jp)- Xcc) *1000.  ! scale to kpc inits
         Y = (Yp(jp)- Ycc) *1000.
         Z = (Zp(jp)- Zcc) *1000.
            aLx =Y*VZp(jp)  -Z*VYp(jp)
            aLy =Z*VXp(jp)   -X*VZp(jp)
            aLz =X*VYp(jp)   -Y*VXp(jp)
            dd = X**2 + Y**2 + Z**2
            ds = sqrt(dd)
            ind = INT(aLz/hz+10000.) -10000
            ind = Min(Max(ind,-Nang),Nang)
            If(iMask(jp).gt.0)Then
                     Lzd(ind) =Lzd(ind) +aLz
                     Mzd(ind) =Mzd(ind) + 1
                     If(ds.le.R1)Then
                        Lzd2(ind) =Lzd2(ind) +aLz
                        Mzd2(ind) =Mzd2(ind) + 1
                     EndIf
                     If(jp.le.N1)Then
                        Lzd1(ind) =Lzd1(ind) +aLz
                        Mzd1(ind) =Mzd1(ind) + 1
                     EndIf
            Else
                     W = iWeight(jp)
                     Lzh(ind) =Lzh(ind) +aLz*W
                     Mzh(ind) =Mzh(ind) + W
                     If(ds.le.R1)Then
                        Lzh2(ind) =Lzh2(ind) +aLz*W
                        Mzh2(ind) =Mzh2(ind) + W
                     EndIf

            EndIf
      EndDo

      write (*,100)N1,R1,R1
      write (37,100)N1,R1,R1
 100  format(5x,'Disk',12x,'n<n1=',i5,5x,'r<r1=',f5.1,
     & 7x,'Halo',12x,'n<n1=',i5,5x,'r<r1=',f5.1,/
     &   ' Lz(kpckm/s)','<Lz> Npart',  
     &   '  <Lz>  Npart',
     &   '  <Lz>    Npart',
     &'    <Lz>    Npart',  
     &   '  <Lz>    Npart',
     &   '  <Lz>  Npart')
      Do i=-Nang,Nang
         a = i*hz
         aL = Lzd(i)/Max(Mzd(i),1)
         aL2= Lzd2(i)/Max(Mzd2(i),1)
         aL1= Lzd1(i)/Max(Mzd1(i),1)
         bL = Lzh(i)/Max(Mzh(i),1)
         bL2= Lzh2(i)/Max(Mzh2(i),1)
         write(*,110) a,aL,Mzd(i),aL1,Mzd1(i),aL2,Mzd2(i),
     &                        bL,Mzh(i),bL2,Mzh2(i)
         write(37,110) a,aL,Mzd(i),aL1,Mzd1(i),aL2,Mzd2(i),
     &                        bL,Mzh(i),bL2,Mzh2(i)
      EndDo
 110  format(f7.1,3(f7.1,i6),5x,f8.1,i8,2(f8.1,i6))
      Return
      End
C------------------------------------------
C                                                      
      SUBROUTINE Projection(N,Box,Alpha)
c             Alpha is angle between plain of the disk and
c             plain of projection
c  Zold                                                                                Znew
c   `                      / Disk (Xold)                                            |
c        `                /                                                                |
c             `          /  Alpha                                                     |
c==>>> ------------------------------ Xnew    ==>    -------------------------------Xnew
c                      /                                                                   |
c                     /                                                                    |
c
c           Znew is the distance in the plain of projects
c           Vlos = V_x,new 
c            Average for two observers 90 degrees away
C------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMcool.h'
      Parameter (pi180 = 180./3.1415926535)
      Parameter (pi = 3.1415926535)
      EQUIVALENCE (Ndisk,extras(90))

      drlog =0.05
      d_lim = 0.100
      cosa = COS(Alpha/pi180)
      sina = SIN(Alpha/pi180)
      write (*,*) ' Angle =',Alpha, ' cos/sin=',cosa,sina 
      Xcc = Box/2.
      Ycc = Box/2.
      Zcc = Box/2.
      Do i =-Nrad,Nrad
               Nradp(i) = 0
               Radp(i)  = 0.
               Vradp(i)  = 0.
               Vrad2p(i) = 0.
      EndDo
      
      Do jp=1,Ndisk
         X = (Xp(jp)- Xcc) *1000.  ! scale to kpc inits
         Y = (Yp(jp)- Ycc) *1000.
         Z = (Zp(jp)- Zcc) *1000.
c                        x-z coordinates
            z_new = X*sina +Z*cosa ! z-coord in projection
            If(abs(z_new).le.d_lim)Then     ! inside the strip
             ind = INT(LOG10(ABS(Y))/drlog+1000.) -1000
             ind = min(max(ind,-Nrad),Nrad)
             Vradial = -VXp(jp)*cosa +VZp(jp)*sina
             If(Y.le.0.) Vradial =-Vradial
               Nradp(ind) = Nradp(ind) + 1
               Radp(ind)  = Radp(ind)  + abs(Y)
               Vradp(ind)  = Vradp(ind)  + Vradial
               Vrad2p(ind) = Vrad2p(ind)  + Vradial**2
            EndIf
c                        y-z coordinayes
            z_new = Y*sina +Z*cosa ! z-coord in projection
            If(abs(z_new).le.d_lim)Then     ! inside the strip
             ind = INT(LOG10(ABS(X))/drlog+1000.) -1000
             ind = min(max(ind,-Nrad),Nrad)
             Vradial = VYp(jp)*cosa -VZp(jp)*sina
             If(X.le.0.) Vradial =-Vradial
               Nradp(ind) = Nradp(ind) + 1
               Radp(ind)  = Radp(ind)  + abs(X)
               Vradp(ind)  = Vradp(ind)  + Vradial
               Vrad2p(ind) = Vrad2p(ind)  + Vradial**2
            EndIf
      EndDo
      V1 =0
      write(37,90) Alpha
 90   format(1x,10('-'),'Projection along major axis',10('-'),/
     &    '  Rout(kpc)   Rdisk  ',
     &            '  Vrot   sig_v_rot   Npart Alpha=',f7.2)
      Do  i=-Nrad+1,Nrad-1
         rad_out = 10.**((i+1)*drlog)
         nn = Nradp(i)
         Din = Din + nn
         n0 = max(nn,1)
         Raddisk  = Radp(i)/n0
         If(nn.eq.0)Raddisk=rad_out 
         Vradial = Vradp(i)/n0
         Vradial2=sqrt(max(Vrad2p(i)/n0-Vradial**2,1.e-10))
         If(nn.gt.20)Then
            write(37,100)rad_out,Raddisk,
     &           Vradial/cosa,Vradial2/cosa,nn
         EndIf
      EndDo
 100  format(2g10.3,2g11.3,i7)

      Return
      End

C------------------------------------------
C                                                      
      SUBROUTINE Profile(N,Box,ScaleM)
C------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMcool.h'
      Parameter (pi180 = 180./3.1415926535)
      Parameter (pi = 3.1415926535)

      drlog =0.075
      Xcc = Box/2.
      Ycc = Box/2.
      Zcc = Box/2.

c                             DM profile   --------------------- spherical shells
      Do jp=1,N
        If(iMask(jp).lt.0)Then  ! not cooled particle
         W = iWeight(jp)
         X = (Xp(jp)- Xcc) *1000.  ! scale to kpc inits
         Y = (Yp(jp)- Ycc) *1000.
         Z = (Zp(jp)- Zcc) *1000.
            dd        = X**2 + Y**2 + Z**2
            ds         = sqrt(dd)
            Vtot      = (VXp(jp)**2+VYp(jp)**2+VZp(jp)**2)
            Vradial = (VXp(jp)*X+VYp(jp)*Y+VZp(jp)*Z) /
     &                      max(ds,1.e-5)
             Vtan2    = Vtot -Vradial**2
             ind = INT(LOG10(ds)/drlog+1000.) -1000
             ind = min(max(ind,-Nrad),Nrad)
               Nradh(ind) = Nradh(ind) + W
               Radh(ind)  = Radh(ind)  + ds*W
               Vfih2(ind)  = Vfih2(ind)  + Vtan2*W
               Vradh(ind)  = Vradh(ind)  + Vradial*W
               Vradh2(ind) = Vradh2(ind)  + Vradial**2*W
        EndIf 
      EndDo 
      V1 = 0.
      Din = 0.
      write(37,90)
 90   format(1x,20('-'),' DM profile',/
     &    '  Rout     Rhalo     Vchalo ',
     &            ' Density  ',
     &            '   Vrad    sigRadial      V_tan     Beta     Nhalo')
      Do  i=-Nrad,Nrad
         rad_out  = 10.**((i+1)*drlog)
         V0          = V1
         V1          = 4.1888*rad_out**3
         wn          = Nradh(i)
         nn           =wn /iWeight(1)
         Din         = Din + wn
         w0          = max(wn,1.e-9)
         densD    = wn/(V1-V0)*ScaleM*1.e-9
         Radhalo = Radh(i)/w0
         If(wn.eq.0)Radhalo=rad_out 
         Vtan       = sqrt(Vfih2(i)/w0)
         Vradial   = Vradh(i)/w0
         Vradial2 =sqrt(max(Vradh2(i)/w0-Vradial**2,1.e-10))
         Vtot        = sqrt((Vradh2(i)+Vfih2(i))/w0)
         Vcirc = 2.08e-3*sqrt(max(Din*ScaleM/rad_out,1.e-10))
         beta  = 1. -Vtan**2/2./(Vradial2**2+Vradial**2)
         If(nn.gt.4)Then
         write(37,100)rad_out,Radhalo,Vcirc,densD,
     &           Vradial,Vradial2,Vtan,beta,nn,INT(Din/iWeight(1))
         EndIf
      EndDo
 100  format(2g10.3,f7.2,
     &        g11.3,1x,4g11.4,2x,i7,i9)
                            ! disk statistics: spherical and cylindrical
c      Do i=-Nrad,Nrad
c         Nradp(i) =0
c      EndDo
      i_halo = 1   ! only one halo cooled
      n_cooled = iph_cool(i_halo,1)
      Do i=1,n_cooled
         jp = ip_cool(i)
         X = (Xp(jp)- Xcc) *1000.  ! scale to kpc inits
         Y = (Yp(jp)- Ycc) *1000.
         Z = (Zp(jp)- Zcc) *1000.
            aLx =Y*VZp(jp)  -Z*VYp(jp)
            aLy =Z*VXp(jp)   -X*VZp(jp)
            aLz =X*VYp(jp)   -Y*VXp(jp)
            dd = X**2 + Y**2 + Z**2
            ds = sqrt(dd)
            rd = X**2 + Y**2 
            rs = sqrt(rd)
            Vrotat  = aLz/max(rs,1.e-5)
            Vradial = (VXp(jp)*X+VYp(jp)*Y+VZp(jp)*Z) /
     &                   max(ds,1.e-5)
             Vvert  = VZp(jp)
             ind = INT(LOG10(ds)/drlog+1000.) -1000
             ind = min(max(ind,-Nrad),Nrad)
                                ! sperical shells
               Nradd(ind) = Nradd(ind) + 1
               Radd(ind)  = Radd(ind)  + ds
               Vfi(ind)   = Vfi(ind)  + Vrotat
c               Vfi2(ind)  = Vfi2(ind)  + Vrotat**2
c               Vrad(ind)  = Vrad(ind)  + Vradial
c               Vrad2(ind) = Vrad2(ind)  + Vradial**2
c               Vzz(ind)   = Vzz(ind)  + Vvert
c               Vzz2(ind)  = Vzz2(ind)  + Vvert**2

                                ! projection on the plane
             ind = INT(LOG10(rs)/drlog+1000.) -1000
             ind = min(max(ind,-Nrad),Nrad)
               Nradp(ind) = Nradp(ind) + 1
               Radp(ind)  = Radp(ind)  + rs
               Vfip(ind)   = Vfip(ind)  + Vrotat
               Vfi2p(ind)  = Vfi2p(ind)  + Vrotat**2
               Vradp(ind)  = Vradp(ind)  + Vradial
               Vrad2p(ind) = Vrad2p(ind)  + Vradial**2
               Vzzp(ind)   = Vzzp(ind)  + Vvert
               Vzz2p(ind)  = Vzz2p(ind)  + Vvert**2
                               ! projection along wedges
               inf = -1
               If(abs(Y)/rs.lt.0.5) inf =1  ! along the bar
               If(abs(X)/rs.lt.0.5) inf =2  ! perpendic  bar
               IF(inf.gt.0)Then
                  Nradb(ind,inf) = Nradb(ind,inf) + 1
                  Radb(ind,inf)  = Radb(ind,inf)  + rs
                  Vfib(ind,inf)   = Vfib(ind,inf)  + Vrotat
                  Vfi2b(ind,inf)  = Vfi2b(ind,inf)  + Vrotat**2
                  Vradb(ind,inf)  = Vradb(ind,inf)  + Vradial
                  Vrad2b(ind,inf) = Vrad2b(ind,inf)  + Vradial**2
                  Vzzb(ind,inf)   = Vzzb(ind,inf)  + Vvert
                  Vzz2b(ind,inf)  = Vzz2b(ind,inf)  + Vvert**2
               EndIf
      EndDo
                       ! print statistics ------------------------------
      V1 = 0.
      Din = 0.
      write(39,92)
 92   format(1x,20('-'),'All components: Spherical shells',/
     &    '  Rout     Rdisk      Vchalo Vcdisk Vcbulge Vctot',
     &    '  Vrot_disk',6x,'Nhalo',11x,'Ndisk',14x,'Nbulge')
      Do  i=-Nrad,Nrad
         rad_out  = 10.**((i+1)*drlog)
         V0          = V1
         V1          = 4.1888*rad_out**3
         wn          = Nradh(i)
         nn           =wn /iWeight(1)
         Din         = Din + wn
         w0          = max(wn,1.e-9)
         Radhalo     = Radh(i)/w0
         If(wn.eq.0)Radhalo=rad_out 
         nd          = Nradd(i)
         Dind        = Dind + nd
         n0          = max(nd,1)
         Raddisk = Radd(i)/n0
         Vrotat =Vfi(i)/n0
         If(nd.eq.0)Raddisk=rad_out 
         nbl         = Nradg(i)
         Dinbl       = Dinbl + nbl
         n0          = max(nbl,1)
         Radbulge    = Radg(i)/n0
         If(nbl.eq.0)Radbulge=rad_out 

         Vcirc = 2.08e-3*sqrt(max((Din+Dind+Dinbl)*ScaleM/rad_out,
     &                                             1.e-10))
         VcD  =  2.08e-3*sqrt(max((    Dind)*ScaleM/rad_out,1.e-10))
         VcH  =  2.08e-3*sqrt(max((Din     )*ScaleM/rad_out,1.e-10))
         VcBl =  2.08e-3*sqrt(max((Dinbl   )*ScaleM/rad_out,1.e-10))

         If(nn.gt.10)Then
         write(39,105)rad_out,Raddisk,VcH,VcD,VcBl,Vcirc,
     &           Vrotat,INT(wn),INT(Din),
     &           nd,INT(Dind),nbl,INT(Dinbl)
         EndIf
      EndDo
 105  format(2g10.3,f8.2,4f7.2,i8,2x,i8,2x,i6,4(2x,i8))
                         ! cylindrical shells: print ---------------------
      V1 = 0.
      Din = 0.
      write(41,94)
 94   format(1x,20('-'),'Cylindrical shells profile: Disk and Bulge',/
     &    '  Rout     Rdisk     Vrot  sig_rotat sig_z sig_rad',
     &    ' SurfDisk SurfBulge   Bar: Vrot sig_rot  Surf',
     &    '  off bar: Vrot sig_rot  Surf')
      Do  i=-Nrad,Nrad
         rad_out  = 10.**((i+1)*drlog)
         V0          = V1
         V1          = 3.141592*rad_out**2
         nd          = Nradp(i)
         Dind       = Dind + nd
         n0          = max(nd,1)
         Raddisk = Radp(i)/n0
         If(nd.eq.0)Raddisk=rad_out 


         Vrotat =Vfip(i)/n0            ! all disk 
         V2p     =sqrt(max(Vfi2p(i)/n0-Vrotat**2,1.e-10))
         Vwz      =sqrt(Vzz2p(i)/n0)
         Vradial =sqrt(Vrad2p(i)/n0)
         Surf     = nd/(V1-V0)
         SurfBl   = Nradu(i)/(V1-V0)

         nb     = Nradb(i,1)           ! along bar +- 30 degrees
         n0b   = max(nb,1)
         VrotatB =Vfib(i,1)/n0b
         V2B     =sqrt(max(Vfi2b(i,1)/n0b-VrotatB**2,1.e-10))
         SurfB    = nb/(V1-V0)*3.     ! correction for 30degrees

         nb     = Nradb(i,2)             ! off bar +- 30 degrees
         n0b   = max(nb,1)
         VrotatN =Vfib(i,2)/n0b
         V2N     =sqrt(max(Vfi2b(i,2)/n0b-VrotatN**2,1.e-10))
         SurfN    = nb/(V1-V0)*3.   

         vvv =sqrt(Vfi2b(i,2)/n0b)
c         write (*,'(4i6,6g11.3)') nd,n0,Nradb(i,1),Nradb(i,2),
c     &    Radp(i),rad_out,VrotatB ,V2B,VrotatN ,V2N
         If(nd.gt.10)Then
         write(41,107)rad_out,Raddisk,
     &                      Vrotat ,V2p,Vwz,Vradial,Surf,SurfBl,
     &                      VrotatB,V2B,SurfB,
     &                      VrotatN,V2N,SurfN
         EndIf
      EndDo
 107  format(2g10.3,4f7.2,2g11.3,3x,2f7.2,g11.3,3x,2f7.2,g11.3)

      Return
      End

C------------------------------------------
C                      Read cooled particles, set Mask
      SUBROUTINE ReadCool
C------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMcool.h'
      Real xmax(2),xmin(2),ymax(2),ymin(2),
     +          zmax(2),zmin(2),vmax(2),vmin(2)
      DATA xmax,ymax,zmax,vmax/8*0.e-0/
      DATA xmin,ymin,zmin,vmin/8*0.e+15/

      read(10) n_halo
      IF(n_halo .gt. nh_cool) THEN
        write(*,*) 'n_halo .gt. nh_cool', n_halo, nh_cool
        write(*,*) 'increase nh_cool in a_cooling.h'
        STOP
      ENDIF

      kkL = 0   ! last index of the previous halo
      DO k = 1, n_halo
        read(10) (iph_cool(k,i),i =1,3),(halo_prop(k,kk),kk = 1,nh_prop)
        write(*,*) 'halo # :',k, '  iph_cool(k,i) = ',
     +           (iph_cool(k,i),i =1,3)     
        IF(iph_cool(k,1) .gt. n_cool)  THEN
          write(*,*) 'iph_cool(k,1) .gt. nh_cool',iph_cool(k,1),n_cool
          write(*,*) 'increase n_cool in a_cooling.h'
          STOP
        ENDIF
        kkF = kkL + 1                 ! read First particle
        if (kkF .NE. iph_cool(k,2)) write(*,*) 'ERROR in kkF'
        kkL = kkF + iph_cool(k,1) - 1   ! read Last particle
        if (kkL .NE. iph_cool(k,3)) write(*,*) 'ERROR in kkL'
        read(10) (ip_cool(kk), kk = iph_cool(k,2),iph_cool(k,3))
      ENDDO
      close (10)

      i_halo = 1   ! only one halo cooled
      n_cooled = iph_cool(i_halo,1)
      write(*,*) 'n_cooled = ', n_cooled
      Do i=1,Np
         iMask(i) = -1
      EndDo 
      DO k = 1, n_cooled
        i = ip_cool(k)
        iMask(i) = k
       ENDDO

       Return
      End
C------------------------------------------
C                                                      Read particles
      SUBROUTINE ReadPnts(N,ScaleC,ScaleV,ScaleM)
C------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMcool.h'

      Integer Xdist(0:25),Ydist(0:25),Zdist(0:25)
      Real*8 TotWeight

      Box     = ScaleC*NGRID
      Radius2 = Radius**2

      N       = 0                            ! Number of particles
      Nsm     = 0
      TotWeight =0.
      xmax =-1.e+9
      xmin = 1.e+9
      ymax =-1.e+9
      ymin = 1.e+9
      zmax =-1.e+9
      zmin = 1.e+9
      vmax =-1.e+9
      vmin = 1.e+9
c      Do i=0,25
c         Xdist(i) =0
c         Ydist(i) =0
c         Zdist(i) =0
c      Enddo 
      Icount   = 0
      Icount_p = Icount-1
      ifile    = 1
      If(Nspecies.eq.0)Then ! old case: 1 complete set
         Npages =NROW          ! Number of pages
         N_in_last=NPAGE       ! Number of particles in last page
      Else                             ! multiple masses
         N_particles =lspecies(Nspecies)   ! Total number of particles
cc         N_particles =          N_particles/3 !!!!!

         Npages = (N_particles -1)/NPAGE +1
         N_in_last=N_particles -NPAGE*(Npages-1)
      EndIf
      write (*,*) ' Pages=',Npages,' Species=',Nspecies
c      write (*,*) ' N_in_last=',N_in_last
C				       Loop over particles
       DO IROW=1,Npages
            In_page =NPAGE
            If(IROW.eq.Npages)In_page =N_in_last
c            write (*,*)' Read page=',IROW,' file=',ifile,' N=',N
            iL = NPAGE*(IROW-1)
	      CALL GETROW(IROW,ifile)
                  Icount_p=Icount
	      DO IN=1,In_page
	        X  =ScaleC* (XPAR(IN)-1.)
	        Y  =ScaleC* (YPAR(IN)-1.)
	        Z  =ScaleC* (ZPAR(IN)-1.)
C           write (*,'(i8,10g11.4)') IN+iL,
c     &              X,Y,Z,XPAR(IN),YPAR(IN),ZPAR(IN)
                Vxs=ScaleV* VX(IN)
                Vys=ScaleV* VY(IN)
                Vzs=ScaleV* VZ(IN)
                Icount =Icount +1
                vmax =MAX(vmax,Vxs,Vys,Vzs)
                vmin =MIN(vmin,Vxs,Vys,Vzs)
                If(Nspecies.eq.0)Then   ! find weight of particle
                   W =PARTW
                Else
                   Ipart =IN+iL             ! current particle number
                   Do i =1,Nspecies
                      if(Ipart.le.lspecies(i))Then
                         W =wspecies(i)
                         goto 50
                      endif 
                   EndDo 
                EndIf
 50             N   = N +1
                  If(Ipart.le.lspecies(1))Nsm=Nsm +1
                  IF(N.gt.Np)Then    ! too many particles
                           write (*,*) ' Too many particles. Max=',Np
                           STOP
                  Endif 
                  Xp(N)  =X   
                  Yp(N)  =Y   
                  Zp(N)  =Z   
                  Vxp(N)  =Vxs   
                  Vyp(N)  =Vys   
                  Vzp(N)  =Vzs   
                  Ipart  =IN+iL                     ! current particle number
                  iWeight(N) = INT(W/wspecies(1)+0.1) !  particles weight   iWeight(Ipart) 
                  TotWeight = TotWeight + iWeight(N) 
                  If(iWeight(N).lt.1.001)Then
                     xmax =MAX(xmax,Xp(N))
                     xmin  =MIN(xmin,Xp(N))
                     ymax =MAX(ymax,Yp(N))
                     ymin  =MIN(ymin,Yp(N))
                     zmax =MAX(zmax,Zp(N))
                     zmin  =MIN(zmin,Zp(N))
c                     ii =Min(INT(X/Box*25.),25)
c                     jj =Min(INT(Y/Box*25.),25)
c                     kk =Min(INT(Z/Box*25.),25)
c                     Xdist(ii) =Xdist(ii) +1
c                     Ydist(jj) =Ydist(jj) +1
c                     Zdist(kk) =Zdist(kk) +1
                   EndIf
        ENDDO
        ENDDO 
        write (*,*) ' Number of particles selected:=',N,' Small=',Nsm
        write (*,*) ' Limits                              =',xmin,xmax       
        write (*,*) '                                     =',ymin,ymax
        write (*,*) '                                     =',zmin,zmax
        write (*,'(" Total weight         =",1P,g11.3)')TotWeight
        write (*,'(" Total Mass           =",1P,g11.3)')TotWeight*ScaleM

c        write (*,'(i3,2x,i9,2x,i9,2x,i9)')
c     &             (i,Xdist(i),Ydist(i),Zdist(i),i=0,25)
        Return
        End
c     -----------------------------
       Function Age(aexp)
c     -----------------------------
c                                  age for LCDM model 
       PARAMETER (Om0 =0.3)
       PARAMETER (tconst =9.31e+9)
       
       x = ((1.-Om0)/Om0)**0.333333*aexp
       Age = tconst /sqrt(1.-Om0)*(log(x**1.5+sqrt(1.+x**3)))

       Return
       End
C ______________________________ Assign initial values
C		             
C		                     
      BLOCK DATA
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMcool.h'

      DATA Nradd/Nrad2*0/,Vfi/Nrad2*0./,Vrad/Nrad2*0./,
     &          Vzz/Nrad2*0./,Vfi2/Nrad2*0./,Vrad2/Nrad2*0./,
     &           Vzz2/Nrad2*0./,Radd/Nrad2*0./
      DATA Nradb/Nbt*0/,Vfib/Nbt*0./,Vradb/Nbt*0./,
     &          Vzzb/Nbt*0./,Vfi2b/Nbt*0./,Vrad2b/Nbt*0./,
     &           Vzz2b/Nbt*0./,Radb/Nbt*0./
      DATA Nradp/Nrad2*0/,Vfip/Nrad2*0./,Vradp/Nrad2*0./,
     &          Vzzp/Nrad2*0./,Vfi2p/Nrad2*0./,Vrad2p/Nrad2*0./,
     &           Vzz2p/Nrad2*0./,Radp/Nrad2*0./
      DATA Nradu/Nrad2*0/
      DATA Nradh/Nrad2*0/,Vfih/Nrad2*0./,Vradh/Nrad2*0./,
     &         Vfih2/Nrad2*0./,Vradh2/Nrad2*0./,Radh/Nrad2*0./
      DATA Dens/Np*0./
      End
C---------------------------------------------------
      SUBROUTINE RDTAPE(File1,File2)
C---------------------------------------------------
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMcool.h'

      Character  File1*100,File2*100
  
C                                     Open file on a tape
      OPEN(UNIT=9,FILE=File1,
     +     FORM='UNFORMATTED', STATUS='UNKNOWN')
C                                 Read control information
C                                 and see whether it has proper
C                                 structure

      READ  (9,err=10,end=10) HEADER, 
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  TINTG,EKIN,EKIN1,EKIN2,AU0,AEU0,
     +                  NROWC,NGRIDC,Nspecies,Nseed,Om0,Oml0,hubble,Wp5
     +                   ,Ocurv,extras
      Ocurv =0. 

      WRITE (*,100) HEADER, 
     +     AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +     EKIN,
     +     NROWC,NGRID,NRECL,Om0,Oml0,hubble, 
     +     Ocurv


      WRITE (16,100) HEADER,
     +                   AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW, 
     +                  EKIN,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,  
     +                  Ocurv
     
 100  FORMAT(1X,'Header=>',A45,/   
     +     1X,' A=',F8.5,' A0=',F8.3,' Ampl=',F8.3,'Step=',F8.3,/   
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I6,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3)


      IF(NROW.NE.NROWC) THEN
         WRITE (*,*)
     +            ' NROW in PARAMETER and in TAPE-FILE are different'
      ENDIF
      IF(NGRID.NE.NGRIDC) THEN
         WRITE (*,*)
     +           ' NGRID in PARAMETER and in TAPE-FILE are different:'
         write (*,*) ' Ngrid=',NGRID,' NgridC=',NGRIDC
      ENDIF
C                                         Open work file on disk
 10   NBYTE = NRECL*4
      NACCES= NBYTE!/4 !for athena               
      
      
c      write (*,*) ' Open direct access file'
         OPEN(UNIT=21,FILE=File2,ACCESS='DIRECT',
     +	               STATUS='UNKNOWN',RECL=NACCES)
 
      REWIND 9
      RETURN
      END
C--------------------------------------------
C                            Read current PAGE of particles  from disk
C                            NRECL - length of ROW block in words
C--------------------------------------------
      SUBROUTINE GETROW(IROW,Ifile)  
C--------------------------------------------
c      INCLUDE 'Statparam.h'
      INCLUDE 'PMparameters.h'
      INCLUDE 'PMcool.h'

         READ  (20+Ifile,REC=IROW) RECDAT
      RETURN
      END
C--------------------------------------------------------------
C                                           Make linker lists of particles in each cell
      SUBROUTINE GetDensity(Box)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMcool.h'
      EQUIVALENCE (Ndisk,extras(90))

      Cell = Box/Nblink
      dStep = 15.e-6
      Do i=1,5
         RadDens(i) =dStep*i**2  
      EndDo
      write (*,*)  ' GetDens: Cell=',Cell,dStep
      CALL List(Box)
C$OMP PARALLEL DO DEFAULT(SHARED) 
C$OMP+PRIVATE (jp,Density)
      Do jp=1,Ndisk
         CALL Neib(Xp(jp),Yp(jp),Zp(jp),Density) 
         Dens(jp) = Density
      EndDo

      Return
      End
C--------------------------------------------------------------
C                                           Make linker lists of particles in each cell
      SUBROUTINE List(Box)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMcool.h'
      EQUIVALENCE (Ndisk,extras(90)),
     &               (Nbulge,extras(97)),(aMassDisk,extras(93))
             Do i=1,Ndisk
                Lst(i)=-1
             EndDo
             Do k=Nmlink,Nblink
             Do j=Nmlink,Nblink
             Do i=Nmlink,Nblink
                Label(i,j,k)=0
             EndDo
             EndDo
             EndDo  
      Do jp=1,Ndisk
         i=INT(Xp(jp)/Cell)
         j=INT(Yp(jp)/Cell)
         k=INT(Zp(jp)/Cell)
         i=MIN(MAX(Nmlink,i),Nblink)
         j=MIN(MAX(Nmlink,j),Nblink)
         k=MIN(MAX(Nmlink,k),Nblink)
         Lst(jp)      =Label(i,j,k)
         Label(i,j,k) =jp
      EndDo

      Return
      End
C--------------------------------------------------------------
C                                Find all neibhours for a center
C                                Xc,Yc,Zc - center; a0 -its weight
C
      SUBROUTINE Neib(Xc,Yc,Zc,Density)
C--------------------------------------------------------------
      INCLUDE 'PMparameters.h'      
      INCLUDE 'PMcool.h'
      DIMENSION iDen(5)
C                                       Initiate counters
        Radius2= RadDens(5)**2
        Radius = RadDens(5)
        Do i=1,5
           iDen(i) =0
        EndDo 
c        write (*,*)  '==== Neib:',Xc,Yc,Zc,dStep
c                      limits for Label
         i1=INT((Xc-Radius)/Cell)
         j1=INT((Yc-Radius)/Cell)
         k1=INT((Zc-Radius)/Cell)
            i1=MIN(MAX(Nmlink,i1),Nblink)
            j1=MIN(MAX(Nmlink,j1),Nblink)
            k1=MIN(MAX(Nmlink,k1),Nblink)
         i2=INT((Xc+Radius)/Cell)
         j2=INT((Yc+Radius)/Cell)
         k2=INT((Zc+Radius)/Cell)
            i2=MIN(MAX(Nmlink,i2),Nblink)
            j2=MIN(MAX(Nmlink,j2),Nblink)
            k2=MIN(MAX(Nmlink,k2),Nblink)
c            write (*,'("    limits=",6i5)')i1,i2,j1,j2,k1,k2
C                                        Look for neibhours
         Do k=k1,k2
         Do j=j1,j2
         Do i=i1,i2
            jp =Label(i,j,k)
 10         If(jp.ne.0)Then
               dd =(Xc-Xp(jp))**2+(Yc-Yp(jp))**2+(Zc-Zp(jp))**2
               If(dd.lt.Radius2)Then
                  disd        = sqrt(sqrt(dd)/dStep)
                  ind       = min(INT(disd) +1,5)
                  iDen(ind) = iDen(ind) +1
c                  write (*,'(6x,i9,g11.4,3f9.5,2i5)')
c     &             jp,sqrt(dd)*1.e6,
c     &              (Xp(jp)-0.5)*1.e3,(Yp(jp)-0.5)*1.e3,
c     &              (Zp(jp)-0.5)*1.e3,
c     &              ind,iDen(ind) 
              EndIf  
                  jp =Lst(jp)
               GoTo10
            EndIf
         EndDo
         EndDo
         EndDo

         nn =0
         Do i=1,5
            nn =nn +iDen(i)
            If(nn.ge.5)Then
               Density = nn/RadDens(i)**3
               goto 20
            EndIf
         EndDo
         Density = nn/RadDens(5)**3
 20   Density =Density/4.188e9  ! number of particles per kpc**3
c      write(*,'(5x,"Dens=",g11.3,6i8)')Density,iDen,nn
      Return
      End

C ______________________________	 Convert PM from one ng to another ng
C		                         A. Klypin (aklypin@nmsu.edu) 
C		                     
C          Scales internal PM coordinates and velocities 
C          Produces new set of basic files
C	     NROW = number of particles in 1D
C	     NGRID= number of cells        in 1D
       INCLUDE 'PMparameters.h'
       REAL     INPUT
       logical inside
       Character  FileASCII*50
C...................................................................
C			Read data and open files
c      WRITE (*,'(A,$)') 'Enter Name for output  file = '
c      READ  (*,'(A)') FileASCII
c      OPEN(17,FILE=FileASCII,STATUS='UNKNOWN')
      CALL RDTAPE
      Close (9)
      OPEN(UNIT=9,FILE='PMcrd.NEW.DAT',
     +                FORM='UNFORMATTED', STATUS='UNKNOWN')
      OPEN(UNIT=22,FILE='PMcrs0.NEW.DAT',ACCESS='DIRECT',
     +	               STATUS='UNKNOWN',RECL=NACCES)

      write (*,*) ' RDTAPE is done'
      Scale  =INPUT(' Enter scaling factor for new box/old box=')
                       ! rescale NGRID; make scaling factors
      If(Scale.gt.1.)Then
         Scale = INT(Scale+0.1)
         iScale = INT(Scale+0.1)
         if((iScale.ne.2).and.(iScale.ne.4).and.(iScale.ne.8))
     &           STOP ' wrong scaling factor'
         NGRIDC = NGRID*iScale
      Else
         Scale = 1./Scale
         Scale = INT(Scale+0.1)
         iScale = INT(Scale+0.1)
         if((iScale.ne.2).and.(iScale.ne.4).and.(iScale.ne.8))
     &           STOP ' wrong scaling factor'
         Scale =1./Scale
         NGRIDC = NGRID/iScale
      EndIf
      NROWC  = NROW        ! do not change NROW
                           ! rescale weights
      PARTW  = PARTW *Scale**3
      Do j=1,Nspecies
        wspecies(j) =wspecies(j)*Scale**3 
      EndDo

      CALL WRTAPE          ! save control files
      write (*,*)  ' Scaling =',Scale,iscale
      WRITE (*,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,
     +                  NROWC,NGRIDC,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
100   FORMAT(1X,'Header=>',A45,/
     +          1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +           1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,/
     +           1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I6,/
     +           1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +           1x,' Omega_curvature=',F7.3)

C				       Loop over particles
       Icount = 0 
       DO IROW=1,Npages
            In_page =NPAGE
            If(IROW.eq.Npages)In_page =N_in_last
            write (*,*)' Read page=',IROW,' N=',In_page
	      CALL GETROW(IROW,1)
	      DO IN=1,In_page
	        XPAR(IN)  =Scale* (XPAR(IN)-1.)+1.
	        YPAR(IN)  =Scale* (YPAR(IN)-1.)+1.
	        ZPAR(IN)  =Scale* (ZPAR(IN)-1.)+1.
                If(XPAR(IN).ge.NGRIDC+1)write(*,*)' ErrorX',XPAR(IN),IN
                If(YPAR(IN).ge.NGRIDC+1)write(*,*)' ErrorY',YPAR(IN),IN
                If(ZPAR(IN).ge.NGRIDC+1)write(*,*)' ErrorZ',ZPAR(IN),IN
                If(XPAR(IN).lt.1.)write(*,*)' ErrorX',XPAR(IN),IN
                If(YPAR(IN).lt.1.)write(*,*)' ErrorY',YPAR(IN),IN
                If(ZPAR(IN).lt.1.)write(*,*)' ErrorZ',ZPAR(IN),IN
                Vxs=Scale* VX(IN)
                Vys=Scale* VY(IN)
                Vzs=Scale* VZ(IN)
                Icount =Icount +1
                xmax =MAX(xmax,XPAR(IN),YPAR(IN),ZPAR(IN))
                xmin =MIN(xmin,XPAR(IN),YPAR(IN),ZPAR(IN))
	      ENDDO
              CALL WRIROW(IROW,2)
        ENDDO 

      write (*,*) ' Scaled Coordinates were written'
      write (*,*) ' Number of particles          =',Icount
      write (*,*) ' Min/Max of coordinates(Mpc/h)=',xmin,xmax

      END

C---------------------------------------------------
C                                  Read  current data from disk/tape,
C                                  Open files
C                                  Nrecl is the number of values in a record
C                                  Npage is the number of particles in a page
      SUBROUTINE RDTAPE
C---------------------------------------------------
      INCLUDE 'PMparameters.h'
C                                     Open file on a tape
      OPEN(UNIT=9,FILE='PMcrd.DAT',
     +                FORM='UNFORMATTED', STATUS='UNKNOWN')
C                                 Read control information
C                                 and see whether it has proper
C                                 structure
      READ  (9,err=20,end=20) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  TINTG,EKIN,EKIN1,EKIN2,AU0,AEU0,
     +                  NROWC,NGRIDC,Nspecies,Nseed,Om0,Oml0,hubble,Wp5
     +                   ,Ocurv,extras
      WRITE (*,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,EKIN1,EKIN2,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
      WRITE (16,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,EKIN1,EKIN2,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
100   FORMAT(1X,'Header=>',A45,/
     +          1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',3E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I9,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3)
      IF(NROW.NE.NROWC) THEN
         WRITE (*,*)
     +            ' NROW in PARAMETER and in TAPE-FILE are different'
      ENDIF
      IF(NGRID.NE.NGRIDC) THEN
         WRITE (*,*)
     +           ' NGRID in PARAMETER and in TAPE-FILE are different:'
         write (*,*) ' Ngrid=',NGRID,' NgridC=',NGRIDC
      ENDIF
C                                         Open work file on disk
      write (*,*)  ' start openning PMcrs0'
 10   NBYTE = NRECL*4
      NACCES= NBYTE / nbyteword

      OPEN(UNIT=21,FILE='PMcrs0.DAT',ACCESS='DIRECT',
     +	               STATUS='UNKNOWN',RECL=NACCES)


      REWIND 9
       write (*,*)  ' done openning PMcrs0'
      RETURN
 20   write (*,*) ' Error reading the header file: Abort'
      stop
      END
C--------------------------------------------------
C                             Write current PAGE of particles (x,v) to disk
C                             NRECL - length of ROW block in words
      SUBROUTINE WRIROW(IROW,Ifile)
C--------------------------------------------------
      INCLUDE 'PMparameters.h'
        WRITE (20+Ifile,REC=IROW) RECDAT
      RETURN
      END
C---------------------------------------------
C                       Write current data to  disk/tape
C
      SUBROUTINE WRTAPE
C----------------------------------------------
      INCLUDE 'PMparameters.h'
C                                       write header and control data
      WRITE (9) HEADER,
     +           AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +           TINTG,EKIN,EKIN1,EKIN2,AU0,AEU0,
     +           NROWC,NGRIDC,Nspecies,Nseed,Om0,Oml0,hubble,Wp5,
     +           Ocurv,extras
      REWIND 9
      RETURN
      END
C--------------------------------------------
C                            Read current PAGE of particles  from disk
C                            NRECL - length of ROW block in words
      SUBROUTINE GETROW(IROW,Ifile)
C--------------------------------------------
      INCLUDE 'PMparameters.h'
         READ  (20+Ifile,REC=IROW) RECDAT
      RETURN
      END

C---------------------------------- Read in variables      
      REAL FUNCTION INPUT(text)
C------------------------------------------------
      Character text*(*)
          write (*,'(A,$)')text
          read (*,*) x
          INPUT =x
      Return
      End

C ______________________________	 Convert PM format to ASCII -- select points
C		             October 1998         A. Klypin (aklypin@nmsu.edu) 
C		                     
C          Scales internal PM coordinates and velocities 
C          to  coordinates in Mpc/h and km/s
C          In PM the coordinates are in the range 1 - (NGRID+1)
C                     velocities are P = a_expansion*V_pec/(x_0H_0)
C                     where     x_0 = comoving cell_size=Box/Ngrid
C                                    H_0 = Hubble at z=0
C                   
C	     NROW = number of particles in 1D
C	     NGRID= number of cells        in 1D
       INCLUDE 'PMparameters.h'
       REAL     INPUT
       Character  FileASCII*50
C...................................................................
C			Read data and open files
      WRITE (*,'(A,$)') 'Enter Name for output ASCII file = '
      READ  (*,'(A)') FileASCII
      OPEN(17,FILE=FileASCII,STATUS='UNKNOWN')
      CALL RDTAPE

      write (*,*) ' RDTAPE is done'
      Fraction =INPUT(' Enter fraction of particles     =')
      If(Fraction.le.0.)Stop
      Ifraction = INT(1./Fraction+0.01)
      xrand =0.
      write (*,*) ' Every ',Ifraction,' particle will be selected'
       WRITE (17,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
100   FORMAT(1X,'Header=>',A45,/
     +            1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I6,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3)
      Box  =INPUT(' Enter box size in comoving Mpc/h =')
      BoxV =Box*100.    ! Box size in km/s
      ScaleV = BoxV/AEXPN/NGRID  ! scale factor for Velocities
      ScaleC = Box/NGRID         ! scale factor for Coordinates

      xmax =-1.e+9
      xmin = 1.e+9
      vmax =-1.e+9
      vmin = 1.e+9
      Icount =0
      DO ifile =1,Nspecies+1
C				       Loop over particles
       DO IROW=1,NROW
c                   write (*,*) ' Read page=',IROW,' file=',ifile
	      CALL GETROW(IROW,ifile)
	      DO IN=1,NPAGE
	        X  =ScaleC* (XPAR(IN)-1.)
	        Y  =ScaleC* (YPAR(IN)-1.)
	        Z  =ScaleC* (ZPAR(IN)-1.)
           Vxs=ScaleV* VX(IN)
           Vys=ScaleV* VY(IN)
           Vzs=ScaleV* VZ(IN)
           Icount =Icount +1
           xmax =MAX(xmax,X,Y,Z)
           xmin =MIN(xmin,X,Y,Z)
           vmax =MAX(vmax,Vxs,Vys,Vzs)
           vmin =MIN(vmin,Vxs,Vys,Vzs)
           If(Fraction.lt.0.999)xrand =RANDd(Nseed) ! random fraction
           IF(xrand.lt.Fraction)Then                !  get the particle
             write (17,200) IN,X,Y,Z,Vxs,Vys,Vzs
           Endif 
 200       Format(i8,3F9.4,3F9.2)
	      ENDDO
        ENDDO 
      ENDDO

      write (*,*) ' Scaled Coordinates were written to:',
     &            FileASCII
      write (*,*) ' Number of particles          =',Icount
      write (*,*) ' Min/Max of coordinates(Mpc/h)=',xmin,xmax
      write (*,*) ' Min/Max of velocities (km/s) =',vmin,vmax

      END

C ______________________________	 
C		             November 2003         A. Klypin (aklypin@nmsu.edu) 
C		                     
C          Compare two snapshots
C          
C
C
      INCLUDE 'PMparameters.h'
      REAL     INPUT
      DIMENSION         RECDAT2(NRECL)
      COMMON / ROW2/XPAR2(NPAGE),YPAR2(NPAGE),ZPAR2(NPAGE),
     +	VX2(NPAGE),VY2(NPAGE),VZ2(NPAGE)
      REAL*8   disAvr,disMax
      INTEGER  iDispl(0:200)
      logical inside
      Character  FileASCII*50,snap1*4,snap2*4
      EQUIVALENCE    (RECDAT2(1),XPAR2(1))
      DATA disAvr,disMax,xmin,xmax,vmin,vmax,Icount,iDispl
     &    /0.d0,0.d0,1.e+9,-1.e+9,1.e+9,-1.e+9,0,201*0/
C...................................................................
C			Read data and open files
      ifile1      =1
      ifile2      =2
      snap1 ='1657'
      snap2='1677'
      hDispl   =0.5/200
      FileASCII ='SnapCompare.'//snap1//'.dat'
      open(17,file=FileASCII )
      CALL RDTAPE(snap1,9,ifile1)
      CALL RDTAPE(snap2,10,ifile2)

      write (*,*) ' RDTAPE is done'

      WRITE (17,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
100   FORMAT(1X,'Header=>',A45,/
     +          1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +           1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',E12.3,/
     +           1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I6,/
     +           1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +           1x,' Omega_curvature=',F7.3)

      If(extras(100).ne.0.)Then
         Box = extras(100)
      else
        Box =INPUT(' Enter box size in Mpc/h   =')
      endif 
      write (*,*) ' Box size is =  ',Box,'Mpc/h'
      BoxV =Box*100.    ! Box size in km/s
      ScaleV = BoxV/AEXPN/NGRID  ! scale factor for Velocities
c      ScaleC = Box/NGRID         ! scale factor for Coordinates
      ScaleC = 1.

         N_particles =lspecies(Nspecies)   ! Total number of particles
         Npages = (N_particles -1)/NPAGE +1
         N_in_last=N_particles -NPAGE*(Npages-1)
      write (*,*) ' Pages=',Npages,' Species=',Nspecies
      write (*,*) ' N_in_last=',N_in_last
C				       Loop over particles
       DO IROW=1,Npages
            In_page =NPAGE
            If(IROW.eq.Npages)In_page =N_in_last
            write (*,*)' Read page=',IROW,' Max=',DisMax,' N=',In_page
            iL = NPAGE*(IROW-1)
            CALL GETROW(IROW,ifile2)
              Do i =1,NRECL
                 RECDAT2(i) =RECDAT(i)
              EndDo 
            CALL GETROW(IROW,ifile1)
                DO IN=1,In_page
                  Icount =Icount +1
                  X  =XPAR(IN)
                  Y  =YPAR(IN)
                  Z  =ZPAR(IN)
                  X1 =XPAR2(IN)
                  Y1 =YPAR2(IN)
                  Z1 =ZPAR2(IN)
                  dx =min(abs(X-X1),NGRID-abs(X-X1))
                  dy =min(abs(Y-Y1),NGRID-abs(Y-Y1))
                  dz =min(abs(Z-Z1),NGRID-abs(Z-Z1))
                  if(dx.gt.1.)write(*,300)dx,X,X1,Y,Y1,Z,Z1,Icount
 300              format('X:',g12.3,2x,3(2g12.4,2x),i9)
                  displ     = sqrt(dx**2+dy**2+dz**2)
                  disAvr  =disAvr +displ**2
                  disMax =max(displ,disMax)
                  indx = MIN(INT(displ/hDispl),200)
                  iDispl(indx) = iDispl(indx)+1
                  Vxs=ScaleV* VX(IN)
                  Vys=ScaleV* VY(IN)
                  Vzs=ScaleV* VZ(IN)
                  xmax =MAX(xmax,X,Y,Z)
                  xmin   =MIN(xmin,X,Y,Z)
                  vmax =MAX(vmax,Vxs,Vys,Vzs)
                  vmin  =MIN(vmin,Vxs,Vys,Vzs)
               ENDDO
        ENDDO 
      write (*,*) ' Compare two snapshots        =',snap1,'  ',snap2 
      write (*,*) ' Number of particles          =',Icount
      write (*,*) ' Min/Max of coordinates(Mpc/h)=',xmin,xmax
      write (*,*) ' Min/Max of velocities (km/s) =',vmin,vmax
      write (*,*) ' Max displacement (0-cell)    =',disMax
      write (*,*) ' Avr displacement             =',sqrt(disAvr/Icount)
      write (*,*) '    Number of particles with given displacement'
      imax = MIN(INT(disMax/hDispl)+2,200)
      write (*,*) ' dx             N'
      write(*,'(g11.4,i8)')((i-1)*hDispl,iDispl(i),i=0,imax,10)

      write (17,*) ' Compare two snapshots        =',snap1,'  ',snap2 
      write (17,*) ' Number of particles          =',Icount
      write (17,*) ' Min/Max of coordinates(Mpc/h)=',xmin,xmax
      write (17,*) ' Min/Max of velocities (km/s) =',vmin,vmax
      write (17,*) ' Max displacement (0-cell)    =',disMax
      write (17,*) ' Avr displacement             =',sqrt(disAvr/Icount)
      write (17,*) '    Number of particles with given displacement'
      
      write (17,*) ' dx             N'
      write(17,'(g11.4,i8)')((i-1)*hDispl,iDispl(i),i=0,imax)
      END



C---------------------------------------------------
C                                  Read  current data from disk/tape,
C                                  Open files
C                                  Nrecl is the number of values in a record
C                                  Npage is the number of particles in a page
      SUBROUTINE RDTAPE(snapshot,ifile1,ifile2)
C---------------------------------------------------
      INCLUDE 'PMparameters.h'
      CHARACTER snapshot*(*),file1Name*50,file2Name*50
C                                     Open file on a tape
      file1Name = 'FILES/PMcrda0.'//snapshot//'.DAT'
      file2Name = 'FILES/PMcrs0a0.'//snapshot//'.DAT'
      write(*,'(A)')' File=',file1Name,file2Name
      OPEN(UNIT=ifile1,FILE=file1Name,
     +                FORM='UNFORMATTED', STATUS='UNKNOWN')
C                                 Read control information
C                                 and see whether it has proper
C                                 structure
      READ  (ifile1,err=20,end=20) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  TINTG,EKIN,EKIN1,EKIN2,AU0,AEU0,
     +                  NROWC,NGRIDC,Nspecies,Nseed,Om0,Oml0,hubble,Wp5
     +                   ,Ocurv,extras
      WRITE (*,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,EKIN1,EKIN2,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
      WRITE (16,100) HEADER,
     +                  AEXPN,AEXP0,AMPLT,ASTEP,ISTEP,PARTW,
     +                  EKIN,EKIN1,EKIN2,
     +                  NROWC,NGRID,NRECL,Om0,Oml0,hubble,
     +                  Ocurv
100   FORMAT(1X,'Header=>',A45,/
     +           1X,' A=',F8.3,' A0=',F8.3,' Ampl=',F8.3,' Step=',F8.3,/
     +            1X,' I =',I4,' WEIGHT=',F8.3,' Ekin=',3E12.3,/
     +            1X,' Nrow=',I4,' Ngrid=',I4,' Nrecl=',I8,/
     +            1x,' Omega_0=',F7.3,' OmLam_0=',F7.4,' Hubble=',f7.3,/
     +            1x,' Omega_curvature=',F7.3)
      IF(NROW.NE.NROWC) THEN
         WRITE (*,*)
     +            ' NROW in PARAMETER and in TAPE-FILE are different'
      ENDIF
      IF(NGRID.NE.NGRIDC) THEN
         WRITE (*,*)
     +           ' NGRID in PARAMETER and in TAPE-FILE are different:'
         write (*,*) ' Ngrid=',NGRID,' NgridC=',NGRIDC
      ENDIF
C                                         Open work file on disk
 10   NBYTE = NRECL*4
      NACCES= NBYTE / nbyteword

      OPEN(UNIT=20+ifile2,FILE=file2Name,ACCESS='DIRECT',
     +	               STATUS='UNKNOWN',RECL=NACCES)

 
      REWIND ifile1
      RETURN
 20   write (*,*) ' Error reading the header file: Abort',ifile1
      stop
      END
C--------------------------------------------
C                            Read current PAGE of particles  from disk
C                            NRECL - length of ROW block in words
      SUBROUTINE GETROW(IROW,Ifile)
C--------------------------------------------
      INCLUDE 'PMparameters.h'
         READ  (20+Ifile,REC=IROW) RECDAT
      RETURN
      END
C---------------------------------- Read in variables      
      REAL FUNCTION INPUT(text)
C------------------------------------------------
      Character text*(*)
          write (*,'(A,$)')text
          read (*,*) x
          INPUT =x
      Return
      End

C---------------------------------------------------
C     Anatoly Klypin Jauary 2000
C                               Formulas for LCDM model: age, angular-distance
C                               
C                           
C-----------------------------------------------------
C                            Om   = Omega_0                Omc   = Omega_cdm_present
C                            Ocurv = 0
C                            hsmall = H_0/100km/s/Mpc = the Hubble constant
C                            AEXPN = expansion parameter = 1/(1+z), z =redshift
C-----------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / Omegas/ Om,hsmall
      REAL*8                 INTG,INPUT
      EXTERNAL          INTG
C                                                     Constants
      Om     =INPUT(' Enter Omega_0 = matter at z=0 =>')
      hsmall =INPUT(' Enter hubble constant     h   =>') 
      H      =100.*hsmall     ! Hubble constant
      open(50,file='Angles.dat', access='APPEND')
      DO a=0.1,1.,0.1
         CALL AGE(t0,GrowthDen,GrowthVel,a)
      ENDDO
      a =1.
      CALL AGE(t0,GrowthDen_0,GrowthVel_0,a)

      z =     INPUT(' Enter redshift                =>')
c      angle =INPUT(' Enter angle (arcsec)          =>')
      D      =INPUT(' Enter proper radius (Mpc/h)   =>')

      CALL DISTANCEANG(z,angle,D)
c      CALL ANGDISTANCE(z,angle,D)

      write (*,*) '    Proper distance (Mpc/h) =',D, 
     &            ' angle (arcsec)=',angle,' z=',z 
      write (50,100) D,angle,z
 100  format('    Proper distance (Mpc/h) =',f8.4,
     &            ' angle (arcsec)=',f7.1,' z=',f7.3)
      STOP
	   END
C------------------------------------------------- 
C           
C               angular-distance relation :           
C              for given proper linear size (h=1) find angle (arcsecs)
C              at redshift z 
      SUBROUTINE DISTANCEANG(z,angle,D) 
C--------------------------------------- 
      IMPLICIT REAL*8 (A-H,O-Z) 
      PARAMETER (one =1.d-0) 
      COMMON / Omegas/ Om,hsmall 
      Real*8  INTG 
      External Fangle 
 
      if(z.le.0.d+0)Then 
         write (*,*) ' wrong redshift z=',z 
         return 
      EndIf 
         angle= D*206265./( 3000./(1.+z)*INTG(Fangle,one,one+z)) 
      Return 
      End 

C-------------------------------------------------
C          
C               angular-distance relation :          
C              for given angle (arcsecs) find proper linear size (h=1)
C              at redshift z
      SUBROUTINE ANGDISTANCE(z,angle,D)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (one =1.d-0)
      COMMON / Omegas/ Om,hsmall
      Real*8  INTG
      External Fangle

      if(z.le.0.d+0)Then
         write (*,*) ' wrong redshift z=',z
         return
      EndIf
         D =angle/206265.* 3000./(1.+z)*INTG(Fangle,one,one+z)
      Return
      End
C-------------------------------------------------
C                                  Age of the Universe: t0 (z=0)
C                                  Expansion parameter: a =1/(1+z)
C                                  Growth_Rate_Density at a: GrowthDen
C                                     GrowthDen =\delta\rho/\rho
C                                     normalized to GrowthDen =a for Omega=1
C                                     GrowthDen < 1 at a=1 for Lcdm or OCDM
C                                  Growth_Rate_velocity at a: GrowthVel
C                                     GrowthVel = V_peculiar= (a/delta)(d delta/d a)
      SUBROUTINE AGE(t0,GrowthDen,GrowthVel,a)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (zero =1.d-12)
      COMMON / Omegas/ Om,hsmall
      Common /OmegRat/ OmLOm0,OmcOm0
      Real*8  INTG
      External Hnorm,Hage,Hgrow

      Oml    =Max(Abs(1.-Om),zero)
      Ocurv =0.
      OmLOm0 =Oml/Om
      OmcOm0 =Ocurv/Om
      t0     =9.766/hsmall/sqrt(Om)*INTG(Hage,zero,a)
      z      =1./a-1.
      Hubble = hsmall*sqrt(Om/a**3)*Hnorm(a)
         ww  =INTG(Hgrow,zero,a)
      GrowthVel = -(1.5+OmcOm0*a)/Hnorm(a)**2+
     &                 sqrt(a**5)/Hnorm(a)**3/ww
      GrowthDen =2.5*Hnorm(a)/sqrt(a**3)*ww
         write (*,20) t0,z,a,Hubble,GrowthDen,GrowthVel
         write (1,20) t0,z,a,Hubble,GrowthDen,GrowthVel
 20      format(' Age=',f8.3,' z=',f6.2,' a=',f6.3,
     .          ' Hubble/100=',f8.3,' GrowthRateDen=',f7.4,
     .          ' GrowthRateVelocity=',f7.4)
      Return
      End

C-------------------------------------------- Simpson integration
      REAL*8 FUNCTION INTG(FUNC,A,B)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (EPS=5.0d-4, JMAX=22)
      EXTERNAL FUNC
      OST=-1.D30
      OS= -1.D30
      ST =0.
      DO 11 J=1,JMAX
        CALL TRAPZD(FUNC,A,B,ST,J)
        INTG=(4.0d0*ST-OST)/3.0d0
        IF (ABS(INTG-OS).Le.EPS*ABS(OS)) RETURN
        OS=INTG
        OST=ST
11    CONTINUE
      WRITE (*,*)'Integration did not converge'
      RETURN
      END
C----------------------------------------------
      SUBROUTINE TRAPZD(FUNCC,A,B,S,N)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
        SAVE IT
        EXTERNAL FUNCC
      IF (N.EQ.1) THEN
        S=0.5d0*(B-A)*(FUNCC(A)+FUNCC(B))
        IT=1
      ELSE
        TNM=IT
        DEL=(B-A)/TNM
        X=A+0.5D0*DEL
        SUM=0.0D0
        DO 11 J=1,IT
          SUM=SUM+FUNCC(X)
          X=X+DEL
11      CONTINUE
        S=0.5D0*(S+(B-A)*SUM/TNM)
        IT=2*IT
      ENDIF
      RETURN
      END
C---------------------------------- Read in variables      
      REAL*8 FUNCTION INPUT(text)
C-----------------------------------------
      Character text*(*)
          write (*,'(A,$)')text
          read (*,*) x
          INPUT =x
      Return
      End
C-----------------------------------------
      REAL*8 FUNCTION sinhh(x)
C-----------------------------------------
      IMPLICIT REAL*8 (A-H,P-Z)
         sinhh =0.5*(exp(MIN(x,33.d+0))-exp(-MIN(x,33.d+0)))
      RETURN
      END
C---------------------------------------
      REAL*8 FUNCTION Hh(x)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
         Hh =(sqrt(x/(1.d+0 +x**3)))**3 
      Return
      End
C---------------------------------------
      REAL*8 FUNCTION Hnorm(x)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      Common /OmegRat/ OmLOm0,OmcOm0
         Hnorm =sqrt(1.d+0 
     &                  +OmLOm0*x**3
     &                  +OmcOm0*x )
      Return
      End
C---------------------------------------
      REAL*8 FUNCTION Hage(x)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
         Hage =sqrt(x)/Hnorm(x) 
      Return
      End
C---------------------------------------
      REAL*8 FUNCTION Hgrow(x)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
         Hgrow =(sqrt(x)/Hnorm(x))**3 
      Return
      End
C---------------------------------------
      REAL*8 FUNCTION Fangle(x)
C---------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON / Omegas/ Om,hsmall
         Fangle =1./sqrt( (1.-Om)+Om*x**3 )
      Return
      End
